/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneConfig.h

				Q[V[`

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/15	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////
#ifndef	ABSceneConfig_h
#define	ABSceneConfig_h

#include	<iostream>
#include	"GlobalConfig.h"
#include	"ABSceneRunner.h"

//-------------------------------------------------------------------------------
//	eV[
//-------------------------------------------------------------------------------
enum{
	AB_SCENE_SPLASH,			//	scene1-1 "Splash"			Q[N̉
	
	AB_SCENE_ENTRANCE,			//	scene2-1 "Entrance"			^Cg
	AB_SCENE_CONFIGURATION,		//	scene2-2 "Configuration"	ݒ
	AB_SCENE_KEY_CONFIGURATION,	//	scene2-3 "KEY Configuration"ݒ(WCXeBbNݒ)

	AB_SCENE_MUSIC_SELECT,		//	scene3-1 "MusicSelect"		Iȉ
	AB_SCENE_ENTRY,				//	scene3-2 "Entry"			ȏЉ
	AB_SCENE_PLAY,				//	scene3-3 "Play"				vC
	AB_SCENE_FINISH,			//	scene3-4 "Finish"			PȏI
	
	AB_SCENE_MAX,
};
typedef	ABuint32	ABsceneType;

//-------------------------------------------------------------------------------
//	eV[wb_
//-------------------------------------------------------------------------------

//	Shadow Scene
#include	"ABSceneShadow.h"

//	Game Scene
#include	"ABSceneSplash.h"

#include	"ABSceneEntrance.h"
#include	"ABSceneConfiguration.h"
#include	"ABSceneKeyConfiguration.h"

#include	"ABSceneMusicSelect.h"
#include	"ABSceneStageEntry.h"
#include	"ABSceneStagePlay.h"
#include	"ABSceneStageFinish.h"

//-------------------------------------------------------------------------------
//	eV[̍쐬
//-------------------------------------------------------------------------------
inline	void	ABCreateGameScene( ABSceneRunner&  inRunner ) throw( std::bad_alloc )
{
	//	EVScene͂ɒǉĂB
	//	EmۂɎsstd::bad_alloc𓊂ĉB
	//	Eǉ鏇ԂƁAABsceneTypȅ͈vĂB
	//	EsvɂȂ_ŎI delete ܂B

	//	Shadow Scene
	inRunner.setSceneShadow( new ABSceneShadow( inRunner ) );
	
	//	Game scene
	inRunner.addScene( new ABSceneSplash( inRunner )			, AB_SCENE_SPLASH );

	inRunner.addScene( new ABSceneEntrance( inRunner )			, AB_SCENE_ENTRANCE );
	inRunner.addScene( new ABSceneConfiguration( inRunner )		, AB_SCENE_CONFIGURATION );
	inRunner.addScene( new ABSceneKeyConfiguration( inRunner )	, AB_SCENE_KEY_CONFIGURATION );

	inRunner.addScene( new ABSceneMusicSelect( inRunner )		, AB_SCENE_MUSIC_SELECT );
	inRunner.addScene( new ABSceneStageEntry( inRunner )		, AB_SCENE_ENTRY );
	inRunner.addScene( new ABSceneStagePlay( inRunner )			, AB_SCENE_PLAY );
	inRunner.addScene( new ABSceneStageFinish( inRunner )		, AB_SCENE_FINISH );
	
	//	ŏɋNV[
	inRunner.setStartScene( AB_SCENE_SPLASH );
}

#endif	//	ABSceneConfigBase_h
