/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneConfiguration.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"GameSingleton.h"
#include	"GUIApp.h"

#include	"ABSceneConfig.h"
#include	"ABSceneConfiguration.h"
#include	"ABVAItemBindConfigration.h"
#include	"ABSingleton.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABSceneConfiguration::ABSceneConfiguration( ABSceneRunner&  inRunner )
 : 
	ABSceneBase::ABSceneBase( inRunner )
{ 
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABSceneConfiguration::~ABSceneConfiguration( void )
{
}

////////////////////////////////////////////////////////////////////////////
//
//	V[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	V[i[NɌĂяo܂
//--------------------------------------------------------------------------
ABbool	ABSceneConfiguration::onInitialize( void )
{
	return true;
}

//--------------------------------------------------------------------------
//	V[i[IOɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneConfiguration::onFinalize( void )
{
}

//--------------------------------------------------------------------------
//	V[JnɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneConfiguration::onEnterScene( void )
{
	//	IvV͖NAĂ˂΂ȂB
	this->mSelectMenuIndex = AB_OPTION_FIRST;
	
	//	̂߂ɋLĂ܂
	this->mRecoverConfig = ABGetPreference();

}

//--------------------------------------------------------------------------
//	V[IɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneConfiguration::onExitScene( void )
{
}

//--------------------------------------------------------------------------
//	Q[[v
//--------------------------------------------------------------------------
void	ABSceneConfiguration::onGameLoop( void )
{
	ABbool	ret;
	ABint	value = 0;
	ABint	rowMove = 0;

	//	݂̃gK[ԂQ
	GameGetJoystick().update();
	ABTriggerState&		ts = GameGetJoystick().getState();
	//	Configurationݒ
	ABGamePreference&			pref	= ABGetPreference();
	ABGamePreference::Config&	config 	= pref.playConfig;	

	//	j[I
	if( ts.flagPushMoveUp ){
		//	gK[̐ݒɂāA{^A邢͍{^ňړB
		//	{^Ԃ̂ݎQƂȂ΂ȂȂB
		rowMove = -1;
	}
	else if( ts.flagPushMoveDown ){
		//	{^Ԃ̂ݎQƂȂ΂ȂȂB
		rowMove = 1;
	}
	this->mSelectMenuIndex += rowMove;

	//	XLbvs ?
	ABint8*		text = ABConfigCaptionArray::getLabelCaption( this->mSelectMenuIndex );
	if( text ){
		if( text[0] == 0 ){
			//	XLbv
			this->mSelectMenuIndex += rowMove;
		}
	}

	if( this->mSelectMenuIndex < AB_OPTION_FIRST ){
		this->mSelectMenuIndex = AB_OPTION_max - 1;
	}
	else if( AB_OPTION_max <= this->mSelectMenuIndex ){
		this->mSelectMenuIndex = AB_OPTION_FIRST;
	}
	
	//	lύX
	if( ts.flagPushMoveLeft ){
		value = -1;
	}
	else if( ts.flagPushMoveRight ){
		value = 1;
	}

	//	I菈
	if( ts.flagPushSelecrt ){
		//	{^Ƃ
		switch(this->mSelectMenuIndex){
			case AB_OPTION_RESET:
				{
					//	Configuration̏
					config.clean();
					//	Configuration̕ۑ͂Kv
					//	KpKv
				}
				break;

			case AB_MENU_OK:
				{
					//	Configuration̕ۑ
					ret = AquanBeatsPreference::savePreference( &pref );
					if( !ret ){
						//	ۑɎs܂
						break;
					}
					//	Configuration̓Kp
					//	XL[Zbg֘A͗OƂēKpςłԂƂȂĂ܂B
					ret = AquanBeatsPreference::updatePreference( &this->mRecoverConfig, &pref );
					if( !ret ){
						//	KpɎs܂
						break;
					}
					//	ړ
					this->getRunner().moveToScene( AB_SCENE_ENTRANCE );
				}
				break;
			case AB_MENU_CANCEL:
			
				{
					//	Configuration̕A
					config = this->mRecoverConfig.playConfig;

					//	Configuration̕ۑ͂Kv
					//	KpKv
					//	ړ
					this->getRunner().moveToScene( AB_SCENE_ENTRANCE );
				}
				break;
		}
	}
	else if( value != 0 ){
		//	܂͉EƂ
		switch(this->mSelectMenuIndex){

			case AB_OPTION_Volume:
				config.masterVolume += value * 5;
				if( config.masterVolume < 0 || 100 < config.masterVolume ){
					config.masterVolume -= value * 5;
				}
				ret = AquanBeatsPreference::updatePreference( &this->mRecoverConfig, &pref );
				break;
			case AB_OPTION_IsSE:
				//	BMSĐɂ̂ݗLȂ̂Őݒ̂
				config.trueIsUseSoundReverb = ( 0 < value );
				break;

			case AB_OPTION_IsIgnorePoor:
				//	ݒ̂
				config.trueIsUseIgnorePoor = ( 0 < value );
				break;
			case AB_OPTION_ComboLevel:
				//	ݒ̂
				config.trueIsUseCombo = ( 0 < value );
				break;
			case AB_OPTION_HiSpeedLevel:
				//	ݒ̂
				config.hiSpeedRate += (ABfloat32)value * 0.25f;
				if( config.hiSpeedRate < 0.25f || 16.0f < config.hiSpeedRate ){
					config.hiSpeedRate -= (ABfloat32)value * 0.25f;
				}
				break;

			case AB_OPTION_LAYOUT_CENTER_PLAY:
				//	ݒ̂
				config.trueIsUseCenterLayout = ( 0 < value );
				break;

			case AB_OPTION_AUTO_PLAY_P1:
			case AB_OPTION_AUTO_PLAY_P2:
				//	ݒ̂
				{
					ABautoPlayType*	autoPlay = &config.autoPlayMode[ this->mSelectMenuIndex - AB_OPTION_AUTO_PLAY_P1 ];
					if( value <  0 && 0 < *autoPlay ){
						--*autoPlay;
					}
					else if( 0 < value &&  *autoPlay < ( AB_AUTO_PLAY_TYPE_COUNT - 1) ){
						++*autoPlay;
					}
				}
				break;

			case AB_OPTION_All7Keys:
				//	ݒ̂
				config.trueIsUseAll7keyMode = ( 0 < value );
				break;

			case AB_OPTION_ScreenSize:
				//	ݒ̂
				if( value <  0 && 0 < config.screenMode ){
					--config.screenMode;
				}
				else if( 0 < value &&  config.screenMode < ( AB_SCREEN_SIZE_MODE_COUNT - 1) ){
					++config.screenMode;
				}
				break;

			case AB_OPTION_Scheme:
				{
					ABint	currentSC	= this->mVAResource.mScheme.getOpenSchemeNumber();	//	݂̔ԍ
					ABint	sc			= this->mVAResource.mScheme.getCount();				//	XL[
					ABint	oldSC		= currentSC;
					
					if( value <  0 && 0 < currentSC ){
						--currentSC;
					}
					else if( 0 < value &&  currentSC < ( sc - 1) ){
						++currentSC;
					}

					if( oldSC != currentSC ){
						do{
							ABMBSchemeSetPtr		scemeSet = NULL;
							
							//	wԍSchemeJ
							this->mVAResource.mScheme.closeScheme();
							ret = this->mVAResource.mScheme.openScheme( currentSC );
							ABTestBreakReportError( ! ret, "openScheme." );

							//	VZbg𓾂
							scemeSet = this->mVAResource.mScheme.getScheme( 0 );
							ABTestBreakReportError( scemeSet == NULL, "getScheme." );

							//	؂ւ
							pref.selectSchemeNumber	= currentSC;
							pref.selectSchemePtr	= scemeSet;
							config.schemeNumber		= 0;
							this->mVAResource.mScheme.getSchemeFolder().copyName( config.schemeFolder, sizeof(config.schemeFolder) );
							
							//	𑜓x؂ւ܂BB
							this->getRunner().mVARunner.setGameScreenSize( scemeSet->screenSizeWidth, scemeSet->screenSizeHeight );

						}while( false );
						
						if( ! ret ){
							ret = this->mVAResource.mScheme.openScheme( oldSC );
							ABTestBreakReportError( ! ret, "openScheme." );
						}

					}
				}

				break;
			case AB_OPTION_SchemeSet:
				//	ݒ̂
				{
					//	SchemeJ
					ABint	currentSC	= this->mVAResource.mScheme.getOpenSchemeNumber();
					ABint	setc		= this->mVAResource.mScheme.getSchemeCount();
					
					if( setc == 0 ){
						config.schemeNumber = 0 ;
					}
					else{
						if( value <  0 && 0 < config.schemeNumber ){
							--config.schemeNumber;
						}
						else if( 0 < value &&  config.schemeNumber < ( setc - 1) ){
							++config.schemeNumber;
						}
					}
					ABMBSchemeSetPtr		scemeSet = this->mVAResource.mScheme.getScheme( config.schemeNumber );
					pref.selectSchemePtr = scemeSet;
					//	𑜓x؂ւ܂B
					this->getRunner().mVARunner.setGameScreenSize( scemeSet->screenSizeWidth, scemeSet->screenSizeHeight );
				}
				break;

			case AB_OPTION_SOUND_SAMPLE_RATE:
				//	ݒ̂
				if( value <  0 && 0 < config.soundSampleRate ){
					--config.soundSampleRate;
				}
				else if( 0 < value &&  config.soundSampleRate < ( AB__SOUND_SAMPLE_RATE_COUNT - 1) ){
					++config.soundSampleRate;
				}
				break;
			case AB_OPTION_SOUND_CHANNEL_COUNT:
				if( value <  0 && GAS_SAMPLE_CHANNEL_MONO < config.soundChannelMode ){
					--config.soundChannelMode;
				}
				else if( 0 < value &&  config.soundChannelMode < GAS_SAMPLE_CHANNEL_STEREO ){
					++config.soundChannelMode;
				}
				break;
			case AB_OPTION_DRAW_FRAME_RATE:
				if( value <  0 && 0 < config.drawFrameRate ){
					--config.drawFrameRate;
				}
				else if( 0 < value &&  config.drawFrameRate < ( AB__DRAW_FRAME_RATE_COUNT - 1) ){
					++config.drawFrameRate;
				}
				break;
				
			case AB_OPTION_SOUND_CACHE_SIZE:
			
				if( value <  0 ){
					config.cacheSize -= GE_AUDIO_CACHE_FILE_SIZE * 40;
					if( config.cacheSize < AB_SOUND_FILE_CACHE_SIZE_MIN ){
						config.cacheSize = AB_SOUND_FILE_CACHE_SIZE_MIN;
					}
				}
				else if( 0 < value ){
					//	͕[80
					config.cacheSize += GE_AUDIO_CACHE_FILE_SIZE * 40;
					ABint32		maxSize = ( (ABfloat32)AB_SOUND_FILE_CACHE_SIZE_MAX / 100.0 ) * (ABfloat32)GUIApp::getPhysicalMemorySize();
					if( maxSize < config.cacheSize ){
						config.cacheSize = maxSize;
					}
				}
				break;
		}
		//	Kp
	}
	
	//	j[IԂ̕`
	//		EVisualArchitectureƂėpӂ`揈NXʓrR[B
	//		@NXŕ`悷邱ƂŁA`R[h͂ĂB
	//		@`@ς悤ȏCƂA
	//		@̊֐͉ҏWȂčςގ]܂B
	ABVAItemBindConfigration*	binder = static_cast<ABVAItemBindConfigration*>(this->getRunner().mVARunner.getCurrentBinder());
	binder->mSelectMenuIndex = this->mSelectMenuIndex;
}

//--------------------------------------------------------------------------
//	AvP[VCxg
//--------------------------------------------------------------------------
ABbool	ABSceneConfiguration::onAppEvent( GEeventAppType  inAppEventType )
{
	return	true;
}
