/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneEntrance.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABSceneConfig.h"

#include	"GameSingleton.h"
#include	"GUIApp.h"

#include	"ABSingleton.h"
#include	"ABSceneEntrance.h"
#include	"ABVAItemBinderConfig.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABSceneEntrance::ABSceneEntrance( ABSceneRunner&  inRunner )
 : 
	ABSceneBase::ABSceneBase( inRunner )
{ 
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABSceneEntrance::~ABSceneEntrance( void )
{
}

////////////////////////////////////////////////////////////////////////////
//
//	V[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	V[i[NɌĂяo܂
//--------------------------------------------------------------------------
ABbool	ABSceneEntrance::onInitialize( void )
{
	//	j[CfbNXB
	//	V[JnɏȂ̂ŁAēx̃V[JƂAÕj[I܂܂ƂȂB
	this->mSelectMenuIndex = 0;
	return true;
}

//--------------------------------------------------------------------------
//	V[i[IOɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneEntrance::onFinalize( void )
{
}

//--------------------------------------------------------------------------
//	V[JnɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneEntrance::onEnterScene( void )
{
}

//--------------------------------------------------------------------------
//	V[IɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneEntrance::onExitScene( void )
{
}

//--------------------------------------------------------------------------
//	Q[[v
//--------------------------------------------------------------------------
void	ABSceneEntrance::onGameLoop( void )
{
	//	݂̃gK[ԂQ
	GameGetJoystick().update();
	ABTriggerState&		ts = GameGetJoystick().getState();

	//	j[I
	if( ts.flagPushMoveUp ){
		//	gK[̐ݒɂāA{^A邢͍{^ňړB
		//	{^Ԃ̂ݎQƂȂ΂ȂȂB
		--this->mSelectMenuIndex;
	}
	else if( ts.flagPushMoveDown ){
		//	{^Ԃ̂ݎQƂȂ΂ȂȂB
		++this->mSelectMenuIndex;
	}
	
	if( this->mSelectMenuIndex < 0 ){
		this->mSelectMenuIndex = AB_TITLE_MENU_COUNT - 1;
	}
	else if( AB_TITLE_MENU_COUNT <= this->mSelectMenuIndex ){
		this->mSelectMenuIndex = 0;
	}

	//	I菈
	if( ts.flagPushSelecrt ){

		//	{^
		switch(this->mSelectMenuIndex){

			case AB_TITLE_MENU_FREE_STYLE:
				ABGetPreference().gameMode = AB_GAME_MODE_ARCADE;
				ABGetPreference().stageNumber = 1;
				this->getRunner().moveToScene( AB_SCENE_MUSIC_SELECT );
				break;

			case AB_TITLE_MENU_ARCADE:
				ABGetPreference().gameMode = AB_GAME_MODE_ARCADE;
				ABGetPreference().stageNumber = 1;
				this->getRunner().moveToScene( AB_SCENE_MUSIC_SELECT );
				break;

			case AB_TITLE_MENU_EXPART:
				ABGetPreference().gameMode = AB_GAME_MODE_EXPART;
				ABGetPreference().stageNumber = 1;
				this->getRunner().moveToScene( AB_SCENE_MUSIC_SELECT );
				break;

			case AB_TITLE_MENU_SELECT_SCHEME:
				break;

			case AB_TITLE_MENU_KEY_CONFIG:
				this->getRunner().moveToScene( AB_SCENE_KEY_CONFIGURATION );
				break;

			case AB_TITLE_MENU_OPTION:
				this->getRunner().moveToScene( AB_SCENE_CONFIGURATION );
				break;

			case AB_TITLE_MENU_QUIT:
				GUIApp::appQuit();
				break;
		}
	}
	
	//	j[IԂ̕`
	//		EVisualArchitectureƂėpӂ`揈NXʓrR[B
	//		@NXŕ`悷邱ƂŁA`R[h͂ĂB
	//		@`@ς悤ȏCƂA
	//		@̊֐͉ҏWȂčςގ]܂B
	ABVAItemBindEntrance*	binder = static_cast<ABVAItemBindEntrance*>(this->getRunner().mVARunner.getCurrentBinder());
	if( binder ){
		binder->mSelectMenuIndex = this->mSelectMenuIndex;
	}
}

//--------------------------------------------------------------------------
//	AvP[VCxg
//--------------------------------------------------------------------------
ABbool	ABSceneEntrance::onAppEvent( GEeventAppType  inAppEventType )
{
	return	true;
}

////////////////////////////////////////////////////////////////////////////
//
//	VhEV[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneEntrance::onEnterGameLoop( void )
{
}

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneEntrance::onExitGameLoop( void )
{
}
