/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneShadow.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABSingleton.h"
#include	"ABSceneShadow.h"
#include	"ABMBVAItemPreset.h"
#include	"ABMBVASchemeAdapter.h"

#include	"GameSingleton.h"
#include	"GUIApp.h"

#include	"Gamepreference.h"

//----------------------------------
//	debug preference
//----------------------------------

inline	void ABDebugSetting( ABGamePreference*  inPreference ){
	//	platformɓK؂Debugݒs
	#ifdef	OS_COMPILE_MAC_OS_X
		//	NfBXÑACe
		sprintf( inPreference->pathData,		"%s", "/BMS_Debug/" );
		sprintf( inPreference->pathBMSmusic, 	"%s", "/BMS_Debug/BMSMusic/" );
		sprintf( inPreference->pathBMSdatabase, "%s", "/BMS_Debug/BMSCollection/" );
		sprintf( inPreference->pathScheme, 		"%s", "/BMS_Debug/Scheme/" );
	#endif	//	OS_COMPILE_MAC_OS
}


//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABSceneShadow::ABSceneShadow( ABSceneRunner&  inRunner )
 : 
	ABSceneBase::ABSceneBase( inRunner )
{ 
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABSceneShadow::~ABSceneShadow( void )
{
}


////////////////////////////////////////////////////////////////////////////
//
//	V[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	V[i[NɌĂяo܂
//--------------------------------------------------------------------------
ABbool	ABSceneShadow::onInitialize( void )
{
	ABbool		ret;
	//	Q[̏
	do{
	
		//	preference

//		#ifdef	AB_DEBUG_MODE	//	<-KvɉProjectŐݒ肷邱
			//	debugging settting
			//	Debugp̏ݒsB
			ABDebugSetting( &( ABGetPreference() ) );
//		#endif

		GameGetView()->hide();

		//	ݒǂݍ
		if( !AquanBeatsPreference::loadPreference( &( ABGetPreference() )) ){
			//break;
		}

		//	ݒKp
		ret = AquanBeatsPreference::updatePreference( NULL,  &( ABGetPreference() ) );
		ABTestBreakReportError( ! ret, "AquanBeatsPreference::updatePreference." );

		//	_[O[v쐬
		for( ABint i = 0 ; i < ABVA_RENDER_GROUP_COUNT; i++ ){
			ret = GGGetRender().addGroup( &this->mVAResource.mRenderGroup[ i ] );
			if( ! ret ){ break; }
		}
		ABTestBreakReportError( ! ret, "renderer create group." );

		//	open scheme
		//	SCHEMElibraryJ
		ret = this->mVAResource.mScheme.openSchemeLibrary( ABGetPreference().pathScheme );
		ABTestBreakReportError( ! ret, "openSchemeLibrary." );
	
		//	SchemeSet̃vZbeBO
		ABMBVAItemPreset		preset;
		ret = this->mVARunner.createItems( preset );
		ABTestBreakReportError( ! ret, "va createItems." );
		
		//	SCHEMEI
		ABint	selectSchemeNumber = this->mVAResource.mScheme.getSchemeNumber( ABGetPreference().playConfig.schemeFolder );
		if( selectSchemeNumber < 0 ){
			memcpy( ABGetPreference().playConfig.schemeFolder, AB_CONFIG_DEFAULT_SCHEME_FOLDER, sizeof(ABGetPreference().playConfig.schemeFolder) );
			selectSchemeNumber = this->mVAResource.mScheme.getSchemeNumber( ABGetPreference().playConfig.schemeFolder );
		}
		ABTestBreakReportError( selectSchemeNumber < 0 , "getSchemeNumber." );
		ABGetPreference().selectSchemeNumber = selectSchemeNumber;
		
		ret = this->mVAResource.mScheme.openScheme( ABGetPreference().selectSchemeNumber );
		ABTestBreakReportError( ! ret, "openScheme." );

		//	𑜓x؂ւ܂B
		//	::TODO::[U[w̉𑜓xƋ܂B
		ABint	schemeSetNumber = ABGetPreference().playConfig.schemeNumber;
		if( this->mVAResource.mScheme.getSchemeCount() <= schemeSetNumber ){
			schemeSetNumber = this->mVAResource.mScheme.getSchemeCount() - 1;
		}
		ABTestBreakReportError( schemeSetNumber < 0, "scheme set nothing number." );
		ABMBSchemeSetPtr		scemeSet = this->mVAResource.mScheme.getScheme( schemeSetNumber );
		
		this->getRunner().mVARunner.setGameScreenSize( scemeSet->screenSizeWidth, scemeSet->screenSizeHeight, true );

		//	BMS Library open
		ABGetBMSLibrary().open( ABGetPreference().pathBMSmusic );

		GameGetView()->show();

		ret = true;
	}while( false );
	if( !ret ){
		GUIApp::appQuit();
	}

	return	ret;
}

//--------------------------------------------------------------------------
//	V[i[IOɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneShadow::onFinalize( void )
{
	this->mVAResource.mScheme.closeScheme();
	
	//	BMS Library close
	ABGetBMSLibrary().close();

	//	SchemeSet̏I
	this->mVARunner.releaseItems();
}

//--------------------------------------------------------------------------
//	V[JnɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneShadow::onEnterScene( void )
{
	ABbool		ret;

	do{
		ABBMSSchemeSetMode	setMode = AB_BMS_SCHEME_SET_MODE_5KEY;
		
		//	VAInstancep܂
		this->mVARunner.releaseInstances();

		//	fill scheme
		//	IĂSCHEMEgāAVisual@Architecture𒲐B
		ABMBVASchemeAdapter		sa( this->mVAResource.mScheme );
		ABMBSchemeSetPtr		scemeSet = this->mVAResource.mScheme.getScheme( ABGetPreference().playConfig.schemeNumber );
		ABTestBreakReportError( scemeSet == NULL, "getScheme." );
		ret = sa.readScheme( this->mVARunner, setMode, scemeSet );
		ABTestBreakReportError( ! ret, "readScheme." );

		//	VÃACeInstance쐬܂
		//	V[̊JnɁAԍŏɎs邽߁A
		//	eV[ł͈ӎ邱ƂȂVAւACCESS\ɂ܂
		ret = this->mVARunner.createInstances( this->getRunner().getCurrentSceneNumber() );	
		ABTestBreakReportError( ! ret, "va createInstances." );

		ABGetPreference().selectSchemePtr = scemeSet;
	}while( false );
	if( !ret ){
		//	ً}Ei
		if( ABGetPreference().playConfig.schemeNumber != 0 ){
			ABGetPreference().playConfig.schemeNumber = 0;
			this->onEnterScene();
		}
		else{
			GUIApp::appQuit();
		}
	}
}

//--------------------------------------------------------------------------
//	V[IɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneShadow::onExitScene( void )
{
	//	VAInstancep܂
	this->mVARunner.releaseInstances();
//
}

//--------------------------------------------------------------------------
//	Q[[v
//--------------------------------------------------------------------------
void	ABSceneShadow::onGameLoop( void )
{
}

//--------------------------------------------------------------------------
//	AvP[VCxg
//--------------------------------------------------------------------------
ABbool	ABSceneShadow::onAppEvent( GEeventAppType  inAppEventType )
{
	return	true;
}

////////////////////////////////////////////////////////////////////////////
//
//	VhEV[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneShadow::onEnterGameLoop( void )
{
}

//--------------------------------------------------------------------------
//	Q[[v̏
//--------------------------------------------------------------------------
void	ABSceneShadow::onExitGameLoop( void )
{
	//	VAInstance_O܂
	this->mVARunner.render();
}

//--------------------------------------------------------------------------
//	Q[V[JnO
//		V[onEnterScene̍ŌɌĂт܂B̓tF[hAEĝ߂Ɏgp܂B
//--------------------------------------------------------------------------
void	ABSceneShadow::onSpecificEnterScene( void )
{
	if( 1.0f != GGGetRender().getFade() ){
		//	tF[hC
		ABfloat32	fadeTime = 30;
		ABfloat32	fadeLv = 0.0f;
		do{
			GGGetRender().fade( fadeLv );
			GGGetRender().render();
			GameGetView()->renderView( true );
			
			GameTimer::wait( 1 );
			
			fadeLv += 1.0f / fadeTime;
		}while( fadeLv < 1.0f );
		
		GGGetRender().fade( 1.0f );
		GGGetRender().render();
		GameGetView()->renderView( true );
	}
};

//--------------------------------------------------------------------------
//	Q[V[IO
//		V[ononExitScenȇOɌĂт܂B̓tF[hAEĝ߂Ɏgp܂B
//--------------------------------------------------------------------------
void	ABSceneShadow::onSpecificExitScene( void )
{
	//	tF[hAEg
	{
		ABfloat32	fadeTime = 30;
		ABfloat32	fadeLv = 1.0f;
		do{
			GGGetRender().fade( fadeLv );
			GGGetRender().render();
			GameGetView()->renderView( true );
			
			GameTimer::wait( 1 );

			fadeLv -= 1.0f / fadeTime;
		}while( 0.0f < fadeLv );
		
		GGGetRender().fade( 0.0f );
		GGGetRender().render();
		GameGetView()->renderView( true );
	}
};
