/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneStagePlay.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	<string>

#include	"GlobalConfig.h"
#include	"GameSingleton.h"

#include	"ABSceneStagePlay.h"

#include	"ABSingleton.h"

#include	"ABSceneConfig.h"
#include	"ABMBVAItemRenderStagePlay.h"
#include	"ABVAItemBindStagePlay.h"
#include	"ABMBVASchemeAdapter.h"
#include	"ABSingleton.h"

#include	"GUIApp.h"
#include	"GameTimer.h"

using namespace	std;

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABSceneStagePlay::ABSceneStagePlay( ABSceneRunner&  inRunner )
 : 
	ABSceneBase::ABSceneBase( inRunner )
{ 
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABSceneStagePlay::~ABSceneStagePlay( void )
{
}

////////////////////////////////////////////////////////////////////////////
//
//	V[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	V[i[NɌĂяo܂
//--------------------------------------------------------------------------
ABbool	ABSceneStagePlay::onInitialize( void )
{
	this->mStartBMS = false;
	this->mStartError = false;
	return true;
}

//--------------------------------------------------------------------------
//	V[i[IOɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneStagePlay::onFinalize( void )
{
}

//--------------------------------------------------------------------------
//	V[JnɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneStagePlay::onEnterScene( void )
{
	bool	result = false;
	ABbool			ret;
	ABint8*			bmsMusicName;
	ABint			dataNumber = 0;
	string			bmsMusic( ABGetPreference().pathBMSmusic );
	{
		//	debug
/*
		{
			using namespace std;
			static	ABint	number = 0;
			static	ABint8*	bms[]={
	//			"sweet Folder",
	//			"cranky [EURO DANCE] X-Y-Z ''Tin",
	//			"dimeuro",
				"20novce",	
				"stmusic",	
				"yk_evatv",	
		//		"hma",			//<-}Ii		
				"Congratulations_MQ",	
				"yukigesiki_MQ",	
				"ruined_relics_MQ",	
				"mybb",	
				"ruinrmx",	
				"panse",
				"success",	
		//		"pastelbms01",	//::TODO::eLXgǂݍ݃G[
				"nadesico",
			};
	//		bmsMusic += bms[0];

			//	Ȉjuke{bNX
			bmsMusic += bms[number];
			++number;
			if( (sizeof(bms) / sizeof(ABint8*)) <= number ){
				number = 0;
			}
		}
*/
		BMSLibraryData*			collectionData  = NULL;
		do{
			//bmsMusicName = const_cast<ABint8*>(bmsMusic.c_str());

			//	IBMS
			collectionData = ABGetBMSLibrary().getData();	
			ABTestBreakReportError( collectionData == NULL , "BMSLibraryData().getData." );
			if( collectionData->mBroken ){
				ret = false;
				break;
			}
			bmsMusic 		+= collectionData->mFolderRef->mFoladerName;
			bmsMusicName 	= const_cast<ABint8*>(bmsMusic.c_str());
			dataNumber 		= collectionData->mDataNumber;
			
			//	J
			BMSFolder&		folder = ABGetSingleton().mBMSFolder;
			ABMBVAItemRenderStagePlay*	renderer = static_cast<ABMBVAItemRenderStagePlay*>(this->getRunner().mVARunner.getCurrentRender());
			ABVAItemBindStagePlay*	binder = static_cast<ABVAItemBindStagePlay*>(this->getRunner().mVARunner.getCurrentBinder());
			
			GGGetRender().render();
			GameGetView()->renderView( true );

			GameGetAudio().finalize();
			ABGamePreference&		preference = ABGetPreference();
			ret = GameGetAudio().initialize( preference.playConfig.trueIsUseSoundReverb,
											preference.playConfig.cacheSize / GE_AUDIO_CACHE_FILE_SIZE, GE_AUDIO_CACHE_FILE_SIZE, 
											(ABfloat32)AbConfigGetSampleRate( preference.playConfig.soundSampleRate ), preference.playConfig.soundChannelMode );
			
			//	tu̐ݒ
			BMSPlayerConfig		bmsPlayerConfig;
			for( ABint i = 0 ; i < BMS_BMSEQ_EVENT_PLAYER_COUNT; i++ ){
				bmsPlayerConfig.autoPlayMode[i] = ABGetPreference().playConfig.autoPlayMode[i];
			}
			bmsPlayerConfig.gameLevel = ABGetPreference().gameLevel;
			bmsPlayerConfig.expartMode = (ABGetPreference().gameMode == AB_GAME_MODE_EXPART ? BMS_SEQ_EXPART_MODE_ON: BMS_SEQ_EXPART_MODE_OFF);
			
			//	ZbgAbv
			ret = ABGetBMSRunner().setup(
						&bmsPlayerConfig,
						&renderer->mProgressReporter,
						&folder, 
						bmsMusicName,
						dataNumber, 
						&this->getRunner().mVARunner,
						static_cast<ABVAItemBindStagePlay*>(this->getRunner().mVARunner.getCurrentBinder()),
						static_cast<ABMBVAItemRenderStagePlay*>(this->getRunner().mVARunner.getCurrentRender())  );
			ABTestBreakReportError( ! ret, "ABGetBMSRunner().setup" );

			//	XL[Zbg[h̓vCV[łӖȂBŁA܂ǂēxV[\zȂ
			ABBMSSchemeSetMode	setMode;
			BMSTPSongData*		tpSongData = ABGetBMSRunner().mSong->getSongData();
			BMSTPKeyModeType	keyMode = tpSongData->information.keyModeType;
			switch(keyMode){
				case BMS_TP_KEY_TYPE_5KEY:
					setMode = AB_BMS_SCHEME_SET_MODE_5KEY;
					break;
				case BMS_TP_KEY_TYPE_7KEY:
				default:
					setMode = AB_BMS_SCHEME_SET_MODE_7KEY;
					break;
			}
			if( ABGetPreference().playConfig.trueIsUseAll7keyMode ){
				setMode = AB_BMS_SCHEME_SET_MODE_7KEY;
			}
			if( ABGetPreference().playConfig.trueIsUseCenterLayout ){
				if( setMode == AB_BMS_SCHEME_SET_MODE_5KEY ){
					setMode = AB_BMS_SCHEME_SET_MODE_5KEY_CENTER;
				}
				else{
					setMode = AB_BMS_SCHEME_SET_MODE_7KEY_CENTER;
				}
			}
			binder->mSchemeSetMode = setMode;

			//	VAInstancep܂
			this->mVARunner.releaseInstances();

			//	fill scheme
			//	IĂSCHEMEgāAVisual@Architecture𒲐B
			ABMBVASchemeAdapter		sa( this->mVAResource.mScheme );
			ABMBSchemeSetPtr		scemeSet = this->mVAResource.mScheme.getScheme( ABGetPreference().playConfig.schemeNumber );
			ABTestBreakReportError( scemeSet == NULL, "getScheme." );
			ret = sa.readScheme( this->mVARunner, setMode, scemeSet );
			ABTestBreakReportError( ! ret, "readScheme." );

			//	VÃACeInstance쐬܂
			//	V[̊JnɁAԍŏɎs邽߁A
			//	eV[ł͈ӎ邱ƂȂVAւACCESS\ɂ܂
			ret = this->mVARunner.createInstances( this->getRunner().getCurrentSceneNumber() );	
			ABTestBreakReportError( ! ret, "va createInstances." );

		}while( false );	

		if( ! ret ){
			if( collectionData  != NULL ){
				collectionData->mBroken   = true;
			}
		
			//	G[͈ړ
			this->getRunner().moveToScene( AB_SCENE_MUSIC_SELECT );
			this->mStartError = true;
			return;
		}

		this->mStartBMS = true;
		this->mStartError = false;
	} 

}

//--------------------------------------------------------------------------
//	V[IɌĂяo܂
//--------------------------------------------------------------------------
void	ABSceneStagePlay::onExitScene( void )
{
	//	eNX`폜ORender
//	glFinish();

	//	BMS~͐摗B
	ABGetBMSRunner().cleanup();

	GameGetAudio().finalize();
}

//--------------------------------------------------------------------------
//	Q[[v
//--------------------------------------------------------------------------
void	ABSceneStagePlay::onGameLoop( void )
{
//	ABint		i;
	ABbool			ret;
	bool			moveNext = false;
	ABBMSRunner&	bmsRunner = ABGetBMSRunner();
	ABSingleton&	absingleton	= ABGetSingleton();

	if( this->mStartError ){
		return;
	}

	//	ĐJn
	if( this->mStartBMS ){
		ret = bmsRunner.mBMSRunner.playSong( bmsRunner.mSong, bmsRunner.mBMSFolder->getResource() );
		if( !ret ){
			this->getRunner().moveToScene( AB_SCENE_MUSIC_SELECT );
			return;
		}
		this->mStartBMS = false;
	}

	//	vCԂ̏\
	//		EVisualArchitectureƂėpӂ`揈NXʓrR[B
	//		@NXŕ`悷邱ƂŁA`R[h͂ĂB
	//		@`@ς悤ȏCƂA
	//		@̊֐͉ҏWȂčςގ]܂B
	ABVAItemBindStagePlay*	binder = static_cast<ABVAItemBindStagePlay*>(this->getRunner().mVARunner.getCurrentBinder());

	//	݂̃gK[ԂQ
	{
		
		//	check pushed ESC Button
		if( GameGetJoystick().isPush( AB_TRRIGER_MENU_CANCEL ) ){
			moveNext = true;
		}
		if( bmsRunner.mBMSRunner.isEnd() ){
			moveNext = true;
		}
//		moveNext  =true;
		
		if( moveNext ){
			//	IASceneֈړ

//			this->getRunner().moveToScene( AB_SCENE_PLAY );
//			this->getRunner().moveToScene( AB_SCENE_MUSIC_SELECT );
			this->getRunner().moveToScene( AB_SCENE_FINISH );
//			GUIApp::appQuit();
			return;
		}
	}
}

//--------------------------------------------------------------------------
//	AvP[VCxg
//--------------------------------------------------------------------------
ABbool	ABSceneStagePlay::onAppEvent( GEeventAppType  inAppEventType )
{
	return	true;
}

////////////////////////////////////////////////////////////////////////////
//
//	VhEV[Cxgnh[
//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneStagePlay::onEnterGameLoop( void )
{
}

//--------------------------------------------------------------------------
//	Q[[vȌ
//--------------------------------------------------------------------------
void	ABSceneStagePlay::onExitGameLoop( void )
{
}
