/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSRSceneBase.cpp

				Q[V[NX

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/15	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////
#ifndef	ABSRSceneBase_h
#define	ABSRSceneBase_h

#include	"GlobalConfig.h"
#include	"ABSceneRunner.h"

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSRSceneBase
{
public:
	explicit	ABSRSceneBase( ABSceneRunner&  inRunner ) : 
		m_sceneMaster( inRunner ),
		m_sceneNumber( ABSR_SCENE_NOTHING )
	{ 
	}
	virtual ~ABSRSceneBase()
	{ 
	}

	//--------------------------------------------------------------------------
	//	V[Cxgnh[
	//--------------------------------------------------------------------------

	//	V[i[NɌĂяo܂
	//		[mۓs܂
	virtual ABbool	onInitialize( void ){ return( false ); };

	//	V[i[IOɌĂяo܂
	//		[mۓs܂
	virtual void	onFinalize( void ){};

	//	V[JnɌĂяo܂
	//		f[^̏s܂
	virtual void	onEnterScene( void ){};

	//	V[IɌĂяo܂
	//		f[^̌ns܂
	virtual void	onExitScene( void ){};

	//	Q[[v
	//		1/60b̏ɌĂяo܂B`揈͂ōs܂B
	virtual void	onGameLoop( void ){};

	//	AvP[VCxg
	//		falseԂƁACxg̑sj~܂B
	virtual ABbool	onAppEvent( GEeventAppType  inAppEventType ){ return( false ); };

	//--------------------------------------------------------------------------
	//	VhEV[Cxgnh[
	//		VhEV[ƂĐݒ肵Ƃ̂ݎs܂
	//--------------------------------------------------------------------------

	//	Q[[vȌ
	//		V[onGameLoop()̑OŌĂяo܂B
	virtual void	onEnterGameLoop( void ){};

	//	Q[[vȌ
	//		V[onGameLoop()̌ŌĂяo܂B
	virtual void	onExitGameLoop( void ){};
	
	//	Q[V[JnO
	//		V[onEnterScene̍ŌɌĂт܂B̓tF[hAEĝ߂Ɏgp܂B
	virtual void	onSpecificEnterScene( void ){};
	
	//	Q[V[IO
	//		V[ononExitScenȇOɌĂт܂B̓tF[hAEĝ߂Ɏgp܂B
	virtual void	onSpecificExitScene( void ){};

	//--------------------------------------------------------------------------
	//	Property
	//--------------------------------------------------------------------------
	//	V[i[
	ABSceneRunner&		getRunner( void ){ return this->m_sceneMaster; };
	
	//	V[ԍ
	void		setSceneNumber( ABuint32  inNumber ){
		this->m_sceneNumber = inNumber;
	}
	ABuint32	getSceneNumber( void ){
		return	this->m_sceneNumber ;
	}
	
private:
	ABSceneRunner&		m_sceneMaster;
	ABuint32			m_sceneNumber;

private:
	ABSRSceneBase( void );
};

#endif	//	ABSRSceneBase_h
