/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSceneRunner.h

				V[i[
					EV[ǗsB
					EV[Ƃ́A^CgʁAvCʁAIvVݒʂȂǁA
					@eʖwB
					
					@eʂABSRSceneBaseNXhč쐬A
					@eV[̎𓝈AV[Ԃ̈ړ₷鎖łB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/15	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABSceneRunner_h
#define	ABSceneRunner_h

#include	<vector>
#include	<list>

#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"ABVAResource.h"
#include	"ABVARunner.h"

class	ABSRSceneBase;

/*//////////////////////////////////////////////////////////////////////////////
*	Define
*///////////////////////////////////////////////////////////////////////////////

//-------------------------------------------------
//	scene number
//-------------------------------------------------
enum{
	ABSR_SCENE_MAX = 64L,

	ABSR_SCENE_NOTHING = (ABuint32)((1 << 31) - 1),
};

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSceneRunner
{
public:
	ABVAResource		mVAResource;
	ABVARunner			mVARunner;
	
public:
	ABSceneRunner();
	virtual ~ABSceneRunner();

	//	initialize
	void	initialize( void );
	//	fainalize
	void	finalize( void );

	//----------------------------
	//	scene control
	//----------------------------
	//	Scene start
	bool	startScene( void );
	//	Scene end
	void	endScene( void );
	//	move To Scene
	bool	moveToScene( ABuint32  inSceneNum );

	//----------------------------
	//	get / set
	//----------------------------
	//	Get current shene number
	ABuint32	getCurrentSceneNumber( void );

public:
	//----------------------------
	//	scene event
	//----------------------------
	bool	eventCreateInstance( ABuint32  inSceneNum );
	void	eventReleaseInstance( ABuint32  inSceneNum );
	void	eventEnterScene( ABuint32  inSceneNum );
	void	eventExitScene( ABuint32  inSceneNum );
	void	eventGameLoop( void );
	//	falseԂƁACxg̑s𒆎~܂
	bool	eventAppEvent( GEeventAppType  inAppEventType );

	//----------------------------
	//	scene
	//----------------------------
	//	add scene
	void	addScene( ABSRSceneBase*  inScene, ABuint32  inSceneNum );
	//	get scene
	ABSRSceneBase*	getScene( ABuint32  inSceneNum );
	ABSRSceneBase*	getScene( void );
	//	get scene count
	ABuint32	getSceneCount( void );
	
	//----------------------------
	//	shadow scene
	//		escenẻAƂċ@\BsceneԂŋʂ鏈́AVhEsceneɋLq邱ƂłB
	//----------------------------
	//	set shadow scene
	void	setSceneShadow( ABSRSceneBase*  inSceneShadow );
	//	get shadow scene
	ABSRSceneBase*	getSceneShadow( void );

	//----------------------------
	//	start scene
	//----------------------------
	//	set 
	void	setStartScene( ABuint32  inSceneNumber);
	//	get 
	ABuint32	getStartScene( void );

private:
	//	clean
	void	clean( void );
	//	moveToScene
	bool	controlScene( void );

private:
	//	scene manage structure
	struct	MScenePack{
		ABSRSceneBase*	sceneInstance;
		bool			trueIsSceneActive;			//	SceneH
	};
	typedef struct	MScenePack			MScenePack;
	typedef	std::vector<MScenePack>		MSceneArray;

	//	scene control
	enum{
		ABSR_CONTROL_MOVE,	//	V[ړ
	};
	typedef	ABtype	ABSRControlType;
	typedef	struct	ABSRControl{
		ABSRControlType		control;
		ABuint32			sceneNumber;
		
	} ABSRControl;

	typedef	std::list<ABSRControl>	ABSRControlArray;
	typedef	ABSRControlArray::iterator	ABSRControlArrayIt;

	ABSRControlArray	mControlStack;
	
private:
	//	data member
	MSceneArray			m_sceneArray;
	ABuint32			m_sceneNumberCurrent;		//	݂̍\̈ʒu
	ABuint32			m_sceneNumberStart;			//	JnV[
	ABSRSceneBase*		m_sceneShadow;				//	Ascene
};

#endif	//	ABSceneRunner_h
