/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABView.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	<iostream>

#include	"ABSingleton.h"
#include	"ABView.h"
#include	"ABSceneConfig.h"

#include	"GameView.h"
#include	"GameSingleton.h"
#include	"GameTimer.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABView::ABView( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABView::~ABView( void )
{
}

//-------------------------------------------------------------------------------------------------
//	initialize
//-------------------------------------------------------------------------------------------------
ABbool			ABView::initialize( void )
{
	ABbool	ret;

	do{
		this->m_framecount = 0;
	
		//	ݒ\z
		ABGamePreference&	preference = ABGetPreference();	//	̏uԁAInstance𐶐B
		
		//	ݒǂݍ
		
		//	fobOpݒ
		{
		}
	
		//	_[
		GGRender&			renderer = GGGetRender();
		ret = renderer.initialize( GE_SPRITE_MAX );
		ABTestBreakReportError( ! ret, "renderer initialize." );

		renderer.renderSetup();

		//	I[fBI
		GameAudio&			audio = GameGetAudio();
		ret = audio.initialize( true );
		ABTestBreakReportError( ! ret, "audio initialize." );

		//	WCXeBbN
		GameJoystick&		joystick = GameGetJoystick();
		ret = joystick.setup();
		ABTestBreakReportError( ! ret, "joystick setup." );
		joystick.active();
		
		//	WCXeBbNݒǂݍ

		//	V[
		this->m_sceneRunner.initialize();

		//	V[쐬
		try{
			ABCreateGameScene( this->m_sceneRunner );
		}
		catch( std::bad_alloc ){
			ret = false;
			ABTestBreakReportError( ! ret, "ABCreateGameScene." );
		}
		
		//	V[Jn
		ret = this->m_sceneRunner.startScene();
		ABTestBreakReportError( ! ret, "scene runner startScene." );

		//	DEBUG
		//		ẼV[fobMOƂ́AŒѐw肵܂B
		this->m_sceneRunner.moveToScene( AB_SCENE_ENTRANCE );
//		this->m_sceneRunner.moveToScene( AB_SCENE_CONFIGURATION );
//		this->m_sceneRunner.moveToScene( AB_SCENE_KEY_CONFIGURATION );

//		this->m_sceneRunner.moveToScene( AB_SCENE_MUSIC_SELECT );
//		this->m_sceneRunner.moveToScene( AB_SCENE_ENTRY );
//		this->m_sceneRunner.moveToScene( AB_SCENE_PLAY );
//		this->m_sceneRunner.moveToScene( AB_SCENE_FINISH );

		ret = true;
	}while( false );

	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	finalize
//-------------------------------------------------------------------------------------------------
void			ABView::finalize( void )
{
	ABuint32		i;

	this->m_sceneRunner.endScene();

	for( i = 0 ; i < this->m_sceneRunner.getSceneCount(); i++ ){
		delete	this->m_sceneRunner.getScene( i );
	}
	delete	this->m_sceneRunner.getSceneShadow();
	this->m_sceneRunner.finalize();

	GameAudio&			audio = GameGetAudio();
	audio.finalize();

	GGRender&			renderer = GGGetRender();
	renderer.renderCleanup();
	renderer.finalize();
}

//-------------------------------------------------------------------------------------------------
//	change screen mode
//-------------------------------------------------------------------------------------------------
void			ABView::changeScreenMode( ABbool  inTrueIsFullScreenMode )
{
	GGGetRender().renderSetup();
}

//-------------------------------------------------------------------------------------------------
//	`ƃ_[ƃXbv
//-------------------------------------------------------------------------------------------------
ABbool			ABView::draw( const ABuint32  inWidth, const ABuint32  inHeight )
{
	ABbool	ret = true;
	
	//	t[[g떂
	//	Eʕ`悾wt[[gɍ킹Č炷s܂
	//	E^C}[͏ɖb60񏈗Ȃ΂Ȃ܂BAnimation̑́Ab60ł邱ƂOƂĂ܂B

	this->m_sceneRunner.eventGameLoop();

	ABint	drawrate = 60;
	ABint	rate = AbConfigGetDrawFrameRate( ABGetPreference().playConfig.drawFrameRate );
	if( ( this->m_framecount % (drawrate / rate)) == 0 ){

		//	Ƃ`悷B

		//	_O
		GGGetRender().render();

		//	t[[gv
		GameTimer::updateFrameRate();
	}
	else{
		//	XbvȂ
		ret = false;
	}
	this->m_framecount = (++this->m_framecount) % drawrate;

	//	TEhnhO
	GameGetAudio().handling();
	return	ret;	
}

//-------------------------------------------------------------------------------------------------
//	`̈XV
//-------------------------------------------------------------------------------------------------
void			ABView::reshape( const ABuint32  inWidth, const ABuint32  inHeight )
{
	GGGetRender().reshape( inWidth, inHeight );
}

//-------------------------------------------------------------------------------------------------
//	AvP[VCxgɌĂт܂
//-------------------------------------------------------------------------------------------------
ABbool	ABView::appEvent( const GEeventAppType  inEvent )
{
	switch( inEvent ){
		//	IO
		case GE_EVENT_APP_QUIT:
			break;

		//	ANeBuɂȂ܂
		case GE_EVENT_APP_ACTIVATE:
			GameGetJoystick().active();
			break;

		//	fBANeBuɂȂ܂
		case GE_EVENT_APP_DEACTIVATE:
			GameGetJoystick().deactive();
			break;
	}
	return	 this->m_sceneRunner.eventAppEvent( inEvent );
}
