/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABTestRender.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABTestRender.h"

//-->Mac OS X
#include	"CWResourceService.h"
#include	"GEMacFileInfo.h"
//<--Mac OS X

#include	"GameSingleton.h"
#include	"GameString.h"

static CFStringRef	gTextureNames[] = {
	CFSTR("TestImage"),
};
enum{
	MY_TEXTURE_01,

	MY_TEXTURE_COUNT,
};

#define		MY_TEXTURE_FILE_EXT			CFSTR("psd")

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABTestRender::ABTestRender( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABTestRender::~ABTestRender( void )
{
}

//-------------------------------------------------------------------------------------------------
//	initialize
//-------------------------------------------------------------------------------------------------
ABbool			ABTestRender::initialize( void )
{
	ABbool		ret;
	GGSprite*	sprite = NULL;
	GGRender&	renderer = GGGetRender();
	ABint		i;

	do{
		//	eNX`
		for( i = 0 ; i < MY_TEXTURE_COUNT; i++ ){ 
			{
			
				//	--> mac os x
				//	eNX`ǂݍ
				FSRef			fsRef;
				CWresultCode result = RSGetResourceFile( NULL, gTextureNames[ i ], MY_TEXTURE_FILE_EXT, NULL, &fsRef );
				if( result != CW_NO_ERROR ){ break; }
				GameFileInfo	fileInfo( fsRef );
				//	<-- mac os x

				ret = this->m_texture[0].opneBitmap( &fileInfo, true, GE_BMP_TRANSPARENT_ALPHA );
				if( ! ret ){ break; }
				ret = this->m_texture[0].bindTexture();
				if( ! ret ){ break; }

				ret = this->m_texture[1].opneBitmap( &fileInfo, true, GE_BMP_TRANSPARENT_BLACK );
				if( ! ret ){ break; }
				ret = this->m_texture[1].bindTexture();
				if( ! ret ){ break; }

				ret = this->m_texture[2].opneBitmap( &fileInfo, true, GE_BMP_TRANSPARENT_WHITE );
				if( ! ret ){ break; }
				ret = this->m_texture[2].bindTexture();
				if( ! ret ){ break; }
			}
		}
	
		ret = renderer.initialize( M_SPRITE_MAX );
		if( ! ret ){ break; }

		//	O[v쐬
		ret = renderer.addGroup( &this->m_group1 );
		if( ! ret ){ break; }
		
		ret = renderer.addGroup( &this->m_group2 );
		if( ! ret ){ break; }
		
		this->m_group2->setClip( 128, 128, 256, 256 );

		//	XvCg
		for( i = 0 ; i < M_SPRITE_COUNT; i++ ){
			sprite = &this->m_sprite[ i ];
			
			sprite->m_textureName = this->m_texture[ i % 3 ].getTextureName();
			sprite->m_texCoord[0].x = 0.0f;
			sprite->m_texCoord[0].y = 0.0f;
			sprite->m_texCoord[1].x = 1.0f;
			sprite->m_texCoord[1].y = 1.0f;
			
			sprite->m_width		= 32;
			sprite->m_height	= 32;

			sprite->m_locate.x	= abs(random() % (ABint)640);
			sprite->m_locate.y	= abs(random() % (ABint)480);
			sprite->m_locate.z	= (GLfloat)i / 10000.0f;

			sprite->m_color.r		= (GLfloat)( abs(random() % (ABint)128) / 128.0 ) + 0.5f;
			sprite->m_color.g		= (GLfloat)( abs(random() % (ABint)128) / 128.0 ) + 0.5f;
			sprite->m_color.b		= (GLfloat)( abs(random() % (ABint)128) / 128.0 ) + 0.5f;
			sprite->m_color.a		= 1.0f / ((GLfloat)i / 100.0f);

			if( i < 100 ){
				ret = renderer.addPrimitive( this->m_group2, sprite, true, &this->m_spriteIt[ i ] );
				if( ! ret ){ break; }
			}
			else{
				ret = renderer.addPrimitive( this->m_group1, sprite, true, &this->m_spriteIt[ i ] );
				if( ! ret ){ break; }
			}
		}
	
		//	eLXg
		this->m_text.mSprite.m_width = 256;
		this->m_text.mSprite.m_height = 256;
		this->m_text.mSprite.m_locate.set( 60, 60, 0 ); 
		this->m_text.mSprite.m_color.set( 255, 255, 255, 255 );
		this->m_text.mSprite.setup(  this->m_group1, false );
		this->m_text.mFontName		= "Monaco";
		this->m_text.mFontSize		= 16.0f;
		this->m_text.mAlignX		= GE_TEXT_ALIGN_LEFT;
		this->m_text.mAlignY		= GE_TEXT_ALIGN_Y_CENTER;
		this->m_text.mUntiAliasing	= false;
		this->m_text.mFontStyle		= GE_FONT_NOMAL;
		ret = this->m_text.setup();
		if( ! ret ){ break; }
		
		//	eLXg`
//		this->m_text.draw( GESTR( "HALLO WORLD" ) );
	
		//	eLXg 2
		this->m_textBuffer.mSprite.m_width = 256;
		this->m_textBuffer.mSprite.m_height = 256;
		this->m_textBuffer.mSprite.m_locate.set( 320, 60, 0 ); 
		this->m_textBuffer.mSprite.m_color.set( 255, 255, 255, 255 );
		this->m_textBuffer.mSprite.setup(  this->m_group1, false );
		this->m_textBuffer.mFontName		= "Monaco";
		this->m_textBuffer.mFontSize		= 16.0f;
		this->m_textBuffer.mAlignX			= GE_TEXT_ALIGN_X_FIT;
		this->m_textBuffer.mAlignY			= GE_TEXT_ALIGN_Y_FIT;
		this->m_textBuffer.mUntiAliasing	= true;
		this->m_textBuffer.mFontStyle		= GE_FONT_NOMAL;
		ret = this->m_textBuffer.setup();
		if( ! ret ){ break; } 
		{
			ABint8		ascii[17 * 16 + 1];
			memset( ascii, 0, sizeof(ascii) );
			ascii[256] = 0;
			ABint x, y;
			i = 0;
			for( y = 0 ; y < 16 ; y ++ ){
				for( x = 0 ; x < 16 ; x++ ){
					if( ('0' <= i) &&  ( i <= 'z' ) ){
						ascii[ y * 17 + x ] = i;
					}
					else{
						ascii[ y * 17 + x ] = '.';
					}
					++i;
				}
				ascii[ y * 17 + 16 ] = '\n';
			}
			
			GameString	str;
			str.setCString( ascii, GS_ENCORDING_ASCII );
			CFShow( str.getString() );
			this->m_textBuffer.draw( str.get() );
		}

		for( i = 0 ; i < 256 ; i ++ ){
			GGFont::MFont	f;
			f.cellX = i % 16;
			f.cellY = i / 16;
			f.enable = true;
			this->m_font.setFontTable( i, f );
		}

		this->m_textSprite.mTextLengthMax = 64;
		this->m_textSprite.mLocate.set( 8, 8, 0 );
		this->m_textSprite.mColor.set( 255, 255, 255, 255 );
		this->m_textSprite.mWidth = 16;
		this->m_textSprite.mHeight = 16;
		this->m_textSprite.mFont = &this->m_font;
		this->m_textSprite.mSurface = this->m_textBuffer.getTexture();
		
		this->m_textSprite.setup( this->m_group1, false );
		this->m_textSprite.draw( "0123HALLO WORLD" );

		//
		renderer.renderSetup();

	}while( false );

	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	finalize
//-------------------------------------------------------------------------------------------------
void			ABTestRender::finalize( void )
{
	GGRender&	renderer = GGGetRender();
	renderer.renderCleanup();
	renderer.finalize();
}

//-------------------------------------------------------------------------------------------------
//	change screen mode
//-------------------------------------------------------------------------------------------------
void			ABTestRender::changeScreenMode( ABbool  inTrueIsFullScreenMode )
{
	GGGetRender().renderSetup();
}

//-------------------------------------------------------------------------------------------------
//	`ƃ_[ƃXbv
//-------------------------------------------------------------------------------------------------
ABbool			ABTestRender::draw( const ABuint32  inWidth, const ABuint32  inHeight )
{
	GGRender&	renderer = GGGetRender();

	ABbool		ret;
	GGSprite*	sprite = NULL;
	ABint		i;

	//	XvCg̍XV
	for( i = 0 ; i < M_SPRITE_COUNT; i++ ){
		sprite = &this->m_sprite[ i ];

		sprite->m_locate.x	+= 1.0f;
		if( inWidth < sprite->m_locate.x ){
			sprite->m_locate.x = 0 - sprite->m_width;
		}
		sprite->m_locate.y	+= 1.0f;
		if( inHeight < sprite->m_locate.y ){
			sprite->m_locate.x	= abs(random() % (ABint)1280) - 640;
			sprite->m_locate.y = 0 - sprite->m_height;
		}
		
		if( i < 80 ){
			sprite->m_doRotate = true;
			sprite->m_rotateCenter.x = sprite->m_width / 2.0f;
			sprite->m_rotateCenter.y = sprite->m_height / 2.0f;
			sprite->m_rotate.x	+= 1.0f;
		}

		ret = renderer.setPrimitive( this->m_spriteIt[ i ], sprite );
		if( ! ret ){ break; }
	}
	
	//	eLXg`
	this->m_text.draw( GESTR( "HALLO WORLD\rHALLO WORLD\rHALLO WORLD\rHALLO WORLD\r..." ) );

	//	_O
	renderer.render();
	
	return	true;
}

//-------------------------------------------------------------------------------------------------
//	`̈XV
//-------------------------------------------------------------------------------------------------
void			ABTestRender::reshape( const ABuint32  inWidth, const ABuint32  inHeight )
{
	GGGetRender().reshape( inWidth, inHeight );
}


//-------------------------------------------------------------------------------------------------
//	AvP[VCxgɌĂт܂
//-------------------------------------------------------------------------------------------------
ABbool	ABTestRender::appEvent( const GEeventAppType  inEvent )
{
	ABbool	ret = true;	//	̃Cxgp
		
	switch( inEvent ){
		//	IO
		//		j[AAbvCxgɂIiVXeIɔIE܂jB
		case GE_EVENT_APP_QUIT:
			break;

		//	ANeBuɂȂ܂
		case GE_EVENT_APP_ACTIVATE:
			break;

		//	fBANeBuɂȂ܂
		case GE_EVENT_APP_DEACTIVATE:
			break;
	}

	return	ret;
}
