/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABTestRender.cpp

				Render@\eXgNX

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABTestRender_h
#define	ABTestRender_h

#include	"GlobalConfig.h"
#include	"GGRender.h"
#include	"GGTexture.h"
#include	"GGSprite.h"
#include	"GGText.h"

#include	"ABView.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABTestRender : public ABView
{
private:
	enum{
		M_SPRITE_MAX	 = 1000,
		M_SPRITE_COUNT = 600,
	};

	GGSprite			m_sprite[M_SPRITE_COUNT];
	GGPrimitiveListIt	m_spriteIt[M_SPRITE_COUNT];

	GGPrimitiveGroupListIt		m_group1;
	GGPrimitiveGroupListIt		m_group2;
	
	GGTexture		m_texture[3];
	
	GGText			m_text;
	
	GGText			m_textBuffer;
	GGFont			m_font;
	GGTextSprite	m_textSprite;

public:
	ABTestRender( void );
	virtual ~ABTestRender( void );

	//	initialize
	//		AvP[V̏ɌĂт܂B
	virtual ABbool		initialize( void );

	//	finalize
	//		AvP[V̏IsOɌĂт܂B
	virtual void		finalize( void );

	//	change screen mode
	//		j[tXN[[hύXsƂɌĂт܂B
	virtual void		changeScreenMode( ABbool  inTrueIsFullScreenMode );

	//	`ƃ_[ƃXbv
	//		̃^C~Oi1/60bԊujŌĂт܂B
	//		̊֐IAglFlushyуobt@[̃Xbvs܂B
	virtual ABbool		draw( const ABuint32  inWidth, const ABuint32  inHeight );

	//	`̈XV
	//		EBhETCYύXƂɌĂт܂B
	//		tXN[[hύXɂĂт܂B
	virtual void		reshape( const ABuint32  inWidth, const ABuint32  inHeight );

	//	AvP[VCxgɌĂт܂
	virtual ABbool		appEvent( const GEeventAppType  inEvent );
};


#endif	ABTestRender_h
