/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABTestScheme.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABTestScheme.h"
#include	"ABTestVAItemPreset.h"
#include	"ABVAItemConfig.h"

#include	"GameSingleton.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABTestScheme::ABTestScheme( void )
:
	m_vaRunner( m_vaResource )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABTestScheme::~ABTestScheme( void )
{
}

//-------------------------------------------------------------------------------------------------
//	initialize
//-------------------------------------------------------------------------------------------------
ABbool			ABTestScheme::initialize( void )
{
	ABbool		ret = false;

	do{
		GGRender&			renderer = GGGetRender();
		ret = renderer.initialize( M_SPRITE_COUNT );
		if( ! ret ){ break; }

		//	O[v쐬
		for( ABint i = 0 ; i < ABVA_RENDER_GROUP_COUNT; i++ ){
			ret = renderer.addGroup( &this->m_vaResource.mRenderGroup[ i ] );
			if( ! ret ){ break; }
		}
		if( ! ret ){ break; }
		

		//	SchemeSet̃vZbeBO
		ABTestVAItemPreset		preset;
		ret = this->m_vaRunner.createItems( preset );
	
		//	Instance쐬
		ret = this->m_vaRunner.createInstances( AB_TEST_VA_SCENE_1 );
	
		renderer.renderSetup();
		ret = true;
	}while( false );

	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	finalize
//-------------------------------------------------------------------------------------------------
void			ABTestScheme::finalize( void )
{
	GGRender&			renderer = GGGetRender();

	this->m_vaRunner.releaseItems();
	
	renderer.renderCleanup();
	renderer.finalize();
}

//-------------------------------------------------------------------------------------------------
//	change screen mode
//-------------------------------------------------------------------------------------------------
void			ABTestScheme::changeScreenMode( ABbool  inTrueIsFullScreenMode )
{
	GGGetRender().renderSetup();
}

//-------------------------------------------------------------------------------------------------
//	`ƃ_[ƃXbv
//-------------------------------------------------------------------------------------------------
ABbool			ABTestScheme::draw( const ABuint32  inWidth, const ABuint32  inHeight )
{
	//	IACe̍XV
	ABVAItemSpriteObject*		sprite = static_cast<ABVAItemSpriteObject*>(this->m_vaRunner.getInstance( AB_TEST_VA_SPRITE, 0 ));

	sprite->mSprite.m_locate.x	+= 1.0f;
	if( inWidth < sprite->mSprite.m_locate.x ){
		sprite->mSprite.m_locate.x = 0 - sprite->mSprite.m_width;
	}
	sprite->mSprite.update();

	//	_O
	GGGetRender().render();
	return	true;
}

//-------------------------------------------------------------------------------------------------
//	`̈XV
//-------------------------------------------------------------------------------------------------
void			ABTestScheme::reshape( const ABuint32  inWidth, const ABuint32  inHeight )
{
	GGGetRender().reshape( inWidth, inHeight );
}


//-------------------------------------------------------------------------------------------------
//	AvP[VCxgɌĂт܂
//-------------------------------------------------------------------------------------------------
ABbool	ABTestScheme::appEvent( const GEeventAppType  inEvent )
{
	ABbool	ret = true;	//	̃Cxgp
		
	switch( inEvent ){
		//	IO
		//		j[AAbvCxgɂIiVXeIɔIE܂jB
		case GE_EVENT_APP_QUIT:
			break;

		//	ANeBuɂȂ܂
		case GE_EVENT_APP_ACTIVATE:
			break;

		//	fBANeBuɂȂ܂
		case GE_EVENT_APP_DEACTIVATE:
			break;
	}

	return	ret;
}
