/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABTestVAItemPreset.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABTestVAItemPreset.h"
#include	"ABVAItemConfig.h"

//-->Mac OS X
#include	"CWResourceService.h"
#include	"GEMacFileInfo.h"
//<--Mac OS X

static CFStringRef	gTextureNames[] = {
	CFSTR("TestImage"),
};
enum{
	MY_TEXTURE_01,

	MY_TEXTURE_COUNT,
};

#define		MY_TEXTURE_FILE_EXT			CFSTR("psd")


//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABTestVAItemPreset::ABTestVAItemPreset( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABTestVAItemPreset::~ABTestVAItemPreset( void )
{
}

//-------------------------------------------------------------------------------------------------
//	ZbgAbv
//-------------------------------------------------------------------------------------------------
void	ABTestVAItemPreset::setup( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc )
{
	inSetupper.setList( AB_TEST_VA_SCENE_1 );
	this->setup1( inSetupper );
	inSetupper.setList( AB_TEST_VA_SCENE_2 );
	this->setup2( inSetupper );
}

//-------------------------------------------------------------------------------------------------
//	ZbgAbv1
//-------------------------------------------------------------------------------------------------
void	ABTestVAItemPreset::setup1( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc )
{ 
	//	ÓIȃACe	XvCg
	{
		ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite );
		
		item->mLocation.set( 320.0f, 240.0f, 0.0f );
		item->mWidth	= 64;
		item->mHeight	= 64;
		
		item->mColor.set( 128, 128, 255, 255 );
	}

	//	IȃACe	XvCg
	{
		ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, AB_TEST_VA_SPRITE );
		
		item->mLocation.set( 120.0f, 120.0f, 0.0f );
		item->mWidth	= 32;
		item->mHeight	= 32;
		
		item->mColor.set( 128, 255, 128, 255 );
	}

	//	eNX`tXvCg
	{ 
		ABVAItemResImage*	texture;
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			texture = item;
			
			//	--> mac os x
			//	eNX`ǂݍ
			FSRef			fsRef;
			CWresultCode result = RSGetResourceFile( NULL, gTextureNames[ 0 ], MY_TEXTURE_FILE_EXT, NULL, &fsRef );
			if( result != CW_NO_ERROR ){ throw( NULL ); }
			item->mFileInfo.setFSRef( fsRef );
			//	<-- mac os x

			item->mWidth	= 0;
			item->mHeight	= 0;
			item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
		}

		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, AB_TEST_VA_SPRITE_2 );
			
			item->mSurface			= texture;
			item->mCellWidth		= 0;
			item->mCellHeight	= 0;
			item->mCellNumber.set( 0, 0 );
			
			item->mLocation.set( 120.0f, 320.0f, 0.0f );
			item->mWidth	= 32;
			item->mHeight	= 32;
			
			item->mColor.set( 255, 255, 255, 255 );
		}
	}

	//	eLXg{bNX
	{
		ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
		
		item->mLocation.set( 16.0f, 16.0f, 0.0f );
		item->mWidth	= 256;
		item->mHeight	= 32;
		item->mColor.set( 128, 255, 128, 255 );
		
		item->mFontSize = 10.0f;
		item->mFontName = "Monaco";
		
		item->m_textAlignX = GE_TEXT_ALIGN_LEFT;
		item->m_textAlignY = GE_TEXT_ALIGN_TOP;

		item->mText.setCString( "HALLO WORLD\nHALLO WORLD", kCFStringEncodingASCII );
	}


}

//-------------------------------------------------------------------------------------------------
//	ZbgAbv2
//-------------------------------------------------------------------------------------------------
void	ABTestVAItemPreset::setup2( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc )
{
	
}
