/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	AquaBests
*
*	Component:	global
*	File:		AquanBeatsPreference.cpp
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00
*		2003/08/10	Itinoshe Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<AquaBests>
*    Copyright (C) <2003/08/01>  <AquaBests-project>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////
#include	"AquanBeatsPreference.h"
#include	"Gamepreference.h"

#include	"GameSingleton.h"
#include	"GameView.h"
#include	"GUIApp.h"

//-----------------------------------------
//	Constructor
//-----------------------------------------
AquanBeatsPreference::AquanBeatsPreference()
{
}

//-----------------------------------------
//	Destructor
//-----------------------------------------
AquanBeatsPreference::~AquanBeatsPreference()
{
}

//-------------------------------------------------------------------------------------------------
//	ݒ̓ǂݍ
//-------------------------------------------------------------------------------------------------
ABbool	AquanBeatsPreference::loadPreference( ABGamePreference*  ioPreference ) 
{
	ABbool		ret;

	do{
		//	ݒǂݍ
		//	MacOSXł́ABinaryۂƏݒt@Cɏ߂邽߁APɍ\̂Rs[Ċ܂B
		ABuint8*	buffer = NULL;
		do{
			ret = false;
			ABsize	prefSize = GamePreference::getBinaryDize( AB_CONFIG_PROPERTY_KEY_CONFIG );
			if( prefSize != 0 ){
				buffer = (ABuint8*)calloc( sizeof(ABuint8*), prefSize );
				ABTestBreakReportError( buffer == NULL , "calloc( sizeof(ABuint8*), prefSize )." );
				ret = GamePreference::getCopyBinary( AB_CONFIG_PROPERTY_KEY_CONFIG, buffer, prefSize );
				ABTestBreakReportError( ! ret, "load preference error." );

				//	\̃`FbN
				//	o[WAbv́AKvɉāAK؂ȏgݍŉ
				//
				//	::TODO::2004/05/03
				//	ʓIȃAvP[V́Ao[WAbvɔAݒt@CVKvL܂B
				//	̂ƂAÂo[W̃ACfeBeBŏݒǂݎAVACfeBeB̏ݒɕKv܂B
				//	邱ƂŁAÂo[WƐVo[WƂAp鎖\ɂȂ܂B
				//	iVo[W̏ݒ肪炩ɈقȂꍇŁA̍ƂsȂAÂo[W͏ݒǂ߂ȂȂ܂Bj
				//	A݂CodeWorkerw͎̃ACfeBeB邱Ƃo܂BKvȂACodeWorkerɏCȂ΂Ȃ܂B
				//	Ώ@ƂĊȒPȕ@́AKEYVo[WŕύX邱ƂłB
				//	AB_CONFIG_PROPERTY_KEY_CONFIG_VER_200ȂǂƁAo[WɐVKEY쐬A
				//	߂Ă̋NɑOo[WKEYeRs[悤ɂƊȒPłB
				//
				ABGamePreference*	checkBuffer = (ABGamePreference*)buffer;
				if( prefSize != sizeof(ABGamePreference) ){
					ret = false;
					break;
				}

				//	Rs[
				*ioPreference = *checkBuffer;
			}
			ret = true;
		}while( false );
		free( buffer );
		if( ! ret ){
			break;
		}
	}while( false );
	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	ݒ̕ۑ
//-------------------------------------------------------------------------------------------------
ABbool	AquanBeatsPreference::savePreference( const ABGamePreference*  inPreference ) 
{
	//	ݒǂݍ
	//	MacOSXł́ABinaryۂƏݒt@Cɏ߂邽߁APɍ\̂Rs[Ċ܂B
	return GamePreference::writeBinary( AB_CONFIG_PROPERTY_KEY_CONFIG, (ABuint8*)inPreference, sizeof(ABGamePreference) );
}

	
//-------------------------------------------------------------------------------------------------
//	ݒ̔f
//	EȂ̂ŁAɊ܂߂ĉ
//	EinPreferenceύXOŁAinFuturePreferenceύXłBrĐVȂĂ̂XVĂB
//-------------------------------------------------------------------------------------------------
ABbool	AquanBeatsPreference::updatePreference( const ABGamePreference*  inPreference, ABGamePreference*  ioFuturePreference )
{
	const ABGamePreference*  op = inPreference; 
	ABGamePreference*  fp = ioFuturePreference;

	ABbool	change = false;

	//	! inPreference NULL ŌĂ΂邱Ƃ̂ŁAeXgĂr邱ƁB
	/*
		F
		
		change = true;	//	w肳ĂȂΖɕύX
		if( op ){
			//	w肳ĂƂAύXL邩`FbN
			change = ( op->playConfig.screenMode != fp->playConfig.screenMode );
		}
		if( change ){
			//	ύX
			...
		}

	*/
	
	//---------------------------------
	//	Master{[
	//---------------------------------
	change = true;
	if( op ){
		change = ( op->playConfig.masterVolume != fp->playConfig.masterVolume );
	}
	if( change ){
		GameGetAudio().setMasterVolume( (ABfloat32)fp->playConfig.masterVolume / 100.0f );
	}

	//---------------------------------
	//	XN[TCY̕ύX
	//---------------------------------
	change = true;
	if( op ){
		change = ( op->playConfig.screenMode != fp->playConfig.screenMode );
	}
	if( change ){
		ABint	w, h;
		AbConfigGetScreenSizeMode( fp->playConfig.screenMode, &w, &h );

		GUIView*		view = GameGetView();
		view->changeScreenSize( w, h );
//		GGGetRender().setGameScreenSize( w, h );
	}
	
	//---------------------------------
	//	CACHETCY
	//---------------------------------
	if( fp->playConfig.cacheSize < AB_SOUND_FILE_CACHE_SIZE_MIN ){
		fp->playConfig.cacheSize = AB_SOUND_FILE_CACHE_SIZE_MIN;
	}
	
	return true;
}

//-------------------------------------------------------------------------------------------------
//	WCXeBbNݒ̓ǂݍ
//-------------------------------------------------------------------------------------------------
ABbool	AquanBeatsPreference::loadJoystickConfig( void ) 
{
	ABbool		ret= true;

	do{
		//	
	}while( false );
	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	ݒ̕ۑ
//-------------------------------------------------------------------------------------------------
ABbool	AquanBeatsPreference::saveJoystickConfig( void ) 
{
	ABbool		ret= true;

	do{
	}while( false );
	return	ret;
}

