/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		AquanBeatsPreference.h

	Encoding:	Shift-JIS

				PreferenceݒB

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	AquanBeatsPreference_h
#define	AquanBeatsPreference_h

#include	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"CWGameAudioService.h"
#include	"AquanBeatsConfig.h"
#include	"ABMBSchemeData.h"
#include	"GameAudio.h"

//-------------------------------------------------------------------------------
//	ݒ
//-------------------------------------------------------------------------------

//	ݒKEY
//	Eݒt@Cւ̓ǂݏɎgp܂B
#define	AB_CONFIG_PROPERTY_KEY_CONFIG		"UserConfig"
#define	AB_CONFIG_PROPERTY_KEY_JOYSTICK		"JoystickConfig"

//	DefaultSchemẽtH_[
//	EDefaultScheméAK̖OɂȂΓǂݍ܂܂B
#define	AB_CONFIG_DEFAULT_SCHEME_FOLDER		"Default Scheme"

//-------------------------------------------------------------------------------
//	`
//	ȉ`́At@Cɕۑ邽߁AI[gNumber͐΂Ƀ_łBK萔`ĂB
//
//	EBMSConfig̒`Ɠ悤Ȃ̂łčlĉBȉ́AAquanBeatsConfigurationłB
//	@BMSwAAquanBeats̐ݒ荀ڂQƂĂ͐΂ɂ܂B
//	@BMSwAquanBeatswɗL邱ƂdvłB
//-------------------------------------------------------------------------------

//	Q[[h
enum{
	AB_GAME_MODE_FREEPLAY	= 0,
	AB_GAME_MODE_ARCADE		= 1,
	AB_GAME_MODE_EXPART		= 2,
};
typedef ABtype	ABgameModeType;

//	I[gvC[h
enum{
	AB_AUTO_PLAY_TYPE_NONE				= 0,	//	BMS_SEQ_AUTO_PLAY_TYPE_NONE
	AB_AUTO_PLAY_TYPE_ALL				= 1,	//	BMS_SEQ_AUTO_PLAY_TYPE_ALL
	AB_AUTO_PLAY_TYPE_KEY_TRACKS		= 2,	//	BMS_SEQ_AUTO_PLAY_TYPE_KEY_TRACKS
	AB_AUTO_PLAY_TYPE_SCRATCH_TRACKS	= 3,	//	BMS_SEQ_AUTO_PLAY_TYPE_SCRATCH_TRACKS
	
	AB_AUTO_PLAY_TYPE_COUNT				= 4,
};
typedef	ABtype	ABautoPlayType;

//	Q[x
enum{
	AB_GAME_LEVEL_EASY			= 0,	//	BMS_SEQ_GAME_LEVEL_EASY
	AB_GAME_LEVEL_NOMAL			= 1,	//	BMS_SEQ_GAME_LEVEL_NOMAL
	AB_GAME_LEVEL_HARD			= 2,	//	BMS_SEQ_GAME_LEVEL_HARD
	v_GAME_LEVEL_VERY_HARD		= 3,	//	BMS_SEQ_GAME_LEVEL_VERY_HARD
	
	AB_GAME_LEVEL_COUNT,
};
typedef	int		ABgameLevelType;

//	Xe[Wio[
enum{
	AB_STAGE_NUMBER_1	= 0,
	AB_STAGE_NUMBER_2	= 1,
	AB_STAGE_NUMBER_3	= 2,
	AB_STAGE_NUMBER_4	= 3,
	AB_STAGE_NUMBER_5	= 4,

	AB_STAGE_NUMBER_COUNT = 5,
};
typedef	ABtype	ABstageNumber;

//	nCXRAێ
enum{
	AB_PLAY_SCORE_ARRAY_COUNT = 100,
};

//	XN[[h
enum{
	AB_SCREEN_SIZE_MODE_320_240		= 0,
	AB_SCREEN_SIZE_MODE_640_480		= 1,
	AB_SCREEN_SIZE_MODE_800_600		= 2,
	AB_SCREEN_SIZE_MODE_1024_768	= 3,
	AB_SCREEN_SIZE_MODE_1280_1024	= 4,
	
	AB_SCREEN_SIZE_MODE_COUNT	= 5,
};
typedef	ABtype	ABscreenMode;

inline	void	AbConfigGetScreenSizeMode( ABscreenMode  inMode, ABint*  outW, ABint*  outH ){
	ABint	rect[AB_SCREEN_SIZE_MODE_COUNT][2] = {
		{	 320,  240	},
		{	 640,  480	},
		{	 800,  600	},
		{	1024,  768	},
		{	1200, 1024	},
	};
	*outW = rect[AB_SCREEN_SIZE_MODE_640_480][0];
	*outH = rect[AB_SCREEN_SIZE_MODE_640_480][1];
	if( 0 <= inMode && inMode < AB_SCREEN_SIZE_MODE_COUNT ){
		*outW = rect[inMode][0];
		*outH = rect[inMode][1];
	}
}

//	I[fBITv[g
enum{
	AB__SOUND_SAMPLE_RATE_05012,
	AB__SOUND_SAMPLE_RATE_08000,
	AB__SOUND_SAMPLE_RATE_11025,
	AB__SOUND_SAMPLE_RATE_16000,
	AB__SOUND_SAMPLE_RATE_22050,
	AB__SOUND_SAMPLE_RATE_32000,
	AB__SOUND_SAMPLE_RATE_44100,
	
	AB__SOUND_SAMPLE_RATE_COUNT,
};
typedef	ABtype	ABsoundSampleRate;
inline	GASsampleRate	AbConfigGetSampleRate( ABsoundSampleRate  inMode ){
	GASsampleRate	rate[AB__SOUND_SAMPLE_RATE_COUNT] = {
		GAS_SAMPLE_RATE_05012,
		GAS_SAMPLE_RATE_08000,
		GAS_SAMPLE_RATE_11025,
		GAS_SAMPLE_RATE_16000,
		GAS_SAMPLE_RATE_22050,
		GAS_SAMPLE_RATE_32000,
		GAS_SAMPLE_RATE_44100,
	};
	if( 0 <= inMode && inMode < AB__SOUND_SAMPLE_RATE_COUNT ){
		return	rate[ inMode ];
	}
	return	0;
}

//	`t[[g
//	60t[OŃ^C~O킹ĂAnimationL邽߁A3060ȊO̒lɂȂł
enum{
	AB__DRAW_FRAME_RATE_30,
	AB__DRAW_FRAME_RATE_60,
	
	AB__DRAW_FRAME_RATE_COUNT,
};
typedef	ABtype	ABdrawFrameRate;
inline	ABint	AbConfigGetDrawFrameRate( ABdrawFrameRate  inMode ){
	ABint	rate[AB__DRAW_FRAME_RATE_COUNT] = {
		30,
		60,
	};
	if( 0 <= inMode && inMode < AB__DRAW_FRAME_RATE_COUNT ){
		return	rate[ inMode ];
	}
	return	0;
}

//	CACHESize
enum{
	AB_SOUND_FILE_CACHE_SIZE_DEFAULT = GE_AUDIO_CACHE_FILE_SIZE * 40 * 3,	//	GE_AUDIO_CACHE_FILE_SIZE̔{ɂ邱
	AB_SOUND_FILE_CACHE_SIZE_MIN 	= AB_SOUND_FILE_CACHE_SIZE_DEFAULT,		//	AudioUnit̐̂߁AOɂĂ͍sȂBiɊJƂ̂łAudioFileɐ邽߁ACACHEȂ΂ȂȂj
	AB_SOUND_FILE_CACHE_SIZE_MAX 	= 80,									//	őeʂ͎s̕[TCY80Ƃ
};

//	vC[̕
enum{
	AB_PLAY_NAME_LENGTH	= 32,	//	ƂB
};

//	vC[l
enum{
	AB_PLAY_PLAYER_COUNT	= 2,
};

//-------------------------------------------------------------------------------
//	Preference
//		WCXeBbNݒ͂Ƃ͕ĕۑ܂B
//-------------------------------------------------------------------------------

#ifdef	OS_COMPILE_MAC_OS_X
#pragma options align=mac68k	//	\̃TCYݒBK2oCgEALIGNMENTĂB
#endif	OS_COMPILE_MAC_OS_X

typedef	struct ABGamePreference{

	//-----------------------
	//	\̃`FbNp̈ ̓͕K擪ɒuƁB
	//	̃`FbN͉ʃo[W̏ݒǂݍޕKvLƂɂp̂łB
	//-----------------------
	ABuint32	version;	//	vewrsion (MB_VERASION_*)
	ABsize		size;		//	ABGamePreference size

	//-----------------------
	//	epX
	//	Save data
	//-----------------------
	ABint8	pathData[AB_BMS_CHAR_LENGTH_FILEPATH];			//	path : BMS music data dir, BMS database dir, etc
	ABint8	pathBMSmusic[AB_BMS_CHAR_LENGTH_FILEPATH];		//	path : BMS music data dir
	ABint8	pathBMSdatabase[AB_BMS_CHAR_LENGTH_FILEPATH];	//	path : BMS database dir
	ABint8	pathScheme[AB_BMS_CHAR_LENGTH_FILEPATH];		//	path : Scheme dir

	//-----------------------
	//	vC[
	//	Save data
	//-----------------------
	typedef struct{
		ABfloat32		playScore;						//	hi-score
		ABint8			name[ AB_PLAY_NAME_LENGTH ];	//	player name
		
	} Score;
	Score		plauerScore[ AB_PLAY_SCORE_ARRAY_COUNT ];
	
	//-----------------------
	//	config(RtBOʂŐݒ\Ȃ)
	//	Save data
	//-----------------------
	typedef struct{
		ABuint		masterVolume;			//	ɂp[Ze[Ww( 0 - 100 )
		ABbool		trueIsUseSoundReverb;
		ABbool		trueIsUseIgnorePoor;
		ABbool		trueIsUseCombo;
		ABfloat32	hiSpeedRate;			//	nCXs[h{
		ABbool		trueIsUseAll7keyMode;	//	SV@[[h
		ABbool		trueIsUseCenterLayout;	//	CENTERvCCAEggp
		ABautoPlayType	autoPlayMode[AB_PLAY_PLAYER_COUNT];
		
		ABscreenMode	screenMode;										//	XN[TCY[h
		ABint8			schemeFolder[AB_BMS_CHAR_LENGTH_FILEPATH];		//	path : Scheme folder
		ABuint			schemeNumber;									//	SCHEME set number

		ABsoundSampleRate	soundSampleRate;	//	I[fBIiBftHg44.1KHzB
		ABint				soundChannelMode;	//	Channel\BXeIQCmP
		ABdrawFrameRate		drawFrameRate;		//	`t[B݂͕b60ƂA1-60͈̔͂Ŏw肷邱ƁB
		
		ABint32			cacheSize;			//	cacheSize
		
		ABint8			reserve[ 1020 ];//	\
		
		void	clean( void ){
			//	ȉ̒llƂėp܂
			masterVolume			= 100;
			trueIsUseSoundReverb	= true;
			trueIsUseIgnorePoor		= true;
			trueIsUseCombo			= true;
			hiSpeedRate				= 1.0f;			//	nCXs[h{
			trueIsUseAll7keyMode	= false;
			trueIsUseCenterLayout	= false;
			screenMode = AB_SCREEN_SIZE_MODE_640_480;

			snprintf( schemeFolder, sizeof(schemeFolder), "%s", AB_CONFIG_DEFAULT_SCHEME_FOLDER );

			soundSampleRate		= AB__SOUND_SAMPLE_RATE_44100;
			soundChannelMode	= GAS_SAMPLE_CHANNEL_STEREO;
			drawFrameRate		= AB__DRAW_FRAME_RATE_60;
			cacheSize			= AB_SOUND_FILE_CACHE_SIZE_DEFAULT;	//	GE_AUDIO_CACHE_FILE_SIZE̔{ɂ邱

			schemeNumber = 0;
			ABint	i;
			for( i = 0; i < AB_PLAY_PLAYER_COUNT ; i++ ){
				autoPlayMode[i] = AB_AUTO_PLAY_TYPE_NONE;
			}
		}

	} Config;
	Config		playConfig;

	//-----------------------
	//	config
	//	Innner data ( ̓Q[NɏAۑe͖܂)
	//-----------------------
	ABgameModeType		gameMode;
	ABgameLevelType		gameLevel;
	ABbool				trueIsUseStageNumber;
	ABstageNumber		stageNumber;
	
	ABint				selectSchemeNumber;	//	playConfig::schemeFolder[]ԍɕϊċL܂B
	ABMBSchemeSetPtr	selectSchemePtr;	//	I𒆂Scheme
	
	//-----------------------
	//-----------------------
	ABint8			reserve[ 1024 ];//	\

	//-----------------------
	//	clean
	//-----------------------
	void	clean( void ){
		int	i;
		
		version			= AB_VERASION_COMPILE;
		size			= sizeof( ABGamePreference );

		pathData[0]			= 0;
		pathBMSmusic[0]		= 0;
		pathBMSdatabase[0]	= 0;
		pathScheme[0]		= 0;

		playConfig.clean();
		for( i = 0; i < AB_PLAY_SCORE_ARRAY_COUNT ; i++ ){
			plauerScore[i].playScore	= 0;
			plauerScore[i].name[0]	= 0;
		}
		
		gameLevel 		= AB_GAME_LEVEL_NOMAL;
		gameMode		= AB_GAME_MODE_FREEPLAY;
		trueIsUseStageNumber = false;
		stageNumber		= 0;
		selectSchemeNumber = 0;
		selectSchemePtr = NULL;
	}

}	ABGamePreference;

#ifdef	OS_COMPILE_MAC_OS_X
#pragma options align=reset	//	\̃TCYɖ߂Ă
#endif	OS_COMPILE_MAC_OS_X



//-------------------------------------------------------------------------------
//	vCX^C
//		vCX^CConfiguration̈ꕔ㏑AȒPʂɎw肷邱Ƃ̂łݒB
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//	ݒ֘Ȁ
//-------------------------------------------------------------------------------
class	AquanBeatsPreference{
public:
	//	ݒ̓ǂݍ
	static ABbool	loadPreference( ABGamePreference*  ioPreference ) ;
	//	ݒ̕ۑ
	static ABbool	savePreference( const ABGamePreference*  inPreference ) ;
	
	//	ݒ̔f
	//	EȂ̂ŁAɊ܂߂ĉ
	//	EinPreferenceύXOŁAinFuturePreferenceύXłBrĐVȂĂ̂XVĂB
	static ABbool	updatePreference( const ABGamePreference*  inPreference, ABGamePreference*  ioFuturePreference ) ;
	
	//	WCXeBbNݒ̓ǂݍ
	static ABbool	loadJoystickConfig( void ) ;
	//	ݒ̕ۑ
	static ABbool	saveJoystickConfig( void ) ;

private:
	//	not using method (static onle class)
	AquanBeatsPreference();
	~AquanBeatsPreference();
};


#endif	//AquanBeatsPreference_h