/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItem.h

	Encoding:	Shift-JIS

				VisualArchitecture item
				摜Ȃǂ̃ACe̍We`邽߂̃NXB
				hĕKvȃACe\zB

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABVAItem_h
#define	ABVAItem_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<stdio.h>
#include	<iostream>

#include	"GlobalConfig.h"
#include	"ABVAItemObject.h"
#include	"ABVAItemDynamicBinder.h"

#include	"ABVAResource.h"
#include	"ABVARunner.h"

//	L[̍ő吔
enum{	
	ABVA_KEY_ID_MAX = 8,				
};


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItem
{
private:
	ABVARunner*  			m_runner;
	ABVAItemDynamicBinder*	m_dynamicBinder;
	
public:
	//-----------------------------------------------
	//	ACȅ
	//-----------------------------------------------

	ABuint			mKeyID[ ABVA_KEY_ID_MAX ];		//	SchemeQƗpL[BMacBeatSchemeƐVSchemeƂł́Agp@قȂB
	ABuint32		mItemID;						//	ACeʂ邽߂ID( zCfbNXƂĎgp̂ŁA0̘AlɂȂ悤`ĂB)
	ABbool			mStab;							//	true = Instance쐬邪Aۂ̃XvCgȂǂ͍쐬ȂACe



	//-----------------------------------------------
	//	InstanceɊւ
	//-----------------------------------------------

	ABuint		mCreateCount;		//	Instancě

	typedef	struct	attribute{
		//ABbool	flagAutoReSize;			//	ACẽTCYAXN[TCYɍ킹Ċgk( p~ )
		ABbool	flagSpriteSizeAuto;			//	TCYiACẽTCYA摜TCYɃtBbgj
		ABbool	flagSpriteLocationAuto;		//	zu
		ABbool	flagSpriteLocationCenterX;	//	CENTERzu
		ABbool	flagSpriteLocationCenterY;	//	CENTERzu
		ABbool	flagSpriteLocationMirrorX;	//	ʔzuiREVERSE͔]ƂӖۂHl(-)ɂȂ肻Ȃ̂Ŕj
		ABbool	flagSpriteLocationMirrorY;	//	ʔzuiREVERSE͔]ƂӖۂHl(-)ɂȂ肻Ȃ̂Ŕj
		ABbool	flagSpriteVisible;			//	\E\
		ABbool	flagSpriteAnimationRevers;	//	ANIMATIONɂċtĐw肷

		ABbool	flagOptional;				//	ėptO (#*̑tB[htrue/false킷̎w)
		ABbool	trueIsRequireBMPsize;		//	MacBeatNowLoading(SCH_LoadBMS)擾̂߂̃tOij
											//	trueɂƁAsizenonêƂłautoƌȂB
	}	attribute;
	attribute	flag;
		

public:
	//-----------------------------------------------
	//	Constructor
	//-----------------------------------------------
	ABVAItem( void )
	{
		m_runner = NULL;
	
		mStab = false;

		memset( mKeyID, -1, sizeof(mKeyID) );
		mItemID		= 0;
		
		mCreateCount	= 1;

		//flagAutoReSize		= false;
		flag.flagSpriteSizeAuto				= false;
		flag.flagSpriteLocationAuto			= false;
		flag.flagSpriteLocationCenterX		= false;
		flag.flagSpriteLocationCenterY		= false;
		flag.flagSpriteLocationMirrorX		= false;
		flag.flagSpriteLocationMirrorY		= false;
		flag.flagSpriteVisible				= true;
		flag.flagSpriteAnimationRevers		= false;
		
		flag.flagOptional 				= false;
		flag.trueIsRequireBMPsize		= false;

		m_dynamicBinder = NULL;
	}

	//-----------------------------------------------
	//	Destructor
	//-----------------------------------------------
	virtual	~ABVAItem( void ){
		this->destroy();
		
		if( this->m_dynamicBinder ){
			delete	this->m_dynamicBinder;
		}
	}
	
	//-----------------------------------------------
	//	Create instance
	//		hNXŒ`Ă
	//-----------------------------------------------
	virtual	ABVAItemObject*	createInstance( void ) throw( std::bad_alloc )
	{
		return	new 	ABVAItemObject;
	};

	//-----------------------------------------------
	//	Release instance
	//-----------------------------------------------
	virtual	void releaseInstance( const ABVAItemObject*  inObject )
	{
		delete inObject;
	};

	//-----------------------------------------------
	//	dynamic bind render
	//	Edynamic bindergpĂACéAQ[[v炱̊֐Ăт܂B
	//	Edynamic binderׂACéApĂBsvȏꍇ͌pȂOKłB
	//-----------------------------------------------
	virtual	void	dynamicBindRender( ABVAItemDynamicBinder*  inBinder ){
	}

	//-----------------------------------------------
	//	render
	//	EQ[[v炱̊֐Ăт܂B
	//	EACeȕ`揈sꍇ͌pĂBsvȏꍇ͌pȂOKłB
	//-----------------------------------------------
	virtual	void	render( ABint  inBMSLocation ){
	}

	//-----------------------------------------------
	//	set Dynamic binding Constructor
	//		DestructorŎI delete ܂
	//-----------------------------------------------
	void	setDynamicBinder( ABVAItemDynamicBinder*  inBinder )
	{
		m_dynamicBinder = inBinder;
	}

	//-----------------------------------------------
	//	Ŏgp郁o[
	//-----------------------------------------------

	//	Create Instance
	ABbool			create( ABVARunner*  inRunner ){

		ABbool	ret = true;

		this->m_runner = inRunner;
		
		if(this->m_dynamicBinder ){
			ret = this->m_dynamicBinder->initialize();
			if( ! ret ){
				return ret;
			}
		}
		
		for( ABint i = 0 ; i < this->mCreateCount ; i++ ){
			ABVAItemObject*			instance = NULL;
			
			try{
				instance =  this->createInstance();
			}
			catch(...){
				ret = false;
				break;
			}
			
			this->m_array.push_back( instance );
			
			instance->setArchitecture( this->m_array.size() - 1, inRunner, this );
			if( ! instance->setup() ){ 
				ret = false;
				break;
			};
		}
		
		return ret;
	};

	//	Destroy Instance
	void 	destroy( void ){
		while( ! this->m_array.empty() ){
			ABVAItemObject*			item = this->m_array.back();
			item->cleanup();
			this->releaseInstance( item );
			this->m_array.pop_back();
		}

		if(this->m_dynamicBinder ){
			this->m_dynamicBinder->finalize();
		}
		
	};

	//	Get instance array
	ABVAItemObjectArray*	getInstances( void ){
		return	&this->m_array;
	}
	
	//	Get first instance
	ABVAItemObject*			getFisrstInstance( void ){
		return	this->m_array.front();
	}
	
	//	resource擾
	ABVAResource&	getResource( void ){
		return	this->m_runner->getResource();
	}

	void	callRender( ABint  inBMSLocation ){
		if( this->m_dynamicBinder ){
			//	callDynamicBindRender
			this->dynamicBindRender( this->m_dynamicBinder );
		}
		//	Render call
		this->render( inBMSLocation );
	}

private:
	ABVAItemObjectArray		m_array;

};

//	Instanceresource擾
template< class O, class T >
void	ABVAGetResource( O*  inObject, T**  outItem, ABVAResource**  outResouce ){
	*outItem = dynamic_cast<T*>(inObject->getArchitecture());
	*outResouce = &( (*outItem)->getResource() );
}

#endif	ABVAItem_h
