/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemAnimation.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABVAItemAnimation_h
#define	ABVAItemAnimation_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<stdio.h>
#include	<iostream>

#include	"GlobalConfig.h"
#include	"ABVAItemObject.h"
#include	"ABVAItemSprite.h"
#include	"ABVAItem.h"

class	ABVAItemAnimation;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemAnimationObject : public ABVAItemObject
{
public:

	//	MacBeat neonǃAj`
	//	ɂZ\ɂȂĂ̂Ŗʓ|
	enum{
		M_MACBEAT_NEON_1,
		M_MACBEAT_NEON_2,
		M_MACBEAT_NEON_3,
		M_MACBEAT_NEON_4,
		M_MACBEAT_NEON_5,

		M_MACBEAT_NEON_GRAY,	//<--͉ĂȂ̏ԁB

		M_MACBEAT_NEON_1_DARK,
		M_MACBEAT_NEON_2_DARK,
		M_MACBEAT_NEON_3_DARK,
		M_MACBEAT_NEON_4_DARK,
		M_MACBEAT_NEON_5_DARK,
		
		M_MACBEAT_NEON_DARK_REACH = M_MACBEAT_NEON_GRAY,	//	M_MACBEAT_NEON_* ƁAM_MACBEAT_NEON_*_DARK@Ƃ݂ɃpJpJ
	};

	ABVAItemSpriteObject*		mTargetSprite;		//	Aj[VΏۂ̃XvCg
													//	XvCg͐ɍ쐬ĂKvB
													//	ivZbgݒɂĐɃXvCgo^ĂȂ΂ȂȂj

	typedef	enum{
		M_STATE_STOP,				//	Aj[V~
		M_STATE_PLAY,				//	Aj[VĐ
		M_STATE_REVERSE,			//	Aj[VtĐ
	}	MPlayState;
	
	ABint		mFrameNumber;		//	݂̃Aj[Vt[ԍiO̘AԁBsurfacẽZԍƂėpj
									//	CountupAABVAItemSpriteAnimation::mFrameCountMaxɓBA0֖߂B
	ABint		mFrameTime;			//	݂̃t[̑҂ԁBOɂȂ玟̃Aj[Vt[ֈړB
	MPlayState	mPlayMode;			//	Aj[VĐԁB
	ABint		mFrameCounter;		//	1 or -1BmFrameNumbeȓlB
	ABint		mNextSyncLocation;	//	BPM̎́A̓^C~OP[Vl
	ABint		mAnimationCount;	//	ANIMATION
	ABbool		mDoBreakBeat;		//	trueSetrender֐R[ƂAu[NB

public:
	ABVAItemAnimationObject( void );
	virtual	~ABVAItemAnimationObject( void );

	//-----------------------------------------------
	//	setup
	//	EArchitectureɁAsB
	//-----------------------------------------------
	virtual	ABbool	setup( void );

	//-----------------------------------------------
	//	cleanup
	//	Esetup̌nB
	//-----------------------------------------------
	virtual	void	cleanup( void );

	//-----------------------------------------------
	//	Method
	//-----------------------------------------------
	
	//	ĐJn
	void	play( void );
	//	~
	void	stop( void );
	//	ĐH
	ABbool	isPlay( void );
	//	Aj[Vs
	void	animate( ABVAItemAnimation*  inAnimator,  ABint  inBMSLocation, ABbool  inDoBreakBeat );

	//	ANIMATION
	void	resetAnimationCount( void ){
		this->mAnimationCount = 0;
	}
	ABint	getAnimationCount( void ){
		return	this->mAnimationCount;
	}

	//	countdown
	void	countDown( ABVAItemAnimation*  inAnimator );

	//-----------------------------------------------
	//	Property
	//-----------------------------------------------
	
	//	Instancẽf[^ݒ肷
	//		EhNXinTypeŎʂAvoid*Œlݒ肷邱
	virtual	ABbool	setData( const ABVAItemObjData  inType, void*  outData );

	//	Instancẽf[^擾
	//		EhNXinTypeŎʂAvoid*ŒlԂ
	virtual	ABbool	getData( const ABVAItemObjData  inType, void**  outData );

};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemAnimation
//
//		EAnimator݂ȖBAj[VXvCgɂ́AInstance^KvL܂B
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemAnimation : public ABVAItem
{
public:
	//-----------------------------------------------
	//	ACȅ
	//-----------------------------------------------

	typedef	enum{
		M_MODULE_NORMAL,			//	ʏAnimationjbg
		M_MODULE_NEON,				//	lIAnimationjbg
	}	MModule;
	
	typedef	enum{
		M_SYNC_NORMAL,				//	ʏiQ[[vJEgœj
		M_SYNC_BPM,					//	BPMɓ
	}	MSyncMode;
	
	typedef	enum{
		M_PLAY_ONESHOT,				//	P񃋁[vIAAj[V~
		M_PLAY_NEVER,				//	Aj[V
	}	MPlayMode;

	//	MacBeatł́Asurfacẻ摜CAEgc艡ƁA΂΂`ij
	typedef	enum{
		M_LAYOUT_HORIZON,			//	surfaceŁAɃZzuĂ
		M_LAYOUT_VERTICAL,			//	surfaceŁAcɃZzuĂ
		M_LAYOUT_NEON,				//	lIǔzuBɁuT{ÂT{v̌vPOZƂċ@\B
	}	MSurfaceLayoutType;
	
	//	Aj[V
	MModule		mModule;			//	AnimationW[̑IBʏAnimationȊO̓AnimationIB
	ABint		mFrameCountMax;		//	Aj[Vt[iR}j
	ABint		mFrameTimeMax;		//	1t[̑ҋ@Ԑ
									//	MSyncModeɂėp@͓ʂKvłB
									//		EM_SYNC_NORMAL
									//			Q[[vJEggpiPQ[[v1/60bPʎԂƂj
									//			iʏ͖Q[[vPʂŏ֐ĂԃnYȂ̂ŁA
									//			@PcountdownĂƂɂȂj
									//
									//		EM_SYNC_BPM
									//			݂̃P[Vl瓯^C~OZoB
									//			ꏬߕ̃P[VlŎQƂAmBPMSyncRate̎wlɍ킹B
	
	//	[h
	MSyncMode	mSyncMode;
	ABint		mBPMSyncRate;		//	BPM{
									//	ĺA\lŎw肷iP߁192̂ƂAS48j
									//	FmBPMSyncRate = 48 ȂSPʂœAj
									//	@@mBPMSyncRate = 24 ȂWPʂœcj

	//	u[Nr[g摜B̏ߋ؂^C~OŃL邽߂̐ݒ
	ABbool		mDoBreakBeat;			//	trueSetrender֐R[ƂAu[NB
	ABint		mBreakBeatCellNumber;	//	gpZԍBMSurfaceLayoutType̎wɈˑB
										//	-1̎́AmFrameCountMax ̎̉摜gpB


	//	
	MPlayMode			mPlayMode;				//	Aj[VĐ[h
	MSurfaceLayoutType	mSurfaceLayoutType;		//	surfaceł̃Z̕
	ABbool				mTrueIsReversePlay;		//	tĐ?
	ABbool				mTrueIsCellAnimation;	//	falsêƂ́A摜̕ύXsȂB

	//-----------------------------------------------
	//	InstanceɊւ
	//-----------------------------------------------
	ABVAItemSprite*		mTargetSprite;						//	Aj[VΏۂ̃XvCg
	
	void	setTargetSprite( ABVAItemSprite*  inSprite ){	//	Aj[VΏۂ̃XvCgw͂̊֐ĂԂƁB
		this->mTargetSprite = inSprite;
		this->mCreateCount = inSprite->mCreateCount;
	}

public:
	//-----------------------------------------------
	//	Constructor
	//-----------------------------------------------
	ABVAItemAnimation( void )
	{
		this->mModule			= M_MODULE_NORMAL;
		this->mFrameCountMax	= 0;
		this->mFrameTimeMax		= 0;

		this->mSyncMode			= M_SYNC_NORMAL;
		this->mBPMSyncRate		= 0;

		this->mDoBreakBeat = false;
		this->mBreakBeatCellNumber = 0;

		this->mPlayMode				= M_PLAY_NEVER;
		this->mSurfaceLayoutType	= M_LAYOUT_HORIZON;
		this->mTrueIsReversePlay	= false;

		this->mTrueIsCellAnimation = true;
		
		this->mTargetSprite = NULL;
	}

	//-----------------------------------------------
	//	Destructor
	//-----------------------------------------------
	virtual	~ABVAItemAnimation( void ){
	}
	
	//-----------------------------------------------
	//	Create instance
	//		hNXŎ̊֐`Ă
	//-----------------------------------------------
	ABVAItemAnimationObject*	createInstance( void ) throw( std::bad_alloc )
	{
		return	new 	ABVAItemAnimationObject;
	};
	
	//-----------------------------------------------
	//	render
	//	Aj[Vs܂B
	//	EQ[[v炱̊֐Ăт܂BLSĂInstanceAnimate܂B
	//-----------------------------------------------
	virtual	void	render( ABint  inBMSLocation ){
		ABVAItemObjectArray*	array = this->getInstances();
		ABVAItemObjectArrayIt	it;
		for( it = array->begin() ; it != array->end() ; it++ ){
			ABVAItemAnimationObject*	item = static_cast<ABVAItemAnimationObject*>(*it);
			item->animate( this, inBMSLocation, this->mDoBreakBeat );
		}
		//	u[Nr[g͈L
		this->mDoBreakBeat = false;
	}

	//-----------------------------------------------
	//	Eu[Nr[gsBAj[VInstanceSăL܂Bߋ؂̃^C~OŃR[ĂB
	//		@gpZԍBMSurfaceLayoutType̎wɈˑB
	//		@-1̎́AmFrameCountMax ̎̉摜gpB
	//		E̊֐ĂяôƁAAnimate֐Ă΂ď߂Čʂ܂
	//-----------------------------------------------
	void	breakbeatAnimation( void ){
		this->mDoBreakBeat = true;
	}
};


#endif	ABVAItemAnimation_h
