/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemResFont.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABVAItemResFont_h
#define	ABVAItemResFont_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<stdio.h>
#include	<iostream>

#include	"GlobalConfig.h"
#include	"GGText.h"
#include	"ABVAItemObject.h"
#include	"ABVAItem.h"
#include	"ABVAItemResImage.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemResFontObject : public ABVAItemObject
{
public:
	GGFont		mFont;
	
public:
	ABVAItemResFontObject( void );
	virtual	~ABVAItemResFontObject( void );

	//-----------------------------------------------
	//	setup
	//	EArchitectureɁAsB
	//-----------------------------------------------
	virtual	ABbool	setup( void );

	//-----------------------------------------------
	//	cleanup
	//	Esetup̌nB
	//-----------------------------------------------
	virtual	void	cleanup( void );

	//-----------------------------------------------
	//	Property
	//-----------------------------------------------
	
	//	Instancẽf[^ݒ肷
	//		EhNXinTypeŎʂAvoid*Œlݒ肷邱
	virtual	ABbool	setData( const ABVAItemObjData  inType, void*  outData );

	//	Instancẽf[^擾
	//		EhNXinTypeŎʂAvoid*ŒlԂ
	virtual	ABbool	getData( const ABVAItemObjData  inType, void**  outData );

};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemResFont
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemResFont : public ABVAItem
{
	//	font map table
	//	EASCIIR[hƑΉ镶̃rbg}bv摜A
	//	@Surfacêǂɂ̂߂̃e[uB
	//	EÝAAsciiCodeɊYB
	//	EĺASurfaceObhŕAObhԍŎwB
	//	EObhTCÝAmSubScemeKeỹTCYgpB
	//	EObhn_ʒúAmSubScemeKey̍WgpB

public:
	//-----------------------------------------------
	//	ACȅ
	//-----------------------------------------------

	//-----------------------------------------------
	//	InstanceɊւ
	//-----------------------------------------------

	typedef enum{
		M_FONTMAP_TABLE_SIZE = 256
	}	MFontMapTableSize;

	typedef struct{
		ABint	cellX;
		ABint	cellY;
		ABbool	enable;
	} MFont;
	MFont					mFontMapTable[ M_FONTMAP_TABLE_SIZE ];

	ABuint32				mCellLeft;			//	Z̈ʒu
	ABuint32				mCellTop;			//	Z̈ʒu
	ABuint32				mCellWidth;			//	Z̑傫
	ABuint32				mCellHeight;		//	Z̑傫

public:
	//-----------------------------------------------
	//	Constructor
	//-----------------------------------------------
	ABVAItemResFont( void )
	{
		memset( mFontMapTable, 0, sizeof(mFontMapTable) );
		mCellLeft = 0;
		mCellTop = 0;
		mCellWidth	= 0;
		mCellHeight	= 0;
	}

	//-----------------------------------------------
	//	Destructor
	//-----------------------------------------------
	virtual	~ABVAItemResFont( void ){
	}
	
	//-----------------------------------------------
	//	Create instance
	//		hNXŎ̊֐`Ă
	//-----------------------------------------------
	ABVAItemObject*	createInstance( void ) throw( std::bad_alloc )
	{
		return	new 	ABVAItemResFontObject;
	};

};


#endif	ABVAItemResFont_h
