/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemResImage.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABVAItemResImage.h"
#include	"ABVAResource.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemResImageObject
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABVAItemResImageObject::ABVAItemResImageObject( void )
{
	mSetup	= false;
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABVAItemResImageObject::~ABVAItemResImageObject( void )
{
}

//-------------------------------------------------------------------------------------------------
//	setup
//-------------------------------------------------------------------------------------------------
ABbool	ABVAItemResImageObject::setup( void )
{
	ABbool		ret;
	ABVAItemResImage*		item;
	ABVAResource*		resource;
	
	ABVAGetResource( this, &item, &resource );

	do{
		if( item->mStab ){
			//	Ȃ
			return true;
		}

		ret = this->mTexture.opneBitmap( &item->mFileInfo, 
											true, 
											item->mTransparentType,
											item->mWidth,
											item->mHeight );
		ABTestBreakReportError( ! ret, "mTexture.opneBitmap." );

		ret = this->mTexture.bindTexture();
		ABTestBreakReportError( ! ret, "mTexture.bindTexture." );

		this->mSetup = true;

	}while( false );
	return	ret;
};

//-------------------------------------------------------------------------------------------------
//	cleanup
//-------------------------------------------------------------------------------------------------
void	ABVAItemResImageObject::cleanup( void )
{
	ABVAItemResImage*		item;
	ABVAResource*		resource;
	
	ABVAGetResource( this, &item, &resource );

	if( ! this->mSetup ){
		//	Ȃ
		return;
	}
	this->mTexture.deleteTexture();
	this->mTexture.closeBitmap();
	this->mSetup = false;
}

//-------------------------------------------------------------------------------------------------
//	Instancẽf[^ݒ肷
//-------------------------------------------------------------------------------------------------
ABbool	ABVAItemResImageObject::setData( const ABVAItemObjData  inType, void*  outData )
{
	ABbool	ret = true;

	switch( inType ){
		default:
			ret =  false;
			break;
	}

	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	Instancẽf[^擾
//-------------------------------------------------------------------------------------------------
ABbool	ABVAItemResImageObject::getData( const ABVAItemObjData  inType, void**  outData )
{
	ABbool	ret = true;

	switch( inType ){
		default:
			ret =  false;
			break;
	}

	return	ret;
}
