/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemSprite.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"GameSingleton.h"
#include	"ABVAItemSprite.h"
#include	"ABVAItemResImage.h"
#include	"ABMBVAItemPreset.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemSpriteObject
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABVAItemSpriteObject::ABVAItemSpriteObject( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABVAItemSpriteObject::~ABVAItemSpriteObject( void )
{
}

//-------------------------------------------------------------------------------------------------
//	setup
//-------------------------------------------------------------------------------------------------
ABbool	ABVAItemSpriteObject::setup( void )
{
	ABbool					ret;
	ABVAItemSprite*			item;
	ABVAResource*			resource;
	ABVAItemResImageObject*		imageObject = NULL;

	ABVAGetResource( this, &item, &resource );
	
	this->mSprite.m_textureName = 0;
	
	this->mSprite.m_texCoord[0].set( 0.0f, 0.0f );
	this->mSprite.m_texCoord[1].set( 1.0f, 1.0f );
	
	this->mSprite.m_width	= item->mWidth;
	this->mSprite.m_height	= item->mHeight;

	this->mSprite.m_locate	= item->mLocation;
	this->mSprite.m_color	= item->mColor;
	
	if( item->mSurface ){
		imageObject = static_cast<ABVAItemResImageObject*>( item->mSurface->getFisrstInstance() );
		
		ABint	sw, sh;
		ABint	rw, rh;
		imageObject->mTexture.getTextureSize( &sw, &sh );

		//	摜̓ǂݍݎTCY
		imageObject->mTexture.getSize( &rw, &rh );

		ABuint	w, h;
		if( item->flag.flagSpriteSizeAuto || this->mSprite.m_width == 0 ){
			//	ZTCYI
			w = ( item->mCellWidth	== 0 ? rw : item->mCellWidth );
			h = ( item->mCellHeight == 0 ? rh : item->mCellHeight );

			//	TCÝAZTCYݒ
			this->mSprite.m_width	= w;
			this->mSprite.m_height	= h;
		}
		else{
			w = ( item->mCellWidth	== 0 ? this->mSprite.m_width : item->mCellWidth );
			h = ( item->mCellHeight == 0 ? this->mSprite.m_height : item->mCellHeight );
		}

		//	ZNumberAZTCYeNX`WvZ
		ABfloat32	x1 = (ABfloat32)( w * item->mCellNumber.x + item->mCellLeft );
		ABfloat32	y1 = (ABfloat32)( h * item->mCellNumber.y + item->mCellTop );
		ABfloat32	x2 = x1 + w;
		ABfloat32	y2 = y1 + h;
		
		this->mSprite.m_textureName		= imageObject->mTexture.getTextureName();
		this->mSprite.m_texCoord[0].x = x1 / (ABfloat32)sw;
		this->mSprite.m_texCoord[0].y = y1 / (ABfloat32)sh;
		this->mSprite.m_texCoord[1].x = x2 / (ABfloat32)sw;
		this->mSprite.m_texCoord[1].y = y2 / (ABfloat32)sh;
		
		if( this->mSprite.m_textureName == 12){
			int	i = this->mSprite.m_textureName;
		}
		
		this->mSurfaceWidth		= sw;
		this->mSurfaceHeight	= sh;
		this->mCellWidth = w;
		this->mCellHeight = h;
	}
	else{
		this->mSurfaceWidth = 0;
		this->mSurfaceHeight = 0;
		this->mCellWidth = this->mSprite.m_width;
		this->mCellHeight = this->mSprite.m_height;
	}
	
	if( 1000 < this->mCellWidth ){
		int i = 100;
		i = i - 1;
	}
	
	//	Q[XN[̃TCY擾Br[iEBhEtXN[j̃TCYƂ͕člĂB
	ABint	vw, vh;
	this->getRunner()->getGameScreenSize( &vw, &vh );
	
	//	W Z^Ozu
	if( item->flag.flagSpriteLocationCenterX ){
		this->mSprite.m_locate.x = (ABfloat32)(vw - this->mSprite.m_width) / 2.0f;
	}
	if( item->flag.flagSpriteLocationCenterY ){
		this->mSprite.m_locate.y = (ABfloat32)(vh - this->mSprite.m_height) / 2.0f;
	}
	//	W ~[OzuiIuWFNĝ͔̂]Ȃj
	if( item->flag.flagSpriteLocationMirrorX ){
		ABfloat32	center = (ABfloat32)(vw / 2);
		this->mSprite.m_locate.x = (ABfloat32)abs( this->mSprite.m_locate.x - center ) + center;
	}
	if( item->flag.flagSpriteLocationMirrorY ){
		ABfloat32	center = (ABfloat32)(vh / 2);
		this->mSprite.m_locate.y = (ABfloat32)abs( this->mSprite.m_locate.y - center ) + center;
	}

	if( item->mStab ){
		//	XvCg\Ȃ
		return true;
	}

	if( ! item->mVisible ){
		//	DefaultwD
		this->mSprite.m_visible = false;
	}
	else{
		//	XL[ŉB
		this->mSprite.m_visible = item->flag.flagSpriteVisible;
	}

	/*	
	//	NeonǁB̃ACe̓XL[̃oO𕂂ɂĂ鋾̂悤łEEEƂƂŃfobOR[hcĂ
	if( item->mItemID == ABVA_ITEM_ID_PLAY_SPRITE_NEON_P1 ){
		ABint	bugstop = 0;
		bugstop += 1;	//	CodeWorrior9̓fobOݒ肵čœKItɂĂœKĂ܂ijӖȃR[hȂƃuCNłȂł
	}
	if( item->mItemID == ABVA_ITEM_ID_PLAY_SPRITE_DANCE_1 ){
		ABint	bugstop = 0;
		bugstop += 1;	//	CodeWorrior9̓fobOݒ肵čœKItɂĂœKĂ܂ijӖȃR[hȂƃuCNłȂł
	}
	*/

	//	XvCg\
	ret = this->mSprite.setup( resource->mRenderGroup[ 0 ], true );
	if( ! ret ){
		return ret;
	}
	
	
	this->mAnimationObject = NULL;
	return	ret;
};

//-------------------------------------------------------------------------------------------------
//	cleanup
//-------------------------------------------------------------------------------------------------
void	ABVAItemSpriteObject::cleanup( void )
{
	this->mSprite.cleanup();
}

//-------------------------------------------------------------------------------------------------
//	Instancẽf[^ݒ肷
//-------------------------------------------------------------------------------------------------
ABbool	ABVAItemSpriteObject::setData( const ABVAItemObjData  inType, void*  outData )
{
	ABbool	ret = true;

	switch( inType ){
		default:
			ret =  false;
			break;
	}

	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	Instancẽf[^擾
//-------------------------------------------------------------------------------------------------
ABbool	ABVAItemSpriteObject::getData( const ABVAItemObjData  inType, void**  outData )
{
	ABbool	ret = true;

	switch( inType ){

		case ABVA_ITEM_OBJ_SPRITE:
			*outData = &this->mSprite;
			break;
		
		default:
			ret =  false;
			break;
	}

	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	Zԍ̕ύX
//-------------------------------------------------------------------------------------------------
void	ABVAItemSpriteObject::setCellNumber( const  ABint  inX, const ABint  inY )
{
	if( 0 <= inX ){
		ABfloat32	x1 = (ABfloat32)( this->mCellWidth * inX );
		ABfloat32	x2 = x1 + this->mCellWidth;
		this->mSprite.m_texCoord[0].x = x1 / (ABfloat32)this->mSurfaceWidth;
		this->mSprite.m_texCoord[1].x = x2 / (ABfloat32)this->mSurfaceWidth;
	}
	if( 0 <= inY ){
		ABfloat32	y1 = (ABfloat32)( this->mCellHeight * inY );
		ABfloat32	y2 = y1 + this->mCellHeight;
		this->mSprite.m_texCoord[0].y = y1 / (ABfloat32)this->mSurfaceHeight;
		this->mSprite.m_texCoord[1].y = y2 / (ABfloat32)this->mSurfaceHeight;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemTextSprite
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------------------------------------
//	dynamic bind render
//-------------------------------------------------------------------------------------------------
void	ABVAItemSprite::dynamicBindRender( ABVAItemDynamicBinder*  inBinder )
{
	if( inBinder->mBindData == NULL ){
		//	󂯕tȂ
		return ;
	}
	if( inBinder->mMode != ABVA_ITEM_DYNAMIC_BIND_TENSION_GAUGE &&
		inBinder->mMode != ABVA_ITEM_DYNAMIC_BIND_LOCATION_GAUGE ){
		//	󂯕tȂ
		return ;
	}
	
	ABVAItemObjectArray*		array = this->getInstances();

	switch( inBinder->mMode ){
		case ABVA_ITEM_DYNAMIC_BIND_TENSION_GAUGE:
			//	TensionGAUGEp̕`
			{
				ABVAItemDynamicBindTensionGaugeValue*	bindValue = static_cast<ABVAItemDynamicBindTensionGaugeValue*>(inBinder->mBindData);
				ABint	valueMax = *( static_cast<ABint*>(bindValue->mValuePointer) );
				ABint	value = valueMax;
				ABint	count = array->size();
				ABint	i;
				ABint	cellNumber = 0;

				//	Ȉ՗
				static ABint	randomer = 0 ;
				if( bindValue->mRandomizer ){
					//	_ŗh炷
					ABint	rnd1 = randomer;
					randomer = randomer * 5 + 7;
					ABint	rnd2 = randomer;
					randomer = randomer * 5 + 7;
					
					value -= abs(rnd1 % 5) - abs(rnd2 % 2);
				}

				//	ύX邾Ŋe[hւ̑Ή\B
				//	Em[}[h
				ABint	gain = ( bindValue->mUseGain ? bindValue->mGain : 0 );
	

				//	1P, 2P ̈ӎ͕svł
				for( i = 0 ; i < count; i ++ ){
					ABVAItemSpriteObject*	instance = static_cast<ABVAItemSpriteObject*>( (*array)[ i ] );
					if( (i < value) || (i == valueMax) ){
						if( i < gain ){
							//	green
							cellNumber = bindValue->mCellLightGreen;
						}
						else{
							//	red
							cellNumber = bindValue->mCellLightRed;
						}
					}
					else{
						//	dark
						if( i < gain ){
							//	green
							cellNumber = bindValue->mCellDarkGreen;
						}
						else{
							//	red
							cellNumber = bindValue->mCellDarkRed;
						}
					}
					instance->setCellNumber( cellNumber, 0 );
					instance->mSprite.update();
				}
			}
			break;
		case ABVA_ITEM_DYNAMIC_BIND_LOCATION_GAUGE:
			
			//	P[VGAUGEp̕`
			ABVAItemSpriteObject*	instance = static_cast<ABVAItemSpriteObject*>( (*array)[ 0 ] );

			instance->mSprite.m_width =  *( static_cast<ABint*>(inBinder->mBindData->mValuePointer) );
			instance->mSprite.update();
			
			break;

//::TODO::	for back light
/*
		case ABVA_ITEM_DYNAMIC_BIND_CONTROL_SPRITE_VISIBLE: 
			{
				ABVAItemDynamicBindValueInstance*	bindValue = static_cast<ABVAItemDynamicBindValueInstance*>(inBinder->mBindData);
				ABVAItemSpriteObject*	instance = static_cast<ABVAItemSpriteObject*>( (*array)[ bindValue->mInstanceNumber ] );
				instance->mSprite.m_visible =  *( static_cast<ABbool*>(inBinder->mBindData->mValuePointer) );
			}
			break;
			
		case ABVA_ITEM_DYNAMIC_BIND_CONTROL_START_SPRITE_ANIMATION:
			{
				ABVAItemDynamicBindValueInstance*	bindValue = static_cast<ABVAItemDynamicBindValueInstance*>(inBinder->mBindData);
				ABVAItemSpriteObject*	instance = static_cast<ABVAItemSpriteObject*>( (*array)[ bindValue->mInstanceNumber ] );
				if( instance->mAnimationObject ){
					ABbool	flag =  *( static_cast<ABbool*>(inBinder->mBindData->mValuePointer) );
					if( flag ){
						instance->mSprite.m_visible = true;
						instance->mAnimationObject.play()
					}
					else{
						if( ! instance->mAnimationObject.isPlay() ){
							instance->mSprite.m_visible = false;
						}
					}
				}
			}
			break;
*/			
	}

}
