/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemSprite.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABVAItemSprite_h
#define	ABVAItemSprite_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<stdio.h>
#include	<iostream>

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"ABVAItem.h"
#include	"ABVAItemObject.h"

#include	"GGSprite.h"

class	ABVAItemResImage;
class	ABVAItemAnimationObject;

//	f[^
//		ABVAItemObjData
enum{
	ABVA_ITEM_OBJ_SPRITE	= 'spSp',		//	GGSprite
};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemSpriteObject
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemSpriteObject : public ABVAItemObject
{
public:
	GGSprite					mSprite;
	
	ABuint32				mSurfaceWidth;
	ABuint32				mSurfaceHeight;
	ABuint32				mCellWidth;			//	Z̑傫
	ABuint32				mCellHeight;		//	Z̑傫

	ABVAItemAnimationObject*	mAnimationObject;		//	Animation
public:
	ABVAItemSpriteObject( void );
	virtual	~ABVAItemSpriteObject( void );

	//-----------------------------------------------
	//	setup
	//	EArchitectureɁAsB
	//-----------------------------------------------
	virtual	ABbool	setup( void );

	//-----------------------------------------------
	//	cleanup
	//	Esetup̌nB
	//-----------------------------------------------
	virtual	void	cleanup( void );

	//-----------------------------------------------
	//	Property
	//-----------------------------------------------
	
	//	Instancẽf[^ݒ肷
	//		EhNXinTypeŎʂAvoid*Œlݒ肷邱
	virtual	ABbool	setData( const ABVAItemObjData  inType, void*  outData );

	//	Instancẽf[^擾
	//		EhNXinTypeŎʂAvoid*ŒlԂ
	virtual	ABbool	getData( const ABVAItemObjData  inType, void**  outData );

	//-----------------------------------------------
	//	Tool
	//-----------------------------------------------
	//	Zԍ̕ύX
	void	setCellNumber( const  ABint  inX, const ABint  inY );
};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemSprite
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemSprite : public ABVAItem
{
public:
	//-----------------------------------------------
	//	ACȅ
	//-----------------------------------------------

	//-----------------------------------------------
	//	InstanceɊւ
	//-----------------------------------------------

	GGVector3f				mLocation;			//	W
	ABuint32				mWidth;				//	size
	ABuint32				mHeight;			//	size
	
	ABVAItemResImage*		mSurface;			//	摜
	ABuint32				mCellLeft;			//	Z̈ʒu
	ABuint32				mCellTop;			//	Z̈ʒu
	ABuint32				mCellWidth;			//	Z̑傫
	ABuint32				mCellHeight;		//	Z̑傫

	GGVector2f				mCellNumber;		//	Zԍ
	GGColor4f				mColor;				//	F
	
	ABbool					mVisible;			//	\E\
	
public:
	//-----------------------------------------------
	//	Constructor
	//-----------------------------------------------
	ABVAItemSprite( void )
	{
		mLocation.set( 0, 0, 0 );
		mWidth	= 32;
		mHeight	= 32;
		
		mSurface= NULL;
		mCellLeft = 0;
		mCellTop = 0;
		mCellWidth	= 0;
		mCellHeight	= 0;
		mCellNumber.set( 0, 0 );
		mColor.set( 255, 255, 255, 255 );
		
		mVisible = true;
	}

	//-----------------------------------------------
	//	Destructor
	//-----------------------------------------------
	virtual	~ABVAItemSprite( void ){
	}
	
	//-----------------------------------------------
	//	Create instance
	//		hNXŎ̊֐`Ă
	//-----------------------------------------------
	ABVAItemObject*	createInstance( void ) throw( std::bad_alloc )
	{
		return	new 	ABVAItemSpriteObject();
	};

	//-----------------------------------------------
	//	dynamic bind render
	//	Edynamic bindergpĂACéÅ֐Ăт܂B
	//-----------------------------------------------
	virtual	void	dynamicBindRender( ABVAItemDynamicBinder*  inBinder );

};


#endif	ABVAItemSprite_h
