/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVAItemTextSprite.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABVAItemTextSprite_h
#define	ABVAItemTextSprite_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<stdio.h>
#include	<iostream>
#include	<string>

#include	"GlobalConfig.h"
#include	"GameString.h"

#include	"GGText.h"

#include	"ABVAItemObject.h"
#include	"ABVAItemSprite.h"
#include	"ABVAItemResFont.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemTextSpriteObject : public ABVAItemObject
{
public:
	GGText*				mText;
	GGTextSprite*		mTextSprite;

public:
	ABVAItemTextSpriteObject( void );
	virtual	~ABVAItemTextSpriteObject( void );

	//-----------------------------------------------
	//	setup
	//	EArchitectureɁAsB
	//-----------------------------------------------
	virtual	ABbool	setup( void );

	//-----------------------------------------------
	//	cleanup
	//	Esetup̌nB
	//-----------------------------------------------
	virtual	void	cleanup( void );

	//-----------------------------------------------
	//	Property
	//-----------------------------------------------
	
	//	Instancẽf[^ݒ肷
	//		EhNXinTypeŎʂAvoid*Œlݒ肷邱
	virtual	ABbool	setData( const ABVAItemObjData  inType, void*  outData );

	//	Instancẽf[^擾
	//		EhNXinTypeŎʂAvoid*ŒlԂ
	virtual	ABbool	getData( const ABVAItemObjData  inType, void**  outData );

};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABVAItemTextSprite
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVAItemTextSprite : public ABVAItemSprite
{
public:

	//-----------------------------------------------
	//	ACȅ
	//-----------------------------------------------

	//-----------------------------------------------
	//	InstanceɊւ
	//-----------------------------------------------
	enum{
		M_FONT_TABLE_COUNT = 4,
	};

	//	text align
	GEtextAlignX		m_textAlignX;
	GEtextAlignY		m_textAlignY;

	//	Font info
	//	mFont = NULL̂ݗL
	ABfloat32			mFontSize;
	ABint8*				mFontName;
	ABbool				mUseBackColor;
	GGColor4f			mBackColor;		//	
	GameString			mText;	//	mUseFont = falsêƂݒ肵Ȃ΂ȂȂBNbV܂
	ABbool				mSoftReturn;	//	sH

	//	Font
	//	EmUseFont = false ̏ꍇ́AOS̕`@\𗘗pB
	//	EmUseFont =true ̂Ƃ́AXvCgz񉻂ĕ\B
	//		ÊƂAtext alignAFont info͖ƂȂB
	//		EmStringɕĂBmText͎gpł܂B
	ABbool				mUseFont;
	ABVAItemResFont*	mFont[ M_FONT_TABLE_COUNT ];
	ABint				mTextMaxLength;
	ABint				mFontTableType;
	ABint				mFontTableNumber;
	std::string			mString;	//	mUseFont = truêƂݒ肵Ȃ΂ȂȂBNbV܂
	
public:
	//-----------------------------------------------
	//	Constructor
	//-----------------------------------------------
	ABVAItemTextSprite( void )
	{
		m_textAlignX = GE_TEXT_ALIGN_LEFT;
		m_textAlignY = GE_TEXT_ALIGN_TOP;
		
		//	Font
		mFontName	= "Monaco";
		mFontSize	= 10.0f;
		
		mUseFont = false;
		mFontTableType = 0;
		mTextMaxLength = 0;
		mFontTableNumber = 0;
		mSoftReturn = true;
                mBackColor.set( 0, 0, 0, 255 );
		
		memset( mFont, 0, sizeof(mFont) );
	}

	//-----------------------------------------------
	//	Destructor
	//-----------------------------------------------
	virtual	~ABVAItemTextSprite( void ){
	}
	
	//-----------------------------------------------
	//	Create instance
	//		hNXŎ̊֐`Ă
	//-----------------------------------------------
	ABVAItemObject*	createInstance( void ) throw( std::bad_alloc )
	{
		return	new 	ABVAItemTextSpriteObject;
	};

	//-----------------------------------------------
	//	dynamic bind render
	//	Edynamic bindergpĂACéÅ֐Ăт܂B
	//-----------------------------------------------
	virtual	void	dynamicBindRender( ABVAItemDynamicBinder*  inBinder );

};


#endif	ABVAItemTextSprite_h
