/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABVARunner.h

	Encoding:	Shift-JIS

				Scheme\NX

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABVARunner_h
#define	ABVARunner_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<list>
#include	<vector>

#include	"GlobalConfig.h"

class	ABVAItem;
class	ABVAItemObject;
class	ABVAItemPreset;
class	ABVAItemBinder;
class	ABVAItemRender;

class	ABVAResource;

//	ACeXǧ
enum{
	ABVA_ITEM_LIST_MAX = 32,
};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	ABVAItemList
//
//////////////////////////////////////////////////////////////////////////////////////////////////
typedef	std::list< ABVAItem* >			ABVAItemList;
typedef	ABVAItemList::iterator			ABVAItemListIt;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	ABVAItemArray
//
//		ACeʂ邽߂̋tz
//
//////////////////////////////////////////////////////////////////////////////////////////////////
typedef	std::vector< ABVAItemListIt >			ABVAItemArray;
typedef	ABVAItemArray::iterator					ABVAItemArrayIt;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	ABVARunner
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVARunner
{
private:
	ABVAResource&	m_resource;
	ABint			m_bmsLocation;		//	BMSSequencer̃P[V
	
#ifdef	ABVA_RUNNER_CPP
public:
#else
private:
#endif	ABVA_RUNNER_CPP
	ABVAItemList		m_itemList[ABVA_ITEM_LIST_MAX];		//	ACeXg
	ABVAItemArray		m_itemArray[ABVA_ITEM_LIST_MAX];	//	ACetz
	ABVAItemBinder*		m_binderArray[ABVA_ITEM_LIST_MAX];	//	oC_[z
	ABVAItemRender*		m_renderer[ABVA_ITEM_LIST_MAX];		//	ACeRenderz
	ABVAItemList*		m_currentList;						//	ݗLȃXg
	ABVAItemArray*		m_currentItemArray;					//	ݗLȔz
	ABVAItemBinder*		m_currentBinder;
	ABVAItemRender*		m_currentRenderer;

	ABint				m_screenWidth;	//	VẢzXN[TCY
	ABint				m_screenHeight;	//	VẢzXN[TCY

public:
	ABVARunner( ABVAResource&  inResource );
	~ABVARunner( void );
	
	//	ACe쐬
	//		EScheme\zƂɈxĂт܂
	ABbool	createItems( ABVAItemPreset&  inPreset );
	
	//	ACep
	void	releaseItems( void );
	
	//	Instance쐬
	//		ESchemeۂInstance𐶐ƂɌĂт܂BiV[̐؂ւɌJԂĂяo܂Bj
	ABbool	createInstances( ABuint  inListNumber );
	
	//	insutancep
	void	releaseInstances( void );
	
	//	ACe擾
	//		Eԍ̓ACeʔԍn܂
	ABVAItem*		getItem( ABuint  inItemNumber );

	//	ACeLInstance擾
	//		Eԍ̓ACeʔԍn܂
	ABuint			getInstanceCount( ABuint  inItemNumber );

	//	ACe琶ꂽInstance擾
	//		EInstance鎞́AACe擾ăACeQƂ邱ƁB
	ABVAItemObject*	getInstance( ABuint  inItemNumber, ABuint  inInstanceNumber );
	
	//	resource擾
	ABVAResource&	getResource( void ){
		return	this->m_resource;
	}
	
	//	InstanceRender
	void	render( void );
	
	//	Jg̃oC_[擾
	ABVAItemBinder*	getCurrentBinder( void ){
		return	this->m_currentBinder;
	}
	//	Jg̃_[擾
	ABVAItemRender*	getCurrentRender( void ){
		return	this->m_currentRenderer;
	}
	
	//	Xg
	ABuint			getListSize( void ){
		return	ABVA_ITEM_LIST_MAX;
	}
	//	Xg擾
	ABVAItemList*	getList( ABuint  inIndex ){
		return	&this->m_itemList[ inIndex ];
	};
	
	//	BMSP[Vݒ
	void	setBMSLocation(  ABint  inLocation ){
		this->m_bmsLocation = inLocation ;
	}
	
	//	Q[XN[TCY
	//	r[TCYƂ͕ʕłBSchemeɂĎw肳A`Ԃ̉zIȃTCYłB
	void	setGameScreenSize( ABint  inWidth, ABint  inHeght, ABbool  inMinimamCancel = false );
	void	getGameScreenSize( ABint*  outWidth, ABint*  outHeght );
};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	ABVASchemeSetupper
//
//		1FsetList()ŃXgw肷B
//		2FaddData()ŃACelߍށB
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABVASchemeSetupper
{
private:
	ABVARunner&			m_ruuner;
	ABVAItemList*		m_currentList;
	ABVAItemArray*		m_currentItemArray;
	ABVAItemBinder**	m_binder;
	ABVAItemRender**	m_renderer;
	
public:
	ABVASchemeSetupper( ABVARunner&  inRunner ) : m_ruuner(inRunner) {
		m_currentList = NULL;
	};
	~ABVASchemeSetupper( void ){
	};
	
	//	Xgw
	ABbool	setList( ABuint  inListNumber );
	
	//	oC_[ݒ
	//		EsvɂȂ_ŎI delete ܂B
	ABbool	bind( ABVAItemBinder*  inBinder, ABVAItemRender*  inRenderer );
	
	//	ǉ
	//		Eǉ ABVAItem ́AsvɂȂ_ŎI delete ܂B
	//		EinItemNumbeŕAACeʂ邽߂ID( zCfbNXƂĎgp̂ŁA0̘AlɂȂ悤`ĂB)
	//		@̔ԍ́AǉƓɁAACé@mItemID@o[ɂlݒ肵܂B
	ABVAItem*	addItem( ABVAItem*  inItem, ABint  inItemNumber = -1 ) throw( std::bad_alloc ) ;
	
	template< class T >
	T*	addData( T*  inItem, ABint  inItemNumber = -1 ){
		return	static_cast<T*>(this->addItem( inItem, inItemNumber ));
	}
};

#endif	ABVARunner_h
