/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBSchemeData.h

				AquaBeats Scheme data
				Scheme̒ԃf[^\B

				̃f[^̓t@CǂݎꂽA
				AdapterʂāAIVisualArchitectureɋB
				̂߁AQ[`́AڎQƂĂ͂ȂȂB

				AB̎ł́AScheme͑SVisualArchitecturegpB
				MacBeatSchemeSɖȂASchemegp邱ƂłB

				AVisualArchitectureɋf[^ύXi܂肱̃f[^\jƂŁA
				VSchemeւ̈ڍsɔƂ͌yłƍlĂB

				f[^́AVvȍ\̂ŕ\B
				NX鎖ŎȒPɂȂ悤Ɏv邪A
				ۂɂ̓[̈̊ǗnC++̗lXȐɂAԂĕGxB
				ɂ̓f[^𕪗鎖KvłB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABMBSchemeData_h
#define	ABMBSchemeData_h

#include	<vector>

#include	"OSconfig.h"
#include	"GameEngine.h"
#include	"GameFile.h"

#include	"AquanBeatsConfig.h"
#include	"MacBeatSchemeConfig.h"

//------------------------------------------------------------------------------
//	TYPE
//------------------------------------------------------------------------------

//-----------------------------------------
//	XL[Zbgԍ
//-----------------------------------------
enum{
	AB_BMS_SCHEME_SET_MODE_5KEY					= SCMode_5Keys,
	AB_BMS_SCHEME_SET_MODE_5KEY_CENTER			= SCMode_5Keys_CenterPlay,
	AB_BMS_SCHEME_SET_MODE_7KEY					= SCMode_7Keys,
	AB_BMS_SCHEME_SET_MODE_7KEY_CENTER			= SCMode_7Keys_CenterPlay,

	AB_BMS_SCHEME_SET_MODE_COUNT				= SCMode_end,		
};
typedef	ABMBSchemeMode		ABBMSSchemeSetMode;

//-----------------------------------------
//-----------------------------------------
typedef struct
{
	char				name[64];
	GameFileInfo		file;
	bool				isSet;
	
	void	clear( void ){
		memset( &name[0], 0, sizeof(name) );
		isSet = false;
	}
} ABMBSchemeResource;

//-----------------------------------------
//-----------------------------------------
typedef struct ABMBSchemeElement{
	ABMBSchemeWord	sxFlag;
	int				sx;

	ABMBSchemeWord	syFlag;
	int				sy;

	ABMBSchemeWord	pxFlag;
	int				px;

	ABMBSchemeWord	pyFlag;
	int				py;

	ABMBSchemeWord	resize;

	ABMBSchemeElement(){
		clean();
	}
	void	clean( void ){
		sxFlag	= AB_SCHEME_WORD_VALUE;
		sx		= 0;
		syFlag	= AB_SCHEME_WORD_VALUE;
		sy		= 0;
		pxFlag	= AB_SCHEME_WORD_VALUE_HIDE;
		px		= 0;
		pyFlag	= AB_SCHEME_WORD_VALUE_HIDE;
		py		= 0;
		resize	= AB_SCHEME_WORD_VALUE_TRUE;
	}

} ABMBSchemeElement, *ABMBSchemeElementPtr;

//-----------------------------------------
//-----------------------------------------
typedef struct ABMBSchemeModeSet{
	int						resNum[ResPict_end];
	ABMBSchemeElement		elem[SCHKey_end];

	ABMBSchemeModeSet(){
		clean();
	}
	void	clean( void ){
		memset( resNum, 0, sizeof(resNum) );
		for( int i = 0 ; i < SCHKey_end ; i ++ ){
			elem[i].clean();
		}
	}

} ABMBSchemeModeSet;

//-----------------------------------------
//-----------------------------------------
//::TODO::o[WƂ̕𒴂eLXgǂݍނƃNbVJ
#define	AB_SCEMESET_TEXT_LENGTH_NAME	256
#define	AB_SCEMESET_TEXT_LENGTH_VERSION	32
#define	AB_SCEMESET_TEXT_LENGTH_CREATER	64
#define	AB_SCEMESET_TEXT_LENGTH_DATE	32
#define	AB_SCEMESET_TEXT_LENGTH_COMMENT	256
#define	AB_SCEMESET_TEXT_LENGTH_THEME	64
#define	AB_SCEMESET_TEXT_LENGTH_BASE	256

//-----------------------------------------
//	scheme
//-----------------------------------------
typedef struct
{
	char	name[AB_SCEMESET_TEXT_LENGTH_NAME];
	char	version[AB_SCEMESET_TEXT_LENGTH_VERSION];
	char	creator[AB_SCEMESET_TEXT_LENGTH_CREATER];
	char	date[AB_SCEMESET_TEXT_LENGTH_DATE];
	char	comment[AB_SCEMESET_TEXT_LENGTH_COMMENT];
	char	theme[AB_SCEMESET_TEXT_LENGTH_THEME];
	char	base[AB_SCEMESET_TEXT_LENGTH_BASE];

	int		setCount;

} ABMBSchemeSetInfo, *ABMBSchemeSetInfoPtr;

//-----------------------------------------
//	ABVAItem::mKeyID[]̃CfbNX̎g
//-----------------------------------------
enum{
	ABMB_ADAPTER_ITEM_SCHEME_KEY		= 0,	//	schemeL[(摜̔zuʒuEzuTCY)
	ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY	= 1,	//	sub schemeL[i摜̑傫A摜WȂǁj
	ABMB_ADAPTER_ITEM_RES_NUMBER		= 2,	//	Resourceԍ
	ABMB_ADAPTER_ITEM_OPTION_SCHEME_KEY	= 3,	//	ꕔ̃IuWFNg̓IvVwɂēύX܂B
	
	ABMB_ADAPTER_ITEM_ANIMATION_KEY		= 4,	//	Aj[V
};

//-----------------------------------------
//	schemef[^
//-----------------------------------------
typedef struct
{
	ABMBSchemeSetInfo		scemeInfo;										//	XL[
	char					ResDirName[256];								//	ResourceDirectory
	RGBColor				bgColor;
	int						screenSizeWidth;
	int						screenSizeHeight;
	ABMBSchemeModeSet		schemeModeSet[SCMode_end];
	std::vector<ABMBSchemeResource>	resourceArray;
	

	//	clean
	void	clean( void ){
		memset( &scemeInfo, 0, sizeof(scemeInfo) );
		memset( &ResDirName[0], 0, sizeof(ResDirName) );
		memset( &bgColor, 0, sizeof(bgColor) );
		screenSizeWidth = 640;
		screenSizeHeight = 480;
		for( int i = 0 ; i < SCMode_end; i++ ){
			schemeModeSet[i].clean();
		}
		resourceArray.clear();
		resourceArray.reserve(512);	//	KȐ
	}

	
	//	getResource
	ABMBSchemeResource*	getResource( ABMBSchemeMode  inMode, ResPictKey  inKey ){
		int	num = schemeModeSet[ inMode ].resNum[inKey];
		if( 0 <= num && num < resourceArray.size() ){
			return	&( resourceArray[num] );
		}
		else{
			return	NULL;
		}
	}
	
	//	setElement
	void	setElement( ABMBSchemeMode  inMode, ABMBSchemeDataKey  inKey, ABMBSchemeElement*  inElement ){
		if( inKey < 0 ){
			return;
		}
		schemeModeSet[ inMode ].elem[inKey] = *inElement;
	}
	
	//	getElement
	ABMBSchemeElement*	getElement( ABMBSchemeMode  inMode, ABMBSchemeDataKey  inKey ){
		if( inKey < 0 ){
			return NULL;
		}
		return	&( schemeModeSet[ inMode ].elem[inKey] );
	}

} ABMBSchemeSet, *ABMBSchemeSetPtr;

typedef	std::vector<ABMBSchemeSet>		ABMBSchemeSetArray;
typedef	std::vector<GameFileInfo>		ABMBResourceFileIDArray;


#endif	//	ABMBSchemeData_h
