/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBSchemeParser.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	<iostream>
#include	"GlobalConfig.h"
#include	"ABMBSchemeParser.h"

#include	"GEMacFileInfo.h"

using namespace std;

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------
/*
*	Constructor
*/
//-------------------------------------------------------
ABMBSchemeParser::ABMBSchemeParser()
{
	//	keys
	ABMBSchemeRegistSetKey( &this->m_keySchemeSet[0] );
	ABMBSchemeRegistKey( &this->m_keyScheme[0] );
	ABMBSchemeRegistResPict( &this->m_keyResource[0] );
	this->m_schemeArray = NULL;
}
//-------------------------------------------------------
/*
*	Destructor
*/
//-------------------------------------------------------
ABMBSchemeParser::~ABMBSchemeParser()
{
}

//-------------------------------------------------------
//	read scheme
//-------------------------------------------------------
bool	ABMBSchemeParser::readScheme( GameFileInfo*  inFileInfo, ABMBSchemeSetArray*  inSchemeSetArray )
{
	bool			result = false;
	char*			textBuffer = NULL;
	unsigned int	bufSize;
	MVecTextArray	rowArray; 
	UInt8			filePath[ AB_BMS_CHAR_LENGTH_FILEPATH ];

	//	
	this->m_schemeArray = inSchemeSetArray;

	{
		FSRef			ref;
		ref = inFileInfo->getFSRef();
		result = GEMacFileTool::getPathFromFSRef( &ref, (ABuint8*)filePath, AB_BMS_CHAR_LENGTH_FILEPATH );
		ABTestReturnReportError( !result, "getPathFromFSRef." );
	}


	//	eLXgǂݍ
	result = GameTextParser::readFileToBuffer( (char*)filePath, &textBuffer, &bufSize );
	ABTestReturnReportError( !result, "readFileToBuffer." );
	
	do{
		//	t@C?
		ABTestBreakReportError( bufSize == 0 , "empty file." );
		
		//	eLXgobt@sPʂłԂ
		this->m_parserTool.sliceRows( textBuffer, bufSize, &rowArray );

		{	// debug print
			MVecTextArray::iterator		it = rowArray.begin();
			while( it != rowArray.end() ){
				//cout << *it << endl;
				it++;
			}
		}

		//	
		result = this->read_scheme( &rowArray );
		ABTestReturnReportError( !result, "read_scheme." );

		ABDebug( ABReport( "complete." ) );
		result = true;
	}while(false);
	
	//	eLXgobt@
	GameTextParser::releaseFileBuffer( textBuffer );

	return result;
}

/*//////////////////////////////////////////////////////////////////////////////
*	private
*///////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------
//	check version
//-------------------------------------------------------
bool	ABMBSchemeParser::checkVercion( char*  inTextBuffer )
{
	char	value[16];
	
	sscanf( inTextBuffer, "%*s%s", &value );
	return ! strcmp( value, AB_SCHEME_PERSER_VERSION );
}
//-------------------------------------------------------
//	read scheme
//-------------------------------------------------------
bool	ABMBSchemeParser::read_scheme( MVecTextArray*  rowArray )
{
	MVecTextArray::iterator		it;
	bool	result;

	char*		wordPtr = NULL;
	ABMBSchemeSet	schemeSetData;

	//	x`FbNe
	//	find version
	it = rowArray->begin();
	if( this->m_parserTool.findRow( rowArray, it, AB_SCHEME_KEY_VERSION ) ){
		if ( ! this->checkVercion( *it ) ){
			ABReportFormat( "Warning: This File isn't same version %s.", AB_SCHEME_PERSER_VERSION );
			//CNormalAlert( "\pWarning: This File isn't same version, ", NowVersion,
			//			"\p . Perhaps It isn't read correctly." );
		}
	}

	//	o
	//	find start key
	it = rowArray->begin();
	if( ! this->m_parserTool.findRow( rowArray, it, AB_SCHEME_KEY_START_MAC_BEAT ) ){
		ABReportError( "This file isn't scheme file." );
		//NormalAlertISp( "\pError: This file isn't scheme file.", "\p", "\p" );
		return	false;
	}
	++it;
	
	//	VScheme	
	
	//	o
	//	read data
	result = true;
	while ( it != rowArray->end() ){

		//	count Scheme
		if( AB_SCHEME_SET_COUNT < this->m_schemeArray->size() ){
			//	get over(errorɂȂ)
			break;
		}
		
		//	new Scheme
		if( this->m_schemeArray->empty() ){
			//	init
			schemeSetData.clean();
		}
		else{
			//	duplicate
			schemeSetData = this->m_schemeArray->back();
		}
	
		//	find	"%"
		while ( it != rowArray->end() ){
			wordPtr = this->m_parserTool.findCompareWord( *it, "%" );
			if( wordPtr != NULL ){
				//	get set name
				/*gĂȂ̂ŏEȂ*/
				break;
			}
			++it;
		}
		if( it == rowArray->end() ){
			//	set not found or complete
			break;
		}
		
		//	read scope
		if( ! this->read_scope( rowArray, it, 0, &schemeSetData, ABMBSchemeParser::read_schemeSet_scope ) ){
			//	error
			ABReportError( "read_scope." );
			result = false;
			break;
		}
		
		//	get scheme
		this->m_schemeArray->push_back( schemeSetData );
		
		//	find next scheme set
	}
	
	if( this->m_schemeArray->empty() ){
		ABReportError( "not found datas." );
		result = false;
	}
	
	//	DEBUG
	ABReport( "BEGIN DEBUG PRINT" );
	ABMBSchemeSetArray::iterator	sit;
	ABint	setNum = 0;
	for( sit = this->m_schemeArray->begin(); sit != this->m_schemeArray->end(); sit++ ){
		ABMBSchemeSet*		sd = &(*sit);
		printf( "  +SET [%d]\n", setNum ); setNum++;
		
		printf( "    +INFORMATION\n" );
		printf( "      +name    [%s]\n", sd->scemeInfo.name );
		printf( "      +version [%s]\n", sd->scemeInfo.version );
		printf( "      +creator [%s]\n", sd->scemeInfo.creator );
		printf( "      +date    [%s]\n", sd->scemeInfo.date );
		printf( "      +comment [%s]\n", sd->scemeInfo.comment );
		printf( "      +theme   [%s]\n", sd->scemeInfo.theme );
		printf( "      +base    [%s]\n", sd->scemeInfo.base );

		for( ABint	mode = 0; mode < SCMode_end; mode++ ){
			printf( "    +MODE [%d]\n", mode );
			for( ABint	resNum = 0; resNum < ResPict_end; resNum++ ){
				printf( "      +ABMBSchemeSet::schemeModeSet[%d]::resNum[%4d] int[%d]\n", mode, resNum, sd->schemeModeSet[mode].resNum[resNum] );
			}
			for( ABint	eleNum = 0; eleNum < SCHKey_end; eleNum++ ){
				printf( "      +ABMBSchemeSet::schemeModeSet[%4d]::elem[%-24s] sxFlag[%d], sx[%8d], syFlag[%d], sy[%8d], pxFlag[%d], px[%8d], pyFlag[%d], py[%8d], resize[%d]\n", 
									mode, this->m_keyScheme[eleNum], 
									sd->schemeModeSet[mode].elem[eleNum].sxFlag,
									sd->schemeModeSet[mode].elem[eleNum].sx,
									sd->schemeModeSet[mode].elem[eleNum].syFlag,
									sd->schemeModeSet[mode].elem[eleNum].sy,
									sd->schemeModeSet[mode].elem[eleNum].pxFlag,
									sd->schemeModeSet[mode].elem[eleNum].px,
									sd->schemeModeSet[mode].elem[eleNum].pyFlag,
									sd->schemeModeSet[mode].elem[eleNum].py,
									sd->schemeModeSet[mode].elem[eleNum].resize
									 );
			}
		}
	}
	ABReport( "END DEBUG PRINT" );

	return	result;
}

//-------------------------------------------------------
//	read scheme set scope
//-------------------------------------------------------
bool	ABMBSchemeParser::read_schemeSet_scope( 
		MVecTextArray*  rowArray, 
		MVecTextArray::iterator&  it, 
		ABMBSchemeSetKey	setKeyIDDummy,
		ABMBSchemeSet*  inScemeData, 
		ABMBSchemeParser*  inCaller )
{
	#define	DEBUG_FUNC_NAME		"ABMBSchemeParser::read_schemeSet_scope()"
	int		setKeyID;

	//	find key
	for( setKeyID = SCHSetKey_start; setKeyID < SCHSetKey_end; setKeyID++ ){
		if( inCaller->m_parserTool.testFindWord( it, inCaller->m_keySchemeSet[ setKeyID ], true ) ){
			//	find ley
			break;
		}
	}
	//	find ?
	if( SCHSetKey_end <= setKeyID ){
		//	not find
		return	true;
	}
	
	ABDebug( cout << DEBUG_FUNC_NAME << ":find():" << setKeyID << "," << inCaller->m_keySchemeSet[ setKeyID ] << endl; )

	//	read key data
	switch ( setKeyID ){
	
		case	SCHSet_Source_5Keys:
		case	SCHSet_Source_5Keys_CenterPlay:
		case	SCHSet_Source_7Keys:
		case	SCHSet_Source_7Keys_CenterPlay:
		case	SCHSet_Source_Common:
		case	SCHSet_Actual_5Keys:
		case	SCHSet_Actual_5Keys_CenterPlay:
		case	SCHSet_Actual_7Keys:
		case	SCHSet_Actual_7Keys_CenterPlay:
		case	SCHSet_Actual_Common:
			if( ! inCaller->read_scope( rowArray, it, setKeyID, inScemeData, ABMBSchemeParser::read_schemeSet_element ) ){
				//	error
				return	false;
			}
			break;
			
		case	SCHSet_Resource_5Keys:
		case	SCHSet_Resource_5Keys_CenterPlay:
		case	SCHSet_Resource_7Keys:
		case	SCHSet_Resource_7Keys_CenterPlay:
		case	SCHSet_Resource_Common:
			if( ! inCaller->read_scope( rowArray, it, setKeyID, inScemeData, ABMBSchemeParser::read_resource_scope ) ){
				//	error
				return	false;
			}
			break;

		case	SCHSet_Resolution:
			sscanf( *it, "%*s%d%d", &inScemeData->screenSizeWidth, &inScemeData->screenSizeHeight );
			break;
			
		case	SCHSet_Comment:
			sscanf( *it, "%*s%s", &inScemeData->scemeInfo.comment );
			break;
			
		case	SCHSet_BaseSchemeName:
			sscanf( *it, "%*s%s", &inScemeData->scemeInfo.base );
			break;

		case	SCHSet_CreatedDate:
			sscanf( *it, "%*s%s", &inScemeData->scemeInfo.date );
			break;
			
		case	SCHSet_CreatorName:
			sscanf( *it, "%*s%s", &inScemeData->scemeInfo.creator );
			break;
			
		case	SCHSet_ResourceFolderName:
			sscanf( *it, "%*s%s", &inScemeData->ResDirName );
			break;
			
		case	SCHSet_SchemeName:
			sscanf( *it, "%*s%s", &inScemeData->scemeInfo.name );
			break;
			
		case	SCHSet_SchemeTheme:
			sscanf( *it, "%*s%s", &inScemeData->scemeInfo.theme );
			break;
			
		case	SCHSet_Version:
			sscanf( *it, "%*s%s", &inScemeData->scemeInfo.version );
			break;
		case	SCHSet_BgColor:
			unsigned long	color;
			
			sscanf( *it, "%*s%6x", &color );
			
			inScemeData->bgColor.red	= ( color & 0x00ff0000 ) >> 16;
			inScemeData->bgColor.green	= ( color & 0x0000ff00 ) >> 8;
			inScemeData->bgColor.blue	= ( color & 0x000000ff );
			break;
	}

	return	true;
}

//-------------------------------------------------------
//	read scheme set element
//-------------------------------------------------------
bool	ABMBSchemeParser::read_schemeSet_element( 
	MVecTextArray*	rowArray, 
	MVecTextArray::iterator&  it, 
	ABMBSchemeSetKey	setKeyID,
	ABMBSchemeSet*	inScemeData, 
	ABMBSchemeParser*		inCaller )
{
	#undef	DEBUG_FUNC_NAME
	#define	DEBUG_FUNC_NAME		"ABMBSchemeParser::read_schemeSet_element()"
	static char			buffer[256];
	ABMBSchemeDataKey		keyID;

	char*				wordPtr = NULL;
	
	// reading rows
	do{		
		//	find "#..."
		for ( keyID =SCHKey_start; keyID < SCHKey_end; keyID++ ){
			wordPtr = inCaller->m_parserTool.findCompareWord( *it, inCaller->m_keyScheme[keyID], true );
			if( wordPtr != NULL ){
				break;
			}
		}
		
		//	find ?
		if( SCHKey_end <= keyID ){
			//	not found
			break;
		}

//		cout << DEBUG_FUNC_NAME << ":find():" << inCaller->m_keyScheme[ keyID ] << endl;	//	debug

		//	read
		ABDebug( ABReportFormat( "read_schemeSet_element():%-32s", inCaller->m_keyScheme[ keyID ] ));

		//	target
		switch ( setKeyID ){
			case SCHSet_Source_Common:
			case SCHSet_Actual_Common:
				{
					ABMBSchemeElement	element;

					//	ABMBSchemeElement AB_SCHEME_WORD_VALUE_HIDE Ŗ΂Ȃ܂BɂA`̃XL[ACe͉B܂B
					//	Â܂܂ł͕\ȂACeʂɔ܂i܁jMacBeatXL[̃̕p[łȁB
					//	́unonevdlɂ܂B
					//	nonecommon̓eRs[ȂĂ͂ȂȂ̂ŁAnonewACe͉l܂B
					//	Acommon̒lǂݍގɉȂ̂ł́A\ɂȂĂ܂܂B
					//	]āAlu0vɃNAȂĂ͂Ȃ܂B
					element.clean();
					element.pxFlag = AB_SCHEME_WORD_VALUE;
					element.pyFlag = AB_SCHEME_WORD_VALUE;
					inCaller->read_schemeSet_element_data( wordPtr, setKeyID, &element );
					inScemeData->setElement( SCMode_5Keys			, keyID, &element );
					inScemeData->setElement( SCMode_5Keys_CenterPlay, keyID, &element );
					inScemeData->setElement( SCMode_7Keys			, keyID, &element );
					inScemeData->setElement( SCMode_7Keys_CenterPlay, keyID, &element );
				}
				break;
				
			case SCHSet_Source_5Keys:
			case SCHSet_Actual_5Keys:
				inCaller->read_schemeSet_element_data( wordPtr, setKeyID, inScemeData->getElement( SCMode_5Keys, keyID ) );
				break;
				
			case SCHSet_Source_7Keys:
			case SCHSet_Actual_7Keys:
				inCaller->read_schemeSet_element_data( wordPtr, setKeyID, inScemeData->getElement( SCMode_7Keys, keyID ) );
				break;
				
			case SCHSet_Source_5Keys_CenterPlay:
			case SCHSet_Actual_5Keys_CenterPlay:
				inCaller->read_schemeSet_element_data( wordPtr, setKeyID, inScemeData->getElement( SCMode_5Keys_CenterPlay, keyID ) );
				break;
				
			case SCHSet_Source_7Keys_CenterPlay:
			case SCHSet_Actual_7Keys_CenterPlay:
				inCaller->read_schemeSet_element_data( wordPtr, setKeyID, inScemeData->getElement( SCMode_7Keys_CenterPlay, keyID ) );
				break;
		}

	}while ( false );
	return	true;
}
//-------------------------------------------------------
//	read scheme set element
//-------------------------------------------------------
bool	ABMBSchemeParser::read_schemeSet_element_data
( 
	char				*SrcTxt, 
	ABMBSchemeSetKey		inSetKeyID, 
	ABMBSchemeElement		*schemeElement
)
{
	const int	DATA_LENGTH = 32;
	char	data1[DATA_LENGTH] = { 0 };
	char	data2[DATA_LENGTH] = { 0 };
	char	data3[DATA_LENGTH] = { 0 };
	char	data4[DATA_LENGTH] = { 0 };
	char	data5[DATA_LENGTH] = { 0 };
	
	short	count = 0;

	switch ( inSetKeyID ){
		case	SCHSet_Source_5Keys:
		case	SCHSet_Source_7Keys:
		case	SCHSet_Source_Common:
			count = sscanf( SrcTxt,  "%*s%s%s%s%s", data1, data2, data3, data4 );
			this->getValue( data1, &schemeElement->sxFlag, &schemeElement->sx );
			this->getValue( data2, &schemeElement->syFlag, &schemeElement->sy  );
			this->getValue( data3, &schemeElement->pxFlag, &schemeElement->px );
			this->getValue( data4, &schemeElement->pyFlag, &schemeElement->py );
			break;

		case	SCHSet_Actual_5Keys:
		case	SCHSet_Actual_5Keys_CenterPlay:
		case	SCHSet_Actual_7Keys:
		case	SCHSet_Actual_7Keys_CenterPlay:
		case	SCHSet_Actual_Common:
			count = sscanf( SrcTxt,  "%*s%s%s%s%s%s", data1, data2, data3, data4, data5 );
			this->getValue( data1, &schemeElement->sxFlag, &schemeElement->sx );
			this->getValue( data2, &schemeElement->syFlag, &schemeElement->sy );
			this->getValue( data3, &schemeElement->pxFlag, &schemeElement->px );
			this->getValue( data4, &schemeElement->pyFlag, &schemeElement->py );
			this->getValue( data5, &schemeElement->resize, NULL );
			break;
	}
	
	ABDebug( printf( "%8s,%8s,%8s,%8s,%8s\n", data1, data2, data3, data4, data5 ) );
	
	return	true;
}

//-------------------------------------------------------
//	read scheme set element
//-------------------------------------------------------
bool	ABMBSchemeParser::read_resource_scope( 
	MVecTextArray*  rowArray, 
	MVecTextArray::iterator&  it, 
	ABMBSchemeSetKey	setKeyID,
	ABMBSchemeSet*  inScemeData, 
	ABMBSchemeParser*  inCaller 
)
{
	#undef	DEBUG_FUNC_NAME
	#define	DEBUG_FUNC_NAME		"ABMBSchemeParser::read_resource_scope()"
	static char		buffer[256];
	ABMBSchemeDataKey	KeyID;
	int				modeKey[ SCMode_end ];
	int				i;

	char*				wordPtr = NULL;
	ABMBSchemeModeSet*	schemeModeData = inScemeData->schemeModeSet;

	// reading rows
	do{		
	
		//	find "#..."
		for ( KeyID =ResPict_start; KeyID < ResPict_end; KeyID++ ){
			wordPtr = inCaller->m_parserTool.findCompareWord( *it, inCaller->m_keyResource[ KeyID ], true );
			if( wordPtr != NULL ){
				break;
			}
		}
		
		//	find ?
		if( ResPict_end <= KeyID ){
			//	not found
			break;
		}

		//cout << DEBUG_FUNC_NAME << ":find():" << inCaller->m_keyResource[ KeyID ] << endl;	//	debug

		//	target
		memset( modeKey, -1, sizeof(modeKey) );
		switch ( setKeyID ){
			case	SCHSet_Resource_Common:
				modeKey[SCMode_5Keys			] = SCMode_5Keys;
				modeKey[SCMode_5Keys_CenterPlay	] = SCMode_5Keys_CenterPlay;
				modeKey[SCMode_7Keys			] = SCMode_7Keys;
				modeKey[SCMode_7Keys_CenterPlay	] = SCMode_7Keys_CenterPlay;
				break;

			case	SCHSet_Resource_5Keys:
				modeKey[SCMode_5Keys			] = SCMode_5Keys;
				modeKey[SCMode_5Keys_CenterPlay	] = SCMode_5Keys_CenterPlay;
				break;

			case	SCHSet_Resource_7Keys:
				modeKey[SCMode_7Keys			] = SCMode_7Keys;
				modeKey[SCMode_7Keys_CenterPlay	] = SCMode_7Keys_CenterPlay;
				break;

			case	SCHSet_Resource_5Keys_CenterPlay:
				modeKey[SCMode_5Keys_CenterPlay	] = SCMode_5Keys_CenterPlay;
				break;

			case	SCHSet_Resource_7Keys_CenterPlay:
				modeKey[SCMode_7Keys_CenterPlay	] = SCMode_7Keys_CenterPlay;
				break;
			default:
				ABReportError( "UnKnown setKeyID." );
				break;
		}
		
		//	l@F
		//	E[hĂĂAt@C͈ӁidȂӖjłB
		//	@ŁA̔zgpB
		//	Eڂ͏ȃt@CXgB
		//	Eڂ͂ǂ̃t@CƑΉ̂A[hʃXgB
		
		//	read
//		ABDebug( cout << DEBUG_FUNC_NAME << "<read data>" << endl );

		ABMBSchemeResource	sr;
		sr.clear();
		if( ! inCaller->read_resource_data( wordPtr, setKeyID, sr.name )){
			//	read error
			ABReportError( "read_resource_data." );
			return	false;
		}
		inScemeData->resourceArray.push_back( sr );

		ABDebug( ABReportFormat( "read_resource_data():%-32s", inCaller->m_keyResource[ KeyID ] ));
		ABDebug( cout  << " = " << sr.name  << endl );	//	debug

		for( i = 0 ; i < SCMode_end; i++ ){
			if( SCMode_start <= modeKey[i] ){
				schemeModeData[ modeKey[i] ].resNum[KeyID] = inScemeData->resourceArray.size() - 1;
			}
			else{
				schemeModeData[ modeKey[i] ].resNum[KeyID] = -1;
			}
		}
	}while ( false );
	return true;
}
//-------------------------------------------------------
//	read scheme set element
//-------------------------------------------------------
bool	ABMBSchemeParser::read_resource_data
( 
	char				*SrcTxt, 
	ABMBSchemeSetKey		inSetKeyID, 
	char*				resourceName
)
{
	switch ( inSetKeyID )
	{
		case	SCHSet_Resource_Common:
		case	SCHSet_Resource_5Keys:
		case	SCHSet_Resource_5Keys_CenterPlay:
		case	SCHSet_Resource_7Keys:
		case	SCHSet_Resource_7Keys_CenterPlay:
			sscanf( SrcTxt, "%*s%64s", resourceName );
			if( 0 == strcmp( resourceName, AB_SCHEME_WORD_NONE ) ){
				resourceName[0] = 0;	//	ɂ
			}
			break;
	}
	return	true;
}

//-------------------------------------------------------
//	read scope data
//-------------------------------------------------------
bool	ABMBSchemeParser::read_scope( MVecTextArray*  rowArray, MVecTextArray::iterator&  it, ABMBSchemeSetKey  setKeyID, ABMBSchemeSet*  inScemeData, MFuncScopeReader  inFunc )
{
	#undef	DEBUG_FUNC_NAME
	#define	DEBUG_FUNC_NAME		"ABMBSchemeParser::read_scope()"
	bool	flag = false;

	//	find	"{"
	while ( it != rowArray->end() ){
		if ( this->m_parserTool.testFindWord( it, "{" ) )	{
			++it;
			break;
		}
		++it;
	}
	if( it == rowArray->end() ){
		//NormalAlertISp( "\pError: Define of scheme set isn't enclosed by \"{}\".", "\p", "\p" );
		return	false;
	}
		
	//	reading scope
	flag = false;
	while ( it != rowArray->end() ){		
		//	find scope end
		if ( this->m_parserTool.testFindWord( it, "}" ) )	{
			flag = true;
			break;
		}

		//	read data (callback)
		//cout << DEBUG_FUNC_NAME << ">find key." << *it << endl;
		if( ! inFunc( rowArray, it, setKeyID, inScemeData, this ) ){
			//	error
			ABReportError( "faital in call back." );
			flag = false;
			break;
		}
		++it;
	}
	if( ! flag ){
		//NormalAlertISp( "\pError: Define of scheme set isn't enclosed by \"{}\".", "\p", "\p" );
		return	false;
	}

	return	true;
}

//-------------------------------------------------------
//	->K؂Ȍ^
//-------------------------------------------------------
void	ABMBSchemeParser::getValue( char*  inString, ABMBSchemeWord*  outSchemeWord, int*  outValue )
{
	if( 0 == strcmp( inString, AB_SCHEME_WORD_NONE ) ){
		//	CommonȂǂ̂Ƃ͋LKv̂ŁA㏑Ă͂ȂB
		//	AB_SCHEME_WORD_VALUE_NONEĂĂ͂ȂB
		//*outSchemeWord = AB_SCHEME_WORD_VALUE_NONE;
		return;
	}

	if( outValue != NULL ){
		*outValue = 0;
	}

	if( 0 == strcmp( inString, AB_SCHEME_WORD_AUTO ) ){
		*outSchemeWord = AB_SCHEME_WORD_VALUE_AUTO;
	}
	else if( 0 == strcmp( inString, AB_SCHEME_WORD_CENTER ) ){
		*outSchemeWord = AB_SCHEME_WORD_VALUE_CENTER;
	}
	else if( 0 == strcmp( inString, AB_SCHEME_WORD_TRUE ) ){
		*outSchemeWord = AB_SCHEME_WORD_VALUE_TRUE;
	}
	else if( 0 == strcmp( inString, AB_SCHEME_WORD_FALSE ) ){
		*outSchemeWord = AB_SCHEME_WORD_VALUE_FALSE;
	}
	else if( 0 == strcmp( inString, AB_SCHEME_WORD_YES ) ){
		*outSchemeWord = AB_SCHEME_WORD_VALUE_YES;
	}
	else if( 0 == strcmp( inString, AB_SCHEME_WORD_NO ) ){
		*outSchemeWord = AB_SCHEME_WORD_VALUE_NO;
	}
	else if( -1 == atof(inString) ){
		*outSchemeWord = AB_SCHEME_WORD_VALUE_HIDE;
	}
	else{
		*outSchemeWord = AB_SCHEME_WORD_VALUE;
		if( outValue != NULL ){
			*outValue = atof(inString);
		}
	}
}
