/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBSchemeParser.h

				AquaBeats Scheme loader (Parser)

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABMBSchemeParser_h
#define	ABMBSchemeParser_h

#include	<vector>

#include	"OSconfig.h"
#include	"GameEngine.h"
#include	"GameFile.h"

#include	"ABMBSchemeData.h"
#include	"GameTextParser.h"


/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABMBSchemeParser
{
private:
	typedef	GameTextParser::MVecTextArray		MVecTextArray;		//	obt@̍s̐擪AhXi[z`

	typedef	bool (*MFuncScopeReader)(
										MVecTextArray* 				rowArray, 
										MVecTextArray::iterator&	it, 
										ABMBSchemeSetKey				setKeyID,
										ABMBSchemeSet*				inScemeData, 
										ABMBSchemeParser*				inCaller );

private:
	GameTextParser		m_parserTool;
	ABMBSchemeSetArray*	m_schemeArray;

	char*	m_keySchemeSet[ SCHSetKey_end ];
	char*	m_keyScheme[ SCHKey_end ];
	char*	m_keyResource[ ResPict_end ];

public:
	ABMBSchemeParser();
	~ABMBSchemeParser();

	//	read scheme
	bool	readScheme( GameFileInfo*  inFileInfo, ABMBSchemeSetArray*  inSchemeSetArray );

private:
	//	check version
	bool	checkVercion( char*  inTextBuffer );
	//	read scheme
	bool	read_scheme( MVecTextArray*  rowArray );

	//	read scheme set scope
	static bool	read_schemeSet_scope( 
		MVecTextArray*  rowArray, 
		MVecTextArray::iterator&  it, 
		ABMBSchemeSetKey	setKeyID,
		ABMBSchemeSet*  inScemeData, 
		ABMBSchemeParser*  inCaller );

	//	read scheme set element
	static bool	read_schemeSet_element( 
		MVecTextArray*  rowArray, 
		MVecTextArray::iterator&  it, 
		ABMBSchemeSetKey	setKeyIDDummy,
		ABMBSchemeSet*  inScemeData, 
		ABMBSchemeParser*  inCaller );
	//	read scheme set element data
	bool	read_schemeSet_element_data
	( 
		char				*SrcTxt, 
		ABMBSchemeSetKey		inSetKeyID, 
		ABMBSchemeElement		*schemeElement
	);

	//	read scheme set element
	static bool	read_resource_scope( 
		MVecTextArray*  rowArray, 
		MVecTextArray::iterator&  it, 
		ABMBSchemeSetKey	setKeyID,
		ABMBSchemeSet*  inScemeData, 
		ABMBSchemeParser*  inCaller );
	//	read scheme set element
	bool	read_resource_data
	( 
		char				*SrcTxt, 
		ABMBSchemeSetKey		inSetKeyID, 
		char*				resourceName
	);

	//	read scope data
	bool	read_scope( MVecTextArray*  rowArray, MVecTextArray::iterator&  it, ABMBSchemeSetKey  setKeyID, ABMBSchemeSet*  inScemeData, MFuncScopeReader  inFunc );

	//	->K؂Ȍ^
	void	getValue( char*  inString, ABMBSchemeWord*  outSchemeWord, int*  outValue );
};

#endif	//	ABMBSchemeParser_h
