/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemPreset.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	<string>

#include	"GameSingleton.h"

#include	"ABMBVAItemPreset.h"
#include	"ABVAItemConfig.h"
#include	"ABVAItemBinderConfig.h"
#include	"ABMBVAItemRenderConfig.h"

#include	"ABMBSchemeData.h"

using namespace	std;

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemPreset::ABMBVAItemPreset( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemPreset::~ABMBVAItemPreset( void )
{
}

//-------------------------------------------------------------------
//	ZbgAbv
//-------------------------------------------------------------------
void	ABMBVAItemPreset::setup( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc )
{
	//	PFSceneԍw
	//	QFoC_[NXA_[NXoChBisKvȏꍇ͂ȂĂ\ȂBj
	//	RFACeo^
	//
	//	[mۂɎsƂ̓X[鎖Bbad_alloĉݎ󂯕t̂ŒӁB
	//	̊֐SchemeɈxĂт܂B
	//	@xxȂĂǂ̂ŁAǂ݂₷d鎖߂܂B

	//	V[@AB_SCENE_SPLASH@̃ZbgAbv
	inSetupper.setList( AB_SCENE_SPLASH );
	inSetupper.bind( new ABVAItemBindSplash, new ABMBVAItemRenderSplash );
	this->setupSplash( inSetupper );

	//	AB_SCENE_ENTRANCE@̃ZbgAbv
	inSetupper.setList( AB_SCENE_ENTRANCE );
	inSetupper.bind( new ABVAItemBindEntrance, new ABMBVAItemRenderEntrance );
	this->setupEntrance( inSetupper );

	//	V[@AB_SCENE_CONFIGURATION@̃ZbgAbv
	inSetupper.setList( AB_SCENE_CONFIGURATION );
	inSetupper.bind( new ABVAItemBindConfigration, new ABMBVAItemRenderConfigration );
	this->setupConfigration( inSetupper );


	//	V[@AB_SCENE_KEY_CONFIGURATION@̃ZbgAbv
	inSetupper.setList( AB_SCENE_KEY_CONFIGURATION );
	inSetupper.bind( new ABVAItemBindKeyConfigration, new ABMBVAItemRenderKeyConfigration );
	this->setupKeyConfigration( inSetupper );

	//	V[@AB_SCENE_MUSIC_SELECT@̃ZbgAbv
	{
		inSetupper.setList( AB_SCENE_MUSIC_SELECT );
		ABVAItemBindMusicSelect*  binder = new ABVAItemBindMusicSelect;
		inSetupper.bind( binder, new ABMBVAItemRenderMusicSelect );
		this->setupMusicSelect( inSetupper, binder );
	}

	//	V[@AB_SCENE_ENTRY@̃ZbgAbv
	inSetupper.setList( AB_SCENE_ENTRY );
	inSetupper.bind( new ABVAItemBindStageEntry, new ABMBVAItemRenderStageEntry );
//	this->setupEntry( inSetupper );

	//	V[@AB_SCENE_PLAY@̃ZbgAbv
	{
		inSetupper.setList( AB_SCENE_PLAY );
		ABVAItemBindStagePlay*  binder = new ABVAItemBindStagePlay;
		inSetupper.bind( binder, new ABMBVAItemRenderStagePlay );
		this->setupPlay( inSetupper, binder );
	}

	//	V[@AB_SCENE_FINISH@̃ZbgAbv
	{
		inSetupper.setList( AB_SCENE_FINISH );
		ABVAItemBindStageFinish*  binder = new ABVAItemBindStageFinish;
		inSetupper.bind( binder, new ABMBVAItemRenderStageFinish );
		this->setupFinish( inSetupper, binder );
	}

}

//-------------------------------------------------------------------
//	schene	AB_SCENE_SPLASH
//-------------------------------------------------------------------
void	ABMBVAItemPreset::setupSplash( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc )
{
	ABint				i = 0;
	ABint	vw = 640;
	ABint	vh = 480;
	
	// 	NWbg
	//	\nŉsBATSUIЂƂȂ̂ŁA󔒕ŃCAEg邱ƂۂB
	//	AsciiȊOi{ꓙjSourceɏ_łB
	//	{ꂪKvȂƂ́AResourcet@CǂݎĂB
	string	credit;
	credit =  "'Aqua'n Beats for MacOS X'\n";
	credit += "Presented by 2004-2xxx.Aqua'nBeats   ... Aqua'nBeats Project.\n";
	credit += " Original by 2000-2xxx.MacBeats(2nd) ... SoundSpeed-Hedgehog.\n";
	credit += "             2000.     MacBeats(1st) ...             A-KATOH.\n";
//	credit += "Made in Japan.\n";

	//	eLXg	SPLASHbZ[W
	//	̒`SchemeSetɂ͖An[hR[fBOŐÓIɗpӂB
	//	ɏVAɕ\܂B
	{
		ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );

		/*	
		//	^񒆑̃CAEg
		item->mWidth	= 512;
		item->mHeight	= 128;
		item->mLocation.set( (640.0f - item->mWidth ) / 2.0f, ( 480.0f - item->mHeight ) / 2.0f , 0.0f );
		item->mColor.set( 180, 180, 180, 255 );
		
		item->mFontSize = 12.0f;
		//item->mFontName = "Monaco";
		
		item->m_textAlignX = GE_TEXT_ALIGN_RIGHT;
		item->m_textAlignY = GE_TEXT_ALIGN_BOTTOM;		
		item->mFont	= NULL;
		*/		
		//	|̂ŉEɂĂ݂
		item->mWidth	= 512;	//	eNX`[l2̗ݏɂ邱
		item->mHeight	= 128;	//	eNX`[l2̗ݏɂ邱
		item->mLocation.set( (vw - item->mWidth ), ( vh - item->mHeight ), 0.0f );
		item->mColor.set( 180, 180, 200, 255 );	//	FтƂĂ݂
		
		item->mFontSize = 10.0f;				//	[U[̃VXeݒA`GAVOtHgTCỶe󂯂܂B
		//item->mFontName = "Monaco";			//	Default́uMonacovBCŃtHgwBꍇ\Ȃ̂ŒӂB
		
		item->m_textAlignX = GE_TEXT_ALIGN_RIGHT;
		item->m_textAlignY = GE_TEXT_ALIGN_BOTTOM;		

		item->mText.setCString( const_cast<ABint8*>(credit.c_str()), GS_ENCORDING_ASCII );
	}
}
	
//-------------------------------------------------------------------
//	schene	AB_SCENE_ENTRANCE
//-------------------------------------------------------------------
void	ABMBVAItemPreset::setupEntrance( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc )
{
	//	ÓIȃACe	^Cg摜
	{ 
		ABVAItemResImage*	texture;
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			texture = item;

			item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Title;
			item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
		}

		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite );
			
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Title;
			item->mSurface			= texture;
		}
	}

	//	IȃACe	j[
	//	j[Instance𐶐BInstance̐̓V[NXsB
	{ 
		ABVAItemResImage*	texture;
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			texture = item;

			item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]	= ResPict_TitleStrings;
			item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
		}
		{
			//	IACeʔԍ蓖Ă܂BABMBVAItemRenderEntranceNXŃACeQƂ邽߂ɕKvłB
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_ENTRANCE_MENU_CONTROL );

			//	j[̌A܂
			item->mCreateCount		= AB_TITLE_MENU_COUNT;

			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_TitleStrings;
			item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sTitleStrings;
			item->mSurface			= texture;
		}
	}

}

//-------------------------------------------------------------------
//	schene	AB_SCENE_CONFIGURATION
//-------------------------------------------------------------------
void	ABMBVAItemPreset::setupConfigration( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc )
{
	//	ÓIȃACe	^Cg摜
	//	wi摜ƂĎgp܂
	{ 
		ABVAItemResImage*	texture;
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			texture = item;

			item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Title;
			item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
		}

		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite );
			
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Title;
			item->mSurface			= texture;

			//	At@ufBOgpĈÂ܂B
			item->mColor.a	= 0.2f;
		}
	}

	//	eLXg	^Cg
	//	̒`SchemeSetɂ͖An[hR[fBOŐÓIɗpӂB
	//	ɏVAɕ\܂B
	{
		ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );

		item->mWidth	= 128;	//	eNX`[l2̗ݏɂ邱
		item->mHeight	= 32;	//	eNX`[l2̗ݏɂ邱
		item->mLocation.set( 4.0f, 0.0f, 0.0f );
		item->mFontSize = 32.0f;
		item->mText.setCString( "OPTION", GS_ENCORDING_ASCII );
	}

	const ABfloat32	TOP_LOCATION	= 48;
	const ABfloat32	LEFT_LOCATION	= 16;
	const ABfloat32	FONT_SIZE		= 12;
	const ABfloat32	ROW_HEIGHT		= 20;

	//	IACe@eLXg	j[x
	//	FRtBO
	{
		ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite, ABVA_ITEM_ID_CONFIG_MENU_CONTROL );

		item->mCreateCount = AB_OPTION_max;
		item->mSoftReturn = false;
		item->mWidth	= 256;
		item->mHeight	= 16;
		item->mLocation.set( 16, 48, 0.0f );
		item->mFontSize = FONT_SIZE;
		item->mText.setCString( "LABEL", GS_ENCORDING_ASCII );
	}

	//	IACe@eLXg	j[l
	//	FRtBO
	{
		ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite, ABVA_ITEM_ID_CONFIG_MENU_VALUE );

		item->mCreateCount = AB_OPTION_max;
		item->mHeight	= 16;
		item->mLocation.set( 280.0f, 48, 0.0f );
		item->mFontSize = FONT_SIZE;
		//item->mSoftReturn = false;	//	GE_TEXT_ALIGN_RIGHTɂȂ܂
		item->mWidth	= 256;			//	^[Ƃ́AƕƂĂ܂܂
		item->m_textAlignX = GE_TEXT_ALIGN_RIGHT;
		item->mText.setCString( "VALUE", GS_ENCORDING_ASCII );
	}
}

//-------------------------------------------------------------------
//	schene	AB_SCENE_KEY_CONFIGURATION
//-------------------------------------------------------------------
void	ABMBVAItemPreset::setupKeyConfigration( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc )
{
}

//-------------------------------------------------------------------
//	schene	AB_SCENE_MUSIC_SELECT	Iȉ
//-------------------------------------------------------------------
void	ABMBVAItemPreset::setupMusicSelect( ABVASchemeSetupper&  inSetupper, ABVAItemBindMusicSelect*  inBinder ) throw( std::bad_alloc )
{

	ABint				i = 0;

	//	wi摜F^Cg摜
	{ 
		ABVAItemResImage*	texture;
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			texture = item;

			item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Title;
			item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
		}

		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite );
			
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Title;
			item->mSurface			= texture;

			//	At@ufBOgpĈÂ܂B
			item->mColor.a	= 0.2f;
		}
	}
	//	wi摜F^[e[u
	{ 
		ABVAItemResImage*	texture;
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			texture = item;

			item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_TurnTable;
			item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
		}

		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_SELECT_SPRITE_TURN_TABLE );
			
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_TurnTable;
			item->mSurface			= texture;
		}
	}

	{
		ABint	FONT_SIZE = 12;
		
		//	BMS^CgXgi5THHj
		//	ȑIXg̕łB
		{
			ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite, ABVA_ITEM_ID_SELECT_TEXT_MUSIC_TITLE_LIST );
			item->mCreateCount	= 16;
			item->mWidth		= 512;
			item->mHeight		= 32;
			item->mLocation.set( 256.0f, 24.0f, 0.0f );
			item->mFontName		= "Osaka-Mono";
			item->mFontSize = FONT_SIZE;
			item->mUseBackColor = true;
			item->mSoftReturn = false;
			item->mBackColor.set( 128, 128, 128, 230 );	//	witB
			item->m_textAlignY = GE_TEXT_ALIGN_Y_CENTER;
			item->mText.setCString( "-BMS MUSIC / TITLE HEAR BMS MUSIC TITLE HEAR-\nLV[15] SCORE[001298]", GS_ENCORDING_ASCII );
		}
	}

	//	摜FInfoAreaF@BMSvCx
	{ 
		ABVAItemResImage*	texture;
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			texture = item;

			item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Star;
			item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
		}

		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_SELECT_SPRITE_PLAY_LEVEL_MARK );
			item->mCreateCount		= 32;
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Star;
			item->mSurface			= texture;
		}
	}
	
	//----------------------------------------------
	//	Xe[W
	//	̕`揈́AMacbeat̖ȕ\ĂB
	//	@ARCADE[h摜̓Q[[h摜ɑ邪AQ[[hł͖Xe[Wio[摜ꏏɂȂĂB
	//	@ʏ̓_CNgɕ`悷̂ŕʁX̏ꏊɓ]ł邪Ał͐ÓIȕ\œIɓWJȂ΂ȂȂB
	//----------------------------------------------
	{
		//	schemeǂݍ܂AQ[SceneJnƂɁAlvZB
		//	ォ珇ԂɁAlm肵ĂB𗘗pāAs̍WłB
		
		//	lFPlayStepFQ[[h̍Wʒu
		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_SELECT_SPRITE_LOCATE_PLAY_STEP );
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_PlayStep;
			item->mStab			= true;
		}

		//	摜FInfoAreaFGame MODEFARCADE[hx(ARCADEƂx摜)
		//	摜FInfoAreaFGame MODEFEXPERT[hx(EXPERTƂx摜)
		{ 
			ABVAItemResImage*	gameModeTexture;
			{
				ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
				gameModeTexture = item;

				item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_GameModes;
				item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
			}

			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_SELECT_SPRITE_GAME_MODE_LABEL );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_GameModes;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sGameModes;
				item->mSurface			= gameModeTexture;
			}

			//	摜FInfoAreaFGameModeFARCADE[hFXe[Wio[l
			//	摜FInfoAreaFGameModeFEXPERT[hFXe[Wio[l
			{ 
				ABVAItemResImage*	texture;
				{
					ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
					texture = item;

					item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_StageNumbers;
					item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
				}

				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_SELECT_SPRITE_STAGE_NUMBER );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_StageNumbers;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sStageNumbers;
					item->mSurface			= texture;
				}
			}
			//	摜FInfoAreaFGame MODEFARCADE[hFXe[Wx(StageƂx摜)
			//	摜FInfoAreaFGame MODEFEXPERT[hFXe[Wx(StageƂx摜)
			{ 
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_SELECT_SPRITE_STAGE_NUMBER_LABEL );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_GameModes;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sGameModes;
					item->mSurface			= gameModeTexture;
				}
			}
		} 
	} 
	
	//----------------------------------------------
	//	infoarea XgNbsOČ떂߂ɁA㑤ɕ`悵ĂB
	{	
		//	wi摜FInfoArea
		{ 
			ABVAItemResImage*	texture;
			{
				ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
				texture = item;

				item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_InfoArea;
				item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
			}

			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_InfoArea;
				item->mSurface			= texture;
			}
		}
			
		//	ACR摜FI[gvCF1p
		//	ACR摜FI[gvCF2p
		{ 
			ABVAItemResImage*	texture;
			{
				ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
				texture = item;

				item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_AutoPlayIcon;
				item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
			}

			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_SELECT_SPRITE_ICON_AUTO_PLAY_P1 );
				item->mCreateCount		= 2;
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_AutoPlayIcon_1P;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sAutoPlayIcon;
				item->mSurface			= texture;
			}
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_SELECT_SPRITE_ICON_AUTO_PLAY_P2 );
				item->mCreateCount		= 2;
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_AutoPlayIcon_2P;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sAutoPlayIcon;
				item->mSurface			= texture;
			}
		}
	}
	//----------------------------------------------
	{
		//	ACR摜FBMSFVETEvC[EBGA̗LEN
		{ 
			ABVAItemResImage*	texture;
			{
				ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
				texture = item;

				item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_BMSInfoIcon;
				item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
			}

			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_SELECT_SPRITE_ICON_BMS_INFO );
				item->mCreateCount		= ABMBVAItemRenderMusicSelect::M_ICON_BMS_INFO_COUNT;
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_BMSInfoIcon;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sBMSInfoIcon;
				item->mSurface			= texture;
			}
		}
	}
	//----------------------------------------------
	//	BMS,SCHEME
	//----------------------------------------------
	{
		//	FInfoAreaFBMS^Cg
		//	FInfoAreaFW
		//	FInfoAreaFA[eBXg
		//	FInfoAreaFBPM
		//	FInfoAreaFBMStH_[ԍ
		//	FInfoAreaFBMSf[^ԍ
		{
			ABint	FONT_SIZE = 12;
			ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite, ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO );
			item->mCreateCount	= ABMBVAItemRenderMusicSelect::M_TEXT_BMS_INFO_COUNT;
			item->mWidth		= 64;
			item->mHeight		= 16;
			item->m_textAlignX = GE_TEXT_ALIGN_RIGHT;
			item->m_textAlignY = GE_TEXT_ALIGN_BOTTOM;		
			item->mLocation.set( 0.0f, 16.0f + i * 16.0f , 0.0f );
			item->mFontSize = FONT_SIZE;
			item->mText.setCString( "-", GS_ENCORDING_ASCII );
		}
		{
			ABint	FONT_SIZE = 14;
			ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite, ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO_VALUE );
			item->mCreateCount	= ABMBVAItemRenderMusicSelect::M_TEXT_BMS_INFO_COUNT;
			item->mFontName		= "Osaka";
			item->mWidth		= 512;
			item->mHeight		= 16;
			item->m_textAlignY = GE_TEXT_ALIGN_BOTTOM;		
			item->mLocation.set( 0.0f, 16.0f + i * 16.0f , 0.0f );
			item->mFontSize = FONT_SIZE;
			item->mText.setCString( "-", GS_ENCORDING_ASCII );
		}
	}
}

//-------------------------------------------------------------------
//	schene	AB_SCENE_ENTRY	ȏЉ
//-------------------------------------------------------------------
void	ABMBVAItemPreset::setupEntry( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc )
{
}

//-------------------------------------------------------------------
//	schene	AB_SCENE_PLAY	vC
//-------------------------------------------------------------------
void	ABMBVAItemPreset::setupPlay( ABVASchemeSetupper&  inSetupper, ABVAItemBindStagePlay*  inBinder ) throw( std::bad_alloc )
{

	ABint	i;
	ABint	vw = 640;
	ABint	vh = 480;

	//	lFg񂳂Mbvl
	{
		ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_GAP );
		item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Gap;
		item->mStab = true;	//	SCHEMEǂݎׂ̊ƂĂ̂ݎgpBInstance쐬邪AXvCg͍쐬ȂB
	}
	
	//----------------------------	
	//	GUI
	//----------------------------	
	{
		//----------
		//	摜FQ[Xe[Wiwij
		//----------
		{ 
			//----------
			//	wi
			//----------
			{
				//	wiFsurfacẽXvCg\邱ƂŊȒPɕ\łB
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_BACK_COLOR );
				
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Title;

				item->mWidth	= vw;
				item->mHeight	= vh;
				item->mColor.set( 0, 32, 128, 64 );
			}
			//----------
			//	FBMS^Cg
			//----------
			{
				
			}
		}
		//----------
		//	摜FC[WIuWFNg
		//----------
		{
			ResPictKey	resourceKey[] = {
				ResPict_Image1,
				ResPict_Image2,
				ResPict_Image3,
				ResPict_Image4,
				ResPict_Image5,
				ResPict_Image6,
				ResPict_Image7,
				ResPict_Image8,

			};
			ABMBSchemeDataKey	schemeKey[] = {
				SCH_Image1,
				SCH_Image2,
				SCH_Image3,
				SCH_Image4,
				SCH_Image5,
				SCH_Image6,
				SCH_Image7,
				SCH_Image8,
			};
			
			for( i = 0 ; i < sizeof( resourceKey ) / sizeof( ResPictKey ) ; i++ ){
				ABVAItemResImage*	texture;
				{
					ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
					texture = item;

					item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= resourceKey[i];
					item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
				}

				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite );
					
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= schemeKey[i];
					item->mSurface			= texture;
				}
			}
		}
		//----------
		//	摜FAj[V̈iBGAj
		//----------
		{ 
			//	Poor摜
			{
				ResPictKey	skey[] = {
					ResPict_NoAnimation,
					ResPict_PoorAnimation,
					ResPict_NoiseAnimation1,
					ResPict_NoiseAnimation2,
				};
				for( i = 0 ; i < sizeof( skey ) / sizeof(ResPictKey) ; i++ ){
					{
						ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage, ABVA_ITEM_ID_PLAY_SPRITE_POOR_IMAGE_0 + i );

						item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= skey[i];
						item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
					}
				}
			}

			//	LayerOALayerPiꂼsurfacepӂj
			{
				ABVAItemArray*	items	= new ABVAItemArray;
				ABVAItemResImage*	texture;
				{
					ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage, ABVA_ITEM_ID_PLAY_IMAGE_LAYER_0 );
					texture = item;

					item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_NoAnimation;
					item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
				}

				for( i = 0 ; i < 2 ; i ++ ){	
					{
						ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_LAYER_0 + i );
						
						item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Animation;
						item->mVisible = false;
						item->mSurface			= texture;
					}
				}
			}
		}
		{
			//----------
			//	摜FvCtB[hiwi()j
			//----------
			{
				//----------
				//	lFvCtB[hiwi()j
				//----------
				{
					ABVAItemResImage*	texture;
					{
						ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
						texture = item;

						item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_PlayField;
						item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
					}

					//	̃ACeresourcẽTCYɃtBbgׂɗpB
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_FIELD_BASE );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_PlayField;
					item->mSurface				= texture;
					item->mStab = true;	//	̂ɃXvCg͍쐬Ȃ

					//	Player 1
					{
						ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_FIELD_P1 );
						
						item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_PlayField_1P;
						item->mSurface			= texture;
					}
					//	Player 2
					{
						ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_FIELD_P2 );
						
						item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_PlayField_2P;
						item->mSurface			= texture;
					}
				}

			}
		}
	}


	//----------
	//	摜FO[g][
	//----------
	{
		//	Player 1
		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_GREAT_ZONE_P1 );
			
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_GreatZone;
			item->mColor.set( 255, 12, 60, 100 );	//	F	alphaŔd˂
			item->mLocation.z = 1;	//	ƂOɔzu
		}

		//	Player 2
		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_GREAT_ZONE_P2 );
			
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_GreatZone;
			item->mColor.set( 255, 12, 60, 100 );	//	F@alphaŔd˂
			item->mLocation.z = 1;	//	ƂOɔzu
		}
	}
	
	{
		//----------
		//	Neon
		//----------
		{
			//----------
			//	lFNeon
			//----------
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_NEON_BASE );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Neon;
				item->mStab = true;
			}
			
			//----------
			//	摜FNeon
			//----------
			ABVAItemResImage*	texture;
			{
				ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
				texture = item;

				item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Neons;
				item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
			}

			//----------
			//	摜FNeonǁF1P
			//----------
			ABVAItemSprite*		targetItem;
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_NEON_P1 );
				
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Neon_1P;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sNeon;
				item->mSurface			= texture;
				targetItem				= item;
			}			
			//	XvCgAnimationiK^[QbgXvCǧɓo^邱Ɓj
			{
				//	XL[w薳Aj[V
				ABVAItemAnimation*		item = inSetupper.addData( new ABVAItemAnimation, ABVA_ITEM_ID_PLAY_SPRITE_NEON_ANIME_P1 );
				item->mModule				= ABVAItemAnimation::M_MODULE_NEON;	//	lIAnimationw
				item->mSyncMode				= ABVAItemAnimation::M_SYNC_NORMAL;
				item->mPlayMode				= ABVAItemAnimation::M_PLAY_ONESHOT;
				item->mSurfaceLayoutType	= ABVAItemAnimation::M_LAYOUT_NEON;	//	lIAnimationw
				item->mFrameCountMax		= 1;			//	lIǂ1
				item->mFrameTimeMax			= 90;			//	̃LLԂ`bNJEgŎwB
				item->setTargetSprite( targetItem );		//	^[QbgACe̎w͂̊֐gp邱
			}
			//----------
			//	摜FNeonǁF2P
			//----------
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_NEON_P2 );
				
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Neon_2P; 
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sNeon;
				item->mSurface			= texture;
				targetItem				= item;
			}			
			//	XvCgAnimationiK^[QbgXvCǧɓo^邱Ɓj
			{
				//	XL[w薳Aj[V
				ABVAItemAnimation*		item = inSetupper.addData( new ABVAItemAnimation, ABVA_ITEM_ID_PLAY_SPRITE_NEON_ANIME_P2 );
				item->mModule				= ABVAItemAnimation::M_MODULE_NEON;	//	lIAnimationw
				item->mSyncMode				= ABVAItemAnimation::M_SYNC_NORMAL;
				item->mPlayMode				= ABVAItemAnimation::M_PLAY_ONESHOT;
				item->mSurfaceLayoutType	= ABVAItemAnimation::M_LAYOUT_NEON;	//	lIAnimationw
				item->mFrameCountMax		= 1;		//	lIǂ1
				item->mFrameTimeMax			= 90;		//	̃LLԂ`bNJEgŎwB
				item->setTargetSprite( targetItem );	//	^[QbgACe̎w͂̊֐gp邱
			}
		}

	}

	//----------------------------	
	//	Draw Active Premitive
	//----------------------------	
	{
		//	摜FL[_ÉAobNCg
		{
			//	lFC
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_VALUE_LINE );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Line;
				item->mStab = true;
			}			
			//	lFL[m[g̃ItZbgTCY
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_VALUE_NOTE_OFFSET );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_NoteOffset;
				item->mWidth = 0;	//	ftHgl
				item->mHeight = 0;	//	ftHgl
				item->mStab = true;
			}			
			//	lFL[m[g̃TCY
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_VALUE_NOTE_SIZE );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_WKeyHit;
				item->mStab = true;
			}			
			{
				//	摜FobNCg摜
				ABVAItemResImage*	surf	= NULL;
				{
					ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );

					item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_HitLight;
					item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
					surf = item;
				}

				//	XvCgFL[_ÉAobNCg 
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_WHITE );
					item->mCreateCount = 4 * 2;	//	1, 3, 5, 7 * 2Player
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_WKeyHit;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sWKeyHit;
					item->mColor.a = 0.75f;
					item->mSurface			= surf;
					item->mVisible = false;
				}			
				//	XvCgFL[_ÉAobNCg 
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_BLACK );
					item->mCreateCount = 3 * 2;	//	2, 4, 6 * 2Player
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_BKeyHit;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sBKeyHit;
					item->mColor.a = 0.75f;
					item->mSurface			= surf;
					item->mVisible = false;
				}			
				//	XvCgFL[_ÉAobNCg XNb`
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_SCRATCH );
					item->mCreateCount = 1 * 2;	//	1 * 2Player
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_ScrchHit;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sScrchHit;
					item->mColor.a = 0.75f;
					item->mSurface			= surf;
					item->mVisible = false;
				}			

				//	摜F߂̃C
				{
					ABVAItemResImage*	texture;
					{
						ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
						texture = item;

						item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_BarObj;
						item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
					}
				
					//	Player1
					{
						ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_BAR_P1 );
						item->mCreateCount = 16;	//	]Tč쐬
						item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Bar;
						item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sBar;
						item->mVisible 			= false;
						item->mSurface			= texture;
					}			
					//	Player2
					{
						ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_BAR_P2 );
						item->mCreateCount = 16;	//	]Tč쐬
						item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Bar;
						item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sBar;
						item->mVisible 			= false;
						item->mSurface			= texture;
					}			
				}
				
				//	摜F摜
				ABVAItemResImage*	surfNote	= NULL;
				{
					ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );

					item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Objects;
					item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
					surfNote = item;
				}
				//	XvCgFNoteItem	Z肷邽߂̃X^u
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_NOTE_WHITE );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_WKeyNote;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sWKeyNote;
					item->mSurface			= surfNote;
					item->mStab				= true;
				}			
				//	XvCgFNoteItem	Z肷邽߂̃X^u
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_NOTE_BLACK );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_BKeyNote;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sBKeyNote;
					item->mSurface			= surfNote;
					item->mStab				= true;
				}			
				//	XvCgFNoteItem	Z肷邽߂̃X^u
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_NOTE_SCRACH );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_ScrchNote;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sScrchNote;
					item->mSurface			= surfNote;
					item->mStab				= true;
				}			
				//	XvCgFNoteItem	t[XNb`	Z肷邽߂̃X^u
				//	::TODO::MacBeatł̓t[XNb`ΉB]ăXL[`B
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_TEMPLATE_NOTE_FREE_SCRATCH );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_ScrchNote;	//	XNb`őp
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sScrchNote;	//	XNb`őp
					item->mSurface			= surfNote;
					item->mVisible 			= false;
				}

				//	XvCgFNoteItem	ĂACeB
				//	EG4 1Ghz Dualł悻2000̃XvCgŌEۂB
				{
					//	XvCgFNoteItem	t[XNb`iQԖڂLayerj
					{
						ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_FREE_SCRATCH_OBJECT );
						item->mCreateCount = 32 * 4 * 2;	//	32i32ߕj* 4 item * 2Player
						item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_WKeyNote;
						item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sWKeyNote;
						item->mSurface			= surfNote;
						item->mVisible 			= false;
						item->mColor.a 			= 0.6f;
					}
					//	XvCgFNoteItem	Ă鉹ACeB
					ABVAItemSprite*		targetItem;
					{
						ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_NOTE_OBJECT );
						item->mCreateCount = 240 * 2 ;	//	item * 2Player
						item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_WKeyNote;
						item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sWKeyNote;
						item->mSurface			= surfNote;
						item->mVisible 			= false;
						targetItem 		= item;
					}
					//	XvCgAnimationiK^[QbgXvCǧɓo^邱ƁjFNoteItem	Ă鉹ACeB
					{
						//	XL[w薳Aj[V
						ABVAItemAnimation*		item = inSetupper.addData( new ABVAItemAnimation, ABVA_ITEM_ID_PLAY_SPRITE_NOTE_ANIME );
						item->mSyncMode				= ABVAItemAnimation::M_SYNC_BPM;
						item->mPlayMode				= ABVAItemAnimation::M_PLAY_NEVER;
						item->mSurfaceLayoutType	= ABVAItemAnimation::M_LAYOUT_VERTICAL;
						item->mFrameCountMax		= 8;
						item->mFrameTimeMax			= 1;
						item->mBPMSyncRate			= BMS_SEQ_EVENT_RESOLUTION4 / 8;		//	32P(S1/8̒)œ
						item->mBreakBeatCellNumber	= 8;									//	L摜surface̍Ō̃Z
						item->setTargetSprite( targetItem );								//	^[QbgACe̎w͂̊֐gp邱
					}
				}

			}
		}
		
		//	XvCgF茋ʕ`
		{
			ABVAItemResImage*	texture;
			{
				ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
				texture = item;

				item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Judges;
				item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
			}
			//	Player1
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_JUDGE_P1 );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Judge;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sJudge;
				item->mVisible 			= false;
				item->mSurface			= texture;
			}			
			//	Player2
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_JUDGE_P2 );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Judge;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sJudge;
				item->mVisible 			= false;
				item->mSurface			= texture;
			}			
		}
		//	XvCgFXp[N
		{
			ABVAItemResImage*	texture;
			{
				ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
				texture = item;

				item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Sparks;
				item->mTransparentType = GE_BMP_TRANSPARENT_BLACK;
			}
			ABVAItemSprite*		targetItem;
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_SPARK );
				item->mCreateCount = 8 * 2;	//	1~7, scrach * 2
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Spark;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sSpark;
				item->mVisible 			= false;
				item->mSurface			= texture;
				targetItem 		= item;
			}			
			//	XvCgAnimationiK^[QbgXvCǧɓo^邱Ɓj
			{
				//	XL[w薳Aj[V
				ABVAItemAnimation*		item = inSetupper.addData( new ABVAItemAnimation, ABVA_ITEM_ID_PLAY_SPRITE_SPARK_ANIME );
				item->mSyncMode				= ABVAItemAnimation::M_SYNC_NORMAL;
				item->mPlayMode				= ABVAItemAnimation::M_PLAY_ONESHOT;
				item->mSurfaceLayoutType	= ABVAItemAnimation::M_LAYOUT_HORIZON;
				item->mFrameCountMax		= 8;
				item->mFrameTimeMax			= 1;
				item->setTargetSprite( targetItem );	//	^[QbgACe̎w͂̊֐gp邱
			}
		}

		//	XvCgFAjIuWFNg
		{
			ResPictKey	resouceKey[] = {
				ResPict_AnimObj1,
				ResPict_AnimObj2,
				ResPict_AnimObj3,
				ResPict_AnimObj4,
			};
			ABMBSchemeDataKey	schemeKey[] = {
				SCH_AnimObj1,
				SCH_AnimObj2,
				SCH_AnimObj3,
				SCH_AnimObj4,
			};
			ABMBSchemeDataKey	subSchemeKey[] = {
				SCH_sAnimObj1,
				SCH_sAnimObj2,
				SCH_sAnimObj3,
				SCH_sAnimObj4,
			};
			ABMBSchemeDataKey	animatorScemeKey[] = {
				SCH_Opt_AnimObj1,
				SCH_Opt_AnimObj2,
				SCH_Opt_AnimObj3,
				SCH_Opt_AnimObj4,
			};
			for( i = 0 ; i < 4 ; i ++ ){
				ABVAItemResImage*	texture;
				{
					ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
					texture = item;

					item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= resouceKey[i];
					item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
				}
				ABVAItemSprite*		targetItem;
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_ANIME_1 + i );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= schemeKey[i];
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= subSchemeKey[i];
					item->mSurface			= texture;
					targetItem 		= item;
				}			
				//	XvCgAnimationiK^[QbgXvCǧɓo^邱Ɓj
				{
					ABVAItemAnimation*		item = inSetupper.addData( new ABVAItemAnimation );
					item->mKeyID[ABMB_ADAPTER_ITEM_ANIMATION_KEY]	= animatorScemeKey[i];
					item->mSyncMode				= ABVAItemAnimation::M_SYNC_NORMAL;
					item->mPlayMode				= ABVAItemAnimation::M_PLAY_NEVER;
					item->mSurfaceLayoutType	= ABVAItemAnimation::M_LAYOUT_HORIZON;
					item->setTargetSprite( targetItem );	//	^[QbgACe̎w͂̊֐gp邱
				}
			}
		}
		

		//	XvCgF_XIuWFNg
		{
			ResPictKey	resouceKey[] = {
				ResPict_DanceObj1,
				ResPict_DanceObj2,
				ResPict_DanceObj3,
				ResPict_DanceObj4,
			};
			ABMBSchemeDataKey	schemeKey[] = {
				SCH_DanceObj1,
				SCH_DanceObj2,
				SCH_DanceObj3,
				SCH_DanceObj4,
			};
			ABMBSchemeDataKey	subSchemeKey[] = {
				SCH_sDanceObj1,
				SCH_sDanceObj2,
				SCH_sDanceObj3,
				SCH_sDanceObj4,
			};
			ABMBSchemeDataKey	animatorScemeKey[] = {
				SCH_Opt_DanceObj1,
				SCH_Opt_DanceObj2,
				SCH_Opt_DanceObj3,
				SCH_Opt_DanceObj4,
			};
			ABMBSchemeDataKey	optionScemeKey[] = {
				SCH_Opt_Dance1UseBlitKey,
				SCH_Opt_Dance2UseBlitKey,
				SCH_Opt_Dance3UseBlitKey,
				SCH_Opt_Dance4UseBlitKey,
			};
			for( i = 0 ; i < 4 ; i ++ ){
				ABVAItemResImage*	texture;
				{
					ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
					texture = item;

					item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= resouceKey[i];
					item->mKeyID[ABMB_ADAPTER_ITEM_OPTION_SCHEME_KEY]= optionScemeKey[i];
					item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
				}
				ABVAItemSprite*		targetItem;
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_DANCE_1 + i );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= schemeKey[i];
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= subSchemeKey[i];
					item->mSurface			= texture;
					targetItem		 		= item;
				}
				//	XvCgAnimationiK^[QbgXvCǧɓo^邱Ɓj
				{
					ABVAItemAnimation*		item = inSetupper.addData( new ABVAItemAnimation );
					item->mKeyID[ABMB_ADAPTER_ITEM_ANIMATION_KEY]	= animatorScemeKey[i];
					item->mSyncMode				= ABVAItemAnimation::M_SYNC_NORMAL;
					item->mPlayMode				= ABVAItemAnimation::M_PLAY_NEVER;
					item->mSurfaceLayoutType	= ABVAItemAnimation::M_LAYOUT_HORIZON;
					item->setTargetSprite( targetItem );	//	^[QbgACe̎w͂̊֐gp邱
				}
			}
		}

	}
	
	//----------------------------	
	//	Draw Status
	//----------------------------	
	{
		//	io[IuWFNgƌĂ΂镨́AABł̓tHgƂĕ\B
		//	̎͐VSCHEMEASCIIR[hBMP\T|[gĂB
		this->setupFont( inSetupper );

		//---------------------------------------------------
		//	FPLAY StatusFe
		//---------------------------------------------------
		{
			//	FPLAY StatusFȖ
			{
				ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
				item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.mMusicTitle ) );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_BMSTitleArea;
				item->mFontName		= "Osaka";
				item->mWidth		= 512;
				item->mHeight		= 16;
				item->m_textAlignX = GE_TEXT_ALIGN_X_CENTER;		
				item->m_textAlignY = GE_TEXT_ALIGN_TOP;		
				item->mFontSize		= 9;
				item->mText.setCString( "TITLE", GS_ENCORDING_SHIT_JIS );
			}
			//	FPLAY StatusFBPM
			{
				ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
				item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.mValueBPM ) );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_BPM;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_BPM;		//	fontNumberFontTypew肷ׂSCHEME
				item->mTextMaxLength= 3;
				item->mUseFont= true;
				memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
				item->mSurface			= this->m_fontTexture;
				item->mString.assign( "000000" );
			}
			//	FPLAY StatusFFPS
			{
				ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
				item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.mValueFPS ) );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_FPS;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_FPS;		//	fontNumberFontTypew肷ׂSCHEME
				item->mTextMaxLength= 3;
				item->mUseFont= true;
				item->mSurface			= this->m_fontTexture;
				memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
				item->mString.assign( "000000" );
			}
			//	FPLAY StatusFe픻l  PLAYER 1
			{
				//	forł܂Ƃ߂邱ƂoBAXɂȂ̂ŁA肪菑ǂ낤B
				
				//	FPLAY StatusFSCORE
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player1.mValueScore ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Score_1P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Score;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 6;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFJustGreat
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player1.mValueCountJustGreat ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_JustGreat_1P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFGreat
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player1.mValueCountGreat ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_Great_1P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFgood
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player1.mValueCountGood ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_Good_1P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFbad
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player1.mValueCountBad ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_Bad_1P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFpoor
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player1.mValueCountPoor ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_Poor_1P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFmax combo
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player1.mValueCountCombo ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_MaxCom_1P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFTotal
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player1.mValueCountTotal ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_Total_1P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
			}
			//	FPLAY StatusFe픻l  PLAYER 2
			{
				//	FPLAY StatusFtotal
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player2.mValueScore ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Score_2P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Score;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 6;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFJustGreat
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player2.mValueCountJustGreat ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_JustGreat_2P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFGreat
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player2.mValueCountGreat ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_Great_2P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFgood
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player2.mValueCountGood ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_Good_2P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFbad
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player2.mValueCountBad ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_Bad_2P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFpoor
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player2.mValueCountPoor ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_Poor_2P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFmax combo
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player2.mValueCountCombo ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_MaxCom_2P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
				//	FPLAY StatusFTotal
				{
					ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player2.mValueCountTotal ) );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_N_Total_2P;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Param;		//	fontNumberFontTypew肷ׂSCHEME
					item->mTextMaxLength= 4;
					item->mUseFont= true;
					item->mSurface			= this->m_fontTexture;
					memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
					item->mString.assign( "000000" );
				}
			}
			
			{
				ABVAItemResImage*	texture;
				{
					ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
					texture = item;

					item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_GaugeObj;
					item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
				}
				//	摜FQ[Witensionjplayer 1
				{ 
					//	_Ci~bNoC_[ɂĕ\B̂傱傱M邾ŐFXׂႢ܂
					{
						ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P1 );
						item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TENSION_GAUGE, ABVA_ITEM_DYNAMIC_BIND_TYPE_INT, inBinder->mPramam.Player1.mValueTension ) );
						item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Gauge;
						item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sGauge;
						item->mCreateCount		= BMS_SEQ_CONSUMER_SCORE_RESULT_GRAPH_MAX;						//	GAUGEɕKvʍ쐬
						inBinder->mPramam.Player1.mValueTension.mGain				= BMS_SEQ_CONSUMER_SCORE_RESULT_GRAPH_GAIN;			//	ԂȂn_
						inBinder->mPramam.Player1.mValueTension.mUseGain			= true;	//	Ԃ
						inBinder->mPramam.Player1.mValueTension.mCellLightGreen		= 0;	//	摜̈Obhŋ؂Ƃ̉摜ԍBcɐ邱ƁB
						inBinder->mPramam.Player1.mValueTension.mCellLightRed		= 2;	//	摜̈Obhŋ؂Ƃ̉摜ԍBcɐ邱ƁB
						inBinder->mPramam.Player1.mValueTension.mCellDarkGreen		= 1;	//	摜̈Obhŋ؂Ƃ̉摜ԍBcɐ邱ƁB
						inBinder->mPramam.Player1.mValueTension.mCellDarkRed		= 3;	//	摜̈Obhŋ؂Ƃ̉摜ԍBcɐ邱ƁB
						inBinder->mPramam.Player1.mValueTension.mRandomizer			= true;	//	茸肷h̕\B
						item->mSurface			= texture;
					}
				}
				//	摜FQ[Witensionjplayer 2
				{ 
					//	_Ci~bNoC_[ɂĕ\B
					{
						ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P2 );
						item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TENSION_GAUGE, ABVA_ITEM_DYNAMIC_BIND_TYPE_INT, inBinder->mPramam.Player2.mValueTension ) );
						item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Gauge;	//	Player1 ƓBSCH_Gauge2ZȂ΂ȂȂB
						item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sGauge;	//	Player1 ƓBSCH_Gauge2ZȂ΂ȂȂB
						item->mCreateCount		= BMS_SEQ_CONSUMER_SCORE_RESULT_GRAPH_MAX;	//	GAUGEɕKvʍ쐬
						inBinder->mPramam.Player2.mValueTension.mGain				= BMS_SEQ_CONSUMER_SCORE_RESULT_GRAPH_GAIN;			//	ԂȂn_
						inBinder->mPramam.Player2.mValueTension.mUseGain			= true;	//	Ԃ
						inBinder->mPramam.Player2.mValueTension.mCellLightGreen		= 0;	//	摜̈Obhŋ؂Ƃ̉摜ԍBcɐ邱ƁB
						inBinder->mPramam.Player2.mValueTension.mCellLightRed		= 2;	//	摜̈Obhŋ؂Ƃ̉摜ԍBcɐ邱ƁB
						inBinder->mPramam.Player2.mValueTension.mCellDarkGreen		= 1;	//	摜̈Obhŋ؂Ƃ̉摜ԍBcɐ邱ƁB
						inBinder->mPramam.Player2.mValueTension.mCellDarkRed		= 3;	//	摜̈Obhŋ؂Ƃ̉摜ԍBcɐ邱ƁB
						inBinder->mPramam.Player2.mValueTension.mRandomizer			= true;	//	茸肷h̕\B
						item->mSurface			= texture;
					}
				}
			}

			//	lFQ[Witensionjplayer 2 offset
			//	͓߂̎w肪̂ItZbgiΒljɂȂĂ邽߁AZׂ̈ɃXL[ǂݍޒlƂĎgpB
			//@_[Ɏgp܂B
			{ 
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P2_OFFSET );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Gauge2;
					item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sGauge2;	//	::TODO::Ή
					item->mStab = true;
				}
			}
		}
		
		//	FPLAY StatusFTIME(tԁH)
		{
			ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite );
			item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.mValuePlaingTimer ) );
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_ClockObj;
			item->mFontSize		= 16;
			item->mWidth		= 128;
			item->mHeight		= 16;
			item->m_textAlignX = GE_TEXT_ALIGN_RIGHT;
			item->mText.setCString( "0", GS_ENCORDING_ASCII );
		}
		//	摜FPLAY StatusFLOCATION(tʒu)
		//	ESCHEMEȂ̂ŁAPF̋`\
		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite );
			item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_LOCATION_GAUGE, ABVA_ITEM_DYNAMIC_BIND_TYPE_INT, inBinder->mPramam.mValueLocation ) );
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_PositionDraw;
			item->mWidth	= 256;
			item->mHeight	= 256;
			item->mColor.set( 255, 255, 255, 255 );
		}

		{
			//	FPLAY StatusFCOMBOJE^[ P1
			{
				//	E\ʒúAvCjudgȅꏊɍs
				ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite, ABVA_ITEM_ID_PLAY_SPRITE_COMBO_COUNTER_P1 );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player1.mValueComboCounter ) );
				//	item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= ;					//	QƂ
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Combo;		//	fontNumberFontTypew肷ׂSCHEME
				item->mTextMaxLength= 4;
				item->mLocation.set( 50, 200, 0 );
				item->mUseFont= true;
				item->mVisible			= false;
				item->mSurface			= this->m_fontTexture;
				memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
				item->mString.assign( "000000" );
			}
			//	FPLAY StatusFCOMBOJE^[ P2
			{
				//	E\ʒúAvCjudgȅꏊɍs
				ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite, ABVA_ITEM_ID_PLAY_SPRITE_COMBO_COUNTER_P2 );
					item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player2.mValueComboCounter ) );
				//	item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= ;					//	QƂ
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Combo;		//	fontNumberFontTypew肷ׂSCHEME
				item->mLocation.set( 550, 200, 0 );
				item->mTextMaxLength= 4;
				item->mUseFont= true;
				item->mVisible			= false;
				item->mSurface			= this->m_fontTexture;
				memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
				item->mString.assign( "000000" );
			}
		}
	}
	
	{
		//----------
		//	摜F[fBOʔwi
		//----------
		{ 
			ABVAItemResImage*	texture;
			{
				ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage, ABVA_ITEM_ID_PLAY_IMAGE_NOWvLOADING_BG );
				texture = item;

				item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Title;
				item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
			}

			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_NOWvLOADING_BG );
				item->mCreateCount		= 2;
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Title;
				item->mLocation.z = 10;
				item->mSurface			= texture;

			}
		} 
		//----------
		//	摜F[fBOʕ
		//----------
		{

			ABVAItemResImage*	texture;
			{
				ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage, ABVA_ITEM_ID_PLAY_IMAGE_NOW_LOADING_LOGO );
				texture = item;

				item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_NowLoading;
				item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
			}
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_NOW_LOADING_LOGO );
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_LoadBMS;
				item->mLocation.z = 11;
				item->mSurface			= texture;
			}
		} 

		{	
			//----------
			//	摜FvOXo[
			//----------
			{
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_PLAY_SPRITE_PROGRESS_BAR );
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_LoadBMS;
					item->mLocation.z = 12;
					item->mColor.set( 0, 0, 15, 200 );
				}
			} 
		}
	}
}

//-------------------------------------------------------------------
//	schene	AB_SCENE_FINISH	PȏI
//-------------------------------------------------------------------
void	ABMBVAItemPreset::setupFinish( ABVASchemeSetupper&  inSetupper, ABVAItemBindStageFinish*  inBinder ) throw( std::bad_alloc )
{
	ABint	i;

	//	ÓIȃACe	wi
	{ 
		ABVAItemResImage*	texture;
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			texture = item;

			item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Results;
			item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
		}

		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite );
			
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Result;
			item->mSurface			= texture;
		}
	}
	
	{
		//	Ot
		{
			ABint		graphLength = ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH;
		
			//	摜FOt`phbgG
			ABVAItemResImage*		texture;
			{
				ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
				texture = item;

				item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_GraphObj;
				item->mTransparentType = GE_BMP_TRANSPARENT_NONE;
			}

			//	lFOt̕\ʒu
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_FINISH_SPRITE_GRAPH_AREA );
				
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_GraphArea;
				item->mStab			= true;
			}

			//	摜F1P
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_FINISH_SPRITE_GRAPH_P1 );
				
				item->mCreateCount		= graphLength;
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_GraphObj;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sGraphObj;
				item->mSurface			= texture;
			}
			//	摜F2P
			{
				ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_FINISH_SPRITE_GRAPH_P2 );
				
				item->mCreateCount		= graphLength;
				item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_GraphObj;
				item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_sGraphObj;
				item->mSurface			= texture;
			}


			//	io[IuWFNgƌĂ΂镨́AABł̓tHgƂĕ\B
			//	̎͐VSCHEMEASCIIR[hBMP\T|[gĂB
			this->setupFont( inSetupper );
			
			//	XRA
			//---------------------------------------------------
			//	FPLAY StatusFe
			//	E̒ĺAvCɂgpĂBCAEg\ړIقȂׁAēR[hKvB
			//---------------------------------------------------
			{
				//	lF̕\ʒu
				{
					ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_FINISH_SPRITE_SCORE_OFFSET );
					
					item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_PDOffset;
					item->mStab			= true;
				}
			
				//---------------------------------------------------
				//	FPLAY StatusFe
				//---------------------------------------------------
				{
					//	FPLAY StatusFe픻l  PLAYER 1
					{
						//	FPLAY StatusFSCORE
						//	FPLAY StatusFJustGreat
						//	FPLAY StatusFGreat
						//	FPLAY StatusFgood
						//	FPLAY StatusFbad
						//	FPLAY StatusFpoor
						//	FPLAY StatusFmax combo
						//	FPLAY StatusFTotal
						for( i = 0; i < ABVAItemBindStageFinish::M_SET_TYPE_COUNT; i++ ){
							ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite, ABVA_ITEM_ID_FINISH_SPRITE_SCORE_P1 + i );
							item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player1.mValue[ i ] ) );
							item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_PlayData;
							item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Result;		//	fontNumberFontTypew肷ׂSCHEME
							item->mTextMaxLength= 6;
							item->mUseFont= true;
							item->mSurface			= this->m_fontTexture;
							memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
							item->mString.assign( "0123456789" );
						}
					}
					//	FPLAY StatusFe픻l  PLAYER 2
					{
						//	FPLAY StatusFSCORE
						//	FPLAY StatusFJustGreat
						//	FPLAY StatusFGreat
						//	FPLAY StatusFgood
						//	FPLAY StatusFbad
						//	FPLAY StatusFpoor
						//	FPLAY StatusFmax combo
						//	FPLAY StatusFTotal
						for( i = 0; i < ABVAItemBindStageFinish::M_SET_TYPE_COUNT; i++ ){
							ABVAItemTextSprite*		item = inSetupper.addData( new ABVAItemTextSprite, ABVA_ITEM_ID_FINISH_SPRITE_SCORE_P2 + i  );
							item->setDynamicBinder( new ABVAItemDynamicBinder( ABVA_ITEM_DYNAMIC_BIND_TEXT, ABVA_ITEM_DYNAMIC_BIND_TYPE_CSTRING, inBinder->mPramam.Player2.mValue[ i ] ) );
							item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_PlayData;
							item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= SCH_NID_Result;		//	fontNumberFontTypew肷ׂSCHEME
							item->mTextMaxLength= 6;
							item->mUseFont= true;
							item->mSurface			= this->m_fontTexture;
							memcpy( item->mFont, this->m_resFont, sizeof( item->mFont ) );
							item->mString.assign( "0123456789" );
						}
					}
				} //	for
			} //	XRA
		}
	}

	//	ÓIȃACe	Xe[WNAFi
	{ 
		ABVAItemResImage*	texture;
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			texture = item;

			item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_StageClear;
			item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
		}

		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_FINISH_SPRITE_COMPLETE );
			
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Clear;
			item->mSurface			= texture;
			item->mVisible = false;
		}
	}
	//	ÓIȃACe	Xe[WNAFi
	{ 
		ABVAItemResImage*	texture;
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			texture = item;

			item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_StageFailed;
			item->mTransparentType = GE_BMP_TRANSPARENT_WHITE;
		}

		{
			ABVAItemSprite*		item = inSetupper.addData( new ABVAItemSprite, ABVA_ITEM_ID_FINISH_SPRITE_FAILED );
			
			item->mKeyID[ABMB_ADAPTER_ITEM_SCHEME_KEY]		= SCH_Failed;
			item->mSurface			= texture;
			item->mVisible = false;
		}
	}
}


//-------------------------------------------------------------------
//	create font
//-------------------------------------------------------------------
void	ABMBVAItemPreset::setupFont( ABVASchemeSetupper&  inSetupper ) throw( std::bad_alloc )
{
	ABint	i;
	
	{
		//	io[IuWFNgƌĂ΂镨́AABł̓tHgƂĕ\B
		//	̎͐VSCHEMEASCIIR[hBMP\T|[gĂB

		//	tHg摜
		{
			ABVAItemResImage*		item = inSetupper.addData( new ABVAItemResImage );
			this->m_fontTexture = item;

			item->mKeyID[ABMB_ADAPTER_ITEM_RES_NUMBER]		= ResPict_Numbers;
			item->mTransparentType = GE_BMP_TRANSPARENT_BLACK;
		}

		//	tHg
		ABint	surfIndex[] = { '0','1','2','3','4','5','6','7','8','9' };	//@l 0`9 ɊYAASCIIR[h 0`9
		ABMBSchemeDataKey		subSchemeKey[] = {
			SCH_sNumber1, 
			SCH_sNumber2, 
			SCH_sNumber3, 
			SCH_sNumber4
		};

		for( i = 0; i < sizeof(subSchemeKey) / sizeof(ABMBSchemeDataKey) ; i++ ){

			ABVAItemResFont*		item = inSetupper.addData( new ABVAItemResFont );
			item->mKeyID[ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY]	= subSchemeKey[i];
			this->m_resFont[ i ] = item;

			//	ASCIIR[h\쐬
			for( ABint j = 0; j < ( sizeof(surfIndex) / sizeof(ABint) ) ; j++ ){
				//	ACe̒當Q
				ABVAItemResFont::MFont*		font = &item->mFontMapTable[ surfIndex[j] ];

				//	ObhWw肷BPObh́AZ̃TCYitHg蓖ĂeLXgXvCg̑̕傫Ɉˑj
				//
				//	摜ƈv悤ɃZWw肵܂B
				//	@̏ꍇ́AɁ@0`9@ł邾Ȃ̂ŁÂ悤Ɏw肵܂B
				//	@摜͈ɂȂĂ邱ƂL܂AtHg͕ʁXɗpӂȂ΂Ȃ܂B
				//
				font->enable = true;	//	falseɂƉ\Ȃ
				font->cellX	= j;		//	surface摜̈ʒuBPZ̑傫́ASCH_sNumber*ɂĎw肷B
				font->cellY	= 0;		//	y0BSCH_sNumber*YWItZbgƂĎw肷B
			}
		}
	}
}
