/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVASchemeAdapter.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABMBVASchemeAdapter.h"
#include	"ABMBVAItemPreset.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABMBVASchemeAdapter::ABMBVASchemeAdapter( ABMBScheme&  inScheme )
:
	m_scheme( inScheme )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABMBVASchemeAdapter::~ABMBVASchemeAdapter( void )
{
}

//-------------------------------------------------------------------------------------------------
//	read scheme set
//-------------------------------------------------------------------------------------------------
ABbool	ABMBVASchemeAdapter::readScheme( ABVARunner&  inRunner, ABuint  inMode, ABMBSchemeSet*  inScemeSet )
{
	ABuint	max = inRunner.getListSize();
	ABuint	i;
	ABVAItemList*	itemList;
	ABVAItemListIt	it;
	ABVAItem*		item;
	
	
	for( i = 0 ; i < max; i ++ ){
		itemList = inRunner.getList( i );
		
		for( it = itemList->begin(); it != itemList->end(); it++ ){
			item = *it;
			this->setItem( item, inMode, inScemeSet );
		}
	}

	return	true;
}

//-------------------------------------------------------------------------------------------------
//	setItem
//-------------------------------------------------------------------------------------------------
ABbool	ABMBVASchemeAdapter::setItem( ABVAItem*  inItem, ABuint  inMode, ABMBSchemeSet*  inScemeSet )
{
	ABbool	ret;
	
	//	ICastFNULLỸNXInstanceł͖̂ŏ𖳎

	ret = this->setItemDrawText( inMode, inScemeSet, dynamic_cast<ABVAItemTextSprite*>(inItem) );
	if( ret ){ return ret; }

	ret = this->setItemDrawSprite( inMode, inScemeSet, dynamic_cast<ABVAItemSprite*>(inItem) );
	if( ret ){ return ret; }

	ret = this->setItemResSurface( inMode, inScemeSet, dynamic_cast<ABVAItemResImage*>(inItem) );
	if( ret ){ return ret; }

	ret = this->setItemResFont( inMode, inScemeSet, dynamic_cast<ABVAItemResFont*>(inItem) );
	if( ret ){ return ret; }

	ret = this->setItemAnimation( inMode, inScemeSet, dynamic_cast<ABVAItemAnimation*>(inItem) );
	if( ret ){ return ret; }

	ret = this->setItemValue( inMode, inScemeSet, dynamic_cast<ABVAItemData*>(inItem) );
	if( ret ){ return ret; }

//	ret = this->setItemArray( inScemeSet, dynamic_cast<ABVAItemArray*>(inItem) );
//	if( ! ret ){ return ret; }
	
	return	false;
}

//-------------------------------------------------------
//	ABVAItemSprite
//-------------------------------------------------------
bool	ABMBVASchemeAdapter::setItemDrawSprite( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemSprite*  inItem )
{
	if( inItem == NULL){
		return	false;
	}
	else{
		//	{
		this->setBasicData( inMode, inScemeSet, inItem );
		return	true;
	}
}
//-------------------------------------------------------
//	ABVAItemTextSprite
//-------------------------------------------------------
bool	ABMBVASchemeAdapter::setItemDrawText( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemTextSprite*  inItem )
{
	if( inItem == NULL){
		return	false;
	}
	else{
		//	{
		this->setBasicData( inMode, inScemeSet, inItem );
		return	true;
	}
}

//-------------------------------------------------------
//	ABVAItemResImage
//-------------------------------------------------------
bool	ABMBVASchemeAdapter::setItemResSurface( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemResImage*  inItem )
{
	ABint				resNumber;
	ABMBSchemeResource*	schemeRes;

	if( inItem == NULL){
		return	false;
	}
	else{
		//	BMPobt@̃|C^擾
		resNumber = inItem->mKeyID[ ABMB_ADAPTER_ITEM_RES_NUMBER ];
		schemeRes = inScemeSet->getResource( inMode, resNumber );
		if( schemeRes->name[0] ){
			return	inItem->mFileInfo.copy( schemeRes->file );
		}
		else{
			//	gp
			inItem->mStab = true;
		}

		ABint	optionKeyNum= inItem->mKeyID[ ABMB_ADAPTER_ITEM_OPTION_SCHEME_KEY ];//	IvVL[
		//	IvVǂݎ
		if( 0 <= optionKeyNum ){
			ABMBSchemeElement*	subElement = inScemeSet->getElement( inMode, optionKeyNum );	//	"#s..."
			if( subElement->sxFlag == AB_SCHEME_WORD_VALUE_YES ){
				inItem->mTransparentType = GE_BMP_TRANSPARENT_BLACK;
			}
			else if( subElement->syFlag == AB_SCHEME_WORD_VALUE_YES ){
				inItem->mTransparentType = GE_BMP_TRANSPARENT_ALPHA;
			}
			else{
				inItem->mTransparentType = GE_BMP_TRANSPARENT_NONE;
			}
		}
		
		return	true;
	}
}
//-------------------------------------------------------
//	ABVAItemResFont
//-------------------------------------------------------
bool	ABMBVASchemeAdapter::setItemResFont( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemResFont*  inItem )
{
	if( inItem == NULL){
		return	false;
	}
	else{
		//	{
		this->setBasicData( inMode, inScemeSet, inItem );
		return	true;
	}
}

//-------------------------------------------------------
//	ABVAItemAnimation
//-------------------------------------------------------
bool	ABMBVASchemeAdapter::setItemAnimation( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemAnimation*  inItem )
{
	if( inItem == NULL){
		return	false;
	}
	else{
		////	{
		//this->setBasicData( inMode, inScemeSet, inItem );

		//	Aj[V
		ABMBSchemeElement*	element;
		ABint				keyNum = inItem->mKeyID[ ABMB_ADAPTER_ITEM_ANIMATION_KEY ];
		if( 0 <= keyNum ){
			ABint		h = 0, w = 0, x = 0, y = 0;
			element	= inScemeSet->getElement( inMode, keyNum );	//	"#s..."
			//	ABMB_ADAPTER_ITEM_SCHEME_KEYƂĎ擾
			this->getElementData( ABMB_ADAPTER_ITEM_SCHEME_KEY, element, &inItem->flag, &x, &y, &w, &h );

			inItem->mFrameCountMax		= w;
			inItem->mBPMSyncRate		= h;
			inItem->mFrameTimeMax		= x;
			inItem->mTrueIsReversePlay	= inItem->flag.flagSpriteAnimationRevers;
		}

		return	true;
	}
}

//-------------------------------------------------------
//	ABVAItemData
//-------------------------------------------------------
bool	ABMBVASchemeAdapter::setItemValue( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemData*  inItem )
{
	if( inItem == NULL){
		return	false;
	}
	else{
		//	{
		this->setBasicData( inMode, inScemeSet, inItem );
		return	true;
	}
}
/*
//-------------------------------------------------------
//	ABVAItemArray
//-------------------------------------------------------
bool	ABMBVASchemeAdapter::setItemArray( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItemArray*  inItem )
{
	if( inItem == NULL){
		return	false;
	}
	else{
		//	itemz
		ABVAItemBase*	item 		= NULL;
		ABVAItemBase*	firstItem	= NULL;
		GEint	sp;

		firstItem = inItem->getItem( 0 );
		for( sp = 0; sp < inItem->getItemCount(); sp++ ){
			item = inItem->getItem( sp );
			this->setItem( inScemeSet, inMode, item );
			
			//	W
			switch( inItem->msurfaceLayout ){
				case ABVAItemArray::M_SURFACE_LAYOUT_LIST: 
				case ABVAItemArray::M_SURFACE_LAYOUT_LIST_2COL:
					{
						item->mSchemeData.py	= firstItem->mSchemeData.py + firstItem->mSubSchemeData.height * sp;
						item->mSubSchemeData.px	= 0;
						item->mSubSchemeData.py	= firstItem->mSubSchemeData.height * sp;
					}
					break;
				case ABVAItemArray::M_SURFACE_LAYOUT_LIST_2COLONLY:
					{
						item->mSchemeData.py	= firstItem->mSchemeData.py + firstItem->mSubSchemeData.height * sp;
						item->mSubSchemeData.px	= firstItem->mSubSchemeData.width;
						item->mSubSchemeData.py	= firstItem->mSubSchemeData.height * sp;
					}
					break;
					
				case ABVAItemArray::M_SURFACE_LAYOUT_LIST_COLONLY:
					{
						item->mSubSchemeData.px	= firstItem->mSubSchemeData.width * sp;
						item->mSubSchemeData.py	= 0;
					}
					break;
				case ABVAItemArray::M_SURFACE_LAYOUT_X:
					{
						item->mSchemeData.px	= firstItem->mSchemeData.px + firstItem->mSubSchemeData.width * sp;
					}
					break;
				case ABVAItemArray::M_SURFACE_LAYOUT_X_HALF:
					{
						item->mSchemeData.px	= firstItem->mSchemeData.px + ( firstItem->mSubSchemeData.width / 2 )* sp;
					}
					break;
				case ABVAItemArray::M_SURFACE_LAYOUT_NOTHING:
				default:
					break;
			}
		}
		return	true;
	}
}
*/

/////////////////////////////////////////////////////////
//	set basic data
/////////////////////////////////////////////////////////
void	ABMBVASchemeAdapter::setBasicData( ABuint  inMode, ABMBSchemeSetPtr  inScemeSet, ABVAItem*  inItem ) 
{
	ABMBSchemeElement*	element;
	ABMBSchemeElement*	subElement;
//	ABMBSchemeElement*	animatorElement;
	ABint		keyNum, subKeyNum;
	ABint		h = 0, w = 0, x = 0, y = 0;
	ABint		sh = 0, sw = 0, sx = 0, sy = 0;

	keyNum		= inItem->mKeyID[ ABMB_ADAPTER_ITEM_SCHEME_KEY ];		//	CL[
	subKeyNum	= inItem->mKeyID[ ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY ];	//	TuL[

	//	CL[ǂݎ
	//		EɃXvCg̑傫EW̎擾B
	if( 0 <= keyNum ){
		element		= inScemeSet->getElement( inMode, keyNum );
		this->getElementData( ABMB_ADAPTER_ITEM_SCHEME_KEY, element, &inItem->flag, &x, &y, &w, &h );
		
		//	MacBeatNowLoading(SCH_LoadBMS)擾̂߂̃tOij
		if( inItem->flag.trueIsRequireBMPsize ){
			inItem->flag.flagSpriteSizeAuto = true;
		}
	}
	
	//	TuL[ǂݎ
	//		Eɉ摜t@C̑傫AZW̎擾B
	if( 0 <= subKeyNum ){
		subElement		= inScemeSet->getElement( inMode, subKeyNum );	//	"#s..."
		this->getElementData( ABMB_ADAPTER_ITEM_SUB_SCHEME_KEY, subElement, &inItem->flag, &sx, &sy, &sw, &sh );
	}
	
	//	XvCgACeɑ΂ݒ (pĂ鏇Ԃdv)
	ABVAItemSprite*		spriteItem = dynamic_cast<ABVAItemSprite*>(inItem);
	ABVAItemTextSprite*	textSpriteItem = dynamic_cast<ABVAItemTextSprite*>(inItem);
	if( NULL != textSpriteItem ){

		//	CL[w莞
		if( 0 <= keyNum ){

			textSpriteItem->mLocation.x = x;
			textSpriteItem->mLocation.y = y;
			
			if( ! inItem->flag.flagSpriteSizeAuto ){
				if( w != 0 ){
					spriteItem->mWidth	= w;
				}
				if( h != 0 ){
					spriteItem->mHeight	= h;
				}
			}
		}
		//	TuL[w莞
		if( 0 <= subKeyNum ){
			//	tHge[uI
			if( textSpriteItem->mUseFont ){
				//	TuXL[̉TCYtB[hQƂȂ΂ȂȂ
				textSpriteItem->mFontTableNumber = sw - 1;
			}
			else{
				//	ʒuẅׂɉ̂TCYgp
				textSpriteItem->mLocation.x += sw;
				textSpriteItem->mLocation.y += sy;
			}
		}
		
	}
	else if( NULL != spriteItem ){
		//	CL[w莞
		if( 0 <= keyNum ){

			spriteItem->mLocation.x = x;
			spriteItem->mLocation.y = y;
			
			if( ! inItem->flag.flagSpriteSizeAuto ){
				spriteItem->mWidth	= w;
				spriteItem->mHeight	= h;
			}
		}
		//	TuL[w莞
		if( 0 <= subKeyNum ){
			spriteItem->mCellWidth		= sw;		//	size
			spriteItem->mCellHeight		= sh;		//	size
			spriteItem->mCellLeft		= sx;		//	ZW
			spriteItem->mCellTop		= sy;		//	ZW
		}
	}

	ABVAItemResFont*	fontItem = dynamic_cast<ABVAItemResFont*>(inItem);
	if( NULL != fontItem ){
		//	TuL[w莞
		if( 0 <= subKeyNum ){
			fontItem->mCellWidth		= sw;		//	size
			fontItem->mCellHeight		= sh;		//	size
			fontItem->mCellLeft			= sx;		//	ZW
			fontItem->mCellTop			= sy;		//	ZW
		}
	}

}

/////////////////////////////////////////////////////////
//	get sprite data
/////////////////////////////////////////////////////////
void	ABMBVASchemeAdapter::getElementData( 
	ABuint		inType,
	ABMBSchemeElement*		inElement,
	ABVAItem::attribute*	inItem,
	ABint*		outx,
	ABint*		outy,
	ABint*		outw,
	ABint*		outh
){
	ABMBSchemeElement*			element	 = inElement;
	bool	setFlagSX = true;
	bool	setFlagSY = true;
	bool	setFlagPX = true;
	bool	setFlagPY = true;

	//	e`tOݒo
	switch( element->sxFlag ){
		case	AB_SCHEME_WORD_VALUE:
		case	AB_SCHEME_WORD_VALUE_NONE:
				//	ݒsv
				break;
		case	AB_SCHEME_WORD_VALUE_AUTO:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteSizeAuto		= true;
				}
				break;
		case	AB_SCHEME_WORD_VALUE_CENTER:
				break;
		case	AB_SCHEME_WORD_VALUE_TRUE:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagOptional		= true;
				}
				break;
		case	AB_SCHEME_WORD_VALUE_FALSE:
				break;
		case	AB_SCHEME_WORD_VALUE_YES:
				break;
		case	AB_SCHEME_WORD_VALUE_NO:
				break;
		case	AB_SCHEME_WORD_VALUE_HIDE:
				break;
		default:
				setFlagSX = false;
				break;
	}
	switch( element->syFlag ){
		case	AB_SCHEME_WORD_VALUE:
		case	AB_SCHEME_WORD_VALUE_NONE:
				//	ݒsv
				break;
		case	AB_SCHEME_WORD_VALUE_AUTO:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteSizeAuto		= true;
				}
				break;
		case	AB_SCHEME_WORD_VALUE_CENTER:
				break;
		case	AB_SCHEME_WORD_VALUE_TRUE:
				break;
		case	AB_SCHEME_WORD_VALUE_FALSE:
				break;
		case	AB_SCHEME_WORD_VALUE_YES:
				break;
		case	AB_SCHEME_WORD_VALUE_NO:
				break;
		case	AB_SCHEME_WORD_VALUE_HIDE:
				break;
		default:
				setFlagSY = false;
				break;
	}
	switch( element->pxFlag ){
		case	AB_SCHEME_WORD_VALUE:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteVisible			= true;
				}
		case	AB_SCHEME_WORD_VALUE_NONE:
				//	ݒsv
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteLocationCenterX		= false;
				}
				break;
		case	AB_SCHEME_WORD_VALUE_AUTO:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteLocationAuto		= true;
				}
				break;
		case	AB_SCHEME_WORD_VALUE_CENTER:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteLocationCenterX	= true;
				}
				break;
		case	AB_SCHEME_WORD_VALUE_TRUE:
				break;
		case	AB_SCHEME_WORD_VALUE_FALSE:
				break;
		case	AB_SCHEME_WORD_VALUE_YES:
				break;
		case	AB_SCHEME_WORD_VALUE_NO:
				break;
		case	AB_SCHEME_WORD_VALUE_HIDE:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteVisible			= false;
				}
				break;
		default:
				setFlagPX = false;
				break;
	}
	switch( element->pyFlag ){
		case	AB_SCHEME_WORD_VALUE:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteVisible			= true;
				}
				break;
		case	AB_SCHEME_WORD_VALUE_NONE:
				//	ݒsv
				break;
		case	AB_SCHEME_WORD_VALUE_AUTO:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteLocationAuto		= true;
				}
				break;
		case	AB_SCHEME_WORD_VALUE_CENTER:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					//	MacBeatł͏cZ^O͖Hg@\B
					inItem->flagSpriteLocationCenterY	= true;
				}
				break;
		case	AB_SCHEME_WORD_VALUE_TRUE:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteAnimationRevers	= true;
				}
				break;
		case	AB_SCHEME_WORD_VALUE_FALSE:
				break;
		case	AB_SCHEME_WORD_VALUE_YES:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteLocationMirrorX	= true;	//	ʒEɂĉEɔzu
				}
				break;
		case	AB_SCHEME_WORD_VALUE_NO:
				break;
		case	AB_SCHEME_WORD_VALUE_HIDE:
				if( inType == ABMB_ADAPTER_ITEM_SCHEME_KEY ){
					inItem->flagSpriteVisible			= false;
				}
				break;
		default:
				setFlagPY = false;
				break;
	}
	
//	if( element->resize == AB_SCHEME_WORD_VALUE_YES ){
//		inItem->flagAutoReSize	= true;
//	}

	*outw = 0;
	*outh = 0;
	*outx = 0;
	*outy = 0;
	if( setFlagSX && element->sx != 0 ){
		*outw = element->sx;
	}
	if( setFlagSY && element->sy != 0 ){
		*outh = element->sy;
	}
	if( setFlagPX && element->px != 0 ){
		*outx = element->px;
	}
	if( setFlagPY && element->py != 0 ){
		*outy = element->py;
	}
}
