/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemRenderConfigration.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"GameString.h"

#include	"ABMBVAItemPreset.h"

#include	"ABMBVAItemRenderConfigration.h"
#include	"ABVARunner.h"

#include	"ABVAItemTextSprite.h"
#include	"ABSingleton.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABMBVAItemRenderConfigration
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderConfigration::ABMBVAItemRenderConfigration( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderConfigration::~ABMBVAItemRenderConfigration( void )
{
}

//-------------------------------------------------------------------------------------------------
//	
//-------------------------------------------------------------------------------------------------
ABbool	ABMBVAItemRenderConfigration::initialize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	//	CAEg𐮂A񃉃x\܂
	ABVAItemBindConfigration*	binder = static_cast<ABVAItemBindConfigration*>(inBinder);
	ABuint	i;
	
	ABuint	countLabel = inRunner->getInstanceCount( ABVA_ITEM_ID_CONFIG_MENU_CONTROL );
	ABuint	countValue = inRunner->getInstanceCount( ABVA_ITEM_ID_CONFIG_MENU_VALUE );

	for( i = 0 ; i < countLabel; i ++ ){
		//	j[InstanceQ
		ABVAItemTextSpriteObject*	obj = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_ENTRANCE_MENU_CONTROL, i ));

		//	ݒ
		ABint8*		text = ABConfigCaptionArray::getLabelCaption( i );
		if( text[0] ){
			//	jR[hϊ
			GameString	str;
			str.setCString( text, kCFStringEncodingASCII );
			//	eNX`ɕ`
			obj->mText->draw( str.get() );
		}
		else{
			//	l\ȂsȂ̂ŁAB
			obj->mText->mSprite.m_visible = false;
		}
		
		//	CAEgݒ
		obj->mText->mSprite.m_locate.y += obj->mText->mSprite.m_height * i;
		
		//	XvCgXV܂BĂ΂Ȃƕ\ς܂B
		obj->mText->mSprite.update();
	}
	
	for( i = 0 ; i < countValue; i ++ ){
		//	j[InstanceQ
		ABVAItemTextSpriteObject*	obj = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_CONFIG_MENU_VALUE, i ));
		ABVAItem*					item = obj->getArchitecture();

		switch( i ){
			case AB_OPTION_RESET:
			case AB_MENU_OK:
			case AB_MENU_CANCEL:
				//	l\ȂsȂ̂ŁAB
				obj->mText->mSprite.m_visible = false;
				break;
			default:
				ABint8*		text = ABConfigCaptionArray::getLabelCaption( i );
				if( text[0] == 0 ){
					//	l\ȂsȂ̂ŁAB
					obj->mText->mSprite.m_visible = false;
				}
				break;
		}
		
		//	CAEgݒ
		obj->mText->mSprite.m_locate.y += obj->mText->mSprite.m_height * i;
		
		//	XvCgXV܂BĂ΂Ȃƕ\ς܂B
		obj->mText->mSprite.update();
	}

	this->render( inRunner, inBinder );
	return true;
}

//-------------------------------------------------------------------------------------------------
//	I
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderConfigration::finalize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
}

//-------------------------------------------------------------------------------------------------
//	Render
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderConfigration::render( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABVAItemBindConfigration*	binder = static_cast<ABVAItemBindConfigration*>(inBinder);
	ABGamePreference::Config&	config = ABGetPreference().playConfig;	
	ABuint	i;
	static	ABint8*	value1[] = {
		"OFF",	//	false ( = 0 )
		"ON",	//	true  ( = 1 )
	};
	static	ABint8*	value2[] = {
		" 320 x  240", 	//	AB_SCREEN_SIZE_MODE_320_240		= 0,
		" 640 x  480",	//	AB_SCREEN_SIZE_MODE_640_480		= 1,
		" 800 x  600",	//	AB_SCREEN_SIZE_MODE_800_600		= 2,
		"1024 x  768",	//	AB_SCREEN_SIZE_MODE_1024_768	= 3,
		"1280 x 1024",	//	AB_SCREEN_SIZE_MODE_1280_1024	= 4,
	};
	static	ABint8*	value3[] = {
		"MANUAL PLAY", 			//	AB_AUTO_PLAY_TYPE_NONE				= 0,
		"ALL TRACKS",	 		//	AB_AUTO_PLAY_TYPE_ALL				= 1,
		"KEY TRACKS ONLY", 		//	AB_AUTO_PLAY_TYPE_KEY_TRACKS		= 3,
		"SCRATCH TRACK ONLY", 	//	AB_AUTO_PLAY_TYPE_SCRATCH_TRACKS	= 4,
	};
	static	ABint8*	value4[] = {
		"",			//	0
		"MONO",		//	1
		"STEREO",	//	2
	};
	ABint8	valueText[ 128 ];

	
	ABuint	countLabel = inRunner->getInstanceCount( ABVA_ITEM_ID_CONFIG_MENU_CONTROL );
	ABuint	countValue = inRunner->getInstanceCount( ABVA_ITEM_ID_CONFIG_MENU_VALUE );

	for( i = 0 ; i < countLabel; i ++ ){
		//	j[InstanceQ
		ABVAItemTextSpriteObject*	obj = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_ENTRANCE_MENU_CONTROL, i ));

		//	FύX
		if( binder->mSelectMenuIndex == i ){
			//	IԂ̃j[B
			obj->mText->mSprite.m_color.set( 255, 204, 0, 255 );
		}
		else{
			//	IԂ̃j[B
			obj->mText->mSprite.m_color.set( 255, 255, 255, 128 );
		}
		
		//	XvCgXV܂BĂ΂Ȃƕ\ς܂B
		obj->mText->mSprite.update();
	}
	
	for( i = 0 ; i < countValue; i ++ ){
		//	j[InstanceQ
		ABVAItemTextSpriteObject*	obj = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_CONFIG_MENU_VALUE, i ));
		ABVAItem*					item = obj->getArchitecture();

		//	FύX
		if( binder->mSelectMenuIndex == i ){
			//	IԂ̃j[B
			obj->mText->mSprite.m_color.set( 255, 204, 0, 255 );
		}
		else{
			//	IԂ̃j[B
			obj->mText->mSprite.m_color.set( 255, 255, 255, 128 );
		}
		
		//	l\
		valueText[0] = 0;
		switch( i ){
			case AB_OPTION_Volume:
				snprintf( valueText, sizeof(valueText), "%3d%", config.masterVolume );
				break;
			case AB_OPTION_IsSE:
				snprintf( valueText, sizeof(valueText), "%4s", value1[ ( config.trueIsUseSoundReverb ? 1 : 0 ) ] );
				break;
				
			case AB_OPTION_IsIgnorePoor:
				snprintf( valueText, sizeof(valueText), "%4s", value1[ ( config.trueIsUseIgnorePoor ? 1 : 0 ) ] );
				break;
			case AB_OPTION_ComboLevel:
				snprintf( valueText, sizeof(valueText), "%4s", value1[ ( config.trueIsUseCombo ? 1 : 0 ) ] );
				break;
			case AB_OPTION_HiSpeedLevel:
				snprintf( valueText, sizeof(valueText), "x%2.2f", config.hiSpeedRate );
				break;

			case AB_OPTION_LAYOUT_CENTER_PLAY:
				snprintf( valueText, sizeof(valueText), "%4s", value1[ ( config.trueIsUseCenterLayout ? 1 : 0 ) ] );
				break;
			case AB_OPTION_AUTO_PLAY_P1:
				snprintf( valueText, sizeof(valueText), "%16s", value3[ config.autoPlayMode[ 0 ] ] );
				break;
			case AB_OPTION_AUTO_PLAY_P2:
				snprintf( valueText, sizeof(valueText), "%16s", value3[ config.autoPlayMode[ 1 ] ] );
				break;

			case AB_OPTION_All7Keys:
				snprintf( valueText, sizeof(valueText), "%4s", value1[ ( config.trueIsUseAll7keyMode ? 1 : 0 ) ] );
				break;
			case AB_OPTION_ScreenSize:
				snprintf( valueText, sizeof(valueText), "%s", value2[ config.screenMode ] );
				break;
			case AB_OPTION_Scheme:
				snprintf( valueText, sizeof(valueText), "%s", config.schemeFolder );
				break;
			case AB_OPTION_SchemeSet:
			
				{
					ABGamePreference&		preference = ABGetPreference();
					if( preference.selectSchemePtr ){
						snprintf( valueText, sizeof(valueText), "[%3d] %-24s", config.schemeNumber + 1, preference.selectSchemePtr->scemeInfo.name );
					}
					else{
						snprintf( valueText, sizeof(valueText), "[%3d] ERROR", config.schemeNumber + 1 );
					}
				}
				break;

			case AB_OPTION_SOUND_SAMPLE_RATE:
				snprintf( valueText, sizeof(valueText), "%5.1fHz", (ABfloat32)AbConfigGetSampleRate( config.soundSampleRate ) );
				break;
			case AB_OPTION_SOUND_CHANNEL_COUNT:
				snprintf( valueText, sizeof(valueText), "%s", value4[config.soundChannelMode] );
				break;
			case AB_OPTION_DRAW_FRAME_RATE:
				snprintf( valueText, sizeof(valueText), "%2d", AbConfigGetDrawFrameRate(config.drawFrameRate) );
				break;

			case AB_OPTION_SOUND_CACHE_SIZE:
				snprintf( valueText, sizeof(valueText), "%8dMB", config.cacheSize / (1024 * 1024) );
				break;
		}
		if( valueText[0] ){
			//	jR[hϊ
			GameString	str;
			str.setCString( valueText, GS_ENCORDING_SHIT_JIS );
			//	eNX`ɕ`
			obj->mText->draw( str.get() );
		}
		

		//	XvCgXV܂BĂ΂Ȃƕ\ς܂B
		obj->mText->mSprite.update();
	}

}

