/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemRenderList.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABMBVAItemRenderList.h"
#include	"ABVARunner.h"
#include	"ABVARunner.h"
#include	"ABVAItemConfig.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABMBVAItemRenderList
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderList::ABMBVAItemRenderList( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderList::~ABMBVAItemRenderList( void )
{
}

//-------------------------------------------------------------------------------------------------
//	
//-------------------------------------------------------------------------------------------------
ABbool	ABMBVAItemRenderList::initialize(
		ABVARunner*  inRunner, 
		ABVAItemBinder*  inBinder,
		ABVAListDataFillFunc		inFillFunc, 
		ABVAListDataRowEnterFunc	inRowEnterFunc,
		void*  inUserData, ABint	inListRowCount 
){
	ABbool	ret = false;

	mBmsListOffset	= 0;
	mScrollMode		= M_SCROLL_NONE;
	mScrollPosition	= 0;
	mListHeadBMSIndex	= 0;
	mListHeadViewRow= 0;
	mHiSpeedScroolCounter	= M_REQUIRE_DATA_NOTHING;
	mRequireData	= 0;
	mBmsListFillFunc	= NULL;
	mBmsListRowEnter	= NULL;
	mBmsListFillFuncUserData = NULL;

	this->mRequireData = M_REQUIRE_DATA_FILL;
	this->mBmsListFillFunc = inFillFunc;
	this->mBmsListRowEnter = inRowEnterFunc;
	this->mBmsListFillFuncUserData = inUserData;
	this->mListRowCount = inListRowCount;

	return ret;
}

//-------------------------------------------------------------------------------------------------
//	I
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderList::finalize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
}

//-------------------------------------------------------------------------------------------------
//	Render
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderList::render( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABint	i;
	ABint	pos = 0;
	ABint	area = 0;
	ABint	colorMode = 0;
	ABint	targetRow = 0;
	
	ABint	objCount = inRunner->getInstanceCount( this->mRowTextSpriteObjectKey );

	ABint8	buffer1[ M_LIST_ROW_TEXT_SIZE ];

	ABVAItemTextSpriteObject*	objRow;

	//--------------------------------------
	//	ACe̒ǉ
	//--------------------------------------
	switch( this->mRequireData ){
	
		case M_REQUIRE_DATA_FILL:		
			//	߂悤߂Ă
		
			//	lŖ߂
			{
				//	 0, 1, 2, 3, 4, 5, 6, 7, 8,....
				//	95,96,97,98,99, 0, 1, 2, 3.....
			
				this->mScrollPosition	= this->mRowHeight * this->mTaegetRow;
				this->mListHeadBMSIndex	= (this->mListTargetRow + this->mListRowCount - this->mTaegetRow) % this->mListRowCount;
				this->mListHeadViewRow	= objCount - this->mTaegetRow;

				for( i = 0 ; i < objCount; i ++ ){
					ABint	dataInedx	= 0;
					if( (this->mTaegetRow + i) < objCount ){
						dataInedx = (this->mListTargetRow + i) % this->mListRowCount;
					}
					else{
						dataInedx = (this->mListTargetRow + (this->mListRowCount - (objCount - i ))) % this->mListRowCount;
					}
				
					//	R[obNŁAeLXgf[^ႤB
					this->mBmsListFillFunc( dataInedx, this->mBmsListFillFuncUserData, buffer1, M_LIST_ROW_TEXT_SIZE );

					//	\
					objRow = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( this->mRowTextSpriteObjectKey, i ));

					//	Font{tHgłȂꍇ܂
					GameString	str;
					str.setCString( buffer1, GS_ENCORDING_SHIT_JIS );
//					ABint8		rowNumber[8];
//					sprintf( rowNumber, "%d", dataInedx );
//					str.setCString( rowNumber, GS_ENCORDING_SHIT_JIS );
					objRow->mText->draw( str.get() );
				}
			}
			this->mRequireData = M_REQUIRE_DATA_NOTHING;

			//	sIR[obN(cancel͖)
			this->mBmsListRowEnter( 0, this->mListTargetRow, this->mBmsListFillFuncUserData );
			break;

		case M_REQUIRE_DATA_UPPER:		
			//	㑤Ɉǉ悤߂Ă
			{
				ABint	row =  this->mListHeadViewRow ;
				//	R[obNŁAeLXgf[^ႤB
				this->mBmsListFillFunc( this->mListHeadBMSIndex, this->mBmsListFillFuncUserData, buffer1, M_LIST_ROW_TEXT_SIZE );

				//	\
				objRow = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( this->mRowTextSpriteObjectKey, row ));

				//	Font{tHgłȂꍇ܂
				GameString	str;
				str.setCString( buffer1, GS_ENCORDING_SHIT_JIS );
				objRow->mText->draw( str.get() );
			}
			this->mRequireData = M_REQUIRE_DATA_NOTHING;
			break;

		case M_REQUIRE_DATA_LOWER:		
			//	Ɉǉ悤߂Ă
			{
				ABint	row1 =  (this->mListHeadViewRow + objCount - 2 ) % objCount ;
				ABint	bmsIndex =  (this->mListHeadBMSIndex + objCount - 2 ) % this->mListRowCount ;

				//	R[obNŁAeLXgf[^ႤB
				this->mBmsListFillFunc( bmsIndex, this->mBmsListFillFuncUserData, buffer1, M_LIST_ROW_TEXT_SIZE );

				//	\
				objRow = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( this->mRowTextSpriteObjectKey, row1 ));

				//	Font{tHgłȂꍇ܂
				GameString	str;
				ABbool	ret = str.setCString( buffer1, GS_ENCORDING_SHIT_JIS );
				if( !ret ){
					str.setCString( buffer1, GS_ENCORDING_ASCII );
				}
//					ABint8		rowNumber[8];
//					sprintf( rowNumber, "%d / %d, %d / %d", row1, objCount, row2, this->mListRowCount );
//					str.setCString( rowNumber, GS_ENCORDING_SHIT_JIS );
				objRow->mText->draw( str.get() );
			}
			this->mRequireData = M_REQUIRE_DATA_NOTHING;
			break;

		default:
			break;
	}
	
	//--------------------------------------
	//	Xg\Ɍ悤ACezu
	//--------------------------------------
	ABint	areaTop		= this->mArea.top;
	ABint	areaBottom	= this->mArea.top + this->mArea.height;
	ABint	areaRight	= this->mArea.left + this->mArea.width;
	
	//	Izsԍ\sԍɕϊ
	targetRow = this->mListHeadViewRow + this->mTaegetRow;
	targetRow %= objCount;
	
	pos		= areaTop + this->mScrollPosition;
	area	= objCount * this->mRowHeight;
	for( i = 0 ; i < objCount ; i ++ ){

		objRow = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( this->mRowTextSpriteObjectKey, i ));
		
		pos += this->mRowHeight;
		pos %= area;
		if( pos < areaTop ){
			pos += area;
		}
		else if( areaBottom < pos ){
			pos -= area;
		}
		
		objRow->mText->mSprite.m_locate.x = areaRight - 256;
		objRow->mText->mSprite.m_locate.y = pos;
		
		//	iDǂ
		objRow->mText->mSprite.m_locate.x -= ( pos - areaTop ) >> 1 ;

		if( i == targetRow ){
			colorMode = 0;
		}
		else{
			colorMode = 1;
		}
		
		//::TODO::̏ɐFςHQ[xƂH
		switch( colorMode ){
			case 0:
				objRow->mText->mSprite.m_color.set( 255, 178, 0, 255 );
				break;
			case 1:
				objRow->mText->mSprite.m_color.set( 128, 128, 128, 255 - (pos - areaTop) / 2 );
				break;
		}

		objRow->mText->mSprite.update();
	}
	
	//	fobO
//	this->mScrollMode = M_SCROLL_UP;

	switch( this->mScrollMode ){
		case M_SCROLL_UP:
			//	փXN[
			do{

				if(  this->mBmsListOffset == 0 ){
					ABint	saveTagetRpw	 = this->mListTargetRow;
					ABint	saveHeadRpw		 = this->mListHeadBMSIndex;
					ABint	saveHeadViewtRpw = this->mListHeadViewRow;

					//	XN[JnɍsI
					++this->mListTargetRow;
					if( this->mListRowCount <= this->mListTargetRow ){
						this->mListTargetRow = 0;
					}
					++this->mListHeadBMSIndex;
					if( this->mListRowCount <= this->mListHeadBMSIndex ){
						this->mListHeadBMSIndex = 0;
					}
					++this->mListHeadViewRow;
					if( objCount <= this->mListHeadViewRow ){
						this->mListHeadViewRow = 0;
					}
					
					//	sIR[obN
					if( ! this->mBmsListRowEnter( saveTagetRpw, this->mListTargetRow, this->mBmsListFillFuncUserData ) ){
						//	XN[cancel
						this->mListTargetRow	= saveTagetRpw;
						this->mListHeadBMSIndex		= saveHeadRpw;
						this->mListHeadViewRow	= saveHeadViewtRpw;
						break;
					}
					
					this->mRequireData = M_REQUIRE_DATA_LOWER;
				}
				
				this->mBmsListOffset -= 4;		//	PsXN[p
				this->mScrollPosition -= 4;		//	ۂ̍W
				if( 6 <= this->mHiSpeedScroolCounter ){
					this->mBmsListOffset -= 4;
					this->mScrollPosition -= 4;
				}
				if( this->mBmsListOffset < 0 ){	//	<= łȂ΂ȂȂBJNJN܂
					this->mBmsListOffset += this->mRowHeight;
				}
				
			} while( false );

			break;

		case M_SCROLL_DOWN:
			//	փXN[
			do{

				if(  this->mBmsListOffset == 0 ){
					//	XN[JnɍsI
					ABint	saveTagetRpw	 = this->mListTargetRow;
					ABint	saveHeadRpw		 = this->mListHeadBMSIndex;
					ABint	saveHeadViewtRpw = this->mListHeadViewRow;
					
					--this->mListTargetRow;
					if( this->mListTargetRow < 0  ){
						this->mListTargetRow = this->mListRowCount - 1;
					}
					--this->mListHeadBMSIndex;
					if( this->mListHeadBMSIndex < 0  ){
						this->mListHeadBMSIndex = this->mListRowCount - 1;
					}
					--this->mListHeadViewRow;
					if( this->mListHeadViewRow < 0  ){
						this->mListHeadViewRow = objCount - 1;
					}

					//	sIR[obN
					if( ! this->mBmsListRowEnter( saveTagetRpw, this->mListTargetRow, this->mBmsListFillFuncUserData ) ){
						//	XN[cancel
						this->mListTargetRow	= saveTagetRpw;
						this->mListHeadBMSIndex		= saveHeadRpw;
						this->mListHeadViewRow	= saveHeadViewtRpw;
						break;
					}
					
					this->mRequireData = M_REQUIRE_DATA_UPPER;
				}

				this->mBmsListOffset += 4;
				this->mScrollPosition += 4;
				if( 6 <= this->mHiSpeedScroolCounter ){
					this->mBmsListOffset += 4;
					this->mScrollPosition += 4;
				}
				if( this->mRowHeight <= this->mBmsListOffset ){	//	<= łȂ΂ȂȂBJNJN܂
					this->mBmsListOffset = 0;
				}
				
			} while( false );

			break;

		case M_SCROLL_LEFT:
			break;

		case M_SCROLL_RIGHT:
			break;

		default:
			this->mHiSpeedScroolCounter = 0;
			break;
	}
	
	if( this->mBmsListOffset == 0 ){
		this->mScrollMode = M_SCROLL_NONE;

		++this->mHiSpeedScroolCounter;
		if( 6 < this->mHiSpeedScroolCounter ){
			this->mHiSpeedScroolCounter = 6;
		}

	}
}

