/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemRenderMusicSelect.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABSingleton.h"
#include	"ABMBVAItemRenderMusicSelect.h"
#include	"ABVARunner.h"
#include	"ABVAItemConfig.h"
#include	"ABMBVAItemPreset.h"

#include	"ABSingleton.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABMBVAItemRenderMusicSelect
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderMusicSelect::ABMBVAItemRenderMusicSelect( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderMusicSelect::~ABMBVAItemRenderMusicSelect( void )
{
}

//-------------------------------------------------------------------------------------------------
//	
//-------------------------------------------------------------------------------------------------
ABbool	ABMBVAItemRenderMusicSelect::initialize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABbool	ret = false;
	ABint	i;

	//--------------------------
	//	ʒu	BMSvCx
	//--------------------------
	{
		ABuint	countLabel = inRunner->getInstanceCount( ABVA_ITEM_ID_SELECT_SPRITE_PLAY_LEVEL_MARK );
		for( i = 0 ; i < countLabel; i++ ){
			ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_PLAY_LEVEL_MARK, i ));
			
			//	::TODO::~`ɕׂ@\͖ʓ|Ȃ̂ŔrB̐ŝ݂Ή\łB
			ABfloat32	width = obj->mSprite.m_width * 0.5f;
			if( i < 16 ){
				obj->mSprite.m_locate.x += width * i;				//	׉߂Ɖʂ݂͂Ⴄ
			}
			else{
				obj->mSprite.m_locate.x += width * ( i - 16 + 1 );	//	׉߂Ɖʂ݂͂Ⴄ
				obj->mSprite.m_locate.y -= obj->mSprite.m_height * 0.5f;
			}
			obj->mSprite.update();
		}
	}

	//--------------------------
	//	ʒu	Q[[h̍Wʒu
	//--------------------------
	{
		ABVAItemSpriteObject*	objPosPlayStep = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_LOCATE_PLAY_STEP, 0 ));
		
		ABVAItemSpriteObject*	objGameMode = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_GAME_MODE_LABEL, 0 ));
		ABVAItemSpriteObject*	objStageNumberLabel = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_STAGE_NUMBER_LABEL, 0 ));
		ABVAItemSpriteObject*	objStageNumber = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_STAGE_NUMBER, 0 ));

		//	"ARVADE" "EXPERT" ̕
		objGameMode->mSprite.m_locate.x += objPosPlayStep->mSprite.m_locate.x;
		objGameMode->mSprite.m_locate.y += objPosPlayStep->mSprite.m_locate.y;
		objGameMode->mSprite.update();

		//	"STAGE" ̕
		objStageNumberLabel->mSprite.m_locate.x += objGameMode->mSprite.m_locate.x + objGameMode->mSprite.m_width;
		objStageNumberLabel->mSprite.m_locate.y = objGameMode->mSprite.m_locate.y;
		objStageNumberLabel->mSprite.update();

		//	"STAGE1"... ̕
		objStageNumber->mSprite.m_locate.x += objStageNumberLabel->mSprite.m_locate.x + objStageNumberLabel->mSprite.m_width;
		objStageNumber->mSprite.m_locate.y = objStageNumberLabel->mSprite.m_locate.y;
		objStageNumber->mSprite.update();
	}

	//--------------------------
	//	ʒu	ACR摜FI[gvC
	//--------------------------
	{
		ABVAItemSpriteObject*	obj2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_ICON_AUTO_PLAY_P2, 0 ));
		obj2->setCellNumber( 1, -1 );	//	Z2Pɐݒ
		obj2->mSprite.update();
	}
	{
		ABVAItemSpriteObject*	obj1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_ICON_AUTO_PLAY_P1, 1 ));
		ABVAItemSpriteObject*	obj2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_ICON_AUTO_PLAY_P2, 1 ));

		obj1->mSprite.m_locate.y += obj1->mSprite.m_height;
		obj1->setCellNumber( -1, 1 );	//	Z1P~Ղɐݒ
		obj1->mSprite.update();
		obj1->mSprite.m_visible = false;
		obj2->mSprite.m_locate.y += obj2->mSprite.m_height;
		obj2->setCellNumber( 1, 1 );	//	Z2P~Ղɐݒ
		obj2->mSprite.update();
		obj2->mSprite.m_visible = false;
	}

	//--------------------------
	//	ʒu	ACR摜FBMSFVETEvC[EBGA̗LEN
	//--------------------------
	{
		ABuint	countLabel = inRunner->getInstanceCount( ABVA_ITEM_ID_SELECT_SPRITE_ICON_BMS_INFO );
		for( i = 0 ; i < countLabel; i++ ){
			ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_ICON_BMS_INFO, i ));

			GGVector2f	cellLayout = this->getIconBMSCellLayout( i, 0 );	//	Z
			
			obj->mSprite.m_locate.y += obj->mSprite.m_height * i;
			obj->setCellNumber( cellLayout.x, cellLayout.y );
			obj->mSprite.update();
		}
	}

	//--------------------------
	//	ʒu	SCHEME
	//--------------------------
	{
		ABVAItemSpriteObject*	objIcon = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_ICON_BMS_INFO, 0 ));
		ABuint		countLabel = inRunner->getInstanceCount( ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO );
		ABint8*		text[]={
			" TITLE:",
			" GENRE:",
			"ARTIST:",
			"   BPM:",
			"FOLDER:",
			"  DATA:",
		};
		for( i = 0 ; i < countLabel; i++ ){
			ABVAItemTextSpriteObject*	obj 	= static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO, i ));
			ABVAItemTextSpriteObject*	objValue = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO_VALUE, i ));
			GameString	str;

			obj->mText->mSprite.m_locate.x += objIcon->mSprite.m_locate.x + objIcon->mSprite.m_width ;
			obj->mText->mSprite.m_locate.y += 20 * i ; 
			obj->mText->mSprite.update();

			str.setCString( text[i], GS_ENCORDING_ASCII );
			obj->mText->draw( str.get() );

			objValue->mText->mSprite.m_locate.x += obj->mText->mSprite.m_locate.x + obj->mText->mSprite.m_width ;
			objValue->mText->mSprite.m_locate.y = obj->mText->mSprite.m_locate.y; 
			objValue->mText->mSprite.update();

			str.setCString( "Value...", GS_ENCORDING_ASCII );
			objValue->mText->draw( str.get() );
		}
	}

	//--------------------------
	//	ʒu	ȖXg
	//--------------------------
	{
		ABuint	countLabel = inRunner->getInstanceCount( ABVA_ITEM_ID_SELECT_TEXT_MUSIC_TITLE_LIST );
		for( i = 0 ; i < countLabel; i++ ){
			ABVAItemTextSpriteObject*	obj = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_TEXT_MUSIC_TITLE_LIST, i ));
			
//			obj->mText->mSprite.m_locate.y += 32 * i ; 
//			obj->mText->mSprite.update();
		}
		
		this->mBMSHeaderInfo		= NULL;
		this->m_bmsList.mListTargetRow		= ABGetBMSLibrary().getIndex();
		this->m_bmsList.mRowHeight			= 32;
		this->m_bmsList.mTaegetRow			= 5;
		this->m_bmsList.mRowTextSpriteObjectKey = ABVA_ITEM_ID_SELECT_TEXT_MUSIC_TITLE_LIST;
		this->m_bmsList.mArea.set( 0, 100, 640, 640 );
		this->m_bmsList.initialize( inRunner, inBinder, this->listFillFunc, this->listRowEnterFunc, this, ABGetBMSLibrary().getDataCount() );
	}

	return ret;
}

//-------------------------------------------------------------------------------------------------
//	I
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderMusicSelect::finalize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	this->m_bmsList.finalize( inRunner, inBinder );
}

//-------------------------------------------------------------------------------------------------
//	Render
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderMusicSelect::render( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABint	playerNumber;

	//	Xg`
	this->m_bmsList.mListRowCount = ABGetBMSLibrary().getDataCount();
	this->m_bmsList.render( inRunner, inBinder );
	
	ABGamePreference&	preference = ABGetPreference();

	//	XV
	
	//	BMSvCx
	
	//	Q[[h̍Wʒu
	//	ACR摜FI[gvC
	{
		ABint	key[] = {
			ABVA_ITEM_ID_SELECT_SPRITE_ICON_AUTO_PLAY_P1, ABVA_ITEM_ID_SELECT_SPRITE_ICON_AUTO_PLAY_P2
		};
		for( playerNumber = 0 ; playerNumber < 2; playerNumber++ ){
			ABVAItemSpriteObject*	obj1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( key[ playerNumber ], 0 ));
			ABVAItemSpriteObject*	obj2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( key[ playerNumber ], 1 ));

			switch( preference.playConfig.autoPlayMode[playerNumber]  ){
				case AB_AUTO_PLAY_TYPE_NONE:
					obj1->mSprite.m_visible = false;
					obj2->mSprite.m_visible = false;
					break;
				case AB_AUTO_PLAY_TYPE_ALL:
					obj1->mSprite.m_visible = true;
					obj2->mSprite.m_visible = true;
					break;
				case AB_AUTO_PLAY_TYPE_KEY_TRACKS:
					obj1->mSprite.m_visible = true;
					obj2->mSprite.m_visible = false;
					break;
				case AB_AUTO_PLAY_TYPE_SCRATCH_TRACKS:
					obj1->mSprite.m_visible = false;
					obj2->mSprite.m_visible = true;
					break;
			}
		}

	}
	//	ACR摜FBMSFVETEvC[EBGA̗LEN
	if( this->mBMSHeaderInfo != NULL ){

		ABVAItemSpriteObject*	obj;
		GGVector2f	cellLayout;
		
		obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_ICON_BMS_INFO, M_ICON_BMS_INFO_7_OR_5 ));
		cellLayout = this->getIconBMSCellLayout( M_ICON_BMS_INFO_7_OR_5, ( this->mBMSHeaderInfo->keyModeType == 0 ? 0 : 1 ) );	//	Z
		obj->setCellNumber( cellLayout.x, cellLayout.y );
		obj->mSprite.update();

		obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_ICON_BMS_INFO, M_ICON_BMS_INFO_PALYER_COUNT ));
		cellLayout = this->getIconBMSCellLayout( M_ICON_BMS_INFO_PALYER_COUNT, ( this->mBMSHeaderInfo->player == 1 ? 0 : 1 ) );	//	Z
		obj->setCellNumber( cellLayout.x, cellLayout.y );
		obj->mSprite.update();

		obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_ICON_BMS_INFO, M_ICON_BMS_INFO_BGM ));
		cellLayout = this->getIconBMSCellLayout( M_ICON_BMS_INFO_BGM, ( this->mBMSHeaderInfo->BGAType == BMS_TP_BGA_TYPE_NOTHING ? 1 : 0 ) );	//	Z
		obj->setCellNumber( cellLayout.x, cellLayout.y );
		obj->mSprite.update();

		obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_ICON_BMS_INFO, M_ICON_BMS_INFO_RANK ));
		cellLayout = this->getIconBMSCellLayout( M_ICON_BMS_INFO_RANK, this->mBMSHeaderInfo->rank );	//	Z
		obj->setCellNumber( cellLayout.x, cellLayout.y );
		obj->mSprite.update();

	}
	//	SCHEME
	{
		ABVAItemTextSpriteObject*	objValue;
		ABint8	c[256];
		ABint	v = 0;
		GameString	str;

		static ABint8*	rankText[] ={
			"EASY    ",		//	AB_BMS_RANK_EASY,
			"NORMAL  ",		//	AB_BMS_RANK_NORMAL,
			"HARD    ",		//	AB_BMS_RANK_HARD,
			"VERYHARD",		//	AB_BMS_RANK_VERY_HARD,
		};

		//	FInfoAreaFBMS^Cg
		objValue = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO_VALUE, M_TEXT_BMS_INFO_TITLE ));
//		snprintf( c, 256, "%s(LV:%d-%s)" ,this->mBMSHeaderInfo->strTitle, this->mBMSHeaderInfo->playerLevel, rankText[this->mBMSHeaderInfo->rank] );
		str.setCString( this->mBMSHeaderInfo->strTitle, GS_ENCORDING_SHIT_JIS );
		objValue->mText->draw( str.get() );

		//	FInfoAreaFW
		objValue = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO_VALUE, M_TEXT_BMS_INFO_GENRE ));
		str.setCString( this->mBMSHeaderInfo->strGenre, GS_ENCORDING_SHIT_JIS );
		objValue->mText->draw( str.get() );

		//	FInfoAreaFA[eBXg
		objValue = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO_VALUE, M_TEXT_BMS_INFO_ARTIST ));
		str.setCString( this->mBMSHeaderInfo->strArtist, GS_ENCORDING_SHIT_JIS );
		objValue->mText->draw( str.get() );

		//	FInfoAreaFBPM
		objValue = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO_VALUE, M_TEXT_BMS_INFO_BPM ));
		v = this->mBMSHeaderInfo->bpm;
		sprintf( c, "%3d", v );
		str.setCString( c, GS_ENCORDING_ASCII );
		objValue->mText->draw( str.get() );
/*
		//	FInfoAreaFBMStH_[ԍ
		objValue = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO_VALUE, M_TEXT_BMS_INFO_BMS_FOLDER ));
		sprintf( c, "%5d/%5d %s" ,playngStatus->currentBMSfolderNumber, playngStatus->BMSfolderCount, this->mBMSHeaderInfo->directoryName );
		str.setCString( c, GS_ENCORDING_ASCII );
		objValue->mText->draw( str.get() );

		//	FInfoAreaFBMSf[^ԍ
		objValue = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_TEXT_BMS_INFO_VALUE, M_TEXT_BMS_INFO_BMS_NUMBER ));
		sprintf( c, "%5d/%5d", playngStatus->currentBMSdataNumber, playngStatus->BMSdataCount );
		str.setCString( c, GS_ENCORDING_ASCII );
		objValue->mText->draw( str.get() );
*/
	}
	
	//--------------------------
	//	ʒu	BMSvCx
	//--------------------------
	{
		ABuint	i;
		ABuint	countLabel = inRunner->getInstanceCount( ABVA_ITEM_ID_SELECT_SPRITE_PLAY_LEVEL_MARK );
		for( i = 0 ; i < countLabel; i++ ){
			ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_PLAY_LEVEL_MARK, i ));
			
			if( i < this->mBMSHeaderInfo->playerLevel ){
				obj->mSprite.m_visible = true;
			}
			else{
				obj->mSprite.m_visible = false;
			}
		}
	}

	//	ʒu	Q[[h̍Wʒu
	//--------------------------
	{
		ABVAItemSpriteObject*	objGameMode = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_GAME_MODE_LABEL, 0 ));
		ABVAItemSpriteObject*	objStageNumberLabel = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_STAGE_NUMBER_LABEL, 0 ));
		ABVAItemSpriteObject*	objStageNumber = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_SELECT_SPRITE_STAGE_NUMBER, 0 ));

		switch( preference.gameMode ){
			case AB_GAME_MODE_ARCADE:
				objGameMode->mSprite.m_visible = true;
				objGameMode->setCellNumber( 0, -1 );
				objStageNumberLabel->mSprite.m_visible = true;
				objStageNumberLabel->setCellNumber( 0, -1 );
				objStageNumber->mSprite.m_visible = true;
				objStageNumber->setCellNumber( 0, preference.stageNumber );
				break;

			case AB_GAME_MODE_EXPART:
				objGameMode->mSprite.m_visible = true;
				objGameMode->setCellNumber( 1, -1 );
				objStageNumberLabel->mSprite.m_visible = true;
				objStageNumberLabel->setCellNumber( 1, -1 );
				objStageNumber->mSprite.m_visible = true;
				objStageNumber->setCellNumber( 1, preference.stageNumber );
				break;

			case AB_GAME_MODE_FREEPLAY:
			default:
				objGameMode->mSprite.m_visible = false;
				objStageNumberLabel->mSprite.m_visible = false;
				objStageNumber->mSprite.m_visible = false;
				break;
				
		}
	}
}

//-------------------------------------------------------------------------------------------------
//	ȖXgߐs֐
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderMusicSelect::listFillFunc( ABint  inRow, void*  inUserData, ABint8*  outBuffer1, ABint  inRequestBufferSize )
{
	ABMBVAItemRenderMusicSelect*	ins = static_cast<ABMBVAItemRenderMusicSelect*>(inUserData);

	BMSLibrary&			collection		= ABGetBMSLibrary();
	ABint				dataCount		= collection.getDataCount();
	BMSLibraryData*		collectionData	= NULL;

	ABint	row = inRow % dataCount;	//	ōs|B\sf[^sȂ́AeJԂZbgB
	ABint8*	text = NULL;
	
	static ABint8*	rankText[] ={
		"EASY    ",		//	AB_BMS_RANK_EASY,
		"NORMAL  ",		//	AB_BMS_RANK_NORMAL,
		"HARD    ",		//	AB_BMS_RANK_HARD,
		"VERYHARD",		//	AB_BMS_RANK_VERY_HARD,
	};

	collectionData = collection.getData( inRow );	

/*
	//	HeaderJBCɑSĂЂ炭̂ł͂ȂAKvɉĊJAƂlłB
	//	xĴ̓LbVB
	//	f[^ʂŗLĂNԂɂłB
	if( ! collectionData->mTrueIsChashed ){
		bool	result = collectionData->mFolderRef->mBMSdata.openBMSmusicHeaderOnly( collectionData->mDataNumber );
		if( !result ){
			return;
		}
		ABbmsMusicData*		musicData = collectionData->mFolderRef->mBMSdata.getMusicData();
		collectionData->mHeaderInfo = musicData->headerInfo;
		collectionData->mFolderRef->mBMSdata.closeBMSmusic();
		collectionData->mTrueIsChashed = true;
	}
*/
	//	J
	if( ! collectionData->mTrueIsChashed ){
		ABbool	ret = collectionData->mFolderRef->mBMSdata.getInformation( collectionData->mDataNumber, &collectionData->mHeaderInfo );
		if( !ret ){
			snprintf( outBuffer1, inRequestBufferSize - 1, "-    %5d- %-s(%2d)\n[!!!BROKEN BMS FOLDER!!!]",
							inRow + 1,										//	Ȕԍ
							collectionData->mFolderRef->mFoladerName ,		//	BMStH_[
							collectionData->mDataNumber + 1 				//	BMSԍ
							);		//	
		//					collectionData->mFolderRef->mFoladerName );
			return;
			collectionData->mBroken = true;
		}
		collectionData->mTrueIsChashed = true;
	}
	
	ABint8*		title = collectionData->mHeaderInfo.strTitle;
	if( collectionData->mBroken ){
		title = "!!! BROKEN BMS !!!";
	}

	//	ŕ쐬Awobt@Ɋi[B
	//	쐬݂̂Ȃ̂ŁAŎRɏHEłB
	//	Qs܂ŕ\\łAtH[}bgύX΁ACAEgςB
	//	ς񂪂΂ɎƗǂ낤B
	snprintf( outBuffer1, inRequestBufferSize - 1, "-    %5d- %-s(%2d)\n[LV:%2d-%8s][BPM:%3d][%-8s][%-8s]",
					inRow + 1,										//	Ȕԍ
					title ,											//	BMS^Cg
					collectionData->mDataNumber + 1, 				//	BMSԍ
					collectionData->mHeaderInfo.playerLevel, 		//	
					rankText[ collectionData->mHeaderInfo.rank ],	//	
					collectionData->mHeaderInfo.bpm,				//	
					collectionData->mHeaderInfo.strGenre, 			//	
					collectionData->mHeaderInfo.strArtist );		//	
//					collectionData->mFolderRef->mFoladerName );
}

//-------------------------------------------------------------------------------------------------
//	ȖXgsI֐
//-------------------------------------------------------------------------------------------------
bool	ABMBVAItemRenderMusicSelect::listRowEnterFunc( ABint  inExitRow, ABint  inEnterRow, void*  inUserData ) 
{
	ABMBVAItemRenderMusicSelect*	ins = static_cast<ABMBVAItemRenderMusicSelect*>(inUserData);
	
	BMSLibrary&			collection		= ABGetBMSLibrary();
	ABint				dataCount		= collection.getDataCount();
	ABint	row = inEnterRow % dataCount;	//	ōs|B\sf[^sȂ́AeJԂZbgB

	//	IȂ̏\
	collection.setIndex( inEnterRow );	
	BMSLibraryData*		collectionData	= collection.getData();	

	//	|C^Zbg
	//	ł邱Ƃ͂ꂾOKB
	ins->mBMSHeaderInfo = &collectionData->mHeaderInfo;

	return true;
}

