/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemRenderStageFinish.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABMBVAItemRenderStageFinish.h"
#include	"ABVARunner.h"
#include	"ABVAItemConfig.h"
#include	"ABMBVAItemPreset.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABMBVAItemRenderStageFinish
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderStageFinish::ABMBVAItemRenderStageFinish( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderStageFinish::~ABMBVAItemRenderStageFinish( void )
{
}

//-------------------------------------------------------------------------------------------------
//	
//-------------------------------------------------------------------------------------------------
ABbool	ABMBVAItemRenderStageFinish::initialize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABbool	ret = false;
	ABint	i;
	ABint	playerNumber;
	ABint	screenWidth = 640;

	this->mGraphCounter = 0;
	this->mScoreNumber = 0;
	this->mOnInit = true;

	//--------------------------
	//	Graph摜̈ʒu
	//--------------------------
	{
		ABVAItemSpriteObject*	objPos = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_FINISH_SPRITE_GRAPH_AREA, 0 ));

		this->mGraphArea[0].set( objPos->mSprite.m_locate.x, objPos->mSprite.m_locate.y, objPos->mSprite.m_width, objPos->mSprite.m_height );
		this->mGraphArea[1] = this->mGraphArea[0];
		this->mGraphArea[1].left += screenWidth / 2;	//	EΏ
		
		//	1P, 2P
		for( playerNumber = 0 ; playerNumber < 2; playerNumber++ ){

			GGRecti*		area = &this->mGraphArea[playerNumber];

			for( i = 0 ; i < ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH; i++ ){
				ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_FINISH_SPRITE_GRAPH_P1 + playerNumber, i ));
				
				obj->mSprite.m_locate.x = area->left + obj->mSprite.m_width * i / 2;
				obj->mSprite.m_locate.y = area->top + area->height - obj->mSprite.m_width; // K
				obj->mSprite.m_visible = false;
				obj->mSprite.update();
			}
		}
	}

	//--------------------------
	//	XRÄʒu
	//--------------------------
	{
		ABint	xPos[] = {
			0, screenWidth / 2,
		};
		ABVAItemSpriteObject*	objPos = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_FINISH_SPRITE_SCORE_OFFSET, 0 ));
		ABint	key[] = {
			ABVA_ITEM_ID_FINISH_SPRITE_SCORE_P1, ABVA_ITEM_ID_FINISH_SPRITE_SCORE_P2
		};

		//	1P, 2P
		for( playerNumber = 0 ; playerNumber < 2; playerNumber++ ){

			for( i = 0 ; i < ABVAItemBindStageFinish::M_SET_TYPE_COUNT; i++ ){
				ABVAItemTextSpriteObject*	obj = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( key[playerNumber] + i, 0 ));
				
				obj->mTextSprite->mLocate.x += xPos[ playerNumber ] + objPos->mSprite.m_locate.x * i;
				obj->mTextSprite->mLocate.y += objPos->mSprite.m_locate.y * i;
				obj->mTextSprite->setVisible( false );
			}
		}
	}

	return ret;
}

//-------------------------------------------------------------------------------------------------
//	I
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStageFinish::finalize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
}

//-------------------------------------------------------------------------------------------------
//	Render
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStageFinish::render( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABVAItemBindStageFinish*	binder = static_cast<ABVAItemBindStageFinish*>(inBinder);

	if( this->mOnInit ){
		this->setupData( inRunner, inBinder );
		this->mOnInit = false;
	}


	ABbool	drawFlag = false;	
	ABbool	allDraw = false;
	if( (binder->mDisplayCounter % ABVAItemBindStageFinish::M_GRAPH_DRAW_SPEED) == 0 ){
		drawFlag = true;
	}
	if( binder->mDisplayCounter <= ABVAItemBindStageFinish::M_GRAPH_DRAW_TIME ){
		allDraw = true;
	}
	if( ABVAItemBindStageFinish::M_GRAPH_DRAW_TIME <= binder->mDisplayCounter  ){
		//--------------------------
		//	score\
		//--------------------------
		if( drawFlag ){
			ABint	wait = ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH / ABVAItemBindStageFinish::M_SET_TYPE_COUNT;
			if( this->mScoreNumber < ABVAItemBindStageFinish::M_SET_TYPE_COUNT ){

				ABint	drawCount	= 1 + this->mScoreNumber;
				ABint	i			= this->mScoreNumber;
				ABbool	drawScoreFlag = false;	
				if( allDraw ){
					drawCount	= ABVAItemBindStageFinish::M_SET_TYPE_COUNT;
					drawScoreFlag = true;
				}
				else{
					if( (this->mGraphCounter % wait) == 0 ){
						drawScoreFlag = true;
					}
				}

				if( drawScoreFlag ){
					for( ;i < drawCount ; i ++ ){
						ABVAItemTextSpriteObject*	obj1 = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_FINISH_SPRITE_SCORE_P1 + i, 0 ));
						ABVAItemTextSpriteObject*	obj2 = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_FINISH_SPRITE_SCORE_P2 + i, 0 ));
						obj1->mTextSprite->setVisible( true );
						obj2->mTextSprite->setVisible( true );
						++this->mScoreNumber;
					}
				}
			}
		}
		

		//--------------------------
		//	Graph`
		//--------------------------
		if( drawFlag ){
			//	1P, 2P

			ABint	playerNumber;
			ABint	drawCount	= 1 + this->mGraphCounter;
			ABint	i			= this->mGraphCounter;
			
			if( allDraw ){
				drawCount	= ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH;
			}

			if( this->mGraphCounter < ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH ){
				for( ;i < drawCount ; i ++ ){
					for( playerNumber = 0 ; playerNumber < BMS_BMSEQ_EVENT_PLAYER_COUNT ; playerNumber++ ){
						ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_FINISH_SPRITE_GRAPH_P1 + playerNumber, i ));
						GGRecti			area = this->mGraphArea[ playerNumber ];	

						//	ƂȂ鍂͊Ɍ肵Ă̂ŁAOK
						obj->mSprite.m_locate.y -= (ABfloat32)(area.height / BMS_SEQ_CONSUMER_SCORE_RESULT_GRAPH_MAX) * (ABfloat32)binder->mResultGraph[playerNumber][ i ];
						obj->mSprite.m_visible = true;
						
						if( BMS_SEQ_CONSUMER_SCORE_RESULT_GRAPH_GAIN <=  binder->mResultGraph[playerNumber][ i ]){
							//	Ԃ߂Ă
							obj->setCellNumber( 1, -1 );
						}
						else{
							obj->setCellNumber( 0, -1 );
						}
						
						obj->mSprite.update();
					}
				}

				++this->mGraphCounter;
			}
		}
	}

	ABint	range = 60;
	ABint	limit = ABVAItemBindStageFinish::M_GRAPH_TOTAL_TIME - ABVAItemBindStageFinish::M_GRAPH_DRAW_TIME;
	if( binder->mDisplayCounter < limit && ( (limit - binder->mDisplayCounter) <= range )){
		if( binder->mConsumer[BMS_BMSEQ_EVENT_PLAYER1]->isClear() || binder->mConsumer[BMS_BMSEQ_EVENT_PLAYER2]->isClear() ){
			ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_FINISH_SPRITE_COMPLETE, 0 ));
			obj->mSprite.m_visible = true;
			obj->mSprite.m_color.a = 1.0f / (ABfloat32)range * (ABfloat32)( limit - binder->mDisplayCounter );
		}
		else{
			ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_FINISH_SPRITE_FAILED, 0 ));
			obj->mSprite.m_visible = true;
			obj->mSprite.m_color.a = 1.0f / (ABfloat32)range * (ABfloat32)( limit - binder->mDisplayCounter );
		}
	}

	if( 0 < binder->mDisplayCounter ){
		--binder->mDisplayCounter;
	}
}

//-------------------------------------------------------------------------------------------------
//	setup data
//	m[gE͂ōsȂƂ܂BƂ̂VÃZbgAbv̌V[̃ZbgAbvs߁AKvȏ󂯎ȂłB
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStageFinish::setupData( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABint	i;
	ABVAItemBindStageFinish*	binder = static_cast<ABVAItemBindStageFinish*>(inBinder);

	//--------------------------
	//	score
	//--------------------------
	ABint	strLen = ABVAItemBindStageFinish::M_SET_TYPE_COUNT;
	ABVAItemBindStageFinish::MParam::Player*		playerDataArray[] = {
		&binder->mPramam.Player1,
		&binder->mPramam.Player2,
	};
	for( i = 0 ; i < BMS_BMSEQ_EVENT_PLAYER_COUNT; i ++ ){
		ABVAItemBindStageFinish::MParam::Player*		playerData = playerDataArray[i];
		BMSConsumer*	consumer = binder->mConsumer[i];
		if( consumer != NULL ){
			snprintf( playerData->mValue[ ABVAItemBindStageFinish::M_SET_TYPE_SCORE ].mCString, 				strLen, "%06d", consumer->m_score.totalScore );

			snprintf( playerData->mValue[ ABVAItemBindStageFinish::M_SET_TYPE_COUNTER_JUST_GRAET ].mCString, 	strLen, "  %4d", consumer->m_score.judgeNoteCount[BMS_SEQ_JUDGE_JUST_GREATE]  );
			snprintf( playerData->mValue[ ABVAItemBindStageFinish::M_SET_TYPE_COUNTER_GREAT ].mCString,	 		strLen, "  %4d", consumer->m_score.judgeNoteCount[BMS_SEQ_JUDGE_GREATE] );
			snprintf( playerData->mValue[ ABVAItemBindStageFinish::M_SET_TYPE_COUNTER_GOOD ].mCString, 			strLen, "  %4d", consumer->m_score.judgeNoteCount[BMS_SEQ_JUDGE_GOOD] );
			snprintf( playerData->mValue[ ABVAItemBindStageFinish::M_SET_TYPE_COUNTER_BAD ].mCString, 			strLen, "  %4d", consumer->m_score.judgeNoteCount[BMS_SEQ_JUDGE_BAD] );
			snprintf( playerData->mValue[ ABVAItemBindStageFinish::M_SET_TYPE_COUNTER_POOR ].mCString, 			strLen, "  %4d", consumer->m_score.judgeNoteCount[BMS_SEQ_JUDGE_POOR] );
			snprintf( playerData->mValue[ ABVAItemBindStageFinish::M_SET_TYPE_COUNTER_MAX_COMBO ].mCString, 	strLen, "  %4d", consumer->m_score.comboCount );
			snprintf( playerData->mValue[ ABVAItemBindStageFinish::M_SET_TYPE_COUNTER_TOTAL ].mCString, 		strLen, "  %4d", consumer->m_totalNoteCount );
		}
	}
	
	//--------------------------
	//	ResultGraphWv
	//--------------------------
	//	TvO
	ABint	x;
	for( i = 0 ; i < BMS_BMSEQ_EVENT_PLAYER_COUNT; i ++ ){
		BMSConsumer*	consumer = binder->mConsumer[i];
		if( consumer != NULL ){
			ABint	count = consumer->m_tensionGraph.array.size();	//	肵m[gĂB120ȉȂȏォȂ

			//	MacBeat͂ǂẮHǂ݂Ă120ȏvĂȂۂ?i
			//	VvɂB
			if( ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH < count ){
				//	m[gƂ
				for( x = 0 ; x < ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH; x++ ){
					//	TvOpoint߂āÃf[^oB
					ABint	sp = (ABint)( (ABfloat32)x * (ABfloat32)count / (ABfloat32)ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH);
					//	Ċi[B
					binder->mResultGraph[i][x] = consumer->m_tensionGraph.array[sp];
				}
				//	ԂɂȂĂ̂ŁA߂B
				ABint	sample = 0;
				for( x = 0 ; x < ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH; x++ ){
					sample = binder->mResultGraph[i][x];					
					if( 0 <= sample ){
						break;
					}
				}
				for( x = 0 ; x < ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH; x++ ){
					if( binder->mResultGraph[i][x] < 0 ){
						binder->mResultGraph[i][x] = sample;;
					}
					else{
						sample = binder->mResultGraph[i][x];
					}
				}
			}
			else{
				//	m[gȂ
				ABint	sp = 0;
				ABint	lastValue = 0;
				for( x = 0 ; x < count; x++ ){
					//	TvOpoint߂āAɖߍށB
					sp = ( (ABfloat32)x * (ABfloat32)ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH / (ABfloat32)count);
					//	Ċi[B
					binder->mResultGraph[i][sp] = consumer->m_tensionGraph.array[x];
				}
				//	ԂɂȂĂ̂ŁA߂B
				ABint	sample = 0;
				for( x = 0 ; x < ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH; x++ ){
					sample = binder->mResultGraph[i][x];					
					if( 0 <= sample ){
						break;
					}
				}
				for( x = 0 ; x < ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH; x++ ){
					if( binder->mResultGraph[i][x] < 0 ){
						binder->mResultGraph[i][x] = sample;;
					}
					else{
						sample = binder->mResultGraph[i][x];
					}
				}

				//	
				for( x = 1 ; x < ABVAItemBindStageFinish::M_GRAPH_COUNT_WIDTH - 1; x++ ){
					ABint	rate;
					rate = binder->mResultGraph[i][x - 1];
					rate += binder->mResultGraph[i][x];
					rate += binder->mResultGraph[i][x + 1];
					
					binder->mResultGraph[i][x] = (ABfloat32)rate / 3.0f;
				}

			}//	for

		}
	}

}
