/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemRenderStagePlay.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////
//#define		AB_LOCAL_DEBUG_MODE
#include	"GlobalConfig.h"
#include	"GameSingleton.h"

#include	"ABMBVAItemRenderStagePlay.h"
#include	"ABVARunner.h"

#include	"ABMBVAItemPreset.h"
#include	"ABSingleton.h"
#include	"ABVAItemSprite.h"
#include	"ABVAItemTextSprite.h"
#include	"ABVAItemAnimation.h"

#include	"BMSResource.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABMBVAItemRenderStagePlay
//
//////////////////////////////////////////////////////////////////////////////////////////////////
ABMacbeatBMSProgressReporter::ABMacbeatBMSProgressReporter()
{
	this->m_render = NULL;
	this->m_binder = NULL;
	this->m_runner = NULL;
}
ABMacbeatBMSProgressReporter::~ABMacbeatBMSProgressReporter()
{
}

//-------------------------------------------------------------------------------------------------
//	setup
//-------------------------------------------------------------------------------------------------
void	ABMacbeatBMSProgressReporter::setup( ABVARunner*  inRunner, ABMBVAItemRenderStagePlay*  inRender, ABVAItemBindStagePlay*  inBinder )
{
	this->m_render = inRender;
	this->m_binder = inBinder;
	this->m_runner = inRunner;
}

//-------------------------------------------------------------------------------------------------
//	i񍐊Jn
//-------------------------------------------------------------------------------------------------
void	ABMacbeatBMSProgressReporter::onBegin( void ){
	//	inTotalPhaseɂ̓tF[Y܂BɂςȃvOXo[z߂܂B
	ABVAItemSpriteObject*	objBG1 	= static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOWvLOADING_BG, 0 ));
	ABVAItemSpriteObject*	objBG2 	= static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOWvLOADING_BG, 1 ));
	ABVAItemSpriteObject*	objLOGO = static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOW_LOADING_LOGO, 0 ));
	ABVAItemSpriteObject*	objBar = static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_PROGRESS_BAR, 0 ));

	objBG1->mSprite.m_textureName = 0;
	objBG1->mSprite.m_color.set( 0, 0, 0, 255 );
	objBG1->mSprite.update();
	objBG1->mSprite.m_visible = true;
	objBG2->mSprite.m_visible = true;
	objLOGO->mSprite.m_visible = true;
	objBar->mSprite.m_visible = true;

}

//-------------------------------------------------------------------------------------------------
//	i񍐏I
//-------------------------------------------------------------------------------------------------
void	ABMacbeatBMSProgressReporter::onEnd( void ){
	ABVAItemSpriteObject*	objBG1 	= static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOWvLOADING_BG, 0 ));
	ABVAItemSpriteObject*	objBG2 	= static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOWvLOADING_BG, 1 ));
	ABVAItemSpriteObject*	objLOGO = static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOW_LOADING_LOGO, 0 ));
	ABVAItemSpriteObject*	objBar = static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_PROGRESS_BAR, 0 ));
	objBG1->mSprite.m_visible = false;
	objBG2->mSprite.m_visible = false;
	objLOGO->mSprite.m_visible = false;
	objBar->mSprite.m_visible = false;
}

//-------------------------------------------------------------------------------------------------
//	i|[g
//-------------------------------------------------------------------------------------------------
void	ABMacbeatBMSProgressReporter::onReport( const ABint  inSize, const ABint  inPosition ){

	ABVAItemSpriteObject*	objBG1 	= static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOWvLOADING_BG, 0 ));
	ABVAItemSpriteObject*	objBG2 	= static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOWvLOADING_BG, 1 ));
	ABVAItemSpriteObject*	objBar = static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_PROGRESS_BAR, 0 ));
	ABVAItemResImageObject*	objBG2Img	 = static_cast<ABVAItemResImageObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_IMAGE_NOWvLOADING_BG, 0 ));

	if( this->mPhase == 0 && inPosition == 0 ){
		ABVAItemSpriteObject*	objLOGO = static_cast<ABVAItemSpriteObject*>(this->m_runner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOW_LOADING_LOGO, 0 ));

		//	l̂Ƃ́AŏłB̃^C~OłȂƁA摜t@C𓾂邱ƂoȂB
		GGTexture*		texture;
		ABbool	ret = this->mResource->getStageTitleBMP( &texture );
		if( ret ){

			ABint	w, h, tw, th;
			objBG2->mSprite.m_textureName = texture->getTextureName();
			texture->getSize( &w, &h );
			texture->getTextureSize( &tw, &th );
			objBG2->mSprite.m_texCoord[1].x = (ABfloat32)w / (ABfloat32)tw;
			objBG2->mSprite.m_texCoord[1].y = (ABfloat32)h / (ABfloat32)th;
			objBG2->mSprite.update();
			
			objLOGO->mSprite.m_visible = false;
			objBG2->mSprite.m_color.a	= 1.0f;
		}
		else{
			ABint	w, h, tw, th;
			objBG2->mSprite.m_textureName = objBG2Img->mTexture.getTextureName();
			objBG2Img->mTexture.getSize( &w, &h );
			objBG2Img->mTexture.getTextureSize( &tw, &th );
			objBG2->mSprite.m_texCoord[1].x = (ABfloat32)w / (ABfloat32)tw;
			objBG2->mSprite.m_texCoord[1].y = (ABfloat32)h / (ABfloat32)th;
			objBG2->mSprite.update();
			objLOGO->mSprite.m_visible = true;
			//	At@ufBOgpĈÂ܂B
			objBG2->mSprite.m_color.a	= 0.2f;
		}
	}

	//	Phaseƃ|WVAvZB
	//	TCYPhase0̒lƂȂ̂ŁAvZʓ|łB
	ABfloat32	half = (ABfloat32)(objBG1->mSprite.m_width / (ABfloat32)this->mPhaseMax );
	objBar->mSprite.m_width = half * (ABfloat32)this->mPhase + ( half / (ABfloat32)inSize ) * (ABfloat32)inPosition;
	if( objBG1->mSprite.m_width == this->mPhase && inPosition == inSize ){
		objBar->mSprite.m_width = objBG1->mSprite.m_width;
	}
	objBar->mSprite.update();

	//	Renderĕ\
	if( inPosition % 15 == 0 ){
		//	15ɂP񂾂\܂B
		//	Ƃ̂A\ɂVSyncԁi1/60bj邽߂łB
		//	BMS1000ȏ̓ǂݍ݂KvłA1/60b@*@1000 = 60b|܂B
		//	vɁAx[U[ɒm点邽߂̃vOXo[̂̂ő̃{glbNɂȂĂ܂܂B
		//	͂茾āAvOX\Ȃق̐ȂłȂi
		GGGetRender().fade( 1.0f );
		GGGetRender().render();
		GameGetView()->renderView( true );
	}
	else if( inPosition == inSize ){
		GGGetRender().fade( 1.0f );
		GGGetRender().render();
		GameGetView()->renderView( true );
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS ABMBVAItemRenderStagePlay
//
//////////////////////////////////////////////////////////////////////////////////////////////////
ABint	ABMBVAItemRenderStagePlay::ms_trackNumberArray[BMS_SEQ_TRACK_COUNT] = {
		0, //	BMS_SEQ_TRACK_EVENT,						
		M_TRACK_1_W, //	BMS_SEQ_TRACK_KEY1,
		M_TRACK_2_B, //	BMS_SEQ_TRACK_KEY2,
		M_TRACK_3_W, //	BMS_SEQ_TRACK_KEY3,
		M_TRACK_4_B, //	BMS_SEQ_TRACK_KEY4,
		M_TRACK_5_W, //	BMS_SEQ_TRACK_KEY5,
		M_TRACK_6_B, //	BMS_SEQ_TRACK_KEY6,
		M_TRACK_7_W, //	BMS_SEQ_TRACK_KEY7,
		M_TRACK_S, 	 //	BMS_SEQ_TRACK_KEY_SCRATCH,
		M_TRACK_S,	 //	BMS_SEQ_TRACK_KEY_SCRATCH_FREE,
	};
BMSSeqEventTrackType	ABMBVAItemRenderStagePlay::ms_seqTrackNumberArray[M_TRACK_COUNT] = {
		BMS_SEQ_TRACK_KEY1,	//M_TRACK_1_W, //	,
		BMS_SEQ_TRACK_KEY2,	//M_TRACK_2_B, //	,
		BMS_SEQ_TRACK_KEY3,	//M_TRACK_3_W, //	,
		BMS_SEQ_TRACK_KEY4,	//M_TRACK_4_B, //	,
		BMS_SEQ_TRACK_KEY5,	//M_TRACK_5_W, //	,
		BMS_SEQ_TRACK_KEY6,	//M_TRACK_6_B, //	,
		BMS_SEQ_TRACK_KEY7,	//M_TRACK_7_W, //	,
		BMS_SEQ_TRACK_KEY_SCRATCH,	//M_TRACK_S, 	 //	,
	};

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderStagePlay::ABMBVAItemRenderStagePlay( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
ABMBVAItemRenderStagePlay::~ABMBVAItemRenderStagePlay( void )
{
}

//-------------------------------------------------------------------------------------------------
//	
//-------------------------------------------------------------------------------------------------
ABbool	ABMBVAItemRenderStagePlay::initialize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABbool	ret = false;
	ABVAItemBindStagePlay*	binder = static_cast<ABVAItemBindStagePlay*>(inBinder);

	this->m_bmsPreLocate = 0;
	this->mJudgeAnimeCountP1 = 0;
	this->mJudgeAnimeCountP2 = 0;
	this->mJudgeAnimeCellNumberP1 = 0;
	this->mJudgeAnimeCellNumberP2 = 0;
	this->m_useSpriteList.clear();
	this->m_noteNumber.clear();
	this->m_freeScracthNumber.clear();
	this->m_barNumber1.clear();
	this->m_barNumber2.clear();

	this->mProgressReporter.setup( inRunner, this, binder );

	//	̎_ŊeACeɂSCHEME񂪖ߍ܂ĂB
	//	o[Wł́A\邽тɁA
	//	vO̎鏊Ń[hConfigurationɉWvZsĂB
	//	ABł͂̊֐ŁAwǂ̐ݒOĂAQ[[vł͉Ȃčςނ悤ɂĂB
	
	//	Mbvl
	ABVAItemSpriteObject*	objGap = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_GAP, 0 ));

	//--------------------------
	//	wiF̊m
	//--------------------------

	//--------------------------
	//	vCtB[hW̊m
	//--------------------------
	ABVAItemSpriteObject*	objFBase = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_FIELD_BASE, 0 ));
	ABVAItemSpriteObject*	objF1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_FIELD_P1, 0 ));
	ABVAItemSpriteObject*	objF2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_FIELD_P2, 0 ));

	//	TCŶݏ㏑
	objF1->mSprite.m_width  = objFBase->mSprite.m_width;
	objF1->mSprite.m_height = objFBase->mSprite.m_height;
	objF2->mSprite.m_width  = objFBase->mSprite.m_width;
	objF2->mSprite.m_height = objFBase->mSprite.m_height;
	
	//	eNX`WobjFBaseɊ܂܂Ă̂ŏ㏑iYƉ\Ȃj
	objF1->mSprite.m_texCoord[0] = objFBase->mSprite.m_texCoord[0];
	objF1->mSprite.m_texCoord[1] = objFBase->mSprite.m_texCoord[1];
	objF2->mSprite.m_texCoord[0] = objFBase->mSprite.m_texCoord[0];
	objF2->mSprite.m_texCoord[1] = objFBase->mSprite.m_texCoord[1];
		
	objF1->mSprite.update();
	objF2->mSprite.update();

	//--------------------------
	//	O[gZoneW̊m
	//--------------------------
	ABVAItemSpriteObject*	objGrt1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_GREAT_ZONE_P1, 0 ));
	ABVAItemSpriteObject*	objGrt2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_GREAT_ZONE_P2, 0 ));
	{

		//	GapSizel + vCtB[hW + O[][W
		objGrt1->mSprite.m_locate.x += objGap->mSprite.m_width		+ objF1->mSprite.m_locate.x;
		objGrt1->mSprite.m_locate.y += objGap->mSprite.m_height		+ objF1->mSprite.m_locate.y;

		objGrt2->mSprite.m_locate.x += objGap->mSprite.m_width		+ objF2->mSprite.m_locate.x;
		objGrt2->mSprite.m_locate.y += objGap->mSprite.m_height		+ objF2->mSprite.m_locate.y;
	
		objGrt1->mSprite.update();
		objGrt2->mSprite.update();
		
		this->m_greateZoneTop1 = objGrt1->mSprite.m_locate.y;
		this->m_greateZoneTop2 = objGrt1->mSprite.m_locate.y;
	}


	//--------------------------
	//	lIǍW̊m
	//--------------------------
	{
		ABVAItemSpriteObject*	objBase = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NEON_BASE, 0 ));
		ABVAItemSpriteObject*	obj1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NEON_P1, 0 ));
		ABVAItemSpriteObject*	obj2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NEON_P2, 0 ));

		//	TCŶݏ㏑
		obj1->mSprite.m_width  = objBase->mSprite.m_width;
		obj1->mSprite.m_height = objBase->mSprite.m_height;
		obj2->mSprite.m_width  = objBase->mSprite.m_width;
		obj2->mSprite.m_height = objBase->mSprite.m_height;
		
		obj1->mSprite.update();
		obj2->mSprite.update();
	}

	//--------------------------
	//	֌W̃CAEg
	//--------------------------
	{
		//	tB[ḧ̌vZ
		//	vC[tB[hO[gZonë̗ċ߂B
		//	O[gZone̒ӂƂ߁AgapЂ˂΂ȂȂ̂ŁAƂ킩ɂB
		//	ȂA̒`͏ォ牺։Ȃ鎖OƂB
		GGRecti		playFieldP1, playFieldP2;
		ABfloat32		gzBottomP1	= objGrt1->mSprite.m_locate.y + objGrt1->mSprite.m_height;
		ABfloat32		gzBottomP2	= objGrt2->mSprite.m_locate.y + objGrt2->mSprite.m_height;

		playFieldP1.set( 	objF1->mSprite.m_locate.x + objGap->mSprite.m_width, 
							objF1->mSprite.m_locate.y + objGap->mSprite.m_height, 
							objF1->mSprite.m_width, 
							gzBottomP1 - (objF1->mSprite.m_locate.y + objGap->mSprite.m_height * 2 ));

		playFieldP2.set( 	objF2->mSprite.m_locate.x + objGap->mSprite.m_width, 
							objF2->mSprite.m_locate.y + objGap->mSprite.m_height, 
							objF2->mSprite.m_width, 
							gzBottomP2 - (objF2->mSprite.m_locate.y + objGap->mSprite.m_height * 2 ));

		//	MAC BEAT ----------->	
		//
		//	CENTERvĆA^񒆂Ɋ荇悤ɒ`Ȃ΍sȂAMacBeatł̓vOőΏĂB
		//	#PlayField_2ṔApx, py A@auto@̂Ƃ́A#PlayField_1PpB
		//	
		//	͍͂̕폜邩܂B
		//	
		//	āAŏ񂾂A
		//	#PlayField_1P	none none	0		0		yes
		//	#PlayField_2P	none none	auto	auto	yes	// auto  PlayField_1P 𗘗p
		//	
		//	Ə
		//	
		//	#PlayField_1P	none none	0		0		yes
		//	#PlayField_2P	none none	0		0		yes	// PlayField_1P Ɠł
		//	
		//	ƏANłłłBɁAׂMACAEgDɂ₷Ǝv񂾂ǁB
		//	
		switch( binder->mSchemeSetMode ){
			case AB_BMS_SCHEME_SET_MODE_5KEY_CENTER:
			case AB_BMS_SCHEME_SET_MODE_7KEY_CENTER: 
				ABVAItemSprite*			itemF2 = static_cast<ABVAItemSprite*>(inRunner->getItem( ABVA_ITEM_ID_PLAY_SPRITE_FIELD_P2 ));
				if( itemF2->flag.flagSpriteLocationAuto ){
					playFieldP2.set( 	objF1->mSprite.m_locate.x + objF1->mSprite.m_width, 
										objF1->mSprite.m_locate.y, 
										objF1->mSprite.m_width, 
										objF1->mSprite.m_height );
					objF2->mSprite.m_locate.x += playFieldP2.left;
					objF2->mSprite.update();

					//	O[gZoneW̊m(Ăсi
					ABVAItemSpriteObject*	objGrt2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_GREAT_ZONE_P2, 0 ));
					{
						objGrt2->mSprite.m_locate.x = objGap->mSprite.m_width + playFieldP2.left;
						objGrt2->mSprite.update();
					}
				}
				//	lIǍW̊m(Ăсi
				{
					ABVAItemSpriteObject*	obj1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NEON_P1, 0 ));
					ABVAItemSpriteObject*	obj2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NEON_P2, 0 ));
					ABVAItemSprite*	item1 = static_cast<ABVAItemSprite*>(inRunner->getItem( ABVA_ITEM_ID_PLAY_SPRITE_NEON_P1 ));
					ABVAItemSprite*	item2 = static_cast<ABVAItemSprite*>(inRunner->getItem( ABVA_ITEM_ID_PLAY_SPRITE_NEON_P2 ));

					if( item1->flag.flagSpriteLocationAuto ){
						obj1->mSprite.m_locate.x = objF1->mSprite.m_locate.x - obj1->mSprite.m_width;
						obj1->mSprite.m_locate.y = objF1->mSprite.m_locate.y;
						obj1->mSprite.update();
					}
					if( item2->flag.flagSpriteLocationAuto ){
						obj2->mSprite.m_locate.x = objF2->mSprite.m_locate.x + objF2->mSprite.m_width;
						obj2->mSprite.m_locate.y = objF2->mSprite.m_locate.y;
						obj2->mSprite.update();
					}
				}
			break;
		};
		//	<-----------	MAC BEAT 
		

		this->m_playField1 = playFieldP1;
		this->m_playField2 = playFieldP2;
		
		//	egbN̗̈
		//	EegbN̗LEÄm肵܂B̍ƂɂāAȌ̃gbNPʕ`̓o[ϐ邾ōς݂܂B
		//	E[hɂāAvZ@؂ւȂ΂ȂȂB
		ABVAItemSpriteObject*	objOffset = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_VALUE_NOTE_OFFSET, 0 ));
		ABVAItemSpriteObject*	objW = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_WHITE, 0 ));
		ABVAItemSpriteObject*	objB = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_BLACK, 0 ));
		ABVAItemSpriteObject*	objS = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_SCRATCH, 0 )); 
		{
			//printf( "objOffset: %d \n", objOffset->mSprite.m_width );
		
			memset( &this->m_trackFieldP1, 0, sizeof( this->m_trackFieldP1 ) );
			memset( &this->m_trackFieldP2, 0, sizeof( this->m_trackFieldP2 ) );
		
			//	5 key
			switch( binder->mSchemeSetMode ){
				case AB_BMS_SCHEME_SET_MODE_5KEY:
				case AB_BMS_SCHEME_SET_MODE_5KEY_CENTER: 
					for( ABint i = 0; i < M_TRACK_COUNT; i++ ){
						ABint	left = 0;
						ABint	width = 0;
						ABbool	active = true;
						
						//	::TODO::	 +objOffset.m_width̗p@킩
						switch( i ){
							case M_TRACK_1_W:
								//	LEFT SIDE
								width =objB->mSprite.m_width; 
								break;
							case M_TRACK_2_B:
								width =objB->mSprite.m_width; 
								left = objB->mSprite.m_width / 2;
								break;
							case M_TRACK_3_W:
								width =objW->mSprite.m_width; 
								left = objW->mSprite.m_width + objOffset->mSprite.m_width;
								break;
							case M_TRACK_4_B:
								width =objB->mSprite.m_width; 
								left = objW->mSprite.m_width  + objOffset->mSprite.m_width + objB->mSprite.m_width / 2;
								break;
							case M_TRACK_5_W:
								width =objW->mSprite.m_width; 
								left = (objW->mSprite.m_width + objOffset->mSprite.m_width) * 2;
								break;
							case M_TRACK_6_B:
								//	NOTHING
								active = false;
								break;
							case M_TRACK_7_W:
								//	NOTHING
								active = false;
								break;
							case M_TRACK_S:
								//	RIGHT SIDE
								width =objS->mSprite.m_width; 
								left = ( objW->mSprite.m_width + objOffset->mSprite.m_width ) * 3;
								break;
						}
						this->m_trackFieldP1[i].active = active;
						this->m_trackFieldP1[i].area.set( playFieldP1.left + left, playFieldP1.top, width, playFieldP1.height );

						this->m_trackFieldP2[i].active = active;
						this->m_trackFieldP2[i].area.set( playFieldP2.left + left, playFieldP1.top, width, playFieldP1.height );
					}
					break;
				case AB_BMS_SCHEME_SET_MODE_7KEY:
				case AB_BMS_SCHEME_SET_MODE_7KEY_CENTER:
					for( ABint i = 0; i < M_TRACK_COUNT; i++ ){
						ABint	left = 0;
						ABint	width = 0;
						ABbool	active = true;
						
						//	::TODO::	 +objOffset.m_width̗p@킩
						//	1ṔAS 1234567
						//	2ṔA1234567 S

						//	objB͋{AobjW͋{+1ZÂ
						//	i 0, 1, 2, 3, 4, 5...
						//	W 0, 1, 1, 2, 2, 3 
						//	B 0, 0, 1, 1, 2, 2, 3,...
						left = objW->mSprite.m_width * ( ( i + 1 ) / 2 ) + objB->mSprite.m_width *  ( i / 2 ) ;
						
						switch( i ){
							case M_TRACK_1_W:
							case M_TRACK_3_W:
							case M_TRACK_5_W:
							case M_TRACK_7_W:
								width	= objW->mSprite.m_width; 
								break;
							case M_TRACK_2_B:
							case M_TRACK_4_B:
							case M_TRACK_6_B:
								width	= objB->mSprite.m_width; 
								break;
							case M_TRACK_S:
								//	RIGHT SIDE
								width =objS->mSprite.m_width; 
								break;
						}

						if( i != M_TRACK_S ){
							//	XNb`͔ΑȂ̂ŁAgbN 1 - 7 ɂ̓XNb`̑傫Z
							this->m_trackFieldP1[i].active = active;
							this->m_trackFieldP1[i].area.set( 	playFieldP1.left + left + objS->mSprite.m_width, 
																playFieldP1.top, 
																width, 
																playFieldP1.height );
																
							this->m_trackFieldP2[i].active = active;
							this->m_trackFieldP2[i].area.set( 	playFieldP2.left + left + objS->mSprite.m_width, 
																playFieldP1.top, 
																width, 
																playFieldP1.height );
						}
						else{
							//	XNb`͔ΑȂ̂ŁAXNb`̈ʒu͍[ɂ
							this->m_trackFieldP1[i].active = active;
							this->m_trackFieldP1[i].area.set( 	playFieldP1.left, 
																playFieldP1.top, 
																width, 
																playFieldP1.height );
																
							this->m_trackFieldP2[i].active = active;
							this->m_trackFieldP2[i].area.set( 	playFieldP2.left, 
																playFieldP1.top, 
																width, 
																playFieldP1.height );
						}
						
					}
					break;
			}
			
			//	DEBUG
			//printf( "P1: Trk:%3d, %3d, %3d, %3d, %3d, %3d\n", i + 1, this->m_trackFieldP1[i].active, this->m_trackFieldP1[i].area.left, this->m_trackFieldP1[i].area.top, this->m_trackFieldP1[i].area.width, this->m_trackFieldP1[i].area.height );
			//printf( "P2: Trk:%3d, %3d, %3d, %3d, %3d, %3d\n", i + 1, this->m_trackFieldP2[i].active, this->m_trackFieldP2[i].area.left, this->m_trackFieldP2[i].area.top, this->m_trackFieldP2[i].area.width, this->m_trackFieldP2[i].area.height );

		}
	
		//	obNCg̔zu
		//	gbN̈悪m肵Ă̂ŁA[hʂɂ鏈͕svłB
		{ 
			//	5 key mode / nomal layout
			{
				//	1, 3, 5, 7 / 1P, 2P
				{
					ABint	trackNumbers[]={
						M_TRACK_1_W, M_TRACK_3_W, M_TRACK_5_W, M_TRACK_7_W, 	//	1P
						M_TRACK_1_W, M_TRACK_3_W, M_TRACK_5_W, M_TRACK_7_W, 	//	2P
					};
					ABuint	trackNumber = 0;	//	gbN
					ABuint	count1 = inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_WHITE );
					for( ABint i = 0; i < count1; i++ ){
						ABVAItemSpriteObject*	obj1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_WHITE, i ));
						MTrackInfo*				trackInfo;
						ABVAItemSpriteObject**	trackObject;
						trackNumber = trackNumbers[ i ];
						if( i < 4 ){
							trackInfo = &this->m_trackFieldP1[trackNumber];
							trackObject = &this->mTrackObjectP1[trackNumber];
						}
						else{
							trackInfo = &this->m_trackFieldP2[trackNumber];
							trackObject = &this->mTrackObjectP2[trackNumber];
						}
						if( trackInfo->active ){
							//	\gbN
							trackInfo->itemObject = obj1;	//	gbN񂩂tł悤ɑĂB
							obj1->mSprite.m_locate.x = trackInfo->area.left;
							obj1->mSprite.m_locate.y = trackInfo->area.top;
							obj1->mSprite.update();
							*trackObject = obj1;
						}
						else{
							//	BgbN
							obj1->mSprite.m_visible = false;
							*trackObject = NULL;
						}
					}
				}
				//	2. 4. 6 / 1P, 2P
				{
					ABint	trackNumbers[]={
						M_TRACK_2_B, M_TRACK_4_B, M_TRACK_6_B, 	//	1P
						M_TRACK_2_B, M_TRACK_4_B, M_TRACK_6_B, 	//	2P
					};
					ABuint	trackNumber = 1;	//	gbN
					ABuint	count1 = inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_BLACK );
					for( ABint i = 0; i < count1; i++ ){
						ABVAItemSpriteObject*	obj1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_BLACK, i ));
						MTrackInfo*				trackInfo;
						ABVAItemSpriteObject**	trackObject;
						trackNumber = trackNumbers[ i ];
						if( i < 3 ){
							trackInfo = &this->m_trackFieldP1[trackNumber];
							trackObject = &this->mTrackObjectP1[trackNumber];
						}
						else{
							trackInfo = &this->m_trackFieldP2[trackNumber];
							trackObject = &this->mTrackObjectP2[trackNumber];
						}
						if( trackInfo->active ){
							//	\gbN
							trackInfo->itemObject = obj1;	//	gbN񂩂tł悤ɑĂB
							obj1->mSprite.m_locate.x = trackInfo->area.left;
							obj1->mSprite.m_locate.y = trackInfo->area.top;
							obj1->mSprite.update();
							*trackObject = obj1;
						}
						else{
							//	BgbN
							obj1->mSprite.m_visible = false;
							*trackObject = NULL;
						}
						trackNumber += 2;
					}
				}
				//	Scrach / 1P, 2P
				{
					ABuint	count1 = inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_SCRATCH );
					for( ABint i = 0; i < count1; i++ ){
						ABVAItemSpriteObject*	obj1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_BACK_LIGHT_SCRATCH, i ));
						MTrackInfo*				trackInfo;
						ABVAItemSpriteObject**	trackObject;

						if( i == 0 ){
							trackInfo = &this->m_trackFieldP1[M_TRACK_S];
							trackObject = &this->mTrackObjectP1[M_TRACK_S];
						}
						else{
							trackInfo = &this->m_trackFieldP2[M_TRACK_S];
							trackObject = &this->mTrackObjectP2[M_TRACK_S];
						}
						if( trackInfo->active ){
							//	\gbN
							trackInfo->itemObject = obj1;	//	gbN񂩂tł悤ɑĂB
							obj1->mSprite.m_locate.x = trackInfo->area.left;
							obj1->mSprite.m_locate.y = trackInfo->area.top;
							obj1->mSprite.update();
							*trackObject = obj1;
						}
						else{
							//	BgbN
							obj1->mSprite.m_visible = false;
							*trackObject = NULL;
						}

					}
				}
			}
		} 
		
		//	摜F߂̃C
		{
			ABuint	count1 = inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_BAR_P1 );
			ABuint	count2 = inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_BAR_P2 );
			
			for( ABint i = 0; i < count1; i++ ){
				ABVAItemSpriteObject*	obj1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_BAR_P1, i ));
				obj1->mSprite.m_locate.x += playFieldP1.left;
				obj1->mSprite.m_locate.y += playFieldP1.top + i * 10;
				obj1->mSprite.update();
			}
			for( ABint i = 0; i < count2; i++ ){
				ABVAItemSpriteObject*	obj2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_BAR_P2, i ));
				obj2->mSprite.m_locate.x += playFieldP2.left;
				obj2->mSprite.m_locate.y += playFieldP2.top + playFieldP2.height - i * 10;
				obj2->mSprite.update();
			}
		}
		
		//	
		{
			//	t[XNb`Template
			ABVAItemSprite*			itemFS = static_cast<ABVAItemSprite*>(inRunner->getItem( ABVA_ITEM_ID_PLAY_SPRITE_TEMPLATE_NOTE_FREE_SCRATCH ));
			ABVAItemSpriteObject*	objFS = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_TEMPLATE_NOTE_FREE_SCRATCH, 0 ));
			//	ZWύX
//			objFS->mSprite.m_texCoord[0].x = (ABfloat32)(itemFS->mCellLeft + itemFS->mCellWidth) / (ABfloat32)objFS->mSurfaceWidth;
//			objFS->mSprite.m_texCoord[1].x = (ABfloat32)(itemFS->mCellLeft + itemFS->mCellWidth * 2) / (ABfloat32)objFS->mSurfaceWidth;
			objFS->mSprite.m_height = BMS_SEQ_EVENT_RESOLUTION4;	//	4̍
			objFS->mSprite.update();
		}

		//	WbWIuWFNg 1P
		{
			ABVAItemSpriteObject*		judgeObj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_JUDGE_P1, 0 ));
			ABVAItemTextSpriteObject*	comboObj = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_COMBO_COUNTER_P1, 0 ));

			judgeObj->mSprite.m_locate.x = playFieldP1.left;
			comboObj->mTextSprite->mLocate.x = judgeObj->mSprite.m_locate.x + judgeObj->mSprite.m_width;
			comboObj->mTextSprite->setVisible( false);
		}
		//	WbWIuWFNg 2P
		{
			ABVAItemSpriteObject*		judgeObj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_JUDGE_P2, 0 ));
			ABVAItemTextSpriteObject*	comboObj = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_COMBO_COUNTER_P2, 0 ));

			comboObj->mTextSprite->mLocate.x = playFieldP2.left;
			judgeObj->mSprite.m_locate.x = comboObj->mTextSprite->mLocate.x + comboObj->mTextSprite->mWidth * comboObj->mTextSprite->mTextLengthMax;
			
			//	2P̏ꍇ́AlIǂɂ͂ݏoȂ悤ʒuɂ炷B
			ABint	width = judgeObj->mSprite.m_width + comboObj->mTextSprite->mWidth * comboObj->mTextSprite->mTextLengthMax - playFieldP2.width;
			judgeObj->mSprite.m_locate.x -= width;
			comboObj->mTextSprite->mLocate.x -= width;
			comboObj->mTextSprite->setVisible( false);
		}
	}

	//	TENSION GAUGE
	{
		ABuint	count1 = inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P1 );
		ABuint	count2 = inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P2 );
		ABVAItemSpriteObject*	obj1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P1, 0 ));
		ABVAItemSpriteObject*	obj2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P2, 0 ));
		ABVAItemSpriteObject*	objOffset = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P2_OFFSET, 0 ));
		
		for( ABint i = 0; i < count1; i++ ){
			ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P1, i ));
			obj->mSprite.m_locate.x = obj1->mSprite.m_locate.x + obj1->mSprite.m_width * i;
			obj->mSprite.update();
		}
		//	Player 2 ̓ItZbglZB
		for( ABint i = 0; i < count2; i++ ){
			ABVAItemSpriteObject*	obj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_TENSION_GAUGE_P2, i ));
			obj->mSprite.m_locate.x = obj1->mSprite.m_locate.x + objOffset->mSprite.m_locate.x + obj2->mSprite.m_width * i;
			obj->mSprite.m_locate.y = obj1->mSprite.m_locate.y + objOffset->mSprite.m_locate.y;
			obj->mSprite.update();
		}
	}
	
	{
		ABVAItemSpriteObject*	objBG1 	= static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOWvLOADING_BG, 0 ));
		ABVAItemSpriteObject*	objBG2 	= static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOWvLOADING_BG, 1 ));
		ABVAItemSpriteObject*	objLOGO = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOW_LOADING_LOGO, 0 ));
		ABVAItemResImageObject*	objLOGOImg	 = static_cast<ABVAItemResImageObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_IMAGE_NOW_LOADING_LOGO, 0 ));
		ABVAItemSpriteObject*	objBar = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_PROGRESS_BAR, 0 ));

		//	Q[XN[̃TCY擾Br[iEBhEtXN[j̃TCYƂ͕člĂB
		ABint	viewWidth, viewHeight;
		inRunner->getGameScreenSize( &viewWidth, &viewHeight);

		objBG1->mSprite.m_locate.x = 0;
		objBG1->mSprite.m_locate.y = 0;
		objBG1->mSprite.m_width 	= viewWidth;
		objBG1->mSprite.m_height = viewHeight;
		objBG1->mSprite.m_visible = false;
		objBG1->mSprite.update();

		objBG2->mSprite.m_locate = objBG1->mSprite.m_locate;
		objBG2->mSprite.m_width = objBG1->mSprite.m_width;
		objBG2->mSprite.m_height = objBG1->mSprite.m_height;
		objBG2->mSprite.m_visible = false;
		objBG2->mSprite.update();

		//	MacBeat XL[ auto ̂̂摜ɃtBbgBnone͖B̂͂ÂꂾnoneautoƂĂ˂΂ȂȂ
		objLOGO->mSprite.m_locate.x = 0;
		objLOGO->mSprite.m_locate.y = (viewHeight - objLOGO->mSprite.m_height) / 2;
		if( objLOGO->mSprite.m_width == 0 ){
			ABint	rw, rh, tw, th;
			objLOGOImg->mTexture.getSize( &rw, &rh );
			objLOGOImg->mTexture.getTextureSize( &tw, &th );
			objLOGO->mSprite.m_width = rw;
			objLOGO->mSprite.m_height = rh;
			objLOGO->mSprite.m_texCoord[1].x = (ABfloat32)rw / (ABfloat32)tw;
			objLOGO->mSprite.m_texCoord[1].y = (ABfloat32)rh / (ABfloat32)th;
		}
		objLOGO->mSprite.m_visible = false;
		objLOGO->mSprite.update();

		objBar->mSprite.m_width 	= viewWidth;
		objBar->mSprite.m_height 	= 16;
		objBar->mSprite.m_locate.x 	= 0;
		objBar->mSprite.m_locate.y 	= viewHeight - objBar->mSprite.m_height - 4;
		objBar->mSprite.m_visible 	= false;
		objBar->mSprite.update();
	}

	return ret;
}

//-------------------------------------------------------------------------------------------------
//	I
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStagePlay::finalize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{ 
}

//-------------------------------------------------------------------------------------------------
//	Render
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStagePlay::render( ABVARunner*  inRunner, ABVAItemBinder*  inBinder )
{
	ABint	i;
	ABVAItemBindStagePlay*	binder = static_cast<ABVAItemBindStagePlay*>(inBinder);

	//	Render Back lightIuWFNg
	this->renderBackLight( inRunner, binder );
	//	Render Back lIIuWFNg
	this->renderNeonObjects( inRunner, binder );
	//	Render NoteIuWFNg
	this->renderNoteObjects( inRunner, binder );
	//	Render JudgeIuWFNg
	this->renderJudgeObjects( inRunner, binder );
	//	Render 摜
	this->renderBGA( inRunner, binder );
	
	//	_Ci~bNoC_[̒lXV
	{
		snprintf( binder->mPramam.mValueBPM.mCString, ABVAItemBindStagePlay::M_CSTRING_SIZE, "%3d", binder->mBMSPlayerData->bpm );
		snprintf( binder->mPramam.mValueFPS.mCString, ABVAItemBindStagePlay::M_CSTRING_SIZE, "%3d", (ABint)GameTimer::getFrameRate() );

		ABVAItemBindStagePlay::MParam::Player*		bindValue[] ={
			&binder->mPramam.Player1,
			&binder->mPramam.Player2,
		};
		for( i = 0 ; i < BMS_BMSEQ_EVENT_PLAYER_COUNT; i++ ){
			BMSConsumer*		comsumer = binder->mBMSPlayerData->comsumer[i];
			snprintf( bindValue[i]->mValueScore.mCString, 			ABVAItemBindStagePlay::M_CSTRING_SIZE, "%06d", comsumer->m_score.totalScore );
			snprintf( bindValue[i]->mValueCountJustGreat.mCString, 	ABVAItemBindStagePlay::M_CSTRING_SIZE, "%4d", comsumer->m_score.judgeNoteCount[BMS_SEQ_JUDGE_JUST_GREATE] );
			snprintf( bindValue[i]->mValueCountGreat.mCString, 		ABVAItemBindStagePlay::M_CSTRING_SIZE, "%4d", comsumer->m_score.judgeNoteCount[BMS_SEQ_JUDGE_GREATE] );
			snprintf( bindValue[i]->mValueCountGood.mCString, 		ABVAItemBindStagePlay::M_CSTRING_SIZE, "%4d", comsumer->m_score.judgeNoteCount[BMS_SEQ_JUDGE_GOOD] );
			snprintf( bindValue[i]->mValueCountBad.mCString, 		ABVAItemBindStagePlay::M_CSTRING_SIZE, "%4d", comsumer->m_score.judgeNoteCount[BMS_SEQ_JUDGE_BAD] );
			snprintf( bindValue[i]->mValueCountPoor.mCString, 		ABVAItemBindStagePlay::M_CSTRING_SIZE, "%4d", comsumer->m_score.judgeNoteCount[BMS_SEQ_JUDGE_POOR] );
			snprintf( bindValue[i]->mValueCountCombo.mCString, 		ABVAItemBindStagePlay::M_CSTRING_SIZE, "%4d", comsumer->m_score.comboCount );
			snprintf( bindValue[i]->mValueCountTotal.mCString, 		ABVAItemBindStagePlay::M_CSTRING_SIZE, "%4d", comsumer->m_score.totalJudgeNoteCount );
			snprintf( bindValue[i]->mValueComboCounter.mCString, 	ABVAItemBindStagePlay::M_CSTRING_SIZE, "%4d", comsumer->m_score.grateComboCount );
			bindValue[i]->mValueTension.mValue = comsumer->m_score.barometerJudge;
		}
//		snprintf( binder->mPramam.mValuePlaingTimer.mCString, ABVAItemBindStagePlay::M_CSTRING_SIZE, "%3d", abs( rand() % 999 ) );
		binder->mPramam.mValueLocation.mValue = this->m_bmsLocate / BMS_SEQ_EVENT_RESOLUTION4;
	}
	
	for( i = 0 ; i < BMS_BMSEQ_EVENT_PLAYER_COUNT; i++ ){
		binder->mBMSPlayerData->judgeType[i] = -1;
	}
}

//-------------------------------------------------------------------------------------------------
//	NoteIuWFNgǉ
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStagePlay::addNoteObjects( ABVARunner*  inRunner, BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrackType  inTrackNumber, ABint  inLocation, ABbool  inIsAsssign ) 
{
	ABint			trackNumber = ms_trackNumberArray[inTrackNumber];
	ABint			playerNumber = ( inPlayerNumber == BMS_BMSEQ_EVENT_PLAYER1 ? 0 : 1 );
	MTrackInfo*		playerField = ( inPlayerNumber == BMS_BMSEQ_EVENT_PLAYER1 ? &this->m_trackFieldP1[ trackNumber ] : &this->m_trackFieldP2[ trackNumber ] );
	ABbool			freeScratch = ( inTrackNumber == BMS_SEQ_TRACK_KEY_SCRATCH_FREE ? true : false );
	
	//	ǉ
	
	//	LȃgbNH
	if( playerField->active ){
	
		ABbool	checkCount;
		ABuint	spriteNumber;
		GEUniqueNumber*				uniqueNumber;
		ABVAItemSpriteObject*		objNote;
		ABfloat32	alphaColor = 1.0f;
		
		if( inIsAsssign ){
			alphaColor = 0.5f;
		}


		//	IuWFNg擾
		if( ! freeScratch ){
			//	ʂ̉
			checkCount		= this->m_noteNumber.getUseCount() < inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_NOTE_OBJECT );
			if( checkCount ){
				spriteNumber	= this->m_noteNumber.getNewNumber();
				uniqueNumber	= &this->m_noteNumber;
				objNote			= static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOTE_OBJECT, spriteNumber ));
			}
		}
		else{
			//	łt[XNb`
			checkCount		= this->m_freeScracthNumber.getUseCount() < inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_FREE_SCRATCH_OBJECT );
			if( checkCount ){
				spriteNumber	= this->m_freeScracthNumber.getNewNumber();
				uniqueNumber	= &this->m_freeScracthNumber;
				objNote			= static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_FREE_SCRATCH_OBJECT, spriteNumber ));
			}
		}
		if( ! checkCount ){
			ABReportError( "Sprite count over.many note objects." );
		}
		else{
			
			//	W
			objNote->mSprite.m_locate.x = playerField->area.left;
			objNote->mSprite.m_locate.y = 0;
			
			//	ZύX
			ABVAItemSpriteObject*	objNoteCell;
			switch( trackNumber ){
				case M_TRACK_1_W:
				case M_TRACK_3_W:
				case M_TRACK_5_W:
				case M_TRACK_7_W:
					objNoteCell = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOTE_WHITE, 0 ));
					break;

				case M_TRACK_2_B:
				case M_TRACK_4_B:
				case M_TRACK_6_B:
					objNoteCell = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOTE_BLACK, 0 ));
					break;

				case M_TRACK_S:
					if( freeScratch ){
						objNoteCell = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_TEMPLATE_NOTE_FREE_SCRATCH, 0 ));
						alphaColor = 0.7;
					}
					else{
						objNoteCell = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NOTE_SCRACH, 0 ));
					}
					break;
			}
			objNote->mSprite.m_texCoord[0] = objNoteCell->mSprite.m_texCoord[0];
			objNote->mSprite.m_texCoord[1] = objNoteCell->mSprite.m_texCoord[1];
			objNote->mSprite.m_width = objNoteCell->mSprite.m_width;
			objNote->mSprite.m_height = objNoteCell->mSprite.m_height;
			objNote->mSprite.m_color.a = alphaColor;
			
			//	 ŃAbvf[g
			objNote->mSprite.update();
			
			objNote->mSprite.m_visible = true;
			ABLocalDebug( printf("NOTE PUSH this->m_useSpriteList [location %8d][bar ocation %8d]\n", this->m_bmsLocate, inLocation ); );
			this->m_useSpriteList.push_back( MFallObjectInfo( uniqueNumber, playerNumber, playerField, inLocation, trackNumber, objNote, true, inIsAsssign ) );
		}

	}
}

//-------------------------------------------------------------------------------------------------
//	o[IuWFNgǉ
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStagePlay::addBareObjects( ABVARunner*  inRunner, ABint  inLocation ) 
{
	ABint			locateY =  inLocation - this->m_bmsLocate;			//	P[V
	ABfloat32		basePoint = m_greateZoneTop1;

	//	o[ǉ
	ABLocalDebug( printf("    +request event: vibrant change BAR PUSH this->m_useSpriteList [location %8d][bar ocation %8d]\n", this->m_bmsLocate, inLocation ); );
	{

		ABuint	spriteCount = inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_BAR_P1 );
		if( this->m_barNumber1.getUseCount() < spriteCount ){
			ABuint	spriteNumber = this->m_barNumber1.getNewNumber();
			ABVAItemSpriteObject*	objBar = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_BAR_P1, spriteNumber ));

			objBar->mSprite.m_locate.y = basePoint - locateY;
			objBar->mSprite.m_visible = true;
			this->m_useSpriteList.push_back( MFallObjectInfo( &this->m_barNumber1, 0, &this->m_trackFieldP1[M_TRACK_1_W], inLocation, M_TRACK_1_W, objBar, false ) );
		}
	} 
	{
		ABuint	spriteCount = inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_BAR_P2 );
		if( this->m_barNumber2.getUseCount() < spriteCount ){
			ABuint	spriteNumber = this->m_barNumber2.getNewNumber();
			ABVAItemSpriteObject*	objBar = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_BAR_P2, spriteNumber ));

			objBar->mSprite.m_locate.y = basePoint - locateY;
			objBar->mSprite.m_visible = true;
			this->m_useSpriteList.push_back( MFallObjectInfo( &this->m_barNumber2, 1, &this->m_trackFieldP2[M_TRACK_1_W], inLocation, M_TRACK_1_W, objBar, false ) );
		}
	}
}

//-------------------------------------------------------------------------------------------------
//	Render Back lightIuWFNg
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStagePlay::renderBackLight( ABVARunner*  inRunner, ABVAItemBindStagePlay*  inBinder ) 
{
	ABint	p, i;
	ABfloat32	alphaSpeed 	= 0.05f;
	ABfloat32	alphaGain 	= 0.00f;


	for( p = 0; p < BMS_BMSEQ_EVENT_PLAYER_COUNT ; p++ ){
		for( i = 0; i < M_TRACK_COUNT ; i++ ){
			ABVAItemSpriteObject*	obj1;
			if( p == 0 ){
				obj1 = this->mTrackObjectP1[i];
			}
			else{
				obj1 = this->mTrackObjectP2[i];
			}
			
			if( obj1 ){
				//	Press ?
				ABbool	press = inBinder->mTrackBackLightPress[p][ this->ms_seqTrackNumberArray[i] ];
				inBinder->mTrackBackLightPress[p][ this->ms_seqTrackNumberArray[i] ] = false;
				if( press ){
					obj1->mSprite.m_visible = press;
					obj1->mSprite.m_color.a = 1.0f;
				}

				//	
				if( obj1->mSprite.m_visible ){
					obj1->mSprite.m_color.a -=  alphaSpeed;
					if( obj1->mSprite.m_color.a < alphaGain ){
						obj1->mSprite.m_visible = false;
					}
				}
			}
		}
	}
}

//-------------------------------------------------------------------------------------------------
//	Render Back lIIuWFNg
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStagePlay::renderNeonObjects( ABVARunner*  inRunner, ABVAItemBindStagePlay*  inBinder ) 
{
	ABVAItemSprite*					item1 = static_cast<ABVAItemSprite*>(inRunner->getItem( ABVA_ITEM_ID_PLAY_SPRITE_NEON_P1));
	ABVAItemSprite*					item2 = static_cast<ABVAItemSprite*>(inRunner->getItem( ABVA_ITEM_ID_PLAY_SPRITE_NEON_P2));
	ABVAItemAnimationObject*		objAnime1 = static_cast<ABVAItemAnimationObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NEON_ANIME_P1, 0 ));
	ABVAItemAnimationObject*		objAnime2 = static_cast<ABVAItemAnimationObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_NEON_ANIME_P2, 0 ));
	ABint	judge = -1, j = -1;
	ABint	i;
	for( i = 0 ; i < BMS_BMSEQ_EVENT_PLAYER_COUNT ; i++ ){
		switch( inBinder->mBMSPlayerData->judgeType[i] ){
			case BMS_SEQ_JUDGE_JUST_GREATE:
				j = 3;
				break;

			case BMS_SEQ_JUDGE_GREATE:
				j = 2;
				break;

			case BMS_SEQ_JUDGE_GOOD:
				j = 1;
				break;

			case BMS_SEQ_JUDGE_BAD:
				j = 0;
				break;

			case BMS_SEQ_JUDGE_POOR:
			default:
				j = -1;
				break;
		}
		if( judge < j ){
			judge = j;
		}
	}
	item1->mCellNumber.x = judge;
	item2->mCellNumber.x = judge;
	if( 0 <= judge ){
		objAnime1->play();
		objAnime2->play();
	}
}
//-------------------------------------------------------------------------------------------------
//	Render NoteIuWFNg
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStagePlay::renderNoteObjects( ABVARunner*  inRunner, ABVAItemBindStagePlay*  inBinder )
{
	static	ABint	c = 0;
	ABGamePreference::Config*	playConfig = &( ABGetPreference().playConfig );
	
	ABVAItemAnimation*		noteAnimeItem = static_cast<ABVAItemAnimation*>(inRunner->getItem( ABVA_ITEM_ID_PLAY_SPRITE_NOTE_ANIME ));
	ABuint					sparkCount = inRunner->getInstanceCount( ABVA_ITEM_ID_PLAY_SPRITE_BAR_P1 );
	ABbool					sparkFlag[ M_TRACK_COUNT * 2 ];
	memset( sparkFlag, false, sizeof( ABbool ) * M_TRACK_COUNT * 2 );

	//	ړ
	//	Ȃ̂o[Ȃ̂AʂsvɂȂĂ邱ƂɒӂĂB
	MUseNumberLIstIt	it;
	ABint	o = 0;
	for( it = this->m_useSpriteList.begin(); it != this->m_useSpriteList.end(); it++ ){
		MFallObjectInfo*		objectInfo = &(*it);
		MTrackInfo*				playerField	= objectInfo->trackField;
		ABVAItemSpriteObject*	obj			= objectInfo->itemObject;
		GEUniqueNumber*			rentalNumber= objectInfo->rentalNumber;
		ABbool					isNote		= objectInfo->isNote;
		ABint					trackNumber = objectInfo->trackNumber;
		ABint					playerNumber = objectInfo->playerNumber;
		ABbool					isAsssign	= objectInfo->isAsssign;

		//	YẂA݂locationƁAĂIuWFNglocation狁߂B
		//	yI𑜓xƁAhbg͈vĂ̂ŁAꏬ߂192\ƂƂ́AP192hbgƂčlB
		ABfloat32	locationReach = objectInfo->location - this->m_bmsLocate;
		
		//	]āAXs[h𒲐̂́ÂPsŊȂ̂łB
		locationReach *= playConfig->hiSpeedRate;

		//	YWړ
		obj->mSprite.m_locate.y	= m_greateZoneTop1 - locationReach;
		if( isNote ){
			obj->mSprite.m_locate.y	-= obj->mSprite.m_height;
		}
		/*
		if( obj->mSprite.m_locate.y < playerField->area.top ){
			obj->mSprite.m_visible = false;
		}
		else{
			obj->mSprite.m_visible = true;
		}
		*/

		//	 ŃAbvf[g
		obj->mSprite.update();

		if( (objectInfo->location + obj->mSprite.m_height) < this->m_bmsLocate ){
			//	XvCgԍԂāA
			rentalNumber->releaseNumber( obj->getInstanceNumber() );
			//	
			obj->mSprite.m_visible = false;
			it = this->m_useSpriteList.erase( it );

			//	for ́@it++ łP΂Đił܂̂Ŗ߂ĂB
			//	YĂƁA邽тɎ̉uււvČi΁jɕρIƂŏ΂
			--it;	
			
			if( ! isNote ){
			}
			else{
				//	̂Ƃ́ASPARK\
				sparkFlag[ M_TRACK_COUNT * playerNumber + trackNumber ] = true;
			}
		}

		//	o[̂Ƃ́AAnimationu[N
		if( ! isNote ){
			//	SڂŃLƁAyIɊiDH
			//	4 BEAT ... 1,2,3,LIA1,2,3,
/*	
			if( (objectInfo->location - (BMS_SEQ_EVENT_RESOLUTION4) ) < this->m_bmsLocate &&
				this->m_bmsLocate <= (objectInfo->location - BMS_SEQ_EVENT_RESOLUTION4 + 12 ) 
			){
				noteAnimeItem->breakbeatAnimation();
			}
*/
			//	4 BEATȊOƂ܂̂Ŏ߁ijRqƂQqƂLꂿႤ
			if( objectInfo->location  < this->m_bmsLocate ){
				noteAnimeItem->breakbeatAnimation();
			}
		}

	}

	//	SPARK
	{
		for( ABuint i = 0 ; i < sparkCount; i++ ){
			ABVAItemSpriteObject*			objSpark = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_SPARK, i ));
			ABVAItemAnimationObject*		objAnime1 = static_cast<ABVAItemAnimationObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_SPARK_ANIME, i ));


			if( sparkFlag[ i ] ){
				MTrackInfo*		playerFieldSpark = (  i < M_TRACK_COUNT ? &this->m_trackFieldP1[ i ] : &this->m_trackFieldP2[ i - M_TRACK_COUNT ] );
				ABuint			greateZoneTop = (  i < M_TRACK_COUNT ? this->m_greateZoneTop1 : this->m_greateZoneTop2 );

				if( playerFieldSpark->active ){
					objSpark->mSprite.m_locate.x = playerFieldSpark->area.left + (playerFieldSpark->area.width - objSpark->mSprite.m_width) / 2;
					objSpark->mSprite.m_locate.y = greateZoneTop - objSpark->mSprite.m_width / 2;
					objSpark->mSprite.m_visible = true;
					objAnime1->play();
				}
			}
			else if ( ! objAnime1->isPlay() ){
				//	AjIĂABĂ
				objSpark->mSprite.m_visible = false;
				objSpark->mSprite.m_locate.y = -200;
			}
		}
	}

}
//-------------------------------------------------------------------------------------------------
//	Render JudgeIuWFNg
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStagePlay::renderJudgeObjects( ABVARunner*  inRunner, ABVAItemBindStagePlay*  inBinder )
{
	static	ABuint	animationTime = 60;
	ABuint	i;
	ABuint	judge = 0;
	ABuint	cellNumberY;
	
	ABuint	judgeID[] = {
		ABVA_ITEM_ID_PLAY_SPRITE_JUDGE_P1, ABVA_ITEM_ID_PLAY_SPRITE_JUDGE_P2
	};
	ABuint	comboID[] = {
		ABVA_ITEM_ID_PLAY_SPRITE_COMBO_COUNTER_P1, ABVA_ITEM_ID_PLAY_SPRITE_COMBO_COUNTER_P2
	};
	GGRecti*	field[]={
		&this->m_playField1, &this->m_playField2
	};
	ABuint*	animeCountArray[] = {
		&this->mJudgeAnimeCountP1, &this->mJudgeAnimeCountP2,
	};
	ABuint*	animeCellArray[] = {
		&this->mJudgeAnimeCellNumberP1, &this->mJudgeAnimeCellNumberP2,
	};

	for( i = 0 ; i < BMS_BMSEQ_EVENT_PLAYER_COUNT ; i++ ){
		ABVAItemSpriteObject*		judgeObj = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( judgeID[i], 0 ));
		ABVAItemTextSpriteObject*	comboObj = static_cast<ABVAItemTextSpriteObject*>(inRunner->getInstance( comboID[i], 0 ));

		BMSSeqJudgeType	jt;
		jt =  inBinder->mBMSPlayerData->judgeType[i] ;
		switch( jt ){
			case BMS_SEQ_JUDGE_JUST_GREATE:
				cellNumberY = 4;
				break;

			case BMS_SEQ_JUDGE_GREATE:
				cellNumberY = 3;
				break;

			case BMS_SEQ_JUDGE_GOOD:
				cellNumberY = 2;
				break;

			case BMS_SEQ_JUDGE_BAD:
				cellNumberY = 1;
				break;

			case BMS_SEQ_JUDGE_POOR:
				cellNumberY = 0;
				break;
		}
		
		ABuint*		animeCount = animeCountArray[ i ];
		ABuint*		animeCell = animeCellArray[i];
		if( 0 <= jt ){
			*animeCount = animationTime;
			*animeCell = cellNumberY;

			judgeObj->mSprite.m_locate.y = this->m_greateZoneTop1 - 96.0f;	//	judge̕\ʒuł
			judgeObj->setCellNumber( 0, cellNumberY );
			judgeObj->mSprite.m_color.a = 1.0f;
			judgeObj->mSprite.m_visible = true;

			if( 3 < inBinder->mBMSPlayerData->comsumer[i]->m_score.grateComboCount ){
				comboObj->mTextSprite->mLocate.y = judgeObj->mSprite.m_locate.y;
				comboObj->mTextSprite->mColor.a = judgeObj->mSprite.m_color.a;
				comboObj->mTextSprite->updateColor();
				comboObj->mTextSprite->setVisible( true );
			}
			else{
			comboObj->mTextSprite->setVisible( false );
			}

			//	comboObj́A_Ci~bNoChKpĂ̂ŁAŃAbvf[gȂĂOKB
			judgeObj->mSprite.update();
		}
		else{
			//	
			if( 0 < *animeCount ){
				ABfloat32	speed = (ABfloat32)(animationTime - *animeCount) * 0.05f;
				speed	*= speed;	//	Ă݂
				
				judgeObj->mSprite.m_color.a = (ABfloat32)*animeCount / (ABfloat32)animationTime;
				comboObj->mTextSprite->mColor.a = judgeObj->mSprite.m_color.a;
				
				if( 5 < (animationTime - *animeCount) ){
					judgeObj->mSprite.m_locate.y	 -= speed;
					comboObj->mTextSprite->mLocate.y -= speed;
					judgeObj->mSprite.update();
				}

				//	WXgO[gAnimation
				if( (*animeCount & 3) == 0 && 4 <= *animeCell ){
					++(*animeCell);
					if( 7 < *animeCell ){
						*animeCell = 4;
					}
					judgeObj->setCellNumber( 0, *animeCell );
				}

				comboObj->mTextSprite->updateColor();
				--*animeCount;

			}
			else{
				judgeObj->mSprite.m_visible = false;
				comboObj->mTextSprite->setVisible( false );
			}
		}
	}
}
//-------------------------------------------------------------------------------------------------
//	Render 摜
//-------------------------------------------------------------------------------------------------
void	ABMBVAItemRenderStagePlay::renderBGA( ABVARunner*  inRunner, ABVAItemBindStagePlay*  inBinder )
{
	ABVAItemResImageObject*			imagePoor[M_Count];
	imagePoor[M_NoAnimation] = static_cast<ABVAItemResImageObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_POOR_IMAGE_0, 0 ));
	imagePoor[M_PoorAnimation] = static_cast<ABVAItemResImageObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_POOR_IMAGE_1, 0 ));
	imagePoor[M_NoiseAnimation1] = static_cast<ABVAItemResImageObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_POOR_IMAGE_2, 0 ));
	imagePoor[M_NoiseAnimation2] = static_cast<ABVAItemResImageObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_POOR_IMAGE_3, 0 ));
	
	ABVAItemSpriteObject*	objLayer1 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_LAYER_0, 0 ));
	ABVAItemSpriteObject*	objLayer2 = static_cast<ABVAItemSpriteObject*>(inRunner->getInstance( ABVA_ITEM_ID_PLAY_SPRITE_LAYER_1, 0 ));

	ABint	texWidth =  0;
	ABint	texHeight =  0;
	ABint	imageWidth =  0;
	ABint	imageHeight =  0;
	GGTexture*				texture = NULL;
	ABVAItemBindStagePlay::MBMSDrawInfo::Poor*		poor = &inBinder->mBMSDrawInfo.mPoor;

	//	BGA̕ύX
	if( poor->visible ){
	
		//	poor摜\
		if( poor->counter == 0 ){

			//	\Jn
			poor->counter = 16;
			
			//	frontC[B
			objLayer2->mSprite.m_visible = false;

			//	poor摜backC[ɕ\
			objLayer1->mSprite.m_visible = true;
			if( poor->poorNumber == 0 ){
			
				//	SCHEMEw̉摜
				objLayer1->mSprite.m_textureName = imagePoor[ M_PoorAnimation ]->mTexture.getTextureName();
			}
			else if( poor->texture != NULL ){
				objLayer1->mSprite.m_textureName = poor->texture->getTextureName();
			}
			else{
				objLayer1->mSprite.m_visible = false;
			}
			return;
			
		}
		else{
			//	poor摜\
			--poor->counter;
			if( poor->poorNumber <= 0 ){
			
				//	poor\I
				//	̉摜\
				poor->visible = false;
			}
		}
	}
	
	if( inBinder->mBMSDrawInfo.mHaveBGA ){
	
		//	ʕ`͕b60BBMSt͂B]āABGA\肱ڂĂ܂B
		//	XggāAmɕ\B

		//	Back
		ABVAItemBindStagePlay::MBMSDrawInfo::MBGAInfoList*	bgaInfoList = &( inBinder->mBMSDrawInfo.mBGAInfoList[ BMS_BMSEQ_BGA_LAYER_0 ] );
		if( !bgaInfoList->empty() ){
			ABVAItemBindStagePlay::MBMSDrawInfo::MBGAInfo		bgaInfo = 	bgaInfoList->front();
			bgaInfoList->pop_front();

			objLayer1->mSprite.m_visible = false;
			texture = bgaInfo.mTextureLayer;
			if( texture ){
				//	0w肷ƕsȃoOɂȂ̂ŒӁi<--ꎞԂǂ납Ԃ肷i
				if( 0 != texture->getTextureName() ){
					objLayer1->mSprite.m_textureName = texture->getTextureName();
					objLayer1->mSprite.m_visible = true;
				}
			}
		}
		
		//	Front
		bgaInfoList = &( inBinder->mBMSDrawInfo.mBGAInfoList[ BMS_BMSEQ_BGA_LAYER_1 ] );
		if( !bgaInfoList->empty() ){
			ABVAItemBindStagePlay::MBMSDrawInfo::MBGAInfo		bgaInfo = 	bgaInfoList->front();
			bgaInfoList->pop_front();

			objLayer2->mSprite.m_visible = false;
			texture = bgaInfo.mTextureLayer;
			if( texture ){
				//	0w肷ƕsȃoOɂȂ̂ŒӁi<--ꎞԂǂ납Ԃ肷i
				if( 0 != texture->getTextureName() ){
					objLayer2->mSprite.m_textureName = texture->getTextureName();
					objLayer2->mSprite.m_visible = true;
				}
			}
		}
	}
	else{
		objLayer1->mSprite.m_visible = true;
	}
}
