/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMBVAItemRenderStagePlay.cpp

				VA̕`s܂B
				KvɉĔhNX쐬܂B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABMBVAItemRenderStagePlay_h
#define	ABMBVAItemRenderStagePlay_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"GGRender.h"

#include	"ABVAItemRender.h"
#include	"ABVAItemBinderConfig.h"

#include	"BMSConfig.h"
#include	"BMSProgressReporter.h"

class	ABVAItemSpriteObject;
class	ABMBVAItemRenderStagePlay;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	ABMacbeatBMSProgressReporter
//
//	i󋵂񍐂NXB
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABMacbeatBMSProgressReporter : public	BMSProgressReporter{
private:
	ABVARunner*						m_runner;
	ABMBVAItemRenderStagePlay*		m_render;
	ABVAItemBindStagePlay*			m_binder;

public:
	ABMacbeatBMSProgressReporter( void );
	virtual ~ABMacbeatBMSProgressReporter();
	
	void	setup( ABVARunner*  inRunner, ABMBVAItemRenderStagePlay*  inRender, ABVAItemBindStagePlay*  inBinder );

	//	i񍐊Jn
	virtual	void	onBegin( void  );
	//	i񍐏I
	virtual	void	onEnd( void );
	//	i|[g
	virtual	void	onReport( const ABint  inSize, const ABint  inPosition );
	
};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	ABMBVAItemRenderStagePlay : public ABVAItemRender
{
public:
	enum{
		M_NoAnimation,
		M_PoorAnimation,
		M_NoiseAnimation1,
		M_NoiseAnimation2,
		M_Count,
	};

	enum{
		M_TRACK_1_W,
		M_TRACK_2_B,
		M_TRACK_3_W,
		M_TRACK_4_B,
		M_TRACK_5_W,
		M_TRACK_6_B,
		M_TRACK_7_W,

		M_TRACK_S,
		
		M_TRACK_COUNT,
	};
	
	ABint		m_bmsLocate;
	ABint		m_bmsPreLocate;
	
	ABMacbeatBMSProgressReporter		mProgressReporter;	//	ǂݍݏi

private:
	GGRecti		m_playField1;
	GGRecti		m_playField2;
	ABuint		m_greateZoneTop1;
	ABuint		m_greateZoneTop2;
	
	typedef	struct MTrackInfo{
		ABbool						active;		//	gbN̗LEtOB[hɂĂ@Set̂ŁAs͂ŔfB
		ABVAItemSpriteObject*		itemObject;	//	ACeQƗp
		GGRecti						area;
	} MTrackInfo;
	MTrackInfo		m_trackFieldP1[ M_TRACK_COUNT ];	//	1~7key + scratch
	MTrackInfo		m_trackFieldP2[ M_TRACK_COUNT ];	//	1~7key + scratch
	
	
	GEUniqueNumber	m_noteNumber;			//	XvCgǗB
	GEUniqueNumber	m_freeScracthNumber;	//	XvCg(t[XNb`)ǗB
	GEUniqueNumber	m_barNumber1;	//	o[XvCgǗB
	GEUniqueNumber	m_barNumber2;	//	o[XvCgǗB

	//	
	typedef	struct MFallObjectInfo{
		//	\̂̏ConstructorBSTLŖ𗧂B
		MFallObjectInfo( GEUniqueNumber*			inRentalNumber,
						ABint						inPlayerNumber,
						MTrackInfo*					inField, 
						ABint						inLocation, 
						ABint						inTrackNumber,
						ABVAItemSpriteObject*		inObj, 
						ABbool						inIsNote,
						ABbool						inIsAsssign = false
						 ){
			rentalNumber	= inRentalNumber;
			itemObject		= inObj;
			trackField		= inField;
			isNote			= inIsNote;
			trackNumber		= inTrackNumber;
			playerNumber	= inPlayerNumber;
			location		= inLocation;
			isAsssign		= inIsAsssign;
		}

		GEUniqueNumber*				rentalNumber;	//	ԍ̎؂
		ABVAItemSpriteObject*		itemObject;		//	ACeQƗp
		MTrackInfo*					trackField;		//	ǂ̃tB[hH
		ABbool						isNote;			//	H
		ABint						trackNumber;	//	gbNԍ
		ABint						playerNumber;	//	1P or 2P
		ABint						location;		//	BMS LOCATION
		ABbool						isAsssign;		//	AssignIuWFNgifobOpj
	} MFallObjectInfo;
	
	typedef	std::list<MFallObjectInfo>				MUseNumberLIst;
	typedef	MUseNumberLIst::iterator				MUseNumberLIstIt;
	MUseNumberLIst									m_useSpriteList;	//	Ǘ
	
	//	egbNIuWFNg
	ABVAItemSpriteObject*			mTrackObjectP1[ M_TRACK_COUNT ];
	ABVAItemSpriteObject*			mTrackObjectP2[ M_TRACK_COUNT ];
	
	//	judgeIuWFNgAnimationp
	ABuint		mJudgeAnimeCountP1;
	ABuint		mJudgeAnimeCountP2;
	ABuint		mJudgeAnimeCellNumberP1;
	ABuint		mJudgeAnimeCellNumberP2;
	
	static	ABint		ms_trackNumberArray[BMS_SEQ_TRACK_COUNT];
	static	BMSSeqEventTrackType		ms_seqTrackNumberArray[M_TRACK_COUNT];
	
	
public:
	ABMBVAItemRenderStagePlay( void );
	~ABMBVAItemRenderStagePlay( void );

	//	
	virtual ABbool	initialize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );
	//{
	//	return false;
	//}

	//	I
	virtual void	finalize( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );

	//	Render
	virtual void	render( ABVARunner*  inRunner, ABVAItemBinder*  inBinder );

public:
	//	NoteIuWFNgǉ
	void	addNoteObjects( ABVARunner*  inRunner, BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrackType  inTrackNumber, ABint  inLocation, ABbool  inIsAsssign = false );
	//	o[IuWFNgǉ
	void	addBareObjects( ABVARunner*  inRunner, ABint  inLocation );

private:
	//	Render Back lightIuWFNg
	void	renderBackLight( ABVARunner*  inRunner, ABVAItemBindStagePlay*  inBinder );
	//	Render NeonIuWFNg
	void	renderNeonObjects( ABVARunner*  inRunner, ABVAItemBindStagePlay*  inBinder );
	//	Render NoteIuWFNg
	void	renderNoteObjects( ABVARunner*  inRunner, ABVAItemBindStagePlay*  inBinder );
	//	Render JudgeIuWFNg
	void	renderJudgeObjects( ABVARunner*  inRunner, ABVAItemBindStagePlay*  inBinder );
	//	Render 摜
	void	renderBGA( ABVARunner*  inRunner, ABVAItemBindStagePlay*  inBinder );	
};


#endif	ABMBVAItemRenderStagePlay_h
