/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABBMSData.h

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABBMSData_h
#define	ABBMSData_h

#include	<vector>

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"AquanBeatsConfig.h"

#include	"GameFile.h"

class	GGTexture;


/////////////////////////////////////////////
/*
*	DB structure
*/
/////////////////////////////////////////////
/*
//-------------------------------------------
//	BMS Event Data Structure
//-------------------------------------------
struct MStBMSEventData{
	BMSEventHandle	eventH;
	BMSEventPtr		event;
	long			tatalNotes;
};
typedef	struct	MStBMSEventData	MStBMSEventData;
typedef	struct	MStBMSEventData	*MStBMSEventDataPtr;

//-------------------------------------------
//	BMS Data Structure
//-------------------------------------------
struct MStBMSData{
	OSfileInfoPtr	fileInfo;
	short			groupID;
	short			numKeys;
	short			numPlayer;
	short			dchemeSetID;
	bool			haveStageFile;
	bool			haveBGA;
	
	Str255	strTitle;
	Str255	strGenre;
	Str255	strArtist;
	Str15	strBPM;
	Str15	strPlayLevel;
	Str15	strPlayer;
	Str15	strRank;
	Str15	strTotal;
	Str63	strStageFile;
	Str255	strRandom;
	Str63	strScheme;
	Str63	strMidi;
	Str15	strVolWav;
	
};
typedef	struct	MStBMSData	MStBMSData;
typedef	struct	MStBMSData	*MStBMSDataPtr;

//-------------------------------------------
//	BMS DataBase Utility
//-------------------------------------------
typedef struct
{
	OSfileInfoPtr	fileInfo;
	OSfileInfoPtr	fileInfoDatabase;
	long			dirID;
	unsigned long	modificationDate;
	short			numFiles;
	MStBMSDataPtr	bmsDataPtr;
} BMSDataGroup, *BMSDataGroupPtr,;

typedef struct
{
	OSfileInfoPtr		fileInfo;
	long				dirID;
	unsigned long		modificationDate;
	short				numGroups;
	short				numFiles;
	BMSDataGroupPtr		bmsDataGroupPtr;
} BMSData, *BMSDataPtr;
*/

/////////////////////////////////////////////
/*
*	BMS music data information structure
*/
/////////////////////////////////////////////
//-------------------------------------------
//	type	gpL[̐
//-------------------------------------------
enum{
	AB_BMS_KEY_TYPE_5KEY,
	AB_BMS_KEY_TYPE_7KEY,
};
typedef	ABtype	ABbmsKeyModeType;

//-------------------------------------------
//	type	BGA̗L
//-------------------------------------------
enum{
	AB_BMS_BGA_TYPE_NOTHING,
	AB_BMS_BGA_TYPE_HAVING,
};
typedef	ABtype	ABbmsBGAType;

//-------------------------------------------
//	vCNij
//-------------------------------------------
enum
{
	AB_BMS_RANK_EASY,
	AB_BMS_RANK_NORMAL,
	AB_BMS_RANK_HARD,
	AB_BMS_RANK_VERY_HARD,
};
typedef	ABtype	ABbmsRank;

//-------------------------------------------
//	information Structure
//-------------------------------------------
struct ABbmsMusicInfoData{
	//	BMSeLXgt@CɏLĂ
	ABint8	strTitle[AB_BMS_CHAR_LENGTH_Title];
	ABint8	strGenre[AB_BMS_CHAR_LENGTH_Genre];
	ABint8	strArtist[AB_BMS_CHAR_LENGTH_Artist];

	ABint	bpm;
	ABint	playerLevel;
	ABint	player;			//	1P, or 2P
	ABint	rank;			//	ABbmsRank
	ABint	total;
	ABint	volWav;	
	ABint	random;
	
	ABint8	fileNameStageFile[AB_BMS_CHAR_LENGTH_FILENAME];
	ABint8	fileNameMidi[AB_BMS_CHAR_LENGTH_FILENAME];
	ABint8	fileNameScheme[AB_BMS_CHAR_LENGTH_FILENAME];

	//	p
	ABbmsKeyModeType			keyModeType;	//	5key ? 7key ?
	ABbmsBGAType				BGAType;		//	have BGA ?
	ABint8						directoryName[AB_BMS_CHAR_LENGTH_FILENAME];	//	tH_[̖O

	//	֐
	void	clean( void ){
		//	defaultlݒ肷
		strTitle[0] = 0;
		strGenre[0] = 0;
		strArtist[0]= 0;
		bpm			= 130;
		playerLevel	= 0;
		player		= 1;
		rank		= 2;
		total		= 0;
		volWav		= 100;
		random		= 0;
		
		fileNameStageFile[0]	= 0;
		fileNameMidi[0]			= 0;
		fileNameScheme[0]		= 0;

		keyModeType = 0;	//	5key ? 7key ?
		BGAType = 0;		//	have BGA ?
		directoryName[0] = 0;
	}
	
};
typedef	struct	ABbmsMusicInfoData	ABbmsMusicInfoData;
typedef	struct	ABbmsMusicInfoData	*ABbmsMusicInfoDataPtr;

/////////////////////////////////////////////
/*
*	BMS music data material structure
*/
/////////////////////////////////////////////

//-------------------------------------------
//	BMS Material BitMap Data
//-------------------------------------------
struct	ABbmsMaterialBMPdata
{
	int		number;
	ABint8				filename[AB_BMS_CHAR_LENGTH_FILENAME];
	GGTexture*			bmpTexture;

	//	֐
	void	clean( void ){
		number = 0;
		filename[0]	= 0;
		bmpTexture = 0;
	}
};
typedef	struct	ABbmsMaterialBMPdata	ABbmsMaterialBMPdata;
typedef	struct	ABbmsMaterialBMPdata	*ABbmsMaterialBMPdataPtr;

//-------------------------------------------
//	BMS Material Sound Data
//-------------------------------------------
struct	ABbmsMaterialWAVdata
{
	int		number;
	ABint8				filename[AB_BMS_CHAR_LENGTH_FILENAME];
	ABint				wavData;		//	f[^ւ̎Q

	//	֐
	void	clean( void ){
		number = 0;
		filename[0]	= 0;
		wavData = NULL;
	}
};
typedef	struct	ABbmsMaterialWAVdata	ABbmsMaterialWAVdata;
typedef	struct	ABbmsMaterialWAVdata	*ABbmsMaterialWAVdataPtr;

/////////////////////////////////////////////
/*
*	BMS music data structure
*/
/////////////////////////////////////////////
//-------------------------------------------
//	BMS Seqencer Data
//-------------------------------------------
typedef	std::vector<ABint>		ABbmsObjectDataArray;
struct	ABbmsEventData
{
	ABint						barID;			//	ID
	ABbmsMusicDataEventType		eventType;		//	Cxg

	ABbmsObjectDataArray		objectArray;	//	IuWFNgf[^zieventTypeɂĎgωj
	ABfloat64					value;			//	lieventTypeɂĎgωj
	bool						visible;		//	Es
	ABbmsMusicDataPlayerType	player;			//	player
	ABbmsMusicDataTrackNumber	trackNumber;	//	0,1key~7key,scratch,etc̎wB0͑gbNB
	ABint						noteEventCount;	//	NoteCxĝ݂̃JEgBAB_BMS_MUSIC_DATA_EVENT_OBJECT_1PAAB_BMS_MUSIC_DATA_EVENT_OBJECT_2P̐

	//	֐
	void	clean( void ){
		barID		= 0;
		eventType	= AB_BMS_MUSIC_DATA_EVENT_NOTHING;
		value		= 0;
		visible		= 0;
		player		= 0;
		trackNumber	= 0;
		noteEventCount = 0;
		objectArray.reserve( AB_BMS_MUSIC_DATA_OBJECT_MAX );
		objectArray.clear();
	}
	//	IuWFNgf[^
	long	getNoteCount( void ){
		return	objectArray.size();
	}
};
typedef	struct ABbmsEventData	ABbmsEventData;
typedef	struct ABbmsEventData*	ABbmsEventDataPtr;

//-------------------------------------------
//	BMS Music Data class
//-------------------------------------------
typedef	std::vector<ABbmsMaterialBMPdata>	ABbmsMaterialBMPdataArray;
typedef	std::vector<ABbmsMaterialWAVdata>	ABbmsMaterialWAVdataArray;
typedef	std::vector<ABbmsEventData>			ABbmsEventDataArray;

class	ABbmsMusicData
{
public:
	ABbmsMusicData(){ /*Ńo[ȂOK*/};
	~ABbmsMusicData(){};
	
	ABbmsMusicInfoData			headerInfo;					//	header info
	ABbmsMaterialBMPdataArray	materialBMPdataArray;		//	matireal STL vector array
	ABbmsMaterialWAVdataArray	materialWAVdataArray;		//	matireal STL vector array
	ABbmsEventDataArray			eventDataArray;				//	sequence STL vector array
	ABint						noteEventCount;	//	NoteCxĝ݂̃JEgBAB_BMS_MUSIC_DATA_EVENT_OBJECT_1PAAB_BMS_MUSIC_DATA_EVENT_OBJECT_2P̐

	//	֐
	void	clean( void ){
		this->noteEventCount = 0;
		this->headerInfo.clean();
		this->materialBMPdataArray.clear();
		this->materialWAVdataArray.clear();
		this->eventDataArray.clear();
	}
	
	//	NoteCxg擾
	long	getNoteCount( void ){
		return	noteEventCount;
//		return	this->eventDataArray.size();
	}
};

#endif	//	ABBMSData_h
