/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABBMSRunner.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////


#include	"ABBMSRunner.h"

#include	"ABVARunner.h"
#include	"ABMBVAItemRenderStagePlay.h"


//-------------------------------------------------------
/*
*	Constructor
*/
//-------------------------------------------------------
ABBMSRunner::ABBMSRunner()
{
	this->m_trueIsPlay = false;
}
//-------------------------------------------------------
/*
*	Destructor
*/
//-------------------------------------------------------
ABBMSRunner::~ABBMSRunner()
{
	if( this->m_trueIsPlay ){
		//	BMS~
		this->stop();
		//	BMS
		this->close();
	}
}


//-------------------------------------------------------
//	initialize
//-------------------------------------------------------
bool	ABBMSRunner::initialize( ABVARunner*  inRunner ){
	this->mVARunner = inRunner;
	this->mBmsEventAction.mVARunner = inRunner;
	this->mBmsEventAction.mVAItemRenderStagePlay = static_cast<ABMBVAItemRenderStagePlay*>(this->mVARunner->getCurrentRender());
	this->mBmsEventAction.mVAItemBindStagePlay = static_cast<ABVAItemBindStagePlay*>(this->mVARunner->getCurrentBinder());
	return	true;
}

/////////////////////////////////////////////////////////
//	Method	
/////////////////////////////////////////////////////////
//-------------------------------------------------------
//	BMSI
//-------------------------------------------------------
bool	ABBMSRunner::selectBMS( ABint8*  inSelectBMSMusic )
{
	bool	result = false;

	do{
		result = this->m_bmsMusic.analyzeBMSmusic( inSelectBMSMusic );
		if( !result ){
			break;
		}
		
	}while( false );
	return	result;
}

//-------------------------------------------------------
//	IBMSJ
//-------------------------------------------------------
bool	ABBMSRunner::open( void )
{
	bool	result = this->m_bmsMusic.openBMSmusic( 0 );
	if( !result ){
		return	false;
	}
	
	result = this->m_sequencer.initialize( 2, &this->m_timer, &this->mBmsEventAction, this->m_bmsMusic.getMusicData() );
	if( !result ){
		return	false;
	}

	this->m_trueIsPlay = true;
	return	true;
}

//-------------------------------------------------------
//	IBMS
//-------------------------------------------------------
void	ABBMSRunner::close( void )
{
	//	Kfinalize܂B̃^C~Othis->mBmsEventActionfinalizeĂяoATEȟ㏈K؂ɏ邱Ƃo܂B
	//	TEȟ㏈Yăf[^Ă܂Ɗ댯łB
	this->m_sequencer.finalize();
	//	BMS܂
	this->m_bmsMusic.closeBMSmusic();
	
	this->m_trueIsPlay = false;
}

/////////////////////////////////////////////////////////
//	Method	t
/////////////////////////////////////////////////////////
//-------------------------------------------------------
//	tJn
//-------------------------------------------------------
void	ABBMSRunner::play( void )
{
	this->m_sequencer.play();
}

//-------------------------------------------------------
//	t~
//-------------------------------------------------------
void	ABBMSRunner::stop( void )
{
	this->m_sequencer.stop();
}

//-------------------------------------------------------
//	t
//-------------------------------------------------------
bool	ABBMSRunner::doPlay( void )
{
	//	ĐItrueԂ
	bool	result = false;

	//	Epixelx[Xsequencei܂Pt[pixelړʂvZAjꍇ́AsequencesKvLB
	//	@X͂̂悤ɐ݌v񂾂ǁAԃx[XɕύX߁Å֐͒PɏIcatch邽߂̂̂ɕύXĂB
	
	result = this->m_timer.isEnd();
	
	return result;
}
