/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSequencer.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABSequencer.h"

//-------------------------------------------------------
/*
*	Constructor
*/
//-------------------------------------------------------
ABSequencer::ABSequencer()
{
}
//-------------------------------------------------------
/*
*	Destructor
*/
//-------------------------------------------------------
ABSequencer::~ABSequencer()
{
}

//-------------------------------------------------------
//	Method
//-------------------------------------------------------
//-------------------------------------------------------
/*
*	Initialize
*/
//-------------------------------------------------------

bool	ABSequencer::initialize
( 
	int  inVibrantRange, 
	ABSeqTimeControllerBase*	inTimeController,
	ABSeqEventActionBase*		inEventAction,
	ABbmsMusicData*				inBMSdata
)
{
	this->m_timeController = inTimeController;
	this->m_seqMode = M_SEQMODE_STOP;
	
	this->m_timeController->initialize( &this->m_sequencerLoop, 1 );
	return	this->m_sequencerLoop.initialize( inVibrantRange, inBMSdata, inEventAction );
}

//-------------------------------------------------------
/*
*	Finalize
*/
//-------------------------------------------------------
void	ABSequencer::finalize( void )
{
	this->m_timeController->stop();
	this->m_sequencerLoop.finalize();
}

//-------------------------------------------------------
//	Play
//-------------------------------------------------------
//-------------------------------------------------------
/*
*	paly start
*/
//-------------------------------------------------------
void	ABSequencer::play( void )
{
	this->m_timeController->setLocation( 0 );
	this->m_seqMode = M_SEQMODE_PLAY;
	this->m_timeController->doStartTimer();
}

//-------------------------------------------------------
/*
*	paly pause
*/
//-------------------------------------------------------
void	ABSequencer::pause( void )
{
	this->m_timeController->pause();
	this->m_seqMode = M_SEQMODE_PAUSE;
}

//-------------------------------------------------------
/*
*	paly continue
*/
//-------------------------------------------------------
void	ABSequencer::cont( void )
{
	this->m_timeController->cont();
	this->m_seqMode = M_SEQMODE_PLAY;
}

//-------------------------------------------------------
/*
*	paly stop
*/
//-------------------------------------------------------
void	ABSequencer::stop( void )
{
	this->m_timeController->stop();
	this->m_seqMode = M_SEQMODE_STOP;
}

