/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABBMSRunner.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"ABBMSRunner.h"
#include	"BMSFolder.h"
#include	"ABVARunner.h"
#include	"ABMBVAItemRenderStagePlay.h"
#include	"ABVAItemBindStagePlay.h"

//------------------------------------------------------------------------------
//	Constructor
//------------------------------------------------------------------------------
ABBMSRunner::ABBMSRunner()
:
	mSong(NULL)
{
}
//------------------------------------------------------------------------------
//	Destructor
//------------------------------------------------------------------------------
ABBMSRunner::~ABBMSRunner()
{
	this->cleanup();
}

//------------------------------------------------------------------------------
//	BMS̍Đ
//------------------------------------------------------------------------------
ABbool	ABBMSRunner::setup(
	BMSPlayerConfig*  inConfig,
	BMSProgressReporter*  inReporter, 
	BMSFolder*	inBMSFolder, 
	ABint8*		inBMSFolderName, 
	ABuint		inBMSNumber,
	ABVARunner*					inVARunner,
	ABVAItemBindStagePlay*		inItemBinder, 
	ABMBVAItemRenderStagePlay*	inItemRender 
){
	ABbool	ret;
	
	this->mBMSFolder = inBMSFolder;
	
	ret = this->mBMSFolder->openFolder( inBMSFolderName );
	ABTestReturnReportError( !ret, "this->mBMSFolder->openFolder()" );
	this->mSong = this->mBMSFolder->openSong( inReporter, inBMSNumber );
	ABTestReturnReportError( this->mSong == NULL, "this->mBMSFolder->openSong()" );
	
	this->mBMSEventActor.mVARunner					= inVARunner;
	this->mBMSEventActor.mVAItemRenderStagePlay		= static_cast<ABMBVAItemRenderStagePlay*>(inVARunner->getCurrentRender());
	this->mBMSEventActor.mVAItemBindStagePlay		= static_cast<ABVAItemBindStagePlay*>(inVARunner->getCurrentBinder());

	ret = this->mBMSRunner.initialize( inConfig, &( this->mBMSTimer ), &( this->mBMSEventActor ) );
	ABTestReturnReportError( !ret, "inBMSFolder.openFolder()" );
	return true;
}

//------------------------------------------------------------------------------
//	BMS̍ĐI
//------------------------------------------------------------------------------
void	ABBMSRunner::cleanup( void )
{
	if( this->mBMSFolder == NULL ){
		return;
	}
	
	//	BMS~
	this->mBMSRunner.stopSong();
	this->mBMSFolder->closeSong();
	this->mBMSFolder->closeFolder();
}
