/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSEventAquanBeats.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"BMSEventAquanBeats.h"
#include	"BMSConfig.h"
#include	"BMSResource.h"

#include	"GameSingleton.h"

#include	"ABVARunner.h"
#include	"ABMBVAItemRenderStagePlay.h"
#include	"ABVAItemBindStagePlay.h"

//------------------------------------------------------------------------------
//	Constructor
//------------------------------------------------------------------------------
BMSEventAquanBeats::BMSEventAquanBeats()
{
}
//------------------------------------------------------------------------------
//	Destructor
//------------------------------------------------------------------------------
BMSEventAquanBeats::~BMSEventAquanBeats()
{
}

//------------------------------------------------------------------------------
//	
//------------------------------------------------------------------------------
ABbool	BMSEventAquanBeats::onInit( void )
{
	this->mVARunner->setBMSLocation(0);	//	BPMɓAnimationׂ̈ɐݒ
	this->mVAItemBindStagePlay->mBMSPlayerData = this->mPlayerData;
	this->mVAItemBindStagePlay->mBMSDrawInfo.mHaveBGA = this->mTPSongData->information.BGAType;
	snprintf( this->mVAItemBindStagePlay->mPramam.mMusicTitle.mCString, ABVAItemBindStagePlay::M_CSTRING_SIZE256, "%s", this->mTPSongData->information.strTitle );
	return	true;
}

//------------------------------------------------------------------------------
//	I
//------------------------------------------------------------------------------
void	BMSEventAquanBeats::onFinal( void )
{
}

//------------------------------------------------------------------------------
//	CxgsRequest
//------------------------------------------------------------------------------
void	BMSEventAquanBeats::onPlayerEvent( ABint  inLocation, BMSSeqPlayerEvent  inEvent ) 
{
	switch( inEvent ){
		case BMS_BMSEQ_STARTUP_EVENT_PLAY:					//	yȊJnɌĂт܂B̃^C~OBPM≹ʂȂǂE܂B
			//	this->mTPSongData->information.volWav
			break;

		case BMS_BMSEQ_STARTUP_EVENT_PLAY_MIDI:				//	MIDI̍ĐJn
			//	this->mTPSongData->information.midiFileData
			break;

		case BMS_BMSEQ_STARTUP_EVENT_UPDATE_LOCATION:		//	݂LOCATIONXV
			this->mVAItemRenderStagePlay->m_bmsLocate = inLocation;
			this->mVARunner->setBMSLocation(inLocation);	//	BPMɓAnimationׂ̈ɐݒ
			break;
	}
}

//------------------------------------------------------------------------------
//	ߕύXRequest
//------------------------------------------------------------------------------
void	BMSEventAquanBeats::onChangeBivrant( ABint  inLocation )
{
	//	o[zu
	this->mVAItemRenderStagePlay->addBareObjects( this->mVARunner, inLocation );
}

//------------------------------------------------------------------------------
//	ATCRequest
//------------------------------------------------------------------------------
void	BMSEventAquanBeats::onAssignNote( ABint  inAssignLocation, BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrackType  inTrackNumber, BMSSongEventData*  inEventData )
{
	//	Ȃ
}

//------------------------------------------------------------------------------
//	CxgzuRequest
//------------------------------------------------------------------------------
void	BMSEventAquanBeats::onAllocEvent( ABint  inLocation, BMSSongEventData*  inEventData )
{
	switch( inEventData->eventType ){

		//		
		/*		
		case BMS_BMSEQ_STARTUP_EVENT_PLAY_MIDI:					//	MIDI̍ĐJn

		case BMS_BMSEQ_EVENT_BACK_CHORUS:						//	01:dont play WAV
		case BMS_BMSEQ_EVENT_SET_BAR_RATE:						//	02:߂̔{i_j
		case BMS_BMSEQ_EVENT_CHANGE_BPM:						//	03:BPMl̓rύX
		case BMS_BMSEQ_EVENT_SET_BGA:							//	04:BGA
	//	case BMS_BMSEQ_EVENT_SET_EXTEND:						//	05:Extended Object(For BM98 YANEURAO ver.)	:	BMS not suported.
		case BMS_BMSEQ_EVENT_SET_ANIMATION:						//	06:PoorAj[V̕ύX
		case BMS_BMSEQ_EVENT_SET_LAYER:							//	07:BGA Layer transparency key color
		case BMS_BMSEQ_EVENT_SET_EX_BPM:						//	08:gBPM
		case BMS_BMSEQ_EVENT_HIDE_OBJECT:						//	31-39:1P, 41-49:2P	sIuWFNg
		*/
		
		case BMS_BMSEQ_EVENT_OBJECT:							//	11-19:1P, 21-29:2P	IuWFNg
			{
				//	ʂɕ\鏀s
				this->mVAItemRenderStagePlay->addNoteObjects( this->mVARunner, inEventData->playerNumber, inEventData->trackNumber, inLocation );
			}
			break;
	}
}

//------------------------------------------------------------------------------
//	CxgsRequest
//------------------------------------------------------------------------------
void	BMSEventAquanBeats::onExecuteEvent( ABint  inLocation, BMSSongEventData*  inEventData )
{
	ABbool	playSound = false;
	ABbool	ret;

	//	{Iɂ́AKvȂ̂ΗǂASẴCxgKv͖B

	switch( inEventData->eventType ){

		//////////////////////////////////////	
		//	MacBeats compatible
		//////////////////////////////////////	
		case BMS_BMSEQ_EVENT_BACK_CHORUS:						//	01:dont play WAV
			{
				playSound = true;
			}
			break;

		case BMS_BMSEQ_EVENT_SET_BAR_RATE:						//	02:߂̔{i_j
			{
				//	Ȃ
				//	ĐiKł́AGW̗͂ɂāAɓK؂ȏ߂̒ɒς݂ƂȂĂB
			}
			break;

		case BMS_BMSEQ_EVENT_CHANGE_BPM:						//	03:BPMl̓rύX
		case BMS_BMSEQ_EVENT_SET_EX_BPM:						//	08:gBPM
			{
				//	Ȃ
				//	GW̗͂ɂāAɓK؂ȏ{ĂB
			}
			break;

		case BMS_BMSEQ_EVENT_SET_BGA:							//	04:BGA
			{
				//	ʕ`͕b60BBMSt͂B]āABGA\肱ڂĂ܂B
				//	XggāAmɕ\B
				GGTexture*		texture = NULL;
				if( 0 < (ABint)inEventData->eventValue ){
					ABVAItemBindStagePlay::MBMSDrawInfo::MBGAInfo		bgaInfo;
					ABint			bmpData		= this->mTPSongData->getBMPData( (ABint)inEventData->eventValue );
					if( bmpData != 0 && this->mResource->getBMP( bmpData, &texture ) ){
						bgaInfo.mTextureLayer = texture;
						this->mVAItemBindStagePlay->mBMSDrawInfo.mBGAInfoList[BMS_BMSEQ_BGA_LAYER_0].push_back( bgaInfo );
					}
					else{
						//	`̃rbg}bvw
						bgaInfo.mTextureLayer = NULL;
						this->mVAItemBindStagePlay->mBMSDrawInfo.mBGAInfoList[BMS_BMSEQ_BGA_LAYER_0].push_back( bgaInfo );
					}
				}
			}
			break;

	//	case BMS_BMSEQ_EVENT_SET_EXTEND:						//	05:Extended Object(For BM98 YANEURAO ver.)	:	BMS not suported.

		case BMS_BMSEQ_EVENT_SET_ANIMATION:						//	06:PoorAj[V̕ύX
			{
				GGTexture*		texture = NULL;
				if( 0 < (ABint)inEventData->eventValue ){
					ABint			bmpData		= this->mTPSongData->getBMPData( (ABint)inEventData->eventValue );
					if( this->mResource->getBMP( bmpData, &texture ) ){
						this->mVAItemBindStagePlay->mBMSDrawInfo.mPoor.texture = texture;
					}
					else{
						//	`̃rbg}bvw
						this->mVAItemBindStagePlay->mBMSDrawInfo.mPoor.texture = NULL;
					}
				}
			}
			break;
			
		case BMS_BMSEQ_EVENT_SET_LAYER:							//	07:BGA Layer transparency key color
			{
				//	ʕ`͕b60BBMSt͂B]āABGA\肱ڂĂ܂B
				//	XggāAmɕ\B
				GGTexture*		texture = NULL;
				if( 0 < (ABint)inEventData->eventValue ){
					ABint			bmpData		= this->mTPSongData->getBMPData( (ABint)inEventData->eventValue );
					ABVAItemBindStagePlay::MBMSDrawInfo::MBGAInfo		bgaInfo;
					if( bmpData != 0 && this->mResource->getBMP( bmpData, &texture ) ){
						bgaInfo.mTextureLayer = texture;
						this->mVAItemBindStagePlay->mBMSDrawInfo.mBGAInfoList[BMS_BMSEQ_BGA_LAYER_1].push_back( bgaInfo );
					}
					else{
						//	`̃rbg}bvw
						bgaInfo.mTextureLayer = NULL;
						this->mVAItemBindStagePlay->mBMSDrawInfo.mBGAInfoList[BMS_BMSEQ_BGA_LAYER_1].push_back( bgaInfo );
					}
				}
			}
			break;
		
		case BMS_BMSEQ_EVENT_OBJECT:							//	11-19:1P, 21-29:2P	IuWFNg
			{
				//	Ȃ
				//	łȂ炵Ă͍sȂB
				//playSound = true;	//	fobOp
			}
			break;
		case BMS_BMSEQ_EVENT_HIDE_OBJECT:						//	31-39:1P, 41-49:2P	sIuWFNg
			{
				//	Ȃ
			}
			break;
	}

	if( playSound ){
		//	ԍ擾
		ABint	wavData		= this->mTPSongData->getWAVData( (ABint)inEventData->eventValue );
		ABuint	soundFile;

			//	ABint8*	file		= this->mTPSongData->getWAVFileName( (ABint)inEventData->eventValue );
			//	ABReportFormat( "","" );
			//	printf( "play WAV [wavData %d][file %s]\n", wavData, file );

		//	͕̂̂ʂ̏o
		if( this->mResource->getWAV( wavData, &soundFile ) ){
			ret = GameGetAudio().playSoundTrack( GE_AUDIO_SOUND_TRACK_SOUNDNUMBER_CHANNEL, 0, soundFile );
			ABTestVoidReturnReportError( !ret, "GameGetAudio().playSoundTrack()" );
		}
		else{
			ABReportFormat( "Error:mResource->getWAV()", "" );
			printf( "[eventValue:%8d][wavData:%8d]\n", (ABint)inEventData->eventValue, wavData );
		}
	}
}

//-----------------------------------------------------------------------g-------
	//	ǂ݃CxgsRequest
//-----------------------------------------------------------------------g-------
void	BMSEventAquanBeats::onFetchEvent( ABint  inLocation, BMSSongEventData*  inEventData )
{

//	sƁAAssign^C~Oo܂
#if 0
//#if 1
	//	DEBUGGING
	this->mVAItemRenderStagePlay->addNoteObjects( this->mVARunner, inEventData->playerNumber, inEventData->trackNumber, inLocation, true );
#endif

}

//-----------------------------------------------------------------------g-------
//	[U[TriggerRequest
//------------------------------------------------------------------------------
void	BMSEventAquanBeats::onRequestTrigger( BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrigger*  ioTrigger, ABfloat32  inLocation, ABfloat32*  outTriggerLocation ) 
{
	GameJoystick&	joystick = GameGetJoystick();
	ABbool	player1 = ( inPlayerNumber == BMS_BMSEQ_EVENT_PLAYER1 ? true : false );

	//	WCXeBbN͎̓Ԃ𐳊mɌvāAP[VlsƂoBiAʓ|Ȃ̂ōsȂƂB̂܂ܕԂĂOK)
	*outTriggerLocation = inLocation;
	
	ioTrigger->trigger[ BMS_SEQ_TRACK_KEY1 ] = joystick.isPush( ( player1 ? AB_TRRIGER_P1_BUTTON_1 : AB_TRRIGER_P2_BUTTON_1 )  );
	ioTrigger->trigger[ BMS_SEQ_TRACK_KEY2 ] = joystick.isPush( ( player1 ? AB_TRRIGER_P1_BUTTON_2 : AB_TRRIGER_P2_BUTTON_2 )  );
	ioTrigger->trigger[ BMS_SEQ_TRACK_KEY3 ] = joystick.isPush( ( player1 ? AB_TRRIGER_P1_BUTTON_3 : AB_TRRIGER_P2_BUTTON_3 )  );
	ioTrigger->trigger[ BMS_SEQ_TRACK_KEY4 ] = joystick.isPush( ( player1 ? AB_TRRIGER_P1_BUTTON_4 : AB_TRRIGER_P2_BUTTON_4 )  );
	ioTrigger->trigger[ BMS_SEQ_TRACK_KEY5 ] = joystick.isPush( ( player1 ? AB_TRRIGER_P1_BUTTON_5 : AB_TRRIGER_P2_BUTTON_5 )  );
	ioTrigger->trigger[ BMS_SEQ_TRACK_KEY6 ] = joystick.isPush( ( player1 ? AB_TRRIGER_P1_BUTTON_6 : AB_TRRIGER_P2_BUTTON_6 )  );
	ioTrigger->trigger[ BMS_SEQ_TRACK_KEY7 ] = joystick.isPush( ( player1 ? AB_TRRIGER_P1_BUTTON_7 : AB_TRRIGER_P2_BUTTON_7 )  );
	ioTrigger->trigger[ BMS_SEQ_TRACK_KEY_SCRATCH ] = joystick.isPush( ( player1 ? AB_TRRIGER_P1_BUTTON_TRUN_L : AB_TRRIGER_P2_BUTTON_TRUN_L )  );
	ioTrigger->trigger[ BMS_SEQ_TRACK_KEY_SCRATCH ] |= joystick.isPush( ( player1 ? AB_TRRIGER_P1_BUTTON_TRUN_R : AB_TRRIGER_P2_BUTTON_TRUN_R )  );
	ioTrigger->trigger[ BMS_SEQ_TRACK_KEY_SCRATCH_FREE ] = ioTrigger->trigger[ BMS_SEQ_TRACK_KEY_SCRATCH ];
}

//------------------------------------------------------------------------------
//	ANVRequest
//------------------------------------------------------------------------------
void	BMSEventAquanBeats::onTriggerAction( BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrackType  inTrackNumber, BMSSongEventData*  inEventData )
{
//	return;
	
	//	ԍ擾
	ABbool	ret;
	ABint	wavData		= this->mTPSongData->getWAVData( (ABint)inEventData->eventValue );
	ABuint	soundFile;

		//	ABint8*	file		= this->mTPSongData->getWAVFileName( (ABint)inEventData->eventValue );
		//	ABReportFormat( "","" );
		//	printf( "play WAV [wavData %d][file %s]\n", wavData, file );

	//	͕̂̂ʂ̏o
	if( this->mResource->getWAV( wavData, &soundFile ) ){
		ret = GameGetAudio().playSoundTrack( GE_AUDIO_SOUND_TRACK_SOUNDNUMBER_CHANNEL, 0, soundFile );
		ABTestVoidReturnReportError( !ret, "GameGetAudio().playSoundTrack()" );
	}
	else{
		ABReportFormat( "Error:mResource->getWAV()", "" );
		printf( "[eventValue:%8d][wavData:%8d]\n", (ABint)inEventData->eventValue, wavData );
	}
	//	obNCg_
	BMSSeqEventTrackType	trackNumber = inTrackNumber;
	if( inTrackNumber == BMS_SEQ_TRACK_KEY_SCRATCH_FREE ){
		trackNumber = BMS_SEQ_TRACK_KEY_SCRATCH;
	}
	this->mVAItemBindStagePlay->mTrackBackLightPress[inPlayerNumber][inTrackNumber] = true;
}

