/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSEvent.h

				BMSPlayerŔCxgnh[

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSEvent_h
#define	BMSEvent_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"BMSPlayer.h"
#include	"BMSSong.h"
#include	"BMSParserConfig.h"
#include	"BMSTimer.h"

class	BMSResource;

////////////////////////////////////////////////////////////////////////////////
//	Specific event
//	EBMSCxgƂ͕ʂ́ABMSPlayer̃CxgB
////////////////////////////////////////////////////////////////////////////////
enum {
	BMS_BMSEQ_STARTUP_EVENT_PLAY,						//	yȊJnɌĂт܂B̃^C~OBPM≹ʂȂǂE܂B
	BMS_BMSEQ_STARTUP_EVENT_PLAY_MIDI,					//	MIDI̍ĐJn
	BMS_BMSEQ_STARTUP_EVENT_UPDATE_LOCATION,			//	݂LOCATIONXV
};
typedef	ABint	BMSSeqPlayerEvent;

////////////////////////////////////////////////////////////////////////////////
//	Trigger info
//	ETriggerԂi[
////////////////////////////////////////////////////////////////////////////////
typedef	struct	BMSSeqEventTrigger{

	ABbool		trigger[ BMS_SEQ_TRACK_COUNT ];

}BMSSeqEventTrigger;

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSEvent
{
protected:
	BMSResource*		mResource;
	BMSTPSongData*		mTPSongData;
	BMSPlayerData*  	mPlayerData;
public:
	BMSEvent();
	virtual	~BMSEvent();
	
	//	
	virtual	ABbool	onInit( void ) = 0;
	
	//	I
	virtual	void	onFinal( void ) = 0;
	
	//	CxgsRequest
	virtual	void	onPlayerEvent( ABint  inLocation,  BMSSeqPlayerEvent  inEvent ) = 0;

	//	ߕύXRequest
	//	Eߋ؂o[zus܂B
	virtual	void	onChangeBivrant( ABint  inLocation ) = 0;

	//	CxgzuRequest
	//	EIuWFNg̔zus܂B
	virtual	void	onAllocEvent( ABint  inLocation, BMSSongEventData*  inEventData ) = 0;

	//	CxgsRequest
	//	ECxg̎ss܂B
	virtual	void	onExecuteEvent( ABint  inLocation, BMSSongEventData*  inEventData ) = 0;
	
	//	ǂ݃CxgsRequest
	//	EtJn̉摜\Ȃǂs܂B
	virtual	void	onFetchEvent( ABint  inLocation, BMSSongEventData*  inEventData ) = 0;
	
	//	ATCRequest
	//	EegbNɑΉWCXeBbNL[ɉ蓖Ă܂B
	//	iۂɂ́AGW邽߁AȂĂOKłj
	virtual	void	onAssignNote( ABint  inAssignLocation,BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrackType  inTrackNumber, BMSSongEventData*  inEventData ) = 0;
	//	[U[TriggerRequest
	//	EWCXeBbN̓͂͂ōsĉB
	//	ETriggerƂ́AtrueԂĉB
	virtual	void	onRequestTrigger( BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrigger*  ioTrigger, ABfloat32  inLocation, ABfloat32*  outTriggerLocation ) = 0;
	//	ANVRequest
	//	E[U[TriggerRequestATriggerꍇɌĂт܂BŉĐĂB
	//	EtɂĂт܂B
	virtual	void	onTriggerAction( BMSSeqEventPlayerNumber  inPlayerNumber, BMSSeqEventTrackType  inTrackNumber, BMSSongEventData*  inEventData ) = 0;
	
public:
	
	//	set resource
	void	setResource( BMSResource*  inRes, BMSTPSongData*  inTPSongData, BMSPlayerData*  inPlayerData ){
		mResource = inRes;
		mTPSongData = inTPSongData;
		mPlayerData = inPlayerData;
	}
};

#endif	//	BMSEvent_h
