/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSParser.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

//#define	AB_LOCAL_DEBUG_MODE
#include	"GlobalConfig.h"

#include	"BMSParser.h"
#include	"BMSSong.h"
#include	"BMSProgressReporter.h"

#include	<typeinfo>
#include	<iostream>
using namespace	std;

/*//////////////////////////////////////////////////////////////////////////////
*	class AB BMS Music Analyzer MacBeat 
*///////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------
//	class Architecture MacBeat
//	MacBeatdl̉͋@\NXB
//
//	̃NX̖ړIBMSf[^\̎dlEɂ邱ƂłB
//	IgݗĂ鎖ł΁ABM,DDR,Mac,WinʌɊgtH[}bg𕪗ł邾낤B
//	ł͂̃NXSĂȂ̂ŗ]ӖȂȂi͂|GɂȂƂȂjB
//
//----------------------------------------------------------------
class	BMSTPMusicArchitectureMacBeat : public	BMSTPMusicArchitecture
{
private:
	typedef	BMSTPArchitectureBase		MArchitecture;

public:

	//--------------------------------
	//	Cxgl擾邽߂̃CxgʎqΉNX
	//--------------------------------
	template< typename  scanType >	//	ǂݎ^w肷鎖Blong
	class MTypeValue :  public	MArchitecture{
	public:
		MTypeValue(){};
		virtual ~MTypeValue(){};

		//	Cxg̉͂Ǝ擾܂BŒl̎擾AIuWFNgz̉͂sB
		bool	analyze( BMSTPVibrantData&  outEventData, ABint  inBarID, BMSTPEventType  inEventType, char*  inValue ) {

			if( typeid(scanType) == typeid(long) ){
				long	v;
				sscanf( inValue, "%ld", &v );
				outEventData.value = v;
			}
			else if( typeid(scanType) == typeid(double) ){
				double	v;
				sscanf( inValue, "%lf", &v );
				outEventData.value = v;
			}
			else{
				ABReportError("-unkown or not suported type.");
				return false;
			}
			outEventData.barID		= inBarID;
			outEventData.eventType	= inEventType;
			return true;
		}

	};
	
	//--------------------------------
	//	CxgʎqvC[io[AgbNԍ܂ł鎞̏NX
	//	݂NotepIuWFNgzł̂ݎgĂB
	//--------------------------------
	class MTypeTrackEvents :  public	MArchitecture{
	public:
		MTypeTrackEvents(){};
		virtual ~MTypeTrackEvents(){};
		//	Cxg̉͂Ǝ擾܂BŒl̎擾AIuWFNgz̉͂sB
		bool	analyze( BMSTPVibrantData&  outEventData, ABint  inBarID, BMSTPEventType  inEventType, char*  inValue ){
			
			//	gbNio[擾
			outEventData.trackNumber = (inEventType % 10);			//	10̈ʂ擾
			
			if( outEventData.trackNumber < BMS_TP_OBJECT_KEY1 || BMS_TP_OBJECT_MODE7_KEY7 < outEventData.trackNumber ){
				//	unkown or not suported track
				//	Ή̃gbNԍł
				ABReportError("-unkown or not suported track.");
				return false;
			}
			
			//	vC[io[擾
			outEventData.eventType = inEventType - outEventData.trackNumber;	//	1̈ʂ؂̂
			
			switch( outEventData.eventType ){
				case BMS_TP_EVENT_OBJECT_1P:				//	11-19:1P	IuWFNg
					outEventData.visible = true;
					outEventData.player = BMS_BMSEQ_EVENT_PLAYER1;
					break;
				case BMS_TP_EVENT_OBJECT_2P:				//	21-29:2P	IuWFNg
					outEventData.visible = true;
					outEventData.player = BMS_BMSEQ_EVENT_PLAYER2;
					break;
				case BMS_TP_EVENT_HIDE_OBJECT_1P:			//	31-39:1P	sIuWFNg
					outEventData.visible = false;
					outEventData.player = BMS_BMSEQ_EVENT_PLAYER1;
					break;
				case BMS_TP_EVENT_HIDE_OBJECT_2P:			//	41-49:2P	sIuWFNg
					outEventData.visible = false;
					outEventData.player = BMS_BMSEQ_EVENT_PLAYER2;
					break;
				default:
					//	unkown or not suported events
					ABReportError("-unkown or not suported events.");
					return false;
					break;
			}
			return true;
		}
	};
	
	//--------------------------------
	//	IuWFNgz^̃CxglKvƂCxgʎqΉNX
	//	KeyBoardZonezp(ՖɃCxgĂ^Cv)
	//--------------------------------
	template< class T = MArchitecture >	//	ev[g^@ɂāAIuWFNgz񏈗ȗ̂B
	class MTypeValueObjects :  public	MArchitecture{
	public:
		MTypeValueObjects(){
			mObjectValueType = M_OBJECT_TYPE_16;
		};
		virtual ~MTypeValueObjects(){};
		
		//	ǂݎIuWFNgzl̐lʂw肵ĂB
		typedef enum{
			M_OBJECT_TYPE_16,	//	16i
			M_OBJECT_TYPE_36,	//	36ii 0...9, a...z j
		} MObjectValueType;
		MObjectValueType	mObjectValueType;
		
		//	Cxg̉͂Ǝ擾܂BŒl̎擾AIuWFNgz̉͂sB
		bool	analyze( BMSTPVibrantData&  outEventData, ABint  inBarID, BMSTPEventType  inEventType, char*  inValue ){
			bool	result = false;
			
			outEventData.barID 		= inBarID;
			outEventData.eventType	= inEventType;

			//	NOTEzũIuWFNgz񂩂ǂł͉Ȃ󂾂AgbNԍ擾݂B
			//	ev[gMTypeTrackEventsŖƂ͉NȂA
			//	ev[gMTypeTrackEventŝƂ̓gbNԍ擾łB
			result = this->m_trackAnaryzer.analyze( outEventData, inBarID, inEventType, inValue );
			if( ! result ){ return result; }
			
			//	
			{
				//	
				char	str[3]			={ 0, 0, 0 };
				long	objectCount		= 0;
				int		object	= 0;
				char*	dataBufferPtr	= inValue;
				
				//	
				//	̒iKŏ߂̏dɂčlKv͖BlɋlߍOKB
				while( ( *dataBufferPtr != 0 ) && ( objectCount <= BMS_TP_OBJECT_ARRAY_MAX ) ){
					//	ɂunsigned char16iŊi[B
					str[0] = tolower( *(dataBufferPtr + 0) );
					str[1] = tolower( *(dataBufferPtr + 1) );
					
					switch( this->mObjectValueType ){
						case M_OBJECT_TYPE_16:
							//	16iœǂݍ
							sscanf( str, "%x", &object );
							break;
						case M_OBJECT_TYPE_36:
							//	36iœǂݍ
							object = BMSParser::convCharToNum( str, 2 );
							if( object < 0 ){
								object  = 0;
							}
							break;
					};
					outEventData.objectArray.push_back( object );
					++objectCount;
					dataBufferPtr += 2;
				}
			}
			return	true;
		}
	private:
		T	m_trackAnaryzer;
	};
		
public:
	BMSTPMusicArchitectureMacBeat(){
		this->init();
	};
	virtual ~BMSTPMusicArchitectureMacBeat(){};

	//----------------------------------------	
	//	tH[}bg\z
	//
	//	EǂݎׂCxgʎq͑SĂŏݒ肵܂B
	//	@̕ӂM邾łȂyɊgECłEEEȁHi΁j
	//
	//	EResourcẽIuWFNgźAM_OBJECT_TYPE_36w肵ĂBȗƂPUilœǂݎ܂B
	//----------------------------------------	
	virtual void	setupDataFormat(){
	
		//	Cxgʎq
		this->mTypeBackChorus.mObjectValueType	= MTypeValueObjects<>::M_OBJECT_TYPE_36;		//	36ĩIuWFNgz͂̎w肪Kv
		this->mTypeSetBGA.mObjectValueType		= MTypeValueObjects<>::M_OBJECT_TYPE_36;		//	36ĩIuWFNgz͂̎w肪Kv
		this->mTypeSetAnimation.mObjectValueType = MTypeValueObjects<>::M_OBJECT_TYPE_36;		//	36ĩIuWFNgz͂̎w肪Kv
		this->mTypeSetLayer.mObjectValueType	= MTypeValueObjects<>::M_OBJECT_TYPE_36;		//	36ĩIuWFNgz͂̎w肪Kv
		this->mTypeSetExBPM.mObjectValueType	= MTypeValueObjects<>::M_OBJECT_TYPE_36;		//	36ĩIuWFNgz͂̎w肪Kv

		this->setData( &this->mTypeBackChorus, 	BMS_TP_EVENT_BACK_CHORUS );			//	01:dont play WAV
		this->setData( &this->mTypeSetBarRate, 	BMS_TP_EVENT_SET_BAR_RATE);			//	02:߂̔{i_j
		this->setData( &this->mTypeChangeBPM, 	BMS_TP_EVENT_CHANGE_BPM	 );			//	03:BPMl̓rύX
		this->setData( &this->mTypeSetBGA, 		BMS_TP_EVENT_SET_BGA		 );			//	04:BGA
		//	05:Extended Object(For BM98 YANEURAO ver.)	:	AB not suported.
		this->setData( &this->mTypeSetAnimation,BMS_TP_EVENT_SET_ANIMATION );		//	06:PoorAj[V̕ύX
		this->setData( &this->mTypeSetLayer, 	BMS_TP_EVENT_SET_LAYER );			//	07:BGA Layer transparency key color
		this->setData( &this->mTypeSetExBPM, 	BMS_TP_EVENT_SET_EX_BPM	 );			//	08:gBPM

		BMSTPEventType	noteNumber[M_TRACK_COUNT] = {
			BMS_TP_OBJECT_KEY1,				//	1 Key			(11,21,31,41)
			BMS_TP_OBJECT_KEY2,				//	2 Key
			BMS_TP_OBJECT_KEY3,				//	3 Key
			BMS_TP_OBJECT_KEY4,				//	4 Key
			BMS_TP_OBJECT_KEY5,				//	5 Key
			BMS_TP_OBJECT_SCRATCH,			//	scratch
			BMS_TP_OBJECT_SCRATCH_FREE,		//	free scratch
			BMS_TP_OBJECT_MODE7_KEY6,		//	6 key
			BMS_TP_OBJECT_MODE7_KEY7,		//	7 key
		};
		ABint	i;
		for( i = 0; i < M_TRACK_COUNT ; i++ ){
			this->mTypeObjectShow1p[i].mObjectValueType = MTypeValueObjects<MTypeTrackEvents>::M_OBJECT_TYPE_36;	//	36ĩIuWFNgz͂̎w肪Kv
			this->mTypeObjectShow2p[i].mObjectValueType = MTypeValueObjects<MTypeTrackEvents>::M_OBJECT_TYPE_36;	//	36ĩIuWFNgz͂̎w肪Kv
			this->mTypeObjectHide1p[i].mObjectValueType = MTypeValueObjects<MTypeTrackEvents>::M_OBJECT_TYPE_36;	//	36ĩIuWFNgz͂̎w肪Kv
			this->mTypeObjectHide2p[i].mObjectValueType = MTypeValueObjects<MTypeTrackEvents>::M_OBJECT_TYPE_36;	//	36ĩIuWFNgz͂̎w肪Kv

			this->setData( &this->mTypeObjectShow1p[i], noteNumber[i] + BMS_TP_EVENT_OBJECT_1P );		//	11-19:1P	IuWFNg
			this->setData( &this->mTypeObjectShow2p[i], noteNumber[i] + BMS_TP_EVENT_OBJECT_2P );		//	21-29:2P	IuWFNg
			this->setData( &this->mTypeObjectHide1p[i], noteNumber[i] + BMS_TP_EVENT_HIDE_OBJECT_1P );	//	31-39:1P	sIuWFNg
			this->setData( &this->mTypeObjectHide2p[i], noteNumber[i] + BMS_TP_EVENT_HIDE_OBJECT_2P );	//	41-49:2P	sIuWFNg
		}
	};

public:
	//	BMSʎq`
	MTypeValueObjects<>		mTypeBackChorus;		//	01:dont play WAV
	MTypeValue<double>		mTypeSetBarRate;		//	02:߂̔{i_j
	MTypeValueObjects<>		mTypeChangeBPM;			//	03:BPMl̓rύX
	MTypeValueObjects<>		mTypeSetBGA;			//	04:BGA
	//	05:Extended Object(For BM98 YANEURAO ver.)	:	AB not suported.
	MTypeValueObjects<>		mTypeSetAnimation;		//	06:PoorAj[V̕ύX
	MTypeValueObjects<>		mTypeSetLayer;			//	07:BGA Layer transparency key color
	MTypeValueObjects<>		mTypeSetExBPM;			//	08:gBPM

	enum{
		M_TRACK_COUNT = BMS_TP_OBJECT_MODE7_KEY7
	};
	MTypeValueObjects<MTypeTrackEvents>		mTypeObjectShow1p[M_TRACK_COUNT];	//	11-19:1P	IuWFNg
	MTypeValueObjects<MTypeTrackEvents>		mTypeObjectShow2p[M_TRACK_COUNT];	//	21-29:2P	IuWFNg
	MTypeValueObjects<MTypeTrackEvents>		mTypeObjectHide1p[M_TRACK_COUNT];	//	31-39:1P	sIuWFNg
	MTypeValueObjects<MTypeTrackEvents>		mTypeObjectHide2p[M_TRACK_COUNT];	//	41-49:2P	sIuWFNg
};


/*//////////////////////////////////////////////////////////////////////////////
*	class BMSParser
*///////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------
/*
*	Constructor
*/
//-------------------------------------------------------
BMSParser::BMSParser()
{
	this->setupEventTable();
}
//-------------------------------------------------------
/*
*	Destructor
*/
//-------------------------------------------------------
BMSParser::~BMSParser()
{
	delete	this->m_musicArchitecture;
}
//-------------------------------------------------------
//	BMSCxgʎq`
//-------------------------------------------------------
void	BMSParser::setupEventTable( void )
{
	try{
		this->m_musicArchitecture = new BMSTPMusicArchitectureMacBeat;
	}
	catch(...){
		this->m_musicArchitecture = NULL;
	}
}

//-------------------------------------------------------
//	BMSt@Cǂݍ
//-------------------------------------------------------
bool	BMSParser::loadBMSFile( BMSResource*  inResource, BMSParserHeaderReafAfterProc  inProc, BMSProgressReporter*  inReporter, BMSLoadMode  inLoadMode, GameFileInfo*  inFileInfoPtr, BMSTPSongData*  ioTPSongData )
{
	bool			result = false;
	char*			textBuffer = NULL;
	MVecTextArray	rowArray; 
	unsigned int	bufSize;
	BMSTPSongData*  refMusicData = ioTPSongData;
	
	//	eLXgǂݍ
	ABint8		filePath[ 1024 ];
	inFileInfoPtr->copyPath( (ABuint8*)filePath, sizeof( filePath ) );
	result = GameTextParser::readFileToBuffer( filePath, &textBuffer, &bufSize );
	if( ! result ){
		//	t@CG[
		return result;
	}
	
	do{
		if( bufSize == 0 ){
			//	t@C
			break;
		}
		
		//	eLXgobt@sPʂłԂ
		this->m_parserTool.sliceRows( textBuffer, bufSize, &rowArray );

		//	eLXgobt@@RpC
		//	E̎_őp\ȏԂɂĂ
		{
			//	eLXg -> wb_[f[^ifޏj
			result = this->readBMSheaderData( inLoadMode, refMusicData, &rowArray );
			if( ! result ){
				//	"\pThis is not BMS file.";
				ABReportError("-this->readBMSheaderData.");
				break;
			}
			
			if( inLoadMode == BMS_TP_LOAD_ALL_DATA ){
				result = inProc( inResource, refMusicData ); 
			}
			
//			if( inLoadMode == BMS_TP_LOAD_ALL_DATA ){
				//	eLXg -> Cxgf[^`
				result = this->readBMSeventData( inLoadMode, inReporter, refMusicData, &rowArray );
				if( ! result ){
					//	̓G[FCxgf[^
					ABReportError("-this->readBMSeventData.");
					break;
				}
//			}
		}

		
		result = true;
	}while( false );
	
	//	eLXgobt@
	GameTextParser::releaseFileBuffer( textBuffer );

	return result;
}

//-------------------------------------------------------
//	eLXg -> wb_[f[^
//	Eǂݍޕ
//		E~[WbNip^A̓j
//		Efޏit@Cj
//-------------------------------------------------------
bool	BMSParser::readBMSheaderData( BMSLoadMode  inLoadMode, BMSTPSongData*  refMusicData, MVecTextArray*  inArray )
{
	MVecTextArray::iterator		it;
	//MVecTextArray::iterator		itTest;
	char*			buffer;
	char*			CHAR_SHARP_CODE		= "#";
//	char			dataBuffer[1024+1];
	char*			dataBuffer;

	long			lvalue;
	char*			cvalue;
	char			literalBuffer[16+1];	//	#̎擾p
	char			resValueBuffer[3+1];	//	ʔԍ擾p
	
	BMSMaterialBMP		bmpData;
	BMSMaterialWAV		wavData;
	BMSTableBPM			bpmData;
	
	bool	flagMaterial;
	bool	flagComplete;

	ABLocalDebug( cout << "BMSParser::readBMSheaderData() Read header data." << endl; );

	//	f[^so
	it = inArray->begin();
	this->m_parserTool.findRow( inArray, it, CHAR_SHARP_CODE );

	//	
	ABint	arraySize = 36 * 36 + 16;							//	36ip( + 16 ͌Â^CṽvO}[i΁ĵ̐l͂ăoO瓦Ă)
	refMusicData->materialBMPArray.resize( arraySize );		//	ւ͍œK̗]nLłȁi΁j
	refMusicData->materialWAVArray.resize( arraySize );
	refMusicData->tableBPMArray.resize( arraySize );

	//	f[^ǂ݂ƂJn
	while( it != inArray->end() ){

		//::TODO::ԂɕłƂ͌ȂACf[^Ƃ̋ʂoȂߑS悤B
		//	mainf[^܂łǂ݂Ƃ̂ŁACf[^R[hoĂI
		//itTest = it;
		//if( ! this->m_parserTool.findRow( inArray, itTest, CHAR_MAINDATA_CODE ) ){
		//	//	end
		//	break;
		//}
		
		
		//-----------------------------
		//	36iϊ test code
		//	ȏɏ̂Ȃ񂾂
		//-----------------------------
		/*
		{
			int		testx, testy ;
			int		testv ;
			char*	testdata = "0123456789abcdefghijklmnopqrstuvwxyz";	//ُnisɂȂ邾낤l̃P[Xp^[j͏ȗ
			char	testbuf[ 3 ] = {
				0,0,0,
			};
			
			for(testy=0;testy<36;testy++){
				for(testx=0;testx<36;testx++){
					testbuf[ 0 ] = testdata[ testy  ];
					testbuf[ 1 ] = testdata[ testx ];
					testv = this->convCharToNum( testbuf, 2 );
					cout << testv << " <- " << testbuf << " / ";
				}
			}
			cout << endl ;
		}
		*/
		//-----------------------------
		//	36iϊ test code܂
		//-----------------------------
		
		buffer = *it;

		bmpData.clean();
		wavData.clean();
		lvalue = 0;
		cvalue = NULL;
		flagMaterial = false;
		flagComplete = false;

		//	Sēǂݎw̎
		if( inLoadMode == BMS_TP_LOAD_ALL_DATA ){
		
			//	fރf[^ǂݎ
			sscanf( buffer, "%16s *", literalBuffer );
			//	BPMxx̎ʂ̂ߕŃ`FbN
			if( 6 == strlen(literalBuffer) ){
//				sscanf( buffer, "%4s%2s %64s", literalBuffer, resValueBuffer, dataBuffer );
				sscanf( buffer, "%4s%2s", literalBuffer, resValueBuffer );
				dataBuffer = (char*)((int)buffer + strlen(literalBuffer) + strlen(resValueBuffer) + 1);
				flagMaterial = true;
				flagComplete = true;
				
				//	BMP
				if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_BMP ) ){
					//	hit	BMS_TP_InfoData_STR_BMP
					bmpData.number = this->convCharToNum( resValueBuffer, 2 );
					strncpy( bmpData.filename, dataBuffer, BMS_TP_CHAR_LENGTH_FILENAME );
					refMusicData->materialBMPArray[bmpData.number] = bmpData;
					ABLocalDebug( cout << "-READ > bmpData.filename:" << dataBuffer << ",bmpData.number:" << bmpData.number << endl ; );
				}
				//	WAV
				else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_WAV ) ){
					//	hit	BMS_TP_InfoData_STR_WAV
					wavData.number = this->convCharToNum( resValueBuffer, 2 );
					strncpy( wavData.filename, dataBuffer, BMS_TP_CHAR_LENGTH_FILENAME );
					refMusicData->materialWAVArray[wavData.number] = wavData;
					
					ABLocalDebug( cout << "-READ > wavData.filename:" << dataBuffer << ",wavData.number:" << wavData.number << endl ; );
				}
				//	gBPM
				else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_BPM ) ){

					float		bpmValue;
					sscanf( dataBuffer, "%f", &bpmValue );
					bpmData.clean();
					bpmData.number	= this->convCharToNum( resValueBuffer, 2 );
					bpmData.bpm		= bpmValue;
					refMusicData->tableBPMArray[bpmData.number] = bpmData;
					ABLocalDebug( cout << "-READ > " << "bpmData.number:" << wavData.number << ", bpm:" << bpmData.bpm << endl ; );
				}
				else{
					flagMaterial = false;
					flagComplete = false;
				}
			}
					
		}//if
		
		if( ! flagMaterial ){
			//	other key word
			sscanf( buffer, "%32s", literalBuffer );
			dataBuffer = (char*)((int)buffer + strlen(literalBuffer) + 1);
//			memcpy( dataBuffer, (char*)((int)buffer + strlen(literalBuffer) + 1), strlen(buffer) - strlen(literalBuffer) );
			
			//	ᖡ
			//::TODO::VL[𑝂₷Ƃ͂ɒǉ
			flagComplete = true;
			
			if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_Player ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->information.player = (BMSTPTargetPlayerCount)lvalue;
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_Genre ) ){
				cvalue = &refMusicData->information.strGenre[0];
				this->getBufferValue( dataBuffer, cvalue, sizeof( refMusicData->information.strGenre ) );
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_Title ) ){
				cvalue = &refMusicData->information.strTitle[0];
				this->getBufferValue( dataBuffer, cvalue, sizeof( refMusicData->information.strTitle )  );
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_Artist ) ){
				cvalue = &refMusicData->information.strArtist[0];
				this->getBufferValue( dataBuffer, cvalue, sizeof( refMusicData->information.strArtist )  );
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_BPM ) ){

				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->information.bpm = lvalue;
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_PlayLevel ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->information.playerLevel = lvalue;
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_Rank ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->information.rank = (BMSTPRank)lvalue;
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_VolWav ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->information.volWav = lvalue	;
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_Total ) ){
				this->getBufferValue( dataBuffer, &lvalue );
				refMusicData->information.total = lvalue;
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_StageFile ) ){
				cvalue = &refMusicData->information.fileNameStageFile[0];
				this->getBufferValue( dataBuffer, cvalue, sizeof( refMusicData->information.fileNameStageFile )  );
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_Scheme ) ){
				cvalue = &refMusicData->information.fileNameScheme[0];
				this->getBufferValue( dataBuffer, cvalue, sizeof( refMusicData->information.fileNameScheme )  );
			}
			else if( 0 == strcasecmp( literalBuffer, BMS_TP_InfoData_STR_Midi ) ){
				cvalue = &refMusicData->information.fileNameMidi[0];
				this->getBufferValue( dataBuffer, cvalue, sizeof( refMusicData->information.fileNameMidi )  );
			}
			else {
			
				//	unkown key word
				flagComplete = false;
				//cout << "-READ unkown header > " << literalBuffer << endl;
			}
		}
		
		if( flagComplete ){
			//	ǂݍ񂾍s폜iCxgf[^`̃f[^ǂݍ݂𑬂j
			ABLocalDebug( cout << "-ERASE > " << *it << endl ; );
			it = inArray->erase( it );
		}
		else {
			++it;
		}
	}

	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_Player 	<< ",value:" << refMusicData->information.player << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_Genre 	<< ",value:" << refMusicData->information.strGenre << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_Title 	<< ",value:" << refMusicData->information.strTitle << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_Artist 	<< ",value:" << refMusicData->information.strArtist << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_BPM 		<< ",value:" << refMusicData->information.bpm << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_PlayLevel << ",value:" << refMusicData->information.playerLevel << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_Rank 	<< ",value:" << refMusicData->information.rank << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_VolWav 	<< ",value:" << refMusicData->information.volWav << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_Total 	<< ",value:" << refMusicData->information.total << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_StageFile << ",value:" << refMusicData->information.fileNameStageFile << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_Scheme 	<< ",value:" << refMusicData->information.fileNameScheme << endl ; );
	ABLocalDebug( cout << "-READ > literalBuffer:" << BMS_TP_InfoData_STR_Midi 	<< ",value:" << refMusicData->information.fileNameMidi << endl ; );

	ABLocalDebug( cout << "BMSParser::readBMSheaderData() Read header data finish." << endl; );

	return	true;
}

//-------------------------------------------------------
//	eLXg -> Cxgf[^`
//-------------------------------------------------------
bool	BMSParser::readBMSeventData( BMSLoadMode  inLoadMode, BMSProgressReporter*  inReporter, BMSTPSongData*  refMusicData, MVecTextArray*  inArray )
{
	bool			result = false;
	MVecTextArray::iterator		it;
	char*			buffer;

	long			barCount = 0;

	long			barID;
	long			eventType;
	long			eventTrackNumber;
	double			dvalue;
	char			dataBuffer[1024];
	char			literalBuffer[1024];
	int				dataValue;
	bool			unkown;
	int				position = 0;
	
	char*			CHAR_SHARP_CODE	= "#";
	BMSTPVibrantData	eventData;
	
	ABLocalDebug( cout << "BMSParser::readBMSeventData() Read event data." << endl; );
	
	
	int		useMaxTrackCount = 0;	//	gbNi5,7L[ʗpj
	bool	trueHaveBGA = false;
	
	bool	preRandom		= false;		//	vvZbTFRANDOMwLtO
	int		preRandomNumber = 0;			//	w藐
	int		preRandomCount = 0;				//	̎w萔

	bool	look			= true;			//	truêƂ̍sǂݎ
	
	//	f[^so
	it = inArray->begin();
	this->m_parserTool.findRow( inArray, it, CHAR_SHARP_CODE );

	if( inReporter ){
		inReporter->onReport( inArray->size(), position );
	}

	//	f[^ǂ݂ƂJn
	while( it != inArray->end() ){
		buffer = (*it++);
//		ABLocalDebug( cout << buffer << endl  );

		//	
		eventData.clean();
		unkown 			= false;
		barID			= 0;
		eventType		= 0;
		eventTrackNumber	= 0;
		dataBuffer[0]	= 0;
		dvalue			= 0;
		dataValue		= 0;
		
		//	read rows

		if( inLoadMode != BMS_TP_LOAD_HEADER_INFO_DATA ){
			//	preprocess]

			//	q\ɂ͖Ή(Ή͐Ȃ)Bqɂꍇ͕GɂȂ̂Ŋ֐\B
			sscanf( buffer, "%s %d", literalBuffer, &dataValue );

			//	
			if( 0 == strcasecmp( literalBuffer, BMS_TP_eventData_STR_RANDOM ) ){
				preRandom = true;
				preRandomNumber = (rand() % (dataValue - 1)) + 1;
				preRandomCount = dataValue;
				ABLocalDebug( cout << "#RANDOM..." << dataValue << "," << preRandomNumber << endl  );
				look = false;
			}
			else {
				if( preRandom ){
				
					if( preRandomCount <= dataValue ){
						//	ȂARANDOM̃Gh͖i΁ĵŁARANDOMw̏I𔻒f
						preRandom	= false; 
						look		= true;
					}
					else{
						if( 0 == strcasecmp( literalBuffer, BMS_TP_eventData_STR_IF ) ){
							if( dataValue == preRandomNumber ){
								ABLocalDebug( cout << "#IF choice " << dataValue << "," << preRandomNumber << endl  );
								look = true;
							}
							else{
								//	wԍłȂ΂̍sڍsXLbv
								ABLocalDebug( cout << "#IF skip " << dataValue << "," << preRandomNumber << endl  );
								look = false;
							}
						}
						else if( 0 == strcasecmp( literalBuffer, BMS_TP_eventData_STR_ENDIF ) ){
							//	w͈͂
							ABLocalDebug( cout << "#ENDIF" << endl  );
							look		= true;
						}
					}

				}
			}
		}

		if( look ){
			//	Cxg^Cv16iȂ10i?
			sscanf( buffer, "#%3ld%2ld:%s", &barID, &eventType, dataBuffer );

			if( dataBuffer[0] == 0 ){
				//	":"Ăf[^܂ɗLi
				sscanf( buffer, "#%3ld%2ld %s", &barID, &eventType, dataBuffer );
			}

			if( eventType != 0 ){
				//	f[^͂AeventDataɊi[B
				ABLocalDebug( cout << "-READ EVENT > " << barID << "," << eventType << "," << eventTrackNumber << "," << dataBuffer << endl ; );
				eventData.clean();
				
				if( inLoadMode == BMS_TP_LOAD_HEADER_INFO_DATA ){
					if( BMS_TP_EVENT_OBJECT_1P <= eventType || 
						eventType <= BMS_TP_EVENT_HIDE_OBJECT_2P + BMS_TP_OBJECT_MODE7_KEY7
					){
						result = this->m_musicArchitecture->analyze( eventData, barID, eventType, dataBuffer );
						if( !result ){
							//	sB̃Cxg͓ǂݎs\łB
							ABReportError("-READ ERROR.");
						}
						else{
							if( useMaxTrackCount < eventData.trackNumber ){
								useMaxTrackCount = eventData.trackNumber;
							}
						}
					}
					//	KvȂ̂EI
					result = true;
					if( eventData.eventType == BMS_TP_EVENT_SET_BGA ){
						trueHaveBGA =  true;
					}
					if( BMS_TP_OBJECT_MODE7_KEY6 <= useMaxTrackCount && trueHaveBGA ){
						break;
					}
				}
				else{
					result = this->m_musicArchitecture->analyze( eventData, barID, eventType, dataBuffer );
					if( !result ){
						//	sB̃Cxg͓ǂݎs\łB
						ABReportError("-READ ERROR.");
					}
					else{
						if( barCount < barID ){
							barCount = barID;
						}
					
						ABLocalDebug( cout << "  -EVENT > "; );
						ABLocalDebugSimple( cout << "barID:" << eventData.barID << ","; );
						ABLocalDebugSimple( cout << "eventType:" << eventData.eventType << ","; );
						ABLocalDebugSimple( cout << "player:" << eventData.player << ","; );
						ABLocalDebugSimple( cout << "visible:" << eventData.visible << ","; );
						ABLocalDebugSimple( cout << "trackNumber:" << eventData.trackNumber<< ","; );
						ABLocalDebugSimple( cout << "value:" << eventData.value<< ","; );
						ABLocalDebugSimple( cout << "objectArray:" << eventData.objectArray.size(); );
						ABLocalDebugSimple( cout << endl; );
						
						//	ABbmsMusicDataɊi[
						refMusicData->eventDataArray.push_back( eventData );
						
						if( useMaxTrackCount < eventData.trackNumber ){
							useMaxTrackCount = eventData.trackNumber;
						}
						if( eventData.eventType == BMS_TP_EVENT_SET_BGA ){
							trueHaveBGA =  true;
						}

					}
				}
			}
		}
		
		++position;

		if( inReporter ){
			inReporter->onReport( inArray->size(), position );
		}
	}
	
	ABLocalDebug( cout << "BMSParser::readBMSeventData() Read event data finish." << endl; );

	if( !result ){
		return	false;
	}
	
	//	Headerɐݒ
	if( BMS_TP_OBJECT_MODE7_KEY6 <= useMaxTrackCount ){
		refMusicData->information.keyModeType = BMS_TP_KEY_TYPE_7KEY;
	}
	else{
		refMusicData->information.keyModeType = BMS_TP_KEY_TYPE_5KEY;
	}
	if( trueHaveBGA ){
		refMusicData->information.BGAType = BMS_TP_BGA_TYPE_HAVING;
	}
	else{
		refMusicData->information.BGAType = BMS_TP_BGA_TYPE_NOTHING;
	}
	refMusicData->information.lastBarID = barCount;
	
	return	true;
}

//-------------------------------------------------------
//	obt@̕擾
//-------------------------------------------------------
//	擾
void	BMSParser::getBufferValue( char*  inBuffer, char*  outValue, int  inLength )
{
	memcpy( outValue, inBuffer, inLength );
}
//	POi擾(long^)
void	BMSParser::getBufferValue( char*  inBuffer, long*  outValue )
{
	sscanf( inBuffer, "%ld", outValue );
}
//	POi擾(double^)
void	BMSParser::getBufferValue( char*  inBuffer, double*  outValue )
{
	sscanf( inBuffer, "%lf", outValue );
}
//	PUi擾(unsigned long^)
void	BMSParser::getBufferValue( char*  inBuffer, unsigned long*  outValue )
{
	unsigned long  value = 0;
	sscanf( inBuffer, "%x", &value );
	if( value == 0 ){
		sscanf( inBuffer, "%X", &value );
	}
	*outValue = value;
}

//-------------------------------------------------------
//	io[ɕϊ( 36i )
//-------------------------------------------------------
int		BMSParser::convCharToNum( char*  inBuffer, int  inLength )
{
	int		li = 0;
	char	lc = 0;
	int		resValue = 0;

	for( li = 0; li < inLength; li ++ ){
		resValue *= 36;

		lc = tolower( inBuffer[li] );	//	A -> a

		if( '0' <= lc && lc <= '9'){
			resValue += lc - '0';
		}
		else if( 'a' <= lc && lc <= 'z'){
			
			//	abcdefghij klmnopqrst uvwxyz	26
		
			resValue += 10 + (lc - 'a');
		}
		else{
			//	Ǖs\
			break;
		}
	}
	return	resValue;
}
