/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSPlayer.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

//	RgAEgƁAABLocalDebugLɂ܂ixxȂ܂jBɂĂƃRpC܂B
//#define		AB_LOCAL_DEBUG_MODE

#include	"GlobalConfig.h"

#include	"BMSPlayer.h"
#include	"BMSEvent.h"

//------------------------------------------------------------------------------
//	Constructor
//------------------------------------------------------------------------------
BMSPlayer::BMSPlayer( BMSEvent*  inEventActor )
{
	this->m_eventActor	= inEventActor;
}
//------------------------------------------------------------------------------
//	Destructor
//------------------------------------------------------------------------------
BMSPlayer::~BMSPlayer()
{
}

//------------------------------------------------------------------------------
//	Initialize
//------------------------------------------------------------------------------
ABbool		BMSPlayer::Initialize( BMSPlayerConfig*  inConfig, BMSTimer*  inTimer, BMSSong*  inSong, BMSResource*  inResource )
{
	ABbool		ret;
	
	//	FX
	this->m_end = false;
	this->m_bmsPlayerConfig = inConfig;
	this->m_song		= inSong;
	this->m_resource	= inResource;
	this->m_timer		= inTimer;
	this->m_headVibrant = 0;
	this->m_tailVibrant = - M_VIBRANT_RANGE;
	ret = this->m_song->moveVibrant( this->m_headVibrant, &this->m_headPoint );
	if( !ret ){ return ret; }

	memset( this->m_assignNoteEvent, 0, sizeof(this->m_assignNoteEvent));
	this->m_playerData.clean( this->m_bmsPlayerConfig, &this->m_judgeValue, this->m_comsumer );
	this->m_playerData.bpm = this->m_song->getSongData()->information.bpm;

	//	CxgRequest
	this->m_eventActor->setResource( this->m_resource, this->m_song->getSongData(), &this->m_playerData );
	ret = this->m_eventActor->onInit();
	if( !ret ){ return ret; }

	//	̏
	this->m_judgeValue.initialize( this->m_playerData.bpm );
	ABint	noteCount1 = this->m_song->getNoteCount(BMS_BMSEQ_EVENT_PLAYER1);
	ABint	noteCount2 = this->m_song->getNoteCount(BMS_BMSEQ_EVENT_PLAYER2);
	this->m_comsumer[BMS_BMSEQ_EVENT_PLAYER1].initialize( this->m_song->getSongData()->information.total, noteCount1, false );
	this->m_comsumer[BMS_BMSEQ_EVENT_PLAYER2].initialize( this->m_song->getSongData()->information.total, noteCount2, false );

	this->m_song->getTypeListDataPoimter( &this->m_judgeEventFetchListIt ); 
	this->m_song->getTypeListDataPoimter( &this->m_assignEventFetchListIt ); 

	this->m_first = true;

	ABLocalDebug( ABReport( "Start music" ); );
	return true;
}

//------------------------------------------------------------------------------
//	finalize
//------------------------------------------------------------------------------
void		BMSPlayer::finalize( void )
{
	//	ICxgRequest
//	this->m_eventActor->onFinal();

	ABLocalDebug( ABReport( "End music" ); );
}

//------------------------------------------------------------------------------
//	Đ
//------------------------------------------------------------------------------
void		BMSPlayer::loop( ABint  inLocation )
{
//	printf( "  +loop... location[%d]\n", inLocation );
	ABint	runLocation = inLocation - M_LOCATION_RANGE;

	BMSSongVibrantData*		vd;
	BMSSongVibrantData*		vdTail;
	vd = this->m_song->getVibrant( this->m_headVibrant );
	if( vd == NULL ){ this->m_end = true; return; }

	vdTail = this->m_song->getVibrant( this->m_tailVibrant );
	
	if( this->m_first ){
		ABLocalDebug( ABReport( "inLocation" ); );
		this->m_eventActor->onPlayerEvent( runLocation, BMS_BMSEQ_STARTUP_EVENT_PLAY );

		//	ŏɈx̃Cxgǂ݁B
		this->m_fetchPoint = this->m_headPoint;
		this->fetchEvents( runLocation );

		this->m_first = false;
	}
	this->m_eventActor->onPlayerEvent( runLocation, BMS_BMSEQ_STARTUP_EVENT_UPDATE_LOCATION );
	
	//	P[Vʒu珬߂̐is
	{
		if( vd->location + vd->length <= inLocation ){
			//	݂̏߂яoĂ̂ŁȀ߂ֈړ
			++this->m_headVibrant;
			this->m_song->moveVibrant( this->m_headVibrant, &this->m_headPoint );
			
			//	ߐisCxgRequest	̃^C~OŃo[zu܂
			ABLocalDebug( printf( "  +[request event: vibrant change] inLocation[%d] runLocation[%d] head[%4d], tail[%4d]\n", inLocation, runLocation, this->m_headVibrant, this->m_tailVibrant ); );
			this->m_eventActor->onChangeBivrant( inLocation );
			
			//	vdTailNULL̎́A擪łЂςiȂƂ܂łĂCxgȂj
			if( vdTail == NULL ){
				++this->m_tailVibrant;
				this->m_song->moveVibrant( this->m_tailVibrant, &this->m_tailPoint );
				this->m_song->moveVibrant( this->m_tailVibrant, &this->m_fetchPoint );
			}
		}

		if( vdTail ){
			//	Cxgsʒu̍XVB͕ʂɍsBꏏɍsƁA߂̒ςĂƂɍĂ܂
			if( vdTail->location + vdTail->length <= runLocation ){
				++this->m_tailVibrant;
				if( 0 <= this->m_tailVibrant ){
					this->m_song->moveVibrant( this->m_tailVibrant, &this->m_tailPoint );
					this->m_song->moveVibrant( this->m_tailVibrant, &this->m_fetchPoint );
				}
			}
		}
	}

	//	Cxg̔zu
	this->allocateEvents( inLocation );
	
	if(  0 <= this->m_tailVibrant && 0 <= runLocation ){

		//	Cxg̎s
		this->runEvents( runLocation );
	}
	//	[U[̃ANVs
	this->userAvtion( runLocation );
}

//------------------------------------------------------------------------------
//	BPM擾
//------------------------------------------------------------------------------
ABint		BMSPlayer::getBPM( void )
{
	return	this->m_playerData.bpm;
}

//------------------------------------------------------------------------------
//	IH
//------------------------------------------------------------------------------
ABbool		BMSPlayer::isEnd( void )
{
	return	this->m_end;
}

//------------------------------------------------------------------------------
//	Cxg̔zu
//------------------------------------------------------------------------------
void		BMSPlayer::allocateEvents( ABint  inLocation )
{
	BMSSongEventData*		ed;

	this->m_song->beginGetNextEventData( &this->m_headPoint );
	ed = this->m_song->getEventData( &this->m_headPoint );
	if( ed == NULL ){
//		printf( "  +BMSPlayer::allocateEvents allocateEvents() is NULL\n" );
		return;
	}
//	printf( "  +BMSPlayer::allocateEvents inLocation[%d], ed->location[%d]\n", inLocation, ed->location );
	if( ed->location <= inLocation ){
		//	߂ĂƂ

		//	݂̃Cxgf[^QƂ
		while( this->m_song->getNextEventData( &this->m_headPoint, &ed ) ){
			//	zuCxgRequest
			ABLocalDebug( printf( "  +[request event: alloc event] [%8d] vibrant[ %8d ], location[ %8d], playerNumber[ %-24s ], trackNumber[ %-24s ], eventType[ %-36s ], eventValue[ %8.8F ]\n",
					ed->eventNumber, ed->vibrant, ed->location, BMSSeqGetPlayerNumberName(ed->playerNumber), BMSSeqGetTrackTypeName(ed->trackNumber), BMSSeqGetEventTypeName(ed->eventType), ed->eventValue ); );
			
			this->m_eventActor->onAllocEvent( inLocation, ed );
		}

	}
}

//------------------------------------------------------------------------------
//	Cxg̎s
//------------------------------------------------------------------------------
void		BMSPlayer::runEvents( ABint  inLocation )
{
	BMSSongEventData*		ed;

	this->m_song->beginGetNextEventData( &this->m_tailPoint );
	ed = this->m_song->getEventData( &this->m_tailPoint );
	if( ed == NULL ){
//		printf( "  +BMSPlayer::runEvents getEventData() is NULL\n" );
		return;
	}
//	printf( "      +BMSPlayer::runEvents inLocation[%d], ed->location[%d]\n", inLocation, ed->location );
	if( ed->location <= inLocation ){
		//	߂ĂƂ

		ABint	location = ed->location;

		//	݂̃Cxgf[^QƂ
		while( this->m_song->getNextEventData( &this->m_tailPoint, &ed ) ){

			//	sCxgRequest
			ABLocalDebug( printf( "  +[request event: run event] [%8d] vibrant[ %8d ], location[ %8d], playerNumber[ %-24s ], trackNumber[ %-24s ], eventType[ %-36s ], eventValue[ %8.8F ]\n", 
					ed->eventNumber, ed->vibrant, ed->location, BMSSeqGetPlayerNumberName(ed->playerNumber), BMSSeqGetTrackTypeName(ed->trackNumber), BMSSeqGetEventTypeName(ed->eventType), ed->eventValue ); );

			//	gݍ݃Cxg			
			switch( ed->eventType ){
				case BMS_BMSEQ_EVENT_CHANGE_BPM:
				case BMS_BMSEQ_EVENT_SET_EX_BPM:
				
					if( ed->eventType == BMS_BMSEQ_EVENT_CHANGE_BPM ){
						this->m_playerData.bpm = (ABint)ed->eventValue;
					}
					else{
						this->m_playerData.bpm = this->m_song->getSongData()->getBPM( (ABint)ed->eventValue );
					}
					this->m_timer->resetTimer( this->m_playerData.bpm );
					this->m_judgeValue.initialize( this->m_playerData.bpm );
					break;
			}

			//	CxgsRequest
			this->m_eventActor->onExecuteEvent( inLocation, ed );
		}
		
		//	sÃCxgǂ݁B
		this->m_fetchPoint = this->m_tailPoint;
		this->fetchEvents( inLocation );
	}
}

//------------------------------------------------------------------------------
//	Cxg̐ǂ
//------------------------------------------------------------------------------
void		BMSPlayer::fetchEvents( ABint  inLocation )
{
	BMSSongEventData*		ed;
	ABint					getCounter = 0;

	//	菀
	BMSSongEventData*		firstED = NULL;
	while( this->m_song->getEventTypeListData( this->m_judgeEventFetchListIt, &ed ) ){
		
		//	X^bN܂ĂƂ͔
		if( 2 <= this->m_fetchNoteEvent[ ed->playerNumber ][ ed->trackNumber ].size() ){
			break;
		}

		//	݃P[V̂̂B
		if( inLocation <= ed->location ){
			if( firstED == NULL ){
				firstED = ed;
			}
			else{
				//	P[Vς甲
				if( firstED->location != ed->location ){
					break;
				}
			}

			//	IuWFNgCxg̐ǂ݂sB
			//	L[ATCjudgê߂ɁÃCxgێB
			if( ed->eventType == BMS_BMSEQ_EVENT_OBJECT ){
				//printf("this->m_fetchNoteEvent inLocation[%8d] ed->playerNumber:[%8d], ed->trackNumber[%8d], ed->location[%8d]\n", inLocation, ed->playerNumber, ed->trackNumber, ed->location );
				//	egbNɃXgŊǗB
				//	JUDGE͉ʂ߂ɂĂsKv邪A
				//	Xg\ɂĂƕJUDGEΏۂێ邱ƂoB
				MJudgeEvent		je;
				je.ed = ed;
				this->m_fetchNoteEvent[ ed->playerNumber ][ ed->trackNumber ].push_back(je);
			}
		}
		++this->m_judgeEventFetchListIt;	//	
	}

	firstED = NULL;
	BMSSongEventDataPtrListIt	fetchIt = this->m_assignEventFetchListIt;
//	printf(" +begin assign...[%d]\n", inLocation );	
	while( this->m_song->getEventTypeListData( fetchIt, &ed ) ){

		//	݃P[V̂̂B
		if( ed->location <= inLocation ){
			//	ǂݎ̂
			++this->m_assignEventFetchListIt;
			fetchIt = this->m_assignEventFetchListIt;
		}
		else{
			if( firstED == NULL ){
				//	߂Ă̂Ƃ
				firstED = ed;
			}
			else{
				//	܂ő
				if( (firstED->location + BMS_SEQ_EVENT_RESOLUTION) <= ed->location ){
					break;
				}
			}

			//	AssignP[VĂH
			MAssignEvent	ae = this->m_assignNoteEvent[ ed->playerNumber ][ ed->trackNumber ];
//			if( ae.assignEd && ed->eventType == BMS_BMSEQ_EVENT_OBJECT ){
			if( ae.assignEd ){
				//	Qxڈȍ~Assign
				if( ! ae.assignFlag ){
//					if( ae.ed->location < inLocation && ae.assignEd->eventValue != ed->eventValue ){
					if( ae.assignEd->eventValue != ed->eventValue ){
//						printf("   +2nd assign [ET:%d][EL:%d]\n", ed->trackNumber, ed->location );

						ABint	reach = ed->locationReach / 2;
						if( BMS_SEQ_EVENT_RESOLUTION4 < reach ){
							//	ĂƁAyIWXg^C~OAssignôŁAC悳ɉeiJH
							ae.assignLocation = ed->location - ed->locationReach + BMS_SEQ_EVENT_RESOLUTION4;
						}
						else{
							ae.assignLocation = ed->location - reach;
						}

						//	eς̂ŁAVCxgݒu
						ae.ed = ed;
						ae.assignFlag = true;

						//	CxgsRequest
						this->m_assignNoteEvent[ ed->playerNumber ][ ed->trackNumber ] = ae;
						this->m_eventActor->onFetchEvent( ae.assignLocation, ed );

					}
					//else{
						//	ȂFCxgȂ̂ŁAAssignKv͂ȂB̃gbN𒲂ׂ
					//}
				}
				else{
					//	Ȃ
//					printf("   +2nd assign event update [ET:%d][EL:%d]\n", ed->trackNumber, ed->location );
				}
			}
			else{
				//	߂ĂAssign	܂͉BIuWFNg
				//printf("   +1st assign [ET:%d][EL:%d]\n", ed->trackNumber, ed->location );
				ae.ed = ed;
				ae.assignEd = ae.ed;
				ae.assignLocation = -M_LOCATION_RANGE;
				ae.assignFlag = true;

				//	CxgsRequest
				this->m_assignNoteEvent[ ed->playerNumber ][ ed->trackNumber ] = ae;
				this->m_eventActor->onFetchEvent( ae.assignLocation, ed );
			}

			++fetchIt;//	
		}
	}
//	printf(" +end assign...\n");
}

//------------------------------------------------------------------------------
//	[U[̃ANVs
//------------------------------------------------------------------------------
void		BMSPlayer::userAvtion( ABint  inLocation )
{
	static	BMSSeqEventTrackType	trackArray[] = {
		BMS_SEQ_TRACK_EVENT,						
		BMS_SEQ_TRACK_KEY1,
		BMS_SEQ_TRACK_KEY2,
		BMS_SEQ_TRACK_KEY3,
		BMS_SEQ_TRACK_KEY4,
		BMS_SEQ_TRACK_KEY5,
		BMS_SEQ_TRACK_KEY6,
		BMS_SEQ_TRACK_KEY7,
		BMS_SEQ_TRACK_KEY_SCRATCH_FREE,
		BMS_SEQ_TRACK_KEY_SCRATCH,
	};

	ABint		p,t, track;
	for( p = 0; p < BMS_BMSEQ_EVENT_PLAYER_COUNT; p++ ){
	
		ABbool					activeFreeScratch = false;
		BMSSeqEventTrigger		trigger;
		ABfloat32				triggerLocation = 0.0f;

		//	gK[Request
		//	E[U[Ɏۂɓ͂Ă炤
		this->m_eventActor->onRequestTrigger( (BMSSeqEventPlayerNumber)p, &trigger, inLocation, &triggerLocation );

		for( track = BMS_SEQ_TRACK_KEY1; track < BMS_SEQ_TRACK_COUNT; track++ ){
		
			//	t[XNb`gbNɏ悤Iɒu܂BiŒǉ̂łȏj
			//	́At[XNb`ƏdȂĂXNb`肪߂łB
			//	Ƀt[XNb`𔻒肵At[ZonȅꍇfreeScratchJEjen܂B
			//	ɂdȂĂXNb`̔ꏈ܂B
			t = trackArray[ track ];
		
			MAssignEvent*		ae = &( this->m_assignNoteEvent[ p ][ t ] );
			ABbool				action = false;

			MJudgeEventListIt 		mjit;
			MJudgeEvent				emptyJe;
			MJudgeEvent*			je = NULL;
			

			if( !this->m_fetchNoteEvent[ p ][ t ].empty() ){
				//	judgeX^bN̍ŏjudges
				mjit = this->m_fetchNoteEvent[ p ][ t ].begin();
				je = &( *mjit );
			}
			else{
				je = &emptyJe;
			}

			if( ae->ed && ae->assignFlag ){
				if( ae->assignLocation <= inLocation ){
//					printf("   +do assign [L:%d][ET:%d][EL:%d][AL:%d]\n", inLocation, ae->ed->trackNumber, ae->ed->location, ae->assignLocation );
					//	L[ATCCxgRequest
					this->m_eventActor->onAssignNote( inLocation, (BMSSeqEventPlayerNumber)p, (BMSSeqEventTrackType)t, ae->ed );
					ae->assignEd = ae->ed;
					ae->assignFlag = false;
/*
					if( je->ed ){	//	ǂ݃fobO
						if( 0 == je->triggerCount ){
							action = true;
							je->triggerCount = 1;
							je->triggerLocation = inLocation;
						}
					}
*/
				}
			}
			
			//-----------------------------------------------------------------
			//	t
			//-----------------------------------------------------------------
			if( je->ed ){
				if( je->ed->location <= inLocation && je->triggerCount == 0){
					switch( this->m_bmsPlayerConfig->autoPlayMode[p] ){
						case BMS_SEQ_AUTO_PLAY_TYPE_ALL:
							action = true;
							je->triggerCount = 1;
							je->triggerLocation = inLocation;
							break;
						case BMS_SEQ_AUTO_PLAY_TYPE_KEY_TRACKS:
							if( track != BMS_SEQ_TRACK_KEY_SCRATCH && track != BMS_SEQ_TRACK_KEY_SCRATCH_FREE ){
								action = true;
								je->triggerCount = 1;
								je->triggerLocation = inLocation;
							}
							break;
						case BMS_SEQ_AUTO_PLAY_TYPE_SCRATCH_TRACKS:
							if( track == BMS_SEQ_TRACK_KEY_SCRATCH || track == BMS_SEQ_TRACK_KEY_SCRATCH_FREE ){
								action = true;
								je->triggerCount = 1;
								je->triggerLocation = inLocation;
							}
							break;
					}
				}
			}

			//-----------------------------------------------------------------
			//	auto push trigger testing (debugging)--->
			//
			//	eXg
			//	EۂɃL[ԂV~[g܂BJɎgpĂB
			//
			//	tɂƂ́Aactiontrueɂ܂
			//
			//-----------------------------------------------------------------
#if	0	
//#if	1	
			if( je->ed ){
				//printf("Test. inLocation[%8d] ed->playerNumber:[%8d], ed->trackNumber[%8d], ed->location[%8d]\n", inLocation, je->ed->playerNumber, je->ed->trackNumber, je->ed->location );
				if( je->ed->location <= inLocation && je->triggerCount == 0){
				
					//	茋ʂV~[g܂
					ABfloat32	barance = (ABfloat32)this->m_playerData.bpm / 120.0f;
/*
					{
						//	AB_SEQ_GAME_LEVEL_NOMAL
						{
							static	int testCase = -1;
							++testCase;
							if( 4 < testCase ){
								testCase = 0;
							}
							switch( testCase ){
								case	0:
									triggerLocation = (float)inLocation - 0.0f * barance;		//	JUST GREAT
									break;
								case	1:
									triggerLocation = (float)inLocation - 8.3f * barance;		//	GREAT
									break;
								case	2:
									triggerLocation = (float)inLocation - 16.5f * barance;		//	GOOD
									break;
								case	3:
									triggerLocation = (float)inLocation - 34.1f * barance;		//	BAD
									break;
								case	4:
									triggerLocation = (float)inLocation - 46.1f * barance;		//	POOR
									break;
							}
						}
					} 
*/

					{
						//	AB_SEQ_GAME_LEVEL_NOMAL
						{
							triggerLocation = (float)inLocation - 0.0f * barance;		//	JUST GREAT
//							triggerLocation = (float)inLocation - 10.0f * barance;		//	GREAT
//							triggerLocation = (float)inLocation - 16.5f * barance;	//	GOOD
						}
					}

					//printf("*TEST PUSH. inLocation[%8d] ed->playerNumber:[%8d], ed->trackNumber[%8d], ed->location[%8d]\n", inLocation, je->ed->playerNumber, je->ed->trackNumber, je->ed->location );

					action = true;
					je->triggerCount = 1;
					je->triggerLocation = triggerLocation;


//					if( je->ed->trackNumber != BMS_SEQ_TRACK_KEY_SCRATCH && je->ed->trackNumber != BMS_SEQ_TRACK_KEY_SCRATCH_FREE ){
//					if( je->ed->trackNumber != BMS_SEQ_TRACK_KEY_SCRATCH ){
/*					if( je->ed->trackNumber != BMS_SEQ_TRACK_KEY_SCRATCH_FREE ){
						action = true;
						je->triggerCount = 1;
						je->triggerLocation = triggerLocation;
					}
*/
				}
			}
#endif
			//-----------------------------------------------------------------
			//	eXg܂
			//	<-- auto push trigger testing (debugging)
			//-----------------------------------------------------------------
			
			//	łpoor
			MThroughPoorEvent*	poorEvent = &( this->m_throughPoorEvent[ p ][ t ] );

			//	gK[Request
			//	E[U[Ɏۂɓ͂Ă炤
			
			if( trigger.trigger[t] ){
				++je->triggerCount;
				je->triggerLocation = triggerLocation;
				//printf( "PUSH- inLocation[%8d] je->triggerCount[%d], triggerLocation[%8f]\n", inLocation, je->triggerCount, je->triggerLocation );

				//	łvAH
				if( poorEvent->activeThrough ){
					//	x͏L^
					if( !poorEvent->push ){
						poorEvent->push = true;
					}
				}
				action = true;
			}

			if( ae->assignEd ){
				//	ANVRequest
				//	E͓eɑ΂ẴANVsBŉ炵ĉB

				if( ! (t == BMS_SEQ_TRACK_KEY_SCRATCH_FREE ) ){

					//	t[XNb`ƃXNb`͓炷߁A܂
					if( action ){
						this->m_eventActor->onTriggerAction( (BMSSeqEventPlayerNumber)p, (BMSSeqEventTrackType)t, ae->assignEd );
					}

				}
			}
			
			//------------------------------------------
			//	ƂĂGȔ
			//	E菈́A֐( this->m_judgeValue.judge() )ɔCȂ΂Ȃ܂B
			//	@͈͂̓Q[[hBPMƂ̗݂LAȂp[^`KvŕGȂ߁A
			//	@ŁAP[V͈͂画肷邱Ƃ͏o܂B
			//	EOƂāAt[XNb`Lȏꍇ͒ʏƂ͈قȂ锻sKv܂B
			//------------------------------------------

			//	łpoor
			if( poorEvent->limitLocation <= inLocation ){
				MThroughPoorEvent	emptyPoor;
				*poorEvent = emptyPoor;
			}

			if( je->ed ){
				ABint	checkLocation = ( inLocation - 12 );	//	ʂςƁAxĉƂjudge𒲐łB
				ABint	checkDoJudge;
				
				//	̂Ƃ́AɊ]TAĂ瑬U肷
				//	t[XNb`̏ꍇ́AJUDGE^C~OS扄΂B
				ABint	judgeLocation = je->ed->location;
				if( je->ed->trackNumber == BMS_SEQ_TRACK_KEY_SCRATCH_FREE ){

					//	t[XNb`LZonełB
					if( judgeLocation <= je->triggerLocation ){
						activeFreeScratch = true;
					}

					judgeLocation += BMS_SEQ_EVENT_RESOLUTION4;
					
					//	t[XNb`Zone܂Ŕx܂B
					checkDoJudge =  judgeLocation <= checkLocation;
				}
				else{
					//	t[XNb`ȊO͔胍P[VB_ŉĂΑU肵܂B
					checkDoJudge =  ( judgeLocation <= checkLocation ) ||  ((judgeLocation <= inLocation) && je->triggerCount != 0 ) ;
				}

				//------------------------------------------
				//	胍P[VH
				//------------------------------------------
				if( checkDoJudge ){
					BMSSeqJudgeType			judgeType;

					//printf( "JUDGE- inLocation[%8d] je->triggerCount[%d], triggerLocation[%8f]\n", inLocation, je->triggerCount, je->triggerLocation );

					ABbool				requireJudge = true;
					BMSSeqJudgeType		forceJudge;		//	requireJudge=falsêƂgp
					do{
						if( t == BMS_SEQ_TRACK_KEY_SCRATCH_FREE ){
							//------------------------------------------
							//	t[XNb`gbN̏ꍇ
							//------------------------------------------
							//	S͈͓ȂAĂGreatƂ
							if( 1 <= je->triggerCount ){
								if( ( ( judgeLocation - BMS_SEQ_EVENT_RESOLUTION4 ) <= je->triggerLocation ) && ( je->triggerLocation <= checkLocation  ) ){
									requireJudge = false;						//	judgeThrough
									forceJudge = BMS_SEQ_JUDGE_JUST_GREATE;		//	m
								}
								else{
									//	judgeɈς˂B̂ƂAje->ed->location̓t[XNb`̐擪wĂ̂ŁAt[XNb`̃^C~Oɂ
									//	K؂judgeoB
								}
							}
							else{
								//	judgeɈς˂B
								//	łvA`FbNB
								triggerLocation = 9999.0f;	//	KȒlBADƂĂ
							}
						}
						else if( activeFreeScratch &&  t == BMS_SEQ_TRACK_KEY_SCRATCH ){
							//------------------------------------------
							//	t[XNb`LZoneɂāAXNb`gbN̏ꍇ
							//------------------------------------------
							//	ĂΖɍiƂĂ
							if( 1 <= je->triggerCount ){
								//	judgeɈς˂B
							}
							else{
								//	judgeɈς˂B
								//	łvA`FbNB
								triggerLocation = 9999.0f;	//	KȒlBADƂĂ
							}
						}
						else{
							//------------------------------------------
							//	̑gbN̏ꍇ
							//------------------------------------------
							if( 1 == je->triggerCount ){
								//	Ă
								triggerLocation = je->triggerLocation;
							}
							else{
								//	ĂȂAxĂ
								
								//	łpoor`FbN
								if( poorEvent->activeThrough ){
									if( poorEvent->push ){
										//	łĂiJmȂB肷܂ł͂킩ȂBj
										if( 2 == je->triggerCount ){
											//	{ɉĂȂƂpoorBĂƂ͋łȂ̂JUDGEB
											//	Rȏ㉟Ă狖ȂB
											break;
										}
									}
								}

								//printf( "JUDGE- bad. \n" );
								triggerLocation = 9999.0f;	//	KȒlBADƂĂ
							}
						}
					}while( false );

					//------------------------------------------
					//	s
					//------------------------------------------
					//	t[XNb`ׂ̈傱ƕG
					ABbool	isJudge;
					if( requireJudge ){
						isJudge = this->m_judgeValue.judge( this->m_bmsPlayerConfig->gameLevel, je->ed->location, triggerLocation, &judgeType );
					}
					else{
						isJudge		= true;
						judgeType	= forceJudge;
					}
					
					//------------------------------------------
					//	茋
					//------------------------------------------
					if( isJudge ){
						do{
							//	łpoor`FbN
							if( judgeType == BMS_SEQ_JUDGE_POOR ){
								if( poorEvent->activeThrough ){
									if( poorEvent->push ){
										//	łĂ̂Ŕ
										break;
									}
								}
							}

							//	t[XNb`̏ꍇpoor,badȊOJグ
							if( t == BMS_SEQ_TRACK_KEY_SCRATCH_FREE ){
								judgeType = BMS_SEQ_JUDGE_JUST_GREATE;
							}

							//	ŃvC[̐тWv
							this->m_comsumer[p].setJadgeGreatGete( false );
							this->m_comsumer[p].scoreCount( this->m_bmsPlayerConfig->expartMode, judgeType, this->m_bmsPlayerConfig->gameLevel );

						}while( false );
					}
					
					//------------------------------------------
					//	㏈
					//------------------------------------------
					//	|[g
					this->m_playerData.judgeType[ p ] = judgeType;
					
					//	肵A폜
					this->m_fetchNoteEvent[ p ][ t ].pop_front();
					
					//	łpoord
					if( judgeType == BMS_SEQ_JUDGE_JUST_GREATE && judgeType == BMS_SEQ_JUDGE_GREATE ){
						MThroughPoorEvent	emptyPoor;
						*poorEvent = emptyPoor;
						poorEvent->activeThrough = true;
						poorEvent->limitLocation = inLocation + BMS_SEQ_EVENT_RESOLUTION4 / 2; //	MacBeatdlɏ]8̒Ƃ
					}
				}
			}
			
		}
	}

}
