/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSPlayer.h

				BMS\OĐNXB
				t郆[U[̎ł͖̂ŒӁB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSPlayer_h
#define	BMSPlayer_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"BMSSong.h"

#include	"BMSJudgeValue.h"
#include	"BMSConsumer.h"

class	BMSTimer;
class	BMSEvent;
class	BMSResource;

////////////////////////////////////////////////////////////////////////////////
//	Player data
//	EvC[i[U[ł͂ȂBMStuj̍Đ
////////////////////////////////////////////////////////////////////////////////
typedef	struct BMSPlayerData{

	ABint				bpm;			//	݂BPM
	
	BMSSeqJudgeType		judgeType[ BMS_BMSEQ_EVENT_PLAYER_COUNT ];		//	JUDGEݒ肳܂BQƂNAĂB

	BMSJudgeValue*		judgeValue;		//	judgep
	BMSConsumer*		comsumer[ BMS_BMSEQ_EVENT_PLAYER_COUNT ];			//	tҏ
	BMSPlayerConfig*  	bmsPlayerConfig;		//	tu̐ݒivC[̐ݒł͂Ȃj

	void	clean( BMSPlayerConfig* inBmsPlayerConfig, BMSJudgeValue*  inJudgeValuePointer, BMSConsumer*  inComsumerPointer ){
		ABint	i;
		bpm				= 0;
		judgeValue	= inJudgeValuePointer;
		for( i = 0 ; i < BMS_BMSEQ_EVENT_PLAYER_COUNT; i++ ){
			judgeType[i]	= -1;
			comsumer[i]		= &inComsumerPointer[i];
			bmsPlayerConfig = inBmsPlayerConfig;
		}
	}
} BMSPlayerData;

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSPlayer
{
private:
	enum{	
		M_VIBRANT_RANGE		= 2,
		M_LOCATION_RANGE	= M_VIBRANT_RANGE * BMS_SEQ_EVENT_RESOLUTION,	//	Cxgzu関̍ĐʒuB
	};

	ABint	m_bpm;					//	݂̑x
	ABint	m_location;				//	݂̃P[V
	ABint	m_locHeadPoint;			//	Cxgzuʒu
	ABint	m_locTailPoint;			//	Cxgsʒu

	BMSSong*		m_song;				//	Đ\O
	BMSEvent*		m_eventActor;		//	CxgsNX
	BMSResource*	m_resource;			//	BMP,WAV͂QƂ
	BMSTimer*		m_timer;
	
	ABint				m_headVibrant;	//	߈ʒu
	ABint				m_tailVibrant;	//	߈ʒu
	BMSEventDataPointer	m_headPoint;	//	Cxgzu铪ʒu
	BMSEventDataPointer	m_tailPoint;	//	Cxgs邵ۈʒu
	BMSEventDataPointer	m_fetchPoint;	//	Cxgsǂ݈ʒuBۈʒu̐sB

	BMSPlayerData		m_playerData;	//	tȕ
	
	BMSJudgeValue		m_judgeValue;	//	judgep
	BMSConsumer			m_comsumer[ BMS_BMSEQ_EVENT_PLAYER_COUNT ];	//	tҏ
	
	BMSPlayerConfig* 	m_bmsPlayerConfig;		//	tu̐ݒivC[̐ݒł͂Ȃj

	ABbool				m_first;
	ABbool				m_end;
	
	BMSSongEventDataPtrListIt		m_judgeEventFetchListIt;	//	Cxg^Cvɕč쐬郊XgBǂׂ݂̈Ɏgp܂B
	BMSSongEventDataPtrListIt		m_assignEventFetchListIt;	//	Cxg^Cvɕč쐬郊XgBǂׂ݂̈Ɏgp܂B
	
	typedef	struct MJudgeEvent{
		BMSSongEventData*	ed;
		ABint				triggerCount;		//	[U[gK[
		ABfloat32			triggerLocation;	//	[U[gK[^C~O
		MJudgeEvent(){
			ed = NULL;
			triggerCount = 0;
			triggerLocation = 0.0f;
		}
	} MJudgeEvent;
	typedef	std::list<MJudgeEvent>			MJudgeEventList;
	typedef	MJudgeEventList::iterator		MJudgeEventListIt;
	MJudgeEventList			m_fetchNoteEvent[ BMS_BMSEQ_EVENT_PLAYER_COUNT ][ BMS_SEQ_TRACK_COUNT ];	//	ǂ݂ɂđm[gCxg
	
	typedef	struct MThroughPoorEvent{	//	AłvAĂǂp󂷂́H
		ABbool	activeThrough;	//	true = ł
		ABint	limitLocation;	//	łL
		ABbool	push;			//	ł`FbNɃ{^H
		MThroughPoorEvent(){
			activeThrough = false;
			limitLocation = 0;
			push = false;
		}
	} MThroughPoorEvent;
	MThroughPoorEvent		m_throughPoorEvent[ BMS_BMSEQ_EVENT_PLAYER_COUNT ][ BMS_SEQ_TRACK_COUNT ];	//	łpoor

	typedef	struct MAssignEvent{
		BMSSongEventData*	ed;
		BMSSongEventData*	assignEd;
		ABint				assignLocation;		//	assignׂ^C~O
		ABbool				assignFlag;
		MAssignEvent(){
			assignEd = NULL;
			ed = NULL;
			assignLocation = 0;
			assignFlag = false;
		}
	} MAssignEvent;
	MAssignEvent			m_assignNoteEvent[ BMS_BMSEQ_EVENT_PLAYER_COUNT ][ BMS_SEQ_TRACK_COUNT ];	//	ǂ݂ɂđm[gCxg

public:
	BMSPlayer( BMSEvent*  inEventActor );
	virtual	~BMSPlayer();
	
	//	Initialize
	ABbool		Initialize( BMSPlayerConfig*  inConfig, BMSTimer*  inTimer, BMSSong*  inSong, BMSResource*  inResource );
	
	//	finalize
	void		finalize( void );
	
	//	Đ
	void		loop( ABint  inLocation );
	
	//	BPM擾
	ABint		getBPM( void );

	//	IH
	ABbool		isEnd( void );
	
	//	Consumer擾
	//	BMSĐ͏܂B
	BMSConsumer*	getComsumer( BMSSeqEventPlayerNumber  inPlayerNumber ){
		return &this->m_comsumer[ inPlayerNumber ];
	}

private:	
	//	Cxg̔zu
	void		allocateEvents( ABint  inLocation );
	
	//	Cxg̎s
	void		runEvents( ABint  inLocation );

	//	Cxg̐ǂ
	void		fetchEvents( ABint  inLocation );

	//	[U[̃ANVs
	void		userAvtion( ABint  inLocation );

};

#endif	//	BMSPlayer_h
