/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSResource.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////
#include	<algorithm>

#include	"BMSResource.h"
#include	"BMSParserConfig.h"

#include	"GameSingleton.h"
#include	"GGTexture.h"

using namespace	std;

//------------------------------------------------------------------------------
//	Constructor
//------------------------------------------------------------------------------
BMSResource::BMSResource()
{
	ABint		i;
	ABint8*		ext;
	
	i = 0;
	while( (ext = BMSGetFileExtBMP( i ) ) != NULL ){
		this->m_extBmsArrray.push_back( string(ext) );
		++i;
	}

	i = 0;
	while( (ext = BMSGetFileExtWAV( i )) != NULL ){
		this->m_extWavArrray.push_back( string(ext) );
		++i;
	}
	this->m_stageWallTexture = NULL;
}

//------------------------------------------------------------------------------
//	Destructor
//------------------------------------------------------------------------------
BMSResource::~BMSResource()
{
}

//------------------------------------------------------------------------------
//	\OW
//------------------------------------------------------------------------------
ABbool	BMSResource::collectSong( ABint8*  inFolderPath )
{
	bool	result = false;
	
	this->close();
	this->m_textureArray.reserve( 2048 );	//	K
	this->m_soundArray.reserve( 2048 );	//	K
	
	//	collect folder
	result = this->m_fileList.collectFilInfo( inFolderPath, false );
	ABTestReturnReportError( ! result, "empty folder." );
	
	//	t@CXg\z
	//	Et@C̎R̒ABMSf[^t@CƑfރt@CƂ𕪗Ă܂B

	//	BMSf[^Xg\z
	GameFileInfoList			*fileArray = this->m_fileList.getArray(); 
	GameFileInfoListIt			it;
	MExtArray::iterator			hit;

	ABint8				fileName[BMS_TP_CHAR_LENGTH_FILEPATH];
	ABint8*				fileNamePtr = NULL;
	ABint				len			= sizeof(fileName);
	ABint				extCharLen	= this->m_extBmsArrray[0].length();
	{
		for( it = fileArray->begin() ; it != fileArray->end() ; it++ ){

			memset( fileName, 0, sizeof(fileName) );
			it->copyPath( (ABuint8*)fileName, len );
			
			if( extCharLen <= strlen(fileName)  ){
				//	gq擾
				fileNamePtr = strrchr( fileName, '.' );
				if( fileNamePtr ){
					
					//	ɕϊ
					for( ABint pos = 0 ; pos < strlen( fileNamePtr ); pos++ ){
						ABint	lowerChar =  tolower( *(fileNamePtr + pos) );
						*( fileNamePtr + pos) = lowerChar;
					}
					
					if( fileNamePtr != NULL ){

						++fileNamePtr;
						
						//	BMSt@C
						hit = find( this->m_extBmsArrray.begin(), this->m_extBmsArrray.end(), string( fileNamePtr ) );
						if( hit != this->m_extBmsArrray.end() ){
							//	hitƂBMSf[^t@C֐U蕪
							this->m_songArray.push_back( *it );
						}
					}

				}
			}//if
		}//	for
	}
	
	if( this->m_songArray.empty() ){
		//	
		ABTestReturnReportError( ! result, "nothing BMS file." );
	}
	else{
		this->m_folderPath = inFolderPath;
	}
	return	true;
}

//------------------------------------------------------------------------------
//	\O
//------------------------------------------------------------------------------
ABuint	BMSResource::countSong( void )
{
	return	this->m_songArray.size();
}

//------------------------------------------------------------------------------
//	\Ȍꏊ擾
//------------------------------------------------------------------------------
GameFileInfo*	BMSResource::getSongFile( ABuint  inNumber )
{
	if( this->countSong() <= inNumber ){
		ABReportError( "faital argument inNumber." );
		return NULL;
	}
	return	&( this->m_songArray[ inNumber ] );
}

//------------------------------------------------------------------------------
//	BMPJ
//------------------------------------------------------------------------------
ABuint	BMSResource::openBMP( ABint8*  inFilePath )
{
	ABbool			result;
	GGTexture*		textrue = NULL;
	ABuint			index = 0;
	GameFileInfo	resFileInfo;

	//	t@CQƁAۂɃt@CL邩H
	result = this->getResourceFileInfo( this->m_folderPath, inFilePath, &resFileInfo );
	if( ! result ){
		ABReportError( "not found BMP file." );
		return 0;
	}

	//	J
	try{
			this->m_textureArray.push_back( new GGTexture );
			index = this->m_textureArray.size();
			textrue = this->m_textureArray[ index - 1 ];
	}
	catch( ... ){
		ABReportError( "bad alloc texture." );
		return 0;
	}

	result = textrue->opneBitmap( &resFileInfo, true, GE_BMP_TRANSPARENT_BLACK, 256, 256 );
	if( !result ){
		ABReportError( "faital open file." );
		return 0;
	}

	//	oCh	
	result = textrue->bindTexture();

	//	OK	
	return	index;
}

//------------------------------------------------------------------------------
//	WAVJ
//------------------------------------------------------------------------------
ABuint	BMSResource::openWAV( ABint8*  inFilePath )
{
	ABbool			result;
	ABuint			soundFile = 0;
	ABuint			index	= 0;
	GameFileInfo	resFileInfo;
	ABint			retry;
	ABint8			readFileName[ BMS_TP_CHAR_LENGTH_FILENAME ];

	sprintf( readFileName, "%s", inFilePath );
	for( retry = 0 ; retry < this->m_extWavArrray.size(); retry++ ){
	
		//	t@CQƁAۂɃt@CL邩H
		result = this->getResourceFileInfo( this->m_folderPath, inFilePath, &resFileInfo );
		if( ! result ){

			//	BMSf[^ɋLqĂResourceWAV̂ƂłAۂ̃t@Cmp3ȂB
			//@܂ŁAgqXggpāi"MP3","mp3"Ȃǁjǂ݂Ƃ\ȃt@CEgCB
			//	t@CH
			{
				ABint8		fileName[ BMS_TP_CHAR_LENGTH_FILENAME ];
				//	extrB%[^.]̓XLZbgƌĂ΂@\ŁA.ȍ~̕𖳎B
				sscanf( readFileName, "%[^.]", fileName );								
				//	H
				sprintf( readFileName, "%s.%s", fileName, this->m_extWavArrray[retry].c_str() );	

				ABDebug( ABReportFormat( "", "" ); );
				ABDebug( std::cout << " -not found WAV file. retry open file. filename:[" << readFileName << "]" << std::endl; );
			}
		}
		else{

			//	J
			result = GameGetAudio().openSoundFile( &resFileInfo, &soundFile );
			if( !result ){
				ABReportError( "bad open soundfile." );
				break;
			}
			this->m_soundArray.push_back( soundFile );
			index = this->m_soundArray.size();

			break;
		}
	}
	if( index == 0 ){
		ABReportError( "bad open soundfile." );
	}
	
	return	index;
}

//------------------------------------------------------------------------------
//	BMP
//------------------------------------------------------------------------------
void	BMSResource::closeBMP( ABuint  inResID )
{
	if( inResID != 0 ){
		if( this->m_textureArray.size() < inResID ){
			return ;
		}
		GGTexture*	texture = this->m_textureArray[inResID - 1];
		texture->deleteTexture();
		texture->closeBitmap();
		ABDebug( ABReportFormat( "Close BMP[%d]\n", inResID ) );
	}
}	

//------------------------------------------------------------------------------
//	WAV
//------------------------------------------------------------------------------
void	BMSResource::closeWAV( ABuint  inResID )
{
	if( inResID != 0 ){
		if( this->m_soundArray.size() < inResID ){
			return ;
		}
		ABuint	soundFile = this->m_soundArray[inResID - 1];
		GameGetAudio().closeSoundFile( soundFile );
		ABDebug( ABReportFormat( "Close WAV[%d]\n", inResID ) );
	}
}

//------------------------------------------------------------------------------
//	WAVt@C[CACHE
//------------------------------------------------------------------------------
void	BMSResource::cashingWAV( void )
{
	//::TODO::֐ɕsL
/*
	ABint	i;
	for( i = 0 ; i < this->m_soundArray.size() ; i++ ){
		ABDebug( ABReportFormat( "cashing... WAV[%d]\n", i + 1 ) );
		ABuint	soundFile = this->m_soundArray[i];
		ABbool	ret = GameGetAudio().cashingSoundFile( soundFile );
		if( ret ){
			ABDebug( ABReportFormat( "cashingSoundFile WAV[%d]\n", i + 1 ) );
		}
	}
*/
}

//------------------------------------------------------------------------------
//	Sĕ
//------------------------------------------------------------------------------
void	BMSResource::close( void )
{
	ABint	i;

	for( i = 0 ; i < this->m_textureArray.size() ; i++ ){
		this->closeBMP( i );
	}
	this->m_textureArray.clear();
	for( i = 0 ; i < this->m_soundArray.size() ; i++ ){
		this->closeWAV( i );
	}
	this->m_soundArray.clear();

	if( this->m_stageWallTexture){
		delete	this->m_stageWallTexture;
		this->m_stageWallTexture = NULL;
	}

	ABDebug( ABReport( "Close All" ) );
}

//-------------------------------------------------------
//	ParserŎgpR[obN
//-------------------------------------------------------
ABbool	BMSResource::openStageTitleBMP( BMSResource*  inResource, BMSTPSongData*  ioTPSongData )
{
	ABbool			result;
	GGTexture*		textrue = NULL;
	ABuint			index = 0;
	GameFileInfo	resFileInfo;

	if( inResource->m_stageWallTexture ){
		delete	inResource->m_stageWallTexture;
	}
	if( ioTPSongData->information.fileNameStageFile[0] == 0 ){
		//	G[ɂȂĂǂ
		return false;
	}

	//	t@CQƁAۂɃt@CL邩H
	result = inResource->getResourceFileInfo( inResource->m_folderPath, ioTPSongData->information.fileNameStageFile, &resFileInfo );
	if( ! result ){
		ABReportError( "not found BMP file." );
		return false;
	}

	//	J
	try{
		inResource->m_stageWallTexture =  new GGTexture ;
		textrue = inResource->m_stageWallTexture;
	}
	catch( ... ){
		ABReportError( "bad alloc texture." );
		return false;
	}

	result = textrue->opneBitmap( &resFileInfo, true, GE_BMP_TRANSPARENT_NONE, 0, 0 );
	if( !result ){
		ABReportError( "faital open file." );
		return false;
	}

	//	oCh	
	result = textrue->bindTexture();

	//	OK	
	return	true;
}


////////////////////////////////////////////////////////////////////////////////
//	ClientR[hɒ񋟂R[h
////////////////////////////////////////////////////////////////////////////////

//	Xe[W^Cg
ABbool		BMSResource::getStageTitleBMP( GGTexture**  outTexture )
{
	if( this->m_stageWallTexture == NULL  ){
		return	false;
	}
	else{
		*outTexture =	this->m_stageWallTexture;
	}
	return true;
}


//	BMP擾
ABbool		BMSResource::getBMP( ABuint  inResID, GGTexture**  outTexture )
{
	if( inResID != 0 ){

		if( this->m_textureArray.size() < inResID ){
			return false;
		}
		*outTexture =	this->m_textureArray[inResID - 1];
		return true;
	}
	return	false;
}

//	WAV擾
ABbool			BMSResource::getWAV( ABuint  inResID, ABuint*  outSoundFile )
{
	if( inResID != 0 ){
		if( this->m_soundArray.size() < inResID ){
			return false;
		}
		*outSoundFile = 	this->m_soundArray[inResID - 1];
		return true;
	}
	return false;
}


////////////////////////////////////////////////////////////////////////////////
//	
////////////////////////////////////////////////////////////////////////////////
//-------------------------------------------------------
//	get resource file info
//-------------------------------------------------------
bool	BMSResource::getResourceFileInfo( ABint8*  inDirectory, ABint8*  inFileName, GameFileInfo*  outFileInfo )
{
	char	fullPath[BMS_TP_CHAR_LENGTH_FILEPATH];
	bool	result	= false;

	//	tpX쐬
	memset( fullPath, 0, BMS_TP_CHAR_LENGTH_FILEPATH );
	this->makeFullpath( fullPath, inDirectory, inFileName, strlen(fullPath) );
	
	//	BMSWindowsArchitectureɏ]ShiftJISƂ݂ȂB
//	char	fileName[BMS_TP_CHAR_LENGTH_FILEPATH];
	GameString		fileNameString;
//	fileNameString.setCString( fullPath, GS_ENCORDING_SHIT_JIS );
	//	MacOS̃Jglocationɕϊ
//	fileNameString.getCString( fullPath, sizeof(fullPath), GS_ENCORDING_SYSTEM );
	//	MacOSUTF8ɕϊ
	fileNameString.setCString( fullPath, GS_ENCORDING_SHIT_JIS );
	fileNameString.getCString( fullPath, sizeof(fullPath), GS_ENCORDING_UTF8 );
	
	if( 0 != strlen( fullPath ) ){

		result = outFileInfo->make( (ABuint8*)fullPath );
		if( ! result ){
			//	file
			std::cout << "not open Res:: PATH:" << fullPath << ", FILE:" << inFileName << std::endl;
			return false;
		}
		//		std::cout << "Open Res::" << mode << "," << resNum << "," << fullPath << std::endl;
	}

	return true;
}
//-------------------------------------------------------
//	make fullpath
//-------------------------------------------------------
void	BMSResource::makeFullpath( ABint8*  outFullPath , ABint8*  inFolderName, ABint8*  inFileName ,ABint  inFolderNameSize )
{
	//	make path	/*::TODO::I[o[l鎖*/
	if( 0 == strlen(inFileName) ){
		outFullPath = NULL;
		return;
	}
	if( outFullPath[ inFolderNameSize - 1 ] != '/' ){
		sprintf( outFullPath , "%s/%s", inFolderName, inFileName );
	}
	else{
		sprintf( outFullPath , "%s%s", inFolderName, inFileName );
	}
}


