/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSResource.h

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSResource_h
#define	BMSResource_h

#include	<vector>
#include	<string>

#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"GameFile.h"
#include	"GameFileList.h"

#include	"BMSParserConfig.h"
class	GGTexture;

////////////////////////////////////////////////////////////////////////////////
//	class	ResourceǗNX
//	
//		̃NX́A@ˑx̍Resource𕪗邽߂̕łB
//	
////////////////////////////////////////////////////////////////////////////////
class	BMSResource
{
protected:
	typedef	std::vector<std::string>	MExtArray;

	typedef	std::vector< GGTexture* >	MTextureArray;	//i@ˑj
	typedef	std::vector< ABint >		MSoundArray;	//i@ˑj

	GameFileList		m_fileList;			//	tH_[̃t@CXg
	GameFileInfoArray	m_songArray;		//	tH_[̃Xgi@ˑj

	GGTexture*			m_stageWallTexture;	//	Xe[Wt@C
	MTextureArray		m_textureArray;		//	eNX`zi@ˑj
	MSoundArray			m_soundArray;		//	TEhzi@ˑj

	MExtArray			m_extBmsArrray;		//	ǂݍ݉\Ȋgq
	MExtArray			m_extWavArrray;		//	ǂݍ݉\Ȋgq

	ABint8*				m_folderPath;
public:
	BMSResource();
	virtual	~BMSResource();

	//	\OW
	virtual	ABbool	collectSong( ABint8*  inFolderPath );
	
	//	\O
	virtual	ABuint	countSong( void );
	
	//	\Ȍꏊ擾
	virtual	GameFileInfo*	getSongFile( ABuint  inNumber );
	
	//	BMPJ
	//	EBMPJAQƂׂ̈̔ԍԂ܂B
	//	E0 ͖`lƂA1ȏ̒lԂĉB
	virtual	ABuint	openBMP( ABint8*  inFilePath );

	//	WAVJ
	//	EWAVJAQƂׂ̈̔ԍԂ܂B
	//	E0 ͖`lƂA1ȏ̒lԂĉB
	virtual	ABuint	openWAV( ABint8*  inFilePath );

	//	BMP
	//	EQƔԍ^܂B
	//	E0̏ꍇ́A`lƂĖĂB
	virtual	void	closeBMP( ABuint  inResID );	

	//	WAV
	//	EQƔԍ^܂B
	//	E0̏ꍇ́A`lƂĖĂB
	virtual	void	closeWAV( ABuint  inResID );	
	
	//	WAVt@C[CACHE
	virtual	void	cashingWAV( void );	
	
	//	Sĕ
	virtual	void	close( void );

	//	ParserŎgpR[obNGXe[W^Cg摜J
	static ABbool	openStageTitleBMP( BMSResource*  inResource, BMSTPSongData*  ioTPSongData );

	////////////////////////////////////////
	//	ClientR[hɒ񋟂R[h
	////////////////////////////////////////

	//	Xe[W^Cg
	ABbool		getStageTitleBMP( GGTexture**  outTexture );

	//	BMP擾
	//	EQƔԍ^܂B
	//	E0̏ꍇ́A`lƂĖĂB
	ABbool		getBMP( ABuint  inResID, GGTexture**  outTexture );
	
	
	//	WAV擾
	//	EQƔԍ^܂B
	//	E0̏ꍇ́A`lƂĖĂB
	ABbool			getWAV( ABuint  inResID, ABuint*  outSoundFile );


protected:
	////////////////////////////////////////
	//	
	////////////////////////////////////////
	
	//	get resource file info
	bool	getResourceFileInfo( ABint8*  inDirectory, ABint8*  inFileName, GameFileInfo*  outFileInfo );

	//	make fullpath
	void	makeFullpath( ABint8*  outFullPath , ABint8*  inFolderName, ABint8*  inFileName ,ABint  inFolderNameSize );
};

#endif	//	BMSResource_h
