/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSSong.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"BMSSong.h"

//-------------------------------------------------------
//	Constructor
//-------------------------------------------------------
BMSSong::BMSSong( BMSTPSongData&  inSongTPData )
:
	m_songData( inSongTPData )
{
	this->m_noteEventCount[BMS_BMSEQ_EVENT_PLAYER1] = ( 0 );
	this->m_noteEventCount[BMS_BMSEQ_EVENT_PLAYER2] = ( 0 );
	this->m_songData.clean();
}
//-------------------------------------------------------
//	Destructor
//-------------------------------------------------------
BMSSong::~BMSSong()
{
	this->clear();
	this->m_songData.clean();
}

////////////////////////////////////////////////////////////////////////////////
//	f[^̉
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	͎s
//------------------------------------------------------------------------------
ABbool	BMSSong::analyze( void )
{
	this->clear();

	BMSTPVibrantDataArray*		array = &this->m_songData.eventDataArray;
	if( array->empty() ){
		return false;
	}
	this->m_vibrantArray.resize( this->m_songData.information.lastBarID + 1 + 4 );

	BMSTPVibrantDataArrayIt	it;
	for( it = array->begin(); it != array->end(); it++ ) {
		//	P߃Cxg
		//	̒iKł͉lɂ߂ł܂
		this->analyzeEvent( &(*it) );
	}
	if( this->m_eventList.empty() ){
		//	G[
		ABReportError( "analyze." );
		return	false;
	}

	//	œK
	//	ߏ̐
	BMSSongVibrantDataArrayIt	vit;
	BMSSongEventDataListIt		eit;
	BMSSongVibrantData*			vibrantData = NULL;
	BMSSongEventData*			eventData = NULL;
	ABuint						vibrantLocation	= 0;
	for( vit = this->m_vibrantArray.begin(); vit != this->m_vibrantArray.end(); vit++ ) {
		ABfloat32					vibrantRate = 1.0f;
		vibrantData	= &( *vit );

		for( eit = vibrantData->eventList.begin(); eit != vibrantData->eventList.end(); eit++ ) {
			eventData	= &(*eit);

			//	BMS_BMSEQ_EVENT_SET_BAR_RATECxgKp
			//	鎞͍Ō̗̕p
			switch( eventData->eventType ){
				case BMS_BMSEQ_EVENT_SET_BAR_RATE:
					//	ŏ߂Lk
					//	w菬߂̂ݗL
					vibrantRate = eventData->eventValue;
					break;
			};
			eventData->location	= vibrantData->location;
		}

		//	߂̃P[Vm
		if( vibrantRate != 1.0f ){
			vibrantData->length = (ABint)( (ABfloat32)vibrantData->length * vibrantRate);
		}
		vibrantData->vibrantRate = vibrantRate;
		vibrantData->location = vibrantLocation;
		vibrantData->eventDataPointer = this->m_eventList.end();

		//	̃P[V́Ȁ݂߂̒Z
		vibrantLocation		+= vibrantData->length;
	}

	//	߂LkOɎs܂
	{
		//	CxgP[VlŃ\[g
		this->m_eventList.sort( BMSSongEventData::compare_less );
		//	Cxg̏dr
		this->m_eventList.unique(BMSSongEventData::compare_equal);

		//	egbN̉BIuWFNgƂĈԍŏɒǉĂB
		//	́AtJnɉ炷߂̎d݂łB
		//	Ă΁Atł͓ʂȏȂɁAǂ݂đ鎖ȒPɂȂ܂B
		{
			BMSSongEventData*		trackEvent[BMS_BMSEQ_EVENT_PLAYER_COUNT][ BMS_SEQ_TRACK_COUNT ];
			ABint					trackSearchCount = (ABint)BMS_SEQ_TRACK_KEY1;
			ABint					p, t;
			memset( &trackEvent, NULL, sizeof(trackEvent) );
			for( eit = this->m_eventList.begin(); eit != this->m_eventList.end(); eit++ ) {
				if( eit->eventType == BMS_BMSEQ_EVENT_OBJECT || eit->eventType == BMS_BMSEQ_EVENT_HIDE_OBJECT ){
					if( BMS_SEQ_TRACK_KEY1 <= eit->trackNumber ){
						if( trackEvent[eit->playerNumber][eit->trackNumber] == NULL ){
							trackEvent[eit->playerNumber][eit->trackNumber] = &(*eit);
							trackSearchCount++;
						}
						if( BMS_SEQ_TRACK_COUNT <= trackSearchCount ){
							break;
						}
					}
				}
			}
			for( p = 0 ; p < BMS_BMSEQ_EVENT_PLAYER_COUNT ; p++ ){
				for( t = 0 ; t < BMS_SEQ_TRACK_COUNT ; t++ ){
					if( trackEvent[p][t] ){
						this->m_eventList.push_front( *trackEvent[p][t] );
						eit = this->m_eventList.begin();
						eit->eventType = BMS_BMSEQ_EVENT_HIDE_OBJECT;
						eit->vibrant = 0;
						eit->location = 0;
					}
				}
			}
		}
	}

	//	Cxg̐
	ABint		vibrant	= -1;
	ABuint		number = 0;
	ABint		locationReach[BMS_BMSEQ_EVENT_PLAYER_COUNT][BMS_SEQ_TRACK_COUNT];
	memset( locationReach, 0, sizeof(locationReach) );
	
	for( eit = this->m_eventList.begin(); eit != this->m_eventList.end(); eit++ ) {
		eventData	= &(*eit);

		if( vibrant != eventData->vibrant ){
			//	߂̏
			vibrantData = &( this->m_vibrantArray[eventData->vibrant] );
			//	Cxgւ̎Q
			vibrantData->eventDataPointer = eit;
		}
		//	ߔԍXV
		vibrant = eventData->vibrant;

		//	Cxg̃P[V
		//	̎_ł́AP߂BMS_SEQ_EVENT_RESOLUTIONƂ́Aߓ̈ʒuĂB
		//	m肵Ă鏬߂̒ƁA߂̈ʒuƂŁAvZB
		eventData->location			= vibrantData->location + (ABint)( eventData->location * (ABfloat32)vibrantData->vibrantRate );
		eventData->eventNumber		= number;
		eventData->locationReach	= eventData->location - locationReach[ eventData->playerNumber ][ eventData->trackNumber ];
		locationReach[eventData->playerNumber][eventData->trackNumber] = eventData->location;
		
		//	m[gv
		if( eventData->eventType == BMS_BMSEQ_EVENT_OBJECT ){
			++this->m_noteEventCount[ eventData->playerNumber ];
		}
		
		//	CxgʂɃXg쐬
		if( eventData->eventType == BMS_BMSEQ_EVENT_OBJECT || eventData->eventType == BMS_BMSEQ_EVENT_HIDE_OBJECT ){
			this->m_eventTypeDataList.push_back( eventData );
		}
		
		++number;
	}
	

	//	fobOo
	ABDebug( this->show(); );

	return true;
}

//------------------------------------------------------------------------------
//	1߉
//------------------------------------------------------------------------------
void	BMSSong::analyzeEvent( BMSTPVibrantData*  inVibrantEvent )
{
	ABbool		doubleMirror = false;
	ABint		i			 = 0;
	
	ABint						vibrant		= inVibrantEvent->barID;
	ABint						location	= 0;
	BMSSeqEventPlayerNumber		playerNumber= inVibrantEvent->player;
	BMSSeqEventTrackType		trackNumber	= BMSSeqGetTrackNumber( inVibrantEvent->trackNumber );
	BMSSeqEventType				eventType	= BMSSeqGetEventType( inVibrantEvent->eventType );
	ABfloat32					eventValue	= inVibrantEvent->value;

	switch( eventType ){
	
		case BMS_BMSEQ_EVENT_SET_BAR_RATE:

			//	CxgƂĕێ
			{
				BMSSongVibrantData*		vibrantData = &( this->m_vibrantArray[ vibrant ] );
				vibrantData->eventList.push_back( BMSSongEventData(vibrant, 0, BMS_BMSEQ_EVENT_PLAYER1, trackNumber, eventType, eventValue)  );
			}
		
			//	XɒʏCxgƂđs
			
		default:
		
			//	ʏCxg
			{
				ABint		divaideCount = inVibrantEvent->getObjectCount();
				ABint		objectLength = BMS_SEQ_EVENT_RESOLUTION / divaideCount;	//	؂Ȃf[^͖̗Lf[^B
		
				//	BM98dlł́A0𖳎悤ɂȂĂB
				ABbool	skipZero = true;
	/*
				switch( eventType ){
					case BMS_BMSEQ_EVENT_BACK_CHORUS:
					case BMS_BMSEQ_EVENT_OBJECT:
					case BMS_BMSEQ_EVENT_HIDE_OBJECT:
						skipZero = true;
						break;
				}
	*/		
				//	battle~[́A2Pf[^𖳎
				if( ! ( doubleMirror && playerNumber == BMS_BMSEQ_EVENT_PLAYER2 ) ){

					if( 0 == divaideCount ){
						//	IuWFNgzȂ
						this->m_eventList.push_back( BMSSongEventData( vibrant, objectLength * i, playerNumber, trackNumber, eventType, eventValue ) );
					}
					else{
						//	IuWFNgz
						for( i = 0 ; i < divaideCount ; i++ ){
							ABbool	skip = false;
							ABint	object = inVibrantEvent->objectArray[ i ];	//	IuWFNgz񂩂P擾
							if( object == 0 && skipZero ){
								skip = true;
							}
							if( !skip ){
								this->m_eventList.push_back( BMSSongEventData( vibrant, objectLength * i, playerNumber, trackNumber, eventType, (ABfloat32)object ) );

								//	battle~[̖ߍ
								if( eventType == BMS_BMSEQ_EVENT_OBJECT || eventType == BMS_BMSEQ_EVENT_HIDE_OBJECT ){
									if( doubleMirror && playerNumber == BMS_BMSEQ_EVENT_PLAYER1 ){
										this->m_eventList.push_back( BMSSongEventData( vibrant, objectLength * i, BMS_BMSEQ_EVENT_PLAYER2, trackNumber, eventType, (ABfloat32)object ) );
									}
								}

							}
						}

					}

				}
			}
			break;
	}
}

//------------------------------------------------------------------------------
//	f[^ɂ
//------------------------------------------------------------------------------
void	BMSSong::clear( void )
{
	this->m_vibrantArray.clear();
	this->m_eventList.clear();
	this->m_eventTypeDataList.clear();
}

////////////////////////////////////////////////////////////////////////////////
//	f[^̎擾
////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
//	BMSTPSongDat̎擾
//------------------------------------------------------------------------------
BMSTPSongData*		BMSSong::getSongData( void )
{
	return &this->m_songData;
}


//------------------------------------------------------------------------------
//	w菬߂Ɉړ
//------------------------------------------------------------------------------
ABbool	BMSSong::moveVibrant( ABuint  inVibrant, BMSEventDataPointer*  outEventPointer )
{
	if( this->m_vibrantArray.size() <= inVibrant ){
		return false;
	}
	
	outEventPointer->eventPointer = this->m_vibrantArray[inVibrant].eventDataPointer;
	return true;
}

//------------------------------------------------------------------------------
//	ߏ擾
//------------------------------------------------------------------------------
BMSSongVibrantData*		BMSSong::getVibrant( ABint  inVibrant )
{
	if( inVibrant < 0 || (ABint)this->m_vibrantArray.size() <= inVibrant ){
		return NULL;
	}
	return	&( this->m_vibrantArray[inVibrant] );
}

//------------------------------------------------------------------------------
//	̃CxgʒuɈړ
//------------------------------------------------------------------------------
ABbool	BMSSong::moveNextLocation( BMSEventDataPointer*  ioEventPointer )
{
	if( ioEventPointer->eventPointer == this->m_eventList.end() ){
		//	݂̏߂Ƀf[^͖
		return false;
	}
	
	ABint						location = ioEventPointer->eventPointer->location;
	BMSSongEventDataListIt		eit = ioEventPointer->eventPointer;
	for( ; eit != this->m_eventList.end(); eit++ ) {
		if( location != eit->location ){
			//	̃Cxgʒuł
			ioEventPointer->eventPointer = eit;
			break;
		}
	}

	ioEventPointer->currentLocation = location;
	if( ioEventPointer->eventPointer == this->m_eventList.end() ){
		return false;
	}
	return true;
}

//------------------------------------------------------------------------------
//	݂̈ʒũCxgf[^擾Jn
//------------------------------------------------------------------------------
void	BMSSong::beginGetNextEventData( BMSEventDataPointer*  ioEventPointer )
{
	//	݂̃Cxgʒu̐擪ɍ킹
	//	Cxgz͓ꃍP[ṼCxgłB
	//		...
	//		Event	1	loc( 192 )	<--Cxgʒu̐擪
	//		Event	2	loc( 192 )
	//		Event	3	loc( 192 )
	//		Event	1	loc( 396 )	<--Cxgʒu̐擪
	//		Event	2	loc( 396 )
	//		Event	4	loc( 482 )	<--Cxgʒu̐擪
	//		...
	if( ioEventPointer->eventPointer == this->m_eventList.end() ){
		//	݂̏߂Ƀf[^͖
		return;
	}

	ABint						location	= ioEventPointer->eventPointer->location;
	BMSSongEventDataListIt		eit			= ioEventPointer->eventPointer;
	while( eit != this->m_eventList.begin() ){
		ABint	eitLocation = eit->location;
		if( location != eitLocation ){
			//	ÕCxgʒu݂̂ŁA݈ʒu̓o
			break;
		}
		ioEventPointer->eventPointer	= eit;
		eit--;
	}
	ioEventPointer->currentLocation = location;
//	printf( "*begin1> ioEventPointer->eventPointer->location[%d], location[%d]\n", ioEventPointer->eventPointer->location, location );
}

//------------------------------------------------------------------------------
//	݂̈ʒũCxgf[^擾
//------------------------------------------------------------------------------
BMSSongEventData*		BMSSong::getEventData( BMSEventDataPointer*  ioEventPointer )
{
	if( ioEventPointer->eventPointer == this->m_eventList.end() ){
		return NULL;
	}
	BMSSongEventData*	eventData = &( *ioEventPointer->eventPointer );
	return	eventData;
}

//------------------------------------------------------------------------------
//	݂̈ʒũCxgf[^擾
//------------------------------------------------------------------------------
ABbool		BMSSong::getNextEventData( BMSEventDataPointer*  ioEventPointer, BMSSongEventDataPtr*  outEventData )
{
	if( ioEventPointer->eventPointer == this->m_eventList.end() ){
		return false;
	}

	*outEventData = &( *ioEventPointer->eventPointer );

	if( (*outEventData)->location != ioEventPointer->currentLocation ){
		//	̃P[VʒuɈړ
		return	false;
	}

	//	QƂi߂
//	printf( "*next move \n" );
	ioEventPointer->eventPointer++;

	return	true;
}

//------------------------------------------------------------------------------
//	wCxg^Cv̎Cxg擾Jn
//------------------------------------------------------------------------------
void	BMSSong::getTypeListDataPoimter( BMSSongEventDataPtrListIt*  outIt )
{
	*outIt = this->m_eventTypeDataList.begin();
}

//------------------------------------------------------------------------------
//	wCxg^Cv̎Cxg擾
//------------------------------------------------------------------------------
ABbool	BMSSong::getEventTypeListData( BMSSongEventDataPtrListIt&  inIt, BMSSongEventDataPtr*  outEventData )
{
	if( inIt == this->m_eventTypeDataList.end() ){
		return false;
	}
	*outEventData = *inIt;
	return true;
}

////////////////////////////////////////////////////////////////////////////////
//	f[^̏
////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
//	ߑ擾
//------------------------------------------------------------------------------
ABuint	BMSSong::getVibrantCount( void )
{
	return this->m_vibrantArray.size();
}

//------------------------------------------------------------------------------
//	fobOpR\[AEg
//------------------------------------------------------------------------------
void	BMSSong::show( void )
{
	ABReport( "Begin output." );

	BMSSongVibrantDataArrayIt	vit;
	BMSSongEventDataListIt		eit;
	BMSSongEventData*			ed;
	BMSSongVibrantData*			vd;
	ABint						v,c;

	printf( "[VibrantData]\n" );
	v = 0;
	for( vit = this->m_vibrantArray.begin(); vit != this->m_vibrantArray.end(); vit++ ){
		vd = &(*vit);

		printf( "    +vibrant[ %4d], location[ %8d ], vibrantRate[ %8.8f], length[ %8d ], eventDataPointer[ eventNumber %8d ]\n",
				v, vd->location, vd->vibrantRate, vd->length, ( (vd->eventDataPointer != this->m_eventList.end()) ? vd->eventDataPointer->eventNumber : 0 )  );
	
		c = 0;
		for( eit = vd->eventList.begin(); eit != vd->eventList.end(); eit++ ){
			ed = &(*eit);
			printf( "            +[vibrant event data] [%8d] vibrant[ %8d ], location[ %8d], playerNumber[ %-24s ], trackNumber[ %-24s ], eventType[ %-36s ], eventValue[ %8.8F ], locationReach[ %8d ]\n",
					c, ed->vibrant, ed->location, BMSSeqGetPlayerNumberName(ed->playerNumber), BMSSeqGetTrackTypeName(ed->trackNumber), BMSSeqGetEventTypeName(ed->eventType), ed->eventValue, ed->locationReach );
			++c;
		}
		++v;
	}

	printf( "[EventData]\n" );
	for( eit = this->m_eventList.begin(); eit != this->m_eventList.end(); eit++ ){
		ed = &(*eit);
		printf( "    +eventNumber[%8d] vibrant[ %8d ], location[ %8d], playerNumber[ %-24s ], trackNumber[ %-24s ], eventType[ %-36s ], eventValue[ %8.8F ], locationReach[ %8d ]\n",
				ed->eventNumber, ed->vibrant, ed->location, BMSSeqGetPlayerNumberName(ed->playerNumber), BMSSeqGetTrackTypeName(ed->trackNumber), BMSSeqGetEventTypeName(ed->eventType), ed->eventValue, ed->locationReach );
	}
	ABReport( "End output." );
}

