/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSSong.h

	Encoding:	Shift-JIS

				BMSf[^̓\B
				o[Wł́Aꕶ񂩂EoĂA
				{o[Wł́AĐ₷悤At@C\ϊێB

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSSong_h
#define	BMSSong_h

#include	<vector>
#include	<list>

#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"BMSConfig.h"
#include	"BMSParserConfig.h"

////////////////////////////////////////////////////////////////////////////////
//	Event list
////////////////////////////////////////////////////////////////////////////////
typedef	struct BMSSongEventData{
	
	ABint						vibrant;		//	ߔԍ
	ABint						location;		//	Đʒu
	BMSSeqEventPlayerNumber		playerNumber;	//	Player 1 or 2 
	BMSSeqEventTrackType		trackNumber;	//	track number
	BMSSeqEventType				eventType;		//	event
	ABfloat32					eventValue;		//	event̒l
	ABuint						eventNumber;	//	fobOp
	ABint						locationReach;	//	ÕCxgƂlocationBAssignɗpB

	BMSSongEventData(
		ABint						inVibrant,		//	ߔԍ
		ABint						inLocation,		//	Đʒu
		BMSSeqEventPlayerNumber		inPlayerNumber,	//	Player 1 or 2 
		BMSSeqEventTrackType		inTrackNumber,	//	track number
		BMSSeqEventType				inEventType,		//	event
		ABfloat32					inEventValue		//	event̒l
	){
		vibrant 		= inVibrant;
		location 		= inLocation;
		playerNumber	= inPlayerNumber;
		trackNumber		= inTrackNumber;
		eventType		= inEventType;
		eventValue		= inEventValue;
		eventNumber		= 0;
		locationReach	= 0;
	}

	//	P[Vʒu̔r
	static bool	compare_less( BMSSongEventData&  l, BMSSongEventData&  r ){
		return	(l.vibrant * BMS_SEQ_EVENT_RESOLUTION + l.location) < (r.vibrant * BMS_SEQ_EVENT_RESOLUTION + r.location);
	}
	//	P[VʒuACxg̔r
	static bool	compare_equal( BMSSongEventData&  l, BMSSongEventData&  r ){
		if(  l.eventType == BMS_BMSEQ_EVENT_OBJECT || l.eventType == BMS_BMSEQ_EVENT_HIDE_OBJECT  ){
			return	( l.eventType == r.eventType ) && 
					( (l.vibrant * BMS_SEQ_EVENT_RESOLUTION + l.location) == (r.vibrant * BMS_SEQ_EVENT_RESOLUTION + r.location) ) && 
					( l.playerNumber == r.playerNumber ) &&
					( l.trackNumber == r.trackNumber ) ;
		}
		return	false;
	}

} BMSSongEventData, *BMSSongEventDataPtr;

typedef	std::list< BMSSongEventData >		BMSSongEventDataList;
typedef	BMSSongEventDataList::iterator		BMSSongEventDataListIt;

typedef	std::list< BMSSongEventData* >		BMSSongEventDataPtrList;
typedef	BMSSongEventDataPtrList::iterator	BMSSongEventDataPtrListIt;

////////////////////////////////////////////////////////////////////////////////
//	Vibrant array
//	P߂̏ێ܂B
////////////////////////////////////////////////////////////////////////////////
typedef	struct BMSSongVibrantData{

	ABint						location;				//	Đʒu
	ABint						length;					//	P߂̒B192Z蒷肵܂B
	ABfloat64					vibrantRate;			//	߂̐Lk
	BMSSongEventDataList		eventList;				//	߃CxgXg
	BMSSongEventDataListIt		eventDataPointer;		//	߂̎n߈ʒũCxgւ̎Q

	BMSSongVibrantData(){
		location	= 0;
		vibrantRate	= 1.0f;
		length		= BMS_SEQ_EVENT_RESOLUTION;
	};

} BMSSongVibrantData;

typedef	std::vector< BMSSongVibrantData >		BMSSongVibrantDataArray;
typedef	BMSSongVibrantDataArray::iterator		BMSSongVibrantDataArrayIt;

////////////////////////////////////////////////////////////////////////////////
//	struct	CxgQƏ
////////////////////////////////////////////////////////////////////////////////
typedef	struct	BMSEventDataPointer{

	BMSSongEventDataListIt		eventPointer;	//	݂̃Cxgւ̎Q
	ABint						currentLocation;//	݂̃P[Vʒu
	BMSEventDataPointer(){
		currentLocation = 0;
	}

} BMSEventDataPointer;

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSSong
{
private:
	BMSTPSongData&				m_songData;
	BMSSongVibrantDataArray		m_vibrantArray;	//	̔z͂Pߖڂ猄Ԗl܂Ă܂
	BMSSongEventDataList		m_eventList;
	ABint						m_noteEventCount[BMS_BMSEQ_EVENT_PLAYER_COUNT];//	m[gCxg̑

	BMSSongEventDataPtrList		m_eventTypeDataList;	//	Cxg^Cvŕč쐬郊XgBǂׂ݂̈Ɏgp܂B

	ABbool	m_ready;

public:
	BMSSong( BMSTPSongData&  inSongTPData );
	virtual	~BMSSong();

	/////////////////////////////////////	
	//	f[^̉
	/////////////////////////////////////	

	//	͎s
	//	Eԃf[^WJ܂B
	//	@̒iKŁA_uvCp̃f[^\ɕϊ肵܂B
	ABbool	analyze( void );

	//	f[^ɂ
	//	Em_songData͋ɂ܂B
	void	clear( void );

	/////////////////////////////////////	
	//	f[^̎擾
	/////////////////////////////////////	
	
	//	BMSTPSongDat̎擾
	BMSTPSongData*		getSongData( void );

	//	w菬߂Ɉړ
	ABbool	moveVibrant( ABuint  inVibrant, BMSEventDataPointer*  outEventPointer );

	//	ߏ擾
	BMSSongVibrantData*		getVibrant( ABint  inVibrant );
	
	//	̃CxgʒuɈړ
	//	E݃CxgʒũP[VƔrāuvɊYCxgAVʒuƂB
	//	EIɓBfalseԂ
	ABbool	moveNextLocation( BMSEventDataPointer*  ioEventPointer );

	//	݂̈ʒũCxgf[^擾
	BMSSongEventData*	getEventData( BMSEventDataPointer*  ioEventPointer );

	//	݂̈ʒũCxgf[^擾Jn
	void	beginGetNextEventData( BMSEventDataPointer*  ioEventPointer );

	//	݂̈ʒũCxgf[^擾AɈړ
	//	EbeginGetNextEventData()ŊJn邱ƁB
	//	EtreuԂĂAw胍P[ṼCxg擾𑱂Ȃ΂ȂȂB
	//	@falseԂĂÃP[VɈړ̂ŁA擾𒆒f邱ƁB
	ABbool	getNextEventData( BMSEventDataPointer*  ioEventPointer, BMSSongEventDataPtr*  outEventData );

	//	wCxg^Cv̎Cxg擾Jn
	//	E擪ɏĕԂ܂
	void	getTypeListDataPoimter( BMSSongEventDataPtrListIt*  outIt );

	//	wCxg^Cv̎Cxg擾
	//	EŌ܂œBfalseԂ܂
	ABbool	getEventTypeListData( BMSSongEventDataPtrListIt&  inIt, BMSSongEventDataPtr*  outEventData );

	/////////////////////////////////////	
	//	f[^̏
	/////////////////////////////////////	

	//	ߑ擾
	ABuint	getVibrantCount( void );
	
	//	m[g擾
	ABint	getNoteCount( BMSSeqEventPlayerNumber  inPlayerNumber ){
		return	this->m_noteEventCount[inPlayerNumber];
	}
	
	//	fobOpR\[o
	void	show( void );

private:
	/////////////////////////////////////	
	//	
	/////////////////////////////////////	
	//	1߉
	void	analyzeEvent( BMSTPVibrantData*  inVibrantEvent );

};

#endif	//	BMSSong_h
