/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSTimer.h

				BMSV[PT[Ŏg^C}[Controller

				EOSɂA^C}[@͈قȂB
				@̃NXpA eOSƂōœKȏ@`B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSTimer_h
#define	BMSTimer_h

#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"BMSConfig.h"
#include	"BMSPlayer.h"

////////////////////////////////////////////////////////////////////////////////
//	class
////////////////////////////////////////////////////////////////////////////////
class	BMSTimer
{
protected:
	BMSPlayer*		m_musicPlayer;
	ABint			m_location;
	ABbool			m_pauseIsTrue;

public:
	BMSTimer(){
	}
	virtual	~BMSTimer(){
	}

	////////////////////////////////
	//	pׂMethod
	////////////////////////////////

	//	setup
	virtual	ABbool	setup( void ){
		return true;
	}

	//	cleanup
	virtual	void	cleanup( void ){
	}

	//	start timer
	//	E^C}[ZbgB
	virtual	void	startTimer( ABfloat32  inBPM ){};
	
	//	E^C}[Đݒ肷B
	virtual	void	resetTimer( ABfloat32  inBPM ){};
	
	//	stop timer
	//	E^C}[~B
	virtual	void	stopTimer( void ){};

	//	timer event firei΂fĂ݂j
	//	E^C}[OɂȂ炱methodR[邱ƁB
	//	E̊֐R[-^C}[ZbgԂ̍nB
	virtual	void	fire( double  inLocation ){
		//	Cxgs
		this->doFire( inLocation );
	};

	//	INSIDE
public:
	void	initialize( BMSPlayer*  inMusicPkayer ){
		this->m_musicPlayer		= inMusicPkayer;
		this->m_location		= 0;
		this->m_pauseIsTrue 	= false;
		this->setup();
	};
	void	start( void ){
		this->startTimer( this->m_musicPlayer->getBPM() );
		this->m_pauseIsTrue = false;
	}
	void	setLocation( ABint  inLocation ){
		this->m_location = inLocation;
	}
	float	getLocation( void ){
		return	this->m_location;
	}
	void	pause( void ){
		this->m_pauseIsTrue = true;
	};
	void	cont( void ){
		this->m_pauseIsTrue = false;
	};
	void	stop( void ){
		this->stopTimer();
		this->m_pauseIsTrue = true;
	};

private:
	void	doFire( ABfloat32  inLocation ){

		if( ! this->m_pauseIsTrue ){
			ABint  prevbpm = this->m_musicPlayer->getBPM();
			ABint  nextbpm = 0;
			
			this->m_location = (ABint)inLocation;
			this->m_musicPlayer->loop( this->m_location );

			//	BPMύXĂA^C}[Đݒ
			nextbpm = this->m_musicPlayer->getBPM();
			if( prevbpm != nextbpm ){
				this->stopTimer();
				this->resetTimer( nextbpm );
			}
		}
		
	};

	ABfloat32	getRezolutionMiliSecond( void ){
		ABfloat32	rate = ( 60.0f * 1000.0f) / (double)( this->m_musicPlayer->getBPM() * 2 * BMS_SEQ_EVENT_RESOLUTION4) ;	//	S̕b
		return	rate;
	}

};

#endif	//	BMSTimer_h
