/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSLibrary.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	<iostream>

#include	"BMSLibrary.h"

#include	"BMSTimer.h"
#include	"BMSEvent.h"
#include	"BMSPlayer.h"

using namespace	std;

//-------------------------------------------------------
//	Constructor
//-------------------------------------------------------
BMSLibrary::BMSLibrary()
{
}

//-------------------------------------------------------
//	Destructor
//-------------------------------------------------------
BMSLibrary::~BMSLibrary()
{
}

//-------------------------------------------------------
/*
*	open DJ collection
*/
//-------------------------------------------------------
bool BMSLibrary::open( ABint8*  inDirectory )
{
	bool result = false;
	ABint	i, j;
	GameFileInfo* 			fileInfo;
	ABint8					filePath[ 1024 ];
	BMSLibraryData::McollectionFolderIt		it;

	ABDebug( ABReport( "BMSLibrary::open()" ); );

	do{
		//	DataBaseL邩H
		
		//	΍쐬
		//	L΍XV
	
		//	f[^x[XJ
		
		//	ݒ
		this->m_collectionFolder.clear();
		this->m_collectionData.clear();
		this->m_collectionData.reserve( 10240 );
		
		//	t@CW
		result = this->m_folderList.collectFilInfo( inDirectory, true );

		//	BMSf[^\\z
		this->m_collectionFolder.resize( this->m_folderList.getCount() );

		it = this->m_collectionFolder.begin();
		
		for( i = 0 ; i < this->m_folderList.getCount() ; i++ ){
		
			if( it == this->m_collectionFolder.end() ){
				break;
			}

			//	BMStH_̃pX
			fileInfo = this->m_folderList.getInfo( i );
			fileInfo->copyPath( (ABuint8*)filePath, sizeof(filePath) - 1 );
			fileInfo->copyName( it->mFoladerName, sizeof(it->mFoladerName) - 1 );
			
			//	tH_BMSf[^擾
			result = it->mBMSdata.openFolder( filePath );//	JςȂOK
			if( result ) {
				ABint	bmsCount = it->mBMSdata.countSong();
				ABint	dataNumber = 0 ;
			
				//	\z
				ABDebug( cout << " -look up bms > data count:" << bmsCount << ", path: " << filePath <<  endl; ); 
				for( j = 0 ; j < bmsCount ; j++ ){
					this->m_collectionData.push_back( BMSLibraryData( it, j ) );
				}
			}
			else{
				ABReportError( "openFolder." );
			}
			
			++it;
		};
		
		if( this->m_collectionData.empty() ){
			ABReportError( "not found bms data." );
			break;
		}
		
		result = true;
	}while( false );
	
	return result;
}

//-------------------------------------------------------
/*
*	close DJ collection
*/
//-------------------------------------------------------
void BMSLibrary::close(void)
{
	ABDebug( ABReport( "BMSLibrary::close()" ); );

	//	ȂB

	this->m_collectionFolder.clear();
	this->m_collectionData.clear();
}

//-------------------------------------------------------
//	wԍ̃f[^擾
//-------------------------------------------------------
BMSLibraryData*	BMSLibrary::getData( ABint  inIndex ){
	ABint	index = ( 0 <= inIndex ? inIndex : this->m_index );


	if( this->m_collectionData.size() <= index ){
		return NULL;
	}
	return &( this->m_collectionData[ index ] );
}

