/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSLibrary.h


	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	BMSLibrary_h
#define	BMSLibrary_h

#include	<list>
#include	<vector>

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"GameFileList.h"

#include	"BMSParserConfig.h"
#include	"BMSFolder.h"

//--------------------------------------------------
//	BMStH_\
//--------------------------------------------------
class BMSLibraryBMSFolder
{
public:
	BMSLibraryBMSFolder():
		mFolderNumber(0),
		mDataCount(0)
	{
	}
	~BMSLibraryBMSFolder(){
	}
	
	ABint			mFolderNumber;			//	FileListQƗp̔ԍ
	ABint			mDataCount;				//	tH_[BMSf[^
	BMSFolder		mBMSdata;				//	BMSf[^̃pbP[W

	ABint8			mFoladerName[ 256 ];	//	tH_[
};

//--------------------------------------------------
//	f[^\
//--------------------------------------------------
class BMSLibraryData
{
public:
	typedef	std::list<BMSLibraryBMSFolder>	McollectionFolder;
	typedef	McollectionFolder::iterator		McollectionFolderIt;

public:
	BMSLibraryData( McollectionFolderIt  inItarator, ABint  inDataNumber ) :
		mFolderRef( inItarator ),
		mDataNumber( inDataNumber )
	{
		mTrueIsChashed = false;
		mBroken = false;
	}
	~BMSLibraryData(){
	}
	
	McollectionFolder::iterator		mFolderRef;		//	BMSLibraryBMSFolderւ̎Q
	ABint							mDataNumber;	//	tH_̃f[^̔ԍ
	BMSTPSongInformation			mHeaderInfo;	//	wb_
	bool							mTrueIsChashed;	//	LbVς݂H
	bool							mBroken;		//	Ă
};

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class BMSLibrary
{
public:
	typedef	std::list<BMSLibraryBMSFolder>		McollectionFolder;
	typedef	std::vector<BMSLibraryData>			McollectionData;

public:
	BMSLibrary();
	~BMSLibrary();
	
	//	wfBNgJ
	//	EDirectoryɗLBMStH_[SďEグ܂
	bool 	open( ABint8*  inDirectory );
	
	//	
	void 	close(void);
	
	//	tH_擾
	ABint	getFolderCount( void ){
		return	this->m_collectionFolder.size();
	}
	//	f[^擾
	ABint	getDataCount( void ){
		return	this->m_collectionData.size();
	}
	
	//	f[^ԍw
	void	setIndex( ABuint  inIndex ){
		this->m_index = inIndex;
	}

	//	f[^ԍ擾
	ABuint	getIndex( void ){
		return	this->m_index;
	}
	
	//	wԍ̃f[^擾
	BMSLibraryData*		getData( ABint  inIndex = -1 );

private:
	GameFileList		m_folderList;			//	file info list
	ABuint				m_index;

	McollectionFolder	m_collectionFolder;
	McollectionData		m_collectionData;
};

#endif	//	BMSLibrary_h
