/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		BMSRunner.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"BMSRunner.h"

#include	"BMSTimer.h"
#include	"BMSEvent.h"
#include	"BMSPlayer.h"

//-------------------------------------------------------
//	Constructor
//-------------------------------------------------------
BMSRunner::BMSRunner()
{
	this->m_timer = NULL;
	this->m_event = NULL;
}

//-------------------------------------------------------
//	Destructor
//-------------------------------------------------------
BMSRunner::~BMSRunner()
{
	this->finalize();
}

//-------------------------------------------------------
//	Initialize
//-------------------------------------------------------
ABbool	BMSRunner::initialize( BMSPlayerConfig*  inConfig, BMSTimer*  inTimer, BMSEvent*  inEvent )
{
	try{
		this->m_musicPlayer	= new BMSPlayer( inEvent );
	}
	catch(std::bad_alloc){
		return	false;
	}
	
	this->m_config = *inConfig;	//	Rs[Ȃ΂ȂȂ
	this->m_timer = inTimer;
	this->m_event = inEvent;
	
	this->m_timer->initialize( this->m_musicPlayer );
	
	return	true;
}

//-------------------------------------------------------
//	finalize
//-------------------------------------------------------
void	BMSRunner::finalize( void )
{
	if( this->m_musicPlayer ){

		this->stopSong();
		this->m_timer->cleanup();

		this->m_musicPlayer->finalize();
		delete	this->m_musicPlayer;
		this->m_musicPlayer = NULL;
	}
}

//-------------------------------------------------------
//	tJn
//-------------------------------------------------------
ABbool		BMSRunner::playSong( BMSSong*  inSong, BMSResource*  inRes )
{
	if( this->m_musicPlayer == NULL ){
		return false;
	}
	if( inSong == NULL ){
		return false;
	}
	if( inRes == NULL ){
		return false;
	}
	this->m_musicPlayer->Initialize( &this->m_config, this->m_timer, inSong, inRes );
	this->m_timer->start();
	return	true;
}

//-------------------------------------------------------
//	t~
//-------------------------------------------------------
ABbool		BMSRunner::stopSong( void )
{
	if( this->m_musicPlayer == NULL ){
		return false;
	}
	this->m_timer->stop();
	return	true;
}

//-------------------------------------------------------
//	tIH
//-------------------------------------------------------
ABbool		BMSRunner::isEnd( void )
{
	if( this->m_musicPlayer == NULL ){
		return false;
	}
	return	this->m_musicPlayer->isEnd();
}


