/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABBMseqDataArchitecture.h

				BMS music data Architecture

				EBMSt@C\pASequencerpEvent`Ǘ

				BMSt@CtH[}bgƁASequencer\Ƃ̊ԂŁAݕϊNXB
				𗘗pƁAt@Cǂݍݎɔʂ₷`iI[gio[jɕϊĕێłB
				ǂݍݎAĐƁABMSEventHE`EoE肵Ăς킵B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABBMseqDataArchitecture_h
#define	ABBMseqDataArchitecture_h

#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"
#include	"ABBMSConfig.h"
#include	"ABBMSData.h"

#include	<vector>

/*//////////////////////////////////////////////////////////////////////////////
*	const
*///////////////////////////////////////////////////////////////////////////////
//-----------------------
//	Architect ID
//	EtH[}bgǂݍݎɁAEvent͑SIDɕϊB
//	EEventQƂƂ́AIDgċtB
//-----------------------
typedef		int		ABarchitectID;

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABBMseqDataArchitecture
{
private:

	typedef	struct MseqEvent{
		ABBMseqEventType		eventType;			//	Event̎
		ABBMseqSubEventType		subEventType;		//	Event̃TuށiABBMseqEventKeyTrackTypeB̒lɂp\Bj
		ABBMseqEventKind		eventKind;			//	Event̎ʁiKEYBOARDʂAȊOEventj
		ABBMseqObjectArrayType	objectArrayType;	//	IuWFNgz̗LA

		//	ׂ͒`ȂŔėpIɂĂ

	}	MseqEvent;

	typedef	struct MArchitect{
		MseqEvent					seqEvent;	//	SequencerEvent\
		ABbmsMusicDataEventType		eventCode;	//	Event̃R[hiBMSt@CEvent̒lj

	}	MArchitect;
	typedef	std::vector<MArchitect>	MArchitectArray;

public:
	ABBMseqDataArchitecture(){};
	~ABBMseqDataArchitecture(){};
	
	//-----------------------
	//	setup
	//-----------------------
	void 	setup( void ){
		architecture.reserve( AB_BMSEQ_KEYTRACK_COUNT );
	}

	//-----------------------
	//	Add
	//-----------------------
	void	add
	(
		ABBMseqEventType		inEventType,			//	Event̎
		ABBMseqSubEventType		inSubEventType,			//	Event̃TuށiABBMseqEventKeyTrackTypeB̒lɂp\Bj
		ABBMseqEventKind		inEventKind,			//	Event̎ʁiKEYBOARDʂAȊOEventj
		ABBMseqObjectArrayType	inObjectArrayType,		//	IuWFNgz̗LA

		ABbmsMusicDataEventType	inEventCode				//	Event̃R[hiBMSt@CEvent̒lj
	){
		MArchitecture	architecture;

		architect.eventType			= inEventType;
		architect.subEventType		= inSubEventType;
		architect.eventCode			= inEventCode;
		architect.objectArrayType	= inObjectArrayType;

		architect.eventCode			= inEventCode;
		
		this->m_architectArray.push_back( architecture );
	}
	
	//-----------------------
	//	Get ABarchitectID
	//-----------------------
	ABarchitectID	getArchitectID( ABbmsMusicDataEventType  inEventCode ){
		//	p[vi΁j
		int	i;
		for( i = 0 ; i < this->m_architectArray.size() ; i++ ){
			MArchitect*	architect = &( this->m_architectureArray[i] );
			if( architect->eventCode == inEventCode ){
				return	i;
			}
		}
		return	-1;
	}

	//-----------------------
	//	Get BMS EventCode
	//-----------------------
	ABbmsMusicDataEventType		getBMSEventCode( ABarchitectID	inID ){
		if( inID < 0 || this->m_architectArray.size() <= inID ){
			return	AB_BMS_MUSIC_DATA_EVENT_NOTHING;
		}
		MArchitect*	architect = &( this->m_architectureArray[ inID ] );
		return	architect->eventCode;
	}
	
	//-----------------------
	//	GetSeqData
	//-----------------------
	bool	getSeqData
	( 
		ABbmsMusicDataEventType  inEventCode,

		ABBMseqEventType*		outEventType,			//	Event̎
		ABBMseqSubEventType*	outSubEventType,		//	Event̃TuށiABBMseqEventKeyTrackTypeB̒lɂp\Bj
		ABBMseqEventKind*		outEventKind,			//	Event̎ʁiKEYBOARDʂAȊOEventj
		ABBMseqObjectArrayType*	outObjectArrayType		//	IuWFNgz̗LA
	){
		ABarchitectID	id = this->getArchitectID( inEventCode );
		if( id < 0 || this->m_architectArray.size() <= id ){
			return	false;
		}
		
		MseqEvent	seqEvent = &this->m_architectureArray[ id ]->seqEvent;
		
		*outEventType		= seqEvent->eventType;
		*outSubEventType	= seqEvent->subEventType;
		*outEventKind		= seqEvent->eventKind;
		*outObjectArrayType	= seqEvent->objectArrayType;

		return	true;
	}

private:
	MArchitectArray		m_architectArray;
};

#endif	//	ABBMseqDataArchitecture_h
