/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMusicData.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	<algorithm>
#include	<iostream>
#include	"GameEngine.h"
#include	"GameSingleton.h"
#include	"ABMusicData.h"

using namespace	std;

//-------------------------------------------------------
/*
*	Constructor
*/
//-------------------------------------------------------
ABMusicData::ABMusicData()
{
	//-----------------------
	//	MacBeat0.9*݊
	//-----------------------
	this->m_extBmsArrray.push_back( string("bms") );	//	5L[
	this->m_extBmsArrray.push_back( string("bme") );	//	7L[
	this->m_extBmsArrray.push_back( string("mbm") );	//	7L[H

	this->m_extWavArrray.push_back( string("mp3") );	//	MP3
	this->m_extWavArrray.push_back( string("MP3") );	//	
}
//-------------------------------------------------------
/*
*	Destructor
*/
//-------------------------------------------------------
ABMusicData::~ABMusicData()
{
}

//-------------------------------------------------------
//	BMStH_
//		inFileInfoPtr	BMSf[^̊i[ĂtH_
//-------------------------------------------------------
bool	ABMusicData::analyzeBMSmusic( ABint8*  inDirectory )
{
	bool	result = false;
	
	this->m_bmsFileArray.clear();
	
	//	collect folder
	result = this->m_fileList.collectFilInfo( inDirectory, false );
	if( ! result ){
		return result;
	}
	
	//	t@CXg\z
	//	Et@C̎R̒ABMSf[^t@CƑfރt@CƂ𕪗Ă܂B

	//	BMSf[^Xg\z
	GameFileInfoList			*fileArray = this->m_fileList.getArray(); 
	GameFileInfoListIt			it;
	MExtArray::iterator			hit;
	
	ABint8				fileName[AB_BMS_CHAR_LENGTH_FILEPATH];
	ABint8*				fileNamePtr = NULL;
	ABint				len			= sizeof(fileName);
	ABint				extCharLen	= this->m_extBmsArrray[0].length();
	{
		for( it = fileArray->begin() ; it != fileArray->end() ; it++ ){

			it->copyPath( (ABuint8*)fileName, len );
			
			if( extCharLen <= strlen(fileName)  ){
				fileNamePtr = strrchr( fileName, '.' );
				if( fileNamePtr != NULL ){

					++fileNamePtr;
					
					//	
					hit = find( this->m_extBmsArrray.begin(), this->m_extBmsArrray.end(), string( fileNamePtr ) );
					if( hit != this->m_extBmsArrray.end() ){
						//	hitƂBMSf[^t@C֐U蕪
						this->m_bmsFileArray.push_back( *it );
					}
				}
			}//if
		}//	for
	}
	
	if( this->m_bmsFileArray.size() == 0 ){
		//	
		return false;
	}
	
	this->m_directory = inDirectory;
	return	true;
}

/////////////////////////////////////////////////////////
//	BMSf[^J
/////////////////////////////////////////////////////////
//-------------------------------------------------------
//	BMSf[^J
//-------------------------------------------------------
bool	ABMusicData::openBMSmusic( ABint  inMusicNumber )
{
	return	this->openBMSmusicFile( inMusicNumber, AB_LOAD_ALL_DATA );
}
//-------------------------------------------------------
//	BMSf[^J	wb_[̂
//-------------------------------------------------------
bool	ABMusicData::openBMSmusicHeaderOnly( ABint  inMusicNumber )
{
	return	this->openBMSmusicFile( inMusicNumber, AB_LOAD_HEADER_INFO_DATA );
}
//-------------------------------------------------------
//	BMSf[^J	{
//-------------------------------------------------------
bool	ABMusicData::openBMSmusicFile( ABint  inMusicNumber, ABLoadMode inMode )
{
	bool			result = false;
	GameFileInfo*	fileInfo = &( this->m_bmsFileArray[inMusicNumber] );
	ABParser		m_parser( AB_LOAD_ALL_DATA );
	
	ABint	bgaWidth = 256;
	ABint	bgaHeight = 256;
	
	do{
		//	BMSf[^
		this->closeBMSmusic();

		//	BMSeLXgt@Cǂݍ݂Ɖ
		result = m_parser.loadBMSFile( fileInfo, &this->m_bmsMusic );
		if( ! result ){
			break;
		}

		snprintf( this->m_bmsMusic.headerInfo.directoryName, AB_BMS_CHAR_LENGTH_FILENAME, "%s", this->m_directory );

		if( inMode == AB_LOAD_HEADER_INFO_DATA ){
			return	true;
		}

		//	fރt@CJ
		//	BMP
		{
			ABbmsMaterialBMPdataArray*				array = &(this->m_bmsMusic.materialBMPdataArray);
			ABbmsMaterialBMPdataArray::iterator		it;
			GameFileInfo	resFileInfo;
			ABint8*			fileName;
			
			for( it = array->begin(); it != array->end(); it++ ){
				ABbmsMaterialBMPdata*	bmp = &(*it);
				
				fileName	= bmp->filename;
				if( fileName[0] != 0 ){
					std::cout << " *Open file number = [" << bmp->number << "] ,filename:[" << fileName << "]" << std::endl;

					//	t@CQƁAۂɃt@CL邩H
					result = this->getResourceFileInfo( this->m_directory, fileName, &resFileInfo );
					if( ! result ){
						std::cout << " -not found BMP file." << fileName << std::endl;
					}
					else{
					
						//	J
						GGTexture*	textrue;
						try{
							this->m_bmpData.push_back( new GGTexture );
							textrue = this->m_bmpData[ this->m_bmpData.size() - 1 ];
						}
						catch( ... ){
							std::cout << " -bad alloc." << fileName << std::endl;
							break;
						}

						result = textrue->opneBitmap( &resFileInfo, true, GE_BMP_TRANSPARENT_BLACK, bgaWidth, bgaHeight );
						
						if( ! result ){
							//	fileĂۂ
							std::cout << " -file is broken." << fileName << std::endl;
							break;
						}
						result = textrue->bindTexture();
						
						//	OpenGLeNX`ԍSet
						bmp->bmpTexture = textrue;
					}
				}
			}
		}
		//	WAV
		{
			ABbmsMaterialWAVdataArray*				array = &(this->m_bmsMusic.materialWAVdataArray);
			ABbmsMaterialWAVdataArray::iterator		it;
			GameFileInfo	resFileInfo;
			bool			retry = false;
			ABint			retryCount = 0;
			ABint8*			fileName;
			ABint8*			retryExt[]={
				"MP3",	
				"mp3",	
			};
			
			GameAudio&			audio = GameGetAudio();

			for( it = array->begin(); it != array->end(); it++ ){

				retry		= true;
				retryCount	= sizeof(retryExt) / sizeof(retryExt[0]) - 1;
				fileName	= it->filename;
				
				if( fileName[0] != 0 ){
					std::cout << " *Open file number = [" << it->number << "] ,filename:[" << fileName << "]" << std::endl;
					while( retry ){
						//	t@CQƁAۂɃt@CL邩H
						result = this->getResourceFileInfo( this->m_directory, fileName, &resFileInfo );
						if( ! result ){
							//	BMSf[^ɋLqĂResourceWAV̂ƂłAۂ̃t@Cmp3ȂB
							//@܂ŁAgqXggpāi"MP3","mp3"Ȃǁjǂ݂Ƃ\ȃt@CEgCB
							//	t@CH
							{
								ABint8		fileNameStr[ sizeof(it->filename) / sizeof(ABint8) ];
								sscanf( fileName, "%[^.]", fileNameStr );						//	extrB%[^.]̓XLZbgƌĂ΂@\ŁA.ȍ~̕𖳎B
								sprintf( fileName, "%s.%s", fileNameStr, retryExt[retryCount] );//	H
							}
							--retryCount;
							if( retryCount < 0 ){
								//	gCs
								std::cout << " -not found WAV file. filename:[" << fileName << "]" << std::endl;
								break;
							}
							else{
								std::cout << " -not found WAV file. retry open file. filename:[" << fileName << "]" << std::endl;
							}
						}
						else{
							retry		= false;
							
							//	J
							result = audio.openSoundFile( &resFileInfo, (ABuint*)&it->wavData );
							if( ! result ){
								//	fileĂۂ
								std::cout << " -file is broken. filename:[" << fileName << "]" << std::endl;
								break;
							}
							
						}
					}//<--do
				}
			}//<--for
		}

		//	BMSf[^̌
		
		result = true;
	}while( false );
	
	return result;
}

//-------------------------------------------------------
//	BMSf[^
//-------------------------------------------------------
void	ABMusicData::closeBMSmusic( void )
{

	//	fމ
	{
		ABbmsMaterialBMPdataArray*				array = &(this->m_bmsMusic.materialBMPdataArray);
		ABbmsMaterialBMPdataArray::iterator		it;
		for( it = array->begin(); it != array->end(); it++ ){
			it->bmpTexture = 0;
		}
	}
	{
		GameAudio&			audio = GameGetAudio();

		ABbmsMaterialWAVdataArray*				array = &(this->m_bmsMusic.materialWAVdataArray);
		ABbmsMaterialWAVdataArray::iterator		it;
		for( it = array->begin(); it != array->end(); it++ ){
			audio.closeSoundFile( it->wavData );
			it->wavData = 0;
		}
	}
	
	//	eNX`
	while( ! this->m_bmpData.empty() ){
		delete this->m_bmpData.back();
		this->m_bmpData.pop_back();
	}

	//	BMSf[^
	this->m_bmsMusic.clean();
}

//-------------------------------------------------------
//	get resource file info
//-------------------------------------------------------
bool	ABMusicData::getResourceFileInfo( ABint8*  inDirectory, ABint8*  inFileName, GameFileInfo*  outFileInfo )
{
	char	fullPath[AB_BMS_CHAR_LENGTH_FILEPATH];
	bool	result	= false;

	//	tpX쐬
	memset( fullPath, 0, AB_BMS_CHAR_LENGTH_FILEPATH );
	this->makeFullpath( fullPath, inDirectory, inFileName, strlen(fullPath) );
	if( 0 != strlen( fullPath ) ){

		result = outFileInfo->make( (ABuint8*)fullPath );
		if( ! result ){
			//	file
			std::cout << "not open Res::" << inFileName << std::endl;
			return false;
		}
		//		std::cout << "Open Res::" << mode << "," << resNum << "," << fullPath << std::endl;
	}

	return true;
}
//-------------------------------------------------------
//	make fullpath
//-------------------------------------------------------
void	ABMusicData::makeFullpath( ABint8*  outFullPath , ABint8*  inFolderName, ABint8*  inFileName ,ABint  inFolderNameSize )
{
	//	make path	/*::TODO::I[o[l鎖*/
	if( 0 == strlen(inFileName) ){
		outFullPath = NULL;
		return;
	}
	if( outFullPath[ inFolderNameSize - 1 ] != '/' ){
		sprintf( outFullPath , "%s/%s", inFolderName, inFileName );
	}
	else{
		sprintf( outFullPath , "%s%s", inFolderName, inFileName );
	}
}
