/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABMusicData.cpp

				BMSf[^̊ǗA
				EPtH_̃t@C𑍏̂BMS~[WbNf[^Ƃł͌ĂԁB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABMusicData_h
#define	ABMusicData_h

#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"

#include	"ABBMSData.h"
#include	"ABParser.h"
#include	"GameFileList.h"
#include	"GGTexture.h"

#include	<vector>
#include	<string>

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABMusicData
{
public:
	ABMusicData();
	~ABMusicData();

	//	BMStH_
	//		inFileInfoPtr	BMSf[^̊i[ĂtH_
	bool	analyzeBMSmusic( ABint8*  inDirectory );
	
	//	BMSf[^J
	//		inFileInfoPtr	BMSf[^̊i[ĂtH_
	bool	openBMSmusic( ABint  inMusicNumber );
	//	BMSf[^J@wb_[̂
	//		inFileInfoPtr	BMSf[^̊i[ĂtH_
	bool	openBMSmusicHeaderOnly( ABint  inMusicNumber );
	
	//	BMSf[^
	void	closeBMSmusic( void );
	
	//	get bms music data
	ABbmsMusicData*	getMusicData( void ){ return( &this->m_bmsMusic ); };

	//	BMStH_ɂBMSf[^t@C擾
	ABint	getBMSmusicCount( void ){
		return	this->m_bmsFileArray.size();
	}
	
private:
	typedef	std::vector<GameFileInfo>	MfileInfoArray;
	typedef	MfileInfoArray::iterator	MfileInfoArrayIt;
	typedef	std::vector<std::string>	MExtArray;

	typedef	std::vector< GGTexture* >	MBMPArray;
	typedef	MBMPArray::iterator			MBMPArrayIt;

	ABbmsMusicData			m_bmsMusic;		//	BMSf[^
	MfileInfoArray			m_bmsFileArray;	//	JgBMSt@CXg
	
	MExtArray				m_extBmsArrray;		//	ǂݍ݉\Ȋgq
	MExtArray				m_extWavArrray;		//	ǂݍ݉\Ȋgq
	
	GameFileList			m_fileList;		//	file info list
	ABint8*  				m_directory;	//	bmd music directory
	
	MBMPArray				m_bmpData;		//	BMPXg
	
	//	BMSf[^J	{
	bool	openBMSmusicFile( ABint  inMusicNumber, ABLoadMode inMode );
	
	//	get resource file info
	bool	getResourceFileInfo( ABint8*  inDirectory, ABint8*  inFileName, GameFileInfo*  outFileInfo );
	//	make fullpath
	void	makeFullpath( ABint8*  outFullPath , ABint8*  inFolderName, ABint8*  inFileName ,ABint  inFolderNameSize );

};

#endif	//	ABMusicData_h
