/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABParser.h
	
				BMSt@Ct@Cǂݍ݁A͂ParserłB

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////
#ifndef	ABParser_h
#define	ABParser_h

#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"

#include	"ABBMSData.h"
#include	"GameTextParser.h"
#include	"GameFile.h"

#include	<vector>
#include	<algorithm>

/*//////////////////////////////////////////////////////////////////////////////
*	class AB BMS Music Analyzer
*///////////////////////////////////////////////////////////////////////////////
//	BMSf[^͂dg݂JX^}CY₷`Œ񋟂B
//
//	ECxg̎ނ΁AoĂǂɂǂ̂AƂANV`łAƂlB
//	@ȉ͂̃ANVi񋟂B
//	ExANVpӂĂ΁Aǂݍݎswitch肷KvȂȂB
//
//--------------------------------------------------------------
//	class
//--------------------------------------------------------------
class	ABBMSArchitectureBase
{
public:
	ABBMSArchitectureBase(){
		this->mEventType = AB_BMS_MUSIC_DATA_EVENT_NOTHING;
	};
	virtual ~ABBMSArchitectureBase(){};

	//	Cxg̉͂Ǝ擾܂BŒl̎擾AIuWFNgz̉͂sB
	//	l͕̂܂ܓn̂ŁAKvɉď邱ƁB
	virtual bool	analyze( ABbmsEventData&  outEventData, long  inBarID, long  inEventType, long  inEventTrackNumber, char*  inValue ){
		return true;
	};

	//	rp
	static bool	compare( ABBMSArchitectureBase*  l, ABBMSArchitectureBase*  r ){
		return	l->mEventType < r->mEventType;
	}
	static bool	equal( ABBMSArchitectureBase*  l, ABBMSArchitectureBase*  r ){
		return	l->mEventType == r->mEventType;
	}
	
	//	
	void	setData( 
		ABbmsMusicDataEventType		inEventType
	)
	{
		this->mEventType = inEventType;
	};
	ABbmsMusicDataEventType	mEventType;
};

/*//////////////////////////////////////////////////////////////////////////////
*	class AB BMS Music Analyzer
*///////////////////////////////////////////////////////////////////////////////
class	ABBMSMusicArchitecture
{
public:
	enum{
		M_MAX_EVENT_TYPE_COUNT,	
	};
public:
	ABBMSMusicArchitecture(){
		this->mArchitectureArrayTable.resize( AB_BMS_MUSIC_DATA_EVENT_MAX, -1 );
	};
	virtual	~ABBMSMusicArchitecture(){};
	//	init hNXConstructorŌĂԂƁB
	virtual	void init( void ){
		this->setupDataFormat();
		sort( this->mArchitectureArray.begin(), this->mArchitectureArray.end(), ABBMSArchitectureBase::compare );
	}
	//	`͂ɏĂˁB
	virtual	void setupDataFormat( void ) = 0;

	//	setupDataFormatŎgpݒ
	void	setData( 
		ABBMSArchitectureBase*  	inArchitecture,
		ABbmsMusicDataEventType		inEventType
	)
	{
		inArchitecture->setData( inEventType );
		this->addArchitecture( inArchitecture );
	};

public:	
	bool	analyze( ABbmsEventData&  outEventData, long  inBarID, long  inEventType, long  inEventTrackNumber, char*  inValue ){
		ABint	index = this->mArchitectureArrayTable[ inEventType ];
		if( index < 0 ){
			return false;
		}
		return this->mArchitectureArray[index]->analyze( outEventData, inBarID, inEventType, inEventTrackNumber, inValue );
	}
	
	typedef	std::vector<ABBMSArchitectureBase*>		MBMSArchitectureArray;
	typedef	std::vector<ABint>						MBMSArchitectureArrayTable;	//	tQƃe[uBQƎԂ萔ɂB
	MBMSArchitectureArray		mArchitectureArray;
	MBMSArchitectureArrayTable	mArchitectureArrayTable;
private:
	void	addArchitecture( ABBMSArchitectureBase*  inArchitecture ){
		ABint	size = this->mArchitectureArray.size();
		this->mArchitectureArray.push_back( inArchitecture );
		this->mArchitectureArrayTable[ inArchitecture->mEventType ] = size;
		
	}
};

/*//////////////////////////////////////////////////////////////////////////////
*	class ABParser
*///////////////////////////////////////////////////////////////////////////////
enum{
	AB_LOAD_ALL_DATA,			//	default
	AB_LOAD_HEADER_INFO_DATA,	//	header information data only	^CgȂǂ̏̂ݓǂݍ
};
typedef	ABtype	ABLoadMode;

class ABParser
{
public:
	ABParser();
	ABParser( ABLoadMode  inLoadMode );	//	load mode setting Constructor
	~ABParser();
	
	//	BMSt@Cǂݍ
	bool	loadBMSFile( GameFileInfo*  inFileInfoPtr, ABbmsMusicData*  refMusicData );

private:
	typedef	GameTextParser::MVecTextArray		MVecTextArray;	//	obt@̍s̐擪obt@i[i`̂݁j
private:
	ABLoadMode				m_loadMode;
	GameTextParser			m_parserTool;
	ABBMSMusicArchitecture* m_musicArchitecture;

	//	BMSCxgʎq`
	void	setupEventTable( void );

	//	eLXg -> wb_[f[^
	bool	readBMSheaderData( ABbmsMusicData*  refMusicData, MVecTextArray*  inArray );

	//	eLXg -> Cxgf[^`
	bool	readBMSeventData( ABbmsMusicData*  refMusicData, MVecTextArray*  inArray );

public:
	//	擾
	static void	getBufferValue( char*  inBuffer, char*  outValue );
	//	POi擾(long^)
	static void	getBufferValue( char*  inBuffer, long*  outValue );
	//	POi擾(double^)
	static void	getBufferValue( char*  inBuffer, double*  outValue );
	//	PUi擾(unsigned long^)
	static void	getBufferValue( char*  inBuffer, unsigned long*  outValue );
	//	io[ɕϊ
	static int	convCharToNum( char*  inBuffer, int  inLength );

};

#endif	//	ABParser_h
