/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqBMSongAdapter.h

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////


#include	"ABSeqBMSongAdapter.h"

#include	<iostream>
#include	<algorithm>
using namespace std;

//-------------------------------------------------------
/*
*	Constructor
*/
//-------------------------------------------------------
ABSeqBMSongAdapter::ABSeqBMSongAdapter()
{
}
//-------------------------------------------------------
/*
*	Destructor
*/
//-------------------------------------------------------
ABSeqBMSongAdapter::~ABSeqBMSongAdapter()
{
}

//-------------------------------------------------------
/*
*	Song <- BMSdata
*/
//-------------------------------------------------------
bool	ABSeqBMSongAdapter::fill( ABSeqBMSong*  inSong, ABbmsMusicData*  inMusicData )
{
	ABbmsEventData*		bmsEvent = NULL;
	ABSeqSong*			song = inSong->getSong();
	int		i;
	int		location = 0;
	int		barID = 0;
	double	vibrantRate = 1.0d;
	int		vibrantResolution = AB_SEQ_EVENT_RESOLUTION;	//	P߂̒

	cout << "ABSeqBMSongAdapter::fill() Start. " << endl;
	
	this->m_vibrant_rate = 1.0d;
	this->m_vr_startVibrant = 0;

	//	BMS̑SEvent𑖍
	for( i = 0 ; i < inMusicData->eventDataArray.size() ; i++ ){
		//	BMSeLXg̏ԒʂɁAPsǂݎĂB

		//	PߕABMS Event擾
		bmsEvent = &( inMusicData->eventDataArray[i] );

		//	߂ςĂAP[VύX
		if( barID != bmsEvent->barID ){
			//	vZ͂Ɩʓ|B
			//	݂̃P[VʒuiLkɂ192ł͖Ȃj+@iinEvent->barIDԂł͂ȂєтɂȂĂ邩Ȃ̂ŁA192{j
			location += vibrantResolution + ( (bmsEvent->barID - 1 /* vibrantResolutionLƂȂߕĂ */ ) - barID ) * AB_SEQ_EVENT_RESOLUTION;
			//	߂ςǂ𒲂ׂ
			barID = bmsEvent->barID;
			//	O߂̏ߐLkw
			vibrantRate = 1.0d;	//	P߂̒
		}

		//	Cxgʎq02f߂Lkw̏ꍇj́AŌvZ
		if( bmsEvent->eventType == AB_BMS_MUSIC_DATA_EVENT_SET_BAR_RATE ){
			//	߂̃f[^w{ɐLkāAWJ悤AL
			vibrantRate	= bmsEvent->value;
		}

		//	߂̒vZ
		vibrantResolution = (double)AB_SEQ_EVENT_RESOLUTION * vibrantRate;

		//	Event𔻕ʁAIuWFNgzĂƂ͏߂ɓWJB
		this->analyzeBMSEvent( inSong, bmsEvent, vibrantResolution, location );

	}
	
	//	CxgdĂ邩Ȃ̂ŁAĂB
	ABSeqTrack*		track = NULL;
	for( i = 0 ; i < song->getTrackCount() ; i ++ ){
		cout << "optimaize...TrackNumber:" << i << endl;

//		track = song->getTrack( bmsEvent->trackNumber );
		track = song->getTrack( i );
		track->uniqueVibrant();

		this->optimizeEventArray( track );

		//cout << " -vibrant TrackNumber:" << i << ", total count" << track->getVibrantCount() << endl;
	}
	
	cout << "ABSeqBMSongAdapter::fill() Finish. " << endl;

	return  true;
}


//-------------------------------------------------------
/*
*	Event𔻕
*/
//-------------------------------------------------------
void	ABSeqBMSongAdapter::analyzeBMSEvent( ABSeqBMSong*  inSong, ABbmsEventData*  inEvent, int  inVibrantResolution, int  inVibrantLocation )
{
	ABSeqSong*		song = inSong->getSong();
	ABSeqTrack*		track = NULL;

	const ABint L_NORMAL_MODE	= 0;
	const ABint L_BATTLE_MIRROR = 1;
	
	//	for 7 Key mode
	
	
	ABseqTrackType	trackNumberDispatch[] = {
		AB_SEQ_TRACK_EVENT,
		AB_SEQ_TRACK_PLAYER1_KEY1,				//	<--ABbmsMusicDataTrackNumber::AB_BMS_MUSIC_DATA_OBJECT_KEY1				= 1,			//	1 Key			(11,21,31,41)
		AB_SEQ_TRACK_PLAYER1_KEY2,				//	<--ABbmsMusicDataTrackNumber::AB_BMS_MUSIC_DATA_OBJECT_KEY2				= 2,			//	2 Key
		AB_SEQ_TRACK_PLAYER1_KEY3,				//	<--ABbmsMusicDataTrackNumber::AB_BMS_MUSIC_DATA_OBJECT_KEY3				= 3,			//	3 Key
		AB_SEQ_TRACK_PLAYER1_KEY4,				//	<--ABbmsMusicDataTrackNumber::AB_BMS_MUSIC_DATA_OBJECT_KEY4				= 4,			//	4 Key
		AB_SEQ_TRACK_PLAYER1_KEY5,				//	<--ABbmsMusicDataTrackNumber::AB_BMS_MUSIC_DATA_OBJECT_KEY5				= 5,			//	5 Key
		AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH,		//	<--ABbmsMusicDataTrackNumber::AB_BMS_MUSIC_DATA_OBJECT_SCRATCH			= 6,			//	scratch
		AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH_FREE,	//	<--ABbmsMusicDataTrackNumber::AB_BMS_MUSIC_DATA_OBJECT_SCRATCH_FREE		= 7,			//	free scratch

		AB_SEQ_TRACK_PLAYER1_KEY6,				//	<--ABbmsMusicDataTrackNumber::AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY6		= 8,			//	6 key
		AB_SEQ_TRACK_PLAYER1_KEY7,				//	<--ABbmsMusicDataTrackNumber::AB_BMS_MUSIC_DATA_OBJECT_MODE7_KEY7		= 9,			//	7 key

	};	//	ł̓vO㎩RɂׂAgbNԍϊB(BMSf[^Key6,Key7Ԃł͂Ȃ̂ŁAɂ)
	
	ABseqTrackType	trackNumberTable[] = {
		trackNumberDispatch[inEvent->trackNumber],									//	1P,܂2Pp̃gbNԍB
		trackNumberDispatch[inEvent->trackNumber] + AB_SEQ_TRACK_PLAYER2_KEY1 - 1,	//	battle~[̃gbNԍB
	};
	
	ABseqTrackType	trackNumber;
	
	bool	trueIsObjectZeroCut = false;

	cout << "-ABSeqBMSongAdapter::analyzeBMSEvent() > " ;
	cout << "trackNumber(normal):" << trackNumberTable[L_NORMAL_MODE];
	cout << " ,trackNumber(battle):" << trackNumberTable[L_BATTLE_MIRROR] << ", Track Resolution:" << inVibrantResolution;
	cout << endl;
	
	//	TrackɐV߂쐬
	trackNumber = trackNumberTable[L_NORMAL_MODE];
	track = song->getTrack( trackNumber );
	track->createVibrant( inEvent->barID, inVibrantResolution );

	//	Event Check
	if( ! inEvent->objectArray.empty() ){
	
		//	EIuWFNgzłB
		
		//	0𖳎邩H
		trueIsObjectZeroCut = true;

		//	WJAi[
		cout << " -Track Number:" << trackNumber << "-" << endl;
		this->analyzeObjectArray( track, inEvent, inVibrantLocation, trueIsObjectZeroCut );

		//	doubleMirror[hH
		if( false ){
			//	ȂA1pEvent̂Ƃ
			if( inEvent->player == AB_BMS_MUSIC_DATA_PLAYER_NUMBER_1 ){
				//	gbNԍCxggbNł͂ȂƂiIuWFNĝƂ̂݁j
				//	BGAȂǂ̓vC[PƋLłȂ΂ȂȂB
				if( AB_SEQ_TRACK_PLAYER1_KEY1 <= inEvent->trackNumber ){
					//	Battle MirrorBQvC[ɓǉ
					trackNumber = trackNumberTable[L_BATTLE_MIRROR];
					track = song->getTrack( trackNumber );
					cout << " *Set battll mirror data. " << endl;
					cout << " -Track Number:" << trackNumber << "-" << endl;
					this->analyzeObjectArray( track, inEvent, inVibrantLocation, trueIsObjectZeroCut );
				}
			}
		}
	}
	else{
		//	IuWFNgzł͂ȂĺAgbNɊi[
		cout << " -Track Number:event track-" << endl;
		track = song->getTrack( AB_SEQ_TRACK_EVENT );
		this->analyzeValue( track, inEvent, inVibrantLocation );
	}
	
}

//-------------------------------------------------------
/*
*	BMSEventAIuWFNgWJAzɊi[
*/
//-------------------------------------------------------
void	ABSeqBMSongAdapter::analyzeObjectArray( ABSeqTrack*  inTrack, ABbmsEventData*  inEvent, int  inVibrantLocation, bool  inTrueIsObjectZeroCut )
{
	int		i;
	int		value;
	int		length;
	int		objectLength;
	bool	skip;

	//	P߂̕𐔂擾B
	length			= inEvent->getNoteCount();

	//	߂̐Lk
//	objectLength	= (double)( AB_SEQ_EVENT_RESOLUTION / this->m_vibrant_rate ) / (double)length;
//	objectLength	= AB_SEQ_EVENT_RESOLUTION / length;
	objectLength	= (double)inTrack->getVibrantResolution( inEvent->barID ) / (double)length;
	
	//	WJ
	for( i = 0 ; i < length ; i++ ){
		//	IuWFNgz񂩂P擾
		value = inEvent->objectArray[i];

		//	BM98dlł́AWAV̎wł0𖳎悤ɂȂĂB
		skip = false;
		if( inTrueIsObjectZeroCut){
			if( value == 0 ){
				skip = true;
			}
		}
		
		if( ! skip){
			int		barID		= inEvent->barID;
//			int		location	= inEvent->barID * AB_SEQ_EVENT_RESOLUTION + objectLength * i;
			int		location	= inVibrantLocation + objectLength * i;
			int		judge		= 0;
			int		object		= value;
			bool	hideIsTrue	= ! inEvent->visible;	//	inEvent->visibletrueȂ\Ȃ̂ŁA]ĂB
			
			bool	result = inTrack->addEvent( barID, location, judge, object, hideIsTrue, inEvent->eventType );
			if( ! result ){
				// debugging
				cout << " ! error. inTrack->addEvent() faital." << endl;
				return;
			}
			
			cout << "  -ABSeqBMSongAdapter::analyzeObjectArray() > inTrack->addEvent() + " ;
			cout << " inEvent->player:" << inEvent->player;
			cout << " barID:" << barID;
			cout << ", location:" << location;
			cout << ", judge:" << judge;
			cout << ", object:" << object;
			cout << ", hideIsTrue:" << hideIsTrue;
			cout << ", inEvent->eventType:" << inEvent->eventType;
			cout << endl;
		}
	}
}
//-------------------------------------------------------
/*
*	BMSEventzɊi[
*/
//-------------------------------------------------------
void	ABSeqBMSongAdapter::analyzeValue( ABSeqTrack*  inTrack, ABbmsEventData*  inEvent, int  inVibrantLocation )
{
	//	CxgĺAgbNɊi[B
	//	WJ
	int		barID		= inEvent->barID;
//	int		location	= inEvent->barID * AB_SEQ_EVENT_RESOLUTION;
	int		location	= inVibrantLocation;
	int		judge		= 0;
	int		object		= inEvent->value;
	bool	hideIsTrue	= ! inEvent->visible;	//	inEvent->visibletrueȂ\Ȃ̂ŁA]ĂB
	bool	result = inTrack->addEvent( barID, location, judge, object, hideIsTrue, inEvent->eventType );
	if( ! result ){
		// debugging
		cout << " ! error. inTrack->addEvent() faital." << endl;
		return;
	}

	cout << "  -ABSeqBMSongAdapter::analyzeValue() > inTrack->addEvent() + " ;
	cout << " inEvent->player:" << inEvent->player;
	cout << ", barID:" << barID;
	cout << ", location:" << location;
	cout << ", judge:" << judge;
	cout << ", object:" << object;
	cout << ", hideIsTrue:" << hideIsTrue;
	cout << ", inEvent->eventType:" << inEvent->eventType;
	cout << endl;
}

//-------------------------------------------------------
/*
*	͍ςEventz𐮗B
*	ETEh̃L[ABCxgƂĖߍށB
*	@͂ɂāAߒPʂŕ邽߁AɊ蓖Ă鉹𒲂ׂ邱ƂȂĂ܂BŃTEh`FWCxg𖄂ߍłƂɂB
*/
//-------------------------------------------------------
void	ABSeqBMSongAdapter::optimizeEventArray( ABSeqTrack*  inTrack )
{
	//	ETEh`FWCxg̑}
	//		ECxg猟A^C~Oꂽʒuɑ}B
	//		E^C~ÓA
	//			ETEhύXKvȉ̌ASɒuB
	//			ETEhύXKvȉ̌낪SȓȂAԓ_ɒuB
	//			Eԍŏ̉pɂ́AԍŏɒuB
	
	ABint	vibrantCount = inTrack->getVibrantCount();
	ABint	ri;
	ABSeqTrack::MvibrantData*	vibrant = NULL;
	ABSeqTrack::MeventData		rEventData;
	ABSeqTrack::MeventData		lEventData;
	ABSeqTrack::MeventDataArray::iterator	it;
	
	ABSeqTrack::MvibrantData*				insertPpointVibrantData = NULL;
	ABSeqTrack::MeventDataArray::iterator	insertPpointIt;

	ABSeqTrack::MeventData		newEventData;
	ABSeqTrack::MeventData*		newEventDataPtr;

	bool	trueIsSet;
	ABint	location;
	ABint vibrantCounter = 0;
	ABint counter = 0;	//	[vJE^
	
	//	eventgbN
	
	//	߂search
	for( ri = 0 ; ri < vibrantCount  ; ri ++ ){
		ABint pointCounter = 0;
		
		vibrant = inTrack->getVibrant( ri );
	
		//	ߓsearch
		for( it = vibrant->eventDataArray.begin() ; it != vibrant->eventDataArray.end()  ; it++ ){
			
			//	[ACe[^point󂯎邱Ƃ͏oȂ񂾂ˁB}ƁÂړ邽߁A|C^̂̂ɂȂĂ܂悤B
			//rEventData = &( *it );
			
			//	CHORUS܂߂ABMSődĂȂ̏ꍇ͍HvKvB͌B
			ABint	eventType = it->eventType;
			switch( eventType ){
				case AB_BMS_MUSIC_DATA_EVENT_OBJECT_1P:			//	11-19:1P	IuWFNg
				case AB_BMS_MUSIC_DATA_EVENT_OBJECT_2P:			//	21-29:2P	IuWFNg
				case AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_1P:	//	31-39:1P	sIuWFNg
				case AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_2P:	//	41-49:2P	sIuWFNg
					trueIsSet = true;
					break;
				default:
					trueIsSet = false;
					break;
			}
			
			rEventData = *it;

			memset( &newEventData, 0, sizeof( newEventData ));
			if( trueIsSet ){
				if( counter == 0 ){
					//	ŏ̃CxgH
					location = -AB_SEQ_EVENT_RESOLUTION4 * 4; // <-- tJñ^C~O͔zu^C~OOɂĂBȂƁAŏ̂Qߕ炢͖ԂƂȂĂ܂B
					insertPpointVibrantData = inTrack->getVibrant( 0 );
					insertPpointIt  = insertPpointVibrantData->eventDataArray.insert( insertPpointVibrantData->eventDataArray.begin(), newEventData );
					if( vibrantCounter == 0 ){	//	@ȂƓ̒Ɂ`oO܂c
						it = insertPpointIt;
						++it;	
					}
					newEventDataPtr = &(*insertPpointIt);
					cout << " > SET1..." << endl;
				}
				else{
					//	IuWFNgH
					if( lEventData.object == rEventData.object ){
						trueIsSet = false;
					}
					else{

						//	ÕCxg̈ʒurBԊu͂ȂĂH
						ABint	gap = rEventData.location - lEventData.location;
						if( AB_SEQ_EVENT_RESOLUTION4 * 2 <= gap ){
							//	P[VlAuׂʒuvZ
							location = rEventData.location - AB_SEQ_EVENT_RESOLUTION4;
						}
						else{
							//	P[VlAuׂʒuvZ
							location = rEventData.location - gap / 2;
						}
						
						//	P[Vʒu}߈ʒuo
						if( vibrant->eventDataArray[0].location <= location  ){
							//	ߏɑ}
							it = vibrant->eventDataArray.insert( it, newEventData );	//	}Ait͉Ă܂B󂯎鎖B
							insertPpointIt = it;
							newEventDataPtr = &(*insertPpointIt);
							++it;
							cout << " > SET2..." << endl;
						}
						else{
							//	Ȍ߂ɑ}B߂̒SZȂĂ蓾H̏ꍇ͑Ȍ߂̐擪ɂłB
							insertPpointVibrantData = inTrack->getVibrant( ri - 1 );
							if( insertPpointVibrantData == NULL ){
							
								//	Ƃ́Aߏɑ}
								it = vibrant->eventDataArray.insert( vibrant->eventDataArray.begin(), newEventData );	//	}Ait͉Ă܂B󂯎鎖B
								insertPpointIt = it;
								newEventDataPtr = &(*insertPpointIt);
								++it;
								cout << " > SET3..." << endl;
							}
							else{
								gap = rEventData.location - insertPpointIt->location;
								if( AB_SEQ_EVENT_RESOLUTION4 * 2 <= gap ){
									location = rEventData.location - AB_SEQ_EVENT_RESOLUTION4;
								}
								else{
									location = rEventData.location - gap / 2;
								}
								if( insertPpointVibrantData->eventDataArray.empty() ){
									//	ۂ̎́A擪ɂłB
									insertPpointIt  = insertPpointVibrantData->eventDataArray.insert( insertPpointVibrantData->eventDataArray.begin(), newEventData );
									newEventDataPtr = &(*insertPpointIt);
									cout << " > SET4..." << endl;
								}
								else{
									//	鎞́A߂̍Ō
									insertPpointIt  = insertPpointVibrantData->eventDataArray.end();
									insertPpointIt  = insertPpointVibrantData->eventDataArray.insert( insertPpointIt, newEventData );
									newEventDataPtr = &(*insertPpointIt);
									cout << " > SET5..." << endl;
								}
							}
						}
					}
				}
			}
			if( trueIsSet ){
				newEventDataPtr->bmsEvent	= rEventData.bmsEvent;
				newEventDataPtr->location	= location;
//				newEventDataPtr->location	= rEventData.location;
				newEventDataPtr->judge		= rEventData.judge;
				newEventDataPtr->object		= rEventData.object;
				newEventDataPtr->hideIsTrue	= true;
				newEventDataPtr->eventType	= AB_BMSEQ_EVENT_SOUND_CHANGE;	//	TEh`FWCxg(L[ɉ蓖Ă^C~Ow肷Cxg)

				cout << "   -ABSeqBMSongAdapter::optimizeEventArray() > event insert + " ;
				cout << ", vibrantCounter:" << vibrantCounter;
				cout << ", pointCounter:" << pointCounter;
				cout << ", rEventData.bmsEvent:" << rEventData.bmsEvent;
				cout << ", rEventData.location:" << rEventData.location;
				cout << ", rEventData.eventType:" << rEventData.eventType;
				cout << ", location:" << location;
				cout << ", judge:" << rEventData.judge;
				cout << ", object:" << rEventData.object;
				cout << ", hideIsTrue:" << rEventData.hideIsTrue;
				cout << ", newEventDataPtr->eventType:" << newEventDataPtr->eventType;
				cout << endl;
			}
			
			lEventData = rEventData;
			++counter;
			
			++pointCounter;
		}
		++vibrantCounter;
	}
	
	//	DEBUGóBŁAtO̍ŏISf[^o͂B
	cout << " > View..." << endl;
	ABint	vCount = 0;
	for( ri = 0 ; ri < vibrantCount  ; ri ++ ){
		
		vibrant = inTrack->getVibrant( ri );
		//	ߓsearch
		for( it = vibrant->eventDataArray.begin() ; it != vibrant->eventDataArray.end()  ; it++ ){
			cout << "   -ABSeqBMSongAdapter::optimizeEventArray() > debug print - " ;
			cout << ", vibrant:" << vCount;
			cout << ", bmsEvent:" << it->bmsEvent;
			cout << ", location:" << it->location;
			cout << ", judge:" << it->judge;
			cout << ", object:" << it->object;
			cout << ", hideIsTrue:" << it->hideIsTrue;
			cout << ", eventType:" << it->eventType;
			cout << endl;
		}
		
		++vCount;
	}
	
}	//	namespace	Component_AquaBeats