/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqLoop.h

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////


#include	"ABSeqLoop.h"
#include	"ABSeqBMSongAdapter.h"
#include	<iostream>
using namespace std;

//#define		AB_LOCAL_DEBUG_MODE

//-------------------------------------------------------
/*
*	Constructor
*/
//-------------------------------------------------------
ABSeqLoop::ABSeqLoop()
{
}
//-------------------------------------------------------
/*
*	Destructor
*/
//-------------------------------------------------------
ABSeqLoop::~ABSeqLoop()
{
}

//////////////////////////////////////////////////////////
/*
*	PUBLIC
*/
//////////////////////////////////////////////////////////
//-------------------------------------------------------
/*
*	initialize
*/
//-------------------------------------------------------
bool ABSeqLoop::initialize( int  inVibrantRange, ABbmsMusicData*  inBMSdata, ABSeqEventActionBase*  inEventAction )
{
	ABSeqBMSongAdapter		bmsAdapter;

	if( inBMSdata->headerInfo.bpm == 0 ){
		return false;
	}

	//	init
	ABLocalDebug( cout << "ABSeqLoop::initialize() start." << endl; );
	this->m_clientEventAction = inEventAction;	//	Ăяo̎w肵ANVs邽߂̎Q
	
	//	Song <- BMSdata
	this->m_sequencerData.m_song.setup( inVibrantRange );	//	ʂɕ\鏬ߐwB
	this->m_sequencerData.m_BMSdata = inBMSdata;
	bmsAdapter.fill( &this->m_sequencerData.m_song, inBMSdata );
	this->m_sequencerData.m_consumer.initialize( inBMSdata->headerInfo.total, inBMSdata->getNoteCount(), false );
	this->m_sequencerData.setBPM( inBMSdata->headerInfo.bpm );
	
	int		trackCount =  this->m_sequencerData.m_song.getSong()->getTrackCount() ;
//	this->m_clientEventAction->mDrawObject.initialize( trackCount );

	this->m_vibrantCount 	= 0;
	this->m_vibrantOnLocationCount = 0;
//	this->m_preLocation = 0;
	this->m_vibrantRange 	= inVibrantRange;
//	this->m_vibrantOnTailLocationCount = this->m_vibrantOnLocationCount - inVibrantRange * AB_SEQ_EVENT_RESOLUTION;

	this->m_preFetchFlagArray.resize( trackCount, 0 );
	this->m_nowBpm = 0;
	this->m_noteCount = 0;

/*
	//	߃o[̃P[VʒuZbeBO
//	ABSequenceDrawObject*	drawInfo =&this->m_clientEventAction->mDrawObject ;
	ABSequenceDrawObject::MdrawVibrantLength::iterator	it;
	ABint	vibrantLine = 0;
	for( it = drawInfo->mDrawVibrantLineArray.begin(); it != drawInfo->mDrawVibrantLineArray.end(); it++ ){
		//	擪Aߋ
		*it = vibrantLine;
		vibrantLine -= AB_SEQ_EVENT_RESOLUTION;
	}
*/

	//	ݒ
	int		bpm = this->m_sequencerData.getBPM();
	if( this->m_nowBpm != bpm ){
		this->m_nowBpm = bpm;
		this->m_sequencerData.m_judge.initJudge( this->m_nowBpm );
	}
	
//	this->m_clientEventAction->mDrawObject.mJudgeType = -1;
	this->m_clientEventAction->mPushKeyInfo.clean();
	
	this->m_clientEventAction->initialize();
	
	ABLocalDebug( cout << "ABSeqLoop::initialize() finish." << endl << endl; );
	return true;
}
//-------------------------------------------------------
/*
*	finalize
*/
//-------------------------------------------------------
void ABSeqLoop::finalize( void )
{
	this->m_clientEventAction->finalize();
	this->m_sequencerData.m_song.cleanup();
}

//-------------------------------------------------------
/*
*	Event
*/
//-------------------------------------------------------
void	ABSeqLoop::doEvent( int  inLocation )
{
//	inLocation -= this->m_vibrantRange * AB_SEQ_EVENT_RESOLUTION;

//	ABSequenceDrawObject*		drawInfo =&this->m_clientEventAction->mDrawObject ;
	//	inLocatiońAtJñP[VlB

	//	this->m_vibrantOnLocationCount	݂̃Cxgʒȕߓ̃P[VlB

	//	݂̃P[V(\̎Ɏgp邽ߐݒ肵Ă)
//	this->m_clientEventAction->mDrawObject.mLocation = inLocation;

	//	݂LOCATION`B
	this->m_clientEventAction->updateLocation( inLocation - AB_SEQ_EVENT_RESOLUTION * this->m_vibrantRange );

	//	݂̃P[VEventsEIuWFNgzu
	if( this->m_vibrantOnLocationCount <= inLocation ){

		//	
		this->m_clientEventAction->changeVibrant( this->m_vibrantOnLocationCount );
	
		int		vibrantResolution = 0;
		ABLocalDebug( cout << " ---vibrant on location:" << inLocation << " ---" << endl;);
		ABLocalDebug( cout << "    *Allocation Objects. Vibrant:" << this->m_vibrantCount << "---" << endl; );
		this->doEventActionObjectAllocate( inLocation, this->m_vibrantCount, &vibrantResolution );

		//	zu߂̒𓾂āAɔzu^C~OL
		//	݂̃P[VʒuSPʂŐ؂̂ĂĉZ
		if( vibrantResolution == 0 ){
			vibrantResolution = AB_SEQ_EVENT_RESOLUTION;
		}
		//	IuWFNg̔zu^C~OvZ
		this->m_vibrantOnLocationCount = ( (inLocation / AB_SEQ_EVENT_RESOLUTION4) * AB_SEQ_EVENT_RESOLUTION4 ) + vibrantResolution;
		++this->m_vibrantCount;

/*		
		//	݂̃P[V(\̎Ɏgp邽ߐݒ肵Ă)
		drawInfo->mLocationInAlocate = inLocation;
		//	݂̏߂̃P[Vli[
		drawInfo->mDrawVibrantLineArray.push_front( inLocation );
		//	svɂȂ폜
		drawInfo->mDrawVibrantLineArray.pop_back();
*/
	}
	
	//	݂̎dg݂ł͐mɓ鎖łȂI
//	drawInfo->mTrueIsVibrantChange = false;

	//	ĐCxg̃P[VvZB
	//	zu郍P[VʒuA莞ԗꂽP[VʒũCxgsB
	//	̋́AȂ̂ŁAAB_SEQ_EVENT_RESOLUTIONgpĂƂ߂B
	//	AB_SEQ_EVENT_RESOLUTIONhbgƓ΁AzuAAB_SEQ_EVENT_RESOLUTION * this->m_vibrantRangehbgꂽ^C~OŃCxg𔭐B
	//	݂̃P[VEvents
	
//	this->doEventAction( this->m_vibrantOnTailLocationCount );		//	Events
	this->doEventAction( inLocation - AB_SEQ_EVENT_RESOLUTION * this->m_vibrantRange );		//	Events

//	this->m_vibrantOnTailLocationCount += inLocation - this->m_preLocation;
//	this->m_preLocation = inLocation;

	//	BPMύXĂAݒ肵Ȃ
	int		bpm = this->m_sequencerData.getBPM();
	if( this->m_nowBpm != bpm ){
		this->m_nowBpm = bpm;
		this->m_sequencerData.m_judge.initJudge( this->m_nowBpm );
	}

	//	tI
	if( this->isEnd() ){
		this->m_sequencerData.m_consumer.palyFinish();
	}
}

//-------------------------------------------------------
/*
*	IH
*/
//-------------------------------------------------------
bool	ABSeqLoop::isEnd( void )
{
	ABSeqSong*		song	= this->m_sequencerData.m_song.getSong();
	return	song->isEnd( AB_SEQ_MARKER_TAIL_LOCATION );
}

//////////////////////////////////////////////////////////
/*
*	INSIDE / Event handle
*/
//////////////////////////////////////////////////////////
/*
*	݂̃P[VEvents
*/
//-------------------------------------------------------
void	ABSeqLoop::doEventActionObjectAllocate( int  inLocation, int  inVibrantCount, int*  outVibrantResolution )
{
	ABSeqSong*		song	= this->m_sequencerData.m_song.getSong();
	ABSeqTrack*		track	= NULL;
	int		i;
	int		vibrantPointer;			//	ߔԍ\
	int		eventPointer;			//	ߓ̔zԍ\
	
	ABbmsEventData*		bmsEvent;	//	Eventf[^ւ̎Q
	int					location;	//	1/192iS = 48jŕ\EvenẗʒuB
	int					judge;		//	茋
	int					object;		//	IuWFNg
	bool				hideIsTrue;	//	BIuWFNgH

	ABbmsMusicDataEventType	eventType = AB_BMS_MUSIC_DATA_EVENT_NOTHING;
	
	bool				trueIsEventChain;
	int					chainCount;

	bool				dataHaveIsTrue;

	*outVibrantResolution = AB_SEQ_EVENT_RESOLUTION;

	//---------------
	//	SgbNQƂÃ݂P[VlɂďׂEventmAs
	//---------------
	for( i = 0 ; i < song->getTrackCount(); i++ ){
		//	gbN擾
		track = song->getTrack( i );
//		ABLocalDebug( cout << "   -Track::" << i << "- " << endl; );
		
		//	݈ʒu
		track->setMarker( AB_SEQ_MARKER_HEAD_LOCATION, inVibrantCount, 0 );

		if( ! track->isEnd( AB_SEQ_MARKER_HEAD_LOCATION ) ){
			chainCount = 0;
			dataHaveIsTrue = true;
			//	݂̈ʒu擾
			track->getMarker( AB_SEQ_MARKER_HEAD_LOCATION, &vibrantPointer, &eventPointer );
			while( dataHaveIsTrue ){
				//	PߕA\Ȃ΂ȂȂ
				//	markerʒuEventQ
				dataHaveIsTrue = track->getEvent( vibrantPointer, eventPointer, chainCount, &bmsEvent, &location, &judge, &object, &hideIsTrue, &eventType, &trueIsEventChain );
				if( dataHaveIsTrue ){
					
					//	߂̒Ԃ
					int	vibrantResorution = track->getVibrantResolution( vibrantPointer );
					if( vibrantResorution != 0 ){
						*outVibrantResolution = vibrantResorution;
					}			

					bool	trueIsSet;
					
					switch( eventType ){
						case AB_BMS_MUSIC_DATA_EVENT_OBJECT_1P:			//	11-19:1P	IuWFNg
						case AB_BMS_MUSIC_DATA_EVENT_OBJECT_2P:			//	21-29:2P	IuWFNg
							trueIsSet = true;
							break;
						default:
							trueIsSet = false;
							break;
					}

					if( ! hideIsTrue && trueIsSet ){
						ABLocalDebug( cout << "   -Allocation Objects Request Head position vibrant- Track:" << i << endl; );
						ABLocalDebug( cout << "   -track->getEvent() + " ;  );
						ABLocalDebug( cout << " vibrantPointer:" << vibrantPointer; );
						ABLocalDebug( cout << " eventPointer:" << eventPointer; );
						ABLocalDebug( cout << ", chainCount:" << chainCount; );
						ABLocalDebug( cout << ", bmsEvent:" << bmsEvent; );
						ABLocalDebug( cout << ", location:" << location; );
						ABLocalDebug( cout << ", judge:" << judge; );
						ABLocalDebug( cout << ", object:" << object; );
						ABLocalDebug( cout << ", hideIsTrue:" << hideIsTrue; );
						ABLocalDebug( cout << ", eventType:" << eventType; );
						ABLocalDebug( cout << ", trueIsEventChain:" << trueIsEventChain; );
						ABLocalDebug( cout << endl; );
						ABLocalDebug( cout << "      -Allocation:" ; );
					
						this->m_clientEventAction->requestDrawSetObject( i, location );
					}
				}
				//	̃Cxg
				++eventPointer;
			}
			
		}
	}
}
//-------------------------------------------------------
/*
*	݂̃P[VEvents
*/
//-------------------------------------------------------
void	ABSeqLoop::doEventAction( int  inLocation )
{
	ABSeqSong*		song	= this->m_sequencerData.m_song.getSong();
	ABSeqTrack*		track	= NULL;
	int		i;
//	int		vibrantPointer;			//	ߔԍ\
//	int		eventPointer;			//	ߓ̔zԍ\
	
	ABbmsEventData*		bmsEvent;	//	Eventf[^ւ̎Q
	int					location;	//	1/192iS = 48jŕ\EvenẗʒuB
	int					judge;		//	茋
	int					object;		//	IuWFNg
	bool				hideIsTrue;	//	BIuWFNgH

	ABbmsMusicDataEventType	eventType = AB_BMS_MUSIC_DATA_EVENT_NOTHING;
	bool				doJudgeIsTrue;
	bool				judgeFlag;
	ABseqJudgeType		judgeType;
	float				pushKeyLocation;
	
	bool				trueIsEventChain;

	bool				dataHaveIsTrue;

	bool				trueIsAutoPlay = false;		//	autoplay ?

	//	consumer̓͏Request
	this->m_clientEventAction->requestPushKeyStatus( inLocation );
	//	consumer̓͏
	ABSeqEventActionBase::MPushKeyInfo*	  	pushKeyInfo = &( this->m_clientEventAction->mPushKeyInfo );

	//---------------
	//	SgbNQƂÃ݂P[VlɂďׂEventmAs
	//---------------
	for( i = 0 ; i < song->getTrackCount(); i++ ){
		//	gbN擾
		track = song->getTrack( i );
		
		if( ! track->isEnd( AB_SEQ_MARKER_TAIL_LOCATION ) ){
			dataHaveIsTrue = true;

			do{
				//	markerʒuEventQ
				dataHaveIsTrue = track->getEventMoveNext( AB_SEQ_MARKER_TAIL_LOCATION, inLocation, &bmsEvent, &location, &judge, &object, &hideIsTrue, &eventType, &trueIsEventChain );
				if( !dataHaveIsTrue ){
					break;
				}

				//	ׂCxg
				ABLocalDebug( cout << "  #Proccesing Tail position vibrant- TrackNumber:" << i << " , inLocation:" << inLocation << endl; );

				ABLocalDebug( cout << "    -track->getEvent() + " ; ); 
				ABLocalDebug( cout << ", bmsEvent:" << bmsEvent; );
				ABLocalDebug( cout << ", location:" << location; );
				ABLocalDebug( cout << ", judge:" << judge; );
				ABLocalDebug( cout << ", object:" << object; );
				ABLocalDebug( cout << ", hideIsTrue:" << hideIsTrue; );
				ABLocalDebug( cout << ", eventType:" << eventType; );
				ABLocalDebug( cout << ", trueIsEventChain:" << trueIsEventChain; );
				ABLocalDebug( cout << endl; );
				
				{
					//	Events
					if( eventType != AB_BMS_MUSIC_DATA_EVENT_NOTHING ){
						ABLocalDebug(  cout << "    ->eventSelecter : " ; );
						this->m_clientEventAction->eventSelecter( &this->m_sequencerData, eventType, i, object, bmsEvent, trueIsAutoPlay );
						ABLocalDebug(  cout << endl; );
					}
					
					//	肷H
					{
						//	H
						if( ! hideIsTrue ){
							doJudgeIsTrue = true;	
						}
						else{
							doJudgeIsTrue = false;	//	Ȃ͔̂肵Ȃ
						}
						//	I[gvCH
						//	I[gSCRATCHH
						//	łvAH
/*
						//	肷Cxg
						switch( eventType ){
							case AB_BMS_MUSIC_DATA_EVENT_OBJECT_1P:			//	11-19:1P	IuWFNg
							case AB_BMS_MUSIC_DATA_EVENT_OBJECT_2P:			//	21-29:2P	IuWFNg
								break;
							default:
								doJudgeIsTrue = false;
								break;
						}
*/
					}
					
				}
				{
					//	
					if( doJudgeIsTrue ){
						++this->m_noteCount;
					
//	eXgR[h( 0  1 ɂƁASeXgłBJyɂȂ邩H@)
//#if 0
#if 1
						//	̎eXǵAۂɃL[ԂV~[gB
/*						{
							//	AB_SEQ_GAME_LEVEL_NOMAL
							{
								static	int testCase = -1;
								++testCase;
								if( 4 < testCase ){
									testCase = 0;
								}
								switch( testCase ){
									case	0:
										pushKeyLocation = (float)location - 0.0f;		//	JUST GREAT
										break;
									case	1:
										pushKeyLocation = (float)location - 8.3f;		//	GREAT
										break;
									case	2:
										pushKeyLocation = (float)location - 16.5f;	//	GOOD
										break;
									case	3:
										pushKeyLocation = (float)location - 34.1f;	//	BAD
										break;
									case	4:
										pushKeyLocation = (float)location - 46.1f;	//	POOR
										break;
								}
								this->m_clientEventAction->doPushKey( i, pushKeyLocation, true );
								
							}
*/
						{
							//	AB_SEQ_GAME_LEVEL_NOMAL
							{
//								pushKeyLocation = (float)location - 0.0f;		//	JUST GREAT
								pushKeyLocation = (float)location - 8.3f;		//	GREAT
//								pushKeyLocation = (float)location - 16.5f;	//	GOOD
								ABLocalDebug( cout << "     >@Push key Request:" << endl ; );
								this->m_clientEventAction->doPushKey( i, pushKeyLocation, true );
							}
//*/
						}
#endif

						//	͏
						if( pushKeyInfo->info[ i ].trueIsPushed ){
							pushKeyLocation = pushKeyInfo->info[ i ].location;
							
							//	L[𕡐񉟂Ăpoorɂ
							if( 1 < pushKeyInfo->info[ i ].pushCount ){
								pushKeyLocation = (float)location - 9999;	//	KȒlŎsƂB蓾Ȃli΁j
							}
							pushKeyInfo->info[ i ].pushCount = 0;
						}
						else{
							pushKeyLocation = (float)location - 9999;	//	KȒlŎsƂB蓾Ȃli΁j
						}
						pushKeyInfo->info[ i ].trueIsPushed = false;

						//	̃P[VĺAL[Ԃ̍珬_ŋ߂B
						//	@iBPMlɊ֌WȂAɂȂ΂ȂȂBj

						judgeFlag = this->m_sequencerData.m_judge.judge( AB_SEQ_GAME_LEVEL_NOMAL, location, pushKeyLocation, &judgeType );
						if( judgeFlag ){

							//	ς݂ł邱Ƃ
							//track->setEvent( vibrantPointer, eventPointer, bmsEvent, &location, judgeType, &object, &hideIsTrue );

							//	consumerɕ񍐁FŃvC[̐тWv
							this->m_sequencerData.m_consumer.setJadgeGreatGete( false );
							this->m_sequencerData.m_consumer.scoreCount( AB_SEQ_EXPART_MODE_OFF, judgeType, AB_SEQ_GAME_LEVEL_NOMAL );

							//	茋ʂ
							this->m_clientEventAction->reportJudge( &this->m_sequencerData, i, judgeType );
						}
					}
				}
			
			} while( trueIsEventChain ); //<--do
			
		}
	}//<--for



}

#undef		AB_LOCAL_DEBUG_MODE
