/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqSong.h

				AquaBeatsV[PT[	Song

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABSeqSong_h
#define	ABSeqSong_h

#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"

#include	"ABSeqTrack.h"

#include	<vector>

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSeqSong
{
public:
	typedef	std::vector< ABSeqTrack >	MTrackArray;

public:
	//	method
	ABSeqSong(){};
	~ABSeqSong(){};
	
	//-------------------------
	//	Accesser	gbN
	//-------------------------
	//	create empty track
	void	createTrack( int  inCount ){
		this->m_trackArray.resize( inCount );
	}
	//	delete track
	void	deleteTrack( void ){
		this->m_trackArray.resize( 0 );
	}
	//	get track count
	int		getTrackCount( void ){
		return	this->m_trackArray.size();
	}
	//	get track
	ABSeqTrack*		getTrack( int  inNumber ){
		return	&( this->m_trackArray[ inNumber ] );
	}

	//-------------------------
	//	}[J[
	//-------------------------
	//	create marker
	void	createMarker( int  inMarkerCount ){
		int	i;

		for( i = 0 ; i < this->getTrackCount() ; i ++ ){
			ABSeqTrack*		track = this->getTrack( i );
			
			track->createMarker( inMarkerCount );
		}
	}
	
	//	set marker
	//	gƃ[vł܂BK[hƂB
	//	ߓւ̐ݒ͂ƕGȂ̂őΉȂB
	void	setMarker( int  inMarkerNumber, int  inVibrantPointer ){
		int	i;

		for( i = 0 ; i < this->getTrackCount() ; i ++ ){
			ABSeqTrack*		track = this->getTrack( i );
			
			track->setMarker( inMarkerNumber, inVibrantPointer, 0 );
		}
	}
	//	move Next marker
	void	moveNextMarker( int  inMarkerNumber ){
		int	i;

		for( i = 0 ; i < this->getTrackCount() ; i ++ ){
			ABSeqTrack*		track = this->getTrack( i );
			
			track->moveNextMarker( inMarkerNumber );
		}
	}

	//	is end?
	bool	isEnd( int  inMarkerNumber ){
		int	i;

		for( i = 0 ; i < this->getTrackCount() ; i ++ ){
			ABSeqTrack*		track = this->getTrack( i );
			
			if( ! track->isEnd( inMarkerNumber ) ){
				//	łIĂȂƂ
				return	false;
			}
		}
		return	true;
	}

private:
	//	member
	MTrackArray		m_trackArray;
};

#endif	//	ABSeqSong_h
