/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqTimeControllerBase.h

				BMSV[PT[Ŏg^C}[Controller

				EOSɂA^C}[@͈قȂB
				@̃NXpA eOSƂōœKȏ@`B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////
#ifndef	ABSeqTimeControllerBase_h
#define	ABSeqTimeControllerBase_h

#include	"GlobalConfig.h"

#include	"AquanBeatsConfig.h"
#include	"ABSeqLoop.h"

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSeqTimeControllerBase
{
public:
	ABSeqTimeControllerBase(){
		this->initialize( NULL, 0 );
	};
	virtual	~ABSeqTimeControllerBase(){
	};
	
	//	setup
	virtual	void	setup( void ){
	}

	//	start timer
	//	E^C}[ZbgB
	//	@Pʂ̓~bȂ̂ŁAbɂƂ1000ŊĂB
	virtual	void	startTimer( int  inBPM ){};
	
	//	E^C}[Đݒ肷B
	virtual	void	resetTimer( int  inBPM ){};
	
	//	stop timer
	//	E^C}[~B
	virtual	void	stopTimer( void ){};

	//	timer event firei΂fĂ݂j
	//	E^C}[OɂȂ炱methodR[邱ƁB
	//	E̊֐R[-^C}[ZbgԂ̍nB
	void	fire( double  inLocation ){
		//	Cxgs
		this->doFire( inLocation );
	};

public:
	void	initialize( ABSeqLoop*  inLoop, int  inResolutionCount ){
		this->m_loop		= inLoop;
		this->m_location	= 0;
		this->m_resolutionCount = inResolutionCount;
		this->m_pauseIsTrue = false;
		this->setup();
	};
	void	doStartTimer( void ){
		this->startTimer( this->m_loop->getBPM() );
		this->m_pauseIsTrue = false;
	}
	void	setLocation( int  inLocation ){
		this->m_location = inLocation;
	}
	float	getLocation( void ){
		return	this->m_location;
	}
	void	pause( void ){
		this->m_pauseIsTrue = true;
	};
	void	cont( void ){
		this->m_pauseIsTrue = false;
	};
	void	stop( void ){
		this->stopTimer();
		this->m_pauseIsTrue = true;
	};
	bool	isEnd( void ){
		return this->m_loop->isEnd();
	};

private:
	void	doFire( double  inLocation ){

		if( ! this->m_pauseIsTrue ){
			int  prevbpm = this->m_loop->getBPM();
			int  nextbpm = 0;
			
			this->m_location = inLocation;
			this->m_loop->doEvent( inLocation );

			//	BPMύXĂA^C}[Đݒ
			nextbpm = this->m_loop->getBPM();
			if( prevbpm != nextbpm ){
				this->stopTimer();
				this->resetTimer( nextbpm );
			}
		}
		
	};

	double	getRezolutionMiliSecond( void ){
		double	rate = ( 60.0d * 1000.0d) / (double)( this->m_loop->getBPM() * 2 * AB_SEQ_EVENT_RESOLUTION4) ;	//	S̕b
		return	rate;
	}
protected:
	ABSeqLoop*		m_loop;
	int				m_location;
	int				m_resolutionCount;
	bool			m_pauseIsTrue;
};

#endif	//	ABSeqTimeControllerBase_h
