/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqTrack.h

				AquaBeatsV[PT[	Track

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	ABSeqTrack_h
#define	ABSeqTrack_h

#include	<vector>
#include	<algorithm>


#include	"GlobalConfig.h"
#include	"AquanBeatsConfig.h"

#include	"ABBMSConfig.h"
#include	"ABBMSData.h"

/*//////////////////////////////////////////////////////////////////////////////
*	class
*///////////////////////////////////////////////////////////////////////////////
class ABSeqTrack
{
public:
	//	IuWFNgz
	typedef	struct	MeventData{
		ABbmsEventData*		bmsEvent;			//	Eventf[^ւ̎Q
		int		location;		//	1/192iS = 48jŕ\EvenẗʒuB
		int		judge;			//	茋
		int		object;			//	IuWFNgA܂͒l
		bool	hideIsTrue;		//	BIuWFNgH
		ABbmsMusicDataEventType	eventType;		//	Cxg
	
		void	clean(void ){
			bmsEvent	= NULL;
			location	= 0;
			judge		= 0;
			object		= 0;
			hideIsTrue	= false;
		}
	
	}	MeventData;
	typedef	std::vector<MeventData>				MeventDataArray;

	//	Pߕ̃f[^
	//	EP[VɈقȂCxg܂B
	typedef	struct	MvibrantData{
		int		vibrantResolution;				//	P߂̒
		MeventDataArray		eventDataArray;		//	WJIuWFNg̔z
	
		void	clean( void ){
			vibrantResolution = AB_SEQ_EVENT_RESOLUTION;
			eventDataArray.resize(0);
		}
		
	}	MvibrantData;
	typedef	std::vector<MvibrantData>			MvibrantDataArray;

	//	z|C^[(marker)
	//	ʃNXǂH
	typedef	struct	MarrayPointer{
		int		vibrantPointer;		//	ߔԍ\
		int		eventPointer;		//	ߓ̔zԍ\

		void	clean( void ){
			vibrantPointer	= 0;
			eventPointer	= 0;
		}
	}	MarrayPointer;
	typedef	std::vector<MarrayPointer>			MarrayPointers;

public:
	//	method
	ABSeqTrack(){};
	~ABSeqTrack(){};

public:
	//	member
	MvibrantDataArray		m_vibrantDataArray;		//	1gbN̏߃f[^z 
	MarrayPointers			m_arrayPointers;		//	ɎQƂׂzʒu}[J[Ƃċ@\BzB
	
	//-------------------------
	//	Accesser	
	//-------------------------
	//	V߂쐬
	void	createVibrant( int  inBarID, int  inVibrantResolution ){
		
		//	E߃f[^źACfbNXlߔԍƂzƂB
		//	Ef[^̖߂͋ƂĂB
		//	ł́Aߔԍ̏߃f[^L邩ׁA
		//	ΐVɍ쐬A
		//	݂Ƃ͍쐬ȂB
		
		if( this->m_vibrantDataArray.size() <= inBarID ){
			MvibrantData	vibrant;
			vibrant.clean();
			//	gp̃gbN̒͂OɂĂ
			vibrant.vibrantResolution = 0;
			//	w菬ߔԍ܂ŁȀ߂쐬
			this->m_vibrantDataArray.resize( inBarID + 1, vibrant );
			//	w菬߂͎w̒̏߂ɕύX
			vibrant.vibrantResolution = inVibrantResolution;
			this->m_vibrantDataArray[ inBarID ] = vibrant;
		}
	}
	//	get vibrant
	inline	MvibrantData*	getVibrant( int  inPointer ){
		if( this->m_vibrantDataArray.empty() ){
			return NULL;
		}
		else if( inPointer < 0 || this->getVibrantCount() <= inPointer ){
			return NULL;
		}
		else{
			return	&( this->m_vibrantDataArray[ inPointer ] );
		}
	}
	//	get vibrant@count
	inline	int		getVibrantCount(){
		return	this->m_vibrantDataArray.size();
	}
	//	get last vibrant
	MvibrantData*	getLastVibrant(){
		if( this->m_vibrantDataArray.empty() ){
			return NULL;
		}
		else{
			return	this->getVibrant( this->getVibrantCount() - 1 );
		}
	}
	//	get vibrant resolution
	inline	int	getVibrantResolution( int  inPointer ){
		if( this->m_vibrantDataArray.empty() ){
			return AB_SEQ_EVENT_RESOLUTION;
		}
		else if( inPointer < 0 || this->getVibrantCount() <= inPointer ){
			return AB_SEQ_EVENT_RESOLUTION;
		}
		else{
			return	this->m_vibrantDataArray[ inPointer ].vibrantResolution;
		}
	}

	//-------------------------
	//	Accesser	Event
	//-------------------------
	//	Eventi[
	bool	addEvent
	(
		int		inBarID,			//	ߔԍ
		int		inLocation,			//	1/192iS = 48jŕ\EvenẗʒuB
		int		inJudge,			//	茋
		int		inObject,			//	IuWFNg
		bool	inHideIsTrue,		//	BIuWFNgH
		ABbmsMusicDataEventType	inEventType		//	Cxg
		
	){
		MeventData		eventData;
		MvibrantData*	vibrant = this->getVibrant( inBarID );
		if( vibrant == NULL ){
			return	false;
		}
		
		eventData.location		= inLocation;
		eventData.judge			= inJudge;
		eventData.object		= inObject;
		eventData.hideIsTrue	= inHideIsTrue;
		eventData.eventType		= inEventType;
		vibrant->eventDataArray.push_back( eventData );

		return	true;
	}
	
	//	get event 
	bool		getEvent
	(
		int  	inVibrantPointer,
		int  	inEventPointer,
		int		inChainCount,

		ABbmsEventData**  outEvent,	//	BMSEventւ̎Q
		int*	outLocation,		//	1/192iS = 48jŕ\EvenẗʒuB
		int*	outJudge,			//	茋
		int*	outObject,			//	IuWFNg
		bool*	outHideIsTrue,		//	BIuWFNgH
		ABbmsMusicDataEventType*	outEventType,		//	Cxg
		bool*	outTrueIsEventChain	//	P[VɎ̃CxgLƂAtrueԂ
	){
		MvibrantData*	vibrant		= this->getVibrant( inVibrantPointer );

		//	P[VɁAقȂCxgzuĂ邱ƂLB
		int		p = inEventPointer + inChainCount;

		if( vibrant == NULL ){
			return	false;
		}

		if( vibrant->eventDataArray.size() <= p ){
			return	false;
		}		

		MeventData*		eventData	= &( vibrant->eventDataArray[ p ] );
		*outTrueIsEventChain = false;
		*outLocation	= eventData->location;
		*outJudge		= eventData->judge;
		*outObject		= eventData->object;
		*outHideIsTrue	= eventData->hideIsTrue;
		*outEventType	= eventData->eventType;
		*outEvent		= eventData->bmsEvent;

		//	P[VH
		++p;
		if( p < vibrant->eventDataArray.size() ){
			if( this->compare_equal( *eventData, vibrant->eventDataArray[ p ] ) ){
				//	Cxgł
				*outTrueIsEventChain = true;
			}
		}

		return	true;
	}

	//	get event and move next 
	bool		getEventMoveNext
	(
		int  	inMarkerNumber,
		
		int		inLocation, 

		ABbmsEventData**  outEvent,		//	BMSEventւ̎Q
		int*	outLocation,		//	1/192iS = 48jŕ\EvenẗʒuB
		int*	outJudge,			//	茋
		int*	outObject,			//	IuWFNg
		bool*	outHideIsTrue,		//	BIuWFNgH
		ABbmsMusicDataEventType*	outEventType,		//	Cxg
		bool*	outTrueIsEventChain	//	P[VɎ̃CxgLƂAtrueԂ
	){
		bool	result = false;
		int		vibrantPointer;
		int		eventPointer;
		this->getMarker( inMarkerNumber, &vibrantPointer, &eventPointer );
		MvibrantData*	vibrant = this->getVibrant( vibrantPointer );

		*outTrueIsEventChain = false;

		do{
			if( vibrant == NULL ){
				break;
			}
			if( vibrant->eventDataArray.size() <= eventPointer ){
				break;
			}
			
			MeventData*		eventData	= &( vibrant->eventDataArray[ eventPointer ] );
			if( inLocation < eventData->location ){
				return false;	//	ׂCxgł͂ȂiɏׂCxgłj͉ȂłȂĂ͂Ȃ
			}

			*outLocation	= eventData->location;
			*outJudge		= eventData->judge;
			*outObject		= eventData->object;
			*outHideIsTrue	= eventData->hideIsTrue;
			*outEventType	= eventData->eventType;
			*outEvent		= eventData->bmsEvent;
			*outTrueIsEventChain = false;

			//	̃CxgP[VȂȀKvł邱Ƃ
			++eventPointer;
			if( eventPointer < vibrant->eventDataArray.size() ){
				MeventData*		nextEventData	= &( vibrant->eventDataArray[ eventPointer ] );
				if(  eventData->location == nextEventData->location  ){
					//	Cxgł
					*outTrueIsEventChain = true;
				}
			}
			result = true;
		} while( false ) ;

		//	̃|C^ֈړ
		this->moveNextMarker( inMarkerNumber );

		return	result;
	}

	//	get current event 
	//	EL[ׂ̈ɁÃCxgǂ݂
	bool		getCurrentEvent
	(
		int  	inMarkerNumber,
		int		inLocation, 

		ABbmsEventData**  outEvent,		//	BMSEventւ̎Q
		int*	outLocation,			//	1/192iS = 48jŕ\EvenẗʒuB
		int*	outJudge,				//	茋
		int*	outObject,				//	IuWFNg
		bool*	outHideIsTrue,			//	BIuWFNgH
		ABbmsMusicDataEventType*	outEventType		//	Cxg
	){
		int		vibrantPointer;
		int		eventPointer;
		
		MvibrantData*	vibrant = NULL;
		MeventData*		eventData = NULL;

		//	markerʒũCxgQ
		bool	trueIsGet = false;
		this->getMarker( inMarkerNumber, &vibrantPointer, &eventPointer );
		do{
			if( vibrantPointer < 0 ){
				vibrantPointer = 0;
			}
			vibrant = this->getVibrant( vibrantPointer );
			if( vibrant == NULL ){
				break;
			}
			if( vibrant->eventDataArray.size() < eventPointer ){
				break;
			}
			eventData	= &( vibrant->eventDataArray[ eventPointer ] );
			if( eventData == NULL ){
				break;
			}
			trueIsGet = true;

		}while( false );

		if( ! trueIsGet ){
			return false;
		}
		
		//	ǂݎ
		*outLocation	= eventData->location;
		*outJudge		= eventData->judge;
		*outObject		= eventData->object;
		*outHideIsTrue	= eventData->hideIsTrue;
		*outEventType	= eventData->eventType;
		*outEvent		= eventData->bmsEvent;

		return	true;
	}

	//	get event count
	int		getEventCount( int  inVibrantPointer ){
		MvibrantData*	vibrant		= this->getVibrant( inVibrantPointer );
		if( vibrant == 0 ){
			return 0;
		}
		return	vibrant->eventDataArray.size();
	}

	//-------------------------
	//	d鏬߂𐮗
	//-------------------------
	void	uniqueVibrant( void ){
		MvibrantDataArray::iterator		it;
		for( it = this->m_vibrantDataArray.begin() ; it != this->m_vibrantDataArray.end(); it++ ){
			MeventDataArray*	array = &it->eventDataArray;	
			//	sort
			sort( array->begin(), array->end(), this->compare_less );
			//	unique
			//	ĉŁA]Ad폜A܂]B
			reverse( array->begin(), array->end() );
			unique( array->begin(), array->end(), this->compare_equal );
			reverse( array->begin(), array->end() );
		}
	}

	//-------------------------
	//	STL֐
	//-------------------------
	//	P[Vʒu̔r
	static bool	compare_less( MeventData&  l, MeventData&  r ){
		return	l.location < r.location;
	}
	//	P[VʒuACxg̔r
	static bool	compare_equal( MeventData&  l, MeventData&  r ){
		return	( l.eventType == r.eventType ) && ( l.location == r.location ) && ( l.object == r.object );
	}

	//-------------------------
	//	Accesser	}[J[
	//-------------------------
	//	create marker
	inline void	createMarker( int  inCount ){
		MarrayPointer	marker;

		marker.clean();
		this->m_arrayPointers.resize( inCount, marker );
	}
	//	delete marker
	inline void	deleteMarker( void ){
		this->m_arrayPointers.resize( 0 );
	}
	//	set marker
	inline void	setMarker( int  inMarkerNumber, int  inVibrantPointer, int  inEventPointer ){
		this->m_arrayPointers[ inMarkerNumber ].vibrantPointer	= inVibrantPointer;
		this->m_arrayPointers[ inMarkerNumber ].eventPointer	= inEventPointer;
	}
	//	get marker
	inline void	getMarker( int  inMarkerNumber, int*  outVibrantPointer,  int*  outEventPointer ){
		*outVibrantPointer	= this->m_arrayPointers[ inMarkerNumber ].vibrantPointer;
		*outEventPointer	= this->m_arrayPointers[ inMarkerNumber ].eventPointer;
	}
	//	move Next marker
	inline void	moveNextMarker( int  inMarkerNumber ){
		MarrayPointer*		arrayPointer = &( this->m_arrayPointers[ inMarkerNumber ] );
		
		++arrayPointer->eventPointer;

		if( this->getEventCount( arrayPointer->vibrantPointer ) <= arrayPointer->eventPointer ){
			++arrayPointer->vibrantPointer;
			arrayPointer->eventPointer = 0;
		}
	}
	
	//	is end?
	inline bool	isEnd( int  inMarkerNumber ){
		int		vibrantPointer	= this->m_arrayPointers[ inMarkerNumber ].vibrantPointer;
		int		vibrantCount	= this->getVibrantCount();
		
		if( vibrantCount < vibrantPointer ){
			return true;
		}
		else{
			return false;
		}
	}

};

#endif	//	ABSeqTrack_h
