/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		ABSeqBMEventAction.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	<iostream>

#define		AB_LOCAL_DEBUG_MODE

#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"GameSingleton.h"

#include	"ABSeqBMEventAction.h"

#include	"ABVARunner.h"
#include	"ABMBVAItemRenderStagePlay.h"

using namespace std;


//-------------------------------------------------------
//	Sequencer̃gbNԍA`gbNɕϊ
//-------------------------------------------------------
inline	void	ABSeqBMEventActionConverTrackNumber( ABseqTrackType  inTrackType, ABint*  outPlayerNumber, ABint*  outDrawTrackNumber )
{
	static const ABuint		trackNumber[] = {
		0,										// AB_SEQ_TRACK_EVENT,		//	ObjectzȂEvent
		ABMBVAItemRenderStagePlay::M_TRACK_1_W, // AB_SEQ_TRACK_PLAYER1_KEY1,
		ABMBVAItemRenderStagePlay::M_TRACK_2_B, // AB_SEQ_TRACK_PLAYER1_KEY2,
		ABMBVAItemRenderStagePlay::M_TRACK_3_W, // AB_SEQ_TRACK_PLAYER1_KEY3,
		ABMBVAItemRenderStagePlay::M_TRACK_4_B, // AB_SEQ_TRACK_PLAYER1_KEY4,
		ABMBVAItemRenderStagePlay::M_TRACK_5_W, // AB_SEQ_TRACK_PLAYER1_KEY5,
		ABMBVAItemRenderStagePlay::M_TRACK_6_B, // AB_SEQ_TRACK_PLAYER1_KEY6,
		ABMBVAItemRenderStagePlay::M_TRACK_7_W, // AB_SEQ_TRACK_PLAYER1_KEY7,
		ABMBVAItemRenderStagePlay::M_TRACK_S,   // AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH,
		ABMBVAItemRenderStagePlay::M_TRACK_S,   // AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH_FREE,
		
		ABMBVAItemRenderStagePlay::M_TRACK_1_W, // AB_SEQ_TRACK_PLAYER2_KEY1,
		ABMBVAItemRenderStagePlay::M_TRACK_2_B, // AB_SEQ_TRACK_PLAYER2_KEY2,
		ABMBVAItemRenderStagePlay::M_TRACK_3_W, // AB_SEQ_TRACK_PLAYER2_KEY3,
		ABMBVAItemRenderStagePlay::M_TRACK_4_B, // AB_SEQ_TRACK_PLAYER2_KEY4,
		ABMBVAItemRenderStagePlay::M_TRACK_5_W, // AB_SEQ_TRACK_PLAYER2_KEY5,
		ABMBVAItemRenderStagePlay::M_TRACK_6_B, // AB_SEQ_TRACK_PLAYER2_KEY6,
		ABMBVAItemRenderStagePlay::M_TRACK_7_W, // AB_SEQ_TRACK_PLAYER2_KEY7,
		ABMBVAItemRenderStagePlay::M_TRACK_S,	 // AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH,
		ABMBVAItemRenderStagePlay::M_TRACK_S,	 // AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH_FREE,
	};
	if( inTrackType <= AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH_FREE ){
		*outPlayerNumber 	= 0;
	}
	else{
		*outPlayerNumber 	= 1;
	}

	*outDrawTrackNumber = trackNumber[inTrackType];
}

//-------------------------------------------------------
/*
*	Constructor
*/
//-------------------------------------------------------
ABSeqBMEventAction::ABSeqBMEventAction()
{
}
//-------------------------------------------------------
/*
*	Destructor
*/
//-------------------------------------------------------
ABSeqBMEventAction::~ABSeqBMEventAction()
{
}

//----------------------------------
//	initialize finalize
//----------------------------------
void	ABSeqBMEventAction::initialize( void ) {
	memset( this->m_nextSoundData, 0, sizeof(this->m_nextSoundData) );
	
	this->m_chorusTrack = 0;

	memset( &this->mVAItemBindStagePlay->mBMSDrawInfo, 0, sizeof(this->mVAItemBindStagePlay->mBMSDrawInfo) );

	this->mVAItemBindStagePlay->mBMSDrawInfo.Player1.mJudgeTypeNeon = -1;
	this->mVAItemBindStagePlay->mBMSDrawInfo.Player1.mJudgeTypeObject = -1;
	this->mVAItemBindStagePlay->mBMSDrawInfo.Player2.mJudgeTypeNeon = -1;
	this->mVAItemBindStagePlay->mBMSDrawInfo.Player2.mJudgeTypeObject = -1;
}

void	ABSeqBMEventAction::finalize( void ){
}

//-------------------------------------------------------
//	fetch@EventHandler	vibrant
//	Oɐǂ݂AsEventHandler
//	EŃL[ATCsȂ܂
//-------------------------------------------------------
void	ABSeqBMEventAction::fetchEventSelecter( ABSeqData*  inData, ABbmsMusicDataEventType  inEventType, ABseqTrackType  inTrackType, int  inObject, ABbmsEventData*  inEvent  )
{
	bool	trueIsPlaySound = false;
	bool	trueIssettingSound = false;

	//	EOāAKvƂȂ`lmۂĂB
	//	EL[ɃATCB

	switch( inEventType ){
		case	AB_BMS_MUSIC_DATA_EVENT_BACK_CHORUS:		//	01:dont play WAV
			trueIsPlaySound = true;
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_SET_BAR_RATE:		//	02:߂̔{i_j
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_CHANGE_BPM:			//	03:BPMl̓rύX
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_SET_BGA:			//	04:BGA
			break;
		//	AB_BMS_MUSIC_DATA_EVENT_SET_EXTEND,				//	05:Extended Object(For BM98 YANEURAO ver.)	:	AB not suported.
		case	AB_BMS_MUSIC_DATA_EVENT_SET_ANIMATION:		//	06:PoorAj[V̕ύX
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_SET_LAYER:			//	07:BGA Layer transparency key color
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_SET_EX_BPM:			//	08:gBPM
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_OBJECT_1P:			//	11-19:1P	IuWFNg
			trueIssettingSound = true;
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_OBJECT_2P:			//	21-29:2P	IuWFNg
			trueIssettingSound = true;
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_1P:		//	31-39:1P	sIuWFNg
			trueIssettingSound = true;
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_2P:		//	41-49:2P	sIuWFNg
			trueIssettingSound = true;
			break;
			
		default:	//	UnKnown event
			break;
	}
	
	ABint	tracktype = inTrackType;
	
	switch( inTrackType ){
		case	AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH_FREE:
			tracktype = AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH;
			break;
		case	AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH_FREE:
			tracktype = AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH;
			break;
	};

	if( trueIssettingSound ){
		if( this->mPushKeyInfo.info[tracktype].object != inObject ){
			ABbmsMusicData*				bmsData = inData->m_BMSdata;
			ABbmsMaterialWAVdataArray&	wavArray = bmsData->materialWAVdataArray;
			
			//	Đ
			if( wavArray.size() <= inObject ){
				ABLocalDebug( cout << "     @SOUND Fetch error! > wave nothing... sound.number:" << inObject << endl ; );
				return;
			}

			ABbmsMaterialWAVdata*	wavData = &wavArray[ inObject ];;
			int		channel = 40 + tracktype;

			this->mPushKeyInfo.info[tracktype].object		= inObject;
			this->mPushKeyInfo.info[tracktype].wavData		= wavData;
			this->mPushKeyInfo.info[tracktype].soundChannel = channel;
			this->mPushKeyInfo.info[tracktype].setupFlag = true;
			ABLocalDebug(  cout << "     @SOUND Fetch > sound.number:" << inObject << endl ; );
		}
	}
}

//-------------------------------------------------------
/*
*	EventHandler	vibrant
*/
//-------------------------------------------------------
void	ABSeqBMEventAction::eventSelecter( ABSeqData*  inData, ABbmsMusicDataEventType  inEventType, ABseqTrackType  inTrackType, int  inObject, ABbmsEventData*  inEvent, bool  inTrueIsAutoPlay  )
{
	bool	trueIsPlaySound = false;
	bool	trueIsSetSound = false;

	switch( inEventType ){
		case	AB_BMS_MUSIC_DATA_EVENT_BACK_CHORUS:		//	01:dont play WAV
			trueIsPlaySound = true;
			break;

		case	AB_BMS_MUSIC_DATA_EVENT_SET_BAR_RATE:		//	02:߂̔{i_j
			//	ɗ邸ƑOɏς݂Ȃ̂ŉKv͗L܂B
			break;

		case	AB_BMS_MUSIC_DATA_EVENT_CHANGE_BPM:			//	03:BPMl̓rύX
			inData->setBPM( inObject );
			break;

		case	AB_BMS_MUSIC_DATA_EVENT_SET_BGA:			//	04:BGA
			{
				ABbmsMusicData*					bmsData = inData->m_BMSdata;
				ABbmsMaterialBMPdataArray&		bmpArray = bmsData->materialBMPdataArray;
				ABbmsMaterialBMPdata*			bmpInfo = NULL;
				if(bmpArray.size() <= inObject ){
					ABReportErrorCode( "@BGA ERROR! > bmp nothing... bmp number:", inObject );
					break;
				}
				bmpInfo = &bmpArray[inObject];
				this->mVAItemBindStagePlay->mBMSDrawInfo.mDrawBGAInfo = bmpInfo;
				ABLocalDebug(  cout << "     @BGA > filename:" << bmpInfo->filename << ", number:" << bmpInfo->number << endl ; );
				break;
				
			}

		//	AB_BMS_MUSIC_DATA_EVENT_SET_EXTEND,				//	05:Extended Object(For BM98 YANEURAO ver.)	:	AB not suported.
		case	AB_BMS_MUSIC_DATA_EVENT_SET_ANIMATION:		//	06:PoorAj[V̕ύX
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_SET_LAYER:			//	07:BGA Layer transparency key color
			{
				ABbmsMusicData*					bmsData = inData->m_BMSdata;
				ABbmsMaterialBMPdataArray&		bmpArray = bmsData->materialBMPdataArray;
				ABbmsMaterialBMPdata*			bmpInfo = NULL;
				if(bmpArray.size() <= inObject ){
					ABReportErrorCode( "@BGA ERROR! > bmp nothing... bmp number:", inObject );
					break;
				}
				bmpInfo = &bmpArray[inObject];
				this->mVAItemBindStagePlay->mBMSDrawInfo.mDrawBGALayerInfo = bmpInfo;
				ABLocalDebug(  cout << "     @BGA > filename:" << bmpInfo->filename << ", number:" << bmpInfo->number << endl ; );
				
				break;
				
			}
			break;
			
		case	AB_BMS_MUSIC_DATA_EVENT_SET_EX_BPM:			//	08:gBPM
			inData->setBPM( inObject );
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_OBJECT_1P:			//	11-19:1P	IuWFNg
			if( inTrueIsAutoPlay ){
				trueIsPlaySound = true;
			}
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_OBJECT_2P:			//	21-29:2P	IuWFNg
			if( inTrueIsAutoPlay ){
				trueIsPlaySound = true;
			}
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_1P:		//	31-39:1P	sIuWFNg
			break;
		case	AB_BMS_MUSIC_DATA_EVENT_HIDE_OBJECT_2P:		//	41-49:2P	sIuWFNg
			break;

		//	SequencerpCxg			
		case		AB_BMSEQ_EVENT_SOUND_CHANGE:			//	TEh`FWCxg(L[ɉ蓖Ă^C~Ow肷Cxg)
			trueIsSetSound = true;
			break;
			
		default:	//	UnKnown event
			break;
	}


	bool	result = false;
	if( trueIsPlaySound ){

		//	Đ
		MsoundData*		data = &this->m_nextSoundData[inTrackType];

		ABbmsMusicData*				bmsData = inData->m_BMSdata;
		ABbmsMaterialWAVdataArray&	wavArray = bmsData->materialWAVdataArray;
		if( wavArray.size() <= inObject ){
			ABLocalDebug( cout << "     @SOUND Fetch error! > wave nothing... sound.number:" << inObject << endl ; );
			return;
		}
		data->wavData = &wavArray[ inObject ];
//		if( data->wavData->wavData == NULL ){
//			ABLocalDebug( cout << "     @SOUND Fetch error! > wave data nothing... sound.number:" << inObject << endl ; );
//			return;
//		}
			
		//	Đ
		result = GameGetAudio().playSoundTrack( GE_AUDIO_SOUND_TRACK_SOUNDNUMBER_CHANNEL, 0, data->wavData->wavData );
		ABLocalDebug( cout << "     @SOUND Play > filename:" << data->wavData->filename << ", number:" << data->wavData->number << endl ; );
		
	}
	else if( trueIsSetSound ){
	
		ABint	tracktype = inTrackType;
		switch( inTrackType ){
			case	AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH_FREE:
				tracktype = AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH;
				break;
			case	AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH_FREE:
				tracktype = AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH;
				break;
		};

		if( this->mPushKeyInfo.info[tracktype].object != inObject ){
			ABbmsMusicData*				bmsData = inData->m_BMSdata;
			ABbmsMaterialWAVdataArray&	wavArray = bmsData->materialWAVdataArray;
			
			//	Đ
			if( wavArray.size() <= inObject ){
				ABLocalDebug( cout << "     @SOUND Fetch error! > wave nothing... sound.number:" << inObject << endl ; );
				return;
			}

			ABbmsMaterialWAVdata*	wavData = &wavArray[ inObject ];;

			this->mPushKeyInfo.info[tracktype].object = inObject;
			this->mPushKeyInfo.info[tracktype].wavData = wavData;
			this->mPushKeyInfo.info[tracktype].soundChannel = tracktype;
			this->mPushKeyInfo.info[tracktype].setupFlag = true;
			ABLocalDebug( cout << "     @SOUND Fetch > sound.number:" << inObject << endl ; );
		}
	}
}

/*///////////////////////////////////////////////////////
*	EventHandler	object arrays
*	EߓňEventBĐAAnimationȂǂȂ
*
*	IuWFNgzEvent
*////////////////////////////////////////////////////////
//-------------------------------------------------------
/*
*	IuWFNgzEvent
*/
//-------------------------------------------------------
void	ABSeqBMEventAction::onToggleNote( ABSeqData*  inData, ABseqTrackType  inTrackType, int  inObject )
{
}

//-------------------------------------------------------
/*
*	m[gKEYBOARDɃATC
*/
//-------------------------------------------------------
void	ABSeqBMEventAction::onAssignNote( ABSeqData*  inData, ABseqTrackType  inTrackType, int  inObject )
{
	ABseqTrackType		subEventType = AB_SEQ_TRACK_EVENT; 

	switch( inTrackType ){
		//	Đ
		//	EI[gvCAL[͂ŋ쓮
		case	AB_SEQ_TRACK_PLAYER1_KEY1:
		case	AB_SEQ_TRACK_PLAYER1_KEY2:
		case	AB_SEQ_TRACK_PLAYER1_KEY3:
		case	AB_SEQ_TRACK_PLAYER1_KEY4:
		case	AB_SEQ_TRACK_PLAYER1_KEY5:
		case	AB_SEQ_TRACK_PLAYER1_KEY6:
		case	AB_SEQ_TRACK_PLAYER1_KEY7:
		case	AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH:
		case	AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH_FREE:
		case	AB_SEQ_TRACK_PLAYER2_KEY1:
		case	AB_SEQ_TRACK_PLAYER2_KEY2:
		case	AB_SEQ_TRACK_PLAYER2_KEY3:
		case	AB_SEQ_TRACK_PLAYER2_KEY4:
		case	AB_SEQ_TRACK_PLAYER2_KEY5:
		case	AB_SEQ_TRACK_PLAYER2_KEY6:
		case	AB_SEQ_TRACK_PLAYER2_KEY7:
		case	AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH:
		case	AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH_FREE:
			break;
		default:
			break;
	}
}

//-------------------------------------------------------
//	Request
//-------------------------------------------------------

//	݂LOCATIONXV
void	ABSeqBMEventAction::updateLocation( int  inLocation ) 
{
	this->mVAItemRenderStagePlay->m_bmsLocate = inLocation;
}

//	߂ς
void	ABSeqBMEventAction::changeVibrant( int  inLocation ) 
{
	this->mVAItemRenderStagePlay->addBareObjects( this->mVARunner, inLocation );
}

//	consumer̓͏Request
void	ABSeqBMEventAction::requestPushKeyStatus( int  inLocation )
{
	//	L[͂̏sB
	//	̓t[[g̃^C~Oł͖ABPM̃^C~OŌĂяoׁAmȃ^C~O𓦂catchł̂B
	//	AESCȂǂ͂ōsĂ͂Ȃif́AC̏ōsjB
	
	//	̊֐Hv邱ƂŁAR[fBOAvC\B
	GameJoystick&		joystick = GameGetJoystick();
	ABint				i;

	static	ABint	track[] = {
		AB_SEQ_TRACK_PLAYER1_KEY1,
		AB_SEQ_TRACK_PLAYER1_KEY2,
		AB_SEQ_TRACK_PLAYER1_KEY3,
		AB_SEQ_TRACK_PLAYER1_KEY4,
		AB_SEQ_TRACK_PLAYER1_KEY5,
		AB_SEQ_TRACK_PLAYER1_KEY6,
		AB_SEQ_TRACK_PLAYER1_KEY7,
		AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH,
		AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH,
	};
	for( i = 0; i <= (AB_TRRIGER_P1_BUTTON_TRUN_R - AB_TRRIGER_P1_BUTTON_1 ) ; i++ ){
		this->doPushKey( track[ i ], inLocation, GameGetJoystick().isPush( AB_TRRIGER_P1_BUTTON_1 + i ) );
	}
	/*
	for( i = 0; i <= AB_TRRIGER_STATE_BUTTON_COUNT; i++ ){
		if( i == AB_TRRIGER_STATE_BUTTON_TRUN_R ){
			trackType = AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH;
		}
		else{
			trackType = AB_SEQ_TRACK_PLAYER2_KEY1 + i;
		}
		this->doPushKey( trackType, inLocation, ts.flagPushButtonP2[i] );
	}
	*/

}

//	requestPushKeyStatusŃL[͂󂯎Å֐R[ĂB
void	ABSeqBMEventAction::doPushKey( ABseqTrackType  inTrackType, int  inLocation, bool  inTrueIsPress )
{
	ABseqTrackType		trackType = inTrackType; 

	//	̊֐𒼐ڌĂԂƂŁAI[gvCB܂ŃV~[goB
	switch( inTrackType ){
		case  AB_SEQ_TRACK_EVENT:
			return;	//	eventtrack͖
			break;

		case  AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH_FREE:
			trackType = AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH;
			break;
		case  AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH_FREE:
			trackType = AB_SEQ_TRACK_PLAYER2_KEY_SCRATCH;
			break;
		default:
			break;
	}
	
	if( inTrueIsPress ){

		//	`ɉĂgbN`B
		{
			ABint	playerNumber;
			ABint	drawTrackNumber;

			ABSeqBMEventActionConverTrackNumber( trackType, &playerNumber, &drawTrackNumber );
			if( playerNumber == 0 ){
				this->mVAItemBindStagePlay->mTrackBackLightPressP1[ drawTrackNumber ] = true;
			}
			else{
				this->mVAItemBindStagePlay->mTrackBackLightPressP2[ drawTrackNumber ] = true;
			}
		}

		this->mPushKeyInfo.info[trackType].trueIsPush = true;
		this->mPushKeyInfo.info[trackType].trueIsPress = true;

		this->mPushKeyInfo.info[trackType].location = inLocation;
		

		if( trackType == AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH ){
			this->mPushKeyInfo.info[AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH_FREE].location = inLocation;
			this->mPushKeyInfo.info[AB_SEQ_TRACK_PLAYER1_KEY_SCRATCH_FREE].trueIsPushed = true;
		}
		
		if( this->mPushKeyInfo.info[trackType].trueIsPush ){
			ABLocalDebug( cout << "     @Push key trackType:" << trackType << endl ; );

			//	P񂾂o
			++this->mPushKeyInfo.info[trackType].pushCount;
			this->mPushKeyInfo.info[trackType].trueIsPushed = true;

			//	Đ
			bool	result = false;
			int		channel = this->mPushKeyInfo.info[trackType].soundChannel;
			int		object = this->mPushKeyInfo.info[trackType].object;
			int		location = this->mPushKeyInfo.info[trackType].location;
			int		openFlag = this->mPushKeyInfo.info[trackType].openFlag;

			if( this->mPushKeyInfo.info[trackType].setupFlag ){

				result = GameGetAudio().playSoundTrack( GE_AUDIO_SOUND_TRACK_SOUNDNUMBER_CHANNEL, channel, this->mPushKeyInfo.info[trackType].wavData->wavData );
				if( ! result){
					//	s
					ABLocalDebug( cout << "     @Push key SOUND Play ERROR! trackNumber:" << inTrackType << ", channel:" << channel << ", object:" << object << endl ; );
				}
				else{
					ABLocalDebug( cout << "     @Push key SOUND Play trackNumber:" << inTrackType << ", channel:" << channel << ", object:" << object << endl ; );
				}
			}
			else{
				ABLocalDebug( cout << "     @Push key-ERROR trackType:" << trackType << endl ; );
			}

		}
	}
	else{
		this->mPushKeyInfo.info[trackType].trueIsPress = false;
	}
}

//	ʕ`RequestiIuWFNgʂɂPߒPʂŔzuj
void	ABSeqBMEventAction::requestDrawSetObject( ABseqTrackType  inTrackType, ABint  inLocation )
{
	ABint	playerNumber;
	ABint	drawTrackNumber;

	ABSeqBMEventActionConverTrackNumber( inTrackType, &playerNumber, &drawTrackNumber );
	this->mVAItemRenderStagePlay->addNoteObjects( this->mVARunner, playerNumber, drawTrackNumber, inLocation );
}


//	茋ʂ
void	ABSeqBMEventAction::reportJudge( ABSeqData*  inData, ABseqTrackType  inTrackType, ABseqJudgeType  inJudgeType )
{
	ABint	playerNumber;
	ABint	drawTrackNumber;
	ABSeqBMEventActionConverTrackNumber( inTrackType, &playerNumber, &drawTrackNumber );

	//	茋ʉ摜\
	if( playerNumber == 0 ){
		this->mVAItemBindStagePlay->mBMSDrawInfo.Player1.mJudgeTypeNeon = inJudgeType;
		this->mVAItemBindStagePlay->mBMSDrawInfo.Player1.mJudgeTypeObject = inJudgeType;
	}
	else{
		this->mVAItemBindStagePlay->mBMSDrawInfo.Player2.mJudgeTypeNeon = inJudgeType;
		this->mVAItemBindStagePlay->mBMSDrawInfo.Player2.mJudgeTypeObject = inJudgeType;
	}
	
	//	miss摜
	switch( inJudgeType ){
		case AB_SEQ_JUDGE_BAD:
		case AB_SEQ_JUDGE_POOR: 
			{
				ABbmsMusicData*				bmsData	 = inData->m_BMSdata;
				ABbmsMaterialBMPdataArray&	bmpArray = bmsData->materialBMPdataArray;

				//	poor摜ɐݒ
				if( this->mVAItemBindStagePlay->mBMSDrawInfo.mPoorBMPNumber == 0 ){
					//	w薳̎́ASCHEMEw̉摜gp̂ŁAł͉w肵ȂB
				}
				else{
					//	poor摜ύXCxgŎw肳ꂽ摜gp
					this->mVAItemBindStagePlay->mBMSDrawInfo.mDrawBGAPoorInfo = &bmpArray[ this->mVAItemBindStagePlay->mBMSDrawInfo.mPoorBMPNumber ];
				}
				
				this->mVAItemBindStagePlay->mBMSDrawInfo.mTrueIsPoorBMPDisplay = true;
				this->mVAItemBindStagePlay->mBMSDrawInfo.mPoorTimeCounter = 0;
			}
			break;
		default:
			//	poor@
			this->mVAItemBindStagePlay->mBMSDrawInfo.mTrueIsPoorBMPDisplay = false;
							
			//	~XĂȂƂ́AXp[N\
			if( playerNumber == 0 ){
				this->mVAItemBindStagePlay->mBMSDrawInfo.Player1.mJudgeTypeSpark[inTrackType] = true;
			}
			else{
				this->mVAItemBindStagePlay->mBMSDrawInfo.Player2.mJudgeTypeSpark[inTrackType] = true;
			}
							
			break;
	}
}

#undef		AB_LOCAL_DEBUG_MODE
