/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GGRender.cpp

	Encoding:	Shift-JIS
	
				singleton class
	
				XvCg`GWB
				OpenGL`@\bv܂B
				o邾R̃XvCg`ł悤GL@\ggpĂ܂B
				
	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GGRender_h
#define	GGRender_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<list>
#include	"CWorkerSingletonBase.h"

#include	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"GameEngine.h"

class	GGSprite;

//	Render\
//		E_OPRIMITIVÉAQuadsƂB
//		EAt@uhlāAZobt@͎gpAʎɂďZI[_[Ń\[gďԂۂB
//		
//	PRIMITIVEO[v
//		[g@@O[v@@PRIMITIVEiQuadsj
//		@@@@@E@@@@@@@@E@
//		@@@@@E@@@@@@@@E@
//		@@@@@E@@@@@@@@E@
//		@@@@@E@@@@@@@@@PRIMITIVEiQuadsj
//		
//		EQuadśAO[vPʂŃ_OB
//		@O[v́Ar[|[gŵ߂̂̂ŁA`̈̃NbsOsB
//		

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	Primitive
//
//////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct GGPrimitive{

	//	`̊e_̔zԍwB
	GLushort		elementIndex[4];
	GGSprite*		sprite;

	static bool	zComp( const GGPrimitive&  a, const GGPrimitive&  b );

} GGPrimitive;
typedef	std::list< GGPrimitive >		GGPrimitiveList;
typedef	GGPrimitiveList::iterator		GGPrimitiveListIt;

//	compare z order

////////////////////////////////////////////////////////////////////////////////
//
//	Class	GEUniqueNumber
//
//		UniqueȔԍU
//
////////////////////////////////////////////////////////////////////////////////
class	GEUniqueNumber
{
private:
	typedef std::list<ABuint>		MNumberList;

	ABuint			m_number;
	MNumberList		m_usedNumbers;

	ABuint			m_rentalCount;

public:
	//	Constructor
	GEUniqueNumber( void )
	{
		this->clear();
	}
	
	//	Destructor
	virtual	~GEUniqueNumber( void ){
	}
	
	//	Vԍ擾
	inline	ABuint		getNewNumber( void ){
		ABuint	number;

		if( ! this->m_usedNumbers.empty() ){
			//	ÃXgėp
			number = this->m_usedNumbers.front();
			this->m_usedNumbers.pop_front();
		}
		else{
			//	Vԍ
			number = this->m_number;
			++this->m_number;
		}

		++this->m_rentalCount;
		return	number;
	}

	//	ԍ
	inline	void		releaseNumber( const ABuint  inNumber ){
		//	ÃXgɊi[
		this->m_usedNumbers.push_back( inNumber );
		--this->m_rentalCount;
	}
	
	//	gpʂ擾
	ABuint	getUseCount( void ){
		return	this->m_rentalCount;
	}
	
	//	S
	void	clear( void ){
		this->m_number = 0;
		this->m_rentalCount = 0;
		this->m_usedNumbers.clear();
	}
};



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS Primitive group
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GGPrimitiveGroup
{
public:
	GGPrimitiveList		m_primitiveList;

	ABbool				m_useClip;
	ABint				m_clipLeft;
	ABint				m_clipTop;
	ABint				m_clipWidth;
	ABint				m_clipHeight;

public:
	GGPrimitiveGroup( void ) : 
		m_useClip( false ),
		m_clipLeft( 0 ),
		m_clipTop( 0 ),
		m_clipWidth( 0 ),
		m_clipHeight( 0 )
	{};
	~GGPrimitiveGroup( void ){};

	//	O[v̕`̈Nbv
	void	setClip( const ABint  inLeft, const ABint  inRight, const ABint  inWidth, const ABint  inHeight  ){
		this->m_useClip = true;
		this->m_clipLeft = inLeft;
		this->m_clipTop = inRight;
		this->m_clipWidth = inWidth;
		this->m_clipHeight = inHeight;
	}

	//	O[v̕`̈Nbv
	void	clearClip( void ){
		this->m_useClip = false;
	}

};
typedef	std::list< GGPrimitiveGroup >		GGPrimitiveGroupList;
typedef	GGPrimitiveGroupList::iterator		GGPrimitiveGroupListIt;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GGRender
{
private:
	GEUniqueNumber				m_uniqueNumber;				//	uniqueȔԍ蓖ĂɎgp܂B
	GGPrimitiveGroupList		m_primitiveGroupList;

	ABint16			m_viewPortWidth;
	ABint16			m_viewPortHeight;
	ABint16			m_screenWidth;
	ABint16			m_screenHeight;

	//	_z
	enum{
		M_VA_SIZE_VERTEX		= 3,	//	x, y, z
		M_VA_SIZE_TEXCOORD		= 2,	//	x, y
		M_VA_ROW_STRIDE			= M_VA_SIZE_VERTEX + M_VA_SIZE_TEXCOORD,

		M_VA_OFFSET_VERTEX		= 0,
		M_VA_OFFSET_TEXCOORD	= M_VA_SIZE_VERTEX,
		
		M_QUAD_VERTEX_COUNT		= 4, 
	};
	GLfloat*		m_vertexArray;
	GLsizei			m_quadCount;	//	quad
	
	ABfloat32		m_fadeLevel;
	
	ABbool			m_setupFlag;
	
public:
	
	GGRender( void );
	virtual ~GGRender( void );

	//	initialize
	//		[̏
	ABbool	initialize( const ABsize  inPrimitiveCount );

	//	finalize
	//		[̔p
	void	finalize( void );
	
	//	render setup
	//		openGLɃR[BtXN[ύXɂĂт܂B
	//		ReLXgLȏԂŎsȂ΂ȂȂB
	void	renderSetup( void );

	//	render cleanup
	//		openGLɃR[B(ŌɌĂт܂)
	//		ReLXgLȏԂŎsȂ΂ȂȂB
	void	renderCleanup( void );

	//	Render
	void	render( void );
	
	//	Clear
	void	clear( void );

	//	reshape
	//		reshapeKvȂƂĂт܂B
	void	reshape( const ABint16  inWidth, const ABint16  inHeight );
	
	//	FadeIn, FadeOut
	//	EK}lgpȂtF[houterB
	//	E0.0f(FadeOut) - 1.0f(FadeIn) ŃR[B
	//	EtF[h쒆́ARenderĉB
	//	@iK}l̓EBhE[h̉ʑJڂɂ͊iDArŃNbVƑςł܂j
	void		fade( ABfloat32  inFadeLebel );
	ABfloat32	getFade( void );
	
	//	Get view port size
	void	getViewPortSize( ABint*  outWidth, ABint*  outHeight ){
		*outWidth = this->m_viewPortWidth;
		*outHeight = this->m_viewPortHeight;
	}

	///////////////////////////////////
	//	O[v
	///////////////////////////////////

	//	O[v쐬
	ABbool	addGroup( GGPrimitiveGroupListIt*  outIt );

	//	O[vj
	void	removeGroup( const GGPrimitiveGroupListIt&  inGroupIt );
	
	//	O[vPRIMITIVE
	//		E\[gw莞́AsƓZWŃ\[g܂Bi኱Ԃ|܂j
	//		EZWύXꍇ́AremovePrimitive()ĂĂłB
	ABbool	addPrimitive( 	GGPrimitiveGroupListIt&	inGroupIt, 
							GGSprite*			inSprite,
							const ABbool		inRequestZSort,
							GGPrimitiveListIt*	ioIt );
	
	//	O[vPRIMITIVE
	ABbool	setPrimitive( 	GGPrimitiveListIt&	inIt, 
							GGSprite*			inSprite );
	

	//	O[vPRIMITIVE폜
	void	removePrimitive( GGPrimitiveGroupListIt&  inGroup, const GGPrimitiveListIt&  inPrimitive );

	//	Q[XN[TCY
	//	r[TCYƂ͕ʕłBSchemeɂĎw肳A`Ԃ̉zIȃTCYłB
	void	setGameScreenSize( ABint  inWidth, ABint  inHeght ){
		this->m_screenWidth = inWidth;
		this->m_screenHeight = inHeght;
	}
	void	getGameScreenSize( ABint*  outWidth, ABint*  outHeght ){
		*outWidth = this->m_screenWidth;
		*outHeght = this->m_screenHeight;
	}

private:
	
	//	drawing
	void	draw( void );
	
};

#endif	GGRender_h
