/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GGSprite.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	<stdio.h>

#include	"GGSprite.h"
#include	"GameSingleton.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
GGSprite::GGSprite( void )
{
	this->m_width		= 32;
	this->m_height		= 32;
	memset( &this->m_locate ,0 , sizeof( this->m_locate ) );
	memset( &this->m_texCoord ,0 , sizeof( this->m_texCoord ) );
	memset( &this->m_color ,0 , sizeof( this->m_color ) );
	this->m_blendMode	= GG_SPRITE_BLEND_MODE_SPRITE;
	this->m_doRotate	= false;
	memset( &this->m_rotateCenter ,0 , sizeof( this->m_rotateCenter ) );
	memset( &this->m_rotate, 0 , sizeof( this->m_rotate ) );
	this->m_textureName = 0;
	
	this->m_setupGroup = false;
	this->m_visible	= true;
	this->m_setup = false;
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
GGSprite::~GGSprite( void )
{
	this->cleanup();
}

//-------------------------------------------------------------------------------------------------
//	O[vݒ
//-------------------------------------------------------------------------------------------------
ABbool	GGSprite::setGroup( GGPrimitiveGroupListIt&  inIt )
{
	this->m_groupIt = inIt;
	this->m_setupGroup = true;
	return	true;
}

//-------------------------------------------------------------------------------------------------
//	O[v擾
//-------------------------------------------------------------------------------------------------
GGPrimitiveGroupListIt&		GGSprite::getGroup( void )
{
	return	this->m_groupIt;
}

//-------------------------------------------------------------------------------------------------
//	setup
//-------------------------------------------------------------------------------------------------
ABbool		GGSprite::setup( GGPrimitiveGroupListIt&  inIt, ABbool  inZorder )
{
	this->cleanup();
	this->setGroup( inIt );
	this->m_render = &( GGGetRender() );
	ABbool	ret = this->m_render->addPrimitive( this->m_groupIt, this, inZorder, &this->m_primitiveIt );
	if( ret ){
		this->m_setup = true;
	}
	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	cleanup
//-------------------------------------------------------------------------------------------------
void		GGSprite::cleanup( void )
{
	if( this->m_setupGroup && this->m_setup ){
		this->m_render->setPrimitive( this->m_primitiveIt, this );
		this->m_render->removePrimitive( this->m_groupIt, this->m_primitiveIt );
		this->m_setupGroup = false;
	}
}

//-------------------------------------------------------------------------------------------------
//	_[XV
//-------------------------------------------------------------------------------------------------
ABbool		GGSprite::update( void )
{
	return	this->m_render->setPrimitive( this->m_primitiveIt, this );
}

