/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GGSprite.cpp

	Encoding:	Shift-JIS

				gpOGGRenderNXĂKv܂B

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GGSprite_h
#define	GGSprite_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"GGRender.h"

//------------------------------------------------------------------------------------------------
//	[h
//------------------------------------------------------------------------------------------------
enum{
	GG_SPRITE_BLEND_MODE_NOTHING,		//	uhȂ
	GG_SPRITE_BLEND_MODE_SPRITE,		//	At@}XNŃuh
};
typedef	ABtype	GGSpriteBlendMode;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GGSprite
{
public:
	//	size
	GLfloat		m_width;
	GLfloat		m_height;

	//	locate
	GGVector3f	m_locate;

	//	texture
	GGVector2f	m_texCoord[ 2 ];	//	WƉEW

	//	color
	GGColor4f	m_color;

	//	Blending
	GGSpriteBlendMode		m_blendMode;

	//	rotate
	ABbool		m_doRotate;
	GGVector3f	m_rotateCenter;
	GGVector3f	m_rotate;
	
	GLuint		m_textureName;

	ABbool		m_visible;

private:
	GGRender*					m_render;
	GGPrimitiveGroupListIt		m_groupIt;
	GGPrimitiveListIt			m_primitiveIt;
	ABuint						m_premitivNumber;
	ABbool						m_setup;
	ABbool						m_setupGroup;
	
public:
	GGSprite( void );
	virtual ~GGSprite( void );

	//	O[vݒ
	virtual ABbool	setGroup( GGPrimitiveGroupListIt&  inIt );
	
	//	O[v擾
	virtual GGPrimitiveGroupListIt&		getGroup( void );
	
	//	setup
	//		\OɕKs邱
	virtual ABbool		setup( GGPrimitiveGroupListIt&  inIt, ABbool  inZorder );
	
	//	cleanup
	virtual void		cleanup( void );
	
	//	_[XV
	virtual ABbool		update( void );
	
	inline void	setNumber( ABuint  inNmmber ){
		this->m_premitivNumber = inNmmber;
	}
	inline ABuint	getNumber( void ){
		return	this->m_premitivNumber;
	}
};


#endif	GGSprite_h
