/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GGText.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GGText_h
#define	GGText_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<vector>

#include 	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"GGTexture.h"
#include	"GGSprite.h"

#include	"CWorkerConfig.h"
#include	"CWGameTextService.h"
#include	"GTSTextBox.h"
#include	"GTSTextStyle.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	GGFont
//
//		tHg̓rbg}bveNX`ƂėpӂSURFACE͈̔͂I邽߂̏B
//		ASCIIR[hSURFACẼC[WƂv悤Ȕz쐬A
//		ɃXvCgɓK؂ȃZ蓖ĂB
//		ѕ͒ʏPōςނ̂ŁASURFACE͕ĂB
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GGFont
{
public:
	typedef	struct{
		ABint	cellX;	
		ABint	cellY;
		bool	enable;
		
		void clean( void ){
			cellX = 0;
			cellY = 0;
			enable = false;
		}

	}	MFont;
	typedef	std::vector<MFont>	MFontTable;
	MFontTable		fontTable;
	
	ABint			mSurfaceOffsetX;
	ABint			mSurfaceOffsetY;
	ABuint32		mCellWidth;			//	Z̑傫
	ABuint32		mCellHeight;		//	Z̑傫

public:
	GGFont( void ){
		MFont	font;
		font.clean();
		this->fontTable.resize( 256, font );	//	256
		mSurfaceOffsetX = 0;
		mSurfaceOffsetY = 0;
		mCellWidth = 0;
		mCellHeight = 0;
	}
	~GGFont( void ){
	};

	//	set font table
	void	setFontTable( ABuint8  inAsciiCode, MFont&  inFont ){
		inFont.enable = true;
		this->fontTable[ inAsciiCode ] = inFont;
	}
	//	get font
	MFont*	getFontTable( ABuint8  inAsciiCode ){
		return	&(this->fontTable[ inAsciiCode ]);
	}
};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	GGText
//
//		EOS̋@\gpĕ`悷eLXg\BjR[hΉB
//		ẼNXgpătHgpeNX`𐶐邱Ƃł܂B
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GGText
{
public:
	//	setup()̑Oɏ邱
	GGSprite			mSprite;	//	XvCgBeLXg{bNX̑傫A\ʒuȂǂ͂̃XvCg{Ƃ܂
									//	ZbgAbvOɗ\ߐݒ肵ĂKv܂B

	ABint8*			mFontName;		//	tHg
	ABfloat32		mFontSize;		//	TCYipointwj
	GEtextAlignX	mAlignX;		//	
	GEtextAlignY	mAlignY;		//	
	ABbool			mUntiAliasing;	//	A`GAVOiL̎́AVXeݒ̃tHgTCYݒ̉e󂯂܂j
	GEfontStyle		mFontStyle;		//	
	ABbool			mUseBackColor;
	GGColor4f		mBackColor;		//	
	ABbool			mSoftReturn;	//	sH

private:
	GGTexture			mSurface;	//	eNX``悷邽߂SURFACE
	
	code_worker::GTSTextBox			mTextBox;
	code_worker::GTSTextStyle		mStyle;

public:
	GGText( void );
	~GGText( void );
	
	//	`
	ABbool	setup( void );
	
	//	`I
	void	cleanup( void );

	//	ݒeXV
	//ABbool	update( void );
	
	//	`悷
	ABbool	draw( GEunicodeTextPtr  inText );

	//	eNX`擾
	GGTexture*	getTexture( void ){
		return	&this->mSurface;
	}
};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	GGText
//
//		E̃XvCgňꕶ\鍂ȃeLXg\BAXL[R[hpB
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GGTextSprite
{
public:
	//	setup()̑Oɏ邱
	ABuint			mTextLengthMax;	//	ő啶
	GGVector3f		mLocate;		//	`Jnʒu
	ABfloat32		mWidth;			//	P̃XvCgTCY
	ABfloat32		mHeight;		//	P̃XvCgTCY
	GGFont*			mFont;			//	tHg
	GGTexture*		mSurface;		//	tHgpeNX`
	GGColor4f		mColor;
	
	ABbool			mVisible;
	
private:
	typedef	std::vector<GGSprite>	MSpriteArray;
	typedef	MSpriteArray::iterator	MSpriteArrayIt;

	//	text
//	ABint8*			mText;
	MSpriteArray	mSpriteArray;	//	XvCgz

public:
	GGTextSprite( void );
	~GGTextSprite( void );

	//	XvCgZbgAbv
	ABbool	setup( GGPrimitiveGroupListIt&  inIt, ABbool  inZorder );
	
	//	XvCgN[ibv
	void	cleanup( void );
	
	//	ݒeXV
	//ABbool	update( void );
	
	//	`悷iXvCgzuj
	ABbool	draw( ABint8*  inText );
	
	//	XvCg擾
	GGSprite*	getSprite( ABuint  inNumber );

	//	XvCgB
	void	setVisible( ABbool  inVisible );
	
	//	FύX
	void	updateColor( void );
	
};


#endif	GGText_h
