/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GGTexture.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GGTexture_h
#define	GGTexture_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
//	AB
#include	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"GameEngine.h"

class	GameFileInfo;

//	CodeWorker
#include	"GMSGWorld.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GGTexture
{
private:
	code_worker::GMSGWorld		m_offScreen;
	ABbool			m_setup;
	GLuint			m_textureNumber;
	
	GDHandle		m_saveDevice;
	CGrafPtr		m_savePort;
	CGContextRef	m_currentContext;

public:
	GGTexture( void );
	virtual	~GGTexture( void );

	/////////////////////////////////////////////
	//	摜
	/////////////////////////////////////////////

	//	摜t@Cǂݍ
	ABbool		opneBitmap(	 	const GameFileInfo*				inFileInfo,				//	t@C
								const ABbool					inFixTextureSize,		//	eNX`TCYdli2̗ݏjŐ
								const GEbmpTransparentType		inTrans,				//	ߐF̑I
								const ABint						inWidth = 0,			//	쐬TCY̎w
								const ABint						inHeight = 0			//	쐬TCY̎w
							 );

	//	摜t@Calpha}XN쐬
	void		createAlphaMask( const GEbmpTransparentType  inTrans );					//	ߐF̑I
	
	//	摜t@Cj
	void		closeBitmap( void );

	//	̃obt@쐬
	ABbool		createBitmap( const ABint  inWidth, const ABint  inHeight, const GEColorDepthType  inDepth );

	/////////////////////////////////////////////
	//	`摀
	/////////////////////////////////////////////
	//	obt@NA
	void		clear( void );

	//	obt@֕`s
	CGContextRef	beginDraw( void );
	void			endDraw( void );

	//	obt@XVi݌ʂ𔽉f邽߂Ƀobt@XVKvj
	void		flushBuffer( void );

	//	obt@֕`sƂ̐Fݒ
	void		setFillColor( const ABint  inR, const ABint  inG, const ABint  inB, const ABint  inAlpha );

	//	obt@擾
	ABuint8*	getBuffer( void );

	//	obt@TCY擾
	void		getSize( ABint*  outWidth,  ABint*  outHeight );

	/////////////////////////////////////////////
	//	OpenGL
	/////////////////////////////////////////////
	//	eNX`TCY擾
	void		getTextureSize( ABint*  outWidth,  ABint*  outHeight );
	
	//	eNX`̃oCh
	ABbool	bindTexture( void );

	//	eNX`̍XV
	void	updateTexture( void );

	//	eNX`̍폜
	void	deleteTexture( void );
	
	//	eNX`ԍ擾
	inline GLuint	getTextureName( void ){
		return	this->m_textureNumber;
	}
};


#endif	GGTexture_h
