/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameAudio.cpp

				EABōœKȃTEh񋟁B
				

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GameAudio_h
#define	GameAudio_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"CWGameAudioService.h"

class	GameAudioPlayer;
class	GameFileInfo;

//	gbN̎
enum{
	GE_AUDIO_SOUND_TRACK_SINGLE_CHANNEL,		//	P̃`lgbNBBGMpB
	GE_AUDIO_SOUND_TRACK_MULTI_CHANNEL,			//	Đ閈ɐV`lBSEpB
	GE_AUDIO_SOUND_TRACK_SOUNDNUMBER_CHANNEL,	//	TEhNumberPʂŒP̃`lB
};
typedef	ABtype	GEAudioSoundTravkType;

enum{
	GE_AUDIO_SOUND_CHANNEL_COUNT				= 48,
	
	GE_AUDIO_SOUND_SINGLE_CHANNEL_TRACK_COUNT	= 4,
	GE_AUDIO_SOUND_MULTI_CHANNEL_TRACK_COUNT	= GE_AUDIO_SOUND_CHANNEL_COUNT - GE_AUDIO_SOUND_SINGLE_CHANNEL_TRACK_COUNT,
};

//	cachet@CSize
enum{
	GE_AUDIO_CACHE_FILE_SIZE = 1024 * 512,
};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	GameAudio
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GameAudio
{
private:
	GameAudioPlayer*	m_soundTrack;
	static	ABfloat32	m_masterVolume;
	ABfloat32			m_volumeBalance;

public:
	GameAudio( void );
	~GameAudio( void );
	
	//	Initialize
	ABbool	initialize( 	ABbool  inUserReverb, 
							CWsize	inCacheFileCount = 0,						//	Cachet@C
							CWsize	inMemorySize = GE_AUDIO_CACHE_FILE_SIZE,	//	Pt@C̍ő吔
							GASsampleRate  inInputSampleRate = GAS_SAMPLE_RATE_44100, 
							GASsampleChannelType  inChannelType = GAS_SAMPLE_CHANNEL_STEREO );

	//	Finalize
	void	finalize( void );
	
	//------------------------------
	//	
	//------------------------------

	//	Master{[( 0.0 - 1.0 )
	void	setMasterVolume( ABfloat32  inVol );
	
	//	Đʎw( 0.0 - 1.0 )
	void	setVolumeBalance( ABfloat32  inVol );
		
	//	SgbN~
	void	stopAllSound( void );
	
	//	gbN
	void	setSoundTrackVolume( void );
	
	//	Đ
	ABbool	playSoundTrack( GEAudioSoundTravkType  inType, ABuint  inTrackNumber, ABuint  inFileNumber );
	ABbool	stopSoundTrack( GEAudioSoundTravkType  inType, ABuint  inTrackNumber );
	
	//------------------------------
	//	Ǘ
	//------------------------------

	//	TEht@CJ
	ABbool	openSoundFile( GameFileInfo*  inFile, ABuint*  outFileNumber );
	
	//	TEht@C[CACHE
	//	EőeʂEƂēǂݍ݂܂BopenSoundFile()ŏt@CCACHEƁA傫ȃt@Colߍނ߂Ɏgp܂B
	ABbool	cashingSoundFile( ABuint  inFileNumber );
	
	//	TEht@C
	void	closeSoundFile( ABuint  inFileNumber );
	
	//------------------------------
	//	MIDIt@C
	//------------------------------
	ABbool	openSMF( GameFileInfo*  inFile );
	void	closeSMF( void );
	void	playSMF( void );
	void	stopSMF( void );

	//------------------------------
	//	
	//------------------------------
	//	TEhnhO
	//		EegbN̍Đ󋵂ǗBt[ĂԂƁB
	void	handling( void );
	
};

#endif	GameAudio_h
