/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameEngine.h

				GameEngineLayer̒`B

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GameEngine_h
#define	GameEngine_h

#include	"GlobalConfig.h"

//-------------------------------------------------------------------------------
//	XvCg̍ő吔
//		ƃptH[}Xɉe^܂B
//		ȂƃXvCg̐Ɏx𗈂̂ŁAKxȃTCY]܂łB
//-------------------------------------------------------------------------------
enum{
	GE_SPRITE_MAX	= 2048,
};

//-------------------------------------------------------------------------------
//	_OO[v
//		NbsÖI邽߂RenderO[v
//		o[̗ĂvC̈Nbv邽߂Ɏgp܂B
//		O[oȃO[vƁAË̌vRgp܂B
//-------------------------------------------------------------------------------
enum{
	ABVA_RENDER_GROUP_COUNT = 3,
};


//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
enum{
	GE_COLOR_DEPTH_8	= 8,		//	8bit	(256 gray color) indexJ[͎gpł܂B
	GE_COLOR_DEPTH_16	= 16,		//	16bit	(32657 color)
	GE_COLOR_DEPTH_32	= 32,		//	32bit	(full color)
};
typedef int	GEColorDepthType;

//-------------------------------------------------------------------------------
//	screen config structure
//-------------------------------------------------------------------------------
struct	GEScreenSetupConfig{
	//	screen size
	int	screenSizeX;
	int	screenSizeY;
	
	//	color depth
	GEColorDepthType	screenDepth;
};
typedef	struct	GEScreenSetupConfig	GEScreenSetupConfig;

//	window mode
enum{
	GE_WINDOW_SCREEN = 0,
	GE_FULL_SCREEN = 1,
};
typedef	int	GEScreenWindowType;

//	app event kind
enum{
	GE_APP_EVENT_NOTHING	= -1,

	GE_APP_EVENT_SUSPEND,
	GE_APP_EVENT_RESUME,
	GE_APP_EVENT_QUIT,
};
typedef	int	GEAppEventType;

//	message box icon type
enum{
	GE_MESSAGEBOX_ICON_NOTE		= 0,
	GE_MESSAGEBOX_ICON_CAUTION	= 1,
	GE_MESSAGEBOX_ICON_STOP		= 2,
};
typedef int	GEMessageBoxIconType;

//	message box button type
enum{
	GE_MESSAGEBOX_BUTTON_OK_ONLY	= 0,
	GE_MESSAGEBOX_BUTTON_OK_CANCEL	= 1,
};
typedef int	GEMessageBoxButtonType;
	
//	message box result type
enum{
	GE_MESSAGEBOX_CLICK_CANCEL		= 0,
	GE_MESSAGEBOX_CLICK_OK			= 1,
};
typedef int	GEMessageBoxResultType;


//-------------------------------------------------------------------------------
//	AsciiCode
//-------------------------------------------------------------------------------
enum{
	GE_ASCII_CODE_NULL		= 0x00,
	GE_ASCII_CODE_TAB		= 0x09,
	GE_ASCII_CODE_LF		= 0x0A,
	GE_ASCII_CODE_CR		= 0x0D,
};

//-------------------------------------------------------------------------------
//	Font style
//-------------------------------------------------------------------------------
enum{
	GE_FONT_NOMAL		= 0,
	GE_FONT_BOLD		= 1,
	GE_FONT_ITALIC		= 2,
};
typedef	int	GEfontStyle;
//-------------------------------------------------------------------------------
//	Font align
//-------------------------------------------------------------------------------
typedef	enum{
	GE_TEXT_ALIGN_LEFT,
	GE_TEXT_ALIGN_X_CENTER,
	GE_TEXT_ALIGN_RIGHT,
	GE_TEXT_ALIGN_X_FIT,
} GEtextAlignX;

typedef	enum {
	GE_TEXT_ALIGN_TOP,
	GE_TEXT_ALIGN_Y_CENTER,
	GE_TEXT_ALIGN_BOTTOM,
	GE_TEXT_ALIGN_Y_FIT,
} GEtextAlignY;

//-------------------------------------------------------------------------------
//	BMPߐFw
//-------------------------------------------------------------------------------
typedef	enum {
	GE_BMP_TRANSPARENT_NONE,
	GE_BMP_TRANSPARENT_ALPHA,	//	alphaC[gpē
	GE_BMP_TRANSPARENT_BLACK,	//	RGB( 0, 0, 0 )͓ɂȂ܂
	GE_BMP_TRANSPARENT_WHITE,	//	RGB( 255, 255, 255 )͓ɂȂ܂

}	GEbmpTransparentType;

//-------------------------------------------------------------------------------
//	W
//-------------------------------------------------------------------------------
typedef	struct	GGVector2f{
	ABfloat32	x, y;

	void	set( ABfloat32  inX, ABfloat32  inY ){
		x = inX;
		y = inY;
	}
} GGVector2f;

typedef	struct	GGVector3f{
	ABfloat32	x, y, z;

	void	set( ABfloat32  inX, ABfloat32  inY , ABfloat32  inZ ){
		x = inX;
		y = inY;
		z = inZ;
	}
} GGVector3f;

//-------------------------------------------------------------------------------
//	F
//-------------------------------------------------------------------------------
typedef	struct	GGColor4f{
	ABfloat32	r, g, b, a;
	
	void	set( ABint  inR, ABint  inG, ABint  inB, ABint  inAlpha ){
		r = (ABfloat32)inR / 255.0f;
		g = (ABfloat32)inG / 255.0f;
		b = (ABfloat32)inB / 255.0f;
		a = (ABfloat32)inAlpha / 255.0f;
	}
} GGColor4f;

//-------------------------------------------------------------------------------
//	`
//-------------------------------------------------------------------------------
typedef	struct	GGRecti{
	ABint		top, left, width, height;

	void	set( ABint  inLeft, ABint  inTop, ABint  inWidth, ABint  inHeight ){
		top = inTop;
		left = inLeft;
		width = inWidth;
		height = inHeight;
	}
} GGRecti;


//-------------------------------------------------------------------------------
//	^
//-------------------------------------------------------------------------------
//	jR[h
typedef	struct	GEunicode{}			*GEunicodeTextPtr;

//	jR[hi CFSTR()̂悤Ȏgp@ȂWindows̏ꍇ́Aɂ邱ƁBj
#define	GESTR(x)	(GEunicodeTextPtr)( CFSTR(x) )	

//------------------------------------------------------------------------------
//	AvP[VCxg
//------------------------------------------------------------------------------
enum{
	//	IO
	//		j[AAbvCxgɂIiVXeIɔIE܂jB
	GE_EVENT_APP_QUIT,

	//	ANeBuɂȂ܂
	GE_EVENT_APP_ACTIVATE,

	//	fBANeBuɂȂ܂
	GE_EVENT_APP_DEACTIVATE,
};
typedef	ABtype		GEeventAppType;

#endif	//GameEngine_h