/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameFile.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"GameFile.h"

//	MacOS
#include	"GEMacFileInfo.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
GameFileInfo::GameFileInfo( void )
{
	memset( &this->m_fsRef, 0, sizeof( this->m_fsRef ) );
}
GameFileInfo::GameFileInfo( const GameFileInfo&  inInfo ) throw( std::bad_alloc )
{
	if( ! this->copy( inInfo ) ){
		throw   std::bad_alloc();
	}
}
GameFileInfo::GameFileInfo( ABuint8*  inFilePath ) throw( std::bad_alloc )
{
	if( ! this->make( inFilePath ) ){
		throw   std::bad_alloc();
	}
}

GameFileInfo::GameFileInfo( const FSRef  inFSRef )
{
	this->setFSRef( inFSRef );
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
GameFileInfo::~GameFileInfo( void )
{
}

//-------------------------------------------------------------------------------------------------
//	t@CpX쐬(C String)
//-------------------------------------------------------------------------------------------------
ABbool	GameFileInfo::make( ABuint8*  inFilePath )
{
	ABbool		isDirectory;
	ABbool	ret = GEMacFileTool::getFSRefFromPath( inFilePath, &this->m_fsRef, &isDirectory );
	if( ! ret ){
		return	false;
	}
	return	true;
}


//-------------------------------------------------------------------------------------------------
//	t@CpX擾(C String)
//-------------------------------------------------------------------------------------------------
ABbool	GameFileInfo::copyPath( ABuint8*  outFilePath, const ABsize  inSize )
{
	return	GEMacFileTool::getPathFromFSRef( &this->m_fsRef, outFilePath, inSize );
}

//-------------------------------------------------------------------------------------------------
//	t@C擾(C String)
//-------------------------------------------------------------------------------------------------
void	GameFileInfo::copyName( ABint8*  outFileName, const ABsize  inSize )
{
	FSSpec	spec;
	GEMacFileTool::makeFSSpec( &this->m_fsRef, &spec );
	CopyPascalStringToC( spec.name, outFileName );
}

//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
ABbool	GameFileInfo::copy( const GameFileInfo&  inInfo )
{
	this->m_fsRef = inInfo.getFSRef();
	return	true;
}

//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
void	GameFileInfo::setFSRef( const FSRef  inFSRef )
{
	this->m_fsRef = inFSRef;
}


//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
FSRef	GameFileInfo::getFSRef( void ) const{
	return	this->m_fsRef;
}

