/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameFile.cpp

				t@C

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GameFile_h
#define	GameFile_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<iostream>
#include	<list>
#include	<vector>

#include	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"GameEngine.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	GameFileInfo
//
//		t@CNXBFSRefƂBB
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GameFileInfo
{
private:
	FSRef		m_fsRef;	

public:
	GameFileInfo( void );
	GameFileInfo( ABuint8*  inFilePath ) throw( std::bad_alloc );
	GameFileInfo( const GameFileInfo&  inInfo ) throw( std::bad_alloc );//STLɂ̓Rs[ConstructorYꂸ


	~GameFileInfo( void );

	//	t@CpX쐬(C String)
	ABbool	make( ABuint8*  inFilePath );

	//	t@CpX擾(C String)
	ABbool	copyPath( ABuint8*  outFilePath, const ABsize  inSize );

	//	t@C擾(C String)
	void	copyName( ABint8*  outFileName, const ABsize  inSize );

	//	copy
	ABbool	copy( const GameFileInfo&  inInfo );

	//	̊֐GameEngineLayerł̂ݎgp
	GameFileInfo( const FSRef  inFSRef );
	void	setFSRef( const FSRef  inFSRef );
	FSRef	getFSRef( void ) const;

};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	GameFileInfoList
//
//		t@CNX̃XgB
//
//////////////////////////////////////////////////////////////////////////////////////////////////
typedef	std::list< GameFileInfo >		GameFileInfoList;
typedef	GameFileInfoList::iterator		GameFileInfoListIt;
typedef	std::vector< GameFileInfo >		GameFileInfoArray;
typedef	GameFileInfoArray::iterator		GameFileInfoArrayIt;


#endif	GameFile_h
