/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameFileList.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"GameFileList.h"

#include	"GEMacFileInfo.h"

using namespace std;

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
GameFileList::GameFileList( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
GameFileList::~GameFileList( void )
{
	this->m_fileDataArray.clear();
	
	GameFileInfoListIt	it;
	for( it = this->m_fileList.begin(); it != this->m_fileList.end(); it++ ){
		GameFileInfo*	info = &(*it);
	}
	
	this->m_fileList.clear();
}

//-------------------------------------------------------
//	 wDirectorỹt@CW
//-------------------------------------------------------
ABbool	GameFileList::collectFilInfo( ABint8*  inRootPath, ABbool  inFolderOnly )
{
	ABbool			result;
	MFileData		fileData;

	this->m_fileCount = 0;
	
	this->m_fileList.clear();
	this->m_fileDataArray.clear();
	
	result = this->m_root.make( (ABuint8*)inRootPath );
	if( ! result ){ return false; }
	
	FSRef		ref = this->m_root.getFSRef();
	OSErr	err = GEMacFileTool::collectDirectoryItems( &ref, 
											&this->m_fileList, 
											AB_SCAN_FILE_ITEM_COUNT, &this->m_changeFlag, inFolderOnly );
	if( err != noErr ){ return false; }
	
	for( GameFileInfoListIt it = this->m_fileList.begin(); it != this->m_fileList.end() ; it++ ){
		fileData.live = true;
		fileData.userValue = 0;
		fileData.it = it;
		this->m_fileDataArray.push_back( fileData );
	}
	return	true;
}

//-------------------------------------------------------
//	get count
//-------------------------------------------------------
ABint		GameFileList::getCount( void )
{
	return	this->m_fileList.size();
}

//-------------------------------------------------------
//	get info
//-------------------------------------------------------
GameFileInfo*		GameFileList::getInfo( ABint  inNumber )
{
	return	&( *this->m_fileDataArray[ inNumber ].it );
}

//-------------------------------------------------------
//	enable / desable info
//-------------------------------------------------------
void		GameFileList::setLive( ABint  inNumber, ABbool  inLive )
{
	this->m_fileDataArray[inNumber].live = inLive;
}

//-------------------------------------------------------
//	enable / desable info
//-------------------------------------------------------
ABbool		GameFileList::getLive( ABint  inNumber )
{
	return	this->m_fileDataArray[inNumber].live;
}

//-------------------------------------------------------
//	set user value
//-------------------------------------------------------
void		GameFileList::setUserValue( ABint  inNumber, ABuint32  inUserValue )
{
	this->m_fileDataArray[inNumber].userValue = inUserValue;
}

//-------------------------------------------------------
//	get user value
//-------------------------------------------------------
ABuint32		GameFileList::getUserValue( ABint  inNumber )
{
	return	this->m_fileDataArray[inNumber].userValue;
}
