/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameJoystick.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"GameJoystick.h"

//	MacOS
#include	"CWorkerConfig.h"				//	CodeWorker
#include	"CWGameInputService.h"			//	GIS
#include	"CWGameInputServiceTool.h"		//	GIST

//-------------------------------------------------------------------------------------------------
//	TriggerMapper
//		WCXeBbNDefaultݒB
//-------------------------------------------------------------------------------------------------
GISTTriggerMapper	GameJoystick::m_triggerMapper[] = 
{
	//	@ABJoystickTrriger@ƑSсAłȂ΂Ȃ܂B

	//----------------------------
	//	ݒύXs\gK[
	//----------------------------
	//	AB_TRRIGER_MENU_UP,					//	menuI@gK[
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardUpArrow,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_MENU_DOWN,				//	menuI@gK[
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardDownArrow,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_MENU_LEFT,				//	menuI@gK[
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardLeftArrow,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_MENU_RIGHT,				//	menuI@EgK[
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardRightArrow,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},

	//	AB_TRRIGER_MENU_SELECT,				//	menuI@gK[
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardReturnOrEnter,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_MENU_CANCEL,				//	menuI@LZgK[
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardEscape,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	
	//----------------------------
	//	ݒύX\gK[
	//----------------------------
	//	AB_TRRIGER_BUTTON_START,			//	X^[g{^
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_Keyboard1,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//AB_TRRIGER_BUTTON_EFFECT,			//	GtFNg{^

	//	1Plaler side


	//	2Player side
	//	AB_TRRIGER_BUTTON_1,				//	 1	 1
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardZ,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_2,				//	 2	 2
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardS,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_3,				//	 3	 3
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardX,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_4,				//	 4	 4
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardD,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_5,				//	 5	 5
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardC,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},

	//	AB_TRRIGER_BUTTON_6,				//	 6	 6
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardF,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_7,				//	 7	 7
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardV,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},

	//	AB_TRRIGER_BUTTON_TRUN_L,			//	XNb`]
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardLeftShift,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_TRUN_R,			//	XNb`E]
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardSpacebar,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},

	//	2Player side
	//	AB_TRRIGER_BUTTON_1,				//	 1	 1
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardM,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_2,				//	 2	 2
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardK,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_3,				//	 3	 3
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardComma,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_4,				//	 4	 4
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardL,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_5,				//	 5	 5
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardPeriod,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},

	//	AB_TRRIGER_BUTTON_6,				//	 6	 6
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardSemicolon,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_7,				//	 7	 7
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardSlash,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},

	//	AB_TRRIGER_BUTTON_TRUN_L,			//	XNb`]
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardN,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
	//	AB_TRRIGER_BUTTON_TRUN_R,			//	XNb`E]
	{
		kHIDPage_GenericDesktop,	kHIDUsage_GD_Keyboard,
		GIS_ELEMENT_TYPE_INPUT,		kHIDPage_KeyboardOrKeypad,	kHIDUsage_KeyboardRightShift,
		GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE,
	},
};

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
GameJoystick::GameJoystick( void )
{
	this->m_trrigerMapRef = NULL;
	this->flushState();
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
GameJoystick::~GameJoystick( void )
{
	if( this->m_trrigerMapRef ){
		//	GIST TriggerMappiYƃ[N܂j
		GISTReleaseTriggerMap( this->m_trrigerMapRef );

		//	GIS FINALIZE
		GISFinalize();
	}
}

//-------------------------------------------------------------------------------------------------
//	setup trigger
//-------------------------------------------------------------------------------------------------
ABbool	GameJoystick::setup( void )
{
	bool			result	= false;
	CWresultCode	err		= CW_NO_ERROR;

	//	zgK[̒`
	#define			triggerCount2		2
	#define			triggerCount3		3
	CWuint32		virtualTrigger[ AB_V_TRRIGER_COUNT ][ triggerCount3 ] = 
	{
		{ AB_TRRIGER_MENU_LEFT, AB_TRRIGER_P1_BUTTON_TRUN_L, 0 },	//	AB_V_TRRIGER_MENU_LEFT,				//	menuI@gK[( AB_TRRIGER_MENU_LEFT or AB_TRRIGER_BUTTON_TRUN_L )
		{ AB_TRRIGER_MENU_RIGHT, AB_TRRIGER_P1_BUTTON_TRUN_R, 0 },	//	AB_V_TRRIGER_MENU_RIGHT,			//	menuI@EgK[( AB_TRRIGER_MENU_RIGHT or AB_TRRIGER_BUTTON_TRUN_R )
		
		{ AB_TRRIGER_MENU_SELECT, AB_TRRIGER_P1_BUTTON_1, AB_TRRIGER_BUTTON_START },	//	AB_V_TRRIGER_MENU_SELECT,			//	menuI@gK[( AB_TRRIGER_MENU_SELECT or AB_TRRIGER_BUTTON_START )
	};

	do{
		if( this->m_trrigerMapRef ){
			GISTReleaseTriggerMap( this->m_trrigerMapRef );
		}

		//	GIS INITILIZE
		err = GISInitialize();
		ABTestBreakReportError( err != CW_NO_ERROR, "GISInitialize" );

		//	GIST TriggerMap쐬
		err = GISTCreateTriggerMap( this->m_triggerMapper, CWGetArrayCount( GISTTriggerMapper, this->m_triggerMapper ), &this->m_trrigerMapRef );
		ABTestBreakReportError( err != CW_NO_ERROR, "GISTCreateTriggerMap" );
		
		//	GIST zgK[쐬
		err = GISTCreateVirtualTrigger( this->m_trrigerMapRef, AB_V_TRRIGER_COUNT );
		ABTestBreakReportError( err != CW_NO_ERROR, "GISTCreateVirtualTrigger" );

		//	GIST zgK[ɁAgK[蓖Ă
		//	zgK[ԍ GISTVirtualTriggerNumber()ň͂܂Ȃ΂Ȃ܂B
		err = GISTMappingVirtualTrigger( this->m_trrigerMapRef, GISTVirtualTriggerNumber( AB_V_TRRIGER_MENU_LEFT ), virtualTrigger[AB_V_TRRIGER_MENU_LEFT], triggerCount2 );
		ABTestBreakReportError( err != CW_NO_ERROR, "GISTMappingVirtualTrigger > AB_V_TRRIGER_MENU_LEFT" );
		err = GISTMappingVirtualTrigger( this->m_trrigerMapRef, GISTVirtualTriggerNumber( AB_V_TRRIGER_MENU_RIGHT ), virtualTrigger[AB_V_TRRIGER_MENU_RIGHT], triggerCount2 );
		ABTestBreakReportError( err != CW_NO_ERROR, "GISTMappingVirtualTrigger > AB_V_TRRIGER_MENU_RIGHT" );
		err = GISTMappingVirtualTrigger( this->m_trrigerMapRef, GISTVirtualTriggerNumber( AB_V_TRRIGER_MENU_SELECT ), virtualTrigger[AB_V_TRRIGER_MENU_SELECT], triggerCount3 );
		ABTestBreakReportError( err != CW_NO_ERROR, "GISTMappingVirtualTrigger > AB_V_TRRIGER_MENU_SELECT" );

		this->active();
	
		//	OK
		result = true;
	}while( false );

	return result;
}


//-------------------------------------------------------------------------------------------------
//	{^
//-------------------------------------------------------------------------------------------------
ABJoystickError	GameJoystick::serrchActiveElement( ABJoystickTrriger  inTrigger )
{
	ABint	result;
	
	//	ݒ҂
	result = GISTSearchActiveElement( this->m_trrigerMapRef, inTrigger, &this->m_triggerMapper[ inTrigger ], 
										GIS_ELEMENT_TYPE_INPUT, AB_TRRIGER_SEARCH_TIME_OVER, 
										true, AB_TRRIGER_MENU_CANCEL );
	switch( result ){
		case CW_GIST_USER_CANCEL_SEARCH_ELEMENT:
			//	LZ܂
			result = AB_TRRIGER_ERROR_USER_CANCEL_SEARCH_ELEMENT;
			break;
		case CW_GIST_CANCEL_SEARCH_ELEMENT_REQUIRE_UNIQUE:
			//	gK[Ŏgp̃Gg̎w͋Ȃ
			//	"It can't be chosen because it is using with another trigger."
			result = AB_TRRIGER_ERROR_CANCEL_SEARCH_ELEMENT_REQUIRE_UNIQUE;
			break;
		case CW_NO_ERROR:
			//	OK
			result = AB_TRRIGER_ERROR_NONE;
			break;
		default:
			//	̑̃G[
			result = AB_TRRIGER_ERROR;
			ABReportErrorCode( "Unkown Error", result );
			break;
	}
	return result;
}


//-------------------------------------------------------------------------------------------------
//	Restore trigger
//-------------------------------------------------------------------------------------------------
ABbool	GameJoystick::restore( void )
{
	ABint	err = CW_NO_ERROR;
	ABint	i;
	
	for( i = AB_TRRIGER_BUTTON_START ; i < AB_TRRIGER_COUNT ; i++ ){
		err = GISTResetElements( this->m_trrigerMapRef, i );
		ABTestBreakReportError( err != CW_NO_ERROR, "GISTResetElements" );
		err = GISTMappingElements( this->m_trrigerMapRef, i, &this->m_triggerMapper[ i ] );
		ABTestBreakReportError( err != CW_NO_ERROR, "GISTMappingElements" );
	}
	return	err == CW_NO_ERROR;
}


//-------------------------------------------------------------------------------------------------
//	Gĝ̖擾
//-------------------------------------------------------------------------------------------------
bool	GameJoystick::getButtonName( 
	 ABJoystickTrriger  inTrigger,
	 GameString*		outDeviceName,
	 GameString*		outElementName
){
	ABint			err = CW_NO_ERROR;
	CFStringRef		debice;
	CFStringRef		element;
	err = GISTGetElementName( this->m_trrigerMapRef, inTrigger, &debice, &element );
	ABTestReturnReportError( err != CW_NO_ERROR, "GISTGetElementName" );
	outDeviceName->copy( (GEunicodeTextPtr)debice );
	outDeviceName->copy( (GEunicodeTextPtr)element );
	
	return	err == CW_NO_ERROR;
}

//-------------------------------------------------------------------------------------------------
//	isPress
//-------------------------------------------------------------------------------------------------
ABbool	GameJoystick::isPress( ABJoystickTrriger  inTrigger )
{
	if( ! this->m_active ){
		return false;
	}
	return	GISTGetTriggerScaleValue( this->m_trrigerMapRef, inTrigger );
}

//-------------------------------------------------------------------------------------------------
//	isPush
//-------------------------------------------------------------------------------------------------
ABbool	GameJoystick::isPush( ABJoystickTrriger  inTrigger )
{
	CWbool			eventFlag = false;
	CWint32			value = 0;
	AbsoluteTime	eventTime;

	if( ! this->m_active ){
		return false;
	}
	ABint	result = GISTGetTriggerBufferValue( this->m_trrigerMapRef, inTrigger, &eventFlag, &value, &eventTime );
	return	( eventFlag && value != 0 );
}

//-------------------------------------------------------------------------------------------------
//	ԂXV܂BKxɌĂŉB
//-------------------------------------------------------------------------------------------------
void	GameJoystick::update( void )
{
	ABint	result;
	ABint	i;
	CWbool			eventFlag = false;
	CWint32			value = 0;
	AbsoluteTime	eventTime;

	this->m_state.pushAny = false;
	this->m_state.flagPushMoveUp	= false;
	this->m_state.flagPushMoveDown	= false;
	this->m_state.flagPushMoveLeft	= false;
	this->m_state.flagPushMoveRight	= false;
	
	this->m_state.flagPressMoveUp	= false;
	this->m_state.flagPressMoveDown	= false;
	this->m_state.flagPressMoveLeft	= false;
	this->m_state.flagPressMoveRight= false;

	this->m_state.flagPushSelecrt	= false;
	this->m_state.flagPushCancel	= false;

	memset( this->m_state.flagPushButtonP1, false, sizeof( this->m_state.flagPushButtonP1 ) );
	memset( this->m_state.flagPushButtonP2, false, sizeof( this->m_state.flagPushButtonP2 ) );

	if( ! this->m_active ){
		return ;
	}

	//	Push ?
	result = GISTGetTriggerBufferValue( this->m_trrigerMapRef, AB_TRRIGER_MENU_UP, &eventFlag, &value, &eventTime );
	if( eventFlag && value != 0 ){ this->m_state.flagPushMoveUp		= true;	}
	result = GISTGetTriggerBufferValue( this->m_trrigerMapRef, AB_TRRIGER_MENU_DOWN, &eventFlag, &value, &eventTime );
	if( eventFlag && value != 0 ){ this->m_state.flagPushMoveDown	= true;	}

	result = GISTGetTriggerBufferValue( this->m_trrigerMapRef, GISTVirtualTriggerNumber( AB_V_TRRIGER_MENU_LEFT ), &eventFlag, &value, &eventTime );
	if( eventFlag && value != 0 ){ this->m_state.flagPushMoveLeft	= true;	}
	result = GISTGetTriggerBufferValue( this->m_trrigerMapRef, GISTVirtualTriggerNumber( AB_V_TRRIGER_MENU_RIGHT ), &eventFlag, &value, &eventTime );
	if( eventFlag && value != 0 ){ this->m_state.flagPushMoveRight	= true;	}
	
	result = GISTGetTriggerBufferValue( this->m_trrigerMapRef, GISTVirtualTriggerNumber( AB_V_TRRIGER_MENU_SELECT ), &eventFlag, &value, &eventTime );
	if( eventFlag && value != 0 ){ this->m_state.flagPushSelecrt	= true;	}
	result = GISTGetTriggerBufferValue( this->m_trrigerMapRef, AB_TRRIGER_MENU_CANCEL, &eventFlag, &value, &eventTime );
	if( eventFlag && value != 0 ){ this->m_state.flagPushCancel		= true;	}

	this->m_state.pushAny |= this->m_state.flagPushMoveUp;
	this->m_state.pushAny |= this->m_state.flagPushMoveDown;
	this->m_state.pushAny |= this->m_state.flagPushMoveLeft;
	this->m_state.pushAny |= this->m_state.flagPushMoveRight;
	this->m_state.pushAny |= this->m_state.flagPushCancel;

	for( i = 0 ; i < AB_TRRIGER_STATE_BUTTON_COUNT; i ++ ){
		result = GISTGetTriggerBufferValue( this->m_trrigerMapRef, AB_TRRIGER_MENU_CANCEL, &eventFlag, &value, &eventTime );
		if( eventFlag && value != 0 ){ this->m_state.flagPushButtonP1[ AB_TRRIGER_P1_BUTTON_1 + i ]		= true; }

		result = GISTGetTriggerBufferValue( this->m_trrigerMapRef, AB_TRRIGER_MENU_CANCEL, &eventFlag, &value, &eventTime );
		if( eventFlag && value != 0 ){ this->m_state.flagPushButtonP2[ AB_TRRIGER_P2_BUTTON_1 + i ]		= true; }

		this->m_state.pushAny |= this->m_state.flagPushButtonP1[ AB_TRRIGER_P1_BUTTON_1 + i ];
		this->m_state.pushAny |= this->m_state.flagPushButtonP2[ AB_TRRIGER_P1_BUTTON_1 + i ];
	}

	//	Press ?
	this->m_state.flagPressMoveUp	= ( 0 != GISTGetTriggerValue( this->m_trrigerMapRef, AB_TRRIGER_MENU_UP ) );
	this->m_state.flagPressMoveDown	= ( 0 != GISTGetTriggerValue( this->m_trrigerMapRef, AB_TRRIGER_MENU_DOWN ) );
	this->m_state.flagPressMoveLeft	= ( 0 != GISTGetTriggerValue( this->m_trrigerMapRef, GISTVirtualTriggerNumber( AB_V_TRRIGER_MENU_LEFT ) ) );
	this->m_state.flagPressMoveRight= ( 0 != GISTGetTriggerValue( this->m_trrigerMapRef, GISTVirtualTriggerNumber( AB_V_TRRIGER_MENU_LEFT ) ) );

	for( i = 0 ; i < AB_TRRIGER_STATE_BUTTON_COUNT; i ++ ){
		this->m_state.flagPressButtonP1[ i ] = ( 0 != GISTGetTriggerValue( this->m_trrigerMapRef, AB_TRRIGER_P1_BUTTON_1 + i ) );
		this->m_state.flagPressButtonP2[ i ] = ( 0 != GISTGetTriggerValue( this->m_trrigerMapRef, AB_TRRIGER_P2_BUTTON_1 + i ) );
	}
}


//-------------------------------------------------------------------------------------------------
//	݂̏ԂQƂ܂
//-------------------------------------------------------------------------------------------------
ABTriggerState&		GameJoystick::getState( void )
{
	return	this->m_state;
}


//-------------------------------------------------------------------------------------------------
//	݂̏ԂFLASH()܂
//-------------------------------------------------------------------------------------------------
void	GameJoystick::flushState( void ) 
{
	GISFlashDeviceEvent();
	memset( &this->m_state, 0, sizeof( this->m_state ) );
}

//-------------------------------------------------------------------------------------------------
//	ݒVACY
//-------------------------------------------------------------------------------------------------
ABbool	GameJoystick::serialize( void*  outBuffer, ABsize*  outSize )
{
	CWresultCode	result;
	result = GISTSerialize( this->m_trrigerMapRef, (GISTSerializeBuffer*)outBuffer, outSize );
	ABTestReturnReportError( result != CW_NO_ERROR, "Serialize Error" );
	return	true;
}

//-------------------------------------------------------------------------------------------------
//	ݒfVACY
//-------------------------------------------------------------------------------------------------
ABbool	GameJoystick::deserialize( const void*  inBuffer, const ABsize  inSize )
{
	CWresultCode	result;
	//	fVACY
	result = GISTDeserialize( this->m_trrigerMapRef, (GISTSerializeBuffer*)inBuffer, inSize );
	//	fVACYʂR\[ɏo
	ABDebug( GISTOutputTriggerMapInformation( this->m_trrigerMapRef ) );
	return	true;
}

