/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameJoystick.cpp

				WCXeBbN

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GameJoystick_h
#define	GameJoystick_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<iostream>
#include	<list>

#include	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"GameEngine.h"
#include	"GameString.h"

//	MacOS
#include	"CWGameInputService.h"			//	GIS
#include	"CWGameInputServiceTool.h"		//	GIST

//-------------------------------------------------------------------------------------------------
//	gK[ێ\
//		E̎QƂ͂̍\̂ōs܂
//-------------------------------------------------------------------------------------------------
enum{
	AB_TRRIGER_STATE_BUTTON_1,				//	 1	 1
	AB_TRRIGER_STATE_BUTTON_2,				//	 2	 2
	AB_TRRIGER_STATE_BUTTON_3,				//	 3	 3
	AB_TRRIGER_STATE_BUTTON_4,				//	 4	 4
	AB_TRRIGER_STATE_BUTTON_5,				//	 5	 5

	AB_TRRIGER_STATE_BUTTON_6,				//	 6	 6
	AB_TRRIGER_STATE_BUTTON_7,				//	 7	 7

	AB_TRRIGER_STATE_BUTTON_TRUN_L,			//	XNb`]
	AB_TRRIGER_STATE_BUTTON_TRUN_R,			//	XNb`E]
	
	AB_TRRIGER_STATE_BUTTON_COUNT,
};

typedef struct ABTriggerState{

	//	Push
	ABbool	flagPushMoveUp;				//@gK[
	ABbool	flagPushMoveDown;			//	gK[
	ABbool	flagPushMoveLeft;			//	gK[
	ABbool	flagPushMoveRight;			//	EgK[
	
	ABbool	flagPressMoveUp;				//@gK[
	ABbool	flagPressMoveDown;			//	gK[
	ABbool	flagPressMoveLeft;			//	gK[
	ABbool	flagPressMoveRight;			//	EgK[

	ABbool	flagPushSelecrt;			//	
	ABbool	flagPushCancel;				//	LZ

	ABbool	flagPushButtonP1[ AB_TRRIGER_STATE_BUTTON_COUNT ];	//	e{^
	ABbool	flagPushButtonP2[ AB_TRRIGER_STATE_BUTTON_COUNT ];	//	e{^

	//	Press
	ABbool	flagPressButtonP1[ AB_TRRIGER_STATE_BUTTON_COUNT ];	//	e{^
	ABbool	flagPressButtonP2[ AB_TRRIGER_STATE_BUTTON_COUNT ];	//	e{^

	//	
	ABbool	pushAny;

}	ABTriggerState;


//-------------------------------------------------------------------------------------------------
//	WCXeBbNݒ
//-------------------------------------------------------------------------------------------------
//	Trigger
enum{

	//	nɂĒӎ
	//		E{IɃ^[e[uuőł悤ɂB
	//		E^[e[uEŁAj[IB
	//		Ej[㉺̏ꍇ́AEőIł悤ɂB
	//		E㉺Ẽj[IKvȂƂ́Aǂ炩݂̂^[e[uɊ肠āA̓L[{[hƂB

	//----------------------------
	//	ݒύXs\gK[
	//----------------------------
	AB_TRRIGER_MENU_UP,					//	menuI@gK[
	AB_TRRIGER_MENU_DOWN,				//	menuI@gK[
	AB_TRRIGER_MENU_LEFT,				//	menuI@gK[
	AB_TRRIGER_MENU_RIGHT,				//	menuI@EgK[

	AB_TRRIGER_MENU_SELECT,				//	menuI@gK[
	AB_TRRIGER_MENU_CANCEL,				//	menuI@LZgK[
	
	//----------------------------
	//	ݒύX\gK[
	//----------------------------
	
	AB_TRRIGER_BUTTON_START,			//	X^[g{^

	//	ȉт́AAB_TRRIGER_STATE_BUTTON_*@ƑSł邱ƁB

	AB_TRRIGER_P1_BUTTON_1,				//	 1	 1
	AB_TRRIGER_P1_BUTTON_2,				//	 2	 2
	AB_TRRIGER_P1_BUTTON_3,				//	 3	 3
	AB_TRRIGER_P1_BUTTON_4,				//	 4	 4
	AB_TRRIGER_P1_BUTTON_5,				//	 5	 5

	AB_TRRIGER_P1_BUTTON_6,				//	 6	 6
	AB_TRRIGER_P1_BUTTON_7,				//	 7	 7

	AB_TRRIGER_P1_BUTTON_TRUN_L,		//	XNb`]
	AB_TRRIGER_P1_BUTTON_TRUN_R,		//	XNb`E]
	

	//	ȉт́AAB_TRRIGER_STATE_BUTTON_*@ƑSł邱ƁB
	
	AB_TRRIGER_P2_BUTTON_1,				//	 1	 1
	AB_TRRIGER_P2_BUTTON_2,				//	 2	 2
	AB_TRRIGER_P2_BUTTON_3,				//	 3	 3
	AB_TRRIGER_P2_BUTTON_4,				//	 4	 4
	AB_TRRIGER_P2_BUTTON_5,				//	 5	 5

	AB_TRRIGER_P2_BUTTON_6,				//	 6	 6
	AB_TRRIGER_P2_BUTTON_7,				//	 7	 7

	AB_TRRIGER_P2_BUTTON_TRUN_L,		//	XNb`]
	AB_TRRIGER_P2_BUTTON_TRUN_R,		//	XNb`E]
	
	AB_TRRIGER_COUNT,
};
typedef	ABtype		ABJoystickTrriger;

//	virtual Trigger
//	zgK[͕̃gK[P̃{^Ƀ}bv@\łBgpƁAޕł낢ȃL[܂Ȃčς݂܂B
enum{
	AB_V_TRRIGER_MENU_LEFT,				//	menuI@gK[( AB_TRRIGER_MENU_LEFT or AB_TRRIGER_BUTTON_TRUN_L )
	AB_V_TRRIGER_MENU_RIGHT,			//	menuI@EgK[( AB_TRRIGER_MENU_RIGHT or AB_TRRIGER_BUTTON_TRUN_R )
	
	AB_V_TRRIGER_MENU_SELECT,			//	menuI@gK[( AB_TRRIGER_MENU_SELECT or AB_TRRIGER_BUTTON_START )
	
	AB_V_TRRIGER_COUNT,
};
typedef	ABtype		ABJoystickVirtualTrriger;

//	GgG[
enum{
	AB_TRRIGER_ERROR_NONE = 0,	
	AB_TRRIGER_ERROR = -1,
	AB_TRRIGER_ERROR_USER_CANCEL_SEARCH_ELEMENT = -2,				//	Gg̒T[U[LZ܂B
	AB_TRRIGER_ERROR_CANCEL_SEARCH_ELEMENT_REQUIRE_UNIQUE = -3,		//	ɑTriggergpĂGgȂ̂ŁAGg̒TLZ܂B
};
typedef	ABtype		ABJoystickError;

//	Gg|[O( `bNJEg )
enum{
	AB_TRRIGER_SEARCH_TIME_OVER = 60 * 15,
};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	GameJoystick
//
//		t@CNXBFSRefƂBB
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GameJoystick
{
private:
	ABTriggerState		m_state;
	
	static GISTTriggerMapper	m_triggerMapper[]; 
	GISTTriggerMapRef			m_trrigerMapRef;
	ABbool				m_active;
	
public:
	GameJoystick( void );
	~GameJoystick( void );

	//	setup trigger
	ABbool	setup( void );

	//	{^
	//	E|[Oē͑u蓖ĂBAreSetup()Ăяoď߂ėLƂȂ܂B
	ABJoystickError	serrchActiveElement( ABJoystickTrriger  inTrigger );
	
	//	Restore trigger
	//	ύX\ȃgK[lɕ܂
	ABbool	restore( void );

	//	Gĝ̖擾
	ABbool	getButtonName( 
					 ABJoystickTrriger  inTrigger,
					 GameString*		outDeviceName,
					 GameString*		outElementName
				);

	//	isPress
	//	E̋@\SequenceřĂяoŎgp܂B
	//	EςȂ̂Ƃ͂truełBzgK[͌oł܂B
	ABbool	isPress( ABJoystickTrriger  inTrigger );

	//	isPush
	//	E̋@\SequenceřĂяoŎgp܂B
	//	EP񂾂̉o܂BzgK[͌oł܂B
	ABbool	isPush( ABJoystickTrriger  inTrigger );

	//	ԂXV܂BKxi1/60bPʁjɌĂŉB
	//	AvP[Vbackgroundɂ鎞͌Ă΂Ȃ悤ɂ܂B
	void	update( void );
	
	//	݂̏ԂQƂ܂
	ABTriggerState&		getState( void );
	
	//	݂̏ԂFLASH()܂
	//	AvP[VtgɗƂFLASHĂB
	void	flushState( void );
	
	//	ݒVACY
	//		obt@͉Ȃđv
	ABbool	serialize( void*  outBuffer, ABsize*  outSize );
	
	//	ݒfVACY
	ABbool	deserialize( const void*  inBuffer, const ABsize  inSize );

	//	WCXeBbNLɂ
	void	active( void ){
		this->flushState();
		this->m_active = true;
	}
	//	WCXeBbN𖳌ɂ
	void	deactive( void ){
		this->m_active = false;
	}
	
};

#endif	GameJoystick_h
