/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameString.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"GameString.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
GameString::GameString( void )
:
	m_ref( NULL )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
GameString::~GameString( void )
{
	this->release();
}

//-------------------------------------------------------------------------------------------------
//	C񂩂琶
//-------------------------------------------------------------------------------------------------
ABbool	GameString::setCString( const ABint8*  inStr, const ABuint32  inEncording )
{
	this->release();
	this->m_ref = CFStringCreateWithCString(NULL, inStr, inEncording );
	return	( this->m_ref != NULL ? true : false );
}

//-------------------------------------------------------------------------------------------------
//	C擾
//-------------------------------------------------------------------------------------------------
ABbool	GameString::getCString( ABint8*  outStr, const ABsize  inSize, const ABuint32  inEncording )
{
	return	CFStringGetCString( this->m_ref, outStr, inSize, inEncording );
}

//-------------------------------------------------------------------------------------------------
//	
//-------------------------------------------------------------------------------------------------
void	GameString::release()
{
	if( this->m_ref ){
		CFRelease( this->m_ref );
		this->m_ref = NULL;
	}
}

//-------------------------------------------------------------------------------------------------
//	Copy
//-------------------------------------------------------------------------------------------------
void	GameString::copy( GEunicodeTextPtr  inString )
{
	this->release();
	this->m_ref = CFStringCreateCopy(NULL, (CFStringRef)inString);
}
