/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameTextParser.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstring>


#include	"GameTextParser.h"

using namespace std;

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
GameTextParser::GameTextParser( void )
{
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
GameTextParser::~GameTextParser( void )
{
}

//-------------------------------------------------------
//	wAhXw蕶̐擪AhXԂ
//-------------------------------------------------------
char*	GameTextParser::findCompareWord
( 
	char*  		inStartPtr, 
	char*  		inKeyText,
	bool		inFullHit
)
{
	long	j;
	char*	address = inStartPtr;
	int		len = NULL;

	//	L[T
	for( j = 0 ; 0 != *(address + j) ; j++ ){
	
		if( *(address + j) == inKeyText[0] ){
			//	r
			if( inFullHit ){
				char	word[255];
				sscanf( address + j, "%255s", word );
				len = strlen(word);
			}
			else{
				len = strlen(inKeyText);
			}
			if( 0 == strncmp( address + j, inKeyText, len ) ){
				//	OK
				//cout << "findCompareWord():" << inStartPtr  << endl;	//	debug
				return	address + j;
			}
			else{
				//	no
			}
		}
		
	}
	return	NULL;
}

//-------------------------------------------------------
//	sɎw̕񂪊܂܂Ă邩
//-------------------------------------------------------
bool	GameTextParser::testFindWord
( 
	MVecTextArray::iterator&		inIt, 
	char*  						inKeyText ,
	bool		inFullHit
)
{
	return	NULL != this->findWord(inIt,inKeyText, inFullHit);
}

//-------------------------------------------------------
//	s猟AhXԂ
//-------------------------------------------------------
char*	GameTextParser::findWord
( 
	MVecTextArray::iterator&		inIt, 
	char*  						inKeyText ,
	bool		inFullHit 
)
{
	return	this->findCompareWord( *inIt, inKeyText, inFullHit );
}

//-------------------------------------------------------
//	݂̑s
//-------------------------------------------------------
bool GameTextParser::findRow
( 
	MVecTextArray*				inArray,
	MVecTextArray::iterator&	inFirstIt, 
	char*  						inKeyText 
)
{
	bool	flag = false;
	while( inFirstIt != inArray->end() ){
				
		//	
		if( this->testFindWord( inFirstIt, inKeyText ) ){
			//	OK
			flag = true;
			break;
		}
		//	next
		++inFirstIt;
	}
	return flag;
}

//-------------------------------------------------------
//	eLXgobt@szɕ
//-------------------------------------------------------
void GameTextParser::sliceRows( char*	inTextBuffer, unsigned long inSize, MVecTextArray*  outArray )
{
	long	pos		= 0;
	long	nextpos	= 0;
	char	c1, c2;
	bool	flagPush;
	char*	headPtr;
	int		addPoint;

	outArray->clear();
	
	while( pos < inSize ){

		headPtr = &inTextBuffer[ pos ];
		flagPush = true;
		while( pos < inSize ){

			//	return code ?
			c1 = inTextBuffer[ pos ];
			if( pos + 1 < inSize ){
				c2 = inTextBuffer[ pos + 1 ];
			}
			else{
				c2 = 0;
			}
			
			//	return code check
			addPoint = this->skipReturnCode( c1, c2 );
			if( addPoint == 0 ){
				//	continue
				++pos;
				continue;
			}
			else{
				//	slice
				nextpos = pos + addPoint;
			}

			//	next row
			inTextBuffer[ pos ] = 0;	//	ƌ̂߂ɍsĂ
			pos = nextpos;
			break;
		}

		if( flagPush ){
			//	svȕ̔r
			{
				char*	adress;
				int		charCount;
				int		lookPos;

				//	Rgr
				lookPos = 0;
				adress = headPtr;
				while( *( adress + lookPos ) != 0 ){
					c1 = *( adress + lookPos );
					c2 = *( adress + lookPos + 1);
					if( c1 == '/' && c2 == '/' ){
						*(adress + lookPos) = 0;
						break;
					}
					++lookPos;
				}
				
				//	Tab, spacê݂̍sr
				lookPos		= 0;
				charCount	= 0;
				adress		= headPtr;
				while( *(adress + lookPos ) != 0 ){
					c1 = *( adress + lookPos );
					if( c1 != ' ' && c1 != GE_ASCII_CODE_TAB ){
						++charCount;
					}
					++lookPos;
				}
				if( charCount == 0 || lookPos == 0 ){
					headPtr = NULL;
					//cout << "      -clear-" << endl;
				}
				
			}

			if( headPtr != NULL ){
				//	s̐擪AhXi[
				outArray->push_back( headPtr );
				
				//cout << "-line-" << headPtr << endl;
			}
		}
	}
}

int GameTextParser::skipReturnCode( char	c1, char	c2 )
{
	//	return code check
	if( c1 == GE_ASCII_CODE_CR && c2 == GE_ASCII_CODE_LF ){
		//	windows text file
		return	2;
	}
	else if( c1 == GE_ASCII_CODE_LF ){
		//	Unix text file
		return	1;
	}
	else if( c1 == GE_ASCII_CODE_CR ){
		//	mac text file
		return	1;
	}
	else{
		return	0;
	}
}



//-------------------------------------------------------
//	t@Cobt@ɓǂݍ
//-------------------------------------------------------
bool GameTextParser::readFileToBuffer( char*  inFilePath, char**  outBuffer, unsigned int*  outBufferSize )
{
	bool			result = false;
	unsigned int	fileSize;
	ifstream		outFile;

	outFile.open( inFilePath, ios::in | ios::binary);
	if( ! outFile.is_open() ){
		return result;
	}
	do{
		ifstream::pos_type	pos = outFile.tellg();
		outFile.seekg( 0, ios::end ) ;
		fileSize = (unsigned int)outFile.tellg();
		outFile.seekg( 0, ios::beg ) ;
		outFile.setstate( ios::goodbit );
		++fileSize;

		*outBuffer = (char*)malloc( fileSize );
		if( *outBuffer == NULL ){
			break;
		}
		outFile.read( *outBuffer, fileSize );
		*( *outBuffer + fileSize - 1) = 0;	//	Ô
		
		*outBufferSize = fileSize;
		result = true;
	}while(false);
	outFile.close();
	
	return result;
}
//-------------------------------------------------------
//	obt@t@Cɏ
//-------------------------------------------------------
bool GameTextParser::writeFileToBuffer( char*  inFilePath, char*  outBuffer )
{
	bool	result = false;
	
	do{
		ofstream		outFile;
		
		outFile.open( inFilePath, ios::out | ios::app);
		if( ! outFile.is_open() ){
			break;
		}
		
		outFile.write( outBuffer, strlen( outBuffer ));
		outFile.close();
		
		result = true;
	}while(false);
	
	return result;
}

//-------------------------------------------------------
//	obt@
//-------------------------------------------------------
void GameTextParser::releaseFileBuffer( char*  inBuffer )
{
	free( inBuffer );
}
