/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameTextParser.cpp

				eLXgParserx
				Ascii ܂ Shif-JIS I[

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GameTextParser_h
#define	GameTextParser_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	<vector>

#include	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"GameEngine.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS	GameTextParser
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GameTextParser
{
public:
	typedef	std::vector<char*>			MVecTextArray;	//	obt@̍s̐擪obt@i[
	typedef	MVecTextArray::iterator		MVecTextArrayIt;

public:
	GameTextParser( void );
	~GameTextParser( void );

	//	wAhXw蕶AAhXԂ
	char*	findCompareWord
	( 
		char*  		inStartPtr, 
		char*  		inKeyText,
		bool		inFullHit = false
	);

	//	sɎw̕񂪊܂܂Ă邩
	//	true 	: L
	//	false 	: 
	bool	testFindWord
	( 
		MVecTextArray::iterator&	inIt, 
		char*  						inKeyText,
		bool						inFullHit = false
	);

	//	sw̕AhXԂ
	char*	findWord
	( 
		MVecTextArray::iterator&	inIt, 
		char*  						inKeyText ,
		bool						inFullHit = false
	);

	//	݂̑s
	bool	findRow
	( 
		MVecTextArray*				inArray,
		MVecTextArray::iterator&	inFirstIt, 
		char*  						inKeyText 
	);

	//	eLXgobt@szɕ
	void sliceRows( char*	inTextBuffer, unsigned long inSize, MVecTextArray*  outArray );
	
	int skipReturnCode( char	c1, char	c2 );

public:
	//	t@Cobt@ɓǂݍ(obt@쐬܂)
	static	bool readFileToBuffer( char*  inFilePath, char**  outBuffer, unsigned int*  outBufferSize );
	//	obt@t@Cɏ
	static	bool writeFileToBuffer( char*  inFilePath, char*  outBuffer );
	//	obt@(readFileToBufferŎgpIĂԂ)
	static	void releaseFileBuffer( char*  inBuffer );
	
};

#endif	GameTextParser_h
