/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameTimer.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"OSConfig.h"
#include	"GameTimer.h"

//-------------------------------------------------------------------------------------------------
//	Update frame rate
//-------------------------------------------------------------------------------------------------
void	GameTimer::updateFrameRate( void )
{
	GameTimer::frameRate( true );
}

//-------------------------------------------------------------------------------------------------
//	get frame rate
//-------------------------------------------------------------------------------------------------
CWfloat64	GameTimer::getFrameRate( void )
{
	return	GameTimer::frameRate( false );
}

//-------------------------------------------------------------------------------------------------
//	wait 
//-------------------------------------------------------------------------------------------------
void		GameTimer::wait( ABint  inTicCount )
{
	//	--> MAC OS ONLY
	#ifdef		OS_COMPILE_MAC_OS_X
		Delay( inTicCount, NULL  );
	#endif		OS_COMPILE_MAC_OS_X
	//	<-- MAC OS ONLY
}

//-------------------------------------------------------------------------------------------------
//	t[[ǧvZƎ擾
//-------------------------------------------------------------------------------------------------
CWfloat64	GameTimer::frameRate( ABbool  update )
{
	static CWint32	 		frames		= 0;
	static AbsoluteTime 	time		= {0,0};
	static CWfloat64		framerate	= 0;

	if( update ){
		AbsoluteTime		currTime = UpTime ();
		double				deltaTime = (float) AbsoluteDeltaToDuration (currTime, time);
		if( 0 > deltaTime ){
			// if negative microseconds
			deltaTime /= -1000000.0;
		}
		else{
			// else milliseconds
			deltaTime /= 1000.0;
		}

		frames++;

		if( 0.5 <= deltaTime ){
			framerate = ((CWfloat64)frames / deltaTime);
			time = currTime;	// reset for next time interval
			frames = 0;
		}
	}

	return	framerate;
}

