/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GameView.cpp

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#include	"GameView.h"
#include	"GameSingleton.h"

//-------------------------------------------------------------------------------------------------
//	Constructor
//-------------------------------------------------------------------------------------------------
GameView::GameView( ABView&  inView )
:
	m_abView( inView )
{
	GameGetSingleton().m_gameView = this;
}

//-------------------------------------------------------------------------------------------------
//	Destructor
//-------------------------------------------------------------------------------------------------
GameView::~GameView( void )
{
}

//-------------------------------------------------------------------------------------------------
//	initialize
//-------------------------------------------------------------------------------------------------
CWbool			GameView::onInit( void )
{
	CWbool	ret = this->m_abView.initialize();
	if( !ret ){
		return	ret;
	}
	return	ret;
}

//-------------------------------------------------------------------------------------------------
//	finalize
//-------------------------------------------------------------------------------------------------
void			GameView::onFinal( void )
{
	this->m_abView.finalize();
}

//-------------------------------------------------------------------------------------------------
//	change screen mode
//-------------------------------------------------------------------------------------------------
void			GameView::onChangeScreenMode( CWbool  inTrueIsFullScreenMode )
{
	this->m_abView.changeScreenMode( inTrueIsFullScreenMode );
}

//-------------------------------------------------------------------------------------------------
//	`ƃ_[ƃXbv
//-------------------------------------------------------------------------------------------------
CWbool			GameView::onDraw( void )
{
	CWuint32  width, height;
	this->getCurrentViewSize( &width, &height );
	return	this->m_abView.draw( width, height );
}

//-------------------------------------------------------------------------------------------------
//	`̈XV
//-------------------------------------------------------------------------------------------------
void			GameView::onReshape( void )
{
	CWuint32  width, height;
	this->getCurrentViewSize( &width, &height );
	this->m_abView.reshape( width, height );
}

//-------------------------------------------------------------------------------------------------
//	AvP[VCxgɌĂт܂
//-------------------------------------------------------------------------------------------------
ABbool	GameView::onAppEvent( const GVSeventApp  inEvent )
{
	ABbool	ret = true;		//	̃Cxgp
		
	switch( inEvent ){
		//	IO
		//		j[AAbvCxgɂIiVXeIɔIE܂jB
		case GVS_EVENT_APP_QUIT:
			ret = this->m_abView.appEvent( GE_EVENT_APP_QUIT );
			break;

		//	ANeBuɂȂ܂
		case GVS_EVENT_APP_ACTIVATE:
			ret = this->m_abView.appEvent( GE_EVENT_APP_ACTIVATE );
			break;

		//	fBANeBuɂȂ܂
		case GVS_EVENT_APP_DEACTIVATE:
			ret = this->m_abView.appEvent( GE_EVENT_APP_DEACTIVATE );
			break;
	}

	return	ret;
}
