/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GEMacFileInfo.cpp

				MacOS FileSpec, FileRef

	Encoding:	Shift-JIS

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GEMacFileInfo_h
#define	GEMacFileInfo_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"OSConfig.h"
#include	"GlobalConfig.h"
#include	"GameEngine.h"

#include	"GameFile.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	Class GEMacFileTool
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GEMacFileTool
{
public:
	GEMacFileTool( void );
	~GEMacFileTool( void );

	//	Directorỹt@CW
	static OSErr	collectDirectoryItems(
				const FSRef*			container,			//	TDirectory
				GameFileInfoList*		fsInfoArray,		//	Wt@C
				int						maxSize,			//	Wő吔
				bool*					containerChanged,	//	ύXĂƂtrueԂ
				bool					directoryOnly		//	WΏ
			);

	//	fullpath -> FSRef (use file open)
	static bool	getFSRefFromPath(
								UInt8 	*path,
								FSRef	*fileRefPtr,
								bool	*isDirectory );

	//	FSRef -> fullpath 
	static bool	getPathFromFSRef(
							FSRef	*fileRefPtr,
							UInt8*	path,
							UInt32 	maxPathSize );

	//	fullpath -> FSSpec (use file open)
	static bool	getFSSpecFromPath(
								UInt8 	*path,
								FSSpec*	fileSpecPtr,
								bool	*isDirectory
							);

	//	FSSpec -> fullpath
	static bool	getPathFromFSSpec(
								FSSpec*	fileSpecPtr,
								UInt8 *path,
								UInt32 maxPathSize
							);

	//	FSSpec -> FSRef
	static OSErr	getFSRefFromFSSpec(
								FSSpec*	fileSpecPtr,
								FSRef *ref 
							);

	//	makeFSRef
	static OSErr	makeFSRef(
								FSVolumeRefNum		volRefNum,
								SInt32				dirID,
								ConstStr255Param	name,
								FSRef *ref 
							);

	//	makeFSSpec
	static OSErr	makeFSSpec(
		const FSRef*	ref,
		FSSpec*			spec );
};


#endif	GEMacFileInfo_h
