//	GVSApplication

#include <Carbon/Carbon.h>
#include <stdio.h>

#include	"GameEngineConfig.h"
#include	"GUIApp.h"

SInt32	GUIApp::ms_physicalMemorySize = 1024 * 1024 * 512;

//------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
GUIApp::GUIApp( GUIView&  inView )
 : 
 m_view( inView )
{
	m_value = 100;
	m_view.m_guiapp = this;
}

//------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
GUIApp::~GUIApp( void )
{
}

//------------------------------------------------------------------------------
//	
//------------------------------------------------------------------------------
CWbool	GUIApp::initialize( void )
{
	CWresultCode	result;
	OSStatus		err;
	IBNibRef		nibRef;

	//	o[W`FbN
	{
		UInt32 response;
		if( (Gestalt( gestaltSystemVersion, (SInt32 *)&response) == noErr) ){
//			if( response < 0x01030 ){
//				//	Mac OS 10.3ȏ̂
			if( response < 0x01024 ){
				//	Mac OS 10.24ȏ̂
				GVSShowAlartDialog( GVS_ALART_TYPE_STOP, CFSTR("MAC OS VERSION CHECKER"), CFSTR("Sorry.Require Mac OS 10.3 later."), 
					GVS_ALART_BUTTON_DEFAULT_OK, CFSTR("QUIT"), NULL, NULL );
				return false;
			}
		}
		if( (Gestalt( gestaltQuickTime, (SInt32 *)&response) == noErr) ){
				//	QuickTime6.4ȏ̂
			if( response < 0x06408000 ){
			
				//	ɁAÂQTłȂG3̎AMatrixMixeri
				//	AG3Ɋւ񂪂ǂɂȂi
				//	ɁAAUGraphMatrixMixerw肵ĂG[ʂ̂íH

				//	GameAudioSurviceG3œɂ́AQT6.4ȏK{ł
				GVSShowAlartDialog( GVS_ALART_TYPE_STOP, CFSTR("QUICK TIME VERSION CHECKER"), CFSTR("Sorry.Require QuickTime 6.4 later."), 
					GVS_ALART_BUTTON_DEFAULT_OK, CFSTR("QUIT"), NULL, NULL );
				return false;
			}
		}
		//	[TCY
		if( (Gestalt( gestaltPhysicalRAMSize, (SInt32 *)&response) == noErr) ){
			ms_physicalMemorySize = response;
		}
		
	}
	
	GVSDisableKeyScript();
	this->m_menu.m_app = this;

	//	NIBt@CgpāAj[
	err = CreateNibReference( AB_MACOS_RES_NIB_FILE, &nibRef );
	if( err != noErr ){	return NULL; }
	result = this->m_menu.setMenu( nibRef, AB_MACOS_RES_MENU_BAR );
	if( result != CW_NO_ERROR ){	return false; }
	
	//	^C}[[vCXg[
	result = this->installTimerLoop( kEventDurationSecond / 60.0f );
	if( result != CW_NO_ERROR ){	return false; }

	//	CEBhEp	
	GVSwindowAttribute	attribute = 
//		GVS_WINDOW_ATTRIBUTE_CLOSE_BUTTON | 
//		GVS_WINDOW_ATTRIBUTE_RESIZE |
		GVS_WINDOW_ATTRIBUTE_MINIMIZE_BUTTON ;
//		GVS_WINDOW_ATTRIBUTE_ZOOM_BUTTON |
//		GVS_WINDOW_ATTRIBUTE_GET_MOUSE_EVENT | 
//		GVS_WINDOW_ATTRIBUTE_GET_KEYBOARD_EVENT | 
//		GVS_WINDOW_ATTRIBUTE_GET_TABLET_EVENT;;
	this->m_view.createWindow( attribute, GVS_WINDOW_APPEARANCE_METAL, 640, 8, AB_MACOS_RES_WINDOW_TITLE );
	if( ! this->m_view.initialize() ){	return false; }
	return	true;
}

//------------------------------------------------------------------------------
//	I
//------------------------------------------------------------------------------
void	GUIApp::finalize( void )
{
	this->m_view.finalize();
	GVSShowMouse();
}

//------------------------------------------------------------------------------
//	t[[gŃ^C}[Zbg
//------------------------------------------------------------------------------
CWbool	GUIApp::setTimerLoop( const CWint  inFrameRate ){
	this->removeTimerLoop();
	CWresultCode	result = this->installTimerLoop( kEventDurationSecond / (CWfloat32)inFrameRate );
	return	( result == CW_NO_ERROR ? true : false  );
}

//------------------------------------------------------------------------------
//	^C}[[vŌĂяo܂B
//------------------------------------------------------------------------------
void	GUIApp::onEventLoop( void )
{
	//	_[
	this->m_view.renderView();
}

//------------------------------------------------------------------------------
//	CxgɌĂт܂
//------------------------------------------------------------------------------
GVSeventResult	GUIApp::onEventHandler( const GVSeventApp  inEvent )
{
	GVSeventResult	result = GVS_EVENT_RESULT_NO;
	
	//	IO
	CWbool	ret = this->m_view.onAppEvent( inEvent );
	if( ! ret ){
		return	GVS_EVENT_RESULT_OK;
	}
		
	switch( inEvent ){
		//	IO
		//		j[AAbvCxgɂIiVXeIɔIE܂jB
		case GVS_EVENT_APP_QUIT:

			this->removeTimerLoop();
			this->m_view.hide();

			//	tXN[[h́Afɖ߂Ă
			if( this->m_view.isFullScreen() ){
				//	Render֎~ŕύXBÍAɐFXȂ̂IĂԂȂ̂ŁARenderĂ͂Ȃ̂B
				this->m_view.setFullScreen( false, false );
			}
			break;

		//	ANeBuɂȂ܂
		case GVS_EVENT_APP_ACTIVATE:
			break;

		//	fBANeBuɂȂ܂
		case GVS_EVENT_APP_DEACTIVATE:
			break;
	}
	return	result;
}
