//	GVSView

#ifndef	GUIView_h
#define	GUIView_h

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	TYPE
//
//////////////////////////////////////////////////////////////////////////////////////////////////
#include	"CWorkerConfig.h"
#include	"GVSView.h"

#include	"CWGLService.h"
#include	"GLSService.h"
#include	"GLSContextView.h"

class	GUIApp;

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CLASS
//
//////////////////////////////////////////////////////////////////////////////////////////////////
class	GUIView : public	code_worker::GVSView
{
public:
	GUIApp*		m_guiapp;
	
private:
	code_worker::GLSContextView		m_glView;
	CWbool		m_switchingScreenMode;
	
public:
	GUIView( void );
	virtual	~GUIView( void );
	
	//	initialize
	virtual	CWbool			onInit( void ) = 0;
	//	finalize
	virtual	void			onFinal( void ){};
	//	change screen mode
	virtual	void			onChangeScreenMode( CWbool  inTrueIsFullScreenMode ){};
	//	`ƃ_[ƃXbv
	virtual	CWbool			onDraw( void ) = 0;
	//	`̈XV
	virtual	void			onReshape( void ) = 0;

	//	AvP[VCxgɌĂт܂
	virtual CWbool			onAppEvent( const GVSeventApp  inEvent ) = 0;

	//	`
	/*
		F
			glColor4f(  1.0f, 1.0f, 1.0f , 1.0f  );
			glRasterPos3f( 16, 16, 0); 
			inGLContext->drawCString( "Text drawing..." );
	*/
	virtual	void			onDrawInfo( code_worker::GLSContext*  inGLContext, const Rect*  inPortBounds ){};

public:	
	//	initialize
	CWbool			initialize( void );
	
	//	finalize
	void			finalize( void );

	//	̕`
	void			drawInfo( void );

	//	`ƃ_[ƃXbv
	void			renderView( CWbool  inRenderOnly = false );

	//	XN[TCYύX
	CWbool			changeScreenSize( CWint  inWidth, CWint  inHeight  );

	//	tXN[
	CWbool			isFullScreen( void );
	CWresultCode	setFullScreen( CWbool  inTrueIsFullScreenMode, CWbool  inDoRenderFlag = true );

	//	Jgr[̃TCY
	void	getCurrentViewSize( CWuint32*  outWidth, CWuint32*  outHeight );

	//	CxgɌĂт܂B
	virtual	GVSeventResult	onWindowEventHandler( const GVSeventView  inEvent );

/*
	//	}EXCxgɌĂт܂B
	virtual	GVSeventResult	onMouseEventHandler( const GVSeventMouse  inEvent, const GVSMouseEventData*  inEventData );
	//	L[{[hCxgɌĂт܂B
	virtual	GVSeventResult	onKeyboardEventHandler( const GVSeventKeyboard  inEvent, const GVSKeyboardEventData*  inEventData );
	//	^ubgCxgɌĂт܂B
	//		F	GVSTabletEventData*				inEventData				GVSeventTablet = GVS_EVENT_TABLET_POINT ł͖Ƃ NULLł
	//		F	GVSTabletProximityEventData*	inProximityEventData	GVSeventTablet = GVS_EVENT_TABLET_PROXIMITY ł͖Ƃ NULLł
	virtual	GVSeventResult	onTabletEventHandler( const GVSeventTablet  inEvent, const GVSTabletEventData*  inEventData, const GVSTabletProximityEventData*  inProximityEventData );
*/
};


#endif	GUIView_h
