/*///////////////////////////////////////////////////////////////////////////////

---------------------------------------------------------------------------------

	Component:	
	File:		GlobalConfig.h

	Encoding:	Shift-JIS

				SR[hŋLݒB

	Version:	
		version 1.00	2003/04/13	Reno

---------------------------------------------------------------------------------

	GNU General Public License
	<Aqua'n-Bests>
    Copyright (C) <2004>  <Aqua'n-Bests developer>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*///////////////////////////////////////////////////////////////////////////////

#ifndef	GlobalConfig_h
#define	GlobalConfig_h

#include <iostream>

//-------------------------------------------------------------------------------
//	^
//-------------------------------------------------------------------------------
typedef	bool				ABbool;

typedef	int					ABint;
typedef	char				ABint8;
typedef	short				ABint16;
typedef	long				ABint32;
typedef	long long			ABint64;

typedef	unsigned int		ABuint;
typedef	unsigned char		ABuint8;
typedef	unsigned short		ABuint16;
typedef	unsigned long		ABuint32;
typedef	unsigned long long	ABuint64;

typedef	float				ABfloat32;
typedef	double				ABfloat64;

typedef	unsigned int		ABsize;
typedef	unsigned long		ABusize;
typedef	int					ABtype;


//-------------------------------------------------------------------------------
//	|[gc[
//-------------------------------------------------------------------------------

//	report
#define	ABReportFormat( FORMAT, MESSAGE )			{	printf( "[FILE:%-48s][FUNC:%-32s][LINE:%6d] ", __FILE__, __func__, __LINE__ ); printf( FORMAT, MESSAGE );	}

#define	ABReport( MESSAGE )							{	ABReportFormat( "      > %s", MESSAGE ); printf( "\n" );	}
#define	ABReportError( ERR_MESSAGE )				{	ABReportFormat( "ERROR > %s", ERR_MESSAGE ); printf( "\n" );	}
#define	ABReportErrorCode( ERR_MESSAGE, ERR_CODE )	{	ABReportFormat( "ERROR > [ERR:%8d]", ERR_CODE ); printf( "%s\n", ERR_MESSAGE );	 }

//	error report and return
//		TEST^Ȃ烌|[gReturn
#define	ABTestReturnReportErrorCode( TEST, ERR_CODE, ERR_MESSAGE )	{	if( TEST ){ ABReportErrorCode(ERR_MESSAGE, ERR_CODE); return ERR_CODE ; } }
#define	ABTestReturnReportError( TEST, ERR_MESSAGE )		{	if( TEST ){ ABReportError(ERR_MESSAGE); return ! TEST ; } }
#define	ABTestVoidReturnReportError( TEST, ERR_MESSAGE )	{	if( TEST ){ ABReportError(ERR_MESSAGE); return ; } }
#define	ABTestVoidReturnReportErrorCode( TEST, ERR_MESSAGE, CODE )	{	if( TEST ){ ABReportErrorCode(ERR_MESSAGE, CODE); return ; } }
#define	ABTestBreakReportError( TEST, ERR_MESSAGE )			{	if( TEST ){ ABReportError(ERR_MESSAGE); break ; } }

//------------------------------------------------------------------------------
//	DEBUG MODE
//		fobO̂݃RpCׂe`MacroB
//		fobOł́uAB_DEBUG_MODEv`ĂB
//		`([X)ł͋ɂȂ悤ɂ܂B
//------------------------------------------------------------------------------
#ifdef	AB_DEBUG_MODE
	#define	ABDebug( X )	{ X; }
#else
	#define	ABDebug( X )
#endif

//	SourceAEgvbg邽߂̒`B
//
//		#define	AB_LOCAL_DEBUG_MODE
//		ABLocalDebug( "..." );
//		#undef	AB_LOCAL_DEBUG_MODE
//
#ifdef	AB_LOCAL_DEBUG_MODE
	#define	ABLocalDebug( X )	{  ABReportFormat( "","" ); X; }
	#define	ABLocalDebugSimple( X )	{  X; }
#else
	#define	ABLocalDebug( X )
	#define	ABLocalDebugSimple( X )
#endif


#endif	//GlobalConfig_h