/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GLService
*	File:		CWGLService.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/19	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/03/22>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWGLService_h
#define	CWGLService_h

#include	<Carbon/Carbon.h>
#include	<OpenGL/gl.h>
#include	<AGL/AGL.h>

#include	"CWorkerConfig.h"

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////
enum{
	CW_GLS_FAITAL_CHANGE_DISPLAY_MODE	= 2000,		//	fBXvC[h̐؂ւɎs
};

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	Dipplay DeviceID
//------------------------------------------------------------------------------
enum	{
	GLS_DEVICE_ID_MAIN_DISPLAY = 1,
};

//------------------------------------------------------------------------------
//	Screen Mode
//------------------------------------------------------------------------------
typedef enum	GLSScreenMode{
	GLS_SCREEN_MODE_WINDOW,			//	Window[h
	GLS_SCREEN_MODE_FULL_SCREEN,	//	FullScreen[h
	
	//	ItXN[[hł̓n[hEFAANZ[V̎gpoȂȂB
	//	`挋ʂėpƂ́At[obt@ǂݖ߂A
	//	pBuffergp邱ƁB
	GLS_SCREEN_MODE_OFF_SCREEN,		//	OffScreen[h

	//	MAC OS 10.3 Later
	GLS_SCREEN_MODE_P_BUFFER,		//	pBuffer context [h
	
} GLSScreenMode;

//------------------------------------------------------------------------------
//	View Mode
//------------------------------------------------------------------------------
typedef enum	GLSViewMode{
	GLS_VIEW_MODE_WINDOW,			//	Window[h
	GLS_VIEW_MODE_FULL_SCREEN,		//	FullScreen[h
} GLSViewMode;

//------------------------------------------------------------------------------
//	Context Opetion
//------------------------------------------------------------------------------
typedef	struct	GLSContextOption{
	CWbool		useZBuffer;			//	true = Z Buffergp
	CWuint		zBufferSize;
	
	CWbool		useStencilBuffer;	//	true = StencilBuffergp
	CWuint		stencilBufferSize;

	//	}`TvgpƂ́AKvɉĎOOpenGL`FbNsĂB
	//	@܂AReLXgɑ΂glEneblew肷KvL܂B(Q&A1268)
	//
	//		glEnable (GL_MULTISAMPLE_ARB);
	//		glHint (GL_MULTISAMPLE_FILTER_HINT_NV, GL_NICEST);	//	GL_DONT_CARE, GL_FASTEST, GL_NICEST
	//
	CWbool		useMultiSample;		//	true = A`GAVOgp(GPUɈˑ)
	CWuint		sampleBuffers;		//	obt@
	CWuint		samples;			//	Tv
	
}	GLSContextOption;

//------------------------------------------------------------------------------
//	ContextView Opetion
//------------------------------------------------------------------------------
typedef	struct	GLSContextViewOption{
	GLSContextOption	contextOption;
	
	GLSViewMode			viewMode;	//	view[h
	CGDirectDisplayID	displayID;	//	display deviceID ( default: = kCGDirectMainDisplay )
	CWuint				width;		//	full screen̉
	CWuint				height;		//	full screen̍
	CWuint				freq;		//	full screen̐g
	CWuint				colorDepth;	//	full screen̐F[x

}	GLSContextViewOption;

//------------------------------------------------------------------------------
//	Randerer information
//------------------------------------------------------------------------------
#define	GLS_RANDER_INFO_CHAR_ARRAY	256

typedef	struct	GLSRandererInfo{
	// Renderer info
	CWbool		accelerated;
	CWint32		rendererID;
	CWint32		deviceVRAM;
	CWint32		textureVRAM;
	CWbool		fullScreenMode;

	CWint8		rendererName[GLS_RANDER_INFO_CHAR_ARRAY]; 		// name of hardware renderer
	CWint8		rendererVendor[GLS_RANDER_INFO_CHAR_ARRAY]; 	// name of hardware renderer vendor
	CWint8		rendererVersion[GLS_RANDER_INFO_CHAR_ARRAY]; 	// string representation of hardware renderer version

	// Renderer Caps
	CWint32 	textureUnits;			// standard gl path max number of texture units
	CWint32 	maxTextureSize;			// maximum 1D and 2D texture size supported
	CWint32 	max3DTextureSize;		// maximum 3D texture size supported
	CWint32 	maxCubeMapTextureSize;	// maximum cube map texture size supported
	CWint32		maxRectTextureSize;		// maximum rectangular texture size supported

	// OpenGL version support
	CWuint16	glVersion;				// bcd gl version (ie. 1.4 is 0x0140)

	// Functionality
	struct{
		//	2004/03/24	version 1.4 / MacOS 10.3
		CWbool		fSpecularVector;	// GL_APPLE_specular_vector
		CWbool		fTransformHint;		// GL_APPLE_transform_hint 
		CWbool		fPackedPixels;		// GL_APPLE_packed_pixels or 1.2+
		CWbool		fClientStorage;		// GL_APPLE_client_storage
		CWbool		fYCbCr;				// GL_APPLE_ycbcr_422 (YUV texturing)
		CWbool		fTextureRange;		// GL_APPLE_texture_range (AGP texturing)
		CWbool		fFence;				// GL_APPLE_fence
		CWbool		fVAR;				// GL_APPLE_vertex_array_range
		CWbool		fVAO;				// GL_APPLE_vertex_array_object
		CWbool		fElementArray;		// GL_APPLE_element_array
		CWbool		fVPEvals;			// GL_APPLE_vertex_program_evaluators
		CWbool		fFloatPixels;		// GL_APPLE_float_pixels

		CWbool		fFlushRender;		// GL_APPLE_flush_render
		CWbool		fPixelBuffer;		// GL_APPLE_pixel_buffer
		
		CWbool		fImaging;			// GL_ARB_imaging  (not required in 1.2+)
		CWbool		fTransposeMatrix;	// GL_ARB_transpose_matrix or 1.3+
		CWbool		fMultitexture;		// GL_ARB_multitexture or 1.3+
		CWbool		fTexEnvAdd;			// GL_ARB_texture_env_add, GL_EXT_texture_env_add or 1.3+
		CWbool		fTexEnvCombine;		// GL_ARB_texture_env_combine or 1.3+
		CWbool		fTexEnvDot3;		// GL_ARB_texture_env_dot3 or 1.3+
		CWbool		fTexEnvCrossbar;	// GL_ARB_texture_env_crossbar or 1.4+
		CWbool		fTexCubeMap;		// GL_ARB_texture_cube_map or 1.3+
		CWbool		fTexCompress;		// GL_ARB_texture_compression or 1.3+
		CWbool		fMultisample;		// GL_ARB_multisample or 1.3+ (Anti-aliasing)
		CWbool		fTexBorderClamp;	// GL_ARB_texture_border_clamp or 1.3+
		CWbool		fPointParam;		// GL_ARB_point_parameters or 1.4+
		CWbool		fVertexProg;		// GL_ARB_vertex_program
		CWbool		fFragmentProg;		// GL_ARB_fragment_program
		CWbool		fTexMirrorRepeat;	// GL_ARB_texture_mirrored_repeat or 1.4+
		CWbool		fDepthTex;			// GL_ARB_depth_texture or 1.4+
		CWbool		fShadow;			// GL_ARB_shadow or 1.4+
		CWbool		fShadowAmbient;		// GL_ARB_shadow_ambient
		CWbool		fVertexBlend;		// GL_ARB_vertex_blend
		CWbool		fWindowPos;			// GL_ARB_window_pos or 1.4+
		CWbool		fTex3D;				// GL_EXT_texture3D or 1.2+
		CWbool		fClipVolHint;		// GL_EXT_clip_volume_hint
		CWbool		fRescaleNorm;		// GL_EXT_rescale_normal or 1.2+
		CWbool		fBlendColor;		// GL_EXT_blend_color or GL_ARB_imaging
		CWbool		fBlendMinMax;		// GL_EXT_blend_minmax or GL_ARB_imaging
		CWbool		fBlendSub;			// GL_EXT_blend_subtract or GL_ARB_imaging
		CWbool		fCVA;				// GL_EXT_compiled_vertex_array
		CWbool		fTexLODBias;		// GL_EXT_texture_lod_bias or 1.4+
		CWbool		fABGR;				// GL_EXT_abgr
		CWbool		fBGRA;				// GL_EXT_bgra or 1.2+
		CWbool		fTexFilterAniso;	// GL_EXT_texture_filter_anisotropic
		CWbool		fPaletteTex;		// GL_EXT_paletted_texture
		CWbool		fShareTexPalette;	// GL_EXT_shared_texture_palette
		CWbool		fSecColor;			// GL_EXT_secondary_color or 1.4+
		CWbool		fTexCompressS3TC;	// GL_EXT_texture_compression_s3tc
		CWbool		fTexRect;			// GL_EXT_texture_rectangle
		CWbool		fFogCoord;			// GL_EXT_fog_coord
		CWbool		fDrawRangeElements;	// GL_EXT_draw_range_elements
		CWbool		fStencilWrap;		// GL_EXT_stencil_wrap or 1.4+
		CWbool		fBlendFuncSep;		// GL_EXT_blend_func_separate or 1.4+
		CWbool		fMultiDrawArrays;	// GL_EXT_multi_draw_arrays or 1.4+
		CWbool		fShadowFunc;		// GL_EXT_shadow_funcs
		CWbool		fStencil2Side;		// GL_EXT_stencil_two_side
		CWbool		fTexEdgeClamp;		// GL_SGIS_texture_edge_clamp or 1.2+
		CWbool		fGenMipmap;			// GL_SGIS_generate_mipmap or 1.4+
		CWbool		fTexLOD;			// GL_SGIS_texture_lod or 1.2+
		CWbool		fPointCull;			// GL_ATI_point_cull_mode
		CWbool		fTexMirrorOnce;		// GL_ATI_texture_mirror_once
		CWbool		fPNtriangles;		// GL_ATI_pn_triangles or GL_ATIX_pn_triangles
		CWbool		fTextFragShader;	// GL_ATI_text_fragment_shader
		CWbool		fBlendEqSep;		// GL_ATI_blend_equation_separate
		CWbool		fBlendWeightMinMax;	// GL_ATI_blend_weighted_minmax
		CWbool		fCombine3;			// GL_ATI_texture_env_combine3
		CWbool		fRevComp4Bytes;		// GL_ATI_array_rev_comps_in_4_bytes
		CWbool		fPointSprite;		// GL_NV_point_sprite
		CWbool		fRegCombiners;		// GL_NV_register_combiners
		CWbool		fRegCombiners2;		// GL_NV_register_combiners2
		CWbool		fTexEnvCombine4;	// GL_NV_texture_env_combine4
		CWbool		fBlendSquare;		// GL_NV_blend_square or 1.4+
		CWbool		fFogDist;			// GL_NV_fog_distance
		CWbool		fMultisampleFilterHint; // GL_NV_multisample_filter_hint
		CWbool		fTexGenReflect;		// GL_NV_texgen_reflection
		CWbool		fTexShader;			// GL_NV_texture_shader
		CWbool		fTexShader2;		// GL_NV_texture_shader2
		CWbool		fTexShader3;		// GL_NV_texture_shader3
		CWbool		fDepthClamp;		// GL_NV_depth_clamp
		CWbool		fLightMaxExp;		// GL_NV_light_max_exponent
		CWbool		fRasterPosClip;		// GL_IBM_rasterpos_clip
	} api;
	
} GLSRandererInfo;

////////////////////////////////////////////////////////////////////////////////
//
//	defaultl̎擾
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	GLSContextOption default value
//------------------------------------------------------------------------------
inline	void	GLSGetDefaultContextOpetion( GLSContextOption&  inOption )
{
	inOption.useZBuffer		= true;
	inOption.zBufferSize	= 32;
	
	inOption.useStencilBuffer	= false;
	inOption.stencilBufferSize	= 32;
	
	inOption.useMultiSample	= false;
	inOption.sampleBuffers	= 0;
	inOption.samples		= 0;

}

//------------------------------------------------------------------------------
//	GLSContextViewOption default value
//------------------------------------------------------------------------------
inline	void	GLSGetDefaultContextViewOpetion( GLSContextViewOption&  inOption )
{
	GLSGetDefaultContextOpetion( inOption.contextOption );
	
	inOption.viewMode		= GLS_VIEW_MODE_WINDOW;
	inOption.displayID		= kCGDirectMainDisplay;
	inOption.width			= 640;
	inOption.height			= 480;
	inOption.freq			= 60;
	inOption.colorDepth		= 32;
}


#endif	//CWGLService_h