/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / OpenGLService
*	File:		GLSContext.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				OpenGL`ReLXgBAGLgĂ܂B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/22	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GLSContext_h
#define	GLSContext_h

#include	<Carbon/Carbon.h>
#include	<AGL/AGL.h>
#include	<OpenGL/gl.h>

#include	"CWorkerConfig.h"
#include	"CWGLService.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GLSContext
{
private:
	AGLContext     		m_aglContext;
	GLSContextOption	m_contextOption;
	GLSScreenMode		m_screenMode;
	CWuint				m_deviceID;

	GLuint				m_fontList;
	GLuint				m_shareFontList;	//	LtHg
	
	CWfloat32	m_stringColorR;
	CWfloat32	m_stringColorG;
	CWfloat32	m_stringColorB;
	CWfloat32	m_stringColorA;
	
public:
	//	Constructor
	GLSContext( void );
	//	Destructor
	virtual 	~GLSContext( void );

	//	initialize
	//		IɏĂB
	//
	//		EBhEReLXgƃtXN[ReLXg̋ĹAEBhEReLXgP̃fBXvCɎ܂ĂȂ΂Ȃ܂B
	//		@fAȏ̃fBXvCł́AEBhËʒu𐧌铙̑΍􂪕KvłB
	//		OpenGL̃`FbN͍s܂BႦ΃}`TvKvȎ́AĂяoOɃ`FbNĂB
	//
	//		F	CWuint				inDeviceID			0 w肵ĂBifBXvCԍBAGLׂ݊̈ɗpӂ܂AgKv͂܂Bj
	//		F	GLSContextOption*	inContextOption		ReLXg̐ݒB
	//		F	GLSScreenMode		inScreenMode		ReLXg̎ށB
	//		F	GLSContext*			inShareContext		LReLXgB
	//		ߒlF	CWresultCode							G[R[h
	CWresultCode	initialize( const CWuint			inDeviceID		/* = OGS_DEVICE_ID_MAIN_DISPLAY */, 
								const GLSContextOption*	inContextOption, 
								const GLSScreenMode		inScreenMode,
								const GLSContext*		inShareContext	/* = NULL */ );
	//	finalize
	//		IɏIĂBiÔDestructorłĂł܂j
	void			finalize( void );

	//	GLReLXgɁAwindow蓖Ă
	//
	//		F	CGrafPtr  inDrawPort					WindowRefCGrafPtrB
	//		ߒlF	CWresultCode							G[R[h
	CWresultCode	attachWindow( const CGrafPtr  inDrawPort );

	//	GLReLXgAwindowO
	//
	//		ߒlF	CWresultCode							G[R[h
	CWresultCode	detachWindow( void );

	//	GLReLXgJgɐݒ
	//
	//		ߒlF	CWresultCode							G[R[h
	CWresultCode	activeContext( void );

	//	GLReLXgJgɐݒ
	//
	//		ߒlF	CWresultCode							G[R[h
	CWresultCode	deactiveContext( void );

	//	GLReLXgAbvf[g
	//
	//		ߒlF	CWresultCode							G[R[h
	CWresultCode	updateContext( void );

	//	tXN[ɐݒ
	//		tXN[́AfobOȂBfobOɂĒfƁAs\Ɋׂ܂B
	//
	//		F	GLsizei  inWidth		؂ւ𑜓x̉B0 nƁA݂̒lŐ؂ւ܂B
	//		F	GLsizei  inHeight		؂ւ𑜓x̏cB0 nƁA݂̒lŐ؂ւ܂B
	//		F	GLsizei  inFreq			؂ւ𑜓x̐gB0 nƁA݂̒lŐ؂ւ܂B
	//		ߒlF	CWresultCode			G[R[h
	CWresultCode	changeModeFullScreenOn( const GLsizei  inWidth, const GLsizei  inHeight, const GLsizei  inFreq );

	//	tXN[؂
	//		𑜓xȀԂɖ߂܂B
	//
	//		ߒlF	CWresultCode			G[R[h
	CWresultCode	changeModeFullScreenOff( void );
	
	//	ItXN[ɐݒ
	//
	//		F	GLsizei  inWidth		obt@̉B
	//		F	GLsizei  inHeight		obt@̏cB
	//		F	GLsizei  inRowbytes		obt@̉@~@Ppixel̃oCgB
	//		F	GLvoid*  inBaseaddr		obt@ւ̃AhXB
	//		ߒlF	CWresultCode			G[R[h
	CWresultCode	changeModeOffScreenOn( const GLsizei  inWidth, const GLsizei  inHeight, const GLsizei  inRowbytes, GLvoid*  inBaseaddr );

	//	ItXN[؂
	//
	//		ߒlF	CWresultCode			G[R[h
	CWresultCode	changeModeOffScreenOff( void );
	
	//	rander and swap buffer
	//		_OƁAobNobt@Ɠւ܂B
	//		OffScreenReLXgPBufferReLXgł͎gpKv͂܂iglFinish()Ăт܂BjB
	//
	//		ߒlF	CWresultCode			G[R[h
	CWresultCode	randerAndSwapBuffer( void );

	//	get device number
	//		̃ReLXg̃fBXvCԍԂ܂B
	//
	//		ߒlF	CWuint	fBXvCԍ
	CWuint			getDeviceID( void ) const{
		return	this->m_deviceID;
	}
	
	////////////////////////////////////////////////////////////////////////////////
	//
	//	`@ȉ̓fobOVvȏ\prɎgp܂B
	//
	////////////////////////////////////////////////////////////////////////////////
	//	string setup
	//
	//		F	CWint8*  inFontName
	//		F	Style  inFace
	//		F	CWint  inSize
	//		ߒlF	CWresultCode			G[R[h
	CWresultCode	setupFont( const CWint8*  inFontName, const CWint  inSize );

	//	string cleanup
	//		gpAĂ΂ȂĂOKł
	void	cleanupFont( void );

	//	string draw
	//
	//		F	CWint8*  inCStrings
	void	drawCString( const CWint8*  inCStrings );

	//	set drawing color
	//
	//		F	CWfloat32  inR
	//		F	CWfloat32  inG
	//		F	CWfloat32  inB
	//		F	CWfloat32  inA
	//		F	CWint8*  inCStrings
	void	setCStringColor( const CWfloat32  inR = 1.0f, const CWfloat32  inG = 1.0f, const CWfloat32  inB = 1.0f, const CWfloat32  inA = 1.0f );

	//	string window position drawing
	//
	//		F	CWuint  inX
	//		F	CWuint  inY
	//		F	CWint8*  inCStrings
	void	drawCStringPos( const CWuint  inX, const CWuint  inY, const CWint8*  inCStrings );

	////////////////////////////////////////////////////////////////////////////////
	//
	//	ȉ̊֐͑GLSNXɒ񋟂̂ł̂ŁAʂɂ͎gKv͂܂B
	//
	////////////////////////////////////////////////////////////////////////////////
	//	get AGL context
	//		AGLReLXgԂ܂B
	AGLContext		getContext( void ) const {
		return	this->m_aglContext;
	}

	//	error report
	//		AGLG[R\[֏o͂܂B
	GLenum	repoatError( const CWint  inLineNumber );
	
	//	font list
	GLuint	getFontList( void ){
		return	this->m_fontList;
	}
};

}	//	code_worker

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

#endif	//GLSContext_h