/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / OpenGLService
*	File:		GLSContextView.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				GLgp邽߂̉ʁiWindowyуtXN[j񋟂܂BAGLgĂ܂B
*				ReLXgr[gpƁAEBhE[hAtXN[[hA
*				}`Tv[hʂɃReLXgpӂKvAP̃ReLXĝ悤ɐł܂B
*
*				p@
*					PFinitialize
*					QFr[ɃEBhE蓖Ă
*					RFKvɉāA[hύXiEBhE<->tXN[؂ւjs܂B
*					SFfinalize
*
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/22	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GLSContextView_h
#define	GLSContextView_h

#include	<Carbon/Carbon.h>
#include	<OpenGL/gl.h>
#include	<AGL/AGL.h>

#include	"CWorkerConfig.h"
#include	"CWGLService.h"
#include	"GLSContext.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GLSContextView
{
private:
	GLSContextViewOption	m_option;
	GLSContext				m_mainContext;		//	CƂReLXgB
	GLSContext				m_subContext;		//	TuƂȂReLXgBtXN[Ƃ͌ȂB
	GLSContext*				m_currentContext;	//	݂̃JgB
	
	CGrafPtr				m_contextAttachPort;	//	ReLXgr[Ɋ蓖ĂĂEBhE
public:
	//	Constructor
	GLSContextView( void );
	//	Destructor
	virtual 	~GLSContextView( void );

	//	initialize
	//		IɏĂB
	//
	//		F	GLSContextViewOption*  inContextOption		r[̃[hB
	//		ߒlF	CWresultCode								G[R[hB
	CWresultCode	initialize( const GLSContextViewOption*  inContextOption );
	
	//	finalize
	//		IɏIĂBiÔDestructorłĂł܂j
	void			finalize();
	
	//	[hݒ肷
	//	EtXN[A𑜓x؂ւA}`Tv̗LEs܂B
	//
	//		F	GLSContextViewOption*	inContextOption		r[̃[hB
	//		ߒlF	CWresultCode								G[R[hB
	CWresultCode	changeMode( const GLSContextViewOption*	inContextOption );
	
	//	[h擾
	//
	//		F	GLSContextViewOption*	inContextOption		r[̃[hB
	void			getMode( GLSContextViewOption*	outContextOption );
	
	//	r[ɁAwindow蓖Ă
	//
	//		F	CGrafPtr  inDrawPort					WindowRefCGrafPtrB
	//		ߒlF	CWresultCode							G[R[h
	CWresultCode	attachWindow( const CGrafPtr  inDrawPort );

	//	r[AwindowO
	//
	//		ߒlF	CWresultCode							G[R[h
	CWresultCode	detachWindow( void );
	
	//	JgReLXg擾
	//
	//		ߒlF	GLSContext*
	GLSContext*		getCurrentContext( void );

	//	CReLXg擾
	//
	//		ߒlF	GLSContext*
	GLSContext*		getMainContext( void );

	//	TuReLXg擾
	//
	//		ߒlF	GLSContext*
	GLSContext*		getSubContext( void );

	//	Abvf[g
	//
	//		ߒlF	CWresultCode								G[R[hB
	CWresultCode	update( void );
	
};

}	//	code_worker

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

#endif	//GLSContextView_h