/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / OpenGLService
*	File:		GLSPBuffer.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				PBuffer(MacOS 10.3 Later)BAGLgĂ܂B
*				10.2ȑȌꍇ́At[obt@̎QyA邢OffScreen̎gpőp܂B
*
*				pBufferɊւ́AADCTvAATI̊g@\Ȃǂ瓾܂B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/22	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GLSPBuffer_h
#define	GLSPBuffer_h

#include	<Carbon/Carbon.h>
#include	<OpenGL/gl.h>
#include	<AGL/AGL.h>

#include	"CWorkerConfig.h"
#include	"CWGLService.h"
#include	"GLSContext.h"

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GLSPBuffer
{
private:
	GLSContext		m_context;			//	Kvȋ@\gp̂ŁApł͂ȂL܂B
	AGLPbuffer		m_aglPBuffer;
	CWuint8*		m_buffer;
	CWuint8*		m_currentBuffer;

public:
	//	Constructor
	GLSPBuffer( void );
	//	Destructor
	virtual 	~GLSPBuffer( void );

	//	initialize
	//		IɏĂB
	//
	//		F	GLSContextOption*	inContextOption			ReLXgIvVB
	//		F	CWuint				inWidth					pBuffer̉B
	//		F	CWuint				inHeight				pBuffeȑcB
	//		F	GLenum				inTextureType			eNX`̎ށB
	//		F	CWuint32			inPBufferMaxLevel		~bv}bvH
	//		F	CWuint8*			inBufferAddress			obt@̃AhXB
	//		F	GLSContext*			inShareContext			LReLXgB
	//		ߒlF	CWresultCode								G[R[hB
	CWresultCode	initialize( 	const GLSContextOption*		inContextOption, 
									const CWuint				inWidth,
									const CWuint				inHeight,
									const GLenum				inTextureType		/* = GL_TEXTURE_2D */,
									const CWuint32				inPBufferMaxLevel,	/* = 0 */
									CWuint8*					inBufferAddress,	/* = NULL */
									const GLSContext*			inShareContext 		/* = NULL */);
	
	//	finalize
	//		IɏIĂBiÔDestructorłĂł܂j
	void			finalize( void );

	//	pBufferւOpenGL`Jn
	//		̊֐ĂяoȌ́ApBufferւ̕`ɐ؂ւ܂B
	//
	//		F	GLSContext&		inTargetContext		pBuffereNX`ƂĎgp鑤̃ReLXgB
	//		F	CWint			inFace				H
	//		F	CWint			inLevel				~bv}bvH
	//		ߒlF	CWresultCode						G[R[hB
	CWresultCode	beginDraw( const GLSContext&  inTargetContext, const CWint  inFace, const CWint  inLevel );
	
	//	pBufferւOpenGL`I
	//		OpenGL̃pCvClꍇ́A Kvɉ glFinish() ĂłIĂB
	//
	//		ߒlF	CWresultCode						G[R[hB
	CWresultCode	endDraw( void );

	//	pBuffereNX`ɃoCh
	//		śAinTargetContextJgɂȂĂȂ΂Ȃ܂B
	//
	//		F	GLSContext&		inTargetContext		pBuffereNX`ƂĎgp鑤̃ReLXgB
	//		F	CWint			inSource			H
	//		ߒlF	CWresultCode						G[R[hB
	CWresultCode	texImagePBuffer( const GLSContext&  inTargetContext, const  CWint  inSource /* = 'DrawBufferMode (gl.h)' */ );

	//	ReLXg擾
	//
	//		ߒlF	GLSContext*							ReLXgB
	GLSContext*		getContext( void ){
		return	&this->m_context;
	}
	
	//	AGLReLXg擾
	//
	//		ߒlF	AGLContext							AGLContext
	AGLContext		getAGLContext( void ){
		return	this->m_context.getContext();
	}
	
	//	pBuffer擾
	//
	//		ߒlF	AGLPbuffer							AGLPbuffer
	AGLPbuffer		getPBuffer( void ){
		return	this->m_aglPBuffer;
	}
	
};

}	//	code_worker
#endif	//GLSPBuffer_h