/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / OpenGLService
*	File:		GLSService.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				GLe퉇@\BAGLgĂ܂B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/22	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GLSService_h
#define	GLSService_h

#include	<Carbon/Carbon.h>
#include	<OpenGL/gl.h>
#include	<AGL/AGL.h>

#include	"CWorkerConfig.h"
#include	"CWGLService.h"
#include	"CWorkerSingletonBase.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	F\display̐
//------------------------------------------------------------------------------
#define		GLS_DISPLAY_COUNT_MAX		32

////////////////////////////////////////////////////////////////////////////////
//
//	Function
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class	GLSFader
//
////////////////////////////////////////////////////////////////////////////////
/*
	DestructorgpătF[hAEg̕As悤ɂĂ܂B

	gpF
		{
			GLSFader	fader( kCGDirectMainDisplay, 60 );	//	Fade Out
			
			//	DestructorŁAFade In
		}

	tF[hAEg̃NbVΏfobMO͔ɑςłBiႤƃVbNłi΁jj
	XN[[h؂ւȊO̗prɂ͎gȂ𐄏܂B

	OpenGLgpĕ`\ł܂̂Łi`|S`jA̕EBhEx[X̏ꍇڂǂłB
*/
class	GLSFader
{
private:
	enum{
		M_GAMMA_R_MIN,
		M_GAMMA_R_MAX,
		M_GAMMA_R_VALUE,

		M_GAMMA_G_MIN,
		M_GAMMA_G_MAX,
		M_GAMMA_G_VALUE,

		M_GAMMA_B_MIN,
		M_GAMMA_B_MAX,
		M_GAMMA_B_VALUE,
		
		M_GAMMA_COUNT,
	};
	CGGammaValue		m_gamma[ M_GAMMA_COUNT ];
	CGDirectDisplayID	m_displayID;
	CWfloat32			m_rate;
	CWbool				m_trueIsFadeOut;
	CWuint				m_fadeInDelay;
	
public:
	GLSFader( void );
	
	//	tF[hAEg
	//		EuEǂł́AtXN[ւ̐؂ւ́AxԂ60`90Ɏw肷ƌhǂȂ܂B
	//		EuEǂł́AEBhE[hւ̐؂ւ́ADefaultl̏ԂhǂȂ܂B
	//
	//		FCWuint	inFadeSpeed			tF[h`bNJEgԐ
	//		FCWuint	inFadeInDelay		tF[hC܂ł̒x
	GLSFader( const CGDirectDisplayID  inDisplayID  /* = kCGDirectMainDisplay */,  CWuint  inFadeSpeed, CWuint  inFadeInDelay = 30 );

	//	tF[hC
	~GLSFader( void );

	//	tF[hAEg
	//
	//		FCWuint	inFadeSpeed			tF[h`bNJEgԐ
	//		FCWuint	inFadeInDelay		tF[hC܂ł̒x
	void	fadeOut( const CGDirectDisplayID  inDisplayID  /* = kCGDirectMainDisplay */,  CWuint  inFadeSpeed, CWuint  inFadeInDelay = 30 );

	//	tF[hC
	void	fadeIn( void );
};

////////////////////////////////////////////////////////////////////////////////
//
//	Class	GLSService
//
////////////////////////////////////////////////////////////////////////////////
class	GLSService
{
private:
	CGDirectDisplayID		m_displayArray[ GLS_DISPLAY_COUNT_MAX ];
	CGDisplayCount			m_displayCount;

public:
	/////////////////////////////////////////
	//	fBXvC
	//
	//		AGL, CGLǂłgp\B
	//
	/////////////////////////////////////////
	//	wio[̃fBXvCID擾
	//
	//		F	CWuint	inDisplayNumber						1 ... n
	//		ߒlF	CWresultCode								G[R[hB
	CGDirectDisplayID	getDisplayID( const CWuint	inDisplayNumber );

	//	wfBXvCID̃io[擾
	//
	//		F	CGDirectDisplayID	inDisplayID				CGDirectDisplayID
	//		ߒlF	CWuint										fBXvC̔ԍ
	CWuint			getDisplayNumber( const CGDirectDisplayID	inDisplayID );

	//	fBXvC̐
	//
	//		ߒlF	CWuint										fBXvC̐
	CWuint			getDisplayCount( void );

	//	fBXvC̉𑜓x̐
	//
	//		F	CGDirectDisplayID	inDisplayID				CGDirectDisplayID
	//		ߒlF	CWuint										𑜓x̐
	CWuint			getDisplayModeCount( const CGDirectDisplayID  inDisplayID );

	//	fBXvC𑜓x̎擾
	//		EnIłATgetDisplayModeCount()Ƀ[vgŉB
	//		E]̉𑜓xɑΉĂ邩ǂ܂߂ɒƂɎgp܂B
	//		@ʏ́ÃtXN[ݒOɍsƂ܂B
	//		EɂĂ͖cȗʂԂ܂B
	//		ERg[plƓlAԂeLłƂ͌܂BۂɎsƂAs鎖蓾܂B
	//
	//		F	CGDirectDisplayID	inDisplayID				CGDirectDisplayID
	//		F	CWuint				inModeNumber			𑜓xԍ
	//		F	CWuint*				outWidth				𑜓x̉
	//		F	CWuint*				outHeight				𑜓x̏c
	//		F	CWuint*				outColorDepth			𑜓x̐F[x
	//		F	CWuint*				outFreq					𑜓x̐g
	//		ߒlF	CWresultCode								G[R[hB
	CWresultCode	searchDisplayMode(	const CGDirectDisplayID		inDisplayID /* = kCGDirectMainDisplay */,
										const CWuint	inModeNumber,	
										CWuint*			outWidth,
										CWuint*			outHeight,
										CWuint*			outColorDepth,
										CWuint*			outFreq );

	//	w̃fBXvC𑜓xɐ؂ւ
	//		V[hEBhEgp邽߁AOpenGL`ړIŎgpȊO̗prɂ͎g܂B
	//		@i܂AsƁAʂ^ɂȂ܂Bj
	//
	//		F	CGDirectDisplayID	inDisplayID				CGDirectDisplayID
	//		F	CWuint				inModeNumber			𑜓xԍ
	//		ߒlF	CWresultCode								G[R[hB
	CWresultCode	changeDisplayMode(
								const CGDirectDisplayID		inDisplayID,
								const CWuint	inModeNumber );

	//	fBXvC̐؂ւ
	//		V[hEBhEgp邽߁AOpenGL`ړIŎgpȊO̗prɂ͎g܂B
	//		@i܂AsƁAʂ^ɂȂ܂Bj
	//
	//		F	CGDirectDisplayID	inDisplayID				CGDirectDisplayID
	//		F	CWuint				inWidth					؂ւ𑜓x̉
	//		F	CWuint				inHeight				؂ւ𑜓x̏c
	//		F	CWuint				inColorDepth			؂ւ𑜓x̐F[x
	//		F	CWuint				inFreq					؂ւ𑜓x̐g
	//		ߒlF	CWresultCode								G[R[hB
	CWresultCode	changeDisplayMode(	const CGDirectDisplayID		inDisplayID /* = kCGDirectMainDisplay */, 
										const CWuint	inWidth,
										const CWuint	inHeight,
										const CWuint	inColorDepth,
										const CWuint	inFreq );

	//	fBXvCɖ߂
	void			recoveryDisplayMode( void );

	//	_[擾
	//		EwfBXvC̃_[𒲍܂B
	//		@fBXvCwłȂAItXN[ReLXg̃_[擾邱Ƃ͏o܂B
	//		E̖A_[邩́AgpR[h߂Ȃ΂Ȃ܂B
	//		@ʓIɂ́A\pReLXg쐬OɍsAI܂Ń_[ێ܂B
	//
	//		F	CGDirectDisplayID	inDisplayID				CGDirectDisplayID
	//		F	GLSRandererInfo*  	outRanderInfo			i[郌_[̃|C^B
	static	void	getRandererInfo( const CGDirectDisplayID  inDisplayID,  GLSRandererInfo*  outRanderInfo );


protected:
	//	Constructor
	GLSService( void );
	//	Destructor
	virtual ~GLSService( void );
	GLSService( const GLSService& );
	GLSService&	operator = ( const GLSService& );

};
typedef	CWorkerSingletonBase<GLSService>		GLSServiceSingleton;

////////////////////////////////////////////////////////////////////////////////
//
//	Function
//
////////////////////////////////////////////////////////////////////////////////
//	Get Singleton
//
//		GLSServiceNXsingletonłBo[ṕÅ֐gpăCX^X擾ĂB
//
//		ߒlF	GLSService&								GLSServiceNX̃CX^X
GLSService&		GLSGetServiceSingleton( void );



}	//	code_worker

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

#endif	//GLSService_h