/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameMediaService
*	File:		CWGameAudioService.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				Q[I[fBI@\xB
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/05/12	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/03/22>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWGameAudioService_h
#define	CWGameAudioService_h

#include	<Carbon/Carbon.h>
#include	<CoreServices/CoreServices.h>
#include 	<CoreAudio/CoreAudio.h>
#include 	<AudioUnit/AudioUnit.h>
#include 	<AudioToolbox/AudioToolbox.h>

#include	"CWorkerConfig.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code	( -12000 )
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	_Oi
//------------------------------------------------------------------------------
enum{
	GAS_RENDER_QUALITY_MAX		= kRenderQuality_Max,
	GAS_RENDER_QUALITY_HIGH		= kRenderQuality_High,
	GAS_RENDER_QUALITY_MEDIUM	= kRenderQuality_Medium,
	GAS_RENDER_QUALITY_LOW		= kRenderQuality_Low,
	GAS_RENDER_QUALITY_MIN		= kRenderQuality_Min
};
typedef	CWtype	GASrenderQualyty;

//------------------------------------------------------------------------------
//	Reverb̎
//------------------------------------------------------------------------------
enum{
	GAS_EFFECT_REVERB_TYPE_SMALL_ROOM	= kReverbRoomType_SmallRoom,
	GAS_EFFECT_REVERB_TYPE_MEDIUM_ROOM	= kReverbRoomType_MediumRoom,
	GAS_EFFECT_REVERB_TYPE_LARGE_ROOM	= kReverbRoomType_LargeRoom,
	GAS_EFFECT_REVERB_TYPE_MEDIUM_HALL	= kReverbRoomType_MediumHall,
	GAS_EFFECT_REVERB_TYPE_LARGE_HALL	= kReverbRoomType_LargeHall,
	GAS_EFFECT_REVERB_TYPE_PLATE		= kReverbRoomType_Plate,
};
typedef	CWtype	GASeffectRevebType;

//------------------------------------------------------------------------------
//	Tv[g
//------------------------------------------------------------------------------
#define		GAS_SAMPLE_RATE_44100	( 44100.0f )		//	44.100khz	default
#define		GAS_SAMPLE_RATE_32000	( 32000.0f )		//	32.000khz
#define		GAS_SAMPLE_RATE_22050	( 22050.0f )		//	22.050khz
#define		GAS_SAMPLE_RATE_16000	( 16000.0f )		//	16.000khz
#define		GAS_SAMPLE_RATE_11025	( 11025.0f )		//	11.025khz
#define		GAS_SAMPLE_RATE_08000	(  8000.0f )		//	 8.000khz
#define		GAS_SAMPLE_RATE_05012	(  5012.0f )		//	 5.012khz
typedef	CWfloat32	GASsampleRate;

//------------------------------------------------------------------------------
//	XeI/m
//------------------------------------------------------------------------------
enum{
	GAS_SAMPLE_CHANNEL_MONO		= 1,
	GAS_SAMPLE_CHANNEL_STEREO	= 2,
};
typedef	CWtype	GASsampleChannelType;

//------------------------------------------------------------------------------
//	GtFN^[ݒ
//------------------------------------------------------------------------------
typedef	struct GASAudioEffect{
	
	GASrenderQualyty	reverbQualyty;			//	
	CWfloat32			reverbParamDryWetMix;	//	o[ûi hC/EFbg̔䗦wB j ( 0.0 - 100.0f )
	GASeffectRevebType	reverbType;				//	Reverb̎

} GASAudioEffect;

//------------------------------------------------------------------------------
//	Configuration
//------------------------------------------------------------------------------
typedef	struct GASConfiguration{
	
	GASsampleRate			audioSampleRate;			//	Ŝ̉
	CWsize					audioFileBufferTotalSize;	//	I[fBIt@C[ɓǂݍލۂ̑TCY
	CWsize					audioFileBufferSize;		//	I[fBIt@C[ɓǂݍލۂ̃t@C̃TCY
	CWsize					audioBusCount;				//	ɍĐ鉹̍ő吔
	GASsampleChannelType	audioInputChannel;			//	͂XeI܂̓mɂ
	GASsampleChannelType	audioOutputChannel;			//	ŏIo͂XeI܂̓mɂ

} GASConfiguration;

//------------------------------------------------------------------------------
//	TEht@C
//------------------------------------------------------------------------------
typedef	struct OPAQUA_STRUCT(GASSoundFile)*		GASSoundFileRef;

//------------------------------------------------------------------------------
//	TEhIuWFNg
//------------------------------------------------------------------------------
typedef	struct OPAQUA_STRUCT(GASSoundObject)*	GASSoundObjectRef;

////////////////////////////////////////////////////////////////////////////////
//
//	Function
//
////////////////////////////////////////////////////////////////////////////////


//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

#endif	//CWGameAudioService_h