/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameAudioService
*	File:		GASAudioService.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:

				AudioUnitgpTEhĐxNX
				
				EAUConvertergpAI[fBIt@C̍ĐB
				EI[fBIt@CĐ\[XuTEhIuWFNgvƌĂсA
				@Cӂ̌ij쐬łB

				EAudioUnit̐ڑ\

					ÉAo͂ChannelɂāA傱Ƃ\ωB
					
					Input STEREO / Output STEREO
						ETEhIuWFNgP[IN Element 0(L)]+@MatrixMixer +[OUT Element 0(L)]Reverb(STEREO)ftHgAEgvbg(STEREO)
						@@@@@@@@@@@@@@[IN Element 1(R)]+  @          +[OUT Element 1(R)]
						ETEhIuWFNgQ[IN Element 2(L)]+
						@@@@@@@@@@@@@@[IN Element 3(R)]+
						ETEhIuWFNgR[IN Element 4(L)]+
						@@@@@@@@@@@@@@[IN Element 5(R)]+
						EEE

					Input MONO / Output MONO
						ETEhIuWFNgP[IN Element 0(LR)]+@MatrixMixer +[OUT Element 0(LR)]Reverb(STEREO)ftHgAEgvbg(STEREO)
						ETEhIuWFNgQ[IN Element 1(LR)]+
						ETEhIuWFNgR[IN Element 2(LR)]+
						EEE
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/05/12	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GASAudioService_h
#define	GASAudioService_h

#include	<vector>
#include	<list>

#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"
#include	"CWGameAudioService.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////
class	GASAudioServiceData;

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GASAudioService
{
private:
	GASAudioServiceData*		m_data;		//	̃NXJׂɁANX͂ɉBĂB

	GASConfiguration				m_config;
	CWsize							m_fileBifferSize;		//	CacheĂt@C̑TCY
	AudioStreamBasicDescription		m_converterDesc;		//	Ro[g̃tH[}bgBt@Cǂݍ݂ƓɃRo[gs悤ێĂB

public:
	GASAudioService( void );
	virtual	~GASAudioService( void );
	

	////////////////////////////////////////////////////////////////////
	//	
	////////////////////////////////////////////////////////////////////

	//	
	CWresultCode	initialize( 
		const GASConfiguration*	inConfig,
		const GASAudioEffect*  	inEfffect	= NULL
	);	

	//	I
	void	finalize( void );

	////////////////////////////////////////////////////////////////////
	//	
	////////////////////////////////////////////////////////////////////

	//	}X^[{[
	CWresultCode	setMasterVolume( const CWfloat32  inVolume );

	////////////////////////////////////////////////////////////////////
	//	TEht@C
	////////////////////////////////////////////////////////////////////

	//	TEht@CJ
	//	Et@CPʂŃXeImwł܂B
	GASSoundFileRef	openWave( const FSRef  inFile, CWbool  inPreload = false, CWsize  inCacheSize = 0, const  GASsampleChannelType  inChannelType = 0);

	//	TEht@C
	void		closeWave( const GASSoundFileRef  inSoundResource );
	
	//	TEht@C[ɓǂݍ
	//	Et@CĐĂTEhIuWFNgLꍇAǂݍ݂łȂ
	//	Et@CPʂŃXeImwł܂B
	CWresultCode	loadWave( const GASSoundFileRef  inSoundResource, const CWsize  inCacheSize = 0, const  GASsampleChannelType  inChannelType = 0 );
	
	//	[ɒ~TEht@Cf[^
	//	Et@CĐĂTEhIuWFNgLꍇApurgełȂ
	void		purgeWave( const GASSoundFileRef  inSoundResource );
	
	//	TEht@C̃[ɓǂݍ܂ĂoCgԂ
	CWsize		getBufferSize( const GASSoundFileRef  inSoundResource );
	
	////////////////////////////////////////////////////////////////////
	//	TEhIuWFNg
	////////////////////////////////////////////////////////////////////
	
	//	쐬
	GASSoundObjectRef	createSoundObject( void );
	
	//	p
	void releaseSoundObject( const GASSoundObjectRef  inSoundObject );

	//	Đ
	CWresultCode	playWave( const GASSoundObjectRef  inSoundObject, const  GASSoundFileRef  inSoundResource );
	//	ĐH
	CWbool			isPlayWave( const GASSoundObjectRef  inSoundObject );
	//	~
	CWresultCode	stopWave( const GASSoundObjectRef  inSoundObject );

	//	 ( 0.0 <-> 1.0 ( 1.0 == max volume ) )
	CWresultCode	setVolume( const GASSoundObjectRef  inSoundObject, const CWfloat32  inVolume );
	//	 ( 0.0 <-> 1.0 ( 1.0 == max volume ) )
	CWresultCode	getVolume( const GASSoundObjectRef  inSoundObject, CWfloat32*  outVolume );
	
	//	p ( 0.0 <-> 1.0 ( 0.5 == center position ) )
	CWresultCode	setPan( const GASSoundObjectRef  inSoundObject, const CWfloat32  inPan );
	//	p ( 0.0 <-> 1.0 ( 0.5 == center position ) )
	CWresultCode	getPan( const GASSoundObjectRef  inSoundObject, CWfloat32*  outPan );
	
	/*
	//	NOT SUPORT
	//	[gi -n  <-> n ( 1.0 == default ) j
	CWresultCode	setRate( const GASSoundObjectRef  inSoundObject, const CWfloat32  inRate );
	//	[gi -n  <-> n ( 1.0 == default ) j
	CWresultCode	getRate( const GASSoundObjectRef  inSoundObject, CWfloat32*  outRate );
	*/

	////////////////////////////////////////////////////////////////////
	//	MIDI
	//	EQuickTime̕yȂ̂ŃI}PƂĂ̈ʒuÂB
	//	@GtFN^[̘A͂Ă܂B
	////////////////////////////////////////////////////////////////////

	//	SMFJ
	CWresultCode	openSMF( const FSSpec*  inFile );

	//	SMF
	CWresultCode	closeSMF( void );

	//	Đ
	CWresultCode	playSMF( void );

	//	ĐH
	CWbool	isPlaySMF( void );

	//	~
	CWresultCode	stopSMF( void );

private:
	//	t@C
	void	closeAudioFile( void );

};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GASAudioService_h