/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameInputService
*	File:		CWGameInputServiceTool.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				HIDfoCX͏𗘗p邽߂̏ʃc[B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/07	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWGameInputServiceTool_h
#define	CWGameInputServiceTool_h

#include	"CWorkerConfig.h"
#include	"CWGameInputService.h"

//	Carbon
#include <Carbon/Carbon.h>

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus


////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////
enum{
	CW_GIST_FAITAL_Trigger_NUMBER					= -1501,		//	gK[ԍł͗L܂B
	CW_GIST_FAITAL_VIRTUAL_Trigger_NUMBER			= -1502,		//	zgK[ԍł͗L܂B
	
	//	Configuration
	CW_GIST_USER_CANCEL_SEARCH_ELEMENT				= -1530,		//	Gg̒T[U[LZ܂B
	CW_GIST_CANCEL_SEARCH_ELEMENT_REQUIRE_UNIQUE 	= -1531,		//	ɑTriggergpĂGgȂ̂ŁAGg̒TLZ܂B
	CW_GIST_NOT_SEARCH_ELEMENT						= -1532,		//	ݒł܂łB
	
	//	Serialize
	CW_GIST_NOT_SUPPORT_VERSION						= -1550,		//	o[WقȂĂ܂B
	CW_GIST_ILLEGAL_SERIALIZE_BUFFER				= -1551,		//	SERIALIZEobt@ɖ肪L܂B
};

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	Version
//------------------------------------------------------------------------------
#define	GIST_VERSION	'0100'								//	version 1.00

//------------------------------------------------------------------------------
//	TriggerMap
//	gK[}bv
//------------------------------------------------------------------------------
typedef	struct	OPAQUA_STRUCT(_OPAQUA_GISTTriggerMap)		*GISTTriggerMapRef;

//------------------------------------------------------------------------------
//	Serialize Buffer
//	VACYobt@
//------------------------------------------------------------------------------
typedef	void*	GISTSerializeBuffer;

//------------------------------------------------------------------------------
//	TriggerMapper fillter
//	gK[}bp[tB^[
//------------------------------------------------------------------------------
enum{
	GIST_MAPPER_FILTER_NOTHING					= 0,		//	w薳BfilterValue͎gpȂB

	GIST_MAPPER_FILTER_NOCKOUT_USAGE_RESERVE	= 1,		//	element usage  "reserve"( -1 )@̃Gg͌oȂBfilterValue͎gpȂB

	GIST_MAPPER_FILTER_TARGET_ELEMENT			= 2,		//	filterValueԖڂɌmGg擾AGg͖B
															//		̋@\͕̃WCXeBbNڑĂƂAPڂPoAQڂQoAR߂RoAEEE
															//		ƂɌo邱ƂłB
};
typedef	CWtype		GISTTriggerMapperFilter;

//------------------------------------------------------------------------------
//	Scale range
//	XP[͈̓ftHgl
//------------------------------------------------------------------------------
//	XP[l͈͂̎w@
enum{
	GIST_ELEMENT_SCALE_DEFAULT = 0,			//	DEFAULTlw肷
	GIST_ELEMENT_SCALE_CUSTOM				//	lw肷
};
typedef CWtype		GISTElementScaleSelect;

//	XP[l͈͂̎w
enum{
	GIST_ELEMENT_DEFAULT_SCALE_MIN = 0,					//	XP[l̍ŏ
	GIST_ELEMENT_DEFAULT_SCALE_MAX = 255,				//	XP[l̍ő
};

//------------------------------------------------------------------------------
//	TriggerMapper
//	gK[}bp[
//		ftHg̃gK[}bv\z邽߂̍\́B
//		gK[}bv쐬ƂA̍\̂̎wɃGg蓖ĂB
//------------------------------------------------------------------------------
struct	GISTTriggerMapper{
	CWint32						deviceUsagePage;	//	IfoCXUsagePage		萔́A<IOKit/hid/IOHIDUsageTables.h> QƂ邱ƁB
	CWint32						deviceUsage;		//	IfoCXUsage			萔́A<IOKit/hid/IOHIDUsageTables.h> QƂ邱ƁB
	//	deviceUsagePagéA/* Usage Pages */ɋLqĂ萔gp܂Bʏ́AHIDPage_GenericDesktopw肵܂B
	//	deviceUsagéAʏA/* GenericDesktop Page (0x01) */ɋLqĂ萔gp܂B
	//	deviceUsagePage kHIDPage_Undefined w肷ƁAfoCX̎ނ肵܂B
	
	GISElementType				elementType;		//	IGg̎
	CWint32						elementUsagePage;	//	IGgUsagePage	萔́A<IOKit/hid/IOHIDUsageTables.h> QƂ邱ƁB
	CWint32 					elementUsage;		//	IGgUsage		萔́A<IOKit/hid/IOHIDUsageTables.h> QƂ邱ƁB
	//	elementUsagePagéA/* Usage Pages */ɋLqĂ萔gp܂B
	//	elementUsagéAelementUsagePageŎw肳ꂽy[WԍɋLqĂ萔gp܂B
	//	foCXusagePage,usageƎʂĂ܂Aw肵Ȃ΂ȂȂ̂Œӂ܂傤B

	GISTTriggerMapperFilter		filter;				//	IƂ̃tB^[
	CWint32						filterValue;		//	FilterBfilterlɂėp@قȂB

	//	ݒw
	GISTElementScaleSelect		scaleSelect;		//	scaleMin,scaleMax̎w@
													//	scaleSelect = GIST_ELEMENT_SCALE_DEFAULTȂAscaleMin,scaleMax,𖳎ďliGIST_ELEMENT_DEFAULT_SCALE_*jgpB
													//	scaleSelect = GIST_ELEMENT_DEFAULT_SCALE_MAXȂAscaleMin,scaleMax̒lgpB
	CWint32						scaleMin;			//	XP[l̍ŏ
	CWint32						scaleMax;			//	XP[l̍ő
};
typedef	struct	GISTTriggerMapper	GISTTriggerMapper;

//------------------------------------------------------------------------------
//	zgK[NUMBER̃ItZbg
//------------------------------------------------------------------------------
enum{
	GIST_VIRTUAL_Trigger_OFFSET_NUMBER = 1024,
};
#define		GISTVirtualTriggerNumber( X )		( GIST_VIRTUAL_Trigger_OFFSET_NUMBER + X )

////////////////////////////////////////////////////////////////////////////////
//
//	Interface
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	쐬Ɣj
//------------------------------------------------------------------------------
//	gK[}bv쐬
//		F GISTTriggerMapper*		inTriggerMapperArray	IGg̎w
//		F CWsize					inArrayCount			z
//		F GISTTriggerMapRef*		outTriggerMapRef		VgK[}bv
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTCreateTriggerMap( 	const GISTTriggerMapper*	inTriggerMapperArray, const CWsize  inArrayCount, GISTTriggerMapRef*  outTriggerMapRef );

//	gK[}bvj
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
CW_EXTERN	void				GISTReleaseTriggerMap( const GISTTriggerMapRef  inTriggerMap );

//------------------------------------------------------------------------------
//	zgK[
//
//		̃gK[̃gK[ƂĎ舵ׂ̋@\B
//		Ⴆ΁A㉺EɈړ邽߂̃gK[KvȂƂAȉ̂悤Ȏdl~ꍇLB
//
//			EWCXeBbNƃL[{[hő삵B
//			EWCXeBbN͎RɃGgݒ肵B
//			EL[{[h́AɃj[̑Is悤AύXs\ɂB
//
//		̂ƂAWCXeBbNpgK[ƁAL[{[hpgK[pӂA
//		܂Ƃ߂ztrigger쐬ƁAȌɃR[fBOoB
//
//		ij
//		@EzgK[i㉺Ej 
//		@@@@@@@@@@@@@@@ @@EgK[iL[{[h̏㉺EBRtBMAŐݒ肵ȂBj
//		@@@@@@@@@@@@@@@ @
//		@@@@@@@@@@@@@@@ @@EgK[iWCXeBbN̏㉺EBRtBMAŐݒsBj
//	
//		ztriggeŕAꕔ̊֐ɐ̂́Aʏ̃gK[ƋʂȂpłB
//
//------------------------------------------------------------------------------
//	zgK[쐬
//		zgK[̃gK[ԍ́AʏgK[̌ɒǉB
//		č쐬sƁAzgK[ύXłB
//		쐬̑́Aʏ̃gK[ƂĔԍőłB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWsize					inSize					zgK[Ɋ蓖ĂgK[̌
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTCreateVirtualTrigger( const GISTTriggerMapRef  inTriggerMap, const CWsize  inSize );

//	zgK[蓖Ă
//		wgK[ɁAwz̃gK[蓖ĂB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			zgK[ԍ
//		F CWuint32*				inTriggerNumberArray	蓖ĂgK[ԍ̔z
//		F CWsize					inArrayCount			z
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTMappingVirtualTrigger( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber, const CWuint32*  inTriggerNumberArray, const CWsize  inArrayCount );

//	zgK[̊蓖Ă
//		wgK[zgK[̎AB폜Ȃ̂ŁAzgK[͎c܂܋̏ԂɂȂB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			zgK[ԍ
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTResetVirtualTrigger( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber );

//	zgK[H
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			zgK[ԍ
//		ߒlF CWbool											true = zgK[łAfalse = zgK[ł͂Ȃ
CW_EXTERN	CWbool				GISTIsVirtualTrigger( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber );

//------------------------------------------------------------------------------
//	gK[ƃfoCXƃGg
//------------------------------------------------------------------------------
//	gK[ɃGg蓖Ă
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		F GISTTriggerMapper*		inTriggerMapper			Gg
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTMappingElements( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber, const GISTTriggerMapper*  inTriggerMapper  );

//	gK[Ɋ蓖ĂꂽGgSĉ
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTResetElements( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber );

//	gK[}bvgpĂfoCX̎擾Jn
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTBeginGetDevice( const GISTTriggerMapRef  inTriggerMap );

//	gK[}bvgpĂfoCX擾
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	GISDeviceRef		GISTGetNextDevice( const GISTTriggerMapRef  inTriggerMap );

//	gK[Gg擾Jn
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTBeginGetElement( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber );

//	gK[Gg擾
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	GISElementRef		GISTGetNextElement( const GISTTriggerMapRef  inTriggerMap );

//------------------------------------------------------------------------------
//	l
//		PgK[ɕ̃Gg蓖ĂĂ鎞́A_aԂB
//------------------------------------------------------------------------------
//	gK[l擾i݂̒l擾j
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		ߒlF CWint32											l
CW_EXTERN	CWint32			GISTGetTriggerValue( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber );

//	gK[l擾iobt@OŌ̒l擾j
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		F CWbool*					outTrueIeGetEvent		Cxg̗LBtrue = LAfalse = 
//		F CWint32*					outValue				l
//		F AbsoluteTime*			outTime					l擾
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode	GISTGetTriggerBufferValue( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber, CWbool*  outTrueIeGetEvent, CWint32*  outValue, AbsoluteTime*  outTime /*= NULL*/ );
 
//	XP[OKpl擾i݂̒l擾j
//		lnKv͂ȂAڌĂŒl擾łB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		ߒlF CWint32											l
CW_EXTERN	CWint32			GISTGetTriggerScaleValue( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber );

//	XP[OKpl擾iobt@OŌ̒l擾j
//		lnKv͂ȂAڌĂŒl擾łB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		F CWbool*					outTrueIeGetEvent		Cxg̗LBtrue = LAfalse = 
//		F CWint32*					outValue				l
//		F AbsoluteTime*			outTime					l擾
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode	GISTGetTriggerScaleBufferValue( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber, CWbool*  outTrueIeGetEvent, CWint32*  outValue, AbsoluteTime*  outTime /*= NULL*/ );

//	Lu[gKpl擾i݂̒l擾j
//		lnKv͂ȂAڌĂŒl擾łB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		ߒlF CWint32											l
CW_EXTERN	CWint32			GISTGetTriggerCalibrateValue( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber );

//	Lu[gKpl擾iobt@OŌ̒l擾j
//		lnKv͂ȂAڌĂŒl擾łB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		F CWbool*					outTrueIeGetEvent		Cxg̗LBtrue = LAfalse = 
//		F CWint32*					outValue				l
//		F AbsoluteTime*			outTime					l擾
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode	GISTGetTriggerCalibrateBufferValue( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber, CWbool*  outTrueIeGetEvent, CWint32*  outValue, AbsoluteTime*  outTime /*= NULL*/ );

//------------------------------------------------------------------------------
//	CONFIGURATION
//------------------------------------------------------------------------------
//	Search active element
//
//		E莞Ԃ̊ԁA[U[̓͂󂯕tAwgK[ɃGg蓖ĂB
//		EƁAgK[Ɋ蓖ĂꂽSẴGgB
//		EsA܂̓LZƂ͕ύXȂB
//		ErẃAd邱ƂŔ듮邽߂̋@\B
//		EG[R[hɂāAǂ̂悤ɃLZꂽ̂肵ă[U[Ƀ|[g悤ɂĂB
//	
//		EdvȖ߂lF
//			CW_GIST_USER_CANCEL_SEARCH_ELEMENT				w̃LZGg󂯕t̂ŁALZB
//			CW_GIST_CANCEL_SEARCH_ELEMENT_REQUIRE_UNIQUE	󂯕tGg͑TriggerŎgpĂ邽߁ALZB
//
//		F GISTTriggerMapRef		inTriggerMap				gK[}bv
//		F CWuint32					inTriggerNumber				gK[ԍ
//		F GISTTriggerMapper*		inTargetTriggerMapper		󂯕tGg̎wiݒw胁o[͖܂j
//		F GISElementType			inElementType				󂯕tGg̎
//		F CWint					inTimeOutTickCount			^CAEg܂ł̎( 1 / 60 bPʎw )
//		F CWbool					inTrueIsUnique				Gg̔rwBtrue = dGg̎ws\ƂAfalse = d
//		F CWint32					inCancelTrigger				LZ󂯕tTriggerԍBgpȂƂ́i-1jw肷邱ƁB
//		ߒlF CWresultCode											G[R[h
CW_EXTERN	CWresultCode		GISTSearchActiveElement
( 
	GISTTriggerMapRef			inTargetTriggerMap,
	CWint32						inTargetTriggerNumber,
	const GISTTriggerMapper*	inTargetTriggerMapper,
	const GISElementType		inElementType,
	const CWint					inTimeOutTickCount,
	const CWbool				inTrueIsUnique           /* = false               */,
	const CWint32				inCancelTriggerNumber	 /* = -1                  */
);

//------------------------------------------------------------------------------
//	ۑƕA
//------------------------------------------------------------------------------
//	gK[}bvVACY
//		EgK[Ɋ蓖ĂGgAyуgK[VACYAobt@Ɋi[ă|C^𓾂邱ƂłB
//		EzgK[ɂĂ̓VACYɊ܂߂ȂBizgK[̓vO}R[fBOׂełA[U[ύX鎖z肵ĂȂBj
//		Eobt@̈ɂĂ̓gK[}bvǗ邽߁Ap̕Kv͂ȂB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F GISTSerializeBuffer*		outSerializeBuffer		VACYꂽf[^i[obt@̃|C^
//		F CWsize*					outBufferSize			VACYꂽf[^i[obt@̃TCY
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTSerialize( const GISTTriggerMapRef  inTriggerMap, GISTSerializeBuffer*  outSerializeBuffer, CWsize*  outBufferSize );

//	gK[}bvfVACY
//		EVACYf[^ɕ邱ƂłB
//		E[U[̊ωĂƁAfoCX炸SɕAłȂgK[邱ƂLB
//		EVACYf[^obt@̓NCAgR[hӔCB̃obt@ǂݎꂽf[^̓Rs[Ŏ󂯎̂ŁA
//		@֐ĂяonĂB
CW_EXTERN	CWresultCode		GISTDeserialize( const GISTTriggerMapRef  inTriggerMap, const GISTSerializeBuffer  inSerializeBuffer, const CWsize  inBufferSize );
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F GISTSerializeBuffer		inSerializeBuffer		VACYĂf[^i[Ăobt@̃|C^
//		F CWsize					inBufferSize			VACYĂf[^i[Ăobt@̃TCY
//		ߒlF CWresultCode										G[R[h

//------------------------------------------------------------------------------
//	
//------------------------------------------------------------------------------
//	gK[擾(ʏgK[ƉzgK[̑)
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		ߒlF CWsize											gK[AzgK[̍v
CW_EXTERN	CWsize		GISTGetTriggerCount( const GISTTriggerMapRef  inTriggerMap );

//	gpfoCX擾
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		ߒlF CWsize											gK[}bvgpĂfoCX̌
CW_EXTERN	CWsize		GISTGetDeviceCount( const GISTTriggerMapRef  inTriggerMap );

//	Gg擾
//		EgK[Ɋ蓖ĂĂGg̐A܂͉zgK[Ɋ蓖ĂĂgK[̐Ԃ
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		ߒlF CWsize											igK[̏ꍇjgK[gpĂGǧ
//																izgK[̏ꍇj蓖ĂĂgK[̐
CW_EXTERN	CWsize		GISTGetElementCount( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber );

//	zgK[擾
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		ߒlF CWsize											zgK[̍v
CW_EXTERN	CWsize		GISTGetVirtualTriggerCount( const GISTTriggerMapRef  inTriggerMap );

//	gK[擾(ʏgK[̑)
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		ߒlF CWsize											ʏgK[̍v
#define					GISTGetNormalTriggerCount( inTriggerMap )	{ GISTGetTriggerCount(inTriggerMap) - GISTGetVirtualTriggerCount(inTriggerMap); }

//	gK[Ɋ蓖ĂꂽGĝ擾
//		EP̃Gg蓖ĂĂꍇ́AfoCXt̖̂ԂB
//		ẼGg蓖ĂĂꍇ́AfoCX̖̂ōŏ̃Gg̖OԂB
//		EzgK[̎w͖łB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		ߒlF CFStringRef*				outDeviceName			foCX̖
//		ߒlF CFStringRef*				outElementName			Gg̖
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTGetElementName( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber, CFStringRef*  outDeviceName, CFStringRef*  outElementName );

//	XP[O͈͂ݒ肷
//		EzgK[̎w͖łB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		F CWint32					inMin					ŏl
//		F CWint32					inMax					ől
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTSetScaleRange( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber, const CWint32  inMin, const CWint32  inMax );

//	XP[O͈͂擾
//		EzgK[̎w͖łB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		F CWint32*					outMin					ŏl
//		F CWint32*					outMax					ől
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTGetScaleRange( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber, CWint32*  outMin, CWint32*  outMax );

//	Lu[g͈͂擾
//		EzgK[̎w͖łB
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F CWuint32					inTriggerNumber			gK[ԍ
//		F CWint32*					outMin					ŏl
//		F CWint32*					outMax					ől
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTGetCalibrateRange( const GISTTriggerMapRef  inTriggerMap, const CWuint32  inTriggerNumber, CWint32*  outMin, CWint32*  outMax );

//	UserData
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		F void*					inUserData				[U[f[^
//		ߒlF CWresultCode										G[R[h
CW_EXTERN	CWresultCode		GISTSetTriggerMapUserData( const GISTTriggerMapRef  inTriggerMap, const void*  inUserData );
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
//		ߒlF void*											[U[f[^
CW_EXTERN	void*				GISTGetTriggerMapUserData( const GISTTriggerMapRef  inTriggerMap );

//------------------------------------------------------------------------------
//	fobO
//------------------------------------------------------------------------------
//	output to consol Trigger map information
//	gK[}bv̑SgK[o
//
//		F GISTTriggerMapRef		inTriggerMap			gK[}bv
CW_EXTERN	CWresultCode		GISTOutputTriggerMapInformation( const GISTTriggerMapRef  inTriggerMap );


#ifdef __cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif __MWERKS__
#endif __cplusplus

#endif	//CWGameInputServiceTool_h