/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameMediaService
*	File:		GMSAudioPlayer.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				MacOS 10.2 Later
*
*				AudioUnitgpĐ@\BQ[prɍi荞ł邽߁Ay\tgEFAprɂ͕nłB
*				BGM̍ĐAMIDI̍ĐT|[gĂ܂B
*
*					ETEht@C̊ǗB
*					EP̃t@CLāAʁX̉ōĐł܂B
*					Eo[u|܂B
*					EAudioToolbox/AudioFile.hɋLĂt@CɑΉB
*
*				p
*					ETEh\[X			EWAV,AIFF,MP3Ȃǂ̑fށB
*					ETEhIuWFNg		EĐ鉹B
*												@̃TEh\[XĐ邱ƂłB
*												E̃TEh\[XÃTEhIuWFNgŋL邱ƂłB
*
*				p@
*					P@BiTEhIuWFNg̍쐬j
*					Q@TEh\[XJB
*					R@TEhIuWFNgɃTEh\[Xw肵AĐB
*					S@TEh\[XpB
*					T@IBiTEhIuWFNgpBj
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/29	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GMSAudioPlayer_h
#define	GMSAudioPlayer_h

#include	<Carbon/Carbon.h>
#include 	<AudioUnit/AudioUnit.h>

#include	"CWorkerConfig.h"
#include	"CWGameMediaService.h"

#include	<vector>
#include	<list>

namespace	code_worker{

//	Inside
class	AUnit;
class	AUSoundFile;
class	AURenderer;
class	AUPlayer;
class	AUSMF;
class	AUSoundFile;

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	Sound resource
//------------------------------------------------------------------------------
typedef	struct	OPAQUA_STRUCT(_OPAQUA_GMSSoundResourceData)		*GMSSoundResourceRef;	//	s̃f[^

//------------------------------------------------------------------------------
//	Kl
//------------------------------------------------------------------------------
enum{
	//	TEhIuWFNg̍ő吔
	GMS_AUDIO_PLAYER_MAX_SOUND_CHANNEL	= 256,
	
	//	E1t@C̓ǂݍݎɎgpobt@TCYB
	//	@̃TCYȉ̃t@C̓[ɂߍނ̂ŁAǂȂ܂
	//	Et@Cɖ肪LꍇAobt@ǂݍ݋@\ȂP[XL܂B
	//	@mp3ŗǂ̂ŁAʉȂǕpɂɍĐ̂ɂĂAIFFŗpӂ邱Ƃ߂܂B
	GMS_AUDIO_FILE_BUFFER_SIZE			= 1024 * 64,	//	byte
};

//------------------------------------------------------------------------------
//	GtFN^[ݒ
//------------------------------------------------------------------------------
typedef	struct GMSAudioEffect{
	
	CWbool		useReverb;				//	o[ugp
	CWfloat32	reverbParamDryWetMix;	//	o[ûi hC/EFbg̔䗦wB j

} GMSAudioEffect;

//------------------------------------------------------------------------------
//	GtFN^[ݒ
//------------------------------------------------------------------------------
inline	void GMSGetDefaultAudioEffect( GMSAudioEffect*  inEffect ){
	inEffect->useReverb = false;
	inEffect->reverbParamDryWetMix = 10.0f;
}

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GMSAudioPlayer
{
private:
	enum{
		M_MIXER_COUNT = 4,
	};
	typedef	std::vector<AUPlayer*>		MAudioPlayerArray;

	typedef	std::list<AUSoundFile*>		MDeleteSoundFileArray;

	CWuint					m_soundObjectCount;
	CWuint					m_fileBufferSize;

	AUnit*					m_outputUnit;					//	ŏIo͐m[h
	AURenderer*				m_mixerUnit[M_MIXER_COUNT];		//	eTEhIuWFNg𓝍~LT[m[h
	CWuint					m_mixerBusCount;				//	~LT[̃oX
	AudioStreamBasicDescription	m_mixerDesc;
	
	AUnit*					m_finalMixerUnit;	//	ŏI~LT[m[h
	AUnit*					m_effectUnit;		//	ŏIGtFNgm[h

	AUSMF*					m_midiPlayer;		//	SMFvC[

	MAudioPlayerArray		m_soundObject;		//	SoundObject
	
public:
	GMSAudioPlayer( void );
	virtual	~GMSAudioPlayer( void );
	
	////////////////////////////////////////////////////////////////////
	//	
	////////////////////////////////////////////////////////////////////

	//	
	CWresultCode	initialize( 
		const GMSAudioEffect*  inEfffect	= NULL,
		const CWuint  inSoundObjectCount	= GMS_AUDIO_PLAYER_MAX_SOUND_CHANNEL, 
		const CWuint  inFileBufferSize		= GMS_AUDIO_FILE_BUFFER_SIZE );	

	//	I
	CWbool	finalize( void );

	////////////////////////////////////////////////////////////////////
	//	
	////////////////////////////////////////////////////////////////////

	//	}X^[{[
	CWbool	setMasterVolume( const CWfloat32  inVolume );

	////////////////////////////////////////////////////////////////////
	//	TEh\[X
	////////////////////////////////////////////////////////////////////

	//	t@CJ
	GMSSoundResourceRef	openWave( const FSRef  inFile );

	//	t@C
	CWbool	closeWave( const GMSSoundResourceRef  inSoundResource );
	
	//	t@C̃[ɓǂݍ܂ĂoCgԂ
	CWuint32	getBufferSize( const GMSSoundResourceRef  inSoundResource );
	
		
	////////////////////////////////////////////////////////////////////
	//	TEhIuWFNg
	////////////////////////////////////////////////////////////////////

	//	Đ
	CWbool	playWave( const CWuint  inSoundObjectNumber, GMSSoundResourceRef  inSoundResource );
	//	ĐH
	CWbool	isPlayWave( const CWuint  inSoundObjectNumber );
	//	~
	CWbool	stopWave( const CWuint  inSoundObjectNumber );

	//	 ( 0.0 <-> 1.0 ( 1.0 == max volume ) )
	CWbool	setVolume( const CWuint  inSoundObjectNumber, const CWfloat32  inVolume );
	//	 ( 0.0 <-> 1.0 ( 1.0 == max volume ) )
	CWbool	getVolume( const CWuint  inSoundObjectNumber, CWfloat32*  outVolume );
	
	//	p ( 0.0 <-> 1.0 ( 0.5 == center position ) )
	CWbool	setPan( const CWuint  inSoundObjectNumber, const CWfloat32  inPan );
	//	p ( 0.0 <-> 1.0 ( 0.5 == center position ) )
	CWbool	getPan( const CWuint  inSoundObjectNumber, CWfloat32*  outPan );
	
	////////////////////////////////////////////////////////////////////
	//	MIDI
	//	EQuickTime̕yȂ̂ŃI}PƂĂ̈ʒuÂB
	//	@GtFN^[̘A͂Ă܂B
	////////////////////////////////////////////////////////////////////

	//	SMFJ
	CWbool	openSMF( const FSSpec*  inFile );

	//	SMF
	CWbool	closeSMF( void );

	//	Đ
	CWbool	playSMF( void );

	//	ĐH
	CWbool	isPlaySMF( void );

	//	~
	CWbool	stopSMF( void );

private:
	AUPlayer*		getChannel( const CWuint  inSoundObjectNumber );
	inline CWuint	getMixerNumber( const CWuint  inSoundObjectNumber, CWuint*  outMixerNumber );
	
	static void	fileCloseComplete( const AUSoundFile*  inFile, void*  inUserData );
};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GMSAudioPlayer_h