/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameMediaService
*	File:		GMSGWorld.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				GWorld̃T|[gB
*				OepnGLeNX`pɁA肵ɂĂ܂B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/29	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GMSGWorld_h
#define	GMSGWorld_h

#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"
#include	"CWGameMediaService.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////
enum{
	GMS_ERROR_NOT_ALPHA_BIT		= -4000,	//	alpha}XN̖F[x̃obt@[ɑ΂āAalpha}XNsƂ܂
};

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GMSGWorld
{
private:
	GWorldPtr		m_gworld;
	CWuint8*		m_buffer;
	CWuint			m_rowstride;
	OSType			m_pixelFormat;
	void*			m_userData;
	
	CWuint32		m_width;		//	obt@̃TCYieNX`TCY̏ꍇ́ÃTCY傫Ƃ܂j
	CWuint32		m_height;		//	obt@̃TCYieNX`TCY̏ꍇ́ÃTCY傫Ƃ܂j
	CWuint32		m_realWidth;	//	摜̎TCY
	CWuint32		m_realHeight;	//	摜̎TCY

public:
	GMSGWorld( void );
	virtual	~GMSGWorld( void );
	
	///////////////////////////////////////////
	//	method
	///////////////////////////////////////////

	//	obt@[쐬܂
	//		EinColorDepth́A1,2,4,8rbgJ[͑SĊerbgmNCfbNXJ[̃obt@쐬܂B
	//		@24rbgA32rbǵA32rbg(ARGB)J[̃obt@쐬܂B
	//		@imNCfbNXJ[̓At@}XNp̃eNX`Ƃėp邱Ƃz肵Ă܂Bj
	//	
	//		F@CWuint32		inWidth			
	//		F@CWuint32		inHeight		c
	//		F@GMScolorDepth	inColorDepth	F[x
	//		ߒlF@CWresultCode					G[R[h
	CWresultCode	create( const CWuint32  inWidth, const CWuint32  inHeight, const GMScolorDepth  inColorDepth );

	//	obt@[AeNX`TCYō쐬܂
	//		E@\create()ƓłB
	//
	//		E̓eNX`TCYł͂Ȃ摜{̑傫n܂B
	//		ẼTCYɁAœKȃeNX`摜i2̗ݏljvZ܂B
	//		ẼTCYeNX`TCY傫Ȃ邱Ƃ܂B
	//	
	//		F@CWuint32		inWidth			
	//		F@CWuint32		inHeight		c
	//		F@GMScolorDepth	inColorDepth	F[x
	//		ߒlF@CWresultCode					G[R[h
	CWresultCode	createTexture( const CWuint32  inWidth, const CWuint32  inHeight, const GMScolorDepth  inColorDepth );

	//	obt@[p܂
	void	release( void );

	//	GWorldPtr擾܂
	//
	//		ߒlF@GWorldPtr
	GWorldPtr 	getOffScreen( void );

	//	obt@[AhX擾܂
	//
	//		ߒlF@CWuint8*	
	CWuint8*	getBuffer( void );

	//	obt@[rowstrideiTCY~Ppixel̃oCgj擾܂
	//
	//		ߒlF@CWuint32
	CWuint32	getBufferRowStride( void );

	//	F[x擾܂
	//
	//		ߒlF@GMScolorDepth
	GMScolorDepth	getBufferDepth( void );

	//	wJ[L[𓧖FƂāAalpha}XN쐬܂
	//		E32rbgJ[obt@[̂ݎgp\łB
	//		E̋@\́ADrawSprocket̃CfbNXJ[摜̓ߐF`V~[gł܂B
	//		@Ⴆ΁ACfbNXJ[OiFj𓧉ߐFƂƂ́ARGBJ[̍𓧉ߐFƂăAt@}XN쐬܂B
	//		@쐬摜́AAt@uh𗘗pAOpenGLeNX`Ƃėp܂B
	//
	//		F@CWuint32		inColorIndex		ߐF
	//		ߒlF@CWresultCode
	CWresultCode	createAlpha( const CWuint32  inColorIndex );

	//	wlAœKȃeNX`TCYvZ܂
	//
	//		F@CWuint32		inTextureDimension	ƂȂTCY
	//		ߒlF@CWuint32							eNX`TCY
	CWuint32		GetNextTextureSize( const CWuint32 inTextureDimension );

/*
	//	obt@[Rs[܂(pixelPʂŃRs[܂)
	//		ERs[́A\߃obt@쐬Ă܂B
	//		ETCY͐Lk܂BKvɉāA\߃TCY͍킹Ă܂B
	void 	copyPixels( GMSGWorld*  inDest );
*/

	//	eNX`TCYԂ܂
	//		E2̗ݏlԂ܂BcreateTexture()̈œnTCY傫܂B
	//
	//		ߒlF@CWuint32	
	CWuint32	getWidth( void ){ return(this->m_width); };
	//	eNX`TCYԂ܂
	//		E2̗ݏlԂ܂BcreateTexture()̈œnTCY傫܂B
	//
	//		ߒlF@CWuint32	c
	CWuint32	getHeight( void ){ return(this->m_height); };

	//	ۂ̉摜TCYԂ܂
	//		Ecreate()AEcreateTexture()̈œnTCYԂ܂B
	//
	//		ߒlF@CWuint32	摜̎
	CWuint32	getRealWidth( void ){ return(this->m_realWidth); };
	//	ۂ̉摜TCYԂ܂
	//		Ecreate()AEcreateTexture()̈œnTCYԂ܂B
	//
	//		ߒlF@CWuint32	摜̎c
	CWuint32	getRealHeight( void ){ return(this->m_realHeight); };

	//	[U[f[^ݒ肵܂
	//
	//		F@void*
	void	setUserdata( void*  inData ){
		this->m_userData = inData;
	};
	//	[U[f[^擾܂
	//
	//		ߒlF@void*
	void*	getUserdata( void ){
		return	this->m_userData;
	}

private:
	//	摜ɁAwJ[L[𓧖FƂJ[L[쐬܂
	//		E32rbgJ[obt@[̂ݎgp\łB
	void 	SetAlphaMaskSourceColor( const Ptr pixelPtr, const CWuint32 numberOfPixels, const CWuint32 colorIndex );

};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GMSGWorld_h