/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameMediaService
*	File:		GMSMusicPlayer.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				QuickTimegpĐ@\B
*				ȒPBGM̍ĐAMIDI̍ĐɌĂB
*
*				̃NX́AP̃NXłPt@CǗB
*				P̉iBGMjƂĎgp邱Ƃz肵Ă̂ŁA
*				P̌ʉ𕡐`lŕʁXɍĐ邱Ƃ͂łȂB
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/29	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GMSMusicPlayer_h
#define	GMSMusicPlayer_h

#include	<Carbon/Carbon.h>
#include	<QuickTime/QuickTime.h>

#include	"CWorkerConfig.h"
#include	"CWGameMediaService.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GMSMusicPlayer
{
private:
	CWbool			m_muteFlag;
	CWint			m_currentVolume;
	Movie			m_movie;
	MediaHandler	m_mediaHandler;
	CWbool			m_pauseFlag;

	static CWuint		m_constructionCounter;
public:
	GMSMusicPlayer( void );
	virtual	~GMSMusicPlayer( void );
	
	///////////////////////////////////////////
	//	method
	///////////////////////////////////////////

	//	t@CJ
	//		F@FSSpec*  inFileToPlay
	//		ߒlF	CWresultCode			G[R[h
	CWresultCode	open( const FSSpec*  inFileToPlay );

	//	p
	void			release( void );

	//	play
	void			play( void );

	//	is done
	//		ߒlF	CWbool		true = ĐĂȂAfalse = ĐĂ
	CWbool			isDone( void );

	//	repeat
	//		ߒlF	CWbool		true = JԂAfalse = JԂĂȂiJԂKvȂj
	CWbool			playRepeate( void );

	//	pause
	void			pause( void );

	//	resume
	void			resume( void );

	//	mute
	//		F@CWbool  flag		true = ~[gAfalse = ~[g
	void			mute( const CWbool  flag );

	//	stop
	void			stop( void );

	//	volume change
	//		F@CWint	volume			-255 ... 255
	void			setVolume( const CWint  volume );

	//	get volume
	//		ߒlF	CWint					-255 ... 255
	CWint			getVolume( void );

	//	givetime
	//		F@CWint32  task
	void			giveTimePlay( const CWint32  task );

	//	panpot change
	//		F@CWint16  pan		p|bg	-127 ... 127
	void			setPanpot( const CWint16  pan );

	//	panpot change
	//		ߒlF@CWint16				p|bg	-127 ... 127
	CWint16			getPanpot( void );

	//	set Rate
	//		F@CWint16  rate		Đ[g	0 ... 100
	void			setRate( CWint16  rate );

	//	get Rate
	//		ߒlF@CWint16				Đ[g	0 ... 100
	CWint16			getRate( void );

	//	set BassAndTreble
	//		MIDȈꍇ͌ʖB
	//
	//		F@CWint16  bass		
	//		F@CWint16  trable		
	//		ߒlF	CWresultCode			G[R[h
	CWresultCode	setBassAndTreble( const CWint16  bass, const CWint16  trable );

	//	get BassAndTreble
	//		F@CWint16*  bass
	//		F@CWint16*  trable
	//		ߒlF	CWresultCode			G[R[h
	CWresultCode	getBassAndTreble( CWint16*  bass, CWint16*  trable );

private:
	//	getMovieMedia
	OSErr	getMovieMedia( const FSSpec *inFile, Movie *outMovie, MediaHandler*  outMediaHandler );
};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GMSMusicPlayer_h