/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameMediaService
*	File:		CWGameTextService.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				`@\BATSUIgpB
*				ATSUI͓ǁAX^C⃌CAEgOɗpӂ邱ƂŁALxptH[}X̐䂪₷B
*				{IɃeLXg`͔ɒxBɂꍇ́ANCAgR[hŗlXȍHvKvL邾낤B
*
*				`@\Tv
*					EeLXǵAueLXg{bNXvŕ\B
*					EueLXg{bNXv́AuX^Cvw肷ՂłB
*					EuX^Cv́AtHgAFAƂݒsB
*					EueLXg{bNXv́AeLXĝ́AeLXg̔zuɊւAyуX^C̐ݒsB
*					EuX^Cv͕ݒƂoAeLXg{bNXƂɎwEėpoB
*					EuX^CvgpƁA̃eLXgubNɕ̃X^C蓖Ă邱ƂoB
*					@ႦΕ̈ꕔ̃tHgJ[ATCYύXAA_[o[Ȃǂ̑\łB
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/04/04	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/03/22>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWGameTextService_h
#define	CWGameTextService_h

#include	"CWorkerConfig.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code	( -6000 )
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	X^C@
//------------------------------------------------------------------------------
enum{
	GTS_TEXT_FACE_NORMAL		= 0,
	GTS_TEXT_FACE_BOLD			= 1 << 1,
	GTS_TEXT_FACE_ITALIC		= 1 << 2,
	GTS_TEXT_FACE_UNDER_LINE	= 1 << 3,
	GTS_TEXT_FACE_CONDENSE		= 1 << 4,
	GTS_TEXT_FACE_EXTEND		= 1 << 5,
};
typedef CWtype	GTStextStyleFace;

//------------------------------------------------------------------------------
//	X^C@`
//------------------------------------------------------------------------------
enum{
	GTS_TEXT_STRONGLY_HORIZON,	//	
	GTS_TEXT_STRONGLY_VERTICAL,	//	c
};
typedef CWtype	GTStextStyleStrongly;

//------------------------------------------------------------------------------
//	X^C@CށiA_[CAj
//------------------------------------------------------------------------------
enum{
	GTS_TEXT_LINE_NOTHING,
	GTS_TEXT_LINE_SINGLE,	//	Pd
	GTS_TEXT_LINE_DOUBLE,	//	Qd
};
typedef CWtype	GTStextLine;

//------------------------------------------------------------------------------
//	eLXg{bNX@
//------------------------------------------------------------------------------
enum{
	GTS_TEXT_ALIGN_START,		//	񂹁A܂͏
	GTS_TEXT_ALIGN_CENTER,		//	S
	GTS_TEXT_ALIGN_END,			//	E񂹁A܂͉
	GTS_TEXT_ALIGN_JUST,		//	ϓzu
};
typedef	CWtype	GTSTextAlignH;
typedef	CWtype	GTSTextAlignV;

//------------------------------------------------------------------------------
//	eLXg{bNX@CAEgݒ
//------------------------------------------------------------------------------
typedef	struct GTSLayoutInfo{
	GTSTextAlignH	alignH;				//	̎w
	GTSTextAlignH	alignV;				//	c̎w
	
	CWbool			useUntiAliasing;	//	true = A`GAVOLAfalse = A`GAVO
	CWbool			useBreak;			//	true = eLXg{bNXEE[Ő܂ԂAfalse = ܂ԂȂ

	CWbool			useBackLayer;		//	true = wihԂ, false = wiNA
	CWfloat32		backColorR;
	CWfloat32		backColorG;
	CWfloat32		backColorB;
	CWfloat32		backColorA;
	
//	GTStextStyleStrongly	strongly;	//	cA

} GTSLayoutInfo;

////////////////////////////////////////////////////////////////////////////////
//
//	Function
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//	eLXg{bNX@CAEg̏ݒ擾
//------------------------------------------------------------------------------
inline	void GTSGetDefaultLayoutInfo( GTSLayoutInfo*  ioLayoutInfo )
{
	ioLayoutInfo->alignH = GTS_TEXT_ALIGN_START;
	ioLayoutInfo->alignV = GTS_TEXT_ALIGN_START;
	ioLayoutInfo->useUntiAliasing	= true;
	ioLayoutInfo->useBreak			= true;
	
	ioLayoutInfo->useBackLayer	= false;
	ioLayoutInfo->backColorR	= 0.0f;
	ioLayoutInfo->backColorG	= 0.0f;
	ioLayoutInfo->backColorB	= 0.0f;
	ioLayoutInfo->backColorA	= 0.0f;
	
//	ioLayoutInfo->strongly	= GTS_TEXT_STRONGLY_HORIZON;
}


//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

#endif	//CWGameTextService_h