/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameMediaService
*	File:		GTSTextBox.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				eLXg`悷`̈B
*				EQuartzŕ`悵܂BQD͎gp܂iQD̓At@uhgpłȂׁjB
*				
*				EWnQuartzɏ]܂B
*					ATSUÍȀꍇA̍_ƂčW肵܂B
*					}gNXϊœVntɂƕ܂Ŕ]Ă܂̂ŁA\ׂ̈̑傫
*					eLXg{bNX̃TCYAK؂ȍWvZĂB
*	
*				EpOt
*					ATSUI̓LbW^[ȂǂF܂B
*					seLXgubN邽߂ɂ́ApOteLXgEoA
*					sPʂŕ`悵܂B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/29	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GTSTextBox_h
#define	GTSTextBox_h

#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"
#include	"CWGameTextService.h"
#include	"GTSTextStyle.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GTSTextBox
{
private:
	UniChar*			m_uniCharBuffer;
	CFIndex				m_uniCharLength;
	ATSUTextLayout		m_atsuiLayout;

public:
	GTSTextBox( void );
	virtual	~GTSTextBox( void );
	
	///////////////////////////////////////////
	//	method
	///////////////////////////////////////////

	//	eLXgݒ肷
	//		EݒƓɃpOt𕪉܂BieLXgʂɉĎԂ|܂j
	//
	//		F@GTSTextStyle* 	inStyle
	//		F@CFStringRef		inStringRef
	//		ߒlF@CWresultCode
	CWresultCode	setText( 
				const GTSTextStyle* 	inStyle,
				const CFStringRef		inStringRef );

	//	eLXgNA
	void			clearText( void );

	//	eLXg`悷
	//
	//		F@CGContextRef		inDrawerRef
	//		F@GTSLayoutInfo*		inLayout		eLXg{bNX̐ݒ
	//		F@CGRect*				inBounds		eLXg{bNX̃TCYƍW
	//		ߒlF@CWresultCode
	CWresultCode	draw( 
				CGContextRef			inDrawerRef,
				const GTSLayoutInfo*	inLayout,
				const CGRect*			inBounds );

	//	w͈͂ɃX^CKp
	//
	//		F@GTSTextStyle* 		inStyle
	//		F@CWuint32			inStart			Kp镶ʒu
	//		F@CWuint32			inLength		Kp镶
	//		ߒlF@CWresultCode
	CWresultCode	setStyleRun(
				const GTSTextStyle* 	inStyle,
				const CWuint32			inStart,
				const CWuint32			inLength );

private:
	//	pOt
	CWbool		findParagraph(
				UniChar*				theText, 
				UniCharCount			theTextLength, 
				UniCharArrayOffset		paragraphStart, 
				UniCharArrayOffset*		paragraphEnd );

};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GTSTextBox_h


