/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameMediaService
*	File:		GTSTextStyle.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				X^C
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/29	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GTSTextStyle_h
#define	GTSTextStyle_h

#include	<ApplicationServices/ApplicationServices.h>
#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"
#include	"CWGameTextService.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

//	CGColorRef	MacOS 10.3 Later
//	RpC[F10.28ȑOł̓RpC͖B
//	sF10.3A10.28ȑOǂŃRpCĂǂA10.28ȑOł͊֘A̎s𖳎B
#if	MAC_OS_X_VERSION_10_3 <= MAC_OS_X_VERSION_MAX_ALLOWED
	//	10.3ȍ~ł̂݃RpC
	typedef CGColorRef					CWCGColorRef;
#else	//	MAC_OS_X_VERSION_10_3 <= MAC_OS_X_VERSION_MAX_ALLOWED
	typedef struct	CWCGColor			*CWCGColorRef;

	#define FixedToFloat(a)     ((float)(a) / fixed1)
	#define FloatToFixed(a)     ((Fixed)((float)(a) * fixed1))

#endif	//	MAC_OS_X_VERSION_10_3 <= MAC_OS_X_VERSION_MAX_ALLOWED

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GTSTextStyle
{
private:
	ATSUStyle		m_atsuiStyle;

public:
	GTSTextStyle( void );
	virtual	~GTSTextStyle( void );
	
	///////////////////////////////////////////
	//	method
	///////////////////////////////////////////

	//	X^C쐬
	//
	//		F@CWint8*		inFontName		tHg(C String)@At@xbgŎwB
	//		F@CWfloat32  	inFontSize		tHgTCYB
	//		ߒlF@CWresultCode
	CWresultCode	create( const CWint8*	inFontName, const CWfloat32  inFontSize );

	//	X^Cj
	void			release( void );
	
	//	X^C擾
	//
	//		ߒlF@ATSUStyle
	ATSUStyle	getStyle( void ) const{
		return	this->m_atsuiStyle;
	}

	//	tHg
	//
	//		F@CWint8*  inFontName
	//		ߒlF@CWresultCode
	CWresultCode	setFontName( const CWint8*  inFontName );

	//	tHgTCY
	//
	//		F@CWfloat32  inFontSize
	//		ߒlF@CWresultCode
	CWresultCode	setFontSize( const CWfloat32  inFontSize );

	//	tFCX
	//
	//		F@GTStextStyleFace  inFace
	//		ߒlF@CWresultCode
	CWresultCode	setFace( const GTStextStyleFace  inFace );

	//	J[
	//
	//		F@CWfloat32  inR
	//		F@CWfloat32  inG
	//		F@CWfloat32  inB
	//		F@CWfloat32  inA
	//		ߒlF@CWresultCode
	CWresultCode	setColor( const CWfloat32  inR, const CWfloat32  inG, const CWfloat32  inB, const CWfloat32  inA );

	//	̕`icEj
	//	E`掞90xЂԂȂ΂ȂȂ
	//
	//		F@GTStextStyleStrongly  inStrongly
	//		ߒlF@CWresultCode
	CWresultCode	setCharacterType( const GTStextStyleStrongly  inStrongly );

	//	̊g嗦Aĕ̊g嗦
	//
	//		F@CWfloat32  inWidthRate
	//		F@CWfloat32  inHeightRate
	//		ߒlF@CWresultCode
	CWresultCode	setScale( const CWfloat32  inWidthRate, const CWfloat32  inHeightRate );

	//	Ԋu
	//
	//		F@CWfloat32  inShift
	//		ߒlF@CWresultCode
	CWresultCode	setColShiftBefore( const CWfloat32  inShift );

	//	Ԋu
	//
	//		F@CWfloat32  inShift
	//		ߒlF@CWresultCode
	CWresultCode	setColShiftAfter( const CWfloat32  inShift );

	//	s
	//
	//		F@CWfloat32  inShift
	//		ߒlF@CWresultCode
	CWresultCode	setRowShift( const CWfloat32  inShift );

	//	gbLO
	//
	//		F@CWfloat32  inTracking
	//		ߒlF@CWresultCode
	CWresultCode	setTracking( const CWfloat32  inTracking );

	//	Drop Shadow
	//
	//		F@CWfloat32			inBlur
	//		F@CWfloat32			inOffsetX
	//		F@CWfloat32			inOffsetY
	//		ߒlF@CWCGColorRef		inColorRef
	CWresultCode	setDropShadow( 
		const CWfloat32		inBlur		/* =  0.0f */,
		const CWfloat32		inOffsetX	/* =  3.0f */,
		const CWfloat32		inOffsetY	/* = -3.0f */,
		const CWCGColorRef	inColorRef
	);

	//	A_[C
	//
	//		F@GTStextLine		inLine
	//		F@CWCGColorRef	inColorRef
	//		ߒlF@CWresultCode
	CWresultCode	setUnderLine(
		const GTStextLine	inLine,
		const CWCGColorRef	inColorRef
	);
	//	
	//
	//		F@GTStextLine		inLine
	//		F@CWCGColorRef	inColorRef
	//		ߒlF@CWresultCode
	CWresultCode	setStrikeThrough(	
		const GTStextLine	inLine,
		const CWCGColorRef	inColorRef
	);

private:
	//	X^C쐬
	OSStatus	createATSUIStyle(
				StringPtr	fontName,
				CWfloat32	fontSize, 
				ATSUStyle*	theStyle);
	//	X^Cj
	void		releaseATSUIStyle( ATSUStyle  theStyle );

};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GTSTextStyle_h
