/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameViewService
*	File:		GVSHiIView.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				HIViewBEBhE`r[JX^Rg[̐@\񋟁B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/22	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GVSHiIView_h
#define	GVSHiIView_h

#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"
#include	"CWGameViewService.h"

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GVSHiIView
{
private:
	HIViewRef			m_hiObjectRef;
	HIObjectClassRef	m_hiObjectClassRef;
	EventParamName		m_eventParamName;

public:
	GVSHiIView( void );
	virtual	~GVSHiIView( void );
	
	///////////////////////////////////////////
	//	method
	///////////////////////////////////////////
	//	r[쐬
	//		F	const WindowRef			inParentWindow		\teEBhE
	//		F	const Rect*				inBounds			r[̃TCY
	//		F	const CFStringRef		inClassID			NXIDi 		EX. CFSTR( "com.myAooName.viewName" ) j
	//		F	const EventParamName	inEventParamName	Cxgi	EX. 'Boun'@j
	CWresultCode		create( const WindowRef			inParentWindow, 
								const Rect*				inBounds, 
								const CFStringRef		inClassID, 
								const EventParamName	inEventParamName );

	//	r[p
	void				destroy( void );

	///////////////////////////////////////////
	//	virtual
	///////////////////////////////////////////
	//	r[쐬
	virtual	OSStatus 	onConstruct( EventRef  inEvent );
	//	r[pO
	virtual	OSStatus	onDestruct( EventRef  inEvent );
	//	r[
	virtual	OSStatus	onInitialize( EventHandlerCallRef  inCallRef, EventRef  inEvent );
	//	r[`BJX^Rg[̏ꍇ́Ã^C~Oŕ`悵܂B
	virtual	OSStatus	onDraw( EventRef  inEvent );
	//	}EX蔻B
	virtual	OSStatus	onHitTest( EventRef  inEvent );
	//	}EXgbLOB
	virtual	OSStatus	onTrack( EventRef  inEvent );
	//	r[̃nCCgɂω܂B
	virtual	OSStatus	onChanged( EventRef  inEvent );
	//	f[^擾B
	virtual	OSStatus	onGetData( EventRef  inEvent );
	//	f[^ݒB
	virtual	OSStatus	onSetData( EventRef  inEvent );
	//	r[̗̈擾B
	virtual	OSStatus	onGetRegion( EventRef  inEvent );

private:
	//	HIViewNXo^
	OSStatus	regist( const CFStringRef  inClassID );
	//	HIViewCxgnh[
	static pascal OSStatus	eventHandler( EventHandlerCallRef  inCallRef, EventRef  inEvent, void*  inUserData );
	
};

}	//	code_worker
#endif	//GVSHiIView_h