/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameViewService
*	File:		GVSMenu.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				j[@\񋟂B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/22	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GVSMenu_h
#define	GVSMenu_h

#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"
#include	"CWGameViewService.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GVSMenu
{
private:
	EventHandlerUPP		m_menuEventHandlerUpp;
	EventHandlerRef		m_menuHandlerRef;
	MenuRef				m_menuRef;

public:
	GVSMenu( void );
	virtual	~GVSMenu( void );
	
	///////////////////////////////////////////
	//	method
	///////////////////////////////////////////

	//	j[ݒ
	//		ENIBt@Cɂ邩AAꂩIł܂B
	//		ENIBt@C̏ꍇ́AAboutj[OŗpӂȂ΂Ȃ܂B
	//		ENIBt@CL̏ꍇ́AAboutj[͎ŗpӂ܂B
	//
	//		F	IBNibRef 		inNibRef			nibt@C
	//		F	CFStringRef 	inMenuResourceName	j[\[X̖
	//		ߒlF@CWresultCode						G[R[h
	CWresultCode	setMenu( const IBNibRef  inNibRef = NULL, const CFStringRef  inMenuResourceName = NULL );
	
	//	j[n
	void	releaseMenu( void );
	
	//	j[ACeCl[u
	//
	//		F	MenuCommand  inMenuCommand		j[R}hB( EX. 'mCmd' ȂǁBnibŒ`̂w肷B)
	void	enableMenuItem( const MenuCommand  inCommandID );

	//	j[ACefBZ[u
	//
	//		F	MenuCommand  inMenuCommand		j[R}hB( EX. 'mCmd' ȂǁBnibŒ`̂w肷B)
	void	disableMenuItem( const MenuCommand  inCommandID );
	
	
	///////////////////////////////////////////
	//	virtual
	///////////////////////////////////////////
	//	j[CxgɌĂт܂B
	//
	//		F	GVSeventMenu		inEvent			Cxg
	//		F	MenuCommand  		inCommandID		j[R}hB( EX. 'mCmd' ȂǁBnibŒ`̂w肷B)
	//		ߒlF@GVSeventResult						Cxgǂ̃tOBꍇACxg`FC͏I܂B
	virtual GVSeventResult	onEventHandler( const GVSeventMenu  inEvent, const UInt32  inCommandID );

private:
	//	^C}[[vCxgnh[CXg[
	CWresultCode	installMenuEventHandler( void );
	//	^C}[[vCxgnh[ACXg[
	void			removeMenuEventHandler( void );

	//	j[Cxgnh[
	static	pascal OSStatus menuEventHandler( EventHandlerCallRef  inNextHandler, EventRef  inEvent, void*  inUserData );
};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GVSMenu_h