/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameViewService
*	File:		GVSTimerEvent.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				^C}[Cxg[v
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/22	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GVSTimerEvent_h
#define	GVSTimerEvent_h

#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"
#include	"CWGameViewService.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GVSTimerEvent
{
private:
	EventLoopTimerUPP	m_timerLoopEventHandlerUPP;
	EventLoopTimerRef	m_timerLoopEventHandlerRef;

public:
	GVSTimerEvent( void );
	virtual	~GVSTimerEvent( void );
	
	///////////////////////////////////////////
	//	method
	///////////////////////////////////////////
	//	^C}[[vCxgnh[CXg[
	//
	//		F	EventTimerInterval  inInterval		^C}[̊ԊuB
	//		ߒlF@CWresultCode						G[R[h
	CWresultCode	installTimerLoop( const EventTimerInterval  inInterval );

	//	^C}[ԊuĐݒ
	//
	//		F	EventTimerInterval  inInterval		^C}[̊ԊuB
	//		ߒlF@CWresultCode						G[R[h
	CWresultCode	resetTimerLoop( const EventTimerInterval  inInterval );

	//	^C}[[vCxgnh[ACXg[
	void			removeTimerLoop( void );

	//	VXeŇoߎԂ擾
	//
	//		ߒlF@EventTime							
	EventTime		getCurrentTime( void );
	
	///////////////////////////////////////////
	//	virtual
	///////////////////////////////////////////
	//	^C}[[vŌĂяo܂B
	virtual	void	onEventLoop( void );

private:
	//	AvP[VCxgnh[
	static pascal void	timerLoopEventHandler( EventLoopTimerRef  inTimer, void*  inUserData );
};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GVSTimerEvent_h