/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorker MacOS X / GameViewService
*	File:		GVSView.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				EBhE@\񋟂B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/03/22	Itinose Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	GVSView_h
#define	GVSView_h

#include	<Carbon/Carbon.h>
#include	"CWorkerConfig.h"
#include	"CWGameViewService.h"

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export on
	#endif	__MWERKS__
#endif	__cplusplus

namespace	code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Result Code
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Define
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//
//	Class
//
////////////////////////////////////////////////////////////////////////////////
class	GVSView
{
private:
	WindowRef			m_windowRef;
	EventHandlerRef		m_eventHandlerRef;
	EventHandlerUPP		m_eventHandlerUPP;
	DMExtendedNotificationUPP	m_dmNotificationUPP;

	EventHandlerUPP		m_inputEventHandlerUPP;
	EventHandlerRef		m_inputEventHandlerRef;

	EventHandlerUPP		m_keyboarodEventHandlerUPP;
	EventHandlerRef		m_keyboarodEventHandlerRef;

	EventHandlerUPP		m_tabletEventHandlerUPP;
	EventHandlerRef		m_tabletEventHandlerRef;
	
	CWbool		m_isActivated;
	
public:
	GVSView( void );
	virtual	~GVSView( void );
	
	///////////////////////////////////////////
	//	method
	///////////////////////////////////////////
	//	EBhE쐬
	//
	//		F	GVSwindowAttribute	inAttribute		EBhE
	//		F	GVSwindowAppearance	inAppearance	EBhEO
	//		F	CWint				inWidth			
	//		F	CWint				inHeight		c
	//		F	CFStringRef			inTitle			^Cg
	//		ߒlF@CWresultCode						G[R[h
	CWresultCode	createWindow( 
		const GVSwindowAttribute	inAttribute, 
		const GVSwindowAppearance	inAppearance,
		const CWint			inWidth,
		const CWint			inHeight,
		const CFStringRef	inTitle
	);

	//	EBhEj
	void	destroyWindow( void );

	//	EBhẼ^Cgݒ
	//
	//		F	CFStringRef  		inTitle			^Cg
	//		ߒlF@CWresultCode						G[R[h
	CWresultCode	setTitle( const CFStringRef  inTitle );

	//	EBhẼ^Cg擾
	//
	//		F	CFStringRef*  		outTitle		^Cg
	//		ߒlF@CWresultCode						G[R[h
	CWresultCode	copyTitle( CFStringRef*  outTitle );

	//	EBhËʒu
	//		\ߒ`ĂʒuiʒȂǁjɍWݒ肵܂B
	//
	//		F	GVSwindowPosition	inPosition		Wwl
	void	repositionWindow( const GVSwindowPosition  inPosition );

	//	EBhE\
	void	show( void );

	//	EBhEB
	void	hide( void );
	
	//	EBhEWݒ
	//
	//		F	CWint16		inPointX			ʒu
	//		F	CWint16		inPointY			cʒu
	//		F	CWbool		inTrueIsFront		true = őOʂֈړAfalse = ړȂ
	void	setLocation( const CWint16  inPointX, const CWint16  inPointY, const CWbool  inTrueIsFront );

	//	EBhEW擾
	//
	//		F	CWint16*	outPointX			ʒu
	//		F	CWint16*	outPointY			cʒu
	void	getLocation( CWint16*  outPointX, CWint16*  outPointY );

	//	EBhETCYݒ
	//
	//		F	CWint16		inWidth				
	//		F	CWint16		inHeight			c
	void	setSize( const CWint16  inWidth, const CWint16  inHeight );

	//	EBhETCY擾
	//
	//		F	CWint16*	outWidth			
	//		F	CWint16*	outHeight			c
	void	getSize( CWint16*  outWidth, CWint16*  outHeight );

	//	EBhE擾
	//
	//		ߒlF@CWresultCode						G[R[h
	WindowRef	getWindowRef( void );

	///////////////////////////////////////////
	//	virtual
	///////////////////////////////////////////
	//	EBhECxgɌĂт܂B
	//	
	//		F	GVSeventView	inEvent			Cxg
	//		ߒlF@GVSeventResult					Cxgǂ̃tOBꍇACxg`FC͏I܂B
	virtual	GVSeventResult	onWindowEventHandler( const GVSeventView  inEvent );

	//	}EXCxgɌĂт܂B
	//	
	//		F	GVSeventMouse	inEvent			Cxg
	//		ߒlF@GVSeventResult					Cxgǂ̃tOBꍇACxg`FC͏I܂B
	virtual	GVSeventResult	onMouseEventHandler( const GVSeventMouse  inEvent, const GVSMouseEventData*  inEventData );

	//	L[{[hCxgɌĂт܂B
	//	
	//		F	GVSeventKeyboard	inEvent		Cxg
	//		ߒlF@GVSeventResult					Cxgǂ̃tOBꍇACxg`FC͏I܂B
	virtual	GVSeventResult	onKeyboardEventHandler( const GVSeventKeyboard  inEvent, const GVSKeyboardEventData*  inEventData );

	//	^ubgCxgɌĂт܂B
	//	
	//		F	GVSTabletEventData*				inEventData				GVSeventTablet = GVS_EVENT_TABLET_POINT ł͖Ƃ NULLł
	//		F	GVSTabletProximityEventData*	inProximityEventData	GVSeventTablet = GVS_EVENT_TABLET_PROXIMITY ł͖Ƃ NULLł
	//		ߒlF@GVSeventResult											Cxgǂ̃tOBꍇACxg`FC͏I܂B
	virtual	GVSeventResult	onTabletEventHandler( const GVSeventTablet  inEvent, const GVSTabletEventData*  inEventData, const GVSTabletProximityEventData*  inProximityEventData );

private:
	//	𑜓x؂ւʒmCxgnh[CXg[
	void	installDisplayNotify( void );
	//	𑜓x؂ւʒmCxgnh[ACXg[
	void	removeDisplayNotify( void );

	//	𑜓x؂ւʒmCxgnh[
	static pascal void	displayNotifyEventHandler( void*  inUserData, short  inMessage, void *inNotifyData );
	//	EBhECxgnh[
	static pascal OSStatus		windowEventHandler( EventHandlerCallRef	inHandlerRef, EventRef  inEventRef, void*  inUserData );
	//	̓Cxgnh[
	static pascal OSStatus		inputEventHandler( EventHandlerCallRef	inHandlerRef, EventRef  inEventRef, void*  inUserData );
};

//	CPLUSPLUS
#ifdef	__cplusplus
	#ifdef __MWERKS__
		#pragma		export off
	#endif	__MWERKS__
#endif	__cplusplus

}	//	code_worker
#endif	//GVSView_h