/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	CodeWorkerUniversal
*	File:		CWUniqueNumber.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				UniqueȔԍ蓖Ăc[B
*				VvȎǗɗp܂B
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/02/01	Itinoshe Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWUniqueNumber_h
#define	CWUniqueNumber_h

#include	<list>
#include	"CWorkerConfig.h"

namespace code_worker{

////////////////////////////////////////////////////////////////////////////////
//
//	Class	CWUniqueNumber
//
////////////////////////////////////////////////////////////////////////////////
class	CWUniqueNumber
{
private:
	typedef std::list<CWuint>		MNumberList;

	CWuint			m_number;
	MNumberList		m_usedNumbers;

	CWuint			m_rentalCount;
	CWuint			m_startNumber;

public:
	//	Constructor
	CWUniqueNumber( void )
	{
		this->clear();
	}
	CWUniqueNumber( CWuint  inStartNumber )
	{
		this->clear();
		this->m_startNumber = inStartNumber;
	}
	
	//	Destructor
	virtual	~CWUniqueNumber( void ){
	}
	
	//	Vԍ擾
	inline	CWuint		getNewNumber( void ){
		CWuint	number;

		if( ! this->m_usedNumbers.empty() ){
			//	ÃXgėp
			number = this->m_usedNumbers.front();
			this->m_usedNumbers.pop_front();
		}
		else{
			//	Vԍ
			number = this->m_number;
			++this->m_number;
		}

		++this->m_rentalCount;
		return	number;
	}

	//	ԍ
	inline	void		releaseNumber( const CWuint  inNumber ){
		//	ÃXgɊi[
		this->m_usedNumbers.push_back( inNumber );
		--this->m_rentalCount;
	}
	
	//	gpʂ擾
	CWuint	getUseCount( void ){
		return	this->m_rentalCount;
	}
	
	//	S
	void	clear( void ){
		this->m_number = this->m_startNumber;
		this->m_rentalCount = 0;
		this->m_usedNumbers.clear();
	}
};

}
#endif	//CWorkerSingletonBase_h