/*//////////////////////////////////////////////////////////////////////////////
*
*	Project:	CodeWorker
*
*	Component:	
*	File:		CWorkerDevTool.h
*
*	Encoding:	Shift-JIS
*	Font:		Osaka-
*
*	Memo:
*				Jxc[
*
*	FileVersion:	
*	----------------------------------------------------------------------------
*		version 1.00	2004/02/01	Itinoshe Shinta
*	----------------------------------------------------------------------------
*
*	Licence:	GNU General Public License
*	----------------------------------------------------------------------------
*	<CodeWorker>
*    Copyright (C) <2004/02/01>  <Itinose Shinta>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*	----------------------------------------------------------------------------
*
*///////////////////////////////////////////////////////////////////////////////

#ifndef	CWorkerDevTool_h
#define	CWorkerDevTool_h

#ifdef	__cplusplus
//	C++
#include <iostream>
namespace code_worker{

#else
//	C
#include <stdid.h>

#endif	__cplusplus

////////////////////////////////////////////////////////////////////////////////
//
//	debugging tool
//
////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
//	DEBUG MODE
//		fobO̂݃RpCׂe`MacroB
//		fobOł́uCW_DEBUGv`ĂB`͋ɂȂ܂B
//------------------------------------------------------------------------------
#ifdef	CW_DEBUG
	#define	CWDebug( X )	{ X; }
#else
	#define	CWDebug( X )
#endif

//------------------------------------------------------------------------------
//	CPP UNIT TEST SUPORT FUNCTION ( INLINE )
//	for C++ only
//------------------------------------------------------------------------------
#ifdef	__cplusplus

//	output to consol function name
inline	void CWOutputFunctionName( const char*  inClassNamem, const char*  inFuncName )
{
	using namespace std;
	cout << inClassNamem << "::" << inFuncName;
}

//	output to consol function in
inline	void CWOutputFunctionIn( const char*  inClassNamem, const char*  inFuncName )
{
	using namespace std;
	cout << "\n[ENTER]";
	CWOutputFunctionName( inClassNamem, inFuncName );
	cout << endl;
}

//	output to consol function out
inline	void CWOutputFunctionOut( const char*  inClassNamem, const char*  inFuncName )
{
	using namespace std;
	cout << "[EXIT]";
	CWOutputFunctionName( inClassNamem, inFuncName );
	cout << endl;
}

#endif	__cplusplus

////////////////////////////////////////////////////////////////////////////////
//
//	error report tool
//
////////////////////////////////////////////////////////////////////////////////

//	report
#define	CWReportFormat( FORMAT, MESSAGE )			{	printf( "[FILE:%-48s][FUNCTION:%-32s][LINE:%6d] ", __FILE__, __func__, __LINE__ ); printf( FORMAT, MESSAGE );	}

#define	CWReport( MESSAGE )							{	CWReportFormat( "      > %s", MESSAGE ); printf( "\n" );	}
#define	CWReportError( ERR_MESSAGE )				{	CWReportFormat( "ERROR > %s", ERR_MESSAGE ); printf( "\n" );	}
#define	CWReportErrorCode( ERR_MESSAGE, ERR_CODE )	{	CWReportFormat( "ERROR > [ERR CODE:%8d]", ERR_CODE ); printf( "%s\n", ERR_MESSAGE );	 }

//	error report and return
//		TEST^Ȃ烌|[gReturn
#define	CWTestReturnReportError( TEST, ERR_CODE, ERR_MESSAGE )				{	if( TEST ){ CWReportErrorCode(ERR_MESSAGE, ERR_CODE); return ERR_CODE ; } }
#define	CWTestReturnReportErrorCode( TEST, ERR_CODE )						{	if( TEST ){ CWReportErrorCode("", ERR_CODE); return ERR_CODE ; } }
#define	CWTestReturnReportErrorMessageCode( TEST, ERR_MESSAGE, ERR_CODE )	{	if( TEST ){ CWReportErrorCode(ERR_MESSAGE, ERR_CODE); return ERR_CODE ; } }

#define	CWTestBreakReportError( TEST, ERR_CODE, ERR_MESSAGE )				{	if( TEST ){ CWReportErrorCode(ERR_MESSAGE, ERR_CODE); break ; } }
#define	CWTestBreakReportErrorCode( TEST, ERR_CODE )						{	if( TEST ){ CWReportErrorCode("", ERR_CODE); break ; } }
#define	CWTestBreakReportErrorMessageCode( TEST, ERR_MESSAGE, ERR_CODE )	{	if( TEST ){ CWReportErrorCode(ERR_MESSAGE, ERR_CODE); break ; } }

//	for C++ only
#ifdef	__cplusplus
#define	CWThrowReportError( ERR_MESSAGE, OBJECT )									{	CWReportFormat( "ERROR > %s", ERR_MESSAGE ); printf( "\n" );throw(OBJECT);	}
#define	CWTestThrowReportError( TEST, ERR_CODE, ERR_MESSAGE, OBJECT )				{	if( TEST ){ CWReportErrorCode(ERR_MESSAGE, ERR_CODE); throw(OBJECT) ; } }
#define	CWTestThrowReportErrorCode( TEST, ERR_CODE, OBJECT )						{	if( TEST ){ CWReportErrorCode("", ERR_CODE); throw(OBJECT) ; } }
#define	CWTestThrowReportErrorMessageCode( TEST, ERR_MESSAGE, ERR_CODE, OBJECT )	{	if( TEST ){ CWReportErrorCode(ERR_MESSAGE, ERR_CODE); throw(OBJECT) ; } }
#endif	__cplusplus

#ifdef	__cplusplus
}//	namespace code_worker{
#endif	__cplusplus

#endif	//CWorkerDevTool_h